| package |
package := Package name: 'Comet-Tests-Core'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '10'.


package classNames
	add: #CTCometTest;
	yourself.

package methodNames
	add: #GRPlatformTest -> #testForkCometProcessDo;
	add: 'GRPackage class' -> #cometTestsCore;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: 'Comet-Core';
	add: '..\Grease\Grease-Core';
	add: '..\Grease\Grease-Tests-Core';
	add: '..\Javascript\Javascript-Tests-Core';
	yourself).

package!

"Class Definitions"!

JSObjectTest subclass: #CTCometTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

cometTestsCore
	^ self new
		name: 'Comet-Tests-Core';
		description: 'Unit tests for the Comet-Core package.';
		addDependency: 'Javascript-Tests-Core';
		addDependency: 'Comet-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #cometTestsCore!*comet-tests-core!public! !

!GRPlatformTest methodsFor!

testForkCometProcessDo
	| semaphore seen |
	semaphore := self platform semaphoreClass new.
	seen := false.
	self platform cometForkProcessDo: [ seen := true. semaphore signal ].
	semaphore wait.
	self assert: seen! !
!GRPlatformTest categoriesFor: #testForkCometProcessDo!*comet-tests-core!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

CTCometTest guid: (GUID fromString: '{71D4BA30-E259-423C-BB12-E2F6ED87077E}')!
CTCometTest comment: ''!
!CTCometTest categoriesForClass!Unclassified! !
!CTCometTest methodsFor!

comet
	^ CTComet context: self renderContext!

testConnect
	self
		assert: (self comet url: 'http://www.pusher.com/'; connect)
		equals: 'new Comet("http://www.pusher.com/").connect()'!

testDisconnect
	self
		assert: (self comet url: 'http://www.pusher.com/'; disconnect)
		equals: 'new Comet("http://www.pusher.com/").disconnect()'! !
!CTCometTest categoriesFor: #comet!accessing!public! !
!CTCometTest categoriesFor: #testConnect!public!tests! !
!CTCometTest categoriesFor: #testDisconnect!public!tests! !

"Binary Globals"!

