| package |
package := Package name: 'Grease-Core'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '45'.


package classNames
	add: #GRBoundDelayedSend;
	add: #GRCodec;
	add: #GRCodecStream;
	add: #GRDelayedSend;
	add: #GRDeprecatedApiNotification;
	add: #GRError;
	add: #GRInflector;
	add: #GRInvalidArgumentCount;
	add: #GRInvalidUtf8Error;
	add: #GRMappedPrinter;
	add: #GRNotification;
	add: #GRNullCodec;
	add: #GRNullCodecStream;
	add: #GRNumberPrinter;
	add: #GRObject;
	add: #GROrderedMultiMap;
	add: #GROrdinalizePrinter;
	add: #GRPackage;
	add: #GRPlatform;
	add: #GRPluggablePrinter;
	add: #GRPrinter;
	add: #GRSequentialPrinter;
	add: #GRSignPrinter;
	add: #GRSmallDictionary;
	add: #GRStringPrinter;
	add: #GRUnboundDelayedSend;
	add: #GRUnitPrinter;
	add: #GRUnsupportedEncodingError;
	add: #GRVersion;
	yourself.

package methodNames
	add: #Character -> #print:on:;
	add: #Integer -> #greaseInteger;
	add: #Integer -> #pluralize:;
	add: #Integer -> #pluralize:with:;
	add: #Number -> #greaseInteger;
	add: #Object -> #greaseDeprecatedApi:details:;
	add: #String -> #excerpt:;
	add: #String -> #excerpt:radius:;
	add: #String -> #excerpt:radius:ellipsis:;
	add: #String -> #greaseInteger;
	add: #String -> #pluralize;
	add: #String -> #print:on:;
	add: #String -> #trimBoth;
	add: #String -> #trimBoth:;
	add: #String -> #trimLeft;
	add: #String -> #trimLeft:;
	add: #String -> #trimLeft:right:;
	add: #String -> #trimRight;
	add: #String -> #trimRight:;
	add: #String -> #truncate;
	add: #String -> #truncate:;
	add: #String -> #truncate:ellipsis:;
	add: #UndefinedObject -> #print:on:;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	yourself).

package!

"Class Definitions"!

Object subclass: #GRObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Error subclass: #GRError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRError subclass: #GRInvalidArgumentCount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRError subclass: #GRInvalidUtf8Error
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRError subclass: #GRUnsupportedEncodingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Notification subclass: #GRNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRNotification subclass: #GRDeprecatedApiNotification
	instanceVariableNames: 'details'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRObject subclass: #GRCodec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRObject subclass: #GRCodecStream
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRObject subclass: #GRDelayedSend
	instanceVariableNames: 'receiver selector'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRObject subclass: #GRInflector
	instanceVariableNames: ''
	classVariableNames: 'InflectionRules Uninflected'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRObject subclass: #GRPackage
	instanceVariableNames: 'name description dependencies license url'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRObject subclass: #GRPlatform
	instanceVariableNames: ''
	classVariableNames: 'Current'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRObject subclass: #GRPrinter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRObject subclass: #GRSmallDictionary
	instanceVariableNames: 'size keys values'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRObject subclass: #GRVersion
	instanceVariableNames: 'major minor revision stageLabel stageNumber'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRCodec subclass: #GRNullCodec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRCodecStream subclass: #GRNullCodecStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRDelayedSend subclass: #GRBoundDelayedSend
	instanceVariableNames: 'arguments'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRDelayedSend subclass: #GRUnboundDelayedSend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRPrinter subclass: #GRMappedPrinter
	instanceVariableNames: 'next block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRPrinter subclass: #GRNumberPrinter
	instanceVariableNames: 'characters base delimiter digits infinite nan padding accuracy precision separator'
	classVariableNames: 'NumbersToCharactersLowercase NumbersToCharactersUppercase'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRPrinter subclass: #GROrdinalizePrinter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRPrinter subclass: #GRPluggablePrinter
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRPrinter subclass: #GRSequentialPrinter
	instanceVariableNames: 'parts'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRPrinter subclass: #GRSignPrinter
	instanceVariableNames: 'negativePrinter positivePrinter'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRPrinter subclass: #GRStringPrinter
	instanceVariableNames: 'trim length pad character'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRPrinter subclass: #GRUnitPrinter
	instanceVariableNames: 'integerPrinter fractionPrinter units base'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRSmallDictionary subclass: #GROrderedMultiMap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!Character methodsFor!

print: anObject on: aStream
	aStream nextPut: self! !
!Character categoriesFor: #print:on:!*grease-core!public! !

!Integer methodsFor!

greaseInteger
	^ self!

pluralize: aSingularString 
	^ self 
		pluralize: aSingularString
		with: (GRInflector pluralize: aSingularString)!

pluralize: aSingularString with: aPluralString
	^ self printString , ' ' , (self abs = 1 ifTrue: [ aSingularString ] ifFalse: [ aPluralString ])! !
!Integer categoriesFor: #greaseInteger!*grease-core!public! !
!Integer categoriesFor: #pluralize:!*grease-core!public! !
!Integer categoriesFor: #pluralize:with:!*grease-core!public! !

!Number methodsFor!

greaseInteger
	"Answer an integer of the receiver, in our case we simply truncate the number."
	^ self truncated! !
!Number categoriesFor: #greaseInteger!*grease-core!public! !

!Object methodsFor!

greaseDeprecatedApi: apiString details: detailsString 
	GRDeprecatedApiNotification new
		details: detailsString;
		signal: apiString! !
!Object categoriesFor: #greaseDeprecatedApi:details:!*grease-core!public! !

!String methodsFor!

excerpt: aString
	"Answer an excerpt of the receiver that matches the first occurence of aString. If aString isn't found, nil is answered."
	
	^ self excerpt: aString radius: 100!

excerpt: aString radius: anInteger
	"Answer an excerpt of the receiver that matches the first occurence of aString. The radius anInteger expands the excerpt on each side of the first occurrence by the number of characters defined in radius. If aString isn't found, nil is answered."
	
	^ self excerpt: aString radius: anInteger ellipsis: '...'!

excerpt: aString radius: anInteger ellipsis: anEllipsisString
	"Answer an excerpt of the receiver that matches the first occurence of aString. The radius anInteger expands the excerpt on each side of the first occurrence by the number of characters defined in radius. If aString isn't found, nil is answered."

	| index start stop |
	(index := self indexOfSubCollection: aString) = 0
		ifTrue: [ ^ nil ].
	start := index - anInteger max: 1.
	stop := index + anInteger + aString size - 1 min: self size.
	^ (start > 1 ifTrue: [ anEllipsisString ] ifFalse: [ '' ]) ,
		(self copyFrom: start to: stop) ,
	  	(stop < self size ifTrue: [ anEllipsisString ] ifFalse: [ '' ])!

greaseInteger
	"Convert the receiver to an integer, answer nil if this is not a number."
	| number stream negated char |
	number := nil.
	stream := self readStream.
	negated := stream peek = $-.
	negated ifTrue: [ stream next ].
	[ stream atEnd not and: [ (char := stream next) isDigit ] ] whileTrue: 
		[ number := (number isNil 
			ifTrue: [ 0 ]
			ifFalse: [ 10 * number ]) + (char greaseInteger - $0 greaseInteger) ].
	^ (number isNil or: [ negated not ]) 
		ifFalse: [ number negated ]
		ifTrue: [ number ]!

pluralize
	^ GRInflector pluralize: self!

print: anObject on: aStream
	aStream nextPutAll: self!

trimBoth
	"Trim separators from both sides of the receiving string."
	
	^ self trimBoth: [ :char | char isSeparator ]!

trimBoth: aBlock
	"Trim characters satisfying the condition given in aBlock from both sides of the receiving string."

	^ self trimLeft: aBlock right: aBlock!

trimLeft
	"Trim separators from the left side of the receiving string."
	
	^ self trimLeft: [ :char | char isSeparator ]!

trimLeft: aBlock
	"Trim characters satisfying the condition given in aBlock from the left side of the receiving string."
	
	^ self trimLeft: aBlock right: [ :char | false ]!

trimLeft: aLeftBlock right: aRightBlock
	"Trim characters satisfying the condition given in aLeftBlock from the left side and aRightBlock from the right sides of the receiving string."

	| left right |
	left := 1.
	right := self size.
	[ left <= right and: [ aLeftBlock value: (self at: left) ] ]
		whileTrue: [ left := left + 1 ].
	[ left <= right and: [ aRightBlock value: (self at: right) ] ]
		whileTrue: [ right := right - 1 ].
	^ self copyFrom: left to: right!

trimRight
	"Trim separators from the right side of the receiving string."
	
	^ self trimRight: [ :char | char isSeparator ]!

trimRight: aBlock
	"Trim characters satisfying the condition given in aBlock from the right side of the receiving string."

	^ self trimLeft: [ :char | false ] right: aBlock!

truncate
	"Truncate the receiver to 30 characters."
	
	^ self truncate: 30!

truncate: anInteger
	"Truncate the receiver to anInteger characters."
	
	^ self truncate: anInteger ellipsis: '...'!

truncate: anInteger ellipsis: aString
	"Truncate the receiver to anInteger characters and append aString as ellipsis if necessary."

	^ anInteger < self size
		ifTrue: [ (self copyFrom: 1 to: anInteger) , aString ]
		ifFalse: [ self copy ]! !
!String categoriesFor: #excerpt:!*grease-core!public! !
!String categoriesFor: #excerpt:radius:!*grease-core!public! !
!String categoriesFor: #excerpt:radius:ellipsis:!*grease-core!public! !
!String categoriesFor: #greaseInteger!*grease-core!public! !
!String categoriesFor: #pluralize!*grease-core!public! !
!String categoriesFor: #print:on:!*grease-core!public! !
!String categoriesFor: #trimBoth!*grease-core!public! !
!String categoriesFor: #trimBoth:!*grease-core!public! !
!String categoriesFor: #trimLeft!*grease-core!public! !
!String categoriesFor: #trimLeft:!*grease-core!public! !
!String categoriesFor: #trimLeft:right:!*grease-core!public! !
!String categoriesFor: #trimRight!*grease-core!public! !
!String categoriesFor: #trimRight:!*grease-core!public! !
!String categoriesFor: #truncate!*grease-core!public! !
!String categoriesFor: #truncate:!*grease-core!public! !
!String categoriesFor: #truncate:ellipsis:!*grease-core!public! !

!UndefinedObject methodsFor!

print: anObject on: aStream! !
!UndefinedObject categoriesFor: #print:on:!*grease-core!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

GRObject guid: (GUID fromString: '{E1B727B3-FADF-4E34-B080-74E1E41E1FF9}')!
GRObject comment: '
A common superclass that ensures consistent initialization behaviour on all platforms and provides #error: methods that signal an instance of WAPlatformError.

Packages that are using Seaside-Platform should normally subclass WAPlatformObject instead of Object.'!
!GRObject categoriesForClass!Unclassified! !
!GRObject methodsFor!

error: aString
	^ self class error: aString!

initialize! !
!GRObject categoriesFor: #error:!error handling!public! !
!GRObject categoriesFor: #initialize!initialization!public! !

!GRObject class methodsFor!

defaultErrorClass
	^ GRError!

error: aString
	^ self defaultErrorClass signal: aString!

new
	^ self basicNew initialize! !
!GRObject class categoriesFor: #defaultErrorClass!error handling!public! !
!GRObject class categoriesFor: #error:!error handling!public! !
!GRObject class categoriesFor: #new!instance creation!public! !

GRError guid: (GUID fromString: '{2BD891A5-2CEF-4B57-A42B-10D1A490DE65}')!
GRError comment: '
This class provides consistent initialization and exception signaling behaviour across platforms. All platforms must provide the ANSI-standard signaling protocol on this class. #signal: can therefore be safely called on any subclass.

Packages that are using Seaside-Platform should usually subclass WAPlatformError instead of Error.'!
!GRError categoriesForClass!Unclassified! !
GRInvalidArgumentCount guid: (GUID fromString: '{D2F525BA-B224-4BC4-94CA-0C7DF2602B9B}')!
GRInvalidArgumentCount comment: 'Signaled whenever a message is sent with the incorrect number of arguments.'!
!GRInvalidArgumentCount categoriesForClass!Unclassified! !
GRInvalidUtf8Error guid: (GUID fromString: '{6FFDB28A-7B65-4181-9C3A-A98BD49C390C}')!
GRInvalidUtf8Error comment: '
A WAInvalidUtf8Error signals that the input is not valid UTF-8.
'!
!GRInvalidUtf8Error categoriesForClass!Unclassified! !
GRUnsupportedEncodingError guid: (GUID fromString: '{1A93CC2B-0B28-4A5E-BDF7-FAFDBEFE95AB}')!
GRUnsupportedEncodingError comment: ''!
!GRUnsupportedEncodingError categoriesForClass!Unclassified! !
GRNotification guid: (GUID fromString: '{C6A3C05F-C99F-48ED-847A-3C96FE1F767B}')!
GRNotification comment: '
This class provides consistent initialization and exception signaling behaviour across platforms. All platforms must provide the ANSI-standard signaling protocol on this class. #signal: can therefore be safely called on any subclass.

Packages that are using Seaside-Platform should usually subclass WAPlatformNotification instead of Notification.'!
!GRNotification categoriesForClass!Unclassified! !
GRDeprecatedApiNotification guid: (GUID fromString: '{13738992-280D-4238-B6B4-D77EB7C7CDBB}')!
GRDeprecatedApiNotification comment: '
This notification is signaled whenever a deprecated message is sent.

see WAObject>>#seasideDeprecatedApi:details: '!
!GRDeprecatedApiNotification categoriesForClass!Unclassified! !
!GRDeprecatedApiNotification methodsFor!

details
	^ details!

details: anObject
	details := anObject! !
!GRDeprecatedApiNotification categoriesFor: #details!accessing!public! !
!GRDeprecatedApiNotification categoriesFor: #details:!accessing!public! !

GRCodec guid: (GUID fromString: '{7F4E6CFF-4450-4BD6-9672-3F3E7E50DE79}')!
GRCodec comment: 'A codec defines how Seaside communicates without the outside world and how outside data is converted into the image (decoding) and back outside the image (encoding). The codec is essentially a stream factory that provides wrappers around standard streams. All streams do support binary mode for non-converted transfer.'!
!GRCodec categoriesForClass!Unclassified! !
!GRCodec methodsFor!

decode: aString
	| readStream writeStream |
	readStream := self decoderFor: aString readStream.
	writeStream := WriteStream on: (String new: aString size).
	[ readStream atEnd ]
		whileFalse: [ writeStream nextPutAll: (readStream next: 1024) ].
	^ writeStream contents!

decoderFor: aReadStream
	"Wrap aReadStream with an decoder for the codec of the receiver. Answer a read stream that delegates to and shares the state of aReadStream." 
	
	self subclassResponsibility!

encode: aString
	| writeStream |
	writeStream := self encoderFor: (WriteStream
		on: (String new: aString size)).
	writeStream nextPutAll: aString.
	^ writeStream contents!

encoderFor: aWriteStream
	"Wrap aWriteStream with an encoder for the codec of the receiver. Answer a write stream that delegates to and shares the state of aWriteStream."
	
	self subclassResponsibility!

name
	"Answer a human readable string of the receivers encoding policy."

	self subclassResponsibility!

printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name!

url
	"Answer a codec that is responsible to encode and decode URLs. In most cases an UTF-8 codec is the only valid choice, but subclasses might decide to do something else."

	self subclassResponsibility! !
!GRCodec categoriesFor: #decode:!convenience!public! !
!GRCodec categoriesFor: #decoderFor:!conversion!public! !
!GRCodec categoriesFor: #encode:!convenience!public! !
!GRCodec categoriesFor: #encoderFor:!conversion!public! !
!GRCodec categoriesFor: #name!accessing!public! !
!GRCodec categoriesFor: #printOn:!printing!public! !
!GRCodec categoriesFor: #url!accessing!public! !

!GRCodec class methodsFor!

allCodecs
	"Answer all codecs supported in this system. This is a collection of codec instances."

	^ self subclasses
		inject: self codecs asArray
		into: [ :result :each | result , each allCodecs ]!

basicForEncoding: aString
	"Create the actual instance."
	self subclassResponsibility!

codecs
	"Answer a collection of possible codecs of the receiver. To be overridden by concrete subclasses."

	^ #()!

forEncoding: aString
	"Answer a new codec instance for the given encoding name. Raise an WAUnsupportedEncodingError if the encoding name is not supported by this image."
	self allSubclassesDo: [ :each |
		(each supportsEncoding: aString)
			ifTrue: [ ^each basicForEncoding: aString ] ].
	self unsupportedEncoding: aString!

supportsEncoding: aString
	"Answer whether the the given encoding name is supported by this codec class."
	self subclassResponsibility!

unsupportedEncoding: aString 
	"Signal an unsupported encoding."
	GRUnsupportedEncodingError signal: 'unsupported encoding: ' , aString! !
!GRCodec class categoriesFor: #allCodecs!accessing!public! !
!GRCodec class categoriesFor: #basicForEncoding:!private! !
!GRCodec class categoriesFor: #codecs!accessing!public! !
!GRCodec class categoriesFor: #forEncoding:!instance creation!public! !
!GRCodec class categoriesFor: #supportsEncoding:!public!testing! !
!GRCodec class categoriesFor: #unsupportedEncoding:!private! !

GRCodecStream guid: (GUID fromString: '{70B6B58C-AF9C-432C-8833-556E3FA2A5E7}')!
GRCodecStream comment: '
A WACodecStream is a wrapper around a write stream and defines common behavior.

Instance Variables
	stream:		<WriteStream>

stream
	- a WriteStream

'!
!GRCodecStream categoriesForClass!Unclassified! !
!GRCodecStream methodsFor!

atEnd
	^ stream atEnd!

contents
	^ stream contents!

crlf
	self nextPut: Character cr; nextPut: Character lf!

flush
	stream flush!

initalizeOn: aStream
	self initialize.
	stream := aStream.!

next
	self subclassResponsibility!

next: anInteger
	self subclassResponsibility!

nextPut: aCharacter
	self subclassResponsibility!

nextPutAll: aString
	self subclassResponsibility!

size
	^ stream size!

space
	self nextPut: Character space!

tab
	self nextPut: Character tab! !
!GRCodecStream categoriesFor: #atEnd!public!testing! !
!GRCodecStream categoriesFor: #contents!accessing!public! !
!GRCodecStream categoriesFor: #crlf!public!streaming! !
!GRCodecStream categoriesFor: #flush!accessing!public! !
!GRCodecStream categoriesFor: #initalizeOn:!initialization!public! !
!GRCodecStream categoriesFor: #next!public!streaming! !
!GRCodecStream categoriesFor: #next:!public!streaming! !
!GRCodecStream categoriesFor: #nextPut:!public!streaming! !
!GRCodecStream categoriesFor: #nextPutAll:!public!streaming! !
!GRCodecStream categoriesFor: #size!accessing!public! !
!GRCodecStream categoriesFor: #space!public!streaming! !
!GRCodecStream categoriesFor: #tab!public!streaming! !

!GRCodecStream class methodsFor!

on: aStream
	^ self basicNew initalizeOn: aStream! !
!GRCodecStream class categoriesFor: #on:!instance creation!public! !

GRDelayedSend guid: (GUID fromString: '{FE6B13CC-7ED0-40A9-9D11-BC782604FE67}')!
GRDelayedSend comment: '
A WADelayedSend is a future message send of a message to an object. Some of the arguments can be predefined. Instances are intended to be interchangeable with blocks.

This class should conform the ANSI valuable protocol.

This is an abstract class. Use the methods in the ''instance-creation'' protocol on the class side to create intances.

Instance Variables
	receiver:		<Object>
	selector:		<Symbol>

receiver
	- the object receiving the message

selector
	- the message selector sent to the receiver
'!
!GRDelayedSend categoriesForClass!Unclassified! !
!GRDelayedSend methodsFor!

argumentCount
	"Answer the number of arguments that must be provided to the receiver when sending it."
	
	self subclassResponsibility!

fixCallbackTemps
	"For polymorphism with BlockContext>>#fixCallbackTemps."!

initializeWithReceiver: anObject selector: aSymbol
	self initialize.
	receiver := anObject.
	selector := aSymbol!

invalidArgumentCount
	GRInvalidArgumentCount signal!

printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' receiver: '; print: receiver.
	aStream nextPutAll: ' selector: '; print: selector!

value
	^ self valueWithArguments: #()!

value: anObject
	^ self valueWithArguments: (Array with: anObject)!

value: aFirstObject value: aSecondObject
	^ self valueWithArguments: (Array with: aFirstObject with: aSecondObject)!

valueWithArguments: anArray
	self subclassResponsibility!

valueWithPossibleArguments: anArray
	self subclassResponsibility! !
!GRDelayedSend categoriesFor: #argumentCount!accessing!public! !
!GRDelayedSend categoriesFor: #fixCallbackTemps!accessing!public! !
!GRDelayedSend categoriesFor: #initializeWithReceiver:selector:!initialization!public! !
!GRDelayedSend categoriesFor: #invalidArgumentCount!private! !
!GRDelayedSend categoriesFor: #printOn:!printing!public! !
!GRDelayedSend categoriesFor: #value!evaluating!public! !
!GRDelayedSend categoriesFor: #value:!evaluating!public! !
!GRDelayedSend categoriesFor: #value:value:!evaluating!public! !
!GRDelayedSend categoriesFor: #valueWithArguments:!evaluating!public! !
!GRDelayedSend categoriesFor: #valueWithPossibleArguments:!evaluating!public! !

!GRDelayedSend class methodsFor!

receiver: anObject selector: aSymbol 
	^ GRUnboundDelayedSend basicNew 
		initializeWithReceiver: anObject
		selector: aSymbol!

receiver: anObject selector: aSymbol argument: aParameter
	^ self receiver: anObject selector: aSymbol arguments: (Array with: aParameter)!

receiver: anObject selector: aSymbol arguments: anArray 
	^ GRBoundDelayedSend basicNew 
		initializeWithReceiver: anObject
		selector: aSymbol
		arguments: anArray! !
!GRDelayedSend class categoriesFor: #receiver:selector:!instance creation!public! !
!GRDelayedSend class categoriesFor: #receiver:selector:argument:!instance creation!public! !
!GRDelayedSend class categoriesFor: #receiver:selector:arguments:!instance creation!public! !

GRInflector guid: (GUID fromString: '{6B6BB438-BFCD-4D79-8265-9ADB020CB667}')!
GRInflector comment: 'The Inflector transforms words from singular to plural.'!
!GRInflector categoriesForClass!Unclassified! !
!GRInflector class methodsFor!

initialize
	Uninflected := #('bison' 'bream' 'breeches' 'britches' 'carp' 'chassis' 'clippers' 'cod' 'contretemps' 'corps' 'debris' 'deer' 'diabetes' 'djinn' 'eland' 'elk' 'equipment' 'fish' 'flounder' 'gallows' 'graffiti' 'headquarters' 'herpes' 'high-jinks' 'homework' 'information' 'innings' 'ities' 'itis' 'jackanapes' 'mackerel' 'measles' 'mews' 'money' 'mumps' 'news' 'ois' 'pincers' 'pliers' 'pox' 'proceedings' 'rabies' 'rice' 'salmon' 'scissors' 'sea-bass' 'series' 'shears' 'sheep' 'species' 'swine' 'trout' 'tuna' 'whiting' 'wildebeest').
	InflectionRules := #(('man' 'en' 2) ('child' 'ren' 0) ('cow' 'kine' 3) ('penis' 'es' 0) ('sex' 'es' 0) ('person' 'ople' 4) ('octopus' 'es' 0) ('quiz' 'zes' 0) ('ox' 'en' 0) ('louse' 'ice' 4) ('mouse' 'ice' 4) ('matrix' 'ices' 2) ('vertix' 'ices' 2) ('vertex' 'ices' 2) ('indix' 'ices' 2) ('index' 'ices' 2) ('x' 'es' 0) ('ch' 'es' 0) ('ss' 'es' 0) ('sh' 'es' 0) ('ay' 's' 0) ('ey' 's' 0) ('iy' 's' 0) ('oy' 's' 0) ('uy' 's' 0) ('y' 'ies' 1) ('alf' 'ves' 1) ('elf' 'ves' 1) ('olf' 'ves' 1) ('arf' 'ves' 1) ('nife' 'ves' 2) ('life' 'ves' 2) ('wife' 'ves' 2) ('sis' 'es' 2) ('tum' 'a' 2) ('ium' 'a' 2) ('buffalo' 'es' 0) ('tomato' 'es' 0) ('buffalo' 'es' 0) ('bus' 'es' 0) ('alias' 'es' 0) ('status' 'es' 0) ('octopus' 'i' 2) ('virus' 'i' 2) ('axis' 'es' 2) ('s' '' 0))!

pluralize: aString
	| string |
	string := aString asLowercase.
	Uninflected do: [ :each |
		(string endsWithSubCollection: each)
			ifTrue: [ ^ aString ] ].
	InflectionRules do: [ :rule |
		(string endsWithSubCollection: rule first)
			ifTrue: [ ^ (aString allButLast: rule third) , rule second ] ].
	^ aString , 's'! !
!GRInflector class categoriesFor: #initialize!initialization!public! !
!GRInflector class categoriesFor: #pluralize:!accessing!public! !

GRPackage guid: (GUID fromString: '{5F48EB12-A167-4D68-8132-0AFE9D309A4E}')!
GRPackage comment: ''!
!GRPackage categoriesForClass!Unclassified! !
!GRPackage methodsFor!

addDependenciesTo: aCollection
	(aCollection includes: self) ifFalse: [
		self dependencies
			do: [ :each | each addDependenciesTo: aCollection ].
		aCollection add: self ].
	^ aCollection!

addDependency: aString
	dependencies add: aString!

allDependencies
	"Answer all dependencies on which this package depends."

	^ self addDependenciesTo: OrderedCollection new!

dependencies
	"Return a collection of package names on which this package depends."

	^ dependencies!

description
	"Answer a short description of the package."

	^ description!

description: aString
	description := aString!

initialize
	super initialize.
	dependencies := OrderedCollection new.
	license := #MIT!

isLGPL
	^ self license = #LGPL!

isMIT
	^ self license = #MIT!

license
	"Answer the current license of this package, by default MIT is used."

	^ license!

license: aSymbol
	license := aSymbol!

name
	"Answer the name of the package. This string should be useable to identify the platform specific native package object, e.g. the Monticello package name."

	^ name!

name: aString
	name := aString!

printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(; nextPutAll: self name; nextPut: $)!

resolveWith: aDictionary
	dependencies := dependencies 
		collect: [ :each | aDictionary at: each ifAbsent: [ self error: self name printString , ' depends on unknown package ' , each printString ] ]!

seasideAddonsUrl
	^ 'http://www.squeaksource.com/Seaside30Addons'!

seasideLGPLUrl
	^ 'http://www.squeaksource.com/Seaside30LGPL'!

seasideUrl
	^ 'http://www.squeaksource.com/Seaside30'!

url
	"Answer the base-URL of the package. This string is only meaningful for platforms that can directly access Monticello repositories."

	^ url isSymbol
		ifTrue: [ self perform: url ]
		ifFalse: [ url ]!

url: aStringOrSymbol
	"Set the base-URL of the package, or a symbol referring to a method in this class that answers the URL. This setting is only meaningful for platforms that can directly access Monticello repositories."

	url := aStringOrSymbol! !
!GRPackage categoriesFor: #addDependenciesTo:!private! !
!GRPackage categoriesFor: #addDependency:!dependencies!public! !
!GRPackage categoriesFor: #allDependencies!dependencies!public! !
!GRPackage categoriesFor: #dependencies!dependencies!public! !
!GRPackage categoriesFor: #description!accessing!public! !
!GRPackage categoriesFor: #description:!accessing!public! !
!GRPackage categoriesFor: #initialize!initialization!public! !
!GRPackage categoriesFor: #isLGPL!public!testing! !
!GRPackage categoriesFor: #isMIT!public!testing! !
!GRPackage categoriesFor: #license!accessing!public! !
!GRPackage categoriesFor: #license:!accessing!public! !
!GRPackage categoriesFor: #name!accessing!public! !
!GRPackage categoriesFor: #name:!accessing!public! !
!GRPackage categoriesFor: #printOn:!printing!public! !
!GRPackage categoriesFor: #resolveWith:!dependencies!public! !
!GRPackage categoriesFor: #seasideAddonsUrl!accessing-repositories!public! !
!GRPackage categoriesFor: #seasideLGPLUrl!accessing-repositories!public! !
!GRPackage categoriesFor: #seasideUrl!accessing-repositories!public! !
!GRPackage categoriesFor: #url!accessing!public! !
!GRPackage categoriesFor: #url:!accessing!public! !

!GRPackage class methodsFor!

greaseCore
	^ self new
		name: 'Grease-Core';
		description: 'The main package of the Grease compatibility layer.';
		url: #seasideUrl;
		yourself!

packages
	"Answer a list of all registered packages. A package is registered by adding a class extension to the receiving class answering an instance of the receiving class."

	| packages package |
	packages := Dictionary new.
	self class selectors do: [ :each |
		(each numArgs = 0 and: [ each ~= #packages ]) ifTrue: [ 
			package := self perform: each.
			packages at: package name put: package ] ].
	packages do: [ :each | each resolveWith: packages ].
	^ packages values! !
!GRPackage class categoriesFor: #greaseCore!accessing!public! !
!GRPackage class categoriesFor: #packages!public!querying! !

GRPlatform guid: (GUID fromString: '{9E8BB8C0-8BCC-41B6-BFE4-685AD9ADC21D}')!
GRPlatform comment: '
The abstract platform implementation. Each platform should provide a subclass implementing any abstract methods and overriding any other methods as necessary.

Default implementations should be provided here when possible/useful but default implementations MUST be valid on ALL PLATFORMS so it is rarely practical. VA Smalltalk flags sends of uknown messages so even these must be known to exist on all platforms.

Common cases where default implementations *are* appropriate are where there is a standard implementation that is valid on all platforms but one or more platforms have an additional, optimized implementation that should be used instead.

All classes and methods used by methods of this class should be either:
  + included in the Seaside-Platform package;
  + defined by the ANSI Smalltalk standard; or
  + (not ideal) referenced via ''Smalltalk at: #ClassName''.'!
!GRPlatform categoriesForClass!Unclassified! !
!GRPlatform methodsFor!

addToShutDownList: anObject
	"Add anObject to the shutdown-list of the system. On shutdown the message #shutDown will be sent to anObject."
	self subclassResponsibility!

addToStartUpList: anObject
	"Add anObject to the startup-list of the system. On startup the message #startUp will be sent to anObject."
	self subclassResponsibility!

asMethodReturningByteArray: aByteArrayOrString named: aSymbol
	"Generates the source of a method named aSymbol that returns aByteArrayOrString as a ByteArray"
	self subclassResponsibility!

base64Decode: aString
	self subclassResponsibility!

compile: aString into: aClass classified: aSymbol
	"The trick here is to be as silently a possible so that the package is not marked dirty when running WAFileLibrary test.
	This also makes running tests much faster."
	self subclassResponsibility!

contentsOfFile: aString binary: aBoolean
	self subclassResponsibility!

convertToSmalltalkNewlines: aString
	"Convert any line endings (CR, CRLF, LF) to the default platform newline."
	
	aString isNil 
		ifTrue: [ ^ nil ].
	^ String streamContents: [ :writeStream |
		| readStream |
		readStream := aString readStream.
		[ readStream atEnd ] whileFalse: [
			| next |
			next := readStream next.
			next = Character cr
				ifTrue: [
					readStream peek = Character lf
						ifTrue: [ readStream skip: 1 ].
					writeStream nextPutAll: self newline ]
				ifFalse: [
					next = Character lf
						ifTrue: [ writeStream nextPutAll: self newline ]
						ifFalse: [ writeStream nextPut: next ] ] ] ]!

doTransaction: aBlock
	"for Gemstone/S compatibility
	http://gemstonesoup.wordpress.com/2007/05/10/porting-application-specific-seaside-threads-to-gemstone/
	use when modifying an object from an outside thread"
	^aBlock value!

ensureExistenceOfFolder: aString
	"creates a folder named aString in the image directory"
	self subclassResponsibility!

filesIn: aPathString
	"Return a collection of absolute paths for all the files (no directories) in the directory given by aPathString
	must not include file names that start with ."
	self subclassResponsibility!

includesUnsafeUrlCharacter: aString
	"Answer whether the given string contains a character that is not URL safe.
	May answer true even if only safe charaters are in the string.
	
	Platforms may override this for performance."
	^ true!

includesUnsafeXmlCharacter: aString
	"Answer whether the given string contains a character that needs to be escapted for XML.
	May answer true even if no character that needs to be escaped in the the XML.
	
	Platforms may override this for performance."
	^ true!

isProcessTerminated: aProcess
	"Return a boolean indicating whether aProcess has been terminated."
	
	self subclassResponsibility!

label
	"Answer a descriptive label string for the platform implementation"
	
	self subclassResponsibility!

localNameOf: aFilename
	"Answers the local name of a file indentified by an absolute file path.
	
	Eg.
	If the platform is Windwos and aFilename is 'C:\Windows\win32.dll' then it would answer 'win32.dll'.
	If the platform is Unix and aFilename is '/usr/bin/vim' then it would answer 'vim'."
	self subclassResponsibility!

newline
	"Answer a String with the default newline character of this platform."
	
	self subclassResponsibility!

newRandom
	"Answers the random number generator to be used to create session and continuation keys. Make sure it is seeded. They only methods that will be sent to it are:
	  #nextInt: - should answer a random integer in the interval [1, anInteger]
	  #randomFrom: - should answer a random element from the given collection
	
	Make sure that both methods are safe under heavy concurrent load.
	
	Used by Gemstone/S traditional Randoms which cannot be persisted.
	Used by Squeak to use a secure random when avaiable."
	self subclassResponsibility!

openDebuggerOn: anError
	self subclassResponsibility!

readWriteByteStream
	"Return a ReadWriteStream on a ByteArray that stores integers 0..255
		^ReadWriteStream on: ByteArray new
	"

	^self subclassResponsibility!

readWriteCharacterStream
	"Return a ReadWriteStream on a String that stores characters
		^ReadWriteStream on: String new
	"

	^self subclassResponsibility!

reducedConflictDictionary
	"used by Gemstone/S reduced conflict classes that can be used to avoid transaction conflicts"
	^ Dictionary!

removeFromShutDownList: anObject
	"Remove anObject from the shutdown list in the system."
	self subclassResponsibility!

removeFromStartUpList: anObject
	"Remove anObject from the startup list in the system."
	self subclassResponsibility!

removeSelector: aSymbol from: aClass
	self subclassResponsibility!

secureHashFor: aString
	self subclassResponsibility!

semaphoreClass
	"used by Gemstone/S traditional Semaphores which cannot be persisted"
	self subclassResponsibility!

stackDepth
	self subclassResponsibility!

terminateProcess: aProcess
	"Permanently terminate the process, unwinding first to execute #ensure: and #ifCurtailed: blocks."
	
	self subclassResponsibility!

version
	"Answer the Grease version"

	^ (GRVersion major: 1 minor: 0)
		yourself!

versionString
	^ String streamContents: [ :stream |
		stream
			nextPutAll: (self version greaseString);
			nextPutAll: ' (';
			nextPutAll: (self label);
			nextPut: $) ]!

weakDictionaryOfSize: aNumber
	self subclassResponsibility!

write: aStringOrByteArray toFile: aFileNameString inFolder: aFolderString
	"writes aStringOrByteArray to a file named aFilenameString in the folder aFolderString"
	self subclassResponsibility! !
!GRPlatform categoriesFor: #addToShutDownList:!public!startup! !
!GRPlatform categoriesFor: #addToStartUpList:!public!startup! !
!GRPlatform categoriesFor: #asMethodReturningByteArray:named:!file library!public! !
!GRPlatform categoriesFor: #base64Decode:!encoding!public! !
!GRPlatform categoriesFor: #compile:into:classified:!file library!public! !
!GRPlatform categoriesFor: #contentsOfFile:binary:!file library!public! !
!GRPlatform categoriesFor: #convertToSmalltalkNewlines:!file library!public! !
!GRPlatform categoriesFor: #doTransaction:!public!transactions! !
!GRPlatform categoriesFor: #ensureExistenceOfFolder:!file library!public! !
!GRPlatform categoriesFor: #filesIn:!file library!public! !
!GRPlatform categoriesFor: #includesUnsafeUrlCharacter:!public!testing! !
!GRPlatform categoriesFor: #includesUnsafeXmlCharacter:!public!testing! !
!GRPlatform categoriesFor: #isProcessTerminated:!processes!public! !
!GRPlatform categoriesFor: #label!public!version info! !
!GRPlatform categoriesFor: #localNameOf:!file library!public! !
!GRPlatform categoriesFor: #newline!file library!public! !
!GRPlatform categoriesFor: #newRandom!factory!public! !
!GRPlatform categoriesFor: #openDebuggerOn:!exceptions!public! !
!GRPlatform categoriesFor: #readWriteByteStream!factory!public! !
!GRPlatform categoriesFor: #readWriteCharacterStream!factory!public! !
!GRPlatform categoriesFor: #reducedConflictDictionary!factory!public! !
!GRPlatform categoriesFor: #removeFromShutDownList:!public!startup! !
!GRPlatform categoriesFor: #removeFromStartUpList:!public!startup! !
!GRPlatform categoriesFor: #removeSelector:from:!file library!public! !
!GRPlatform categoriesFor: #secureHashFor:!cryptography!public! !
!GRPlatform categoriesFor: #semaphoreClass!factory!public! !
!GRPlatform categoriesFor: #stackDepth!exceptions!public! !
!GRPlatform categoriesFor: #terminateProcess:!processes!public! !
!GRPlatform categoriesFor: #version!public!version info! !
!GRPlatform categoriesFor: #versionString!public!version info! !
!GRPlatform categoriesFor: #weakDictionaryOfSize:!factory!public! !
!GRPlatform categoriesFor: #write:toFile:inFolder:!file library!public! !

!GRPlatform class methodsFor!

current

	^ Current!

current: aPlatform
	Current := aPlatform!

select
	GRPlatform current: self new!

unselect
	GRPlatform current class = self ifTrue: [ GRPlatform current: nil ]! !
!GRPlatform class categoriesFor: #current!public!registration! !
!GRPlatform class categoriesFor: #current:!public!registration! !
!GRPlatform class categoriesFor: #select!public!registration! !
!GRPlatform class categoriesFor: #unselect!public!registration! !

GRPrinter guid: (GUID fromString: '{E534CD88-2DB1-4607-ACC4-36B192ADD007}')!
GRPrinter comment: ''!
!GRPrinter categoriesForClass!Unclassified! !
!GRPrinter methodsFor!

, aPrinter 
	^ GRSequentialPrinter new , self , aPrinter!

pad: aString center: aCharacter to: anInteger
	"Pad to the center of aString with aCharacter to at least anInteger characters."

	| result index |
	anInteger <= aString size
		ifTrue: [ ^ aString ].
	index := (anInteger - aString size) // 2.
	result := (String new: anInteger) atAllPut: aCharacter.
	result
		replaceFrom: index + 1
		to: index + aString size
		with: aString
		startingAt: 1.
	^ result!

pad: aString left: aCharacter to: anInteger
	"Pad to the left side of aString with aCharacter to at least anInteger characters."

	| result |
	anInteger <= aString size
		ifTrue: [ ^ aString ].
	result := (String new: anInteger) atAllPut: aCharacter.
	result
		replaceFrom: anInteger - aString size + 1
		to: anInteger
		with: aString
		startingAt: 1.
	^ result!

pad: aString right: aCharacter to: anInteger
	"Pad to the right side of aString with aCharacter to at least anInteger characters."

	| result |
	anInteger <= aString size
		ifTrue: [ ^ aString ].
	result := (String new: anInteger) atAllPut: aCharacter.
	result
		replaceFrom: 1
		to: aString size
		with: aString
		startingAt: 1.
	^ result!

print: anObject
	^ String streamContents: [ :stream | self print: anObject on: stream ]!

print: anObject on: aStream
	"Subclasses override this method to produce some output."! !
!GRPrinter categoriesFor: #,!operators!public! !
!GRPrinter categoriesFor: #pad:center:to:!public!utilities! !
!GRPrinter categoriesFor: #pad:left:to:!public!utilities! !
!GRPrinter categoriesFor: #pad:right:to:!public!utilities! !
!GRPrinter categoriesFor: #print:!printing!public! !
!GRPrinter categoriesFor: #print:on:!printing!public! !

!GRPrinter class methodsFor!

abbreviatedMonthName
	^ self monthName: #('Jan' 'Feb' 'Mar' 'Apr' 'May' 'Jun' 'Jul' 'Aug' 'Sep' 'Oct' 'Nov' 'Dec')!

abbreviatedWeekName
	^ self weekName: #('Sun' 'Mon' 'Tue' 'Wed' 'Thu' 'Fri' 'Sat')!

absOffsetHoursPadded
	^ GRMappedPrinter 
		block: [ :date | date offset hours abs ]
		next: (self numberWithAtLeastDigits: 2)!

absOffsetMinutesPadded
	^ GRMappedPrinter 
		block: [ :date | date offset minutes abs ]
		next: (self numberWithAtLeastDigits: 2)!

binaryFileSize
	^ GRUnitPrinter 
		base: 1024
		units: #(
				'byte'
				'bytes'
				'KiB'
				'MiB'
				'GiB'
				'TiB'
				'PiB'
				'EiB'
				'ZiB'
				'YiB'
			)!

cookieTimestamp
	"Netscape's original proposal defined an Expires header that took a date value in a fixed-length variant format in place of Max-Age: Wdy, DD-Mon-YY HH:MM:SS GMT"
	^ GRMappedPrinter 
		block: [ :timestamp | timestamp asUTC ]
		next: self abbreviatedWeekName , ', ' , self paddedDay , '-' , self abbreviatedMonthName , '-' , self paddedYear , ' ' , self isoTime , ' GMT'!

decimalFileSize
	^ GRUnitPrinter 
		base: 1000
		units: #(
				'byte'
				'bytes'
				'kB'
				'MB'
				'GB'
				'TB'
				'PB'
				'EB'
				'ZB'
				'YB'
			)!

fullMonthName
	^ self monthName: #('January' 'February' 'March' 'April' 'May' 'June' 'July' 'August' 'September' 'October' 'November' 'December')!

fullWeekName
	^ self weekName: #('Sunday' 'Monday' 'Tuesday' 'Wednesday' 'Thursday' 'Friday' 'Saturday')!

httpDate
	"Answers a printer that formats dates for HTTP1.1 (RFC 2616)"
	^ self rfc1123!

isoDate
	"Ansers a printer that formats dates accoring to ISO(YYYY-MM-DD) E.g.
	2003-12-24"
	^ self paddedYear , $- , self paddedMonth , $- , self paddedDay!

isoTime
	"Ansers a printer that formats time accoring to ISO(HH:MM:SS) E.g.
	12:23:34"
	^ self paddedHour24 , $: , self paddedMinute , $: , self paddedSecond!

monthName: anArray 
	^ GRPluggablePrinter on: [ :date | anArray at: date monthIndex ]!

numberWithAtLeastDigits: anInteger 
	^ GRNumberPrinter new
		padding: $0;
		digits: anInteger;
		yourself!

offsetSign
	^ GRMappedPrinter 
		block: [ :date | date offset ]
		next: (GRSignPrinter new
				positivePrinter: $+;
				negativePrinter: $-;
				yourself)!

paddedCentury
	^ GRMappedPrinter 
		block: [ :date | date year \\ 100 ]
		next: (self numberWithAtLeastDigits: 2)!

paddedDay
	^ GRMappedPrinter 
		block: [ :date | date dayOfMonth ]
		next: (self numberWithAtLeastDigits: 2)!

paddedHour12
	^ GRMappedPrinter 
		block: [ :time | (time hour - 1) \\ 12 + 1 ]
		next: (self numberWithAtLeastDigits: 2)!

paddedHour24
	^ GRMappedPrinter 
		block: [ :time | time hour ]
		next: (self numberWithAtLeastDigits: 2)!

paddedMinute
	^ GRMappedPrinter 
		block: [ :time | time minute ]
		next: (self numberWithAtLeastDigits: 2)!

paddedMonth
	^ GRMappedPrinter 
		block: [ :date | date monthIndex ]
		next: (self numberWithAtLeastDigits: 2)!

paddedSecond
	^ GRMappedPrinter 
		block: [ :time | time second ]
		next: (GRNumberPrinter new
				padding: $0;
				digits: 2)!

paddedYear
	^ GRMappedPrinter 
		block: [ :date | date year ]
		next: (self numberWithAtLeastDigits: 4)!

rfc1123
	"Answers a printer that formats dates for HTTP1.1 (RFC 1123). Eg.
	Sun, 06 Nov 1994 08:49:37 GMT "
	^ GRMappedPrinter 
		block: 
			[ :date | 
			"For the purposes of HTTP, GMT is exactly equal to UTC (Coordinated Universal Time)"
			date asUTC ]
		next: GRSequentialPrinter new , self abbreviatedWeekName , ', ' , self paddedDay , Character space , self abbreviatedMonthName , Character space , self paddedYear , Character space , self isoTime , ' GMT'!

rfc822
	"Answers a privter that formats dates according to RFC 822 (email). Eg.
	Sun, 31 Aug 2008 19:41:46 +0200"
	^ self abbreviatedWeekName , ', '
		, self paddedDay, Character space, self abbreviatedMonthName, Character space, self paddedYear, Character space,
		self isoTime, Character space, self offsetSign, self absOffsetHoursPadded, self absOffsetMinutesPadded!

rfc822WithTimeZone: aString
	"Answers a privter that formats dates according to RFC 822 (email) with the given time zone String. Eg.
	Sun, 31 Aug 2008 19:41:46 <aString>"
	^ self abbreviatedWeekName , ', '
		, self paddedDay, Character space, self abbreviatedMonthName, Character space, self paddedYear, Character space,
		self isoTime, Character space, aString!

swissCurrency
	^ GRSequentialPrinter new , 'CHF ' , GRSignPrinter new , (GRNumberPrinter new
			separator: $';
			precision: 2;
			accuracy: 0.05;
			yourself)!

unpaddedCentury
	^ GRMappedPrinter 
		block: [ :date | date year \\ 100 ]
		next: GRNumberPrinter new!

unpaddedDay
	^ GRMappedPrinter 
		block: [ :date | date dayOfMonth ]
		next: GRNumberPrinter new!

unpaddedHour12
	^ GRMappedPrinter 
		block: [ :time | (time hour - 1) \\ 12 + 1 ]
		next: GRNumberPrinter new!

unpaddedHour24
	^ GRMappedPrinter 
		block: [ :time | time hour ]
		next: GRNumberPrinter new!

unpaddedMinute
	^ GRMappedPrinter 
		block: [ :time | time minute ]
		next: GRNumberPrinter new!

unpaddedMonth
	^ GRMappedPrinter 
		block: [ :date | date monthIndex ]
		next: GRNumberPrinter new!

unpaddedSecond
	^ GRMappedPrinter 
		block: [ :time | time second ]
		next: GRNumberPrinter new!

unpaddedYear
	^ GRMappedPrinter 
		block: [ :date | date year ]
		next: GRNumberPrinter new!

usCurrency
	^ GRSignPrinter new , $$ , (GRNumberPrinter new
			separator: $,;
			precision: 2;
			yourself)!

weekName: anArray 
	^ GRPluggablePrinter on: [ :date | anArray at: date dayOfWeek ]! !
!GRPrinter class categoriesFor: #abbreviatedMonthName!parts-date!public! !
!GRPrinter class categoriesFor: #abbreviatedWeekName!parts-date!public! !
!GRPrinter class categoriesFor: #absOffsetHoursPadded!parts-date!public! !
!GRPrinter class categoriesFor: #absOffsetMinutesPadded!parts-date!public! !
!GRPrinter class categoriesFor: #binaryFileSize!parts-units!public! !
!GRPrinter class categoriesFor: #cookieTimestamp!factory!public! !
!GRPrinter class categoriesFor: #decimalFileSize!parts-units!public! !
!GRPrinter class categoriesFor: #fullMonthName!parts-date!public! !
!GRPrinter class categoriesFor: #fullWeekName!parts-date!public! !
!GRPrinter class categoriesFor: #httpDate!factory!public! !
!GRPrinter class categoriesFor: #isoDate!factory!public! !
!GRPrinter class categoriesFor: #isoTime!factory!public! !
!GRPrinter class categoriesFor: #monthName:!parts-date!public! !
!GRPrinter class categoriesFor: #numberWithAtLeastDigits:!parts-units!public! !
!GRPrinter class categoriesFor: #offsetSign!parts-date!public! !
!GRPrinter class categoriesFor: #paddedCentury!parts-date!public! !
!GRPrinter class categoriesFor: #paddedDay!parts-date!public! !
!GRPrinter class categoriesFor: #paddedHour12!parts-time!public! !
!GRPrinter class categoriesFor: #paddedHour24!parts-time!public! !
!GRPrinter class categoriesFor: #paddedMinute!parts-time!public! !
!GRPrinter class categoriesFor: #paddedMonth!parts-date!public! !
!GRPrinter class categoriesFor: #paddedSecond!parts-time!public! !
!GRPrinter class categoriesFor: #paddedYear!parts-date!public! !
!GRPrinter class categoriesFor: #rfc1123!factory!public! !
!GRPrinter class categoriesFor: #rfc822!factory!public! !
!GRPrinter class categoriesFor: #rfc822WithTimeZone:!factory!public! !
!GRPrinter class categoriesFor: #swissCurrency!factory!public! !
!GRPrinter class categoriesFor: #unpaddedCentury!parts-date!public! !
!GRPrinter class categoriesFor: #unpaddedDay!parts-date!public! !
!GRPrinter class categoriesFor: #unpaddedHour12!parts-time!public! !
!GRPrinter class categoriesFor: #unpaddedHour24!parts-time!public! !
!GRPrinter class categoriesFor: #unpaddedMinute!parts-time!public! !
!GRPrinter class categoriesFor: #unpaddedMonth!parts-date!public! !
!GRPrinter class categoriesFor: #unpaddedSecond!parts-time!public! !
!GRPrinter class categoriesFor: #unpaddedYear!parts-date!public! !
!GRPrinter class categoriesFor: #usCurrency!factory!public! !
!GRPrinter class categoriesFor: #weekName:!parts-date!public! !

GRSmallDictionary guid: (GUID fromString: '{61645538-E091-41F2-AB33-7BD621039224}')!
GRSmallDictionary comment: 'I am an implementation of a dictionary. Compared to other dictionaries I am very efficient for small sizes, speed- and space-wise. I also mantain the order in which elements are added when iterating. My implementation features some ideas from the RefactoringBrowser.'!
!GRSmallDictionary categoriesForClass!Unclassified! !
!GRSmallDictionary methodsFor!

add: anAssociation
	self at: anAssociation key put: anAssociation value.
	^anAssociation!

addAll: aDictionary
	aDictionary keysAndValuesDo: [ :key :value | self add: key -> value ].
	^ aDictionary!

associations
	"Answer a Collection containing the receiver's associations."

	| result |
	result := WriteStream on: (Array new: self size).
	self associationsDo: [ :assoc | result nextPut: assoc ].
	^ result contents!

associationsDo: aBlock
	self keysAndValuesDo: [ :key :value | aBlock value: key -> value ]!

at: aKey
	"Answer the value associated with aKey. Raise an exception, if no such key is defined."

	^ self at: aKey ifAbsent: [ self errorKeyNotFound ]!

at: aKey ifAbsent: aBlock
	"Answer the value associated with aKey. Evaluate aBlock, if no such key is defined."

	| index |
	index := self findIndexFor: aKey.
	^ index = 0
		ifFalse: [ values at: index ]
		ifTrue: [ aBlock value ]!

at: aKey ifAbsentPut: aBlock
	"Answer the value associated with aKey. Evaluate aBlock, if no such key is defined and store the return value."

	| index |
	index := self findIndexFor: aKey.
	^ index = 0
		ifFalse: [ values at: index ]
		ifTrue: [ self privateAt: aKey put: aBlock value ]!

at: aKey ifPresent: aBlock
	"Lookup aKey in the receiver. If it is present, answer the value of evaluating the given block with the value associated with the key. Otherwise, answer nil."

	| index |
	index := self findIndexFor: aKey.
	^ index = 0 ifFalse: [ aBlock value: (values at: index) ]!

at: aKey put: aValue
	"Set the value of aKey to be aValue."

	| index |
	index := self findIndexFor: aKey.
	^ index = 0
		ifFalse: [ values at: index put: aValue ]
		ifTrue: [ self privateAt: aKey put: aValue ]!

do: aBlock
	1 to: size do: [ :index | aBlock value: (values at: index) ]!

errorKeyNotFound
	self error: 'Key not found'!

findIndexFor: aKey
	1 to: size do: [ :index |
		(keys at: index) = aKey
			ifTrue: [ ^ index ] ].
	^ 0!

grow
	| newKeys newValues |
	newKeys := Array new: 2 * size.
	newValues := Array new: 2 * size.
	1 to: size do: [ :index |
		newKeys at: index put: (keys at: index).
		newValues at: index put: (values at: index) ].
	keys := newKeys.
	values := newValues!

includesKey: aKey
	"Answer whether the receiver has a key equal to aKey."

	^ (self findIndexFor: aKey) ~= 0!

initialize: anInteger
	self initialize.
	size := 0.
	keys := Array new: anInteger.
	values := Array new: anInteger!

isCollection
	^ true!

isDictionary
	^ true!

isEmpty
	^ size = 0!

keys
	^ keys copyFrom: 1 to: size!

keysAndValuesDo: aBlock
	1 to: size do: [ :index | aBlock value: (keys at: index) value: (values at: index) ]!

keysDo: aBlock
	1 to: size do: [ :each | aBlock value: (keys at: each) ]!

postCopy
	super postCopy.
	keys := keys copy.
	values := values copy!

privateAt: aKey put: aValue
	size = keys size ifTrue: [ self grow ].
	keys at: (size := size + 1) put: aKey.
	^ values at: size put: aValue!

removeIndex: index
	| value |
	value := values at: index.
	index to: size - 1 do:
			[ :i | 
			keys at: i put: (keys at: i + 1).
			values at: i put: (values at: i + 1) ].
	keys at: size put: nil.
	values at: size put: nil.
	size := size - 1.
	^ value!

removeKey: aKey
	"Remove aKey from the receiver, raise an exception if the element is missing."

	^ self removeKey: aKey ifAbsent: [ self errorKeyNotFound ]!

removeKey: aKey ifAbsent: aBlock
	"Remove aKey from the receiver, evaluate aBlock if the element is missing."

	| index |
	index := self findIndexFor: aKey.
	index = 0 ifTrue: [ ^ aBlock value ].
	^ self removeIndex: index!

size
	^ size!

values
	^ values copyFrom: 1 to: size! !
!GRSmallDictionary categoriesFor: #add:!accessing!public! !
!GRSmallDictionary categoriesFor: #addAll:!accessing!public! !
!GRSmallDictionary categoriesFor: #associations!accessing!public! !
!GRSmallDictionary categoriesFor: #associationsDo:!enumerating!public! !
!GRSmallDictionary categoriesFor: #at:!accessing!public! !
!GRSmallDictionary categoriesFor: #at:ifAbsent:!accessing!public! !
!GRSmallDictionary categoriesFor: #at:ifAbsentPut:!accessing!public! !
!GRSmallDictionary categoriesFor: #at:ifPresent:!accessing!public! !
!GRSmallDictionary categoriesFor: #at:put:!accessing!public! !
!GRSmallDictionary categoriesFor: #do:!enumerating!public! !
!GRSmallDictionary categoriesFor: #errorKeyNotFound!private! !
!GRSmallDictionary categoriesFor: #findIndexFor:!private! !
!GRSmallDictionary categoriesFor: #grow!private! !
!GRSmallDictionary categoriesFor: #includesKey:!public!testing! !
!GRSmallDictionary categoriesFor: #initialize:!initialization!public! !
!GRSmallDictionary categoriesFor: #isCollection!public!testing! !
!GRSmallDictionary categoriesFor: #isDictionary!public!testing! !
!GRSmallDictionary categoriesFor: #isEmpty!public!testing! !
!GRSmallDictionary categoriesFor: #keys!enumerating!public! !
!GRSmallDictionary categoriesFor: #keysAndValuesDo:!enumerating!public! !
!GRSmallDictionary categoriesFor: #keysDo:!enumerating!public! !
!GRSmallDictionary categoriesFor: #postCopy!copying!public! !
!GRSmallDictionary categoriesFor: #privateAt:put:!private! !
!GRSmallDictionary categoriesFor: #removeIndex:!private! !
!GRSmallDictionary categoriesFor: #removeKey:!accessing!public! !
!GRSmallDictionary categoriesFor: #removeKey:ifAbsent:!accessing!public! !
!GRSmallDictionary categoriesFor: #size!accessing!public! !
!GRSmallDictionary categoriesFor: #values!enumerating!public! !

!GRSmallDictionary class methodsFor!

new
	^ self new: 3!

new: anInteger
	^ self basicNew initialize: anInteger; yourself!

withAll: aDictionary
	^ (self new: aDictionary size)
		addAll: aDictionary;
		yourself! !
!GRSmallDictionary class categoriesFor: #new!instance creation!public! !
!GRSmallDictionary class categoriesFor: #new:!instance creation!public! !
!GRSmallDictionary class categoriesFor: #withAll:!instance creation!public! !

GRVersion guid: (GUID fromString: '{33AE342D-B841-4F0D-A646-DF214B215E04}')!
GRVersion comment: ''!
!GRVersion categoriesForClass!Unclassified! !
!GRVersion methodsFor!

< otherVersion
	(major < otherVersion major) ifTrue: [ ^ true ].
	(otherVersion major < major) ifTrue: [ ^ false ].
	((minor ifNil: [ 0 ]) < (otherVersion minor ifNil: [ 0 ])) ifTrue: [ ^ true ].
	((otherVersion minor ifNil: [ 0 ]) < (minor ifNil: [ 0 ])) ifTrue: [ ^ false ].
	((revision ifNil: [ 0 ]) < (otherVersion revision ifNil: [ 0 ])) ifTrue: [ ^ true ].
	((otherVersion revision ifNil: [ 0 ]) < (revision ifNil: [ 0 ])) ifTrue: [ ^ false ].
	(stageLabel = otherVersion stage) ifTrue: [
		^ ((stageNumber ifNil: [ 1 ]) < (otherVersion stageNumber ifNil: [ 1 ])) ].
	stageLabel isNil ifTrue: [ ^ false ].
	otherVersion stage isNil ifTrue: [ ^ true ].
	^ stageLabel < otherVersion stage
	
	!

<= otherVersion
	^ (self > otherVersion) not!

= otherVersion
	^ (major = otherVersion major) and: [
		((minor ifNil: [ 0 ]) = (otherVersion minor ifNil: [ 0 ])) and: [
		((revision ifNil: [ 0 ] ) = (otherVersion revision ifNil: [ 0 ])) and: [
		(stageLabel = otherVersion stage) and: [
		(stageNumber ifNil: [ 1 ]) = (otherVersion stageNumber ifNil: [ 1 ]) ] ] ] ]!

> otherVersion
	^ otherVersion < self!

>= otherVersion
	^ (self < otherVersion) not!

beAlpha
	self beAlpha: nil!

beAlpha: anInteger
	self stage: #alpha number: anInteger!

beBeta
	self beBeta: nil!

beBeta: anInteger
	self stage: #beta number: anInteger!

beFinal
	self stage: nil number: nil!

beReleaseCandidate
	self beReleaseCandidate: nil!

beReleaseCandidate: anInteger
	self stage: #rc number: anInteger!

greaseString
	^String streamContents: 
			[:stream | 
			stream nextPutAll: major greaseString.
			stream nextPut: $..
			stream nextPutAll: (minor ifNil: [0]) greaseString.
			revision isNil 
				ifFalse: 
					[stream nextPut: $..
					stream nextPutAll: revision greaseString].
			stageLabel isNil 
				ifFalse: 
					[stream nextPutAll: stageLabel greaseString.
					stageNumber isNil ifFalse: [stream nextPutAll: stageNumber greaseString]]]!

hash
	^ (major hash bitXor: minor hash) bitXor: revision hash!

initializeWithMajor: majorInteger minor: minorInteger revision: revisionInteger
	self initialize.
	major := majorInteger.
	minor := minorInteger.
	revision := revisionInteger!

isAlpha
	^ stageLabel = #alpha!

isBeta
	^ stageLabel = #beta!

isFinal
	^ stageLabel isNil!

isReleaseCandidate
	^ stageLabel = #rc!

major
	^ major!

major: anInteger
	major := anInteger!

minor
	^ minor!

minor: anInteger
	minor := anInteger!

revision
	^ revision!

revision: anInteger
	revision := anInteger!

stage
	^ stageLabel!

stage: aSymbol number: anInteger
	stageLabel := aSymbol.
	stageNumber := anInteger!

stageNumber
	^ stageNumber! !
!GRVersion categoriesFor: #<!comparing!public! !
!GRVersion categoriesFor: #<=!comparing!public! !
!GRVersion categoriesFor: #=!comparing!public! !
!GRVersion categoriesFor: #>!comparing!public! !
!GRVersion categoriesFor: #>=!comparing!public! !
!GRVersion categoriesFor: #beAlpha!convenience!public! !
!GRVersion categoriesFor: #beAlpha:!convenience!public! !
!GRVersion categoriesFor: #beBeta!convenience!public! !
!GRVersion categoriesFor: #beBeta:!convenience!public! !
!GRVersion categoriesFor: #beFinal!convenience!public! !
!GRVersion categoriesFor: #beReleaseCandidate!convenience!public! !
!GRVersion categoriesFor: #beReleaseCandidate:!convenience!public! !
!GRVersion categoriesFor: #greaseString!converting!public! !
!GRVersion categoriesFor: #hash!comparing!public! !
!GRVersion categoriesFor: #initializeWithMajor:minor:revision:!initialization!public! !
!GRVersion categoriesFor: #isAlpha!public!testing! !
!GRVersion categoriesFor: #isBeta!public!testing! !
!GRVersion categoriesFor: #isFinal!public!testing! !
!GRVersion categoriesFor: #isReleaseCandidate!public!testing! !
!GRVersion categoriesFor: #major!accessing!public! !
!GRVersion categoriesFor: #major:!accessing!public! !
!GRVersion categoriesFor: #minor!accessing!public! !
!GRVersion categoriesFor: #minor:!accessing!public! !
!GRVersion categoriesFor: #revision!accessing!public! !
!GRVersion categoriesFor: #revision:!accessing!public! !
!GRVersion categoriesFor: #stage!accessing!public! !
!GRVersion categoriesFor: #stage:number:!accessing!public! !
!GRVersion categoriesFor: #stageNumber!accessing!public! !

!GRVersion class methodsFor!

major: majorInteger
	^ self major: majorInteger minor: nil!

major: majorInteger minor: minorInteger
	^ self major: majorInteger minor: minorInteger revision: nil!

major: majorInteger minor: minorInteger revision: revisionInteger
	^ self basicNew
		initializeWithMajor: majorInteger minor: minorInteger revision: revisionInteger;
		yourself!

new
	^ self major: 1! !
!GRVersion class categoriesFor: #major:!instance creation!public! !
!GRVersion class categoriesFor: #major:minor:!instance creation!public! !
!GRVersion class categoriesFor: #major:minor:revision:!instance creation!public! !
!GRVersion class categoriesFor: #new!instance creation!public! !

GRNullCodec guid: (GUID fromString: '{C275ADFE-0A52-4639-B664-5213359D04A6}')!
GRNullCodec comment: 'The null codec always returns the original streams. It assumes that the outside world uses the same encoding as the inside world. This is highly efficient as no transfomration is applied to the data, but has its drawbacks.'!
!GRNullCodec categoriesForClass!Unclassified! !
!GRNullCodec methodsFor!

decode: aString
	"Overridden for efficencey."

	^ aString!

decoderFor: aReadStream 
	"wrap to avoid String vs ByteArray issues"
	^ GRNullCodecStream on: aReadStream!

encode: aString
	"Overridden for efficencey."

	^ aString!

encoderFor: aWriteStream 
	"wrap to avoid String vs ByteArray issues"
	^ GRNullCodecStream on: aWriteStream!

name
	^ GRNullCodec codecName!

url
	"The selfish method. Let's do it with ourselves."
	
	^ self! !
!GRNullCodec categoriesFor: #decode:!convenience!public! !
!GRNullCodec categoriesFor: #decoderFor:!conversion!public! !
!GRNullCodec categoriesFor: #encode:!convenience!public! !
!GRNullCodec categoriesFor: #encoderFor:!conversion!public! !
!GRNullCodec categoriesFor: #name!accessing!public! !
!GRNullCodec categoriesFor: #url!accessing!public! !

!GRNullCodec class methodsFor!

basicForEncoding: aString
	^self new!

codecName
	^ '(none)'!

codecs
	^ Array with: self new!

supportsEncoding: aString
	^aString isNil! !
!GRNullCodec class categoriesFor: #basicForEncoding:!private! !
!GRNullCodec class categoriesFor: #codecName!accessing!public! !
!GRNullCodec class categoriesFor: #codecs!accessing!public! !
!GRNullCodec class categoriesFor: #supportsEncoding:!public!testing! !

GRNullCodecStream guid: (GUID fromString: '{476A4891-E16F-4FE4-8641-B90744405828}')!
GRNullCodecStream comment: '
A WANullCodecStream is a WriteStream on a String on which you can both put binary and character data without encoding happening.

Instance Variables
	stream:		<WriteStream>

stream
	- a WriteStream on a String
'!
!GRNullCodecStream categoriesForClass!Unclassified! !
!GRNullCodecStream methodsFor!

next
	^stream next!

next: anInteger
	^stream next: anInteger!

nextPut: aCharacterOrByte
	aCharacterOrByte isCharacter
		ifTrue: [ stream nextPut: aCharacterOrByte ]
		ifFalse: [ stream nextPut: (Character codePoint: aCharacterOrByte) ]!

nextPutAll: aStringOrByteArray
	aStringOrByteArray isString
		ifTrue: [ stream nextPutAll: aStringOrByteArray ]
		ifFalse: [
			1 to: aStringOrByteArray size do: [ :index |
				stream nextPut: (Character codePoint: (aStringOrByteArray at: index)) ] ]! !
!GRNullCodecStream categoriesFor: #next!public!streaming! !
!GRNullCodecStream categoriesFor: #next:!public!streaming! !
!GRNullCodecStream categoriesFor: #nextPut:!public!streaming! !
!GRNullCodecStream categoriesFor: #nextPutAll:!public!streaming! !

GRBoundDelayedSend guid: (GUID fromString: '{9FC770FA-B4BE-4628-98B1-2DA01FE242BE}')!
GRBoundDelayedSend comment: '
A delayed send that has some or all of the arguments defined in advance. Additionally supplied arguments will be added, if possible, to these when the object is evaluate.

Instance Variables
	arguments:		<Array>

arguments
	- the predefined arguments
'!
!GRBoundDelayedSend categoriesForClass!Unclassified! !
!GRBoundDelayedSend methodsFor!

argumentCount
	^selector numArgs - arguments size!

initializeWithReceiver: anObject selector: aSymbol arguments: anArray
	self initializeWithReceiver: anObject selector: aSymbol.
	arguments := anArray asArray!

printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' arguments: '; print: arguments!

valueWithArguments: anArray
	^ arguments size + anArray size = selector numArgs
		ifTrue: [ receiver perform: selector withArguments: arguments , anArray ]
		ifFalse: [ self invalidArgumentCount ]!

valueWithPossibleArguments: anArray
	| composed |
	^ (composed := arguments , anArray) size < selector numArgs
		ifTrue: [ self invalidArgumentCount ]
		ifFalse: [ receiver perform: selector withArguments: (composed first: selector numArgs) ]! !
!GRBoundDelayedSend categoriesFor: #argumentCount!accessing!public! !
!GRBoundDelayedSend categoriesFor: #initializeWithReceiver:selector:arguments:!initialization!public! !
!GRBoundDelayedSend categoriesFor: #printOn:!printing!public! !
!GRBoundDelayedSend categoriesFor: #valueWithArguments:!evaluating!public! !
!GRBoundDelayedSend categoriesFor: #valueWithPossibleArguments:!evaluating!public! !

GRUnboundDelayedSend guid: (GUID fromString: '{CD6E1393-AB42-4732-9C4C-678DEA33C4D2}')!
GRUnboundDelayedSend comment: 'A delayed send that has none of the arguments defined in advance.'!
!GRUnboundDelayedSend categoriesForClass!Unclassified! !
!GRUnboundDelayedSend methodsFor!

argumentCount
	^ selector numArgs!

valueWithArguments: anArray
	^ anArray size = selector numArgs
		ifTrue: [ receiver perform: selector withArguments: anArray ]
		ifFalse: [ self invalidArgumentCount ]!

valueWithPossibleArguments: anArray
	^ anArray size < selector numArgs
		ifTrue: [ self invalidArgumentCount ]
		ifFalse: [ self valueWithArguments: (anArray first: selector numArgs) ]! !
!GRUnboundDelayedSend categoriesFor: #argumentCount!accessing!public! !
!GRUnboundDelayedSend categoriesFor: #valueWithArguments:!evaluating!public! !
!GRUnboundDelayedSend categoriesFor: #valueWithPossibleArguments:!evaluating!public! !

GRMappedPrinter guid: (GUID fromString: '{DC955EB4-C6E9-4A25-B5F4-FEE9052EE36A}')!
GRMappedPrinter comment: ''!
!GRMappedPrinter categoriesForClass!Unclassified! !
!GRMappedPrinter methodsFor!

block: aBlock
	block := aBlock!

initialize
	super initialize.
	self block: [ :value | value ]!

next: aPrinter
	next := aPrinter!

print: anObject on: aStream
	next print: (block value: anObject) on: aStream! !
!GRMappedPrinter categoriesFor: #block:!accessing!public! !
!GRMappedPrinter categoriesFor: #initialize!initialization!public! !
!GRMappedPrinter categoriesFor: #next:!accessing!public! !
!GRMappedPrinter categoriesFor: #print:on:!printing!public! !

!GRMappedPrinter class methodsFor!

block: aBlock next: aPrinter
	^ self new 
		block: aBlock;
		next: aPrinter;
		yourself! !
!GRMappedPrinter class categoriesFor: #block:next:!instance creation!public! !

GRNumberPrinter guid: (GUID fromString: '{7EAB220C-C46B-43DD-A7E3-FEF9A52987EE}')!
GRNumberPrinter comment: '
A WANumberPrinter is prints numbers (integers and floats) in various formats in a platform independent way.

Instance Variables
	accuracy:		<UndefinedObject|Float>
	base:			<Integer>
	delimiter:		<UndefinedObject|Charater>
	digits:			<UndefinedObject|Integer>
	infinite:		<UndefinedObject|String>
	nan:			<UndefinedObject|String>
	padding:		<UndefinedObject|Charater>
	precision:		<Integer>
	separator:		<UndefinedObject|Charater>'!
!GRNumberPrinter categoriesForClass!Unclassified! !
!GRNumberPrinter methodsFor!

accuracy: aFloat
	"Round towards the nearest number that is a multiple of aFloat."
	
	accuracy := aFloat!

base: anInteger
	"The numeric base to which the number should be printed."

	base := anInteger!

characters: aString
	"The characters to be used to convert a number to a string."

	characters := aString!

delimiter: aCharacter
	"The delimiter to separate the integer and fraction part of the number."

	delimiter := aCharacter!

digits: anInteger
	"The number of digits to be printed in the integer part."

	digits := anInteger!

digitsOf: aNumber base: aBaseInteger
	"Answer the absolute digits of aNumber in the base aBaseInteger."

	| integer stream next |
	integer := aNumber truncated abs.
	integer = 0 ifTrue: [ ^ '0' ].
	stream := WriteStream on: (String new: 10).
	[ integer > 0 ] whileTrue: [
		next := integer quo: aBaseInteger.
		stream nextPut: (characters 
			at: 1 + integer - (next * aBaseInteger)).
		integer := next ].
	^ stream contents reverse!

infinite: aString
	"The string that should be displayed if the number is positive or negative infinity."
	
	infinite := aString!

initialize
	super initialize.
	self lowercase.
	self base: 10.
	self delimiter: $..
	self infinite: 'Infinite'.
	self nan: 'NaN'.
	self padding: $ .
	self precision: 0!

lowercase
	"Use lowercase characters for numbers of base 10 and higher."

	self characters: NumbersToCharactersLowercase!

nan: aString
	"The string that should be displayed if the number is not a number."
	
	nan := aString!

padding: aCharacter
	"The padding for the integer part."

	padding := aCharacter!

precision: anInteger
	"The number of digits to be printed in the fraction part."
	
	precision := anInteger!

print: aNumber on: aStream
	aNumber isNaN
		ifTrue: [ ^ self printNaN: aNumber on: aStream ].
	aNumber isInfinite 
		ifTrue: [ ^ self printInfinite: aNumber on: aStream ].
	precision = 0
		ifTrue: [ self printInteger: aNumber on: aStream ]
		ifFalse: [ self printFloat: aNumber on: aStream ]!

printFloat: aNumber on: aStream
	| multiplier rounded |
	multiplier := base asFloat raisedTo: precision.
	rounded := aNumber roundTo: (accuracy ifNil: [ 1.0 / multiplier ]).
	self printInteger: rounded on: aStream.
	delimiter isNil
		ifFalse: [ aStream nextPut: delimiter ].
	self printFraction: rounded fractionPart abs * multiplier on: aStream!

printFraction: aNumber on: aStream
	| result |
	result := self
		pad: (self digitsOf: aNumber rounded base: base)
		left: $0 to: precision.
	separator isNil
		ifFalse: [ result := self separate: result left: separator ].
	aStream nextPutAll: result!

printInfinite: aNumber on: aStream
	infinite isNil
		ifFalse: [ aStream nextPutAll: infinite ]!

printInteger: aNumber on: aStream
	| result |
	result := self digitsOf: aNumber integerPart base: base.
	separator isNil
		ifFalse: [ result := self separate: result right: separator ].
	(digits isNil or: [ padding isNil ])
		ifFalse: [ result := self pad: result left: padding to: digits ].
	aStream nextPutAll: result!

printNaN: anInteger on: aStream
	nan isNil
		ifFalse: [ aStream nextPutAll: nan ]!

separate: aString left: aCharacter
	"Separate from the left side every 3 characters with aCharacter."
		
	| size stream |
	size := aString size.
	stream := WriteStream on: (String new: 2 * size).
	1 to: size do: [ :index |
		(index ~= 1 and: [ index \\ 3 = 1 ])
			ifTrue: [ stream nextPut: aCharacter ].
		stream nextPut: (aString at: index) ].
	^ stream contents!

separate: aString right: aCharacter
	"Separate from the right side every 3 characters with aCharacter."
		
	| size stream |
	size := aString size.
	stream := WriteStream on: (String new: 2 * size).
	1 to: size do: [ :index |
		(index ~= 1 and: [ size - index \\ 3 = 2 ])
			ifTrue: [ stream nextPut: aCharacter ].
		stream nextPut: (aString at: index) ].
	^ stream contents!

separator: aCharacter
	"Separator character to be used to group digits."

	separator := aCharacter!

uppercase
	"Use uppercase characters for numbers of base 10 and higher."
	
	self characters: NumbersToCharactersUppercase! !
!GRNumberPrinter categoriesFor: #accuracy:!accessing!public! !
!GRNumberPrinter categoriesFor: #base:!accessing!public! !
!GRNumberPrinter categoriesFor: #characters:!accessing!public! !
!GRNumberPrinter categoriesFor: #delimiter:!accessing!public! !
!GRNumberPrinter categoriesFor: #digits:!accessing!public! !
!GRNumberPrinter categoriesFor: #digitsOf:base:!public!utilities! !
!GRNumberPrinter categoriesFor: #infinite:!accessing!public! !
!GRNumberPrinter categoriesFor: #initialize!initialization!public! !
!GRNumberPrinter categoriesFor: #lowercase!actions!public! !
!GRNumberPrinter categoriesFor: #nan:!accessing!public! !
!GRNumberPrinter categoriesFor: #padding:!accessing!public! !
!GRNumberPrinter categoriesFor: #precision:!accessing!public! !
!GRNumberPrinter categoriesFor: #print:on:!printing!public! !
!GRNumberPrinter categoriesFor: #printFloat:on:!printing!public! !
!GRNumberPrinter categoriesFor: #printFraction:on:!printing!public! !
!GRNumberPrinter categoriesFor: #printInfinite:on:!printing!public! !
!GRNumberPrinter categoriesFor: #printInteger:on:!printing!public! !
!GRNumberPrinter categoriesFor: #printNaN:on:!printing!public! !
!GRNumberPrinter categoriesFor: #separate:left:!public!utilities! !
!GRNumberPrinter categoriesFor: #separate:right:!public!utilities! !
!GRNumberPrinter categoriesFor: #separator:!accessing!public! !
!GRNumberPrinter categoriesFor: #uppercase!actions!public! !

!GRNumberPrinter class methodsFor!

initialize
	NumbersToCharactersLowercase := '0123456789abcdefghijklmnopqrstuvwxyz'.
	NumbersToCharactersUppercase := '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'! !
!GRNumberPrinter class categoriesFor: #initialize!initialization!public! !

GROrdinalizePrinter guid: (GUID fromString: '{2199F09C-67D1-4302-A613-01F0DEAC216F}')!
GROrdinalizePrinter comment: ''!
!GROrdinalizePrinter categoriesForClass!Unclassified! !
!GROrdinalizePrinter methodsFor!

ordinalize: anInteger
	^ (anInteger \\ 100 between: 11 and: 13)
		ifTrue: [ 'th' ]
		ifFalse: [ 
			#('st' 'nd' 'rd')
				at: anInteger \\ 10 
				ifAbsent: [ 'th' ] ]!

print: anObject on: aStream
	aStream nextPutAll: (self ordinalize: anObject integerPart)! !
!GROrdinalizePrinter categoriesFor: #ordinalize:!private! !
!GROrdinalizePrinter categoriesFor: #print:on:!printing!public! !

GRPluggablePrinter guid: (GUID fromString: '{95E32743-B57D-40EB-86AA-828FDE843F2A}')!
GRPluggablePrinter comment: ''!
!GRPluggablePrinter categoriesForClass!Unclassified! !
!GRPluggablePrinter methodsFor!

block: aBlock
	block := aBlock!

initialize
	super initialize.
	self block: [ :value | String new ]!

print: anObject on: aStream
	aStream nextPutAll: (block value: anObject)! !
!GRPluggablePrinter categoriesFor: #block:!accessing!public! !
!GRPluggablePrinter categoriesFor: #initialize!initialization!public! !
!GRPluggablePrinter categoriesFor: #print:on:!printing!public! !

!GRPluggablePrinter class methodsFor!

on: aBlock
	^ self new block: aBlock! !
!GRPluggablePrinter class categoriesFor: #on:!instance creation!public! !

GRSequentialPrinter guid: (GUID fromString: '{D8A9A8AF-4054-43A1-A145-E4BB31999B7E}')!
GRSequentialPrinter comment: ''!
!GRSequentialPrinter categoriesForClass!Unclassified! !
!GRSequentialPrinter methodsFor!

, aConverter
	parts add: aConverter!

initialize
	super initialize.
	parts := OrderedCollection new!

print: anObject on: aStream 
	parts do: [ :each | each print: anObject on: aStream ]! !
!GRSequentialPrinter categoriesFor: #,!operators!public! !
!GRSequentialPrinter categoriesFor: #initialize!initialization!public! !
!GRSequentialPrinter categoriesFor: #print:on:!printing!public! !

GRSignPrinter guid: (GUID fromString: '{9A66D376-8071-4D29-BCC2-6648BE2FCDED}')!
GRSignPrinter comment: ''!
!GRSignPrinter categoriesForClass!Unclassified! !
!GRSignPrinter methodsFor!

initialize
	super initialize.
	self negativePrinter: $-.
	self positivePrinter: nil!

negativePrinter: aPrinter
	"The printer to be used when the number is negative."
	
	negativePrinter := aPrinter!

positivePrinter: aPrinter
	"The printer to be used when the number is zero or positive."
	
	positivePrinter := aPrinter!

print: anObject on: aStream 
	anObject negative
		ifTrue: [ negativePrinter print: anObject on: aStream ]
		ifFalse: [ positivePrinter print: anObject on: aStream ]! !
!GRSignPrinter categoriesFor: #initialize!initialization!public! !
!GRSignPrinter categoriesFor: #negativePrinter:!accessing!public! !
!GRSignPrinter categoriesFor: #positivePrinter:!accessing!public! !
!GRSignPrinter categoriesFor: #print:on:!printing!public! !

GRStringPrinter guid: (GUID fromString: '{D0C7AE35-089B-4EB8-B7EF-4C1154788F07}')!
GRStringPrinter comment: ''!
!GRStringPrinter categoriesForClass!Unclassified! !
!GRStringPrinter methodsFor!

character: aCharacter
	"The character to pad the string with."
	
	character := aCharacter!

initialize
	super initialize.
	self character: $ ; length: nil.
	self trimNone; padNone!

length: anInteger
	"The maximal size of the string, or the size to pad to."

	length := anInteger!

padCenter
	"Pad to the center."
	
	pad := #pad:center:to:!

padLeft
	"Pad to the left."
	
	pad := #pad:left:to:!

padNone
	"Do not pad the input."
	
	pad := nil!

padRight
	"Pad to the right."
	
	pad := #pad:right:to:!

print: anObject on: aStream 
	| string |
	string := anObject greaseString.
	trim isNil
		ifFalse: [ string := string perform: trim ].
	length isNil ifFalse: [
		length < string size 
			ifTrue: [ string := string copyFrom: 1to: length ].
		(pad isNil or: [ character isNil ])
			ifFalse: [ string := self perform: pad with: string with: character with: length ] ].
	aStream nextPutAll: string!

trimBoth
	"Trim to the left and to the right."

	trim := #trimBoth!

trimLeft
	"Trim to the left and to the right."

	trim := #trimLeft!

trimNone
	"Do not trim the input."

	trim := nil!

trimRight
	"Trim to the left and to the right."

	trim := #trimRight! !
!GRStringPrinter categoriesFor: #character:!accessing!public! !
!GRStringPrinter categoriesFor: #initialize!initialization!public! !
!GRStringPrinter categoriesFor: #length:!accessing!public! !
!GRStringPrinter categoriesFor: #padCenter!padding!public! !
!GRStringPrinter categoriesFor: #padLeft!padding!public! !
!GRStringPrinter categoriesFor: #padNone!padding!public! !
!GRStringPrinter categoriesFor: #padRight!padding!public! !
!GRStringPrinter categoriesFor: #print:on:!printing!public! !
!GRStringPrinter categoriesFor: #trimBoth!public!trimming! !
!GRStringPrinter categoriesFor: #trimLeft!public!trimming! !
!GRStringPrinter categoriesFor: #trimNone!public!trimming! !
!GRStringPrinter categoriesFor: #trimRight!public!trimming! !

GRUnitPrinter guid: (GUID fromString: '{C1D430E9-5409-4201-8D26-B6F4FCA4F612}')!
GRUnitPrinter comment: ''!
!GRUnitPrinter categoriesForClass!Unclassified! !
!GRUnitPrinter methodsFor!

base: anInteger
	base := anInteger!

fractionPrinter: aPrinter
	fractionPrinter := aPrinter!

initialize
	super initialize.
	self integerPrinter: (GRNumberPrinter new
		precision: 0;
		yourself).
	self fractionPrinter: (GRNumberPrinter new
		precision: 1;
		yourself)!

integerPrinter: aPrinter
	integerPrinter := aPrinter!

print: anObject on: aStream
	anObject = 1
		ifTrue: [ ^ self print: anObject unit: units first on: aStream ].
	units allButFirst
		inject: anObject asFloat
		into: [ :value :each |
			value < base
				ifFalse: [ value / base ]
				ifTrue: [ ^ self print: value unit: each on: aStream ] ]!

print: aNumber unit: aString on: aStream
	(units first = aString or: [ units second = aString ])
		ifTrue: [ integerPrinter print: aNumber on: aStream ]
		ifFalse: [ fractionPrinter print: aNumber on: aStream ].
	aStream nextPut: $ ; nextPutAll: aString!

units: anArray
	units := anArray! !
!GRUnitPrinter categoriesFor: #base:!accessing!public! !
!GRUnitPrinter categoriesFor: #fractionPrinter:!accessing!public! !
!GRUnitPrinter categoriesFor: #initialize!initialization!public! !
!GRUnitPrinter categoriesFor: #integerPrinter:!accessing!public! !
!GRUnitPrinter categoriesFor: #print:on:!printing!public! !
!GRUnitPrinter categoriesFor: #print:unit:on:!printing!public! !
!GRUnitPrinter categoriesFor: #units:!accessing!public! !

!GRUnitPrinter class methodsFor!

base: anInteger units: anArray
	^ self new 
		base: anInteger;
		units: anArray;
		yourself! !
!GRUnitPrinter class categoriesFor: #base:units:!instance creation!public! !

GROrderedMultiMap guid: (GUID fromString: '{92B12D93-3806-4C5F-A386-845A5C0A60D1}')!
GROrderedMultiMap comment: 'I am an implementation of an ordered multi-map. I allow multiple values to be associated with the same key and maintain the order of addition. #at: and its derivatives all operate on the first matching key, while #allAt: returns the complete list of values for a key in the order they were added.'!
!GROrderedMultiMap categoriesForClass!Unclassified! !
!GROrderedMultiMap methodsFor!

add: anAssociation
	self privateAt: anAssociation key put: anAssociation value.
	^anAssociation!

allAt: aKey
	^ Array streamContents: [ :stream |
		1 to: size do: [ :index |
			(keys at: index) = aKey
				ifTrue: [ stream nextPut: (values at: index) ] ] ]!

allAt: aKey ifAbsent: absentBlock
	| results |
	results := self allAt: aKey.
	^ results isEmpty
		ifTrue: [ absentBlock value ]
		ifFalse: [ results ]!

at: aKey add: aValue
	"Add an association between aKey and aValue. Do not replace existing
	values with the same key."
	
	^ self privateAt: aKey put: aValue!

removeKey: aKey ifAbsent: aBlock
	"Remove aKey from the receiver, evaluate aBlock if the element is missing."

	"This is inefficient and could be optimized."
	| removed |
	removed := Array streamContents: [ :stream |
		| index |
		[ (index := self findIndexFor: aKey) = 0 ] whileFalse: [
			stream nextPut: (self removeIndex: index) ] ].
	^ removed isEmpty
		ifTrue: [ aBlock value ]
		ifFalse: [ removed ]! !
!GROrderedMultiMap categoriesFor: #add:!accessing!public! !
!GROrderedMultiMap categoriesFor: #allAt:!accessing!public! !
!GROrderedMultiMap categoriesFor: #allAt:ifAbsent:!accessing!public! !
!GROrderedMultiMap categoriesFor: #at:add:!accessing!public! !
!GROrderedMultiMap categoriesFor: #removeKey:ifAbsent:!accessing!public! !

"Binary Globals"!

