| package |
package := Package name: 'Grease-Dolphin-Core'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '4'.


package classNames
	add: #GRDolphinConverterCodecStream;
	add: #GRDolphinLatin1Codec;
	add: #GRDolphinLatin1CodecStream;
	add: #GRDolphinPlatform;
	add: #GRDolphinUtf8Codec;
	add: #GRDolphinUtf8CodecStream;
	add: #Text;
	yourself.

package methodNames
	add: #Array -> #beMutable;
	add: #Array -> #isArray;
	add: #ArrayedCollection -> #sort:;
	add: #Bag -> #sortedCounts;
	add: #Behavior -> #allInstancesDo:;
	add: #Behavior -> #allSubInstancesDo:;
	add: #Behavior -> #fullName;
	add: #BlockClosure -> #callCC:;
	add: #BlockClosure -> #fixCallbackTemps;
	add: #BlockClosure -> #isBlock;
	add: #BlockClosure -> #numArgs;
	add: #BlockClosure -> #valueWithPossibleArguments:;
	add: #ByteArray -> #greaseString;
	add: #Character -> #greaseInteger;
	add: #Character -> #isCharacter;
	add: #Character -> #to:;
	add: #Collection -> #any;
	add: #Collection -> #associationsDo:;
	add: #Collection -> #count:;
	add: #Collection -> #isCollection;
	add: #Collection -> #isEmptyOrNil;
	add: #Collection -> #isSequenceable;
	add: #Collection -> #noneSatisfy:;
	add: #Collection -> #sorted;
	add: #Collection -> #sorted:;
	add: #Color -> #asHTMLColor;
	add: #Date -> #-;
	add: #Date -> #dayOfWeek;
	add: #Date -> #dayOfYear;
	add: #Date -> #printFormat:;
	add: #DateAndTime -> #asDate;
	add: #DateAndTime -> #asDateAndTime;
	add: #DateAndTime -> #asTime;
	add: #DateAndTime -> #monthIndex;
	add: #Dictionary -> #isDictionary;
	add: #Dictionary -> #keysSortedSafely;
	add: #Dictionary -> #valuesDo:;
	add: #Duration -> #asMilliseconds;
	add: #Duration -> #asMilliSeconds;
	add: #Duration -> #isZero;
	add: #Float -> #isInfinite;
	add: #Float -> #isNaN;
	add: #Integer -> #printPaddedWith:to:;
	add: #Integer -> #printPaddedWith:to:base:;
	add: #Integer -> #printStringBase:;
	add: #Integer -> #second;
	add: #Integer -> #seconds;
	add: #MessageSend -> #argumentCount;
	add: #MessageSend -> #fixCallbackTemps;
	add: #MessageSend -> #isMessageSend;
	add: #MessageSend -> #numArgs;
	add: #MessageSend -> #value:;
	add: #MessageSend -> #value:value:;
	add: #MessageSend -> #valueWithEnoughArguments:;
	add: #MessageSend -> #valueWithPossibleArguments:;
	add: #Number -> #asNumber;
	add: #Number -> #day;
	add: #Number -> #days;
	add: #Number -> #hour;
	add: #Number -> #hours;
	add: #Number -> #isInfinite;
	add: #Number -> #isNaN;
	add: #Number -> #isNumber;
	add: #Number -> #javascriptOn:;
	add: #Number -> #milliseconds;
	add: #Number -> #minute;
	add: #Number -> #minutes;
	add: #Number -> #second;
	add: #Number -> #seconds;
	add: #Number -> #weeks;
	add: #Object -> #className;
	add: #Object -> #copyFrom:;
	add: #Object -> #greaseString;
	add: #Object -> #isArray;
	add: #Object -> #isBlock;
	add: #Object -> #isCharacter;
	add: #Object -> #isCollection;
	add: #Object -> #isDictionary;
	add: #Object -> #isFraction;
	add: #Object -> #isMessageSend;
	add: #Object -> #isNumber;
	add: #Object -> #printStringLimitedTo:;
	add: #PositionableStream -> #binary;
	add: #PositionableStream -> #greaseUpToAll:;
	add: #PositionableStream -> #isBinary;
	add: #Random -> #nextInt:;
	add: #Random -> #randomFrom:;
	add: #SequenceableCollection -> #atRandom;
	add: #SequenceableCollection -> #atRandom:;
	add: #SequenceableCollection -> #beginsWithSubCollection:;
	add: #SequenceableCollection -> #copyAfter:;
	add: #SequenceableCollection -> #copyAfterLast:;
	add: #SequenceableCollection -> #copyUpToLast:;
	add: #SequenceableCollection -> #endsWithSubCollection:;
	add: #SequenceableCollection -> #isSequenceable;
	add: #SequenceableCollection -> #reversed;
	add: #StackFrame -> #equalsTo:;
	add: #String -> #caseInsensitiveLessOrEqual:;
	add: #String -> #encodeForHTTP;
	add: #String -> #findTokens:;
	add: #String -> #greaseString;
	add: #String -> #greaseSubStrings:;
	add: #String -> #includesSubString:;
	add: #String -> #includesSubstring:caseSensitive:;
	add: #String -> #isByteString;
	add: #String -> #padded:to:with:;
	add: #String -> #skipDelimiters:startingAt:;
	add: #String -> #withCRs;
	add: #Symbol -> #asMutator;
	add: #Symbol -> #capitalized;
	add: #Symbol -> #greaseString;
	add: #Symbol -> #isKeyword;
	add: #Symbol -> #isUnary;
	add: #Time -> #addSeconds:;
	add: #Time -> #hour;
	add: #Time -> #minute;
	add: #Time -> #second;
	add: #UndefinedObject -> #greaseString;
	add: #UndefinedObject -> #isEmptyOrNil;
	add: #UnicodeCharacter -> #greaseInteger;
	add: #UnicodeCharacter -> #greaseString;
	add: #UnicodeString -> #isByteString;
	add: #WriteStream -> #crlf;
	add: #WriteStream -> #greaseNext:putAll:startingAt:;
	add: 'Character class' -> #leadingChar:code:;
	add: 'Color class' -> #fromString:;
	add: 'Date class' -> #daysInMonthNumber:forYear:;
	add: 'Date class' -> #year:month:day:;
	add: 'DateAndTime class' -> #date:time:;
	add: 'DateAndTime class' -> #fromSeconds:;
	add: 'DateAndTime class' -> #year:month:day:;
	add: 'Duration class' -> #milliseconds:;
	add: 'Duration class' -> #milliSeconds:;
	add: 'Duration class' -> #weeks:;
	add: 'Float class' -> #infinity;
	add: 'Float class' -> #nan;
	add: 'Float class' -> #negativeInfinity;
	add: 'GRPackage class' -> #greaseDolphinCore;
	add: 'SequenceableCollection class' -> #streamContents:;
	add: 'String class' -> #cr;
	add: 'String class' -> #crlf;
	add: 'String class' -> #lf;
	add: 'Time class' -> #hour:minute:second:;
	add: 'Time class' -> #midnight;
	add: 'Time class' -> #milliseconds:since:;
	add: 'Time class' -> #millisecondsSince:;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\ActiveX\Components\CDO\CDO';
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: '..\..\Object Arts\Dolphin\MVP\Presenters\Prompters\Dolphin Prompter';
	add: '..\..\Object Arts\Dolphin\DolphinSure\DolphinSure';
	add: 'Grease-Core';
	add: '..\..\IDB\IDB DateAndTime';
	add: '..\..\IDB\IDB Duration';
	add: '..\..\US\US Unicode';
	yourself).

package!

"Class Definitions"!

String variableByteSubclass: #Text
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRCodec subclass: #GRDolphinUtf8Codec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRNullCodec subclass: #GRDolphinLatin1Codec
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRCodecStream subclass: #GRDolphinConverterCodecStream
	instanceVariableNames: 'converter'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRDolphinConverterCodecStream subclass: #GRDolphinUtf8CodecStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRNullCodecStream subclass: #GRDolphinLatin1CodecStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRPlatform subclass: #GRDolphinPlatform
	instanceVariableNames: ''
	classVariableNames: 'SmtpServer UrlTable XmlTable'
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!Array methodsFor!

beMutable
	"Converts the receiver to a mutable instance."

	self isImmutable: false!

isArray
	^true! !
!Array categoriesFor: #beMutable!public! !
!Array categoriesFor: #isArray!public!testing! !

!ArrayedCollection methodsFor!

sort: sortBlock
	"Sort the receiver using sortBlock."

	(DefaultSortAlgorithm sortBlock: sortBlock) sort: self from: 1 to: 3! !
!ArrayedCollection categoriesFor: #sort:!public! !

!Bag methodsFor!

sortedCounts
	|counts|
	counts := SortedCollection sortBlock: [:x :y | x >= y].
	contents associationsDo: [:assoc | counts add: assoc value -> assoc key].
	^ counts! !
!Bag categoriesFor: #sortedCounts!enumerating!public! !

!Behavior methodsFor!

allInstancesDo: operation
	"Evaluates the one argument Block <operation> for each direct instance of the receiver."

	^self allInstances do: operation!

allSubInstancesDo: aMonadicValuable 
	"Evaluate aMonadicValuable for each of the receiver instances, 
	and with all the instances of the receiver subclasses."

	self allSubinstances do: aMonadicValuable!

fullName
	"In VW, will include the namespace"
	^self name asString! !
!Behavior categoriesFor: #allInstancesDo:!instances!public! !
!Behavior categoriesFor: #allSubInstancesDo:!instances!public! !
!Behavior categoriesFor: #fullName!*seaside-squeak-platform!public! !

!BlockClosure methodsFor!

callCC: continuationClass
	"Answer a an instance of continuationClass which contains a copy of the active process.
	When the continuation is later evaluated, it is like returning a value from this frame again."

	^self value: (continuationClass fromContext: Processor activeProcess topFrame sender)!

fixCallbackTemps!

isBlock
	^true!

numArgs
	"Answer the number of arguments required to evaluate receiver."

	^self argumentCount!

valueWithPossibleArguments: anArray
	| args |
	(anArray size == self numArgs)
		ifTrue: [ ^ self valueWithArguments: anArray ].
	args := Array new: self numArgs.
	args replaceFrom: 1
		to: (anArray size min: args size)
		with: anArray
		startingAt: 1.
	^ self valueWithArguments: args! !
!BlockClosure categoriesFor: #callCC:!evaluating!public! !
!BlockClosure categoriesFor: #fixCallbackTemps!*seaside-squeak-platform!public! !
!BlockClosure categoriesFor: #isBlock!*seaside-squeak-platform!public! !
!BlockClosure categoriesFor: #numArgs!public! !
!BlockClosure categoriesFor: #valueWithPossibleArguments:!*seaside-squeak-platform!public! !

!ByteArray methodsFor!

greaseString
	"ByteArrays should not automatically be converted to Strings. You should use a WACodec for this."

	^self printString! !
!ByteArray categoriesFor: #greaseString!*seaside-squeak-platform!public! !

!Character methodsFor!

greaseInteger
	"Answer an unicode code point of the receiver."

	"This is the same from Pharo..."

	^asciiValue bitAnd: 16r3FFFFF!

isCharacter
	"Answer whether the receiver is a kind of Character.
	Seaside compatibility."

	^true!

to: aCharacter
	^(self asciiValue to: aCharacter asciiValue) collect: [:i | i asCharacter]! !
!Character categoriesFor: #greaseInteger!*seaside-squeak-platform!public! !
!Character categoriesFor: #isCharacter!public! !
!Character categoriesFor: #to:!public! !

!Character class methodsFor!

leadingChar: leadChar code: code

	code >= 16r400000 ifTrue: [
		self error: 'code is out of range'.
	].
	leadChar >= 256 ifTrue: [
		self error: 'lead is out of range'.
	].

	^self value: (leadChar bitShift: 22) + code! !
!Character class categoriesFor: #leadingChar:code:!OmniBase!public! !

!Collection methodsFor!

any
	^ self anyOne!

associationsDo: aBlock
	"Evaluate aBlock for each of the receiver's elements (key/value 
	associations).  If any non-association is within, the error is not caught now,
	but later, when a key or value message is sent to it.
	Seaside and Pharo compatibility...
	Sorry for adding this into Collection."

	self do: aBlock!

count: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the number of elements that answered true."

	| sum |
	sum := 0.
	self do: [:each | (aBlock value: each) ifTrue: [sum := sum + 1]].
	^sum!

isCollection
	^true!

isEmptyOrNil
	"Answer whether receiver is emtpy or nil. Receiver never can be nil."

	^self isEmpty!

isSequenceable
	^false!

noneSatisfy: aBlock 
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns false for all elements return true.
	Otherwise return false"

	self do: [:item | (aBlock value: item) ifTrue: [^false]].
	^true!

sorted
	^ self sorted: [ :a :b | a <= b ]!

sorted: sortBlock
	^self asSortedCollection: sortBlock! !
!Collection categoriesFor: #any!*grease-pharo-core!public! !
!Collection categoriesFor: #associationsDo:!enumerating!public! !
!Collection categoriesFor: #count:!enumerating!public! !
!Collection categoriesFor: #isCollection!public!testing! !
!Collection categoriesFor: #isEmptyOrNil!public!testing! !
!Collection categoriesFor: #isSequenceable!public! !
!Collection categoriesFor: #noneSatisfy:!enumerating!public! !
!Collection categoriesFor: #sorted!*grease-pharo-core!public! !
!Collection categoriesFor: #sorted:!*grease-pharo-core!public! !

!Color methodsFor!

asHTMLColor
	"Answer the receiver HTML hexadecimal representation string."
	
	| stream |
	stream := WriteStream on: (String new: 7).
	stream nextPut: $#.
	(Array with: self red with: self green with: self blue) do: [:color |
		stream nextPutAll: (color printPaddedWith: $0 to: 2 base: 16)].
	^stream contents

! !
!Color categoriesFor: #asHTMLColor!public! !

!Color class methodsFor!

fromString: aString
	"Answer the color from the aString in the form of RRGGBB."

	| colorHex |
	aString isEmptyOrNil ifTrue: [^Color white asRGB].
	colorHex := (aString first = $#
			ifTrue: [aString copyFrom: 2 to: aString size]
			ifFalse: [aString]) asUppercase.
	^(colorHex allSatisfy: [:each | each isHexDigit])
		ifTrue: [self fromHTMLSpec: ('#' , colorHex) asUppercase]
		ifFalse: [
			"try to match aColorHex with known named colors"
			colorHex := colorHex asLowercase.
			(self perform: (self selectors detect: [:selector | selector asString asLowercase = colorHex] ifNone: [#white]) asSymbol) asRGB]! !
!Color class categoriesFor: #fromString:!instance creation!public! !

!Date methodsFor!

- operand
	"Substracts operand from receiver."

	^Duration seconds: (self asSeconds - operand asSeconds)
!

dayOfWeek
	"Sunday is 1, Saturday is 7"

	| idx |
	idx := self weekdayIndex + 1.
	^idx = 8 ifTrue: [1] ifFalse: [idx]!

dayOfYear
	"Answer an <integer> between 1 and 366, inclusive, representing the day 
	of the year in the local time of the receiver, which includes the receiver."

	^self day!

printFormat: format
	"Pharo / Squeak compatibility.
	Not implemented yet."

	^String streamContents: [:stream | self printOn: stream format: Locale default dateFormat]! !
!Date categoriesFor: #-!public! !
!Date categoriesFor: #dayOfWeek!accessing!public! !
!Date categoriesFor: #dayOfYear!accessing!public! !
!Date categoriesFor: #printFormat:!printing!public! !

!Date class methodsFor!

daysInMonthNumber: monthIndex forYear: yearInteger 

	^self daysInMonthIndex: monthIndex forYear: yearInteger
!

year: year  month: month day: day
	"For compatibility with Squeak."
 
	^self newDay: day monthIndex: month year: year! !
!Date class categoriesFor: #daysInMonthNumber:forYear:!*seaside-squeak-platform!public! !
!Date class categoriesFor: #year:month:day:!public! !

!DateAndTime methodsFor!

asDate
	^Date newDay: self dayOfMonth monthIndex: self month year: self year!

asDateAndTime
	"Answer the receiver asDateAndTime."

	^self!

asTime
	^Time hours: self hour24 minutes: self minute seconds: self second!

monthIndex
	"Answer the month integer index of the receiver."

	^self month! !
!DateAndTime categoriesFor: #asDate!public! !
!DateAndTime categoriesFor: #asDateAndTime!public! !
!DateAndTime categoriesFor: #asTime!public! !
!DateAndTime categoriesFor: #monthIndex!converting!public! !

!DateAndTime class methodsFor!

date: aDate time: aTime 
	^self fromDate: aDate time: aTime!

fromSeconds: seconds
	"Answer a DateAndTime since the Squeak epoch: 1 January 1901"

	^ self seconds: seconds offset: self defaultOffset!

year: year month: month day: day
	"Answer a new instance of receiver in a day of month of year."

	^self year: year month: month day: day hour: 0 minute: 0 second: 0! !
!DateAndTime class categoriesFor: #date:time:!public! !
!DateAndTime class categoriesFor: #fromSeconds:!initializing!public! !
!DateAndTime class categoriesFor: #year:month:day:!public! !

!Dictionary methodsFor!

isDictionary
	^true!

keysSortedSafely
	"Answer a SortedCollection containing the receiver's keys."

	| sortedKeys |
	sortedKeys := SortedCollection new: self size.
	sortedKeys sortBlock: 
			[:x :y | 
			"Should really be use <obj, string, num> compareSafely..."
			((x isString and: [y isString]) or: [x isNumber and: [y isNumber]]) 
				ifTrue: [x < y]
				ifFalse: 
					[x class == y class 
						ifTrue: [x displayString < y displayString]
						ifFalse: [x class name < y class name]]].
	self keysDo: [:each | sortedKeys add: each].
	^sortedKeys!

valuesDo: aBlock 
	"Evaluate aBlock for each of the receiver's values."

	self associationsDo: [:association | aBlock value: association value]! !
!Dictionary categoriesFor: #isDictionary!public! !
!Dictionary categoriesFor: #keysSortedSafely!public! !
!Dictionary categoriesFor: #valuesDo:!public! !

!Duration methodsFor!

asMilliseconds
	^ self asMilliSeconds!

asMilliSeconds
	"Seaside Compatibility."

	^self asSeconds * 1000!

isZero
	^self = self class zero! !
!Duration categoriesFor: #asMilliseconds!*grease-pharo-core!public! !
!Duration categoriesFor: #asMilliSeconds!converting!public! !
!Duration categoriesFor: #isZero!*grease-pharo-core!public! !

!Duration class methodsFor!

milliseconds: anInteger
	^ self milliSeconds: anInteger!

milliSeconds: milliSeconds
	"Answer a <Duration> which is <number> seconds in length."

	^self seconds: milliSeconds / 1000!

weeks: aNumber
	^self days: (aNumber * 7)! !
!Duration class categoriesFor: #milliseconds:!*grease-pharo-core!public! !
!Duration class categoriesFor: #milliSeconds:!instance creation!public! !
!Duration class categoriesFor: #weeks:!*grease-pharo-core!public! !

!Float methodsFor!

isInfinite
	^(self = Float infinity) or: [self = Float infinity negated]!

isNaN
	"Should use = or equals: but this is implemented only to get
	Grease tests running."

	^self == self class nan! !
!Float categoriesFor: #isInfinite!converting!public! !
!Float categoriesFor: #isNaN!converting!public! !

!Float class methodsFor!

infinity
	"Provided by Nicollas Cellier."

	^##((ByteArray new: 8 withAll: 0)
		at: 7 put: 16rF0;
		at: 8 put: 16r7F;
		doubleAtOffset: 0)!

nan
	"Provided by Nicollas Cellier"

	^##((ByteArray new: 8 withAll: 16rFF) doubleAtOffset: 0)!

negativeInfinity
	"Provided by Nicollas Cellier"

	^##((ByteArray new: 8 withAll: 0)
		at: 7 put: 16rF0;
		at: 8 put: 16rFF;
		doubleAtOffset: 0)! !
!Float class categoriesFor: #infinity!public! !
!Float class categoriesFor: #nan!public! !
!Float class categoriesFor: #negativeInfinity!public! !

!GRPackage class methodsFor!

greaseDolphinCore
	^(self new)
		name: 'Grease-Dolphin-Core';
		addDependency: 'Grease-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #greaseDolphinCore!*grease-pharo-core!public! !

!Integer methodsFor!

printPaddedWith: aCharacter to: anInteger 
	"Answer the string containing the ASCII representation of the receiver 
	padded on the left with aCharacter to be at least anInteger characters.
	Squeak port."

	^ self
		printPaddedWith: aCharacter
		to: anInteger
		base: 10!

printPaddedWith: aCharacter to: anInteger base: aRadix 
	"Answer the string containing the ASCII representation of the receiver 
	padded on the left with aCharacter to be at least anInteger characters.
	Squeak port."
	| aStream padding digits |
	aStream := WriteStream on: (String new: 10).
	self
		printOn: aStream
		base: aRadix
		showRadix: false.
	digits := aStream contents.
	padding := anInteger - digits size.
	padding > 0 ifFalse: [^digits].
	^((String new: padding) atAllPut: aCharacter; yourself) , digits!

printStringBase: anInteger 
	"Prints the receiver with anInteger as its base."

	^self printStringRadix: anInteger showRadix: false!

second
	^self sign seconds
 !

seconds
	^Duration seconds: self! !
!Integer categoriesFor: #printPaddedWith:to:!printing!public! !
!Integer categoriesFor: #printPaddedWith:to:base:!printing!public! !
!Integer categoriesFor: #printStringBase:!public! !
!Integer categoriesFor: #second!public! !
!Integer categoriesFor: #seconds!public! !

!MessageSend methodsFor!

argumentCount
	^ selector numArgs - self arguments size!

fixCallbackTemps
	"for polymorphism with BlockContext >> #fixCallbackTemps"!

isMessageSend
	^true!

numArgs
	^ selector numArgs!

value: anObject
	^ self valueWithArguments: (Array with: anObject)!

value: aFirstObject value: aSecondObject
	^ self valueWithArguments: (Array with: aFirstObject with: aSecondObject)!

valueWithEnoughArguments: anArray
	"Call the selector with enough arguments from arguments and anArray"
	| argsArray |
	argsArray := Array new: self selector numArgs.
	argsArray replaceFrom: 1
		to: (self arguments size min: argsArray size)
		with: self arguments
		startingAt: 1.
	argsArray size > self arguments size ifTrue: [
		argsArray replaceFrom: self arguments size + 1
			to: (self arguments size + anArray size min: argsArray size)
			with: anArray
			startingAt: 1.
	].
	^self receiver perform: self selector withArguments: argsArray!

valueWithPossibleArguments: anArray

     "Evaluate the block represented by the receiver.
     If the block requires one argument, use anArg, if it requires more than one,
     fill up the rest with nils."

	^self valueWithEnoughArguments: anArray! !
!MessageSend categoriesFor: #argumentCount!*seaside-squeak-platform!public! !
!MessageSend categoriesFor: #fixCallbackTemps!*seaside-squeak-platform!public! !
!MessageSend categoriesFor: #isMessageSend!public! !
!MessageSend categoriesFor: #numArgs!*seaside-squeak-platform!public! !
!MessageSend categoriesFor: #value:!*seaside-squeak-platform!public! !
!MessageSend categoriesFor: #value:value:!*seaside-squeak-platform!public! !
!MessageSend categoriesFor: #valueWithEnoughArguments:!public! !
!MessageSend categoriesFor: #valueWithPossibleArguments:!*seaside-squeak-platform!public! !

!Number methodsFor!

asNumber
	"Answer receiver."

	^self!

day

	^self sign days!

days

	^Duration days: self!

hour

	^self sign hours!

hours

	^Duration hours: self!

isInfinite
	^false!

isNaN
	^false!

isNumber
	^true!

javascriptOn: aStream
	aStream nextPutAll: self printString!

milliseconds
	^Duration milliseconds: self!

minute

	^self sign minutes!

minutes

	^Duration minutes: self!

second

	^self sign seconds!

seconds

	^Duration seconds: self!

weeks

	^Duration weeks: self! !
!Number categoriesFor: #asNumber!constants!public! !
!Number categoriesFor: #day!public! !
!Number categoriesFor: #days!public! !
!Number categoriesFor: #hour!public! !
!Number categoriesFor: #hours!public! !
!Number categoriesFor: #isInfinite!public! !
!Number categoriesFor: #isNaN!public! !
!Number categoriesFor: #isNumber!public!testing! !
!Number categoriesFor: #javascriptOn:!public! !
!Number categoriesFor: #milliseconds!*grease-pharo-core!public! !
!Number categoriesFor: #minute!public! !
!Number categoriesFor: #minutes!public! !
!Number categoriesFor: #second!public! !
!Number categoriesFor: #seconds!public! !
!Number categoriesFor: #weeks!public! !

!Object methodsFor!

className
	"Answer a string characterizing the receiver's class, for use in list views for example"

	^self class name asString!

copyFrom: anotherObject
	"Copy to myself all instance variables I have in common with anotherObject.
	This is dangerous because it ignores an object's control over its own inst vars."

	| mine his |
	mine := self basicClass allInstVarNames.
	his := anotherObject basicClass allInstVarNames.
	1 to: (mine size min: his size) do: [:ind |
		(mine at: ind) = (his at: ind) ifTrue: [
			self instVarAt: ind put: (anotherObject instVarAt: ind)]].
	self basicClass isVariable & anotherObject basicClass isVariable ifTrue: [
		1 to: (self basicSize min: anotherObject basicSize) do: [:ind |
			self basicAt: ind put: (anotherObject basicAt: ind)]]!

greaseString
	^self displayString!

isArray
	^false!

isBlock
	^false!

isCharacter
	"Answer whether the receiver is a kind of Character.
	Seaside compatibility."

	^false!

isCollection
	^false!

isDictionary
	^false!

isFraction
	"Answer true if receiver is an instance of class Fraction, else answer false."

	^false!

isMessageSend
	^false!

isNumber
	^false!

printStringLimitedTo: limit

	"Todo, the best"

	^self printString readStream nextAvailable: limit! !
!Object categoriesFor: #className!public! !
!Object categoriesFor: #copyFrom:!copying!public! !
!Object categoriesFor: #greaseString!*seaside-squeak-platform!public! !
!Object categoriesFor: #isArray!public!testing! !
!Object categoriesFor: #isBlock!*seaside-squeak-platform!public! !
!Object categoriesFor: #isCharacter!public!testing! !
!Object categoriesFor: #isCollection!public!testing! !
!Object categoriesFor: #isDictionary!public!testing! !
!Object categoriesFor: #isFraction!public!testing! !
!Object categoriesFor: #isMessageSend!public!testing! !
!Object categoriesFor: #isNumber!public!testing! !
!Object categoriesFor: #printStringLimitedTo:!public! !

!PositionableStream methodsFor!

binary
	"Set a flag indicating that the elements of the receiver should be
	treated as bytes (Integers).
	Squeak compatibility."

	self collection: self collection asByteArray!

greaseUpToAll: aCollection 
	"Needed for Seaside ports to other dialects where #upToAll: may have
	different semantics"
	^ self upToAll: aCollection!

isBinary

	^self collection isKindOf: ByteArray! !
!PositionableStream categoriesFor: #binary!public! !
!PositionableStream categoriesFor: #greaseUpToAll:!*grease-pharo-core!public! !
!PositionableStream categoriesFor: #isBinary!public! !

!Random methodsFor!

nextInt: anInteger
	"Answer a random integer in the interval [1, anInteger].
	Note that the next value of the receiver should be between [0 - 1]."
	
	anInteger >= 1 ifFalse: [self error: 'anInteger should be >= 1'].
	^(self next * anInteger) truncated + 1!

randomFrom: aCollection 
	| random count |
	random := self nextInt: aCollection size.
	^aCollection isSequenceable 
		ifTrue: [aCollection at: random]
		ifFalse: 
			[count := 1.
			aCollection do: 
					[:ea | 
					count = random ifTrue: [^ea].
					count := count + 1]]! !
!Random categoriesFor: #nextInt:!public! !
!Random categoriesFor: #randomFrom:!public! !

!SequenceableCollection methodsFor!

atRandom
	^ self atRandom: Random new!

atRandom: aRandom
	^ self at: (aRandom next * self size) truncated + 1!

beginsWithSubCollection: aSequenceableCollection
	"Some platforms implement #beginsWith: to answer true for an empty argument."
	^ self beginsWith: aSequenceableCollection!

copyAfter: target
	^self copyFrom: (self indexOf: target ifAbsent: [self size])+1 to: self size!

copyAfterLast: anElement
	"Answer a copy of the receiver from after the last occurence
	of anElement up to the end. If no such element exists, answer 
	an empty copy."

	^ self allButFirst: (self lastIndexOf: anElement ifAbsent: [^self copyEmpty: 0])!

copyUpToLast: anElement
	"Answer a copy of the receiver from index 1 to the last occurrence of 
	anElement, not including anElement."

	^ self first: (self lastIndexOf: anElement ifAbsent: [^ self copy]) - 1!

endsWithSubCollection: aSequenceableCollection
	"Some platforms implement #endsWith: to answer true for an empty argument."
	^ self endsWith: aSequenceableCollection!

isSequenceable
	^true!

reversed
	"Answer a copy of receiver with its elements in reversed order."

	^self reverse! !
!SequenceableCollection categoriesFor: #atRandom!public! !
!SequenceableCollection categoriesFor: #atRandom:!public! !
!SequenceableCollection categoriesFor: #beginsWithSubCollection:!*grease-pharo-core!public! !
!SequenceableCollection categoriesFor: #copyAfter:!copying!public! !
!SequenceableCollection categoriesFor: #copyAfterLast:!public! !
!SequenceableCollection categoriesFor: #copyUpToLast:!public! !
!SequenceableCollection categoriesFor: #endsWithSubCollection:!*grease-pharo-core!public! !
!SequenceableCollection categoriesFor: #isSequenceable!public! !
!SequenceableCollection categoriesFor: #reversed!public! !

!SequenceableCollection class methodsFor!

streamContents: aBlock
	|stream|
	stream := WriteStream on: (self new: 100).
	aBlock value: stream.
	^stream contents! !
!SequenceableCollection class categoriesFor: #streamContents:!public! !

!StackFrame methodsFor!

equalsTo: anObject

	^self species == anObject species and: [index == anObject index]! !
!StackFrame categoriesFor: #equalsTo:!public! !

!String methodsFor!

caseInsensitiveLessOrEqual: aString 
	"Answer whether the receiver sorts before or equal to aString.
	The collation order is case insensitive."

	^self <= aString!

encodeForHTTP
	"change dangerous characters to their %XX form, for use in HTTP transactions"
	| encodedStream |
	encodedStream := WriteStream on: (String new).
	self do: [ :c |
		c isSafeForHTTP ifTrue: [ encodedStream nextPut: c ] ifFalse: [ c printHTTPEncodedStringOn: encodedStream ]
	].
	^encodedStream contents. !

findTokens: delimiters
	"Answer the collection of tokens that result from parsing self.  Return strings between the delimiters.  Any character in the Collection delimiters marks a border.  Several delimiters in a row are considered as just one separation.  Also, allow delimiters to be a single character."

	| tokens keyStart keyStop separators |
	tokens := OrderedCollection new.
	separators := String withAll: (delimiters isCharacter 
		ifTrue: [Array with: delimiters]
		ifFalse: [delimiters]).
	keyStop := 1.
	[keyStop <= self size] whileTrue:
		[keyStart := self skipDelimiters: separators startingAt: keyStop.
		keyStop := self indexOfAnyOf: separators startingAt: keyStart.
		keyStop = 0 ifTrue: [keyStop := self size + 1].
		keyStart < keyStop
			ifTrue: [tokens add: (self copyFrom: keyStart to: (keyStop - 1))]].
	^tokens!

greaseString
	^self!

greaseSubStrings: separators 
	"Answer an array containing the substrings in the receiver separated 
	by the elements of separators.
	Pharo port of String>>subStrings:"

	| char result sourceStream subString |
	(separators isString or: [separators allSatisfy: [:element | element isKindOf: Character]]) 
		ifFalse: [^self error: 'separators must be Characters.'].
	sourceStream := self readStream.
	result := OrderedCollection new.
	subString := String new.
	[sourceStream atEnd] whileFalse: 
			[char := sourceStream next.
			(separators includes: char) 
				ifTrue: 
					[subString notEmpty 
						ifTrue: 
							[result add: subString copy.
							subString := String new]]
				ifFalse: [subString := subString , (String with: char)]].
	subString notEmpty ifTrue: [result add: subString copy].
	^result asArray!

includesSubString: aString 
	^self includesSubstring: aString caseSensitive: false!

includesSubstring: aString caseSensitive: aBoolean
	"Answer true if the receiver includes aString as substring.
	If aBoolean is true the search if case sensitive."

	^(self findString: aString startingAt: 1 ignoreCase: aBoolean not) > 0


	!

isByteString
	^true!

padded: leftOrRight to: length with: char
	leftOrRight = #left ifTrue:
		[^ (String new: (length - self size max: 0) withAll: char) , self].
	leftOrRight = #right ifTrue:
		[^ self , (String new: (length - self size max: 0) withAll: char)].!

skipDelimiters: delimiters startingAt: start 
	"Answer the index of the character within the receiver, starting at start, that does NOT match one of the delimiters. If the receiver does not contain any of the delimiters, answer size + 1.  Assumes the delimiters to be a non-empty string."

	start to: self size do: [:i | delimiters detect: [:delim | delim = (self at: i)] ifNone: [^i]].
	^self size + 1!

withCRs
	"Return a copy of the receiver in which backslash (\) characters have been replaced with carriage returns."

	^self collect: [:c | c = $\ ifTrue: [Character cr] ifFalse: [c]]! !
!String categoriesFor: #caseInsensitiveLessOrEqual:!public! !
!String categoriesFor: #encodeForHTTP!copying!public! !
!String categoriesFor: #findTokens:!copying!public! !
!String categoriesFor: #greaseString!public! !
!String categoriesFor: #greaseSubStrings:!public! !
!String categoriesFor: #includesSubString:!public! !
!String categoriesFor: #includesSubstring:caseSensitive:!public! !
!String categoriesFor: #isByteString!converting!public! !
!String categoriesFor: #padded:to:with:!public! !
!String categoriesFor: #skipDelimiters:startingAt:!copying!public! !
!String categoriesFor: #withCRs!public! !

!String class methodsFor!

cr
	"Answer the cr String"

	^##(String with: Character cr)!

crlf
	"Answer the crlf String"

	^##(String with: Character cr with: Character lf)!

lf
	"Answer the lf String"

	^##(String with: Character lf)! !
!String class categoriesFor: #cr!public! !
!String class categoriesFor: #crlf!public! !
!String class categoriesFor: #lf!public! !

!Symbol methodsFor!

asMutator
	"Return a setter message from a getter message. For example,
	#name asMutator returns #name:"
	
	^(self copyWith: $:) asSymbol
!

capitalized
	"I have revised the senders of capitalized on a virgin Dolphin X6 image and
	appears that this override does not generates any problems."

	^self asString capitalized asSymbol!

greaseString
	^self displayString!

isKeyword
	"Answer whether the receiver is a message keyword."

	^self endsWith: ':'!

isUnary
	^ self argumentCount = 0! !
!Symbol categoriesFor: #asMutator!operations!public! !
!Symbol categoriesFor: #capitalized!public! !
!Symbol categoriesFor: #greaseString!public! !
!Symbol categoriesFor: #isKeyword!public!testing! !
!Symbol categoriesFor: #isUnary!public!testing! !

!Time methodsFor!

addSeconds: anInteger 
	"Adds anInteger seconds to the receiver."

	^self class fromMilliseconds: milliseconds + (anInteger * 1000)!

hour

	^self hours!

minute

	^self minutes!

second

	^self seconds! !
!Time categoriesFor: #addSeconds:!arithmetic!public! !
!Time categoriesFor: #hour!accessing!public! !
!Time categoriesFor: #minute!accessing!public! !
!Time categoriesFor: #second!accessing!public! !

!Time class methodsFor!

hour: hoursInteger minute: minutesInteger second: secondsInteger 

	^self hours: hoursInteger minutes: minutesInteger seconds: secondsInteger!

midnight

	^self fromSeconds: 0!

milliseconds: currentTime since: lastTime
	"Answer the elapsed time since last recorded in milliseconds.
	Compensate for rollover."

	| delta |
	delta := currentTime - lastTime.
	^delta < 0
		ifTrue: [SmallInteger maximum + delta]
		ifFalse: [delta]!

millisecondsSince: lastTime
 	"Answer the elapsed time since last recorded in milliseconds.
 	Compensate for rollover."
 
 	^self milliseconds: self millisecondClockValue since: lastTime! !
!Time class categoriesFor: #hour:minute:second:!instance creation!public! !
!Time class categoriesFor: #midnight!public! !
!Time class categoriesFor: #milliseconds:since:!public! !
!Time class categoriesFor: #millisecondsSince:!public! !

!UndefinedObject methodsFor!

greaseString
	"Answer the receiver displayed as String."

	^'nil'!

isEmptyOrNil
	"Answer whether receiver is emtpy or nil. God forbid receiver isn't nil!!!!."

	^true! !
!UndefinedObject categoriesFor: #greaseString!copying!public! !
!UndefinedObject categoriesFor: #isEmptyOrNil!public!testing! !

!UnicodeCharacter methodsFor!

greaseInteger
	"Answer an unicode code point of the receiver."

	"This is the same from Pharo..."

	^codePoint bitAnd: 16r3FFFFF!

greaseString
	^self asUnicodeString! !
!UnicodeCharacter categoriesFor: #greaseInteger!public! !
!UnicodeCharacter categoriesFor: #greaseString!public! !

!UnicodeString methodsFor!

isByteString
	^false! !
!UnicodeString categoriesFor: #isByteString!converting!public! !

!WriteStream methodsFor!

crlf
	self nextPut: Character cr; nextPut: Character lf!

greaseNext: anInteger putAll: aCollection startingAt: startIndex
	"Store the next anInteger elements from the given collection."
	^ self next: anInteger putAll: aCollection startingAt: startIndex! !
!WriteStream categoriesFor: #crlf!*seaside-squeak-platform!public! !
!WriteStream categoriesFor: #greaseNext:putAll:startingAt:!*grease-pharo-core!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

Text guid: (GUID fromString: '{51463927-9382-401D-9718-E09A78C7C0A1}')!
Text isNullTerminated: true!
Text comment: ''!
!Text categoriesForClass!Unclassified! !
!Text methodsFor!

greaseString
	^self displayString! !
!Text categoriesFor: #greaseString!public! !

GRDolphinUtf8Codec guid: (GUID fromString: '{297842BB-DC96-43B2-AA89-F8D24DFD52B7}')!
GRDolphinUtf8Codec comment: 'A WAUtf8Codec is a WACodec optimized for UTF-8.'!
!GRDolphinUtf8Codec categoriesForClass!Unclassified! !
!GRDolphinUtf8Codec methodsFor!

decode: aString
	"We use here the short way..."
	
	^UnicodeString fromUTF8Content: aString asString!

decoderFor: aStream
	^GRDolphinUtf8CodecStream on: aStream converter: nil "Native text conversion"!

encoderFor: aStream
	^GRDolphinUtf8CodecStream on: aStream converter: nil "Native text conversion"!

name
	^ 'utf-8'!

url
	^ self! !
!GRDolphinUtf8Codec categoriesFor: #decode:!decoding!public! !
!GRDolphinUtf8Codec categoriesFor: #decoderFor:!decoding!public! !
!GRDolphinUtf8Codec categoriesFor: #encoderFor:!decoding!public! !
!GRDolphinUtf8Codec categoriesFor: #name!accessing!public! !
!GRDolphinUtf8Codec categoriesFor: #url!accessing!public! !

!GRDolphinUtf8Codec class methodsFor!

basicForEncoding: aString
	^self new!

codecs
	^Array with: self new!

supportsEncoding: aString
	^##(#('UTF-8' 'UTF8' 'UTF 8')) includes: aString asUppercase! !
!GRDolphinUtf8Codec class categoriesFor: #basicForEncoding:!private! !
!GRDolphinUtf8Codec class categoriesFor: #codecs!accessing!public! !
!GRDolphinUtf8Codec class categoriesFor: #supportsEncoding:!public!testing! !

GRDolphinLatin1Codec guid: (GUID fromString: '{A10AAE1B-F003-4193-B86B-AF173B6B2399}')!
GRDolphinLatin1Codec comment: 'A GRPharoLatin1Codec is a WACodec optimized for ISO-8859-1 (direct byte to character mapping).'!
!GRDolphinLatin1Codec categoriesForClass!Unclassified! !
!GRDolphinLatin1Codec methodsFor!

decode: aStringOrByteArray
	"Overridden for efficencey."

	^ aStringOrByteArray asString!

decoderFor: aReadStream 
	"wrap to avoid String vs ByteArray issues"

	^GRDolphinLatin1CodecStream on: aReadStream!

encoderFor: aWriteStream 
	"wrap to avoid String vs ByteArray issues"

	^GRDolphinLatin1CodecStream on: aWriteStream!

initializeWithName: aString 
	self initialize.
	name := aString.!

name
	^ name! !
!GRDolphinLatin1Codec categoriesFor: #decode:!conversion!public! !
!GRDolphinLatin1Codec categoriesFor: #decoderFor:!conversion!public! !
!GRDolphinLatin1Codec categoriesFor: #encoderFor:!conversion!public! !
!GRDolphinLatin1Codec categoriesFor: #initializeWithName:!initialization!public! !
!GRDolphinLatin1Codec categoriesFor: #name!accessing!public! !

!GRDolphinLatin1Codec class methodsFor!

basicForEncoding: aString
	(self supportsEncoding: aString)
		ifFalse: [ self unsupportedEncoding: aString ].
	^ self basicNew initializeWithName: aString!

codecs
	^Array with: (self basicForEncoding: 'iso-8859-1')!

supportedEncodingNames
	^#(
		'iso-8859-1'
		'ISO-8859-1'
		'latin-1'
		'latin1'
	)!

supportsEncoding: aString
	"Answer whether the the given encoding name is supported."
	^ self supportedEncodingNames includes: aString! !
!GRDolphinLatin1Codec class categoriesFor: #basicForEncoding:!private! !
!GRDolphinLatin1Codec class categoriesFor: #codecs!accessing!public! !
!GRDolphinLatin1Codec class categoriesFor: #supportedEncodingNames!private! !
!GRDolphinLatin1Codec class categoriesFor: #supportsEncoding:!private! !

GRDolphinConverterCodecStream guid: (GUID fromString: '{11E2FCCA-81AF-4E3F-B4BD-1CC17E651458}')!
GRDolphinConverterCodecStream comment: '
A WAConverterCodecStream is a WACodec stream around a TextConverter. It is always in text mode.

Instance Variables
	converter:		<TextConverter>

converter
	- the TextConverter used to do the encoding conversion
'!
!GRDolphinConverterCodecStream categoriesForClass!Unclassified! !
!GRDolphinConverterCodecStream methodsFor!

contents
	^ stream contents!

flush
	stream flush!

initalizeOn: aStream converter: aConverter
	self initalizeOn: aStream.
	converter := aConverter!

next
	| character |
	character := converter nextFromStream: stream.
	^ character isNil
		ifFalse: [ character asCharacter ]!

next: anInteger
	| writeStream |
	writeStream := WriteStream on: (String new: anInteger).
	anInteger timesRepeat: [
		writeStream nextPut: (self next
			ifNil: [ ^ writeStream contents ]) ].
	^ writeStream contents!

nextPut: aCharacter
	converter nextPut: aCharacter asCharacter toStream: stream!

nextPutAll: aString
	aString asString do: [ :each | self nextPut: each ]!

size
	^ stream size! !
!GRDolphinConverterCodecStream categoriesFor: #contents!accessing!public! !
!GRDolphinConverterCodecStream categoriesFor: #flush!actions!public! !
!GRDolphinConverterCodecStream categoriesFor: #initalizeOn:converter:!initialization!public! !
!GRDolphinConverterCodecStream categoriesFor: #next!public!streaming! !
!GRDolphinConverterCodecStream categoriesFor: #next:!public!streaming! !
!GRDolphinConverterCodecStream categoriesFor: #nextPut:!public!streaming! !
!GRDolphinConverterCodecStream categoriesFor: #nextPutAll:!public!streaming! !
!GRDolphinConverterCodecStream categoriesFor: #size!accessing!public! !

!GRDolphinConverterCodecStream class methodsFor!

on: aStream converter: aConverter
	^ self basicNew initalizeOn: aStream converter: aConverter! !
!GRDolphinConverterCodecStream class categoriesFor: #on:converter:!instance creation!public! !

GRDolphinUtf8CodecStream guid: (GUID fromString: '{FAD8B1F2-047E-4385-B87B-BF044C0E8783}')!
GRDolphinUtf8CodecStream comment: '
A WAUtf8CodecStream is a WACodecStream optimized for UTF-8 performance in the case where most of the characters are ASCII.
'!
!GRDolphinUtf8CodecStream categoriesForClass!Unclassified! !
!GRDolphinUtf8CodecStream methodsFor!

crlf
	stream nextPut: Character cr.
	stream nextPut: Character lf!

invalidUtf8
	^ GRInvalidUtf8Error signal: 'Invalid UTF-8 input'!

next
	| chars |
	chars := self next: 1.
	^chars notEmpty ifTrue: [chars first]!

next: anInteger 
	^UnicodeString fromUTF8Content: (stream nextAvailable: anInteger) asString!

next: size putAll: aSequenceableCollection startingAt: start
	"Dolphin Smalltalk compatibility."

	| string |
	string := aSequenceableCollection asUTF8Content.
	^stream
		next: size
		putAll: string
		startingAt: start!

nextPut: aCharacter
	self nextPutAll: (String with: aCharacter)!

nextPutAll: aString 
	stream nextPutAll: aString asUTF8Content! !
!GRDolphinUtf8CodecStream categoriesFor: #crlf!public!streaming! !
!GRDolphinUtf8CodecStream categoriesFor: #invalidUtf8!private! !
!GRDolphinUtf8CodecStream categoriesFor: #next!public!streaming! !
!GRDolphinUtf8CodecStream categoriesFor: #next:!public!streaming! !
!GRDolphinUtf8CodecStream categoriesFor: #next:putAll:startingAt:!public! !
!GRDolphinUtf8CodecStream categoriesFor: #nextPut:!public!streaming! !
!GRDolphinUtf8CodecStream categoriesFor: #nextPutAll:!public! !

GRDolphinLatin1CodecStream guid: (GUID fromString: '{C8A29059-CCCB-476B-9247-B84A4A6A3632}')!
GRDolphinLatin1CodecStream comment: 'A GRPharoLatin1CodecStream is a WACodecStream optimized for ISO-8859-1 (direct byte to character mapping).'!
!GRDolphinLatin1CodecStream categoriesForClass!Unclassified! !
!GRDolphinLatin1CodecStream methodsFor!

next
	^ Character value: stream next!

next: anInteger
	^(stream next: anInteger) asString! !
!GRDolphinLatin1CodecStream categoriesFor: #next!public!streaming! !
!GRDolphinLatin1CodecStream categoriesFor: #next:!public!streaming! !

GRDolphinPlatform guid: (GUID fromString: '{1EDC8B9C-2D1C-494F-B8B3-E4EC6F548BAC}')!
GRDolphinPlatform comment: ''!
!GRDolphinPlatform categoriesForClass!Unclassified! !
!GRDolphinPlatform methodsFor!

addToShutDownList: anObject
	"Add anObject to the shutdown-list of the system. On shutdown the message #shutDown will be sent to anObject."

	SessionManager current
		when: #sessionStopped
			send: #shutDown
			to: anObject!

addToStartUpList: anObject
	"Add anObject to the startup-list of the system. On startup the message #startUp will be sent to anObject."

	SessionManager current
		when: #sessionStarted
			send: #startUp
			to: anObject!

asMethodReturningByteArray: aByteArrayOrString named: aSymbol
	"Generates the source of a method named aSymbol that returns aByteArrayOrString as a ByteArray"
	^self useByteArrayLiterals
		ifTrue: [ self asMethodReturningByteArrayLiteral: aByteArrayOrString named: aSymbol ]
		ifFalse: [ self asMethodReturningByteArrayWithCache: aByteArrayOrString named: aSymbol ]!

asMethodReturningByteArrayLiteral: aByteArrayOrString named: aSymbol
	"Generates the source of a method named aSymbol that returns aByteArrayOrString as a byte array using VW/NewCompiler byte array literal syntax."
	^String streamContents: [ :stream |
		stream nextPutAll: aSymbol; nextPut: Character cr.
		stream tab; nextPutAll: '^ #['.
		aByteArrayOrString asByteArray
			do: [ :each | each printOn: stream ]
			separatedBy: [ stream space ].
		stream nextPutAll: ']' ]!

asMethodReturningByteArrayWithCache: aByteArrayOrString named: aSymbol
	"Generates the source of a method named aSymbol that returns aByteArrayOrString as a byte array and caching this array in a literal array of size 1."
	^ String streamContents: [ :stream |
		stream nextPutAll: aSymbol; nextPut: Character cr.
		stream tab; nextPutAll: '^ #('.
		aByteArrayOrString asByteArray
			do: [ :each | each printOn: stream ]
			separatedBy: [ stream space ].
		stream nextPutAll: ') asByteArray' ]!

base64Decode: aString

	^ByteArray fromBase64String: aString!

categoryNamed: aString
	"Private - Answer the MethodCategory named aString."

	^(Smalltalk at: #MethodCategory) name: aString!

compile: aString into: aClass classified: aSymbol
	"The trick here is to be as silently a possible so that the package is not marked dirty when running WAFileLibrary test.
	This also makes running tests much faster."
	
	| compileBlock dirty |
	compileBlock := [[aClass
					compile: aString
					categories: (Array with: (self categoryNamed: aSymbol asString))] on: MethodCompileFailed do: [:ex | GRError signal: 'syntax error' with: ex]].
	dirty := SessionManager isRuntime ifFalse: [aClass owningPackage ifNotNil: [:pac | pac isChanged]].
	[(Smalltalk at: #StsManager ifAbsent: [])
		ifNil: [compileBlock value]
		ifNotNil: [:sts | sts current ignoreCompilerWhile: compileBlock]]
			ensure: [SessionManager isRuntime ifFalse: [aClass owningPackage ifNotNil: [:pac | pac isChanged: dirty]]]!

contentsOfFile: aString binary: aBoolean
	| stream |
	stream := FileStream read: aString text: aBoolean not.
	^[stream contents] ensure: [stream close]!

convertToSmalltalkNewlines: aString
	"Convert any line endings (CR, CRLF, LF) to CR."

	"Dolphin version: Dolphin expects always CRLF.
	We assume that the actual senders of this message
	would expect CRLF for the Windows Dolphin Smalltalk."

	^aString ifNotNil: [aString withNormalizedLineDelimiters]!

deliverMailFrom: fromAddress to: recipientList text: messageText

	CDOIMessage new
		from: fromAddress;
		sender: fromAddress;
		to: recipientList;
		textBody: messageText;
		configuration: self smtpConfiguration;
		Send!

ensureExistenceOfFolder: aString
	"creates a folder named aString in the image directory"
	File createDirectory: (FileLocator imageRelative localFileSpecFor: aString)!

filesIn: aPathString
	"Return a collection of absolute paths for all the files (no directories) in the directory given by aPathString
	must not include file names that start with ."
	| directory fileNames |
	directory := FileLocator imageRelative localFileSpecFor: aPathString.
	fileNames := OrderedCollection new.
	File for: '*.*' in: directory do: [:each |  (each isDirectory not and: [each fileName first ~= $. ]) ifTrue: [fileNames add: each path]].
	^fileNames!

findFirstInString: aString inSet: inclusionMap startingAt: start 
	"Private - Port of Pharo primitive.
	Which is the Dolphin implementation if there is one??"

	| i stringSize |
	inclusionMap size ~= 256 ifTrue: [^0].
	i := start.
	stringSize := aString size.
	[i <= stringSize and: [(inclusionMap at: (aString at: i) asciiValue + 1) = 0]] 
		whileTrue: [i := i + 1].
	i > stringSize ifTrue: [^0].
	^i!

includesUnsafeUrlCharacter: aString 
	^(aString isKindOf: UnicodeString) 
		or: [(self 
				findFirstInString: aString
				inSet: UrlTable
				startingAt: 1) ~= 0]!

includesUnsafeXmlCharacter: aString 
	^(aString isKindOf: UnicodeString) 
		or: [(self 
				findFirstInString: aString
				inSet: XmlTable
				startingAt: 1) ~= 0]!

isProcessTerminated: aProcess
	"Return a boolean indicating whether aProcess has been terminated."
	^ aProcess isTerminated!

label
	^'Dolphin'!

localNameOf: aFilename
	^File splitFilenameFrom: aFilename!

newline
	^String lineDelimiter!

newRandom
	"Answers the random number generator to be used to create session and continuation keys. Make sure it is seeded. They only method that will be sent to it will be #nextInt: which should answer a random integer in the interval [1, anInteger]. Make sure this works in a load balanced scenario.
	
	Used by Gemstone/S traditional Randoms which cannot be persisted.
	Used by Squeak to use a secure random when avaiable."
	
	^Random new!

openDebuggerOn: anError
	
	^SessionManager current onUnhandledError: anError!

readWriteByteStream
	"ByteArray based read write stream"
	
	^ ReadWriteStream on: (ByteArray new: 4096)!

readWriteCharacterStream
	"String based read write stream"

	^ ReadWriteStream on: (String new: 4096)!

reducedConflictDictionary
	"used by Gemstone/S reduced conflict classes that can be used to avoid transaction conflicts"
	^LookupTable!

removeFromShutDownList: anObject
	"Remove anObject from the shutdown list in the system."

	"Dolphin version: This is not totally correct. We should modify
	this behavior to remove only from the shutDown list of the session."
	#toDo.
	SessionManager current events removeEventsTriggeredFor: anObject!

removeFromStartUpList: anObject
	"Remove anObject from the startup list in the system."

	"Dolphin version: This is not totally correct. We should modify
	this behavior to remove only from the startUp list of the session."
	#toDo.
	SessionManager current events removeEventsTriggeredFor: anObject!

removeSelector: aSymbol from: aClass
	
	| dirty actionBlock |
	dirty := SessionManager isRuntime ifFalse: [aClass owningPackage isChanged].
	actionBlock := [aClass removeSelector:aSymbol ifAbsent: []].
	[(Smalltalk at: #StsManager ifAbsent: [])
		ifNil: [actionBlock value]
		ifNotNil: [:sts | sts current ignoreCompilerWhile: actionBlock]]
			ensure: [SessionManager isRuntime ifFalse: [aClass owningPackage isChanged: dirty]]!

seasideSuspendFlowDo: aBlock
	"Evaluate aBlock, passing in a continuation that can be evaluated to answer to the place where this very method was called. This method is presumed to be executed only within the scope of an executing Callback or Task and should, ideally, create a continuation that includes only the contexts that make up the Callback or Task execution (a partial or delimited continuation). Do not use this method, if you don't understand this comment."
	Error notYetImplemented!

secureHashFor: aString
	^ SecureHashAlgorithm new hashMessage: aString!

semaphoreClass
	"used by Gemstone/S traditional Semaphores which cannot be persisted"
	^Semaphore!

smtpConfiguration

	| config |
	config := CDOIConfiguration new.
	config fields
		at: 'http://schemas.microsoft.com/cdo/configuration/smtpserver' 
			put: self smtpServer;
		at: 'http://schemas.microsoft.com/cdo/configuration/sendusing' 
			put: 2;
		at: 'http://schemas.microsoft.com/cdo/configuration/smtpauthenticate' 
			put: 0;
		interface Update.
	^config!

smtpServer
	^self class smtpServer!

stackDepth

	| depth current |
	depth := 0.
	current := Processor activeProcess topFrame.
	[current isNil] whileFalse: [
		current := current sender.
		depth := depth + 1].
	^depth - 1!

terminateProcess: aProcess
	"Permanently terminate the process, unwinding first to execute #ensure: and #ifCurtailed: blocks."
	aProcess terminate!

useByteArrayLiterals
	"whether ByteArray literals can/should be used"
	
	^true!

weakDictionaryOfSize: aNumber
	
	^WeakLookupTable new: aNumber!

write: aStringOrByteArray toFile: aFileNameString inFolder: aFolderString
	"Writes aStringOrByteArray to a file named aFilenameString in the folder aFolderString"
	| folder stream fullFilePath |
	folder := FileLocator imageRelative localFileSpecFor: aFolderString.
	fullFilePath := File fullPathOf: aFileNameString relativeTo: folder.
	stream := FileStream write: fullFilePath text: aStringOrByteArray isString.
	[stream nextPutAll: aStringOrByteArray] ensure: [stream close]! !
!GRDolphinPlatform categoriesFor: #addToShutDownList:!public!startup! !
!GRDolphinPlatform categoriesFor: #addToStartUpList:!public!startup! !
!GRDolphinPlatform categoriesFor: #asMethodReturningByteArray:named:!file library!public! !
!GRDolphinPlatform categoriesFor: #asMethodReturningByteArrayLiteral:named:!private-file library!public! !
!GRDolphinPlatform categoriesFor: #asMethodReturningByteArrayWithCache:named:!private-file library!public! !
!GRDolphinPlatform categoriesFor: #base64Decode:!encoding!public! !
!GRDolphinPlatform categoriesFor: #categoryNamed:!file library!public! !
!GRDolphinPlatform categoriesFor: #compile:into:classified:!file library!public! !
!GRDolphinPlatform categoriesFor: #contentsOfFile:binary:!file library!public! !
!GRDolphinPlatform categoriesFor: #convertToSmalltalkNewlines:!file library!public! !
!GRDolphinPlatform categoriesFor: #deliverMailFrom:to:text:!email!public! !
!GRDolphinPlatform categoriesFor: #ensureExistenceOfFolder:!file library!public! !
!GRDolphinPlatform categoriesFor: #filesIn:!file library!public! !
!GRDolphinPlatform categoriesFor: #findFirstInString:inSet:startingAt:!private!testing! !
!GRDolphinPlatform categoriesFor: #includesUnsafeUrlCharacter:!public!testing! !
!GRDolphinPlatform categoriesFor: #includesUnsafeXmlCharacter:!public!testing! !
!GRDolphinPlatform categoriesFor: #isProcessTerminated:!processes!public! !
!GRDolphinPlatform categoriesFor: #label!public! !
!GRDolphinPlatform categoriesFor: #localNameOf:!file library!public! !
!GRDolphinPlatform categoriesFor: #newline!public! !
!GRDolphinPlatform categoriesFor: #newRandom!factory!public! !
!GRDolphinPlatform categoriesFor: #openDebuggerOn:!exceptions!public! !
!GRDolphinPlatform categoriesFor: #readWriteByteStream!factory!public! !
!GRDolphinPlatform categoriesFor: #readWriteCharacterStream!factory!public! !
!GRDolphinPlatform categoriesFor: #reducedConflictDictionary!public! !
!GRDolphinPlatform categoriesFor: #removeFromShutDownList:!public!startup! !
!GRDolphinPlatform categoriesFor: #removeFromStartUpList:!public!startup! !
!GRDolphinPlatform categoriesFor: #removeSelector:from:!file library!public! !
!GRDolphinPlatform categoriesFor: #seasideSuspendFlowDo:!public! !
!GRDolphinPlatform categoriesFor: #secureHashFor:!cryptography!public! !
!GRDolphinPlatform categoriesFor: #semaphoreClass!factory!public! !
!GRDolphinPlatform categoriesFor: #smtpConfiguration!email!public! !
!GRDolphinPlatform categoriesFor: #smtpServer!private-email!public! !
!GRDolphinPlatform categoriesFor: #stackDepth!exceptions!public! !
!GRDolphinPlatform categoriesFor: #terminateProcess:!processes!public! !
!GRDolphinPlatform categoriesFor: #useByteArrayLiterals!private-file library!public! !
!GRDolphinPlatform categoriesFor: #weakDictionaryOfSize:!factory!public! !
!GRDolphinPlatform categoriesFor: #write:toFile:inFolder:!file library!public! !

!GRDolphinPlatform class methodsFor!

initialize
	self initializeXmlTable.
	self initializeUrlTable.
	self select!

initializeUrlTable
	UrlTable := ByteArray new: 256.
	1 to: 256 do: [ :index |
		('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.~' includes: (Character codePoint: index - 1))
			ifTrue: [ UrlTable at: index put: 0 ]
			ifFalse: [ UrlTable at: index put: 1 ] ]!

initializeXmlTable
	XmlTable := ByteArray new: 256.
	1 to: 256 do: [ :index |
		('"<&>' includes: (Character codePoint: index - 1))
			ifTrue: [ XmlTable at: index put: 1 ]
			ifFalse: [ XmlTable at: index put: 0 ] ]!

isSmtpServerSet
	^SmtpServer notNil and: [SmtpServer notEmpty]!

setSmtpServer
	"Set the SMTP server used to send outgoing messages via"
	SmtpServer ifNil: [SmtpServer := ''].
	SmtpServer := Prompter on: SmtpServer asValue prompt: 'What is your mail server for outgoing mail?' caption: 'SMTP configuration'!

smtpServer

	self isSmtpServerSet
		ifFalse: [self setSmtpServer].
	SmtpServer isEmpty ifTrue: [
		self error: 'no SMTP server specified'].
	^SmtpServer!

uninitialize
	self unload!

unload
	self unselect! !
!GRDolphinPlatform class categoriesFor: #initialize!class initialization!public! !
!GRDolphinPlatform class categoriesFor: #initializeUrlTable!class initialization!public! !
!GRDolphinPlatform class categoriesFor: #initializeXmlTable!class initialization!public! !
!GRDolphinPlatform class categoriesFor: #isSmtpServerSet!public! !
!GRDolphinPlatform class categoriesFor: #setSmtpServer!public! !
!GRDolphinPlatform class categoriesFor: #smtpServer!public! !
!GRDolphinPlatform class categoriesFor: #uninitialize!class initialization!public! !
!GRDolphinPlatform class categoriesFor: #unload!class initialization!public! !

"Binary Globals"!

