| package |
package := Package name: 'Grease-Tests-Dolphin-Core'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '8'.


package classNames
	add: #GRDolphinCodecTest;
	add: #GRDolphinColorTest;
	add: #GRDolphinGenericCodecTest;
	add: #GRDolphinPlatformTest;
	yourself.

package methodNames
	add: #GRUtf8CodecTest -> #expectedFailures;
	add: 'GRPackage class' -> #greaseTestsDolphinCore;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: 'Grease-Core';
	add: 'Grease-Tests-Core';
	add: '..\..\Camp Smalltalk\SUnit\SUnit';
	yourself).

package!

"Class Definitions"!

TestCase subclass: #GRDolphinCodecTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #GRDolphinColorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #GRDolphinGenericCodecTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #GRDolphinPlatformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

greaseTestsDolphinCore
	^(self new)
		name: 'Grease-Tests-Dolphin-Core';
		description: 'Unit tests for the package Grease-Dolphin-Core.';
		addDependency: 'Grease-Dolphin-Core';
		addDependency: 'Grease-Tests-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #greaseTestsDolphinCore!*grease-tests-pharo-core!public! !

!GRUtf8CodecTest methodsFor!

expectedFailures
	^#(testCodecUtf8ShortestForm)! !
!GRUtf8CodecTest categoriesFor: #expectedFailures!*grease-tests-pharo-core!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

GRDolphinCodecTest guid: (GUID fromString: '{297B0823-6B50-45CA-8416-A61A666F31D1}')!
GRDolphinCodecTest comment: ''!
!GRDolphinCodecTest categoriesForClass!Unclassified! !
!GRDolphinCodecTest methodsFor!

testAllCodesIncludesIso88591
	self assert: (GRCodec allCodecs anySatisfy: [ :each |
		each name = 'iso-8859-1' ])! !
!GRDolphinCodecTest categoriesFor: #testAllCodesIncludesIso88591!public!testing! !

GRDolphinColorTest guid: (GUID fromString: '{0AEFE2CB-4B37-49DA-9ACB-767763B9F3DB}')!
GRDolphinColorTest comment: ''!
!GRDolphinColorTest categoriesForClass!Unclassified! !
!GRDolphinColorTest methodsFor!

expectedFailures
	^#( testFromStringThreeDigit )!

testAllColors
	| toTest |
	toTest := #(
		16r000000 16r000001 16r000101 16r010101 16r010100 16r010000 16r001001 16r101001
		16r001122 16r334455 16r667788 16r99AABB 16rCCDDEE 16rFF0011
		16r123456 16r789ABC 16rDEFEDC
		16rFEFEEF 16rFEFEFF 16rFEFEFE 16rFFFEFE 16rFFFFFE 16rFFFFFF).
	toTest do: [:int | 
		| hex |
		hex := int printPaddedWith: $0 to: 6 base: 16.
		self assert: (Color fromString: hex) asHTMLColor asLowercase = ('#', hex) asLowercase ]!

testColorAsHtmlColor
	"test for:
	Color >> #hex
	| aStream |
	aStream := (String new: 6) writeStream.
	aStream nextPutAll: (((self red * 255) asInteger printStringBase: 16)
		padded: #left to: 2 with: $0).
	aStream nextPutAll: (((self green * 255) asInteger printStringBase: 16)
		padded: #left to: 2 with: $0).
	aStream nextPutAll: (((self blue * 255) asInteger printStringBase: 16)
		padded: #left to: 2 with: $0).
	^ aStream contents

	Color >> #asHTMLColor
	^ '#', self hex"
	self assert: (#('#ffffff' '#FFFFFF' ) includes: Color white asHTMLColor).
	self assert: (Color black asHTMLColor = '#000000').
	self assert: (#('#ff0000' '#FF0000' ) includes: Color red asHTMLColor)!

testFromSixDigit
	self assert: (Color fromString: 'ff0000') = Color red asRGB.
	self assert: (Color fromString: 'FF0000') = Color red asRGB.
	self assert: (Color fromString: '#ff0000') = Color red asRGB.
	self assert: (Color fromString: '#FF0000') = Color red asRGB
!

testFromStringName
	self assert: (Color fromString: 'red') = Color red asRGB.
	self assert: (Color fromString: 'RED') = Color red asRGB.
	self assert: (Color fromString: '#red') = Color red asRGB.
	self assert: (Color fromString: '#RED') = Color red asRGB.
!

testFromStringSixDigit
	self assert: (Color fromString: 'ff0000') = Color red asRGB.
	self assert: (Color fromString: 'FF0000') = Color red asRGB.
	self assert: (Color fromString: '#ff0000') = Color red asRGB.
	self assert: (Color fromString: '#FF0000') = Color red asRGB
!

testFromStringThreeDigit
	self assert: (Color fromString: 'f00') = Color red asRGB.
	self assert: (Color fromString: 'F00') = Color red asRGB.
	self assert: (Color fromString: '#f00') = Color red asRGB.
	self assert: (Color fromString: '#F00') = Color red asRGB.! !
!GRDolphinColorTest categoriesFor: #expectedFailures!public!testing! !
!GRDolphinColorTest categoriesFor: #testAllColors!public!testing! !
!GRDolphinColorTest categoriesFor: #testColorAsHtmlColor!public!testing! !
!GRDolphinColorTest categoriesFor: #testFromSixDigit!public!testing! !
!GRDolphinColorTest categoriesFor: #testFromStringName!public!testing! !
!GRDolphinColorTest categoriesFor: #testFromStringSixDigit!public!testing! !
!GRDolphinColorTest categoriesFor: #testFromStringThreeDigit!public!testing! !

GRDolphinGenericCodecTest guid: (GUID fromString: '{09A1254D-06D0-43FA-94C0-BAC51BB891E2}')!
GRDolphinGenericCodecTest comment: ''!
!GRDolphinGenericCodecTest categoriesForClass!Unclassified! !
GRDolphinPlatformTest guid: (GUID fromString: '{99844EAB-2843-4C32-AF25-A40C516921B8}')!
GRDolphinPlatformTest comment: ''!
!GRDolphinPlatformTest categoriesForClass!Unclassified! !
!GRDolphinPlatformTest methodsFor!

testCompileIntoClassified
	| source protocol selectors selector |
	source := 'aMethod
	^ ''a result'''.
	protocol := 'a-protocol'.
	selector := #aMethod.

	GRPlatform current compile: source into: self class classified: protocol.
	[	self assert: (self class selectors includes: selector).
		selectors := (MethodCategory name: protocol) contents collect: [:each | each selector].
		self assert: (selectors includes: selector).
	 	] ensure: [ GRPlatform current removeSelector: selector from: self class ]!

testFullName
	self assert: Object fullName = 'Object'!

testMessageSendValueWithPossibleArguments
	| send |
	send := MessageSend receiver: 1 selector: #+.
	self assert: (send valueWithPossibleArguments: (Array with: 2)) = 3.
	self assert: (send valueWithArguments: (Array with: 2)) = 3.
	self assert: (send value: 2) = 3.

	send := MessageSend receiver: false selector: #not.
	self assert: (send valueWithPossibleArguments: (Array with: 3)).
	
	send := MessageSend receiver: 1 selector: #+ arguments: #(2).
	self assert: (send valueWithPossibleArguments: (Array with: 4)) = 3.
	self assert: send value = 3.
	
	send := MessageSend receiver: Array selector: #with:with: arguments: #(1).
	self assert: (send valueWithPossibleArguments: (Array with: 2)) size = 2.

	send := MessageSend receiver: Array selector: #with:with:.
	self assert: (send value: 1 value: 2) size = 2.
	
	send := MessageSend 
		receiver: 1
		selector: #+.
	self assert: send argumentCount = 1.
	self assert: send arguments size = 0.
	self assert: send fixCallbackTemps == send.
	
	send := MessageSend 
		receiver: 1
		selector: #+
		argument: 2.
	self assert: send argumentCount isZero.
	self assert: send arguments size = 1.
	self assert: send fixCallbackTemps == send! !
!GRDolphinPlatformTest categoriesFor: #testCompileIntoClassified!public!tests! !
!GRDolphinPlatformTest categoriesFor: #testFullName!public!tests! !
!GRDolphinPlatformTest categoriesFor: #testMessageSendValueWithPossibleArguments!public!tests! !

"Binary Globals"!

