| package |
package := Package name: 'Javascript-Core'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '88'.


package classNames
	add: #JSAccess;
	add: #JSAjaxCallback;
	add: #JSAlias;
	add: #JSApply;
	add: #JSAssign;
	add: #JSAssignLocal;
	add: #JSAssignment;
	add: #JSBinary;
	add: #JSCall;
	add: #JSConcatenation;
	add: #JSCondition;
	add: #JSCreate;
	add: #JSDecoration;
	add: #JSFunction;
	add: #JSIfThenElse;
	add: #JSInterval;
	add: #JSJoin;
	add: #JSJson;
	add: #JSJsonDeploymentLibrary;
	add: #JSJsonDevelopmentLibrary;
	add: #JSJsonParser;
	add: #JSJsonStream;
	add: #JSJsonSyntaxError;
	add: #JSLogger;
	add: #JSMember;
	add: #JSNegation;
	add: #JSObject;
	add: #JSPassenger;
	add: #JSProperty;
	add: #JSScript;
	add: #JSStatement;
	add: #JSStream;
	add: #JSTimed;
	add: #JSTimeout;
	yourself.

package methodNames
	add: #Boolean -> #jsonOn:;
	add: #Character -> #javascriptOn:;
	add: #Character -> #jsonOn:;
	add: #Collection -> #javascriptOn:;
	add: #Collection -> #jsonOn:;
	add: #Date -> #javascriptMonthIndex;
	add: #Date -> #javascriptOn:;
	add: #DateAndTime -> #javascriptMonthIndex;
	add: #DateAndTime -> #javascriptOn:;
	add: #Dictionary -> #javascriptOn:;
	add: #Dictionary -> #jsonOn:;
	add: #Duration -> #javascriptOn:;
	add: #Float -> #jsonOn:;
	add: #GRSmallDictionary -> #javascriptOn:;
	add: #GRSmallDictionary -> #jsonOn:;
	add: #Integer -> #jsonOn:;
	add: #Object -> #asFunction;
	add: #Object -> #asFunction:;
	add: #Object -> #asJavascript;
	add: #Object -> #asJson;
	add: #Object -> #isJavascript;
	add: #Object -> #javascriptOn:;
	add: #Object -> #jsonOn:;
	add: #Stream -> #javascript:;
	add: #Stream -> #json:;
	add: #String -> #asFunction:;
	add: #String -> #javascriptOn:;
	add: #String -> #jsonOn:;
	add: #UndefinedObject -> #javascriptOn:;
	add: #UndefinedObject -> #jsonOn:;
	add: #WACallback -> #isPassenger;
	add: #WACallbackRegistry -> #passengerAt:;
	add: #WACallbackRegistry -> #passengerAt:ifAbsent:;
	add: #WACallbackRegistry -> #registerAjaxCallback:;
	add: #WACallbackRegistry -> #registerPassenger:named:;
	add: #WARenderer -> #javascript;
	add: #WARenderer -> #logger;
	add: #WATagBrush -> #passenger:;
	add: #WATagBrush -> #script:;
	add: #WAUrl -> #javascriptOn:;
	add: 'GRPackage class' -> #javascriptCore;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: '..\..\IDB\IDB DateAndTime';
	add: '..\..\IDB\IDB Duration';
	add: '..\Seaside\Seaside-Canvas';
	add: '..\Seaside\Seaside-Core';
	yourself).

package!

"Class Definitions"!

WAError subclass: #JSJsonSyntaxError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRObject subclass: #JSJsonStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #JSDecoration
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #JSJsonParser
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #JSObject
	instanceVariableNames: 'decoration renderContext rendererClass'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSDecoration subclass: #JSApply
	instanceVariableNames: 'arguments'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSDecoration subclass: #JSAssignment
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSDecoration subclass: #JSCall
	instanceVariableNames: 'name arguments'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSDecoration subclass: #JSCreate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSDecoration subclass: #JSIfThenElse
	instanceVariableNames: 'trueStatement falseStatement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSDecoration subclass: #JSMember
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSDecoration subclass: #JSNegation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSDecoration subclass: #JSStatement
	instanceVariableNames: 'statement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSDecoration subclass: #JSTimed
	instanceVariableNames: 'duration'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSMember subclass: #JSAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSMember subclass: #JSAlias
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSMember subclass: #JSAssign
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSMember subclass: #JSProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSAssign subclass: #JSAssignLocal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatement subclass: #JSBinary
	instanceVariableNames: 'operator'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatement subclass: #JSConcatenation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatement subclass: #JSCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSTimed subclass: #JSInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSTimed subclass: #JSTimeout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSObject subclass: #JSJoin
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSObject subclass: #JSJson
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSObject subclass: #JSLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSObject subclass: #JSScript
	instanceVariableNames: 'statements'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSObject subclass: #JSStream
	instanceVariableNames: 'stream'
	classVariableNames: 'Arguments JavascriptCharacters This'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSScript subclass: #JSFunction
	instanceVariableNames: 'return arguments'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACallback subclass: #JSAjaxCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACallback subclass: #JSPassenger
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFileLibrary subclass: #JSJsonDeploymentLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFileLibrary subclass: #JSJsonDevelopmentLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!Boolean methodsFor!

jsonOn: aStream
	self javascriptOn: aStream! !
!Boolean categoriesFor: #jsonOn:!*javascript-core!public! !

!Character methodsFor!

javascriptOn: aStream
	(String with: self) javascriptOn: aStream!

jsonOn: aStream
	self javascriptOn: aStream! !
!Character categoriesFor: #javascriptOn:!*javascript-core!public! !
!Character categoriesFor: #jsonOn:!*javascript-core!public! !

!Collection methodsFor!

javascriptOn: aStream
	JSStream encodeCollection: self on: aStream!

jsonOn: aStream 
	JSJsonStream encodeCollection: self on: aStream! !
!Collection categoriesFor: #javascriptOn:!*javascript-core!public! !
!Collection categoriesFor: #jsonOn:!*javascript-core!public! !

!Date methodsFor!

javascriptMonthIndex
	^ self monthIndex - 1!

javascriptOn: aStream
	aStream nextPutAll: 'new Date('.
	#( year javascriptMonthIndex dayOfMonth )
		do: [ :each | aStream javascript: (self perform: each) ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $)! !
!Date categoriesFor: #javascriptMonthIndex!*javascript-core!public! !
!Date categoriesFor: #javascriptOn:!*javascript-core!public! !

!DateAndTime methodsFor!

javascriptMonthIndex
	^ self monthIndex - 1!

javascriptOn: aStream
	aStream nextPutAll: 'new Date('.
	#( year javascriptMonthIndex dayOfMonth hour minute second )
		do: [ :each | aStream javascript: (self perform: each) ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $)! !
!DateAndTime categoriesFor: #javascriptMonthIndex!*javascript-core!public! !
!DateAndTime categoriesFor: #javascriptOn:!*javascript-core!public! !

!Dictionary methodsFor!

javascriptOn: aStream
	JSStream encodeDictionary: self on: aStream!

jsonOn: aStream
	JSJsonStream encodeDictionary: self on: aStream! !
!Dictionary categoriesFor: #javascriptOn:!*javascript-core!public! !
!Dictionary categoriesFor: #jsonOn:!*javascript-core!public! !

!Duration methodsFor!

javascriptOn: aStream
	aStream javascript: self asMilliseconds! !
!Duration categoriesFor: #javascriptOn:!*javascript-core!public! !

!Float methodsFor!

jsonOn: aStream
	self javascriptOn: aStream! !
!Float categoriesFor: #jsonOn:!*javascript-core!public! !

!GRPackage class methodsFor!

javascriptCore
	^ self new
		name: 'Javascript-Core';
		description: 'Javascript integration in Seaside. Provides a basic functionality to generate Javascript from Smalltalk.';
		addDependency: 'Seaside-Core';
		addDependency: 'Seaside-Canvas';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #javascriptCore!*javascript-core!public! !

!GRSmallDictionary methodsFor!

javascriptOn: aStream
	JSStream encodeDictionary: self on: aStream!

jsonOn: aStream
	JSJsonStream encodeDictionary: self on: aStream! !
!GRSmallDictionary categoriesFor: #javascriptOn:!*javascript-core!public! !
!GRSmallDictionary categoriesFor: #jsonOn:!*javascript-core!public! !

!Integer methodsFor!

jsonOn: aStream
	self javascriptOn: aStream! !
!Integer categoriesFor: #jsonOn:!*javascript-core!public! !

!Object methodsFor!

asFunction
	^ self asFunction: #()!

asFunction: aCollection
	^ JSFunction new add: self; arguments: aCollection!

asJavascript
	^ String streamContents: [ :stream | self javascriptOn: stream ]!

asJson
	^ String streamContents: [ :stream | self jsonOn: stream ]!

isJavascript
	^ false!

javascriptOn: aStream
	self printOn: aStream!

jsonOn: aStream
	self error: 'Override #jsonOn: to make the receiver serializeable as JSON'! !
!Object categoriesFor: #asFunction!*javascript-core!public! !
!Object categoriesFor: #asFunction:!*javascript-core!public! !
!Object categoriesFor: #asJavascript!*javascript-core!public! !
!Object categoriesFor: #asJson!*javascript-core!public! !
!Object categoriesFor: #isJavascript!*javascript-core!public! !
!Object categoriesFor: #javascriptOn:!*javascript-core!public! !
!Object categoriesFor: #jsonOn:!*javascript-core!public! !

!Stream methodsFor!

javascript: anObject
	anObject javascriptOn: self!

json: anObject
	anObject jsonOn: self! !
!Stream categoriesFor: #javascript:!*javascript-core!public! !
!Stream categoriesFor: #json:!*javascript-core!public! !

!String methodsFor!

asFunction: aCollection
	^ (JSStream on: self) asFunction: aCollection!

javascriptOn: aStream
	JSStream encodeString: self on: aStream!

jsonOn: aStream
	self javascriptOn: aStream! !
!String categoriesFor: #asFunction:!*javascript-core!public! !
!String categoriesFor: #javascriptOn:!*javascript-core!public! !
!String categoriesFor: #jsonOn:!*javascript-core!public! !

!UndefinedObject methodsFor!

javascriptOn: aStream
	aStream nextPutAll: 'null'!

jsonOn: aStream
	self javascriptOn: aStream! !
!UndefinedObject categoriesFor: #javascriptOn:!*javascript-core!public! !
!UndefinedObject categoriesFor: #jsonOn:!*javascript-core!public! !

!WACallback methodsFor!

isPassenger
	^ false! !
!WACallback categoriesFor: #isPassenger!*javascript-core!public! !

!WACallbackRegistry methodsFor!

passengerAt: aString
	^ self passengerAt: aString ifAbsent: [ nil ]!

passengerAt: aString ifAbsent: aBlock
	| passenger |
	passenger := callbacks at: aString ifAbsent: [ ^ aBlock value ].
	passenger isPassenger ifFalse: [ ^ aBlock value ].
	^ passenger object!

registerAjaxCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerAjaxCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (JSAjaxCallback on: aBlock)!

registerPassenger: anObject named: aString
	| callback |
	callback := JSPassenger new.
	callback setKey: aString callbacks: callbacks; setObject: anObject.
	callbacks at: (callback convertKey: aString) put: callback.
	^ aString! !
!WACallbackRegistry categoriesFor: #passengerAt:!*javascript-core!public! !
!WACallbackRegistry categoriesFor: #passengerAt:ifAbsent:!*javascript-core!public! !
!WACallbackRegistry categoriesFor: #registerAjaxCallback:!*javascript-core!public! !
!WACallbackRegistry categoriesFor: #registerPassenger:named:!*javascript-core!public! !

!WARenderer methodsFor!

javascript
	^ (JSScript context: self context)
		rendererClass: self species;
		yourself!

logger
	^ (JSLogger context: self context)
		rendererClass: self species;
		yourself! !
!WARenderer categoriesFor: #javascript!*javascript-core!public! !
!WARenderer categoriesFor: #logger!*javascript-core!public! !

!WATagBrush methodsFor!

passenger: anObject
	"Assign a passenger object to the receiver. This is used to keep a mapping between DOM elements and Smalltalk objects. Note, that to we are required to assign a numeric id to the reciever in order to keep the mapping between DOM element and Smalltalk object."

	canvas callbacks registerPassenger: anObject named: self ensureId!

script: anObject
	"Attach a JavaScript object to the receiver. The argument automatically knows the ID of the DOM element it should operate on and will be evaluated when the page complete loading."

	(anObject isNil) 
		ifTrue: [ ^ self ].
	(anObject respondsTo: #id:)
		ifTrue: [ anObject id: self ensureId ].
	canvas document addLoadScript: anObject! !
!WATagBrush categoriesFor: #passenger:!*javascript-core!public! !
!WATagBrush categoriesFor: #script:!*javascript-core!public! !

!WAUrl methodsFor!

javascriptOn: aStream 
	aStream javascript: self printString! !
!WAUrl categoriesFor: #javascriptOn:!*javascript-core!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

JSJsonSyntaxError guid: (GUID fromString: '{BD39030B-DDAD-4BBB-9358-8855C75D0842}')!
JSJsonSyntaxError comment: '
A JSJsonSyntaxError signals invalid JSON input.
'!
!JSJsonSyntaxError categoriesForClass!Unclassified! !
JSJsonStream guid: (GUID fromString: '{74A8E730-6DF6-4D9C-893E-83EC1DEA0C7A}')!
JSJsonStream comment: 'I am a specialization of JSStream that conforms to the JSON spec (http://www.json.org).'!
!JSJsonStream categoriesForClass!Unclassified! !
!JSJsonStream class methodsFor!

encodeCollection: aCollection on: aStream
	"Writes aCollection of elements to aStream enclosed in square brakets."
	
	aStream nextPut: $[.
	aCollection
		do: [ :each | aStream json: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $]!

encodeDictionary: aDictionary on: aStream 
	"Dictionary or hash-maps common structures in JSON to aStream."
	
	| first |
	first := true.
	aStream nextPut: ${.
	aDictionary keysAndValuesDo: [ :key :value |
		first
			ifTrue: [ first := false ]
			ifFalse: [ aStream nextPut: $, ].
		aStream 
			json: key greaseString;
			nextPut: $:;
			json: value ].
	aStream nextPut: $}! !
!JSJsonStream class categoriesFor: #encodeCollection:on:!encoding!public! !
!JSJsonStream class categoriesFor: #encodeDictionary:on:!encoding!public! !

JSDecoration guid: (GUID fromString: '{54A624A6-1296-4646-9B2C-754A38A72A12}')!
JSDecoration comment: 'I decorate JavaScript objects.'!
!JSDecoration categoriesForClass!Unclassified! !
!JSDecoration methodsFor!

isJavascript
	^ true!

javascriptContentOn: aStream
	self owner javascriptContentOn: aStream!

owner
	^ owner!

renderContext
	^ owner renderContext!

setOwner: anObject
	owner := anObject! !
!JSDecoration categoriesFor: #isJavascript!public!testing! !
!JSDecoration categoriesFor: #javascriptContentOn:!printing!public! !
!JSDecoration categoriesFor: #owner!accessing!public! !
!JSDecoration categoriesFor: #renderContext!accessing!public! !
!JSDecoration categoriesFor: #setOwner:!initialization!public! !

JSJsonParser guid: (GUID fromString: '{5350EBD3-BD0F-48AC-B566-FE27F0CD13E8}')!
JSJsonParser comment: '
I am a parser for JSON. It is a bit more forgiving than the standard and allows any kind of top level element except numbers, not just {} and []. See http://www.json.org/ for details.

I can be subclasses to create more sophisticated objects than just Arrays and Dictionaries. To do that, override the one or more methods in the creating protocol.'!
!JSJsonParser categoriesForClass!Unclassified! !
!JSJsonParser methodsFor!

addProperty: anAssociation to: anObject
	"Add the property anAssociation described with key and value to anObject. Subclasses might want to refine this implementation."
	
	^ anObject 
		add: anAssociation;
		yourself!

addValue: anObject to: aCollection
	"Add anObject to aCollection. Subclasses might want to refine this implementation."

	^ aCollection copyWith: anObject!

createArray
	"Create an empty collection. Subclasses might want to refine this implementation."

	^ Array new!

createFalse
	"Create the false literal. Subclasses might want to refine this implementation."
	
	^ false!

createNull
	"Create the null literal. Subclasses might want to refine this implementation."

	^ nil!

createNumber: aString
	"Create a number literal. Subclasses might want to refine this implementation."

	^ aString asNumber!

createObject
	"Create an empty object. Subclasses might want to refine this implementation."
	
	^ Dictionary new!

createProperty: aKey with: aValue
	"Create an empty attribute value pair. Subclasses might want to refine this implementation."
	
	^ aKey -> aValue!

createString: aString
	"Create a string literal. Subclasses might want to refine this implementation."

	^ aString!

createTrue
	"Create the true literal. Subclasses might want to refine this implementation."

	^ true!

error: aString
	"Raise a parse error labelled aString."

	^ JSJsonSyntaxError signal: aString!

expect: aString
	"Expects aString and consume input, throw an error otherwise."

	^ (self match: aString) ifFalse: [ self error: aString , ' expected' ]!

initializeOn: aStream
	self initialize.
	stream := aStream!

match: aString
	"Tries to match aString, consume input and answer true if successful."
	
	| position |
	position := stream position.
	aString do: [ :each |
		(stream atEnd or: [ stream next ~= each ]) ifTrue: [ 
			stream position: position.
			^ false ] ].
	self whitespace.
	^ true!

parse
	| result |
	result := self whitespace; parseValue.
	stream atEnd
		ifFalse: [ self error: 'end of input expected' ].
	^ result!

parseArray
	| result |
	self expect: '['.
	result := self createArray.
	(self match: ']')
		ifTrue: [ ^ result ].
	[ stream atEnd ] whileFalse: [
		result := self
			addValue: self parseValue
			to: result.
		(self match: ']') 
			ifTrue: [ ^ result ].
		self expect: ',' ].
	self error: 'end of array expected'!

parseCharacter
	| char |
	(char := stream next) = $\ 
		ifFalse: [ ^ char ].
	(char := stream next) = $" 
		ifTrue: [ ^ char ].
	char = $\
		ifTrue: [ ^ char ].
	char = $/
		ifTrue: [ ^ char ].
	char = $b
		ifTrue: [ ^ Character backspace ].
	char = $f
		ifTrue: [ ^ Character newPage ].
	char = $n
		ifTrue: [ ^ Character lf ].
	char = $r
		ifTrue: [ ^ Character cr ].
	char = $t
		ifTrue: [ ^ Character tab ].
	char = $u
		ifTrue: [ ^ self parseCharacterHex ].
	self error: 'invalid escape character \' , (String with: char)!

parseCharacterHex
	| value |
	value := self parseCharacterHexDigit.
	3 timesRepeat: [ value := (value << 4) + self parseCharacterHexDigit ].
	^ Character codePoint: value!

parseCharacterHexDigit
	| digit |
	stream atEnd ifFalse: 
		[ digit := stream next greaseInteger.
		(digit 
			between: 48
			and: 57) ifTrue: 
			[ "$0"
			"$9"
			^ digit - 48 ].
		(digit 
			between: 65
			and: 70) ifTrue: 
			[ "$A"
			"$F"
			^ digit - 55 ].
		(digit 
			between: 97
			and: 102) ifTrue: 
			[ "$a"
			"$f"
			^ digit - 87 ] ].
	self error: 'hex-digit expected'!

parseNumber
	| negated number |
	negated := stream peek = $-.
	negated ifTrue: [ stream next ].
	number := self parseNumberInteger.
	(stream peek = $.) ifTrue: [
		stream next. 
		number := number + self parseNumberFraction ].
	(stream peek = $e or: [ stream peek = $E ]) ifTrue: [
		stream next.
		number := number * self parseNumberExponent ].
	negated ifTrue: [ number := number negated ].
	^ self whitespace; createNumber: number!

parseNumberExponent
	| number negated |
	number := 0.
	negated := stream peek = $-.
	(negated or: [ stream peek = $+ ]) ifTrue: [ stream next ].
	[ stream atEnd not and: [ stream peek isDigit ] ] whileTrue: [ number := 10 * number + (stream next greaseInteger - 48) ].
	negated ifTrue: [ number := number negated ].
	^ 10 raisedTo: number!

parseNumberFraction
	| number power |
	number := 0.
	power := 1.0.
	[ stream atEnd not and: [ stream peek isDigit ] ] whileTrue: 
		[ number := 10 * number + (stream next greaseInteger - 48).
		power := power * 10.0 ].
	^ number / power!

parseNumberInteger
	| number |
	number := 0.
	[ stream atEnd not and: [ stream peek isDigit ] ] whileTrue: [ number := 10 * number + (stream next greaseInteger - 48) ].
	^ number!

parseObject
	| result |
	self expect: '{'.
	result := self createObject.
	(self match: '}')
		ifTrue: [ ^ result ].
	[ stream atEnd ] whileFalse: [
		result := self
			addProperty: self parseProperty
			to: result.
		(self match: '}')
			ifTrue: [ ^ result ].
		self expect: ',' ].
	self error: 'end of object expected'!

parseProperty
	| name value |
	name := self parseString.
	self expect: ':'.
	value := self parseValue.
	^ self createProperty: name with: value.!

parseString
	| result |
	self expect: '"'.
	result := WriteStream on: String new.
	[ stream atEnd or: [ stream peek = $" ] ] 
		whileFalse: [ result nextPut: self parseCharacter ].
	^ self expect: '"'; createString: result contents!

parseValue
	| char |
	stream atEnd ifFalse: [ 
		char := stream peek.
		char = ${
			ifTrue: [ ^ self parseObject ].
		char = $[
			ifTrue: [ ^ self parseArray ].
		char = $"
			ifTrue: [ ^ self parseString ].
		(char = $- or: [ char between: $0 and: $9 ])
			ifTrue: [ ^ self parseNumber ].
		(self match: 'true')
			ifTrue: [ ^ self createTrue ].
		(self match: 'false')
			ifTrue: [ ^ self createFalse ].
		(self match: 'null')
			ifTrue: [ ^ self createNull ] ].
	self error: 'invalid input'!

whitespace
	"Strip whitespaces from the input stream."

	[ stream atEnd not and: [ stream peek isSeparator ] ]
		whileTrue: [ stream next ]! !
!JSJsonParser categoriesFor: #addProperty:to:!adding!public! !
!JSJsonParser categoriesFor: #addValue:to:!adding!public! !
!JSJsonParser categoriesFor: #createArray!creating!public! !
!JSJsonParser categoriesFor: #createFalse!creating!public! !
!JSJsonParser categoriesFor: #createNull!creating!public! !
!JSJsonParser categoriesFor: #createNumber:!creating!public! !
!JSJsonParser categoriesFor: #createObject!creating!public! !
!JSJsonParser categoriesFor: #createProperty:with:!creating!public! !
!JSJsonParser categoriesFor: #createString:!creating!public! !
!JSJsonParser categoriesFor: #createTrue!creating!public! !
!JSJsonParser categoriesFor: #error:!private! !
!JSJsonParser categoriesFor: #expect:!private! !
!JSJsonParser categoriesFor: #initializeOn:!initialization!public! !
!JSJsonParser categoriesFor: #match:!private! !
!JSJsonParser categoriesFor: #parse!parsing!public! !
!JSJsonParser categoriesFor: #parseArray!parsing!public! !
!JSJsonParser categoriesFor: #parseCharacter!parsing-internal!public! !
!JSJsonParser categoriesFor: #parseCharacterHex!parsing-internal!public! !
!JSJsonParser categoriesFor: #parseCharacterHexDigit!parsing-internal!public! !
!JSJsonParser categoriesFor: #parseNumber!parsing-internal!public! !
!JSJsonParser categoriesFor: #parseNumberExponent!parsing-internal!public! !
!JSJsonParser categoriesFor: #parseNumberFraction!parsing-internal!public! !
!JSJsonParser categoriesFor: #parseNumberInteger!parsing-internal!public! !
!JSJsonParser categoriesFor: #parseObject!parsing!public! !
!JSJsonParser categoriesFor: #parseProperty!parsing-internal!public! !
!JSJsonParser categoriesFor: #parseString!parsing-internal!public! !
!JSJsonParser categoriesFor: #parseValue!parsing!public! !
!JSJsonParser categoriesFor: #whitespace!private! !

!JSJsonParser class methodsFor!

new
	self error: 'Instantiate the parser with a stream.'!

on: aStream
	^ self basicNew initializeOn: aStream!

parse: aString
	^ self parseStream: aString readStream!

parseStream: aStream
	^ (self on: aStream) parse! !
!JSJsonParser class categoriesFor: #new!instance creation!public! !
!JSJsonParser class categoriesFor: #on:!instance creation!public! !
!JSJsonParser class categoriesFor: #parse:!accessing!public! !
!JSJsonParser class categoriesFor: #parseStream:!accessing!public! !

JSObject guid: (GUID fromString: '{B3B443C8-752B-4D4F-B59A-D606B2219AC0}')!
JSObject comment: '
I represent the abstract root of all JavaScript objects in the Smalltalk world. My subclasses provide accessors and action methods to configure instances of myself and implement the method #javascriptContentOn: to emit valid JavaScript code for my presentation.

Instance Variables
	decoration:			<JSObject|JSDecoration>
	renderContext:		<WARenderContext>
	rendererClass:		<WARenderer>'!
!JSObject categoriesForClass!Unclassified! !
!JSObject methodsFor!

& anObject 
	"Combine the receiver and anObject with a logical AND."
	
	self addDecoration: (JSBinary new operator: '&&'; statement: anObject)!

, anObject 
	"Concatenate the receiver with anObject."

	self addDecoration: (JSConcatenation on: anObject)!

| anObject 
	"Combine the receiver and anObject with a logical OR."
	
	self addDecoration: (JSBinary new operator: '||'; statement: anObject)!

access: aString 
	"Access the member aString."
	
	self addDecoration: (JSAccess named: aString)!

addDecoration: aDecoration
	"Add a new decoration to the receiver."

	aDecoration setOwner: decoration.
	decoration := aDecoration!

alias: aString 
	"Uses aString as an alias for the receiver."
	
	self addDecoration: (JSAlias named: aString)!

apply: aCollection 
	"Apply aCollection of arguments."
	
	self addDecoration: (JSApply new arguments: aCollection)!

assign: anObject 
	"Assign anObject to the receiver."
	
	self addDecoration: (JSAssignment new object: anObject)!

assignLocalTo: aString 
	"Assign the receiver to a local variable aString."
	
	self addDecoration: (JSAssignLocal named: aString)!

assignTo: aString 
	"Assign the receiver to a global variable aString."
	
	self addDecoration: (JSAssign named: aString)!

call: aString
	"Call the method named aString."

	self call: aString withArguments: #()!

call: aString argument: anObject 
	"Call the method named aString with anObject as its argument."
	
	self greaseDeprecatedApi: 'JSObject>>#call:argument:' details: 'Use #call:with:.'.
	self call: aString with: anObject!

call: aString arguments: anArray 
	"Call the method named aString with aCollection as its arguments."

	self greaseDeprecatedApi: 'JSObject>>#call:arguments:' details: 'Use #call:withArguments:.'.
	self call: aString withArguments: anArray!

call: aString with: anObject
	"Call the method named aString with anObject as its argument."

	self call: aString withArguments: (Array with: anObject)!

call: aString with: anObject1 with: anObject2
	"Call the method named aString with anObject1 and anObject2 as its arguments."

	self call: aString withArguments: (Array with: anObject1 with: anObject2)!

call: aString with: anObject1 with: anObject2 with: anObject3
	"Call the method named aString with anObject1 and anObject2 and anObject3 as its arguments."

	self call: aString withArguments: (Array with: anObject1 with: anObject2 with: anObject3)!

call: aString withArguments: anArray
	"Call the method named aString with anArray as arguments."

	self addDecoration: (JSCall new 
		name: aString;
		arguments: anArray;
		yourself)!

condition: anObject 
	"Treat anObject as a condition to the execution of the receiver."
	
	self addDecoration: (JSCondition on: anObject)!

confirm: anObject 
	"Show a confirmation with the message anObject before evaluating the receiver."
	
	self condition: (JSStream new
		nextPutAll: 'confirm';
		argument: anObject)!

create
	"Instantiate the receiver."
	
	self addDecoration: JSCreate new!

decoration
	"Answer the top-level decoration in the receivers decoration stack."

	^ decoration!

greaseString
	^ String streamContents: [ :stream | stream javascript: self ]!

initialize
	super initialize.
	decoration := self!

interval: aDuration
	"Execute the receiver every aDuration."

	self addDecoration: (JSInterval duration: aDuration)!

isJavascript
	^ true!

javascriptContentOn: aStream
	"Generate the JavaScript string of the receiver. Override this method in subclasses to define custom JavaScript code. Note, if you run into this method, you likely use old Seaside code need to rename #printContentOn: to #javascriptContentOn:."
	
	self subclassResponsibility!

javascriptOn: aStream
	"Generate the JavaScript code from the receiver by dispatching to the outermost surrounding decoration. Do not override this method, instead override #javascriptContentOn:."

	self decoration javascriptContentOn: aStream!

not
	"Negate the receiver logically."
	
	self addDecoration: JSNegation new!

printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' ('; javascript: self; nextPut: $)!

property: aString 
	"Treat anObject as a condition to the execution of the receiver."
	
	self addDecoration: (JSProperty named: aString)!

render: aRenderable
	"Render aRenderable and answer the resulting string."
	
	^ String streamContents: [ :stream | self render: aRenderable on: stream ]!

render: aRenderable on: aStream
	"Render aRenderable on aStream."
	
	| document |
	document := WAHtmlDocument
		on: aStream
		codec: self requestContext codec.
	self renderContext document: document during: [
		(self rendererClass context: self renderContext)
			render: aRenderable; flush ].
	document scriptGenerator closeOn: document!

renderContext
	"Answer the current RenderContext."

	^ renderContext!

rendererClass
	"Answer the class that should be used when rendering objects."

	^ rendererClass ifNil: [ rendererClass := WARenderer default ]!

rendererClass: aRendererClass
	"Specify the class that should be used when rendering objects."

	rendererClass := aRendererClass!

return: anObject 
	"Return anObject after evaluating the receiver."
	
	self , (JSStream new
		nextPutAll: 'return ';
		javascript: anObject)!

script: aBlock
	"Evaluate aBlock and answer the string of the generated script."
	
	^ String streamContents: [ :stream | self script: aBlock on: stream ]!

script: aBlock on: aStream
	"Evaluate aBlock and pass in a script object that is subsequently written to aStream."

	| script document |
	document := WAHtmlDocument
		on: aStream
		codec: self requestContext codec.
	self renderContext document: document during: [ 
		script := (JSScript context: self renderContext)
			rendererClass: self rendererClass;
			yourself.
		aBlock value: script.
		script addAll: document loadScripts ].
	script javascriptOn: aStream!

setContext: aRenderContext
	renderContext := aRenderContext!

then: anObject
	"Evaluates anObject if the receiver treated as a boolean evaluates to true."

	self then: anObject else: nil!

then: anObject else: anotherObject 
	"Evaluates anObject if the receiver treated as a boolean evaluates to true, otherwise evaluate anotherObject."
	
	self addDecoration: (JSIfThenElse new
		trueStatement: anObject;
		falseStatement: anotherObject)!

timeout: aDuration 
	"Evaluates the receiver after aDuration."
	
	self addDecoration: (JSTimeout duration: aDuration)! !
!JSObject categoriesFor: #&!decorations!public! !
!JSObject categoriesFor: #,!convenience!public! !
!JSObject categoriesFor: #|!decorations!public! !
!JSObject categoriesFor: #access:!decorations!public! !
!JSObject categoriesFor: #addDecoration:!adding!public! !
!JSObject categoriesFor: #alias:!decorations!public! !
!JSObject categoriesFor: #apply:!decorations!public! !
!JSObject categoriesFor: #assign:!decorations!public! !
!JSObject categoriesFor: #assignLocalTo:!decorations!public! !
!JSObject categoriesFor: #assignTo:!decorations!public! !
!JSObject categoriesFor: #call:!decorations!public! !
!JSObject categoriesFor: #call:argument:!public! !
!JSObject categoriesFor: #call:arguments:!public! !
!JSObject categoriesFor: #call:with:!decorations!public! !
!JSObject categoriesFor: #call:with:with:!decorations!public! !
!JSObject categoriesFor: #call:with:with:with:!decorations!public! !
!JSObject categoriesFor: #call:withArguments:!decorations!public! !
!JSObject categoriesFor: #condition:!decorations!public! !
!JSObject categoriesFor: #confirm:!convenience!public! !
!JSObject categoriesFor: #create!decorations!public! !
!JSObject categoriesFor: #decoration!accessing!public! !
!JSObject categoriesFor: #greaseString!printing!public! !
!JSObject categoriesFor: #initialize!initialization!public! !
!JSObject categoriesFor: #interval:!decorations!public! !
!JSObject categoriesFor: #isJavascript!public!testing! !
!JSObject categoriesFor: #javascriptContentOn:!printing!public! !
!JSObject categoriesFor: #javascriptOn:!printing!public! !
!JSObject categoriesFor: #not!decorations!public! !
!JSObject categoriesFor: #printOn:!printing!public! !
!JSObject categoriesFor: #property:!decorations!public! !
!JSObject categoriesFor: #render:!public!utilities! !
!JSObject categoriesFor: #render:on:!public!utilities! !
!JSObject categoriesFor: #renderContext!accessing!public! !
!JSObject categoriesFor: #rendererClass!accessing!public! !
!JSObject categoriesFor: #rendererClass:!accessing!public! !
!JSObject categoriesFor: #return:!convenience!public! !
!JSObject categoriesFor: #script:!public!utilities! !
!JSObject categoriesFor: #script:on:!public!utilities! !
!JSObject categoriesFor: #setContext:!initialization!public! !
!JSObject categoriesFor: #then:!decorations!public! !
!JSObject categoriesFor: #then:else:!decorations!public! !
!JSObject categoriesFor: #timeout:!decorations!public! !

!JSObject class methodsFor!

context: aRenderContext
	^ self new setContext: aRenderContext; yourself! !
!JSObject class categoriesFor: #context:!instance creation!public! !

JSApply guid: (GUID fromString: '{EAFCB56F-6416-48A4-ADA9-477E3AC8AE38}')!
JSApply comment: 'I apply a JavaScript function and provide arguments.'!
!JSApply categoriesForClass!Unclassified! !
!JSApply methodsFor!

arguments
	^ arguments!

arguments: aCollection
	arguments := aCollection!

javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	JSStream encodeArguments: self arguments on: aStream! !
!JSApply categoriesFor: #arguments!accessing!public! !
!JSApply categoriesFor: #arguments:!accessing!public! !
!JSApply categoriesFor: #javascriptContentOn:!printing!public! !

JSAssignment guid: (GUID fromString: '{4B3DC096-7E02-4D8E-ADFF-A2A0B2C0B59C}')!
JSAssignment comment: 'I represent an assignment ot the decorated object.'!
!JSAssignment categoriesForClass!Unclassified! !
!JSAssignment methodsFor!

javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	aStream
		nextPutAll: '=';
		javascript: self object!

object
	^ object!

object: anObject
	object := anObject! !
!JSAssignment categoriesFor: #javascriptContentOn:!printing!public! !
!JSAssignment categoriesFor: #object!accessing!public! !
!JSAssignment categoriesFor: #object:!accessing!public! !

JSCall guid: (GUID fromString: '{D12A15ED-0914-4225-95C5-6484898704F3}')!
JSCall comment: 'I represent a function call or method invokation to the decorated object.'!
!JSCall categoriesForClass!Unclassified! !
!JSCall methodsFor!

arguments
	^ arguments!

arguments: anArray 
	arguments := anArray!

javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	(self name isNil or: [ self name isEmpty ]) ifFalse:
			[ aStream
				nextPut: $.;
				nextPutAll: self name ].
	JSStream encodeArguments: self arguments on: aStream!

name
	^ name!

name: aString 
	name := aString! !
!JSCall categoriesFor: #arguments!accessing!public! !
!JSCall categoriesFor: #arguments:!accessing!public! !
!JSCall categoriesFor: #javascriptContentOn:!printing!public! !
!JSCall categoriesFor: #name!accessing!public! !
!JSCall categoriesFor: #name:!accessing!public! !

JSCreate guid: (GUID fromString: '{1D33F654-EEC9-4550-975B-50774B87CDD9}')!
JSCreate comment: 'I instantiate the decorated object.'!
!JSCreate categoriesForClass!Unclassified! !
!JSCreate methodsFor!

javascriptContentOn: aStream
	aStream nextPutAll: 'new '.
	super javascriptContentOn: aStream! !
!JSCreate categoriesFor: #javascriptContentOn:!printing!public! !

JSIfThenElse guid: (GUID fromString: '{6E4DE09A-B2D3-4F3F-8AC8-29F0BC6F2D3F}')!
JSIfThenElse comment: 'I execute different code snippets depending if the receiver is true (defined) or false (null).'!
!JSIfThenElse categoriesForClass!Unclassified! !
!JSIfThenElse methodsFor!

falseStatement
	^ falseStatement!

falseStatement: anObject
	falseStatement := anObject!

javascriptContentOn: aStream
	aStream nextPut: $(.
	super javascriptContentOn: aStream.
	aStream nextPut: $?.
	aStream javascript: self trueStatement.
	aStream nextPut: $:.
	aStream javascript: self falseStatement.
	aStream nextPut: $)!

trueStatement
	^ trueStatement!

trueStatement: anObject
	trueStatement := anObject! !
!JSIfThenElse categoriesFor: #falseStatement!accessing!public! !
!JSIfThenElse categoriesFor: #falseStatement:!accessing!public! !
!JSIfThenElse categoriesFor: #javascriptContentOn:!printing!public! !
!JSIfThenElse categoriesFor: #trueStatement!accessing!public! !
!JSIfThenElse categoriesFor: #trueStatement:!accessing!public! !

JSMember guid: (GUID fromString: '{33CA969C-AC0D-4984-9CBE-4A5E1CE76BBD}')!
JSMember comment: ''!
!JSMember categoriesForClass!Unclassified! !
!JSMember methodsFor!

name
	^ name!

name: aString
	name := aString! !
!JSMember categoriesFor: #name!accessing!public! !
!JSMember categoriesFor: #name:!accessing!public! !

!JSMember class methodsFor!

named: anObject
	^ self new name: anObject! !
!JSMember class categoriesFor: #named:!instance creation!public! !

JSNegation guid: (GUID fromString: '{67CB7460-14D7-4F7A-9480-B260556B4712}')!
JSNegation comment: 'I negate the decorated object and yield a boolean value.'!
!JSNegation categoriesForClass!Unclassified! !
!JSNegation methodsFor!

javascriptContentOn: aStream
	aStream nextPut: $!!.
	super javascriptContentOn: aStream! !
!JSNegation categoriesFor: #javascriptContentOn:!printing!public! !

JSStatement guid: (GUID fromString: '{4BCD85D5-38EA-457A-8BFF-BFD034DF0236}')!
JSStatement comment: ''!
!JSStatement categoriesForClass!Unclassified! !
!JSStatement methodsFor!

statement
	^ statement!

statement: anObject
	statement := anObject! !
!JSStatement categoriesFor: #statement!accessing!public! !
!JSStatement categoriesFor: #statement:!accessing!public! !

!JSStatement class methodsFor!

on: anObject
	^ self new statement: anObject! !
!JSStatement class categoriesFor: #on:!instance creation!public! !

JSTimed guid: (GUID fromString: '{7DEFA831-E62A-494E-91BC-5102162B96DA}')!
JSTimed comment: ''!
!JSTimed categoriesForClass!Unclassified! !
!JSTimed methodsFor!

duration
	^ duration!

duration: aDuration
	duration := aDuration! !
!JSTimed categoriesFor: #duration!accessing!public! !
!JSTimed categoriesFor: #duration:!accessing!public! !

!JSTimed class methodsFor!

duration: aDuration
	^ self new duration: aDuration! !
!JSTimed class categoriesFor: #duration:!instance creation!public! !

JSAccess guid: (GUID fromString: '{AB41597E-2EF1-42B9-B3D5-C8D81B989B04}')!
JSAccess comment: 'I access a member of the decorated object.'!
!JSAccess categoriesForClass!Unclassified! !
!JSAccess methodsFor!

javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	aStream
		nextPut: $.;
		nextPutAll: self name! !
!JSAccess categoriesFor: #javascriptContentOn:!printing!public! !

JSAlias guid: (GUID fromString: '{1185E231-7B6D-416A-8214-1B57091F9D2A}')!
JSAlias comment: 'I alias the decorated object with a name.'!
!JSAlias categoriesForClass!Unclassified! !
!JSAlias methodsFor!

javascriptContentOn: aStream
	aStream nextPutAll: self name! !
!JSAlias categoriesFor: #javascriptContentOn:!printing!public! !

JSAssign guid: (GUID fromString: '{138FC7AB-D6E4-4A5C-B89C-99FFF1F4AF3D}')!
JSAssign comment: 'I assign the decorated object to a global variable.'!
!JSAssign categoriesForClass!Unclassified! !
!JSAssign methodsFor!

javascriptContentOn: aStream
	aStream
		nextPutAll: self name;
		nextPut: $=.
	super javascriptContentOn: aStream! !
!JSAssign categoriesFor: #javascriptContentOn:!printing!public! !

JSProperty guid: (GUID fromString: '{70FD2F78-F50E-43E2-99B6-7E377B8A9081}')!
JSProperty comment: 'I access a property of the decoarated object.'!
!JSProperty categoriesForClass!Unclassified! !
!JSProperty methodsFor!

javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	aStream
		nextPut: $[;
		javascript: self name;
		nextPut: $]! !
!JSProperty categoriesFor: #javascriptContentOn:!printing!public! !

JSAssignLocal guid: (GUID fromString: '{49EA4B67-32E4-4DF0-9737-4CB8B0785414}')!
JSAssignLocal comment: 'I assign the decorated object to a local variable.'!
!JSAssignLocal categoriesForClass!Unclassified! !
!JSAssignLocal methodsFor!

javascriptContentOn: aStream
	aStream nextPutAll: 'var '.
	super javascriptContentOn: aStream! !
!JSAssignLocal categoriesFor: #javascriptContentOn:!printing!public! !

JSBinary guid: (GUID fromString: '{25F485DD-2222-4C25-927F-843A09F760E2}')!
JSBinary comment: 'I join the decorated object with a binary operator.'!
!JSBinary categoriesForClass!Unclassified! !
!JSBinary methodsFor!

javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	aStream
		nextPutAll: self operator;
		javascript: self statement!

operator
	^ operator!

operator: aString
	operator := aString! !
!JSBinary categoriesFor: #javascriptContentOn:!printing!public! !
!JSBinary categoriesFor: #operator!accessing!public! !
!JSBinary categoriesFor: #operator:!accessing!public! !

JSConcatenation guid: (GUID fromString: '{EC23354A-0E8B-4A92-86A4-ED419E438677}')!
JSConcatenation comment: 'I represent a sequence (or concatenation) of a decorated object and another object.'!
!JSConcatenation categoriesForClass!Unclassified! !
!JSConcatenation methodsFor!

javascriptContentOn: aStream
	super javascriptContentOn: aStream.
	aStream
		nextPut: $;;
		javascript: self statement! !
!JSConcatenation categoriesFor: #javascriptContentOn:!printing!public! !

JSCondition guid: (GUID fromString: '{67429C79-8786-4BBA-9171-E340646A8E95}')!
JSCondition comment: 'I wrap the decorated object into a conditional statement.'!
!JSCondition categoriesForClass!Unclassified! !
!JSCondition methodsFor!

javascriptContentOn: aStream
	aStream
		nextPutAll: 'if(';
		javascript: self statement;
		nextPutAll: '){'.
	super javascriptContentOn: aStream.
	aStream nextPut: $}! !
!JSCondition categoriesFor: #javascriptContentOn:!printing!public! !

JSInterval guid: (GUID fromString: '{571D18AE-90FE-4A8C-96F4-85E6E1E393DB}')!
JSInterval comment: 'I periodically execute the decorated object.'!
!JSInterval categoriesForClass!Unclassified! !
!JSInterval methodsFor!

javascriptContentOn: aStream
	aStream nextPutAll: 'setInterval(function(){'.
	super javascriptContentOn: aStream.
	aStream
		nextPutAll: '},';
		javascript: self duration;
		nextPut: $)! !
!JSInterval categoriesFor: #javascriptContentOn:!printing!public! !

JSTimeout guid: (GUID fromString: '{E0AD3A7E-8F67-4295-9BBB-1393C0286BCD}')!
JSTimeout comment: 'I evaluate the decorated object after a timeout.'!
!JSTimeout categoriesForClass!Unclassified! !
!JSTimeout methodsFor!

javascriptContentOn: aStream
	aStream nextPutAll: 'setTimeout(function(){'.
	super javascriptContentOn: aStream.
	aStream
		nextPutAll: '},';
		javascript: self duration;
		nextPut: $)! !
!JSTimeout categoriesFor: #javascriptContentOn:!printing!public! !

JSJoin guid: (GUID fromString: '{467B3AFA-C3FD-40A5-B07E-BC3E7152B7CF}')!
JSJoin comment: 'I join a collection of JavaScript statements with the given string.'!
!JSJoin categoriesForClass!Unclassified! !
!JSJoin methodsFor!

collection
	^ collection!

encodeElement: anObject on: aDocument
	"We assume that the element is already URL encoded if this is not an association."

	(anObject isKindOf: Association)
		ifTrue: [
			aDocument nextPut: $".
			aDocument urlEncoder
				nextPutAll: anObject key greaseString.
			anObject value isNil 
				ifTrue: [ aDocument nextPut: $" ]
				ifFalse: [
					aDocument nextPut: $=.
					(anObject value isString or: [ anObject value isCharacter ])
						ifTrue: [
							aDocument urlEncoder 
								nextPutAll: anObject value greaseString.
							aDocument nextPut: $" ]
						ifFalse: [
							aDocument nextPutAll: '"+encodeURIComponent('.
							aDocument stream javascript: anObject value.
							aDocument nextPut: $) ] ] ]
		ifFalse: [ aDocument stream javascript: anObject ]!

encodeEmptyOn: aDocument
	aDocument nextPutAll: '""'!

encodeOn: aDocument
	self collection isEmpty
		ifTrue: [ ^ self encodeEmptyOn: aDocument ].
	self collection size = 1
		ifTrue: [ ^ self encodeElement: self collection first on: aDocument ].
	aDocument nextPut: $[.
	self collection
		do: [ :each | self encodeElement: each on: aDocument ]
		separatedBy: [ aDocument nextPut: $, ].
	aDocument nextPutAll: '].join("&")'!

initializeOn: aCollection
	self initialize.
	collection := aCollection!

javascriptContentOn: aStream
	| document codec |
	codec := [ self requestContext codec ] 
		on: WARequestContextNotFound
		do: [ :e | GRNullCodec new ].
	document := WAUnescapedDocument 
		on: aStream
		codec: codec.
	self encodeOn: document! !
!JSJoin categoriesFor: #collection!accessing!public! !
!JSJoin categoriesFor: #encodeElement:on:!encoding!public! !
!JSJoin categoriesFor: #encodeEmptyOn:!encoding!public! !
!JSJoin categoriesFor: #encodeOn:!encoding!public! !
!JSJoin categoriesFor: #initializeOn:!initialization!public! !
!JSJoin categoriesFor: #javascriptContentOn:!printing!public! !

!JSJoin class methodsFor!

new
	^ self on: OrderedCollection new!

on: aCollection
	^ self basicNew initializeOn: aCollection! !
!JSJoin class categoriesFor: #new!instance creation!public! !
!JSJoin class categoriesFor: #on:!instance creation!public! !

JSJson guid: (GUID fromString: '{CCD3D88F-3DEC-497C-9634-ABFE5C91B796}')!
JSJson comment: 'I represent the JSON object (www.json.org) that is supported by most modern web browsers. For older browsers I require JSJsonDeploymentLibrary or JSJsonDevelopmentLibrary to be included.'!
!JSJson categoriesForClass!Unclassified! !
!JSJson methodsFor!

javascriptContentOn: aStream
	aStream nextPutAll: 'JSON'!

parse: aString
	"This method parses a JSON text to produce an object or array."

	self call: 'parse' with: aString!

parse: aString reviver: aFunction 
	"This method parses a JSON text to produce an object or array. The optional reviver parameter is a function that can filter and transform the results. It receives each of the keys and values, and its return value is used instead of the original value. If it returns what it received, then the structure is not modified. If it returns undefined then the member is deleted."

	self call: 'parse' with: aString with: aFunction asFunction!

stringify: anObject
	"Serialize anObject as a JSON string."

	self call: 'stringify' with: anObject!

stringify: anObject replacer: aReplacer
	"Serialize anObject as a JSON string. aReplacer is an optional parameter that determines how object values are stringified for objects. It can be a function or an array of strings."

	self call: 'stringify' with: anObject with: aReplacer!

stringify: anObject replacer: aReplacer space: aSpace
	"Serialize anObject as a JSON string. aReplacer is an optional parameter that determines how object values are stringified for objects. It can be a function or an array of strings. aSpace is an optional parameter that specifies the indentation of nested structures. If it is omitted, the text will be packed without extra whitespace."

	self call: 'stringify' with: anObject with: aReplacer with: aSpace!

stringify: anObject space: aSpace
	"Serialize anObject as a JSON string. aSpace is an optional parameter that specifies the indentation of nested structures. If it is omitted, the text will be packed without extra whitespace."

	self call: 'stringify' with: anObject with: aSpace! !
!JSJson categoriesFor: #javascriptContentOn:!printing!public! !
!JSJson categoriesFor: #parse:!accessing!public! !
!JSJson categoriesFor: #parse:reviver:!accessing!public! !
!JSJson categoriesFor: #stringify:!accessing!public! !
!JSJson categoriesFor: #stringify:replacer:!accessing!public! !
!JSJson categoriesFor: #stringify:replacer:space:!accessing!public! !
!JSJson categoriesFor: #stringify:space:!accessing!public! !

JSLogger guid: (GUID fromString: '{EE9D9FC3-DEE9-4924-A9C4-31218995AD8C}')!
JSLogger comment: 'I am a logger class to be used together with FireBug. I have nothing to do with Scriptaculous directly, but I nicely fit in here as everybody should be using FireBug for Script debugging anyway.'!
!JSLogger categoriesForClass!Unclassified! !
!JSLogger methodsFor!

assert: anObject 
	self 
		call: 'assert'
		with: anObject!

assert: anObject equals: anotherObject 
	self 
		call: 'assertEquals'
		with: anObject
		with: anotherObject!

assert: anObject greater: anotherObject 
	self 
		call: 'assertGreater'
		with: anObject
		with: anotherObject!

assert: anObject less: anotherObject 
	self 
		call: 'assertLess'
		with: anObject
		with: anotherObject!

assert: anObject notEquals: anotherObject 
	self 
		call: 'assertNotEquals'
		with: anObject
		with: anotherObject!

assert: anObject notGreater: anotherObject 
	self 
		call: 'assertNotGreater'
		with: anObject
		with: anotherObject!

assert: anObject notLess: anotherObject 
	self 
		call: 'assertNotLess'
		with: anObject
		with: anotherObject!

assertFalse: anObject 
	self 
		call: 'assertFalse'
		with: anObject!

assertNotNull: anObject 
	self 
		call: 'assertNotNull'
		with: anObject!

assertNotUndefined: anObject 
	self 
		call: 'assertNotUndefined'
		with: anObject!

assertNull: anObject 
	self 
		call: 'assertNull'
		with: anObject!

assertTrue: anObject 
	self 
		call: 'assertTrue'
		with: anObject!

assertUndefined: anObject 
	self 
		call: 'assertUndefined'
		with: anObject!

debug: anObject 
	self 
		call: 'debug'
		with: anObject!

error: anObject 
	self 
		call: 'error'
		with: anObject!

info: anObject 
	self 
		call: 'info'
		with: anObject!

javascriptContentOn: aStream
	aStream nextPutAll: 'console'!

log: anObject 
	self 
		call: 'log'
		with: anObject!

log: anObject format: anArray 
	self 
		call: 'log'
		withArguments: (Array with: anObject) , anArray!

warn: anObject 
	self 
		call: 'warn'
		with: anObject! !
!JSLogger categoriesFor: #assert:!assertions!public! !
!JSLogger categoriesFor: #assert:equals:!assertions!public! !
!JSLogger categoriesFor: #assert:greater:!assertions!public! !
!JSLogger categoriesFor: #assert:less:!assertions!public! !
!JSLogger categoriesFor: #assert:notEquals:!assertions!public! !
!JSLogger categoriesFor: #assert:notGreater:!assertions!public! !
!JSLogger categoriesFor: #assert:notLess:!assertions!public! !
!JSLogger categoriesFor: #assertFalse:!assertions!public! !
!JSLogger categoriesFor: #assertNotNull:!assertions!public! !
!JSLogger categoriesFor: #assertNotUndefined:!assertions!public! !
!JSLogger categoriesFor: #assertNull:!assertions!public! !
!JSLogger categoriesFor: #assertTrue:!assertions!public! !
!JSLogger categoriesFor: #assertUndefined:!assertions!public! !
!JSLogger categoriesFor: #debug:!messages!public! !
!JSLogger categoriesFor: #error:!messages!public! !
!JSLogger categoriesFor: #info:!messages!public! !
!JSLogger categoriesFor: #javascriptContentOn:!printing!public! !
!JSLogger categoriesFor: #log:!logging!public! !
!JSLogger categoriesFor: #log:format:!logging!public! !
!JSLogger categoriesFor: #warn:!messages!public! !

JSScript guid: (GUID fromString: '{081EC05C-8040-477D-8312-B778B69E4867}')!
JSScript comment: 'I represent a sequence of JavaScript statements.'!
!JSScript categoriesForClass!Unclassified! !
!JSScript methodsFor!

, anObject
	self add: anObject!

<< anObject
	^ self add: anObject!

add: anObject
	^ statements add: anObject!

addAll: aCollection
	^ statements addAll: aCollection!

alert: anObject 
	self add: (JSStream new
		nextPutAll: 'alert';
		argument: anObject;
		yourself)!

callback: aBlock
	self goto: (self renderContext actionUrl
		withField: (self renderContext callbacks store: (WAActionCallback on: aBlock)))!

goto: aUrl 
	self add: (JSStream new
		nextPutAll: 'window.location=';
		javascript: aUrl)!

initialize
	super initialize.
	statements := OrderedCollection new!

javascript
	^ (JSScript context: self renderContext)
		rendererClass: self rendererClass;
		yourself!

javascriptContentOn: aStream
	statements do: [ :each | aStream javascript: each ] separatedBy: [ aStream nextPut: $; ]!

logger
	^ self add: ((JSLogger context: self renderContext)
		rendererClass: self rendererClass;
		yourself)!

refresh
	self goto: self renderContext actionUrl! !
!JSScript categoriesFor: #,!adding!public! !
!JSScript categoriesFor: #<<!adding!public! !
!JSScript categoriesFor: #add:!adding!public! !
!JSScript categoriesFor: #addAll:!adding!public! !
!JSScript categoriesFor: #alert:!convenience!public! !
!JSScript categoriesFor: #callback:!convenience!public! !
!JSScript categoriesFor: #goto:!convenience!public! !
!JSScript categoriesFor: #initialize!initialization!public! !
!JSScript categoriesFor: #javascript!convenience!public! !
!JSScript categoriesFor: #javascriptContentOn:!printing!public! !
!JSScript categoriesFor: #logger!convenience!public! !
!JSScript categoriesFor: #refresh!convenience!public! !

JSStream guid: (GUID fromString: '{1949E127-C02A-4566-B64F-41786D5146D6}')!
JSStream comment: 'I represent a verbatim JavaScript string. I support streaming facilities to efficiently encode JavaScript input.'!
!JSStream categoriesForClass!Unclassified! !
!JSStream methodsFor!

argument: anObject
	"Write a single argument anObject onto the receiving stream."

	self arguments: (Array with: anObject)!

arguments: aCollection
	"Write aCollection of arguments onto the stream."

	self class encodeArguments: aCollection on: self!

contents
	^ self stream contents!

copy
	^ self class on: self contents!

initialize
	super initialize.
	stream := WriteStream on: String new!

javascript: anObject
	self stream javascript: anObject!

javascriptContentOn: aStream
	aStream nextPutAll: self contents!

json: anObject
	self stream json: anObject!

nextPut: aCharacter
	self stream nextPut: aCharacter!

nextPutAll: aString
	self stream nextPutAll: aString!

stream
	^ stream! !
!JSStream categoriesFor: #argument:!convenience!public! !
!JSStream categoriesFor: #arguments:!convenience!public! !
!JSStream categoriesFor: #contents!accessing!public! !
!JSStream categoriesFor: #copy!copying!public! !
!JSStream categoriesFor: #initialize!initialization!public! !
!JSStream categoriesFor: #javascript:!public!streaming! !
!JSStream categoriesFor: #javascriptContentOn:!printing!public! !
!JSStream categoriesFor: #json:!public!streaming! !
!JSStream categoriesFor: #nextPut:!public!streaming! !
!JSStream categoriesFor: #nextPutAll:!public!streaming! !
!JSStream categoriesFor: #stream!accessing!public! !

!JSStream class methodsFor!

argument: anInteger
	^ (Arguments at: anInteger + 1) copy!

argumentAt: anInteger
	^ (Arguments at: anInteger) copy!

encodeArguments: aCollection on: aStream 
	"Writes aCollection of elements to aStream enclosed in round brakes and separated by a comma."
	
	aStream nextPut: $(.
	aCollection
		do: [ :each | aStream javascript: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $)!

encodeCollection: aCollection on: aStream
	"Writes aCollection of elements to aStream enclosed in square brakets."
	
	aStream nextPut: $[.
	aCollection
		do: [ :each | aStream javascript: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $]!

encodeDictionary: aDictionary on: aStream 
	"Dictionary or hash-maps common structures in JavaScript, try to optimize their serialization."
	
	| first |
	first := true.
	aStream nextPut: ${.
	aDictionary keysAndValuesDo: [ :key :value |
		first
			ifTrue: [ first := false ]
			ifFalse: [ aStream nextPut: $, ].
		self encodeKey: key value: value on: aStream ].
	aStream nextPut: $}!

encodeKey: aKey value: aValue on: aStream 
	"Key-value pairs are common structures in JavaScript."
	
	aStream javascript: aKey greaseString; nextPut: $:; javascript: aValue!

encodeString: aString on: aStream 
	"Strings have a complicated encoding in Javascript, try to optimize their serialization."
	
	| char value encoded last |
	aStream nextPut: $".
	1 to: aString size do: [ :index | 
		char := aString at: index.
		value := char greaseInteger.
		value < JavascriptCharacters size 
			ifFalse: [ aStream nextPut: char ]
			ifTrue: [
				encoded := JavascriptCharacters at: value + 1.
				encoded isString 
					ifTrue: [ aStream nextPutAll: encoded ]
					ifFalse: [
						"avoid that browsers mistakenly take the output as a closing tag"
						(last = $< and: [ char = $/ ])
							ifTrue: [ aStream nextPutAll: '\/' ]
							ifFalse: [ aStream nextPut: encoded ] ] ].
		last := char ].
	aStream nextPut: $"!

initialize
	self initializeEncoding.
	self initializeSnippets!

initializeEncoding
	| printer escapes |
	printer := GRNumberPrinter new.
	printer base: 16; padding: $0; digits: 2.
	JavascriptCharacters := Array new: 127.
	0 to: 31 do: [ :index | 
		JavascriptCharacters 
			at: index + 1
			put: '\x' , (printer print: index) ].
	32 to: 126 do: [ :index | 
		JavascriptCharacters 
			at: index + 1
			put: index asCharacter ].
	escapes := #( 0 '\0' 7 '\a' 8 '\b' 9 '\t' 10 '\n' 12 '\f' 13 '\r' 34 '\"' 92 '\\' ).
	1 to: escapes size - 1 by: 2 do: [ :index | 
		JavascriptCharacters 
			at: (escapes at: index) + 1
			put: (escapes at: index + 1) ]!

initializeSnippets
	This := self on: 'this'.
	Arguments := (0 to: 25)
		collect: [ :each | self on: 'arguments[' , each printString , ']' ]!

on: aString
	^ self new nextPutAll: aString!

this
	^ This copy! !
!JSStream class categoriesFor: #argument:!instance creation!public! !
!JSStream class categoriesFor: #argumentAt:!instance creation!public! !
!JSStream class categoriesFor: #encodeArguments:on:!encoding!public! !
!JSStream class categoriesFor: #encodeCollection:on:!encoding!public! !
!JSStream class categoriesFor: #encodeDictionary:on:!encoding!public! !
!JSStream class categoriesFor: #encodeKey:value:on:!encoding!public! !
!JSStream class categoriesFor: #encodeString:on:!encoding!public! !
!JSStream class categoriesFor: #initialize!initialization!public! !
!JSStream class categoriesFor: #initializeEncoding!initialization!public! !
!JSStream class categoriesFor: #initializeSnippets!initialization!public! !
!JSStream class categoriesFor: #on:!instance creation!public! !
!JSStream class categoriesFor: #this!instance creation!public! !

JSFunction guid: (GUID fromString: '{8A6F90F3-23CE-4853-9D10-4CFE8C43A19E}')!
JSFunction comment: 'I represent an anonymous JavaScript function.'!
!JSFunction categoriesForClass!Unclassified! !
!JSFunction methodsFor!

argument
	^ arguments!

arguments
	^ arguments!

arguments: aCollection
	arguments := aCollection!

asFunction
	^ self!

asFunction: aCollection
	self arguments: aCollection!

initialize
	super initialize.
	arguments := #()!

javascriptContentOn: aStream
	aStream nextPutAll: 'function('.
	self arguments do: [ :each | aStream nextPutAll: each ] separatedBy: [ aStream nextPut: $, ].
	aStream nextPutAll: '){'.
	statements isEmpty ifFalse:
			[ statements allButLast do:
					[ :each | 
					aStream
						javascript: each;
						nextPut: $; ].
			self return ifTrue: [ aStream nextPutAll: 'return ' ].
			aStream javascript: statements last ].
	aStream nextPut: $}!

return
	^ return ifNil: [ false ]!

return: aBoolean
	return := aBoolean! !
!JSFunction categoriesFor: #argument!accessing!public! !
!JSFunction categoriesFor: #arguments!accessing!public! !
!JSFunction categoriesFor: #arguments:!accessing!public! !
!JSFunction categoriesFor: #asFunction!converting!public! !
!JSFunction categoriesFor: #asFunction:!converting!public! !
!JSFunction categoriesFor: #initialize!initialization!public! !
!JSFunction categoriesFor: #javascriptContentOn:!printing!public! !
!JSFunction categoriesFor: #return!accessing!public! !
!JSFunction categoriesFor: #return:!accessing!public! !

JSAjaxCallback guid: (GUID fromString: '{9EF1ABAC-0789-410C-A6AB-4296E3203D3B}')!
JSAjaxCallback comment: ''!
!JSAjaxCallback categoriesForClass!Unclassified! !
!JSAjaxCallback methodsFor!

block: aZeroOrOneArgBlock
	block := aZeroOrOneArgBlock isNil
		ifFalse: [ aZeroOrOneArgBlock fixCallbackTemps ]!

evaluateWithArgument: anObject
	block isNil
		ifFalse: [ block valueWithPossibleArguments: (Array with: anObject) ].
	self requestContext
		respond: [ :response | response doNotCache ]!

priority
	^ 5! !
!JSAjaxCallback categoriesFor: #block:!accessing!public! !
!JSAjaxCallback categoriesFor: #evaluateWithArgument:!evaluation!public! !
!JSAjaxCallback categoriesFor: #priority!accessing!public! !

JSPassenger guid: (GUID fromString: '{BC6FA4FD-999D-4A07-8B02-6AA168586B81}')!
JSPassenger comment: ''!
!JSPassenger categoriesForClass!Unclassified! !
!JSPassenger methodsFor!

evaluateWithArgument: anObject
	self shouldNotImplement!

isEnabledFor: aRequestContext
	^ false!

isPassenger
	^ true!

object
	^ object!

setObject: anObject
	object := anObject! !
!JSPassenger categoriesFor: #evaluateWithArgument:!evaluation!public! !
!JSPassenger categoriesFor: #isEnabledFor:!public!testing! !
!JSPassenger categoriesFor: #isPassenger!public!testing! !
!JSPassenger categoriesFor: #object!accessing!public! !
!JSPassenger categoriesFor: #setObject:!initialization!public! !

JSJsonDeploymentLibrary guid: (GUID fromString: '{CCB74CF6-8E93-4289-90A4-C1F9B2CC284B}')!
JSJsonDeploymentLibrary comment: ''!
!JSJsonDeploymentLibrary categoriesForClass!Unclassified! !
!JSJsonDeploymentLibrary methodsFor!

json2Js
	^ 'if(!!this.JSON){this.JSON={};}(function(){function f(n){return n<10?"0"+n:n;}if(typeof Date.prototype.toJSON!!=="function"){Date.prototype.toJSON=function(key){return isFinite(this.valueOf())?this.getUTCFullYear()+"-"+f(this.getUTCMonth()+1)+"-"+f(this.getUTCDate())+"T"+f(this.getUTCHours())+":"+f(this.getUTCMinutes())+":"+f(this.getUTCSeconds())+"Z":null;};String.prototype.toJSON=Number.prototype.toJSON=Boolean.prototype.toJSON=function(key){return this.valueOf();};}var cx=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,escapable=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,gap,indent,meta={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",''"'':''\\"'',"\\":"\\\\"},rep;function quote(string){escapable.lastIndex=0;return escapable.test(string)?''"''+string.replace(escapable,function(a){var c=meta[a];return typeof c==="string"?c:"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4);})+''"'':''"''+string+''"'';}function str(key,holder){var i,k,v,length,mind=gap,partial,value=holder[key];if(value&&typeof value==="object"&&typeof value.toJSON==="function"){value=value.toJSON(key);}if(typeof rep==="function"){value=rep.call(holder,key,value);}switch(typeof value){case"string":return quote(value);case"number":return isFinite(value)?String(value):"null";case"boolean":case"null":return String(value);case"object":if(!!value){return"null";}gap+=indent;partial=[];if(Object.prototype.toString.apply(value)==="[object Array]"){length=value.length;for(i=0;i<length;i+=1){partial[i]=str(i,value)||"null";}v=partial.length===0?"[]":gap?"[\n"+gap+partial.join(",\n"+gap)+"\n"+mind+"]":"["+partial.join(",")+"]";gap=mind;return v;}if(rep&&typeof rep==="object"){length=rep.length;for(i=0;i<length;i+=1){k=rep[i];if(typeof k==="string"){v=str(k,value);if(v){partial.push(quote(k)+(gap?": ":":")+v);}}}}else{for(k in value){if(Object.hasOwnProperty.call(value,k)){v=str(k,value);if(v){partial.push(quote(k)+(gap?": ":":")+v);}}}}v=partial.length===0?"{}":gap?"{\n"+gap+partial.join(",\n"+gap)+"\n"+mind+"}":"{"+partial.join(",")+"}";gap=mind;return v;}}if(typeof JSON.stringify!!=="function"){JSON.stringify=function(value,replacer,space){var i;gap="";indent="";if(typeof space==="number"){for(i=0;i<space;i+=1){indent+=" ";}}else{if(typeof space==="string"){indent=space;}}rep=replacer;if(replacer&&typeof replacer!!=="function"&&(typeof replacer!!=="object"||typeof replacer.length!!=="number")){throw new Error("JSON.stringify");}return str("",{"":value});};}if(typeof JSON.parse!!=="function"){JSON.parse=function(text,reviver){var j;function walk(holder,key){var k,v,value=holder[key];if(value&&typeof value==="object"){for(k in value){if(Object.hasOwnProperty.call(value,k)){v=walk(value,k);if(v!!==undefined){value[k]=v;}else{delete value[k];}}}}return reviver.call(holder,key,value);}cx.lastIndex=0;if(cx.test(text)){text=text.replace(cx,function(a){return"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4);});}if(/^[\],:{}\s]*$/.test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,"@").replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,"]").replace(/(?:^|:|,)(?:\s*\[)+/g,""))){j=eval("("+text+")");return typeof reviver==="function"?walk({"":j},""):j;}throw new SyntaxError("JSON.parse");};}}());'!

selectorsToInclude
	^ #(json2Js)! !
!JSJsonDeploymentLibrary categoriesFor: #json2Js!public!uploads! !
!JSJsonDeploymentLibrary categoriesFor: #selectorsToInclude!accessing!public! !

JSJsonDevelopmentLibrary guid: (GUID fromString: '{EB966075-9349-4178-8F6E-ECADFBCEBC8C}')!
JSJsonDevelopmentLibrary comment: ''!
!JSJsonDevelopmentLibrary categoriesForClass!Unclassified! !
!JSJsonDevelopmentLibrary methodsFor!

json2Js
	^ '/*
    http://www.JSON.org/json2.js
    2009-08-17

    Public Domain.

    NO WARRANTY EXPRESSED OR IMPLIED. USE AT YOUR OWN RISK.

    See http://www.JSON.org/js.html

    This file creates a global JSON object containing two methods: stringify
    and parse.

        JSON.stringify(value, replacer, space)
            value       any JavaScript value, usually an object or array.

            replacer    an optional parameter that determines how object
                        values are stringified for objects. It can be a
                        function or an array of strings.

            space       an optional parameter that specifies the indentation
                        of nested structures. If it is omitted, the text will
                        be packed without extra whitespace. If it is a number,
                        it will specify the number of spaces to indent at each
                        level. If it is a string (such as ''\t'' or ''&nbsp;''),
                        it contains the characters used to indent at each level.

            This method produces a JSON text from a JavaScript value.

            When an object value is found, if the object contains a toJSON
            method, its toJSON method will be called and the result will be
            stringified. A toJSON method does not serialize: it returns the
            value represented by the name/value pair that should be serialized,
            or undefined if nothing should be serialized. The toJSON method
            will be passed the key associated with the value, and this will be
            bound to the value

            For example, this would serialize Dates as ISO strings.

                Date.prototype.toJSON = function (key) {
                    function f(n) {
                        // Format integers to have at least two digits.
                        return n < 10 ? ''0'' + n : n;
                    }

                    return this.getUTCFullYear()   + ''-'' +
                         f(this.getUTCMonth() + 1) + ''-'' +
                         f(this.getUTCDate())      + ''T'' +
                         f(this.getUTCHours())     + '':'' +
                         f(this.getUTCMinutes())   + '':'' +
                         f(this.getUTCSeconds())   + ''Z'';
                };

            You can provide an optional replacer method. It will be passed the
            key and value of each member, with this bound to the containing
            object. The value that is returned from your method will be
            serialized. If your method returns undefined, then the member will
            be excluded from the serialization.

            If the replacer parameter is an array of strings, then it will be
            used to select the members to be serialized. It filters the results
            such that only members with keys listed in the replacer array are
            stringified.

            Values that do not have JSON representations, such as undefined or
            functions, will not be serialized. Such values in objects will be
            dropped; in arrays they will be replaced with null. You can use
            a replacer function to replace those with JSON values.
            JSON.stringify(undefined) returns undefined.

            The optional space parameter produces a stringification of the
            value that is filled with line breaks and indentation to make it
            easier to read.

            If the space parameter is a non-empty string, then that string will
            be used for indentation. If the space parameter is a number, then
            the indentation will be that many spaces.

            Example:

            text = JSON.stringify([''e'', {pluribus: ''unum''}]);
            // text is ''["e",{"pluribus":"unum"}]''


            text = JSON.stringify([''e'', {pluribus: ''unum''}], null, ''\t'');
            // text is ''[\n\t"e",\n\t{\n\t\t"pluribus": "unum"\n\t}\n]''

            text = JSON.stringify([new Date()], function (key, value) {
                return this[key] instanceof Date ?
                    ''Date('' + this[key] + '')'' : value;
            });
            // text is ''["Date(---current time---)"]''


        JSON.parse(text, reviver)
            This method parses a JSON text to produce an object or array.
            It can throw a SyntaxError exception.

            The optional reviver parameter is a function that can filter and
            transform the results. It receives each of the keys and values,
            and its return value is used instead of the original value.
            If it returns what it received, then the structure is not modified.
            If it returns undefined then the member is deleted.

            Example:

            // Parse the text. Values that look like ISO date strings will
            // be converted to Date objects.

            myData = JSON.parse(text, function (key, value) {
                var a;
                if (typeof value === ''string'') {
                    a =
/^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2}(?:\.\d*)?)Z$/.exec(value);
                    if (a) {
                        return new Date(Date.UTC(+a[1], +a[2] - 1, +a[3], +a[4],
                            +a[5], +a[6]));
                    }
                }
                return value;
            });

            myData = JSON.parse(''["Date(09/09/2001)"]'', function (key, value) {
                var d;
                if (typeof value === ''string'' &&
                        value.slice(0, 5) === ''Date('' &&
                        value.slice(-1) === '')'') {
                    d = new Date(value.slice(5, -1));
                    if (d) {
                        return d;
                    }
                }
                return value;
            });


    This is a reference implementation. You are free to copy, modify, or
    redistribute.

    This code should be minified before deployment.
    See http://javascript.crockford.com/jsmin.html

    USE YOUR OWN COPY. IT IS EXTREMELY UNWISE TO LOAD CODE FROM SERVERS YOU DO
    NOT CONTROL.
*/

/*jslint evil: true */

/*members "", "\b", "\t", "\n", "\f", "\r", "\"", JSON, "\\", apply,
    call, charCodeAt, getUTCDate, getUTCFullYear, getUTCHours,
    getUTCMinutes, getUTCMonth, getUTCSeconds, hasOwnProperty, join,
    lastIndex, length, parse, prototype, push, replace, slice, stringify,
    test, toJSON, toString, valueOf
*/

"use strict";

// Create a JSON object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.

if (!!this.JSON) {
    this.JSON = {};
}

(function () {

    function f(n) {
        // Format integers to have at least two digits.
        return n < 10 ? ''0'' + n : n;
    }

    if (typeof Date.prototype.toJSON !!== ''function'') {

        Date.prototype.toJSON = function (key) {

            return isFinite(this.valueOf()) ?
                   this.getUTCFullYear()   + ''-'' +
                 f(this.getUTCMonth() + 1) + ''-'' +
                 f(this.getUTCDate())      + ''T'' +
                 f(this.getUTCHours())     + '':'' +
                 f(this.getUTCMinutes())   + '':'' +
                 f(this.getUTCSeconds())   + ''Z'' : null;
        };

        String.prototype.toJSON =
        Number.prototype.toJSON =
        Boolean.prototype.toJSON = function (key) {
            return this.valueOf();
        };
    }

    var cx = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        gap,
        indent,
        meta = {    // table of character substitutions
            ''\b'': ''\\b'',
            ''\t'': ''\\t'',
            ''\n'': ''\\n'',
            ''\f'': ''\\f'',
            ''\r'': ''\\r'',
            ''"'' : ''\\"'',
            ''\\'': ''\\\\''
        },
        rep;


    function quote(string) {

// If the string contains no control characters, no quote characters, and no
// backslash characters, then we can safely slap some quotes around it.
// Otherwise we must also replace the offending characters with safe escape
// sequences.

        escapable.lastIndex = 0;
        return escapable.test(string) ?
            ''"'' + string.replace(escapable, function (a) {
                var c = meta[a];
                return typeof c === ''string'' ? c :
                    ''\\u'' + (''0000'' + a.charCodeAt(0).toString(16)).slice(-4);
            }) + ''"'' :
            ''"'' + string + ''"'';
    }


    function str(key, holder) {

// Produce a string from holder[key].

        var i,          // The loop counter.
            k,          // The member key.
            v,          // The member value.
            length,
            mind = gap,
            partial,
            value = holder[key];

// If the value has a toJSON method, call it to obtain a replacement value.

        if (value && typeof value === ''object'' &&
                typeof value.toJSON === ''function'') {
            value = value.toJSON(key);
        }

// If we were called with a replacer function, then call the replacer to
// obtain a replacement value.

        if (typeof rep === ''function'') {
            value = rep.call(holder, key, value);
        }

// What happens next depends on the value''s type.

        switch (typeof value) {
        case ''string'':
            return quote(value);

        case ''number'':

// JSON numbers must be finite. Encode non-finite numbers as null.

            return isFinite(value) ? String(value) : ''null'';

        case ''boolean'':
        case ''null'':

// If the value is a boolean or null, convert it to a string. Note:
// typeof null does not produce ''null''. The case is included here in
// the remote chance that this gets fixed someday.

            return String(value);

// If the type is ''object'', we might be dealing with an object or an array or
// null.

        case ''object'':

// Due to a specification blunder in ECMAScript, typeof null is ''object'',
// so watch out for that case.

            if (!!value) {
                return ''null'';
            }

// Make an array to hold the partial results of stringifying this object value.

            gap += indent;
            partial = [];

// Is the value an array?

            if (Object.prototype.toString.apply(value) === ''[object Array]'') {

// The value is an array. Stringify every element. Use null as a placeholder
// for non-JSON values.

                length = value.length;
                for (i = 0; i < length; i += 1) {
                    partial[i] = str(i, value) || ''null'';
                }

// Join all of the elements together, separated with commas, and wrap them in
// brackets.

                v = partial.length === 0 ? ''[]'' :
                    gap ? ''[\n'' + gap +
                            partial.join('',\n'' + gap) + ''\n'' +
                                mind + '']'' :
                          ''['' + partial.join('','') + '']'';
                gap = mind;
                return v;
            }

// If the replacer is an array, use it to select the members to be stringified.

            if (rep && typeof rep === ''object'') {
                length = rep.length;
                for (i = 0; i < length; i += 1) {
                    k = rep[i];
                    if (typeof k === ''string'') {
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? '': '' : '':'') + v);
                        }
                    }
                }
            } else {

// Otherwise, iterate through all of the keys in the object.

                for (k in value) {
                    if (Object.hasOwnProperty.call(value, k)) {
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? '': '' : '':'') + v);
                        }
                    }
                }
            }

// Join all of the member texts together, separated with commas,
// and wrap them in braces.

            v = partial.length === 0 ? ''{}'' :
                gap ? ''{\n'' + gap + partial.join('',\n'' + gap) + ''\n'' +
                        mind + ''}'' : ''{'' + partial.join('','') + ''}'';
            gap = mind;
            return v;
        }
    }

// If the JSON object does not yet have a stringify method, give it one.

    if (typeof JSON.stringify !!== ''function'') {
        JSON.stringify = function (value, replacer, space) {

// The stringify method takes a value and an optional replacer, and an optional
// space parameter, and returns a JSON text. The replacer can be a function
// that can replace values, or an array of strings that will select the keys.
// A default replacer method can be provided. Use of the space parameter can
// produce text that is more easily readable.

            var i;
            gap = '''';
            indent = '''';

// If the space parameter is a number, make an indent string containing that
// many spaces.

            if (typeof space === ''number'') {
                for (i = 0; i < space; i += 1) {
                    indent += '' '';
                }

// If the space parameter is a string, it will be used as the indent string.

            } else if (typeof space === ''string'') {
                indent = space;
            }

// If there is a replacer, it must be a function or an array.
// Otherwise, throw an error.

            rep = replacer;
            if (replacer && typeof replacer !!== ''function'' &&
                    (typeof replacer !!== ''object'' ||
                     typeof replacer.length !!== ''number'')) {
                throw new Error(''JSON.stringify'');
            }

// Make a fake root object containing our value under the key of ''''.
// Return the result of stringifying the value.

            return str('''', {'''': value});
        };
    }


// If the JSON object does not yet have a parse method, give it one.

    if (typeof JSON.parse !!== ''function'') {
        JSON.parse = function (text, reviver) {

// The parse method takes a text and an optional reviver function, and returns
// a JavaScript value if the text is a valid JSON text.

            var j;

            function walk(holder, key) {

// The walk method is used to recursively walk the resulting structure so
// that modifications can be made.

                var k, v, value = holder[key];
                if (value && typeof value === ''object'') {
                    for (k in value) {
                        if (Object.hasOwnProperty.call(value, k)) {
                            v = walk(value, k);
                            if (v !!== undefined) {
                                value[k] = v;
                            } else {
                                delete value[k];
                            }
                        }
                    }
                }
                return reviver.call(holder, key, value);
            }


// Parsing happens in four stages. In the first stage, we replace certain
// Unicode characters with escape sequences. JavaScript handles many characters
// incorrectly, either silently deleting them, or treating them as line endings.

            cx.lastIndex = 0;
            if (cx.test(text)) {
                text = text.replace(cx, function (a) {
                    return ''\\u'' +
                        (''0000'' + a.charCodeAt(0).toString(16)).slice(-4);
                });
            }

// In the second stage, we run the text against regular expressions that look
// for non-JSON patterns. We are especially concerned with ''()'' and ''new''
// because they can cause invocation, and ''='' because it can cause mutation.
// But just to be safe, we want to reject all unexpected forms.

// We split the second stage into 4 regexp operations in order to work around
// crippling inefficiencies in IE''s and Safari''s regexp engines. First we
// replace the JSON backslash pairs with ''@'' (a non-JSON character). Second, we
// replace all simple value tokens with '']'' characters. Third, we delete all
// open brackets that follow a colon or comma or that begin the text. Finally,
// we look to see that the remaining characters are only whitespace or '']'' or
// '','' or '':'' or ''{'' or ''}''. If that is so, then the text is safe for eval.

            if (/^[\],:{}\s]*$/.
test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, ''@'').
replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, '']'').
replace(/(?:^|:|,)(?:\s*\[)+/g, ''''))) {

// In the third stage we use the eval function to compile the text into a
// JavaScript structure. The ''{'' operator is subject to a syntactic ambiguity
// in JavaScript: it can begin a block or an object literal. We wrap the text
// in parens to eliminate the ambiguity.

                j = eval(''('' + text + '')'');

// In the optional fourth stage, we recursively walk the new structure, passing
// each name/value pair to a reviver function for possible transformation.

                return typeof reviver === ''function'' ?
                    walk({'''': j}, '''') : j;
            }

// If the text is not JSON parseable, then a SyntaxError is thrown.

            throw new SyntaxError(''JSON.parse'');
        };
    }
}());'!

selectorsToInclude
	^ #(json2Js)! !
!JSJsonDevelopmentLibrary categoriesFor: #json2Js!public!uploads! !
!JSJsonDevelopmentLibrary categoriesFor: #selectorsToInclude!accessing!public! !

"Binary Globals"!

