| package |
package := Package name: 'Javascript-Tests-Core'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '58'.


package classNames
	add: #JSConversionTest;
	add: #JSDecorationTest;
	add: #JSJsonParserTest;
	add: #JSJsonStreamTest;
	add: #JSJsonTest;
	add: #JSLoggingTest;
	add: #JSObjectTest;
	add: #JSRenderingTest;
	add: #JSScriptTest;
	add: #JSStreamTest;
	yourself.

package methodNames
	add: 'GRPackage class' -> #javascriptTestsCore;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: '..\..\IDB\IDB DateAndTime';
	add: '..\..\IDB\IDB Duration';
	add: 'Javascript-Core';
	add: '..\Seaside\Seaside-Canvas';
	add: '..\Seaside\Seaside-Core';
	add: '..\Seaside\Seaside-Tests-Core';
	add: '..\..\Camp Smalltalk\SUnit\SUnit';
	yourself).

package!

"Class Definitions"!

TestCase subclass: #JSJsonParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #JSJsonStreamTest
	instanceVariableNames: 'printer'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAContextTest subclass: #JSObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSObjectTest subclass: #JSConversionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSObjectTest subclass: #JSDecorationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSObjectTest subclass: #JSJsonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSObjectTest subclass: #JSLoggingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSObjectTest subclass: #JSRenderingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSObjectTest subclass: #JSScriptTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSObjectTest subclass: #JSStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

javascriptTestsCore
	^ self new
		name: 'Javascript-Tests-Core';
		description: 'Unit tests for the Javascript-Core package.';
		addDependency: 'Javascript-Core';
		addDependency: 'Seaside-Tests-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #javascriptTestsCore!*javascript-tests-core!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

JSJsonParserTest guid: (GUID fromString: '{3E352E93-3AD8-4E87-864F-28BBF227DA78}')!
JSJsonParserTest comment: ''!
!JSJsonParserTest categoriesForClass!Unclassified! !
!JSJsonParserTest methodsFor!

assertInvalid: aString
	self should: [ self parse: aString ] raise: JSJsonSyntaxError!

parse: aString
	^ JSJsonParser parse: aString!

testBigArray
	| result |
	result := self parse: ' [ "a" , "b" ] '.
	self assert: result isArray.
	self assert: result size = 2.
	self assert: result first = 'a'.
	self assert: result second = 'b'.!

testBigObject
	| result |
	result := self parse: ' { "a" : 1 , "b" : 2 } '.
	self assert: result isDictionary.
	self assert: result size = 2.
	self assert: (result at: 'a') = 1.
	self assert: (result at: 'b') = 2.!

testEmptyArray
	| result |
	result := self parse: '[]'.
	self assert: result isArray.
	self assert: result isEmpty!

testEmptyObject
	| result |
	result := self parse: '{}'.
	self assert: result isDictionary.
	self assert: result isEmpty!

testExplorerEvent
	| result |
	result := self parse: '{"recordset": null, "type": "change", "fromElement": null, "toElement": null, "altLeft": false, "keyCode": 0, "repeat": false, "reason": 0, "behaviorCookie": 0, "contentOverflow": false, "behaviorPart": 0, "dataTransfer": null, "ctrlKey": false, "shiftLeft": false, "dataFld": "", "qualifier": "", "wheelDelta": 0, "bookmarks": null, "button": 0, "srcFilter": null, "nextPage": "", "cancelBubble": false, "x": 89, "y": 502, "screenX": 231, "screenY": 1694, "srcUrn": "", "boundElements": {"length": 0}, "clientX": 89, "clientY": 502, "propertyName": "", "shiftKey": false, "ctrlLeft": false, "offsetX": 25, "offsetY": 2, "altKey": false}'.
	self assert: (result at: 'type') = 'change'.
	self assert: (result at: 'offsetY') = 2.
	self deny: (result at: 'altKey').
	self assert: (result at: 'dataTransfer') isNil.
	self assert: (result at: 'nextPage') = ''!

testFalse
	self deny: (self parse: 'false')!

testFirefoxEvent
	| result |
	result := self parse: '{"type": "change", "eventPhase": 2, "bubbles": true, "cancelable": true, "timeStamp": 0, "CAPTURING_PHASE": 1, "AT_TARGET": 2, "BUBBLING_PHASE": 3, "isTrusted": true, "MOUSEDOWN": 1, "MOUSEUP": 2, "MOUSEOVER": 4, "MOUSEOUT": 8, "MOUSEMOVE": 16, "MOUSEDRAG": 32, "CLICK": 64, "DBLCLICK": 128, "KEYDOWN": 256, "KEYUP": 512, "KEYPRESS": 1024, "DRAGDROP": 2048, "FOCUS": 4096, "BLUR": 8192, "SELECT": 16384, "CHANGE": 32768, "RESET": 65536, "SUBMIT": 131072, "SCROLL": 262144, "LOAD": 524288, "UNLOAD": 1048576, "XFER_DONE": 2097152, "ABORT": 4194304, "ERROR": 8388608, "LOCATE": 16777216, "MOVE": 33554432, "RESIZE": 67108864, "FORWARD": 134217728, "HELP": 268435456, "BACK": 536870912, "TEXT": 1073741824, "ALT_MASK": 1, "CONTROL_MASK": 2, "SHIFT_MASK": 4, "META_MASK": 8}'.
	self assert: (result at: 'type') = 'change'.
	self assert: (result at: 'eventPhase') = 2.
	self assert: (result at: 'bubbles').
	self assert: (result at: 'cancelable').
	self assert: (result at: 'BACK') = 536870912!

testInvalidArray
	self assertInvalid: '['.
	self assertInvalid: '[1'.
	self assertInvalid: '[1,'.
	self assertInvalid: '[1,]'.
	self assertInvalid: '[1 2]'.
	self assertInvalid: '[]]'!

testInvalidFalse
	self assertInvalid: 'fa'.
	self assertInvalid: 'falsely'.
	self assertInvalid: 'fabulous'!

testInvalidNull
	self assertInvalid: 'nu'.
	self assertInvalid: 'nuclear'.
	self assertInvalid: 'nullified'!

testInvalidObject
	self assertInvalid: '{'.
	self assertInvalid: '{"a"'.
	self assertInvalid: '{"a":'.
	self assertInvalid: '{"a":"b"'.
	self assertInvalid: '{"a":"b",'.
	self assertInvalid: '{"a"}'.
	self assertInvalid: '{"a":}'.
	self assertInvalid: '{"a":"b",}'.
	self assertInvalid: '{}}'!

testInvalidString
	self assertInvalid: '"'.
	self assertInvalid: '"a'.
	self assertInvalid: '"\"'.
	self assertInvalid: '"\a"'.
	self assertInvalid: '"\u"'.
	self assertInvalid: '"\u1"'.
	self assertInvalid: '"\u12"'.
	self assertInvalid: '"\u123"'.
	self assertInvalid: '"\u123x"'!

testInvalidTrue
	self assertInvalid: 'tr'.
	self assertInvalid: 'trace'.
	self assertInvalid: 'truest'!

testNestedArray
	| result |
	result := self parse: '[[2]]'.
	self assert: result isArray.
	self assert: result size = 1.
	result := result first.
	self assert: result isArray.
	self assert: result size = 1.
	self assert: result first = 2.!

testNestedObject
	| result |
	result := self parse: '{"object":{"1":"2"}} '.
	self assert: result isDictionary.
	self assert: result size = 1.
	result := result at: 'object'.
	self assert: result isDictionary.
	self assert: result size = 1.
	self assert: (result at: '1') = '2'.!

testNull
	self assert: (self parse: 'null') isNil!

testNumberFloat
	self assert: (self parse: '0.0') = 0.0.
	self assert: (self parse: '0.12') = 0.12.
	self assert: (self parse: '-0.12') = -0.12.
	self assert: (self parse: '12.34') = 12.34.
	self assert: (self parse: '-12.34') = -12.34.
	self assert: (self parse: '1.2e0') = 1.2.
	self assert: (self parse: '1.2e+1') = 12.0.
	self assert: (self parse: '1.2e-1') = 1.2e-1!

testNumberInteger
	self assert: (self parse: '0') = 0.
	self assert: (self parse: '1') = 1.
	self assert: (self parse: '-1') = -1.
	self assert: (self parse: '12') = 12.
	self assert: (self parse: '-12') = -12.
	self assert: (self parse: '1e2') = 100.
	self assert: (self parse: '1e+2') = 100!

testSafariEvent
	| result |
	result := self parse: '{"returnValue": true, "timeStamp": 1226697417289, "eventPhase": 2, "type": "change", "cancelable": false, "bubbles": true, "cancelBubble": false, "MOUSEOUT": 8, "FOCUS": 4096, "CHANGE": 32768, "MOUSEMOVE": 16, "AT_TARGET": 2, "SELECT": 16384, "BLUR": 8192, "KEYUP": 512, "MOUSEDOWN": 1, "MOUSEDRAG": 32, "BUBBLING_PHASE": 3, "MOUSEUP": 2, "CAPTURING_PHASE": 1, "MOUSEOVER": 4, "CLICK": 64, "DBLCLICK": 128, "KEYDOWN": 256, "KEYPRESS": 1024, "DRAGDROP": 2048}'.
	self assert: (result at: 'type') = 'change'.
	self assert: (result at: 'eventPhase') = 2.
	self assert: (result at: 'bubbles').
	self deny: (result at: 'cancelBubble').
	self deny: (result at: 'cancelable').
	self assert: (result at: 'BLUR') = 8192!

testSmallArray
	| result |
	result := self parse: '["a"]'.
	self assert: result isArray.
	self assert: result size = 1.
	self assert: result first = 'a'.!

testSmallObject
	| result |
	result := self parse: '{"a":1}'.
	self assert: result isDictionary.
	self assert: result size = 1.
	self assert: (result at: 'a') = 1!

testString
	self assert: (self parse: '""') = ''.
	self assert: (self parse: '"foo"') = 'foo'.
	self assert: (self parse: '"foo bar"') = 'foo bar'!

testStringEscaped
	self assert: (self parse: '"\""') = '"'.
	self assert: (self parse: '"\\"') = '\'.
	self assert: (self parse: '"\/"') = '/'.
	self assert: (self parse: '"\b"') = (String with: Character backspace).
	self assert: (self parse: '"\f"') = (String with: Character newPage).
	self assert: (self parse: '"\n"') = (String with: Character lf).
	self assert: (self parse: '"\r"') = (String with: Character cr).
	self assert: (self parse: '"\t"') = (String with: Character tab).
	self assert: (self parse: '"\u20Ac"') = (String with: (Character codePoint: 16r20AC))!

testTrue
	self assert: (self parse: 'true')! !
!JSJsonParserTest categoriesFor: #assertInvalid:!public!utilities! !
!JSJsonParserTest categoriesFor: #parse:!public!utilities! !
!JSJsonParserTest categoriesFor: #testBigArray!public!tests-array! !
!JSJsonParserTest categoriesFor: #testBigObject!public!tests-objects! !
!JSJsonParserTest categoriesFor: #testEmptyArray!public!tests-array! !
!JSJsonParserTest categoriesFor: #testEmptyObject!public!tests-objects! !
!JSJsonParserTest categoriesFor: #testExplorerEvent!public!tests-real! !
!JSJsonParserTest categoriesFor: #testFalse!public!tests-literals! !
!JSJsonParserTest categoriesFor: #testFirefoxEvent!public!tests-real! !
!JSJsonParserTest categoriesFor: #testInvalidArray!public!tests-invalid! !
!JSJsonParserTest categoriesFor: #testInvalidFalse!public!tests-invalid! !
!JSJsonParserTest categoriesFor: #testInvalidNull!public!tests-invalid! !
!JSJsonParserTest categoriesFor: #testInvalidObject!public!tests-invalid! !
!JSJsonParserTest categoriesFor: #testInvalidString!public!tests-invalid! !
!JSJsonParserTest categoriesFor: #testInvalidTrue!public!tests-invalid! !
!JSJsonParserTest categoriesFor: #testNestedArray!public!tests-array! !
!JSJsonParserTest categoriesFor: #testNestedObject!public!tests-objects! !
!JSJsonParserTest categoriesFor: #testNull!public!tests-literals! !
!JSJsonParserTest categoriesFor: #testNumberFloat!public!tests-literals! !
!JSJsonParserTest categoriesFor: #testNumberInteger!public!tests-literals! !
!JSJsonParserTest categoriesFor: #testSafariEvent!public!tests-real! !
!JSJsonParserTest categoriesFor: #testSmallArray!public!tests-array! !
!JSJsonParserTest categoriesFor: #testSmallObject!public!tests-objects! !
!JSJsonParserTest categoriesFor: #testString!public!tests-literals! !
!JSJsonParserTest categoriesFor: #testStringEscaped!public!tests-literals! !
!JSJsonParserTest categoriesFor: #testTrue!public!tests-literals! !

JSJsonStreamTest guid: (GUID fromString: '{EA335EF8-88E8-422D-82AB-622E3D83B7D9}')!
JSJsonStreamTest comment: ''!
!JSJsonStreamTest categoriesForClass!Unclassified! !
!JSJsonStreamTest methodsFor!

assert: anObject equals: aString
	self
		assert: anObject asJson = aString
		description: anObject asJson , ' expected to be ' , aString greaseString
		resumable: true!

jsonOn: aStream
	printer value: aStream!

testArray
	self assert: #(1 2 3) equals: '[1,2,3]'!

testCharacter
	self assert: $a equals: '"a"'!

testCustomArray
	printer := [ :stream | stream json: #('aString1' ('aString2' 'aString3')) ].
	self assert: self equals: '["aString1",["aString2","aString3"]]'!

testCustomDictionary
	printer := [ :stream | 
		stream json: (GRSmallDictionary new
			at: 'foo' put: 'bar';
			at: 'zork' put: (GRSmallDictionary new
				at: 'foo' put: 'bar';
				yourself);
			yourself) ].
	self assert: self equals: '{"foo":"bar","zork":{"foo":"bar"}}'!

testDictionary
	self
		assert:
			((GRSmallDictionary new)
				at: 'foo' put: 1;
				at: 'bar' put: 2;
				at: 'zork' put: 3;
				yourself)
		equals: '{"foo":1,"bar":2,"zork":3}'.
	self
		assert:
			((GRSmallDictionary new)
				at: '' put: 'empty';
				yourself)
		equals: '{"":"empty"}'.
	self
		assert:
			((Dictionary new)
				at: 1 put: 'not-a-string';
				yourself)
		equals: '{"1":"not-a-string"}'.
	self
		assert:
			((Dictionary new)
				at: '1abc' put: 'not-an-id';
				yourself)
		equals: '{"1abc":"not-an-id"}'.
	self
		assert:
			((Dictionary new)
				at: 'abc1' put: 'totally sexy';
				yourself)
		equals: '{"abc1":"totally sexy"}'!

testEncodeArray
	| actual |
	actual := String streamContents: [ :stream |
		JSJsonStream 
			encodeCollection: (Array 
				with: 'something'
				with: (GRSmallDictionary new
					at: 'a' put: '1';
					yourself))
			on: stream ].
	self assert: actual = '["something",{"a":"1"}]'!

testEncodeDictionary
	| actual |
	actual := String streamContents: [ :stream |
		JSJsonStream 
			encodeDictionary: (GRSmallDictionary new
				at: '1' put: 'a';
				at: '2' put: (GRSmallDictionary new
					at: '3' put: 'c';
					yourself);
				yourself) 
			on: stream ].
	self assert: actual = '{"1":"a","2":{"3":"c"}}'!

testLiteral
	self assert: true equals: 'true'.
	self assert: false equals: 'false'.
	self assert: nil equals: 'null'!

testNumber
	self assert: 123 equals: '123'.
	self assert: 123.4 equals: '123.4'.!

testObject
	self
		should: [ Object new asJson ]
		raise: Error!

testStringBasic
	self assert: 'abc' equals: '"abc"'.
	self assert: '123' equals: '"123"'!

testStringEscaping
	self assert: '''' equals: '"''"'.
	self assert: '"' equals: '"\""'.
	self assert: '\' equals: '"\\"'!

testStringSpecial
	self assert: (String with: Character cr) equals: '"\r"'.
	self assert: (String with: Character lf) equals: '"\n"'.
	self assert: (String with: Character tab) equals: '"\t"'.

	self assert: (String with: (Character codePoint: 0)) equals: '"\0"'.
	self assert: (String with: (Character codePoint: 1)) equals: '"\x01"'.
	self assert: (String with: (Character codePoint: 31)) equals: '"\x1f"'! !
!JSJsonStreamTest categoriesFor: #assert:equals:!asserting!public! !
!JSJsonStreamTest categoriesFor: #jsonOn:!printing!public! !
!JSJsonStreamTest categoriesFor: #testArray!public!tests! !
!JSJsonStreamTest categoriesFor: #testCharacter!public!tests-literals! !
!JSJsonStreamTest categoriesFor: #testCustomArray!public!tests-custom! !
!JSJsonStreamTest categoriesFor: #testCustomDictionary!public!tests-custom! !
!JSJsonStreamTest categoriesFor: #testDictionary!public!tests! !
!JSJsonStreamTest categoriesFor: #testEncodeArray!public!tests-encoding! !
!JSJsonStreamTest categoriesFor: #testEncodeDictionary!public!tests-encoding! !
!JSJsonStreamTest categoriesFor: #testLiteral!public!tests-literals! !
!JSJsonStreamTest categoriesFor: #testNumber!public!tests-literals! !
!JSJsonStreamTest categoriesFor: #testObject!public!tests! !
!JSJsonStreamTest categoriesFor: #testStringBasic!public!tests-literals! !
!JSJsonStreamTest categoriesFor: #testStringEscaping!public!tests-literals! !
!JSJsonStreamTest categoriesFor: #testStringSpecial!public!tests-literals! !

JSObjectTest guid: (GUID fromString: '{9ABE50B3-C080-4C09-B8BC-9A60A9BD1C50}')!
JSObjectTest comment: ''!
!JSObjectTest categoriesForClass!Unclassified! !
!JSObjectTest methodsFor!

assert: anObject equals: aString
	self
		assert: anObject asJavascript = aString
		description: anObject asJavascript printString , ' expected to be ' , aString printString
		resumable: true!

assert: aBlock renders: aString 
	| html |
	html := WARenderCanvas builder
		documentClass: WAHtmlDocument;
		rootClass: WAHtmlRoot;
		fullDocument: false;
		render: aBlock.
	self 
		assert: html = aString
		description: 'Got ' , html printString , '; but expected ' , aString printString!

javascript
	^ JSScript context: self renderContext!

mock
	^ JSStream on: 'mock'!

renderContext
	^ WARenderContext new
		actionUrl: (WAUrl absolute: 'http://www.seaside.st/?_s=1&_k=a');
		document: (WAHtmlDocument 
			on: (WriteStream on: String new)
			codec: self requestContext codec);
		yourself!

stream
	^ JSStream new! !
!JSObjectTest categoriesFor: #assert:equals:!public!utilities! !
!JSObjectTest categoriesFor: #assert:renders:!public!utilities! !
!JSObjectTest categoriesFor: #javascript!accessing-javascript!public! !
!JSObjectTest categoriesFor: #mock!accessing-javascript!public! !
!JSObjectTest categoriesFor: #renderContext!accessing!public! !
!JSObjectTest categoriesFor: #stream!accessing-javascript!public! !

!JSObjectTest class methodsFor!

isAbstract
	^ self name = #JSObjectTest!

packageNamesUnderTest
	^ #('Javascript-Core')!

shouldInheritSelectors
	^ true! !
!JSObjectTest class categoriesFor: #isAbstract!public!testing! !
!JSObjectTest class categoriesFor: #packageNamesUnderTest!accessing!public! !
!JSObjectTest class categoriesFor: #shouldInheritSelectors!public!testing! !

JSConversionTest guid: (GUID fromString: '{943650AF-8424-4CAB-BE31-C2ACC00ACF55}')!
JSConversionTest comment: ''!
!JSConversionTest categoriesForClass!Unclassified! !
!JSConversionTest methodsFor!

testArray
	self assert: #(1 2 3) equals: '[1,2,3]'!

testCharacter
	self assert: (Character codePoint: 0) equals: '"\0"'.
	self assert: Character lf equals: '"\n"'.
	self assert: $a equals: '"a"'!

testDateAndTime
	self assert: (DateAndTime year: 1980 month: 6 day: 11 hour: 12 minute: 45 second: 23) equals: 'new Date(1980,5,11,12,45,23)'.
	self assert: (Date year: 1980 month: 6 day: 11) equals: 'new Date(1980,5,11)'!

testDictionary
	self 
		assert: (GRSmallDictionary new
				at: 'foo'
					put: 1;
				at: 'bar'
					put: 2;
				at: 'zork'
					put: 3;
				yourself)
		equals: '{"foo":1,"bar":2,"zork":3}'.
	self 
		assert: (GRSmallDictionary new
				at: ''
					put: 'empty';
				yourself)
		equals: '{"":"empty"}'.
	self 
		assert: (Dictionary new
				at: 1
					put: 'not-a-string';
				yourself)
		equals: '{"1":"not-a-string"}'.
	self 
		assert: (Dictionary new
				at: '1abc'
					put: 'not-an-id';
				yourself)
		equals: '{"1abc":"not-an-id"}'.
	self 
		assert: (Dictionary new
				at: 'abc1'
					put: 'totally sexy';
				yourself)
		equals: '{"abc1":"totally sexy"}'!

testDuration
	self assert: (Duration seconds: 1) equals: '1000'.
	self assert: (Duration milliseconds: 1200) equals: '1200'!

testIsJavascript
	self deny: 123 isJavascript.
	self assert: self mock isJavascript.
	self assert: JSCreate new isJavascript!

testJoinAssocation
	self
		assert: (JSJoin on: (OrderedCollection with: 'foo' -> nil)) 
		equals: '"foo"'.
	self
		assert: (JSJoin on: (OrderedCollection with: 'foo' -> true)) 
		equals: '"foo="+encodeURIComponent(true)'.
	self
		assert: (JSJoin on: (OrderedCollection with: 'foo' -> 123)) 
		equals: '"foo="+encodeURIComponent(123)'!

testJoinEmpty
	self 
		assert: (JSJoin new)
		equals: '""'!

testJoinMultiple
	self
		assert: (JSJoin on: #('foo')) 
		equals: '"foo"'.
	self
		assert: (JSJoin on: #('foo' 'bar'))
		equals: '["foo","bar"].join("&")'!

testJoinString
	self
		assert: (JSJoin on: (OrderedCollection with: 'foo' -> 'bar')) 
		equals: '"foo=bar"'.
	self
		assert: (JSJoin on: (OrderedCollection with: 'foo' -> 'bar zork')) 
		equals: '"foo=bar%20zork"'.
	self
		assert: (JSJoin on: (OrderedCollection with: 'foo' -> 'bar&zork')) 
		equals: '"foo=bar%26zork"'!

testLiteral
	self assert: true equals: 'true'.
	self assert: false equals: 'false'.
	self assert: nil equals: 'null'!

testNumber
	self assert: 123 equals: '123'!

testStringBasic
	self assert: 'abc' equals: '"abc"'.
	self assert: '123' equals: '"123"'!

testStringEscaping
	self assert: '''' equals: '"''"'.
	self assert: '"' equals: '"\""'.
	self assert: '\' equals: '"\\"'!

testStringSpecial
	self assert: (String with: Character cr) equals: '"\r"'.
	self assert: (String with: Character lf) equals: '"\n"'.
	self assert: (String with: Character tab) equals: '"\t"'.

	self assert: (String with: (Character codePoint: 0)) equals: '"\0"'.
	self assert: (String with: (Character codePoint: 1)) equals: '"\x01"'.
	self assert: (String with: (Character codePoint: 31)) equals: '"\x1f"'!

testUrl
	self
		assert: (WAUrl absolute: 'http://www.seaside.st/?1=a&2=b')
		equals: '"http://www.seaside.st/?1=a&2=b"'! !
!JSConversionTest categoriesFor: #testArray!public!tests! !
!JSConversionTest categoriesFor: #testCharacter!public!tests! !
!JSConversionTest categoriesFor: #testDateAndTime!public!tests! !
!JSConversionTest categoriesFor: #testDictionary!public!tests! !
!JSConversionTest categoriesFor: #testDuration!public!tests! !
!JSConversionTest categoriesFor: #testIsJavascript!public!tests-tools! !
!JSConversionTest categoriesFor: #testJoinAssocation!public!tests! !
!JSConversionTest categoriesFor: #testJoinEmpty!public!tests! !
!JSConversionTest categoriesFor: #testJoinMultiple!public!tests! !
!JSConversionTest categoriesFor: #testJoinString!public!tests! !
!JSConversionTest categoriesFor: #testLiteral!public!tests! !
!JSConversionTest categoriesFor: #testNumber!public!tests! !
!JSConversionTest categoriesFor: #testStringBasic!public!tests! !
!JSConversionTest categoriesFor: #testStringEscaping!public!tests! !
!JSConversionTest categoriesFor: #testStringSpecial!public!tests! !
!JSConversionTest categoriesFor: #testUrl!public!tests! !

JSDecorationTest guid: (GUID fromString: '{7FF6C8A9-E7F6-43AA-9BF1-F0B5320C9286}')!
JSDecorationTest comment: ''!
!JSDecorationTest categoriesForClass!Unclassified! !
!JSDecorationTest methodsFor!

testAccess
	self
		assert: (self mock access: 'foo')
		equals: 'mock.foo'!

testAlias
	| mock |
	mock := self mock.
	mock alias: 'foo'.
	self assert: mock equals: 'foo'.
	mock alias: 'bar'; call: 'zork'.
	self assert: mock equals: 'bar.zork()'!

testApply
	self
		assert: (self mock apply: #())
		equals: 'mock()'.
	self
		assert: (self mock apply: #(1))
		equals: 'mock(1)'.
	self
		assert: (self mock apply: #(1 true))
		equals: 'mock(1,true)'!

testAssign
	self
		assert: (self mock assign: 1)
		equals: 'mock=1'!

testAssignLocalTo
	self
		assert: (self mock assignLocalTo: 'x')
		equals: 'var x=mock'!

testAssignTo
	self
		assert: (self mock assignTo: 'x')
		equals: 'x=mock'!

testBinary
	self
		assert: (self mock & false)
		equals: 'mock&&false'.
	self
		assert: (self mock | 1)
		equals: 'mock||1'!

testCall
	self
		assert: (self mock call: 'foo')
		equals: 'mock.foo()'.
	self
		assert: (self mock call: nil)
		equals: 'mock()'.
	self
		assert: (self mock call: '')
		equals: 'mock()'!

testCallWith
	self
		assert: (self mock call: 'foo' with: 1)
		equals: 'mock.foo(1)'.
	self
		assert: (self mock call: nil with: 1)
		equals: 'mock(1)'.
	self
		assert: (self mock call: '' with: 1)
		equals: 'mock(1)'!

testCallWithArguments
	self
		assert: (self mock call: 'foo' withArguments: #(1 2 3 4 5))
		equals: 'mock.foo(1,2,3,4,5)'.
	self
		assert: (self mock call: nil withArguments: #(1 2 3 4 5))
		equals: 'mock(1,2,3,4,5)'.
	self
		assert: (self mock call: '' withArguments: #(1 2 3 4 5))
		equals: 'mock(1,2,3,4,5)'!

testCallWithWith
	self
		assert: (self mock call: 'foo' with: 1 with: 2)
		equals: 'mock.foo(1,2)'.
	self
		assert: (self mock call: nil with: 1 with: 2)
		equals: 'mock(1,2)'.
	self
		assert: (self mock call: '' with: 1 with: 2)
		equals: 'mock(1,2)'!

testCallWithWithWith
	self
		assert: (self mock call: 'foo' with: 1 with: 2 with: 3)
		equals: 'mock.foo(1,2,3)'.
	self
		assert: (self mock call: nil with: 1 with: 2 with: 3)
		equals: 'mock(1,2,3)'.
	self
		assert: (self mock call: '' with: 1 with: 2 with: 3)
		equals: 'mock(1,2,3)'!

testConcatenate
	self
		assert: (self mock , 2 , 3)
		equals: 'mock;2;3'.
	self
		assert: (self mock , nil , self mock)
		equals: 'mock;null;mock'!

testCondition
	self
		assert: (self mock condition: true)
		equals: 'if(true){mock}'.
	self
		assert: (self mock condition: false)
		equals: 'if(false){mock}'!

testConfirm
	self
		assert: (self mock confirm: 'Sure?')
		equals: 'if(confirm("Sure?")){mock}'!

testCreate
	self
		assert: self mock create
		equals: 'new mock'!

testInterval
	self
		assert: (self mock interval: 2 seconds)
		equals: 'setInterval(function(){mock},2000)'!

testNot
	self
		assert: self mock not
		equals: '!!mock'.
	self
		assert: self mock not not
		equals: '!!!!mock'!

testProperty
	self
		assert: (self mock property: 'foo')
		equals: 'mock["foo"]'.
	self
		assert: (self mock property: 123)
		equals: 'mock[123]'.
	self
		assert: (self mock property: 'foo'; assign: 'bar')
		equals: 'mock["foo"]="bar"'!

testReturn
	self
		assert: (self mock return: 1)
		equals: 'mock;return 1'!

testThenElse
	| mock |
	mock := self mock.
	mock then: 1.
	self assert: mock equals: '(mock?1:null)'.

	mock := self mock.
	mock then: 1 else: 2.
	self assert: mock equals: '(mock?1:2)'!

testTimeout
	| mock |
	mock := self mock.
	mock timeout: 123.
	self assert: mock equals: 'setTimeout(function(){mock},123)'! !
!JSDecorationTest categoriesFor: #testAccess!public!tests! !
!JSDecorationTest categoriesFor: #testAlias!public!tests! !
!JSDecorationTest categoriesFor: #testApply!public!tests! !
!JSDecorationTest categoriesFor: #testAssign!public!tests! !
!JSDecorationTest categoriesFor: #testAssignLocalTo!public!tests! !
!JSDecorationTest categoriesFor: #testAssignTo!public!tests! !
!JSDecorationTest categoriesFor: #testBinary!public!tests! !
!JSDecorationTest categoriesFor: #testCall!public!tests! !
!JSDecorationTest categoriesFor: #testCallWith!public!tests! !
!JSDecorationTest categoriesFor: #testCallWithArguments!public!tests! !
!JSDecorationTest categoriesFor: #testCallWithWith!public!tests! !
!JSDecorationTest categoriesFor: #testCallWithWithWith!public!tests! !
!JSDecorationTest categoriesFor: #testConcatenate!public!tests! !
!JSDecorationTest categoriesFor: #testCondition!public!tests! !
!JSDecorationTest categoriesFor: #testConfirm!public!tests! !
!JSDecorationTest categoriesFor: #testCreate!public!tests! !
!JSDecorationTest categoriesFor: #testInterval!public!tests! !
!JSDecorationTest categoriesFor: #testNot!public!tests! !
!JSDecorationTest categoriesFor: #testProperty!public!tests! !
!JSDecorationTest categoriesFor: #testReturn!public!tests! !
!JSDecorationTest categoriesFor: #testThenElse!public!tests! !
!JSDecorationTest categoriesFor: #testTimeout!public!tests! !

JSJsonTest guid: (GUID fromString: '{14F5F9A0-7A3D-4444-AC3F-42D92519733F}')!
JSJsonTest comment: ''!
!JSJsonTest categoriesForClass!Unclassified! !
!JSJsonTest methodsFor!

json
	^ JSJson context: self renderContext!

testParse
	self 
		assert: (self json parse: '[1,2]')
		equals: 'JSON.parse("[1,2]")'.
	self 
		assert: (self json parse: '[1,2]' reviver: 'return null')
		equals: 'JSON.parse("[1,2]",function(){return null})'!

testStringify
	self 
		assert: (self json stringify: self mock)
		equals: 'JSON.stringify(mock)'.
	self 
		assert: (self json stringify: self mock space: 4)
		equals: 'JSON.stringify(mock,4)'.
	self 
		assert: (self json stringify: self mock replacer: #())
		equals: 'JSON.stringify(mock,[])'.
	self 
		assert: (self json stringify: self mock replacer: #() space: ' ')
		equals: 'JSON.stringify(mock,[]," ")'! !
!JSJsonTest categoriesFor: #json!accessing!public! !
!JSJsonTest categoriesFor: #testParse!public!tests! !
!JSJsonTest categoriesFor: #testStringify!public!tests! !

JSLoggingTest guid: (GUID fromString: '{C41D5F94-8242-46D9-B547-A4FC43B3629A}')!
JSLoggingTest comment: ''!
!JSLoggingTest categoriesForClass!Unclassified! !
!JSLoggingTest methodsFor!

logger
	^ JSLogger context: self renderContext!

testAssert
	self 
		assert: (self logger assert: true)
		equals: 'console.assert(true)'.
	self
		assert: (self logger assertTrue: true)
		equals: 'console.assertTrue(true)'.
	self 
		assert: (self logger assertFalse: false)
		equals: 'console.assertFalse(false)'.
	self
		assert: (self logger assertNull: nil)
		equals: 'console.assertNull(null)'.
	self
		assert: (self logger assertNotNull: 1)
		equals: 'console.assertNotNull(1)'.
	self
		assert: (self logger assertUndefined: nil)
		equals: 'console.assertUndefined(null)'.
	self
		assert: (self logger assertNotUndefined: 1)
		equals: 'console.assertNotUndefined(1)'!

testComparison
	self
		assert: (self logger assert: 1 equals: 1)
		equals: 'console.assertEquals(1,1)'.
	self
		assert: (self logger assert: 1 notEquals: 2)
		equals: 'console.assertNotEquals(1,2)'.
	self
		assert: (self logger assert: 1 greater: 2)
		equals: 'console.assertGreater(1,2)'.
	self
		assert: (self logger assert: 2 notGreater: 1)
		equals: 'console.assertNotGreater(2,1)'.
	self
		assert: (self logger assert: 2 less: 1)
		equals: 'console.assertLess(2,1)'.
	self
		assert: (self logger assert: 1 notLess: 2)
		equals: 'console.assertNotLess(1,2)'!

testLogging
	self
		assert: (self logger log: 'done')
		equals: 'console.log("done")'.
	self
		assert: (self logger log: 'done %s and %s' format: #( 'this' 'that' ))
		equals: 'console.log("done %s and %s","this","that")'!

testMessages
	self
		assert: (self logger debug: 3)
		equals: 'console.debug(3)'.
	self
		assert: (self logger info: 'eye m here 2')
		equals: 'console.info("eye m here 2")'.
	self
		assert: (self logger warn: 'don"t 4get ur grlfrnd')
		equals: 'console.warn("don\"t 4get ur grlfrnd")'.
	self
		assert: (self logger error: 'gone gone gone')
		equals: 'console.error("gone gone gone")'! !
!JSLoggingTest categoriesFor: #logger!accessing!public! !
!JSLoggingTest categoriesFor: #testAssert!public!tests! !
!JSLoggingTest categoriesFor: #testComparison!public!tests! !
!JSLoggingTest categoriesFor: #testLogging!public!tests! !
!JSLoggingTest categoriesFor: #testMessages!public!tests! !

JSRenderingTest guid: (GUID fromString: '{F5AF2B19-3F44-4061-B9E4-7C7EF328F969}')!
JSRenderingTest comment: ''!
!JSRenderingTest categoriesForClass!Unclassified! !
!JSRenderingTest methodsFor!

testAddToEvent
	self 
		assert: [ :html | html div onClick: self mock ]
		renders: '<div onclick="mock"></div>'.
	self 
		assert: [ :html | html div onMouseOut: self mock ]
		renders: '<div onmouseout="mock"></div>'.
	self 
		assert: [ :html | html div onKeyUp: self mock ]
		renders: '<div onkeyup="mock"></div>'!

testAddToScript
	self 
		assert: [ :html | html script: self mock ]
		renders: '<script type="text/javascript">/*<!![CDATA[*/mock/*]]>*/</script>'!

testJavascript
	self 
		assert: [ :html | html div onClick: (html javascript add: self mock; add: self mock; yourself) ]
		renders: '<div onclick="mock;mock"></div>'!

testLogger
	self 
		assert: [ :html | html div onClick: (html logger log: 'Foo') ]
		renders: '<div onclick="console.log(&quot;Foo&quot;)"></div>'!

testPassenger
	self 
		assert: [ :html | html div passenger: self ]
		renders: '<div id="id1"></div>'.
	self 
		assert: [ :html | 
			html div passenger: self.
			html div passenger: self class ]
		renders: '<div id="id1"></div><div id="id2"></div>'!

testRenderOn
	self 
		assert: [ :html | html html: (html javascript render: 123) ]
		renders: '123'.
	self 
		assert: [ :html | html html: (html javascript render: 'abc') ]
		renders: 'abc'.
	self 
		assert: [ :html | html html: (html javascript render: [ :h | h div ]) ]
		renders: '<div></div>'!

testScript
	self 
		assert: [ :html | html div script: self mock ]
		renders: '<div></div><script type="text/javascript">/*<!![CDATA[*/mock;/*]]>*/</script>'!

testScriptOn
	self 
		assert: [ :html | html html: (html javascript script: [ :s | ]) ]
		renders: ''.
	self 
		assert: [ :html | html html: (html javascript script: [ :s | s add: self mock ]) ]
		renders: 'mock'.
	self 
		assert: [ :html | html html: (html javascript script: [ :s | s add: self mock; add: self mock ]) ]
		renders: 'mock;mock'! !
!JSRenderingTest categoriesFor: #testAddToEvent!public!tests! !
!JSRenderingTest categoriesFor: #testAddToScript!public!tests! !
!JSRenderingTest categoriesFor: #testJavascript!public!tests! !
!JSRenderingTest categoriesFor: #testLogger!public!tests! !
!JSRenderingTest categoriesFor: #testPassenger!public!tests! !
!JSRenderingTest categoriesFor: #testRenderOn!public!tests! !
!JSRenderingTest categoriesFor: #testScript!public!tests! !
!JSRenderingTest categoriesFor: #testScriptOn!public!tests! !

JSScriptTest guid: (GUID fromString: '{567A595B-08A4-4EF0-8600-EAAE38847849}')!
JSScriptTest comment: ''!
!JSScriptTest categoriesForClass!Unclassified! !
!JSScriptTest methodsFor!

function
	^ JSFunction context: self renderContext!

script
	^ JSScript context: self renderContext!

testAdd
	| script element |
	script := self script.
	element := self stream nextPutAll: 'foo'.
	self assert: (script add: element) == element.
	self assert: script equals: 'foo'.
	element := self stream nextPutAll: 'bar'.
	self assert: (script add: element) == element.
	self assert: script equals: 'foo;bar'!

testAddAll
	| script elements |
	script := self script.
	elements := Array 
		with: (self stream nextPutAll: 'foo')
		with: (self stream nextPutAll: 'bar').
	self assert: (script addAll: elements) == elements.
	self assert: script equals: 'foo;bar'!

testAlert
	self assert: (self script alert: 'Be Alert') equals: 'alert("Be Alert")'!

testArgument
	| function |
	function := self function arguments: #(a b c).
	self assert: (function argument = #(a b c)).
	self assert: (function arguments = #(a b c))!

testArguments
	self
		assert: (self function arguments: #(a))
		equals: 'function(a){}'.
	self
		assert: (self function arguments: #(a b))
		equals: 'function(a,b){}'!

testAsFunction
	self
		assert: (self script asFunction: #(a))
		equals: 'function(a){}'.
	self
		assert: (self function asFunction: #(a b))
		equals: 'function(a,b){}'!

testCallback
	self assert: (self script callback: [ ]) equals: 'window.location="http://www.seaside.st/?_s=1&_k=a&1"'!

testComma
	| script element |
	script := self script.
	element := self stream nextPutAll: 'foo'.
	self assert: (script , element) == script.
	self assert: script equals: 'foo'.
	element := self stream nextPutAll: 'bar'.
	self assert: (script , element) == script.
	self assert: script equals: 'foo;bar'!

testConvert
	self
		assert: self function
		equals: 'function(){}'.
	self
		assert: self function asFunction
		equals: 'function(){}'.
	self 
		assert: 'alert("1")' asFunction
		equals: 'function(){alert("1")}'!

testEmpty
	self assert: self script equals: ''!

testGoto
	self assert: (self script goto: 'http://www.seaside.st') equals: 'window.location="http://www.seaside.st"'!

testLogger
	self assert: (self script logger log: 'Hello Wold') equals: 'console.log("Hello Wold")'!

testRefresh
	self assert: self script refresh equals: 'window.location="http://www.seaside.st/?_s=1&_k=a"'!

testReturn
	| function |
	function := self function.
	function add: (self stream nextPutAll: 'foo').
	function add: (self stream nextPutAll: 'bar').
	function add: (self stream nextPutAll: 'baz').
	self assert: function equals: 'function(){foo;bar;baz}'.

	function := self function return: true.
	function add: (self stream nextPutAll: 'foo').
	function add: (self stream nextPutAll: 'bar').
	function add: (self stream nextPutAll: 'baz').
	self assert: function equals: 'function(){foo;bar;return baz}'!

testShift
	| script element |
	script := self script.
	element := self stream nextPutAll: 'foo'.
	self assert: (script << element) == element.
	self assert: script equals: 'foo'.
	element := self stream nextPutAll: 'bar'.
	self assert: (script << element) == element.
	self assert: script equals: 'foo;bar'! !
!JSScriptTest categoriesFor: #function!accessing!public! !
!JSScriptTest categoriesFor: #script!accessing!public! !
!JSScriptTest categoriesFor: #testAdd!public!tests-compose! !
!JSScriptTest categoriesFor: #testAddAll!public!tests-compose! !
!JSScriptTest categoriesFor: #testAlert!public!tests-utilities! !
!JSScriptTest categoriesFor: #testArgument!public!tests-function! !
!JSScriptTest categoriesFor: #testArguments!public!tests-function! !
!JSScriptTest categoriesFor: #testAsFunction!public!tests-function! !
!JSScriptTest categoriesFor: #testCallback!public!tests-utilities! !
!JSScriptTest categoriesFor: #testComma!public!tests-compose! !
!JSScriptTest categoriesFor: #testConvert!public!tests! !
!JSScriptTest categoriesFor: #testEmpty!public!tests! !
!JSScriptTest categoriesFor: #testGoto!public!tests-utilities! !
!JSScriptTest categoriesFor: #testLogger!public!tests-utilities! !
!JSScriptTest categoriesFor: #testRefresh!public!tests-utilities! !
!JSScriptTest categoriesFor: #testReturn!public!tests-function! !
!JSScriptTest categoriesFor: #testShift!public!tests-compose! !

JSStreamTest guid: (GUID fromString: '{D163A2EC-E346-426D-BA44-99716A0995C6}')!
JSStreamTest comment: ''!
!JSStreamTest categoriesForClass!Unclassified! !
!JSStreamTest methodsFor!

testArgument
	| stream |
	stream := self stream argument: 1.
	self assert: stream contents = '(1)'!

testArguments
	| stream |
	stream := self stream arguments: #(1 2 3).
	self assert: stream contents = '(1,2,3)'!

testCharacter
	self assert: $a equals: '"a"'!

testCopy
	| stream1 stream2 |
	stream1 := self stream nextPutAll: 'foo'.
	stream2 := stream1 copy nextPutAll: 'bar'.
	stream1 nextPutAll: 'zork'.
	self assert: stream1 contents = 'foozork'.
	self assert: stream2 contents = 'foobar'!

testEncodeKeyValueOn
	| actual |
	actual := String streamContents: [ :stream |
		JSStream encodeKey: 'key' value: 'value' on: stream ].
	self assert: actual = '"key":"value"'!

testJavascript
	| stream |
	stream := self stream javascript: #(1 2).
	self assert: stream contents = '[1,2]'!

testLiteral
	self assert: true equals: 'true'.
	self assert: false equals: 'false'.
	self assert: nil equals: 'null'!

testNewArgument
	self assert: (JSStream argument: 0) equals: 'arguments[0]'.
	self assert: (JSStream argument: 1) equals: 'arguments[1]'.
	self deny: (JSStream argument: 1) == (JSStream argument: 1)!

testNewArgumentAt
	self assert: (JSStream argumentAt: 1) equals: 'arguments[0]'.
	self assert: (JSStream argumentAt: 2) equals: 'arguments[1]'.
	self deny: (JSStream argumentAt: 1) == (JSStream argument: 1)!

testNewOn
	self assert: (JSStream on: 'mock') equals: 'mock'!

testNewThis
	self assert: JSStream this equals: 'this'.
	self deny: JSStream this == JSStream this!

testNextPut
	| stream |
	stream := self stream nextPut: $f.
	self assert: stream contents = 'f'!

testNextPutAll
	| stream |
	stream := self stream nextPutAll: 'foo'.
	self assert: stream contents = 'foo'!

testNumber
	self assert: 123 equals: '123'.
	self assert: 123.4 equals: '123.4'.!

testStringBasic
	self assert: 'abc' equals: '"abc"'.
	self assert: '123' equals: '"123"'!

testStringEscaping
	self assert: '''' equals: '"''"'.
	self assert: '"' equals: '"\""'.
	self assert: '\' equals: '"\\"'!

testStringSpecial
	self assert: (String with: Character cr) equals: '"\r"'.
	self assert: (String with: Character lf) equals: '"\n"'.
	self assert: (String with: Character tab) equals: '"\t"'.

	self assert: (String with: (Character codePoint: 0)) equals: '"\0"'.
	self assert: (String with: (Character codePoint: 1)) equals: '"\x01"'.
	self assert: (String with: (Character codePoint: 31)) equals: '"\x1f"'! !
!JSStreamTest categoriesFor: #testArgument!public!tests! !
!JSStreamTest categoriesFor: #testArguments!public!tests! !
!JSStreamTest categoriesFor: #testCharacter!public!tests-literals! !
!JSStreamTest categoriesFor: #testCopy!public!tests! !
!JSStreamTest categoriesFor: #testEncodeKeyValueOn!public!tests-encoding! !
!JSStreamTest categoriesFor: #testJavascript!public!tests! !
!JSStreamTest categoriesFor: #testLiteral!public!tests-literals! !
!JSStreamTest categoriesFor: #testNewArgument!public!tests-constructor! !
!JSStreamTest categoriesFor: #testNewArgumentAt!public!tests-constructor! !
!JSStreamTest categoriesFor: #testNewOn!public!tests-constructor! !
!JSStreamTest categoriesFor: #testNewThis!public!tests-constructor! !
!JSStreamTest categoriesFor: #testNextPut!public!tests! !
!JSStreamTest categoriesFor: #testNextPutAll!public!tests! !
!JSStreamTest categoriesFor: #testNumber!public!tests-literals! !
!JSStreamTest categoriesFor: #testStringBasic!public!tests-literals! !
!JSStreamTest categoriesFor: #testStringEscaping!public!tests-literals! !
!JSStreamTest categoriesFor: #testStringSpecial!public!tests-literals! !

"Binary Globals"!

