| package |
package := Package name: 'RSS-Examples'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '24'.


package classNames
	add: #RRChange;
	add: #RRDemo;
	add: #RRStylesOne;
	add: #RRStylesThree;
	add: #RRStylesTwo;
	yourself.

package methodNames
	add: 'GRPackage class' -> #rssExamples;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: '..\..\IDB\IDB DateAndTime';
	add: 'RSS-Core';
	add: '..\Seaside\Seaside-Core';
	add: '..\Seaside\Seaside-Tools-Core';
	yourself).

package!

"Class Definitions"!

WAObject subclass: #RRChange
	instanceVariableNames: 'timestamp author title description changedClass changedSelector sourceCode'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFileLibrary subclass: #RRStylesOne
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFileLibrary subclass: #RRStylesThree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFileLibrary subclass: #RRStylesTwo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
RRComponent subclass: #RRDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

rssExamples
	^ self new
		name: 'RSS-Examples';
		description: 'Examples of how to use the "RSS-Core" package.';
		addDependency: 'RSS-Core';
		addDependency: 'Seaside-Tools-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #rssExamples!*rss-examples!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

RRChange guid: (GUID fromString: '{DF3A1BCD-CB6D-4D29-ADF3-5EE992E899D1}')!
RRChange comment: ''!
!RRChange categoriesForClass!Unclassified! !
!RRChange methodsFor!

addParametersTo: aUrl
	self hasChangedClass ifFalse: [^self].
	aUrl addField: 'class' value: self changedClassName.
	self hasChangedSelector ifTrue: [
		aUrl addField: 'method' value: self changedSelector ].
	self isMeta ifTrue: [
		aUrl addField: 'meta']
!

author
	^author!

author: anObject
	author := anObject!

changedClass
	^ changedClass!

changedClass: anObject
	changedClass := anObject!

changedClassName
	self hasChangedClass ifFalse: [^nil].
	^ self changedClass theNonMetaClass fullName!

changedSelector
	^ changedSelector!

changedSelector: aSymbol
	changedSelector := aSymbol!

description
	^description ifNil: [ self sourceCode ].!

description: aString
	description := aString!

hasChangedClass
	"Some VW changes are not about any specific class"
	^self changedClass notNil!

hasChangedSelector
	^self changedSelector notNil!

isMeta
	^self changedClass isMeta!

sourceCode
	^sourceCode!

sourceCode: aString
	sourceCode := aString!

sourceCodeLimitedTo: max
	self sourceCode ifNil: [ ^String new ].
	^self sourceCode copyFrom: 1 to: (max min: self sourceCode size)!

timestamp
	^timestamp!

timestamp: aTimestamp
	timestamp := aTimestamp!

title
	^title!

title: aString
	title := aString! !
!RRChange categoriesFor: #addParametersTo:!api!public! !
!RRChange categoriesFor: #author!accessing!public! !
!RRChange categoriesFor: #author:!accessing!public! !
!RRChange categoriesFor: #changedClass!accessing!public! !
!RRChange categoriesFor: #changedClass:!accessing!public! !
!RRChange categoriesFor: #changedClassName!api!public! !
!RRChange categoriesFor: #changedSelector!accessing!public! !
!RRChange categoriesFor: #changedSelector:!accessing!public! !
!RRChange categoriesFor: #description!accessing!public! !
!RRChange categoriesFor: #description:!accessing!public! !
!RRChange categoriesFor: #hasChangedClass!public!testing! !
!RRChange categoriesFor: #hasChangedSelector!public!testing! !
!RRChange categoriesFor: #isMeta!public!testing! !
!RRChange categoriesFor: #sourceCode!accessing!public! !
!RRChange categoriesFor: #sourceCode:!accessing!public! !
!RRChange categoriesFor: #sourceCodeLimitedTo:!api!public! !
!RRChange categoriesFor: #timestamp!accessing!public! !
!RRChange categoriesFor: #timestamp:!accessing!public! !
!RRChange categoriesFor: #title!accessing!public! !
!RRChange categoriesFor: #title:!accessing!public! !

RRStylesOne guid: (GUID fromString: '{1D2FF17B-8542-4E2F-A508-54BE8EAB0851}')!
RRStylesOne comment: ''!
!RRStylesOne categoriesForClass!Unclassified! !
!RRStylesOne methodsFor!

selectorsToInclude
	^#(
		styleCss
	)!

styleCss
	^'
rss {
	display: block;
	font-family: verdana, arial;
}
title {
	display: block;
	margin: 5px;
	padding: 2px;
	color: gray;
	border-bottom: 1px solid silver;
}
link {
	display: block;
	font-size: small;
	padding-left: 10px;
}
item {
	display: block;
	padding: 2px 30px 2px 30px;
}
docs {
	display: block;
	background-color: #ffffe6;
	margin: 20px;
	text-align: center;
	padding: 5px;
	color: #7f7f7f;
	border: 1px solid silver;
}
/* all hidden elements */
language, lastBuildDate, ttl, guid, category, description, pubDate {
	display: none;
}
'! !
!RRStylesOne categoriesFor: #selectorsToInclude!css!public! !
!RRStylesOne categoriesFor: #styleCss!css!public! !

RRStylesThree guid: (GUID fromString: '{E70A67D3-4525-4004-9FBD-FA395304683C}')!
RRStylesThree comment: ''!
!RRStylesThree categoriesForClass!Unclassified! !
!RRStylesThree methodsFor!

styleXsl
	^'<?xml version="1.0" encoding="utf8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="/rss">
 	<html>
 	<head>
 	    <link href="some-more-work-to-do-here.css" rel="stylesheet" type="text/css" />
 	    <style type="text/css">
 	    body {
 	        font-size:0.83em;
 	    }
 	    </style>
 	</head>
 	<body>
 	    <div id="logo">
 	        <xsl:element name="a">
 	            <xsl:attribute name="href">
 	                <xsl:value-of select="channel/link" />
 	            </xsl:attribute>
 	            <xsl:value-of select="channel/title" />
 	        </xsl:element>
 	    </div>
 	    <div class="Snippet" style="border-width:0; background-color:#FFF; margin:1em">
 	        <div class="titleWithLine">
 	            <xsl:value-of select="channel/description" />
 	        </div>
 	        <dl style="padding-right:1em">
 	            <xsl:for-each select="channel/item">
 	                <dd>
 	                    <xsl:element name="a">
 	                        <xsl:attribute name="href">
 	                            <xsl:value-of select="link"/>
 	                        </xsl:attribute>
 	                        <xsl:value-of select="title"/>
 	                    </xsl:element>
 	                </dd>
 	                <dt>
 	                    <xsl:value-of select="description" /><br />
 	                    <span class="comments"><xsl:value-of select="pubDate" /></span>
 	                </dt>
 	            </xsl:for-each>
 	        </dl>
 	    </div>
 	    <div id="footer">
 	        <xsl:value-of select="channel/copyright" />
 	    </div>
 	</body>
 	</html>
 	</xsl:template>
 	</xsl:stylesheet>
'!

updateRoot: anHtmlRoot
	anHtmlRoot stylesheet beXsl url: (self urlOf: #styleXsl)! !
!RRStylesThree categoriesFor: #styleXsl!public!xslt! !
!RRStylesThree categoriesFor: #updateRoot:!path!public! !

RRStylesTwo guid: (GUID fromString: '{F0B3F3C0-B5B5-480B-A072-29FE62357FCC}')!
RRStylesTwo comment: ''!
!RRStylesTwo categoriesForClass!Unclassified! !
!RRStylesTwo methodsFor!

selectorsToInclude
	^#(
		styleCss
		style2Css
	)!

style2Css
	^'
channel link, channel language, channel copyright, channel managingEditor, channel webMaster, channel docs, channel lastBuildDate {
	    display:none;
}
rss {
 	    font-family:Verdana, Arial, Helvetica, sans-serif;
 	    font-size:0.7em;
 	    line-height:130%;
 	    margin:1em;
 }
/* HEADER */
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
channel title {
 	    display:block;
 	    padding:0.4em 0.2em;
 	    color:#FFF;
 	    border-bottom:1px solid black;
 	    font-weight:bold;
 	    font-size:140%;
 	    background-color:#4483C7;
}
channel description {
 	    display:block;
 	    float:left;
 	    font-size:130%;
 	    font-weight:bold;
 	    margin:0.5em;
}
/* CONTENT */
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
channel item {
 	    background-color:#FFFFEE;
 	    border:1px solid #538620;
 	    clear:both;
 	    display:block;
 	    padding:0 0 0.5em;
 	    margin:1em;
}
channel item title {
 	    background-color:#538620;
 	    border-bottom-width:0;
 	    color:#FFF;
 	    display:block;
 	    font-size:110%;
 	    font-weight:bold;
 	    margin:0;
 	    padding:0.3em 0.5em;
}
channel item description {
 	    display: block;
 	    float:none;
 	    margin:0;
 	    text-align: left;
 	    padding:0.2em 0.5em 0.4em;
 	    color: black;
 	    font-size:100%;
 	    font-weight:normal;
}
channel item link {
 	    color:#666;
 	    display:block;
 	    font-size:86%;
 	    padding:0 0.5em;
}
channel item pubDate {
 	    color:#666;
 	    display:block;
 	    font-size:86%;
	    padding:0 0.5em;
}
'!

styleCss
	^'
channel link, channel language, channel copyright, channel managingEditor, channel webMaster, channel docs, channel lastBuildDate {
	    display:none;
}
rss {
 	    font-family:Verdana, Arial, Helvetica, sans-serif;
 	    font-size:0.7em;
 	    line-height:130%;
 	    margin:1em;
 }
/* HEADER */
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
channel title {
 	    display:block;
 	    padding:0.4em 0.2em;
 	    color:#FFF;
 	    border-bottom:1px solid black;
 	    font-weight:bold;
 	    font-size:140%;
 	    background-color:#4483C7;
}
channel description {
 	    display:block;
 	    float:left;
 	    font-size:130%;
 	    font-weight:bold;
 	    margin:0.5em;
}
/* CONTENT */
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
channel item {
 	    background-color:#FFFFEE;
 	    border:1px solid #538620;
 	    clear:both;
 	    display:block;
 	    padding:0 0 0.5em;
 	    margin:1em;
}
channel item title {
 	    background-color:#538620;
 	    border-bottom-width:0;
 	    color:#FFF;
 	    display:block;
 	    font-size:110%;
 	    font-weight:bold;
 	    margin:0;
 	    padding:0.3em 0.5em;
}
channel item description {
 	    display: block;
 	    float:none;
 	    margin:0;
 	    text-align: left;
 	    padding:0.2em 0.5em 0.4em;
 	    color: black;
 	    font-size:100%;
 	    font-weight:normal;
}
channel item link {
 	    color:#666;
 	    display:block;
 	    font-size:86%;
 	    padding:0 0.5em;
}
channel item pubDate {
 	    color:#666;
 	    display:block;
 	    font-size:86%;
	    padding:0 0.5em;
}
'! !
!RRStylesTwo categoriesFor: #selectorsToInclude!accessing!public! !
!RRStylesTwo categoriesFor: #style2Css!css!public! !
!RRStylesTwo categoriesFor: #styleCss!css!public! !

RRDemo guid: (GUID fromString: '{2B63B5A1-AE15-4765-8591-7074A274B23A}')!
RRDemo comment: ''!
!RRDemo categoriesForClass!Unclassified! !
!RRDemo methodsFor!

firstPublicationDate
	^DateAndTime
		year: 2003
		month: 6
		day: 3
		hour: 9
		minute: 39
		second: 21!

fourthPublicationDate
	^DateAndTime
		year: 2003
		month: 5
		day: 20
		hour: 8
		minute: 56
		second: 02!

renderChannelOn: rss
	rss title: 'Liftoff News'.
	rss link: 'http://liftoff.msfc.nasa.gov/'.
	rss description: 'Liftoff to Space Exploration.'.
	rss language englishUnitedStates.
	rss publicationDate: 'Tue, 10 Jun 2003 04:00:00 GMT'.
	rss lastBuildDate: 'Tue, 10 Jun 2003 09:41:01 GMT'.
	rss defaultDocumentation.
	rss generator: 'Weblog Editor 2.0'.
	rss managingEditor: 'editor@example.com'.
	rss webMaster: 'webmaster@example.com'!

renderContentOn: rss
	self renderChannelOn: rss.
	self renderFirstItemOn: rss.
	self renderSecondItemOn: rss.
	self renderThirdItemOn: rss.
	self renderFourthtemOn: rss!

renderFirstItemOn: rss
	rss item: [
		rss title: 'Star City'.
		rss author: 'joesmith@example.com (Joe Smith)'.
		rss link: 'http://liftoff.msfc.nasa.gov/news/2003/news-starcity.asp'.
		rss description: 'How do Americans get ready to work with Russians aboard the International Space Station? They take a crash course in culture, language and protocol at Russia''s Star City.'.
		rss publicationDate: (RRRfc822DateTime newDateAndTime: self firstPublicationDate).
		rss guid: 'http://liftoff.msfc.nasa.gov/2003/06/03.html#item573' ]!

renderFourthtemOn: rss
	rss item: [
		rss title: 'Astronauts'' Dirty Laundry'.
		rss author: (WAEmailAddress address: 'joesmith@example.com').
		rss link: 'http://liftoff.msfc.nasa.gov/news/2003/news-laundry.asp'.
		rss description: 'Compared to earlier spacecraft, the International Space Station has many luxuries, but laundry facilities are not one of them. Instead, astronauts have other options.'.
		rss publicationDate: 'Tue, 20 May 2003 08:56:02 GMT'.
		rss guid: 'http://liftoff.msfc.nasa.gov/2003/05/20.html#item570' ]!

renderSecondItemOn: rss
	rss item: [
		rss title: 'Space Exploration'.
		rss author: 'Joe Smith <joesmith@example.com>'.
		rss link: 'http://liftoff.msfc.nasa.gov/'.
		rss description: 'Sky watchers in Europe, Asia, and parts of Alaska and Canada will experience a partial eclipse of the Sun on Saturday, May 31st.'.
		rss publicationDate: (RRRfc822DateTime newUtc: self secondPublicationDate).
		rss guid: 'http://liftoff.msfc.nasa.gov/2003/05/30.html#item572' ]!

renderThirdItemOn: rss
	rss item: [
		rss title: 'The Engine That Does More'.
		rss author: (WAEmailAddress address: 'joesmith@example.com' username: 'Joe Smith').
		rss link: 'http://liftoff.msfc.nasa.gov/news/2003/news-VASIMR.asp'.
		rss description: 'Before man travels to Mars, NASA hopes to design new engines that will let us fly through the Solar System more quickly.  The proposed VASIMR engine would do that.'.
		rss publicationDate: (RRRfc822DateTime dateAndTime: self thirdPublicationDate timeZoneString: 'EST').
		rss guid: 'http://liftoff.msfc.nasa.gov/2003/05/27.html#item571' ]!

secondPublicationDate
	^DateAndTime
		year: 2003
		month: 5
		day: 30
		hour: 11
		minute: 6
		second: 42!

thirdPublicationDate
	^DateAndTime
		year: 2003
		month: 5
		day: 27
		hour: 8
		minute: 37
		second: 32! !
!RRDemo categoriesFor: #firstPublicationDate!private! !
!RRDemo categoriesFor: #fourthPublicationDate!private! !
!RRDemo categoriesFor: #renderChannelOn:!public!rendering! !
!RRDemo categoriesFor: #renderContentOn:!public!rendering! !
!RRDemo categoriesFor: #renderFirstItemOn:!public!rendering! !
!RRDemo categoriesFor: #renderFourthtemOn:!public!rendering! !
!RRDemo categoriesFor: #renderSecondItemOn:!public!rendering! !
!RRDemo categoriesFor: #renderThirdItemOn:!public!rendering! !
!RRDemo categoriesFor: #secondPublicationDate!private! !
!RRDemo categoriesFor: #thirdPublicationDate!private! !

!RRDemo class methodsFor!

canBeRoot
	^true!

description
	^'RSS Demo'!

initialize
	(WAAdmin register: RRRssHandler at: 'examples/demo.rss')
		rootComponentClass: self! !
!RRDemo class categoriesFor: #canBeRoot!public!testing! !
!RRDemo class categoriesFor: #description!accessing!public! !
!RRDemo class categoriesFor: #initialize!class initialization!public! !

"Binary Globals"!

