| package |
package := Package name: 'Scriptaculous-Components'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '105'.


package classNames
	add: #SUAccordion;
	add: #SUCarousel;
	add: #SUComponentLibrary;
	add: #SUDatePicker;
	add: #SUDateTimePicker;
	add: #SUHorizontalCarousel;
	add: #SUHorizontalSplitter;
	add: #SULightbox;
	add: #SUNavigation;
	add: #SUNavigationCarousel;
	add: #SUNavigationItem;
	add: #SURenderableItem;
	add: #SUSplitter;
	add: #SUSplitterItem;
	add: #SUTabPanel;
	add: #SUTieredList;
	add: #SUTitlePane;
	add: #SUTreeReport;
	add: #SUTreeReportColumn;
	add: #SUVerticalCarousel;
	add: #SUVerticalSplitter;
	add: #SUWindow;
	yourself.

package methodNames
	add: #WAComponent -> #lightbox:;
	add: 'GRPackage class' -> #scriptaculousComponents;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: '..\..\IDB\IDB DateAndTime';
	add: '..\Javascript\Javascript-Core';
	add: '..\Prototype\Prototype-Core';
	add: '..\Seaside\Seaside-Component';
	add: '..\Seaside\Seaside-Core';
	add: '..\Seaside\Seaside-Widgets';
	yourself).

package!

"Class Definitions"!

WAObject subclass: #SURenderableItem
	instanceVariableNames: 'owner body'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #SUTreeReportColumn
	instanceVariableNames: 'owner renderer label'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SURenderableItem subclass: #SUNavigationItem
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SURenderableItem subclass: #SUSplitterItem
	instanceVariableNames: 'min size'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFileLibrary subclass: #SUComponentLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #SUNavigation
	instanceVariableNames: 'items uid'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #SUSplitter
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #SUTieredList
	instanceVariableNames: 'selectionPath childrenBlock labelBlock uid'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #SUTitlePane
	instanceVariableNames: 'title body open uid loaded alwaysRefresh'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #SUTreeReport
	instanceVariableNames: 'uids roots columns expanded childrenBlock expandableBlock'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #SUWindow
	instanceVariableNames: 'title component id updateBlock componentBlock extent origin properties collapsed visible'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUNavigation subclass: #SUAccordion
	instanceVariableNames: 'visible maxVisible'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUNavigation subclass: #SUCarousel
	instanceVariableNames: 'elementExtent numVisible scrollInc offset navMargin elementMargin animationSpeed created'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUNavigation subclass: #SUNavigationCarousel
	instanceVariableNames: 'selected elementHeight visibleElements offset'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUNavigation subclass: #SUTabPanel
	instanceVariableNames: 'selected'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUCarousel subclass: #SUHorizontalCarousel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUCarousel subclass: #SUVerticalCarousel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUSplitter subclass: #SUHorizontalSplitter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUSplitter subclass: #SUVerticalSplitter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAMiniCalendar subclass: #SUDatePicker
	instanceVariableNames: 'widgetId uid format origin containerId open'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUDatePicker subclass: #SUDateTimePicker
	instanceVariableNames: 'showSeconds hours minutes seconds'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WADecoration subclass: #SULightbox
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

scriptaculousComponents
	^ self new
		name: 'Scriptaculous-Components';
		description: 'A collection of AJAX based widgets written on top of script.aculo.us and Prototype.';
		addDependency: 'Scriptaculous-Core';
		addDependency: 'Seaside-Flow'; "Flow is used to implement #lightbox:"
		addDependency: 'Seaside-Widgets';  "SUDatePicker subclasses WAMiniCalendar"
		addDependency: 'Seaside-Component'; "WAComponent is extended"
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #scriptaculousComponents!*scriptaculous-components!public! !

!WAComponent methodsFor!

lightbox: aComponent 
	"Display aComponent within a lightbox of the receiver. Note, that this does a full refresh displaying the lightbox. Also note, that this only works well, if you sent to the root component of your application."

	#jsc.
	"Modified to work without suspended flow.
	Developers should not use lightbox as modal dialogs."
	^self 
		show: aComponent
		onAnswer: []
		delegation: ((SULightbox new)
				delegate: aComponent;
				yourself)! !
!WAComponent categoriesFor: #lightbox:!*scriptaculous-components-call/answer!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

SURenderableItem guid: (GUID fromString: '{64687B54-E13F-4243-B7FD-B8E12F202D3C}')!
SURenderableItem comment: ''!
!SURenderableItem categoriesForClass!Unclassified! !
!SURenderableItem methodsFor!

body
	^ body!

initializeOn: aComponent body: anObject
	self initialize.
	owner := aComponent.
	body := anObject!

isComponent
	"Answer true if the body of the receiver is a component, and therefor needs to be registered as a child."

	^ self body isKindOf: WAComponent!

owner
	^ owner!

renderOn: html 
	html render: self body! !
!SURenderableItem categoriesFor: #body!accessing!public! !
!SURenderableItem categoriesFor: #initializeOn:body:!initialization!public! !
!SURenderableItem categoriesFor: #isComponent!public!testing! !
!SURenderableItem categoriesFor: #owner!accessing!public! !
!SURenderableItem categoriesFor: #renderOn:!public!rendering! !

!SURenderableItem class methodsFor!

on: aComponent body: anObject
	^ self basicNew initializeOn: aComponent body: anObject! !
!SURenderableItem class categoriesFor: #on:body:!instance creation!public! !

SUTreeReportColumn guid: (GUID fromString: '{15F0EFDC-D1E6-4847-B744-1B178CFC12FB}')!
SUTreeReportColumn comment: ''!
!SUTreeReportColumn categoriesForClass!Unclassified! !
!SUTreeReportColumn methodsFor!

initializeOn: aComponent
	self initialize.
	owner := aComponent!

label
	^label!

label: aString
	label := aString!

render: anObject indent: anInteger on: html
	html div class: 'indent'; with: [
		anInteger timesRepeat: [ html div class: 'block' ].
		html div class: 'block'; with: [
			(owner isExpandable: anObject) ifTrue: [
				html anchor
					class: 'expanded' if: (owner isExpanded: anObject);
					onClick: (html prototype evaluator 
						callback: [ :script | owner toggle: anObject level: anInteger on: script ];
						return: false) ] ].
		html div class: 'text'; with: [ self render: anObject on: html ] ]!

render: anObject on: html
	html render: (renderer value: anObject)!

renderer
	^renderer!

renderer: aBlock
	renderer := aBlock! !
!SUTreeReportColumn categoriesFor: #initializeOn:!initialization!public! !
!SUTreeReportColumn categoriesFor: #label!accessing!public! !
!SUTreeReportColumn categoriesFor: #label:!accessing!public! !
!SUTreeReportColumn categoriesFor: #render:indent:on:!public!rendering! !
!SUTreeReportColumn categoriesFor: #render:on:!public!rendering! !
!SUTreeReportColumn categoriesFor: #renderer!accessing!public! !
!SUTreeReportColumn categoriesFor: #renderer:!accessing!public! !

!SUTreeReportColumn class methodsFor!

on: aComponent
	^ self basicNew initializeOn: aComponent! !
!SUTreeReportColumn class categoriesFor: #on:!instance creation!public! !

SUNavigationItem guid: (GUID fromString: '{49D590F5-6812-4ACC-B223-91B17803F249}')!
SUNavigationItem comment: ''!
!SUNavigationItem categoriesForClass!Unclassified! !
!SUNavigationItem methodsFor!

label
	^ label!

label: aString
	label := aString! !
!SUNavigationItem categoriesFor: #label!accessing!public! !
!SUNavigationItem categoriesFor: #label:!accessing!public! !

SUSplitterItem guid: (GUID fromString: '{386ACDBA-1A05-45CC-839F-AFE0E429DC82}')!
SUSplitterItem comment: ''!
!SUSplitterItem categoriesForClass!Unclassified! !
!SUSplitterItem methodsFor!

initializeOn: aComponent body: anObject
	super initializeOn: aComponent body: anObject.
	size := '200px'.
	min := 50!

min
	^min!

min: aNumber
	min := aNumber!

size
	^ size!

size: aNumber
	size := aNumber! !
!SUSplitterItem categoriesFor: #initializeOn:body:!initialization!public! !
!SUSplitterItem categoriesFor: #min!accessing!public! !
!SUSplitterItem categoriesFor: #min:!accessing!public! !
!SUSplitterItem categoriesFor: #size!accessing!public! !
!SUSplitterItem categoriesFor: #size:!accessing!public! !

SUComponentLibrary guid: (GUID fromString: '{CF9D9662-B08E-4DE4-BB9D-9A5288BCA955}')!
SUComponentLibrary comment: ''!
!SUComponentLibrary categoriesForClass!Unclassified! !
!SUComponentLibrary methodsFor!

accordionCss
	^ '.accordion dt,
.accordion dd {
	margin: 0;
	padding: 0;
	overflow: auto;
}
.accordion dt {
	padding: 0.25em;
	background-color: #c5dea1;
}
.accordion dt.active {
	background-color: #e8a400;
}
.accordion dt a:link,
.accordion dt a:visited {
	color: #444;
	outline: none;
	display: block;
	padding: 0.25em;
	text-decoration: none;
}
.accordion dt.active a:link,
.accordion dt.active a:visited {
	color: #000;
}
.accordion dd {
	background-color: #fff;
}'!

arrowdownGif
	^ #(71 73 70 56 57 97 16 0 16 0 196 17 0 129 129 129 176 176 176 212 212 212 234 234 234 251 251 251 157 157 157 193 193 193 229 229 229 133 133 133 142 142 142 243 243 243 232 232 232 233 233 233 149 149 149 147 147 147 203 203 203 128 128 128 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33 249 4 1 0 0 17 0 44 0 0 0 0 16 0 16 0 0 5 58 96 36 142 100 105 158 104 106 50 79 235 182 139 233 64 116 77 55 166 97 219 134 73 36 59 72 130 112 18 4 5 169 130 173 160 58 0 158 128 131 42 18 160 5 166 17 5 2 161 192 70 6 3 175 120 236 13 1 0 59) asByteArray!

arrowrightGif
	^ #(71 73 70 56 57 97 16 0 16 0 196 17 0 129 129 129 176 176 176 212 212 212 234 234 234 251 251 251 157 157 157 193 193 193 229 229 229 133 133 133 142 142 142 243 243 243 232 232 232 233 233 233 149 149 149 147 147 147 203 203 203 128 128 128 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33 249 4 1 0 0 17 0 44 0 0 0 0 16 0 16 0 0 5 54 96 36 142 100 105 158 104 106 46 141 65 168 226 3 65 137 0 203 51 84 28 41 158 3 1 197 201 55 3 64 16 3 19 17 98 68 42 115 197 224 16 186 235 205 106 48 134 195 5 235 122 191 167 16 0 59) asByteArray!

carouselComponentCss
^'.carouselComponent {position:relative;border:1px solid #ccc;overflow:hidden}
 .carouselComponent .carousel-list-h {width:10000px;
		position:relative;
		z-index:1}
 .carouselComponent .carousel-list-v {height:10000px;
		position:relative;
		z-index:1}
 .carouselComponent .carousel-element {
		list-style:none;
		overflow:hidden	}
.carousel-float-h {float:left}
.carousel-float-v {clear:left;float:left}
.carouselComponent .buttonh {position:relative;height:100%;float:left;background:#c5dea1;vertical-align:middle;cursor:pointer}
.carouselComponent .buttonv {clear:left;position:relative;text-align:center;background:#c5dea1;cursor:pointer}
  .carouselComponent .clip-region { border:1px dotted #ccc;
		overflow:hidden;
		margin:0px auto;
		position:relative; 
	}'!

carouselCss
	^ '.carousel .nav {position:relative;padding:5px;border:1px solid #ccc;width:140px;height:100%}
	.carousel .inner {position:relative;margin:2px;overflow:hidden}
	.carousel .move {background:white;position:relative;top:0;left:0}
	.carousel .body {border:1px solid #ccc}
	.carousel .action {border:1px solid #ccc;background:#ffffe0;padding:2px}
	.carousel .nav a {text-decoration:none;color:black}
	.carousel td.right {text-align:right}
	.carousel .nav .active {background:#99ccff;border:1px dotted #ccc}' !

datePickerCss
	^ '.calendar {font-family:Arial;font-size:10px;width:150px;z-index:999}
	.calendar .day {text-align:center;border:1px solid #ccc}
	.calendar .main {border:1px solid black;background:#fff}
	.calendar .daySelected {background:#e0e0e0;font-weight:bold}
	.calendar a {text-decoration:none;color:black;}
	.calendar .day a {color:#336699;display:block;width:16px}
	.calendar .day a:hover {background:#aaa;color:white}
	.calendar .monthTable {width:100%}
	.calendar .monthRow {background:#e0e0e0}
	.calendar .calendarTitle {background-color:#f0f0f0}
	.calendar .monthCurrent {font-size:12px;font-family:verdana;width:100%}
	.calendar .yearTable {width:100%;border-top:1px solid #ccc}
	.calendar .year {font-size:10px;font-family:verdana;text-align:center}
	.calendar .year a:hover {background:#aaa;color:white}
	.calendar .yearCurrent {background:#e0e0e0;font-weight:bold}
	.calendar .day a.today {text-decoration:underline;font-weight:bold}
	.calendar .weekDay {text-align:center}
	.calendar .time {border:1px solid #ccc}
	.calendar .time input.text {width:18px}
	.calendar .time a.button {border:1px solid #aaa;background:#ccc;padding:2px;-moz-border-radius:5px;border-radius:5px}
	.calendar .time a.button:hover {background:#69c}' !

selectorsToInclude
	^ #( treeReportCss tabPanelCss accordionCss titlePaneCss carouselCss carouselComponentCss datePickerCss windowCss splitterCss)!

splitterCss
	^ '.splitter-horizontal .handle {
	height: 5px;
	position: relative;
	background-color: #c5dea1;
	cursor: row-resize;
}

.splitter-vertical div {
	float: left;
}
.splitter-vertical div.handle {
	float: left;
	width: 5px;
	height: 200px;
	position: relative;
	cursor: col-resize;
	background-color: #c5dea1;

}'!

tabPanelCss
	"Based on: http://www.kalsey.com/tools/csstabs/"

	^ '.tabPanel ul.head {
	margin: 0;
	padding-left: 1em;
	padding-bottom: 19px;
	border-bottom: 1px solid #ccc;
}
.tabPanel ul.head li	{
	margin: 0;
	padding: 0;
	display: inline;
	list-style-type: none;
}
.tabPanel ul.head a:link, 
.tabPanel ul.head a:visited {
	float: left;
	color: #444;
	outline: none;
	line-height: 14px;
	margin-right: 1em;
	background: #eee;
	text-decoration: none;
	border: 1px solid #ccc;
	padding: 2px 1em 2px 1em;
}
.tabPanel ul.head a:link.active, 
.tabPanel ul.head a:visited.active {
	color: #000;
	background: #fff;
	border-bottom: 1px solid #fff;
}
.tabPanel ul.head a:hover {
	background-color: #fff;
}'!

titlePaneCss
	^ '.titlePane .title {background:#e0e0e0;border-bottom-color:black;border-bottom-style:dotted;border-bottom-width:1px}
	.titlePane {border:4px solid #ccc;width:450px;overflow:hidden}
	.titlePane .body {background:white;height:100%;width:100%;overflow:hidden}
	.titlePane .closed {height:0px;display:none}
	.titlePane a.title {cursor:pointer;
					outline: none;
					padding: 0.25em;
					display: block;
					text-decoration:none;
					color:black}
	.titlePane td.label {width:100%;white-space:nowrap}
	.titlePane .gfx {background-position: center center;
					width:16px;height:10px;
					background-image: url(arrowright.gif)}
	.titlePane .gfxopen {background-position: center center;
					width:16px;height:10px;
					background-image: url(arrowdown.gif)}
	'!

treeReportCss
	^ '.treeReport {
	border: solid 1px #ccc;
	border-collapse: collapse;
	background-color: white;
}
.treeReport th {
	padding: 4px;
	text-align: left;
	background-color: #ccc;
}
.treeReport td {
	text-align: left;
	vertical-align: top;
	padding-right: 5px;
}
.treeReport td .indent {
	height: 16px;
	overflow: hidden;
	white-space: nowrap;
}
.treeReport td .indent .block,
.treeReport td .indent .text {
	float: left;
	height: 16px;
}
.treeReport td .indent .block {
	width: 16px;
}
.treeReport td .indent .block a {
	width: 16px;
	height: 16px;
	outline: none;
	display: block;
	background-position: center center;
	background-image: url(arrowright.gif);
}
.treeReport td .indent .block a.expanded {
	background-image: url(arrowdown.gif);
}'!

windowCss
	^ 'div.suWindow {background:#e0e0e0;border:1px solid #888;overflow:hidden;position:fixed;-moz-border-radius:5px;border-radius:5px}
	.suWindow .container {overflow:auto;padding:2px}
	.suWindow .title {cursor:move;background:#888;color:white;height:16px; padding:2px 2px 3px 3px}
	.suWindow .title a {text-decoration:none;padding:2px;}' ! !
!SUComponentLibrary categoriesFor: #accordionCss!public!styles! !
!SUComponentLibrary categoriesFor: #arrowdownGif!public!uploaded! !
!SUComponentLibrary categoriesFor: #arrowrightGif!public!uploaded! !
!SUComponentLibrary categoriesFor: #carouselComponentCss!public!styles! !
!SUComponentLibrary categoriesFor: #carouselCss!public!styles! !
!SUComponentLibrary categoriesFor: #datePickerCss!public!styles! !
!SUComponentLibrary categoriesFor: #selectorsToInclude!accessing!public! !
!SUComponentLibrary categoriesFor: #splitterCss!public!styles! !
!SUComponentLibrary categoriesFor: #tabPanelCss!public!styles! !
!SUComponentLibrary categoriesFor: #titlePaneCss!public!styles! !
!SUComponentLibrary categoriesFor: #treeReportCss!public!styles! !
!SUComponentLibrary categoriesFor: #windowCss!public!styles! !

SUNavigation guid: (GUID fromString: '{F13C5A55-AD66-40F0-A302-4599DB61963C}')!
SUNavigation comment: ''!
!SUNavigation categoriesForClass!Unclassified! !
!SUNavigation methodsFor!

add: anObject
	"Add anObject to the collection of child items. Answer an instance of SUNavigationItem."

	^ items add: (self navigationItemClass on: self body: anObject)!

add: anObject label: aString
	^ (self add: anObject) label: aString!

children
	^ self visibleComponentsFor: self visible!

cssClass
	"Answer the css class the outermost DOM element will use."

	self subclassResponsibility!

findIndex: anItem ifAbsent: aBlock 
	| index |
	index := items findFirst: [ :each | each = anItem ].
	index isZero ifTrue: [ aBlock value ].
	^ index!

initialize
	super initialize.
	items := OrderedCollection new!

navigationItemClass
	"Answer the navigation class to represent the child items."

	^ SUNavigationItem!

remove: anItem
	"Remove anItem from the collection of child items."

	^ items remove: anItem ifAbsent: [ nil ]!

renderContentOn: html
	uid := html nextId.
	self renderNavigationOn: html!

renderNavigationOn: html
	self subclassResponsibility!

uid
	^ uid!

uid: aString at: anInteger
	^ uid , '_' , aString , '_' , anInteger greaseString!

visible
	"override in subclasses if not all items are displayed, see for example SUTabPanel"
	^items!

visibleComponentsFor: aCollection
	^(aCollection select: [ :each | each isComponent ]) collect: [ :each | each body ]! !
!SUNavigation categoriesFor: #add:!public! !
!SUNavigation categoriesFor: #add:label:!public! !
!SUNavigation categoriesFor: #children!accessing!public! !
!SUNavigation categoriesFor: #cssClass!accessing!public! !
!SUNavigation categoriesFor: #findIndex:ifAbsent:!private! !
!SUNavigation categoriesFor: #initialize!initialization!public! !
!SUNavigation categoriesFor: #navigationItemClass!accessing!public! !
!SUNavigation categoriesFor: #remove:!public! !
!SUNavigation categoriesFor: #renderContentOn:!public!rendering! !
!SUNavigation categoriesFor: #renderNavigationOn:!public!rendering! !
!SUNavigation categoriesFor: #uid!private! !
!SUNavigation categoriesFor: #uid:at:!private! !
!SUNavigation categoriesFor: #visible!accessing!public! !
!SUNavigation categoriesFor: #visibleComponentsFor:!accessing!public! !

SUSplitter guid: (GUID fromString: '{EF884C1B-620C-47F1-8796-E64F051BEF16}')!
SUSplitter comment: ''!
!SUSplitter categoriesForClass!Unclassified! !
!SUSplitter methodsFor!

add: anObject
	^ items add: (SUSplitterItem on: self body: anObject)!

add: anObject size: aString
	^ (self add: anObject) size: aString!

add: anObject size: aString min: anInteger
	^ (self add: anObject) size: aString; min: anInteger!

children
	^ (items select: [ :each | each isComponent ]) collect: [ :each | each body ]!

cssClass
	^ self subclassResponsibility!

draggable: aBeforeItem and: anAfterItem on: html
	^ html scriptaculous draggable
		revert: true;
		endEffect: nil;
		startEffect: nil;
		onStart: ((JSStream on: 'var splitter = drag.element;',
								self initOffsetScript ,'
								drag._previous = splitter.previous();
								drag._next = splitter.next();')
			asFunction: #(drag))!

initialize
	super initialize.
	items := OrderedCollection new!

initOffsetScript
	^ self subclassResponsibility!

items
	^ items!

renderContentOn: html
	html div class: self cssClass; with: [
		1 to: self items size do: [ :index |
			self renderItem: (self items at: index) on: html.
			self items size = index ifFalse: [ 
				self
					renderSplitter: (self items at: index) 
					and: (self items at: index + 1) 
					on: html ] ] ]!

renderItem: anItem on: html
	self subclassResponsibility!

renderSplitter: aBeforeItem and: anAfterItem on: html
	html div 
		class: 'handle'; 
		script: (self 
			draggable: aBeforeItem 
			and: anAfterItem
			on: html)! !
!SUSplitter categoriesFor: #add:!public! !
!SUSplitter categoriesFor: #add:size:!public! !
!SUSplitter categoriesFor: #add:size:min:!public! !
!SUSplitter categoriesFor: #children!accessing!public! !
!SUSplitter categoriesFor: #cssClass!accessing!public! !
!SUSplitter categoriesFor: #draggable:and:on:!public!scripts! !
!SUSplitter categoriesFor: #initialize!initialization!public! !
!SUSplitter categoriesFor: #initOffsetScript!public!scripts! !
!SUSplitter categoriesFor: #items!accessing!public! !
!SUSplitter categoriesFor: #renderContentOn:!public!rendering! !
!SUSplitter categoriesFor: #renderItem:on:!public!rendering! !
!SUSplitter categoriesFor: #renderSplitter:and:on:!public!rendering! !

SUTieredList guid: (GUID fromString: '{2D4223E9-0129-4870-9484-39B409DC042B}')!
SUTieredList comment: ''!
!SUTieredList categoriesForClass!Unclassified! !
!SUTieredList methodsFor!

children: aOneArgumentBlock
	"Define a one argument block that answers a collection of children for a given node."

	childrenBlock := aOneArgumentBlock!

cssClass
	^ 'tieredList'!

initialize
	super initialize.
	selectionPath := OrderedCollection new.
	childrenBlock := [ :value | #() ].
	labelBlock := [ :value | value printString ]!

labels: aOneArgumentBlock
	"Define a one argument block that answers a string for a given node."

	labelBlock := aOneArgumentBlock!

renderContentOn: html
	html div
		class: self cssClass;
		id: (uid := html nextId);
		with: [ self renderListOn: html ]!

renderList: aCollection level: anInteger on: html
	| id selected |
	aCollection isEmpty ifTrue: [ ^ self ].
	html select
		beOptional;
		list: aCollection;
		labels: labelBlock;
		id: (id := html nextId);
		optionalLabel: '(select)';
		selected: (selected := selectionPath
			at: anInteger
			ifAbsent: [ nil ]);
		callback: [ :value |
			[ selectionPath size < anInteger ]
		 		whileFalse: [ selectionPath removeLast ].
			selectionPath addLast: value ];
		onChange: (html scriptaculous updater
			id: uid;
			triggerFormElement: id;
			callback: [ :r | self renderListOn: r ]).
	selected isNil
		ifFalse: [ self renderList: (childrenBlock value: selected) level: anInteger + 1 on: html ]!

renderListOn: html
	selectionPath isEmpty
		ifFalse: [ self renderList: (childrenBlock value: selectionPath first) level: 2 on: html ]!

selection
	"Answer the selection path including the root node."

	^ selectionPath!

selection: anOrderedCollection
	"Set the selection path including the root node."

	selectionPath := anOrderedCollection! !
!SUTieredList categoriesFor: #children:!accessing!public! !
!SUTieredList categoriesFor: #cssClass!accessing!public! !
!SUTieredList categoriesFor: #initialize!initialization!public! !
!SUTieredList categoriesFor: #labels:!accessing!public! !
!SUTieredList categoriesFor: #renderContentOn:!public!rendering! !
!SUTieredList categoriesFor: #renderList:level:on:!public!rendering! !
!SUTieredList categoriesFor: #renderListOn:!public!rendering! !
!SUTieredList categoriesFor: #selection!accessing!public! !
!SUTieredList categoriesFor: #selection:!accessing!public! !

SUTitlePane guid: (GUID fromString: '{A5CA91B6-5811-4095-976B-6B305428052A}')!
SUTitlePane comment: ''!
!SUTitlePane categoriesForClass!Unclassified! !
!SUTitlePane methodsFor!

alwaysRefresh
	"Answer the value of alwaysRefresh"

	^ alwaysRefresh!

alwaysRefresh: anObject
	"Set the value of alwaysRefresh"

	alwaysRefresh := anObject!

body
	"Answer the value of body"

	^ body!

body: anObject
	"Set the value of body"

	body := anObject!

children
^(body isKindOf: WAComponent) ifTrue: [Array with: body] ifFalse: [#()]
!

cssClass
	^ 'titlePane'!

initialize
	super initialize.
	open := false.
	loaded := false.
	alwaysRefresh := true.!

loaded
	"Answer the value of loaded"

	^ loaded!

loaded: anObject
	"Set the value of loaded"

	loaded := anObject!

mainId
^'main',uid.!

open
	"Answer the value of open"

	^ open!

open: anObject
	"Set the value of open"

	open := anObject!

renderBodyOn: html
	html div
		id: uid;
		class: 'body';
		class: 'closed' if: open not;
		with: [open ifTrue: [ html render: body ] ]!

renderContentOn: html
	uid := html nextId.
	html div
		id: self mainId;
		class: self cssClass; 
		with: [html div: [
				self renderTitleOn: html.
				self renderBodyOn: html ] ].!

renderTitleOn: html
	html anchor class: 'title'; 
		callback: [open := open not];
		onClick: (html prototype evaluator
						callback: [:script | self scriptToggleOn: script];
						return: false);
		 with: [
			html table
				style: 'width:100%';
				cellspacing: 0;
				with: [
					html tableRow: [
						html tableData
							class: 'label';
							with: title.
						html tableData: [
							html div
								id: 'gfx',uid;
								class: 'gfxopen' if: open;
								class: 'gfx' if: open not ] ] ] ]!

scriptToggleOn: script
	open ifTrue: [script scriptaculous effect
					id: uid;
					duration: 0.3;
					blindUp.
				script prototype element
					id: 'gfx',uid;
					removeClassName: 'gfxopen';
					addClassName: 'gfx']
		ifFalse: [(loaded not or: [alwaysRefresh])
					ifTrue: [
						script prototype element
							id: uid;
							update: body.
						loaded := true].
				script prototype element
					id: uid;
					removeClassName: 'closed'.
				script prototype element
					id: 'gfx',uid;
					removeClassName: 'gfx';
					addClassName: 'gfxopen'.
				script scriptaculous effect
					id: uid;
					duration: 0.3;
					blindDown].
	open := open not
!

startOpen
	"Set the value of open and loaded"
	"use this if the content should be open and rendered at startup"

	open := true.
	loaded := true!

title
	"Answer the value of title"

	^ title!

title: anObject
	"Set the value of title"

	title := anObject!

uid
	"Answer the value of uid"

	^ uid!

uid: anObject
	"Set the value of uid"

	uid := anObject! !
!SUTitlePane categoriesFor: #alwaysRefresh!accessing!public! !
!SUTitlePane categoriesFor: #alwaysRefresh:!accessing!public! !
!SUTitlePane categoriesFor: #body!accessing!public! !
!SUTitlePane categoriesFor: #body:!accessing!public! !
!SUTitlePane categoriesFor: #children!accessing!public! !
!SUTitlePane categoriesFor: #cssClass!accessing!public! !
!SUTitlePane categoriesFor: #initialize!initialization!public! !
!SUTitlePane categoriesFor: #loaded!accessing!public! !
!SUTitlePane categoriesFor: #loaded:!accessing!public! !
!SUTitlePane categoriesFor: #mainId!accessing!public! !
!SUTitlePane categoriesFor: #open!accessing!public! !
!SUTitlePane categoriesFor: #open:!accessing!public! !
!SUTitlePane categoriesFor: #renderBodyOn:!public!rendering! !
!SUTitlePane categoriesFor: #renderContentOn:!public!rendering! !
!SUTitlePane categoriesFor: #renderTitleOn:!public!rendering! !
!SUTitlePane categoriesFor: #scriptToggleOn:!public!scripting! !
!SUTitlePane categoriesFor: #startOpen!public! !
!SUTitlePane categoriesFor: #title!accessing!public! !
!SUTitlePane categoriesFor: #title:!accessing!public! !
!SUTitlePane categoriesFor: #uid!accessing!public! !
!SUTitlePane categoriesFor: #uid:!accessing!public! !

SUTreeReport guid: (GUID fromString: '{D6AE778B-F990-4530-9789-C3C00EFDAD2B}')!
SUTreeReport comment: ''!
!SUTreeReport categoriesForClass!Unclassified! !
!SUTreeReport methodsFor!

addColumn: aBlock label: aString
	^ columns add: ((self treeReportColumnClass on: self)
		renderer: aBlock;
		label: aString;
		yourself)!

children: aBlock
	childrenBlock := aBlock!

collapse: anObject level: anInteger on: aScript
	self recursiveCollapse: anObject on: aScript.
	aScript prototype element
		down: '.indent a';
		removeClassName: 'expanded';
		id: (self uid: anObject on: aScript)!

cssClass
	^ 'treeReport'!

expand: anObject
	expanded add: anObject!

expand: anObject level: anInteger on: aScript
	| children parentId |
	children := childrenBlock value: anObject.
	children isEmpty ifTrue: [ ^ self ].
	parentId := self uid: anObject on: aScript.
	aScript prototype element
		id: parentId; 
		down: '.indent a';
		addClassName: 'expanded'.
	aScript prototype insertion
		id: parentId;
		after: [ :html | 
			children do: [ :each |
				self renderRow: each level: anInteger + 1 on: html ] ].
	expanded add: anObject!

expandable: aBlock
	expandableBlock := aBlock!

initialize
	super initialize.
	roots := OrderedCollection new.
	columns := OrderedCollection new.
	expanded := IdentitySet new.
	childrenBlock := [ :value | #() ].
	expandableBlock := [ :value | (childrenBlock value: value) notEmpty ]!

isExpandable: anObject
	^ expandableBlock value: anObject!

isExpanded: anObject
	^ expanded includes: anObject!

recursiveCollapse: anObject on: aScript
	expanded remove: anObject.
	(childrenBlock value: anObject) do: [ :each |
		aScript prototype element
			id: (self uid: each on: aScript);
			remove.
		(expanded includes: each)
			ifTrue: [ self recursiveCollapse: each on: aScript ] ]!

renderBodyOn: html
	"Render the body of the tree report."
	
	self renderRows: roots level: 0 on: html!

renderContentOn: html
	uids := IdentityDictionary new.
	html table 
		cellspacing: 0;
		class: self cssClass;
		with: [ self renderTableOn: html ]!

renderHeadOn: html
	"Display the column titles of the tree report."
	
	html tableRow: [
		columns do: [ :each | 
			html tableHeading: each label ] ]!

renderRow: anObject level: anInteger on: html
	"Render a specific row anObject at level anInteger."
	
	html tableRow id: (self uid: anObject on: html); with: [
		columns keysAndValuesDo: [ :index :each |
			html tableData: [
				index = 1 
					ifFalse: [ each render: anObject on: html ]
					ifTrue: [ each render: anObject indent: anInteger on: html ] ] ] ]!

renderRowIndent: anObject level: anInteger on: html 
	anInteger timesRepeat: [html div class: 'space'].
	html div
		class: 'space';
		with:
			[(expandableBlock value: anObject) 
				ifTrue: 
					[(html anchor)
						class: 'expanded' if: (expanded includes: anObject);
						onClick: (html prototype evaluator
									callback: 
											[:script | 
											self 
												toggle: anObject
												level: anInteger
												on: script];
									return: false)]]!

renderRows: aCollection level: anInteger on: html
	aCollection do: [ :each |
		self renderRow: each level: anInteger on: html.
		(expanded includes: each) ifTrue: [
			self 
				renderRows: (childrenBlock value: each)
				level: anInteger + 1 on: html ] ]!

renderTableOn: html
	html tableHead: [ self renderHeadOn: html ].
	html tableBody: [ self renderBodyOn: html ]!

roots: aCollection
	roots := aCollection!

toggle: anObject level: anInteger on: aScript
	(expanded includes: anObject)
		ifTrue: [ self collapse: anObject level: anInteger on: aScript ]
		ifFalse: [ self expand: anObject level: anInteger on: aScript ]!

treeReportColumnClass
	^ SUTreeReportColumn!

uid: anObject on: html
	^ uids at: anObject ifAbsentPut: [ html nextId ]! !
!SUTreeReport categoriesFor: #addColumn:label:!accessing!public! !
!SUTreeReport categoriesFor: #children:!accessing!public! !
!SUTreeReport categoriesFor: #collapse:level:on:!public!scripts! !
!SUTreeReport categoriesFor: #cssClass!accessing!public! !
!SUTreeReport categoriesFor: #expand:!accessing!public! !
!SUTreeReport categoriesFor: #expand:level:on:!public!scripts! !
!SUTreeReport categoriesFor: #expandable:!accessing!public! !
!SUTreeReport categoriesFor: #initialize!initialization!public! !
!SUTreeReport categoriesFor: #isExpandable:!public!testing! !
!SUTreeReport categoriesFor: #isExpanded:!public!testing! !
!SUTreeReport categoriesFor: #recursiveCollapse:on:!private! !
!SUTreeReport categoriesFor: #renderBodyOn:!public!rendering! !
!SUTreeReport categoriesFor: #renderContentOn:!public!rendering! !
!SUTreeReport categoriesFor: #renderHeadOn:!public!rendering! !
!SUTreeReport categoriesFor: #renderRow:level:on:!public!rendering! !
!SUTreeReport categoriesFor: #renderRowIndent:level:on:!public!rendering! !
!SUTreeReport categoriesFor: #renderRows:level:on:!public!rendering! !
!SUTreeReport categoriesFor: #renderTableOn:!public!rendering! !
!SUTreeReport categoriesFor: #roots:!accessing!public! !
!SUTreeReport categoriesFor: #toggle:level:on:!public!scripts! !
!SUTreeReport categoriesFor: #treeReportColumnClass!accessing!public! !
!SUTreeReport categoriesFor: #uid:on:!private! !

SUWindow guid: (GUID fromString: '{DB142D29-3413-429C-9A25-6E1387EC71D5}')!
SUWindow comment: ''!
!SUWindow categoriesForClass!Unclassified! !
!SUWindow methodsFor!

children
	^Array with: component!

close
	visible := false!

closeButtonEnabled
	^self propertiesAt: #closeButton ifAbsent: [true]!

closeButtonEnabled: aBoolean
	self propertiesAt: #closeButton put: aBoolean!

closeOn: script
	self close.
	script prototype element
		id: self componentId;
		remove.
	script scriptaculous effect
		id: self windowId;
		duration: 0.5; fade!

collapsed
	^collapsed!

collapsed: aBoolean
	collapsed := aBoolean!

collapseOn: script
	collapsed 
		ifFalse: [
				script prototype element
					id: self windowId;
					styleAt: 'height' put: self titleHeight greaseString , 'px'.
				script prototype element
					id: self containerId; hide]
		ifTrue: [
				script prototype element
					id: self windowId;
					styleAt: 'height' put: extent y greaseString, 'px'.
				script prototype element
					id: self containerId;
					show].
	collapsed := collapsed not
!

component: aComponent
	component := aComponent!

componentBlock: aBlock
	componentBlock := aBlock fixCallbackTemps!

componentId
	^'comp_', self windowId!

containerId
	^'container_', self windowId!

cssClass
	^ 'suWindow'!

cssContainerExtent
	^ 'width:' , extent x greaseString , 'px;height:' , (extent y - 16) greaseString , 'px;'!

cssExtent
	^'width:',extent x greaseString,'px;height:', extent y greaseString , 'px;'.!

cssOrigin
	^ 'left:' , origin x greaseString , 'px;top:' , origin y greaseString , 'px;'!

extent: aPoint
	extent := aPoint!

id
	^id !

id: aId
	id := aId!

initialize
	super initialize.
	extent := 300 @ 200.
	origin := 100 @ 100.
	title := 'SU_Window'.
	componentBlock := [  ].
	collapsed := false.
	visible := false!

isVisible
	^ visible!

minimizeButtonEnabled
	^self propertiesAt: #minimizeButton ifAbsent: [true]!

minimizeButtonEnabled: aBoolean
	self propertiesAt: #minimizeButton put: aBoolean!

openOn: aScript 
	self 
		openOn: aScript
		hidden: false!

openOn: aScript hidden: aBoolean
	self isVisible
		ifFalse: [
			visible := true.
			aBoolean ifFalse: [self showOn: aScript ].
			aScript prototype element
				id: self windowId;
				styleAt: 'left' put: origin x greaseString, 'px';
				styleAt: 'top' put: origin y greaseString, 'px'.
			aScript prototype element
				id: self containerId;
				insert: [:html |
					self setComponent.
					self renderComponentOn: html ] ].!

origin: aPoint
	origin := aPoint!

originX: x y: y
	self origin: (Point x: x asNumber y: y asNumber + 16)
!

properties
	properties ifNil: [properties := Dictionary new].
	^properties!

propertiesAt: aKey
	^self properties at: aKey ifAbsent: []!

propertiesAt: aKey ifAbsent: aBlock
	^self properties at: aKey ifAbsent: aBlock!

propertiesAt: aKey put: aValue
	self properties at: aKey put: aValue!

renderBodyOn: html
	html div
		class: 'title';
		id: self titleId;
		with: [self renderTitleOn: html].
	html div
		class: 'container';
		style: self cssContainerExtent;
		id: self containerId
!

renderCloseOn: html
	self closeButtonEnabled
		ifTrue: [html anchor
					title: 'Close';
					onClick: (html prototype evaluator
								callback: [ :script |
									self closeOn: script];
									return: false);
					with: 'X']!

renderComponentOn: html
	html div
		id: self componentId;
		with: component!

renderContentOn: html 
	self close.
	collapsed := false.
	html div
		id: self windowId;
		script: (html scriptaculous draggable
				handle: self titleId;
				revert: false);
		class: self cssClass;
		style: 'display: none';
		style: 'z-index:' , self zIndex greaseString , ';' , self cssOrigin , self cssExtent;
		with: [ self renderBodyOn: html ]!

renderMinimizeOn: html
	self minimizeButtonEnabled
		ifTrue: [
			html anchor
					title: 'Minimize';
					onClick: (html prototype evaluator
									callback: [:script | 
												self collapseOn: script];
												return: false);
					with: '-']!

renderTitleOn: html
	html table
		class: 'title';
		style: 'width:100%';
		cellspacing: 0;
		cellpadding:0;
		with: [
			html tableRow: [
				html tableData
					style: 'width:100%';
					class: 'label';
					with: title.
				html tableData: [self renderMinimizeOn: html].
				html tableData: [self renderCloseOn: html] ] ] 
!

setComponent
	component isNil
		ifTrue: [ component := componentBlock value: self ].
	updateBlock notNil
		ifTrue: [ updateBlock value: self value: component ]!

showOn: aScript
	aScript scriptaculous effect id: self windowId; duration: 0.3; appear!

title: aString
	title := aString!

titleHeight
	^20!

titleId
	^'title_', self windowId!

tooltipKey
	^self propertiesAt: #tooltipKey ifAbsent: [#unknown]!

tooltipKey: aKey
	self propertiesAt: #tooltipKey put: aKey!

updateBlock: aBlock
	updateBlock := aBlock!

windowId
	id ifNil: [id := 'suwindow'].
	^id!

zIndex
	^self propertiesAt: #zIndex ifAbsent: [999]!

zIndex: anInteger
	^self propertiesAt: #zIndex put: anInteger! !
!SUWindow categoriesFor: #children!accessing!public! !
!SUWindow categoriesFor: #close!actions!public! !
!SUWindow categoriesFor: #closeButtonEnabled!accessing-properties!public! !
!SUWindow categoriesFor: #closeButtonEnabled:!accessing-properties!public! !
!SUWindow categoriesFor: #closeOn:!public!scripting! !
!SUWindow categoriesFor: #collapsed!accessing!public! !
!SUWindow categoriesFor: #collapsed:!accessing!public! !
!SUWindow categoriesFor: #collapseOn:!public!scripting! !
!SUWindow categoriesFor: #component:!accessing!public! !
!SUWindow categoriesFor: #componentBlock:!accessing!public! !
!SUWindow categoriesFor: #componentId!accessing!public! !
!SUWindow categoriesFor: #containerId!accessing!public! !
!SUWindow categoriesFor: #cssClass!accessing!public! !
!SUWindow categoriesFor: #cssContainerExtent!private! !
!SUWindow categoriesFor: #cssExtent!private! !
!SUWindow categoriesFor: #cssOrigin!private! !
!SUWindow categoriesFor: #extent:!accessing!public! !
!SUWindow categoriesFor: #id!accessing!public! !
!SUWindow categoriesFor: #id:!accessing!public! !
!SUWindow categoriesFor: #initialize!initialization!public! !
!SUWindow categoriesFor: #isVisible!public!testing! !
!SUWindow categoriesFor: #minimizeButtonEnabled!accessing-properties!public! !
!SUWindow categoriesFor: #minimizeButtonEnabled:!accessing-properties!public! !
!SUWindow categoriesFor: #openOn:!public!scripting! !
!SUWindow categoriesFor: #openOn:hidden:!public!scripting! !
!SUWindow categoriesFor: #origin:!accessing!public! !
!SUWindow categoriesFor: #originX:y:!public! !
!SUWindow categoriesFor: #properties!accessing!public! !
!SUWindow categoriesFor: #propertiesAt:!accessing!public! !
!SUWindow categoriesFor: #propertiesAt:ifAbsent:!accessing!public! !
!SUWindow categoriesFor: #propertiesAt:put:!accessing!public! !
!SUWindow categoriesFor: #renderBodyOn:!public!rendering! !
!SUWindow categoriesFor: #renderCloseOn:!public!rendering! !
!SUWindow categoriesFor: #renderComponentOn:!public!rendering! !
!SUWindow categoriesFor: #renderContentOn:!public!rendering! !
!SUWindow categoriesFor: #renderMinimizeOn:!public!rendering! !
!SUWindow categoriesFor: #renderTitleOn:!public!rendering! !
!SUWindow categoriesFor: #setComponent!private! !
!SUWindow categoriesFor: #showOn:!public!scripting! !
!SUWindow categoriesFor: #title:!accessing!public! !
!SUWindow categoriesFor: #titleHeight!accessing!public! !
!SUWindow categoriesFor: #titleId!accessing!public! !
!SUWindow categoriesFor: #tooltipKey!accessing-properties!public! !
!SUWindow categoriesFor: #tooltipKey:!accessing-properties!public! !
!SUWindow categoriesFor: #updateBlock:!accessing!public! !
!SUWindow categoriesFor: #windowId!accessing!public! !
!SUWindow categoriesFor: #zIndex!accessing!public! !
!SUWindow categoriesFor: #zIndex:!accessing!public! !

!SUWindow class methodsFor!

on: aBlock
	^self new componentBlock: aBlock; yourself! !
!SUWindow class categoriesFor: #on:!instance creation!public! !

SUAccordion guid: (GUID fromString: '{BFD0FF13-B7CF-47A9-9F0F-F96787C54D0B}')!
SUAccordion comment: ''!
!SUAccordion categoriesForClass!Unclassified! !
!SUAccordion methodsFor!

cssClass
	^ 'accordion'!

hide: anElement
	self visible remove: anElement ifAbsent: [ ]!

initialize
	super initialize.
	visible := OrderedCollection new.
	maxVisible := 1!

isVisible: aComponent
	^ self visible includes: aComponent!

maxVisible
	^ maxVisible!

maxVisible: anInteger
	maxVisible := anInteger!

renderBody: anElement index: anInteger visible: aBoolean on: html
	(self isVisible: anElement)
		ifFalse: [ ^ self ].
	html definitionData
		id: (self uid: 'body' at: anInteger);
		style: (aBoolean ifFalse: [ 'display: none' ]);
		with: anElement!

renderHead: anElement index: anInteger on: html
	html definitionTerm 
		id: (self uid: 'head' at: anInteger); 
		class: 'active' if: (self isVisible: anElement);
		with: [
			html anchor
				onClick: (html prototype evaluator
					callback: [ :script | self scriptToggle: anElement on: script ];
					return: false);
				callback: [ self toggle: anElement ];
				with: anElement label ]!

renderNavigationOn: html 
	html definitionList class: self cssClass; with: [
		items keysAndValuesDo: [ :index :element | 
			self renderHead: element index: index on: html.
			self renderBody: element index: index visible: true on: html ] ]!

scriptHide: anElement on: aScript
	| index |
	index := self findIndex: anElement ifAbsent: [ ^ self ].
	aScript scriptaculous effect
		id: (self uid: 'body' at: index);
		onAfterFinish: (PTElement new
						id: (self uid: 'body' at: index); 
						remove);
		duration: 0.2;
		blindUp.
	aScript prototype element
		id: (self uid: 'head' at: index);
		removeClassName: 'active'
		
	
!

scriptShow: anElement on: aScript
	| index |
	index := self findIndex: anElement ifAbsent: [ ^ self ].
	aScript prototype element
		id: (self uid: 'head' at: index);
		insertAfter: [ :html | 
			self 
				renderBody: anElement index: index
				visible: false on: html ].
	aScript scriptaculous effect
		id: (self uid: 'body' at: index);
		duration: 0.2;
		blindDown.
	aScript prototype element
		id: (self uid: 'head' at: index);
		addClassName: 'active'!

scriptToggle: anElement on: aScript
	| previous |
	previous := self visible copy.
	self toggle: anElement.
	(previous difference: self visible)
		do: [ :each | self scriptHide: each on: aScript ].
	(self visible difference: previous)
		do: [ :each | self scriptShow: each on: aScript ]!

show: anElement
	self visible addLast: anElement.
	self maxVisible isNil ifFalse: [
		[ self maxVisible < self visible size ]
			whileTrue: [ self hide: self visible first ] ]!

toggle: anElement
	(self isVisible: anElement)
		ifTrue: [ self hide: anElement ]
		ifFalse: [ self show: anElement ]!

visible
	^ visible! !
!SUAccordion categoriesFor: #cssClass!accessing!public! !
!SUAccordion categoriesFor: #hide:!actions!public! !
!SUAccordion categoriesFor: #initialize!initialization!public! !
!SUAccordion categoriesFor: #isVisible:!public!testing! !
!SUAccordion categoriesFor: #maxVisible!accessing!public! !
!SUAccordion categoriesFor: #maxVisible:!accessing!public! !
!SUAccordion categoriesFor: #renderBody:index:visible:on:!public!rendering! !
!SUAccordion categoriesFor: #renderHead:index:on:!public!rendering! !
!SUAccordion categoriesFor: #renderNavigationOn:!public!rendering! !
!SUAccordion categoriesFor: #scriptHide:on:!public!scripting! !
!SUAccordion categoriesFor: #scriptShow:on:!public!scripting! !
!SUAccordion categoriesFor: #scriptToggle:on:!public!scripting! !
!SUAccordion categoriesFor: #show:!actions!public! !
!SUAccordion categoriesFor: #toggle:!actions!public! !
!SUAccordion categoriesFor: #visible!accessing!public! !

SUCarousel guid: (GUID fromString: '{79AC6B53-5209-422B-846F-0D8F5211DA0E}')!
SUCarousel comment: ''!
!SUCarousel categoriesForClass!Unclassified! !
!SUCarousel methodsFor!

animationSpeed
	^ animationSpeed!

animationSpeed: anObject
	animationSpeed := anObject!

buttonStyle
	^self subclassResponsibility!

clipExtent
	^self subclassResponsibility!

componentExtent
	^self subclassResponsibility!

cssButton
	^self subclassResponsibility!

cssClass
	^ 'carouselComponent'!

cssFloat
	^self subclassResponsibility!

cssOrientation
	^self subclassResponsibility!

elementExtent
	^ elementExtent!

elementExtent: anObject
	elementExtent := anObject!

elementHeight
	^ elementExtent y!

elementMargin
	^ elementMargin!

elementMargin: anObject
	elementMargin := anObject!

elementSize
	^self subclassResponsibility!

elementSizeWithMargins
	^self elementSize + (2 * elementMargin)!

elementWidth
	^ elementExtent x!

initialize
	super initialize.
	numVisible := 5.
	elementExtent := Point x: 40 y: 40.
	elementMargin := 5.
	scrollInc := 5.
	animationSpeed := 0.5.
	navMargin := 12.
	offset := 1!

lastOffset
	^offset + numVisible - 1!

moveSizeX: anInteger
	^0!

moveSizeY: anInteger
	^0!

navMargin
	^ navMargin!

navMargin: anObject
	navMargin := anObject!

nextText
	^self subclassResponsibility!

numVisible
	^ numVisible!

numVisible: anObject
	numVisible := anObject!

prevText
	^self subclassResponsibility!

renderElement: element index: index on: html 
	| currentId |
	currentId := self 
		uid: 'head'
		at: index.
	html div
		id: currentId;
		class: 'carousel-element';
		class: self cssFloat;
		style: 'margin:' , elementMargin greaseString , 'px;height:' , self elementHeight greaseString , 'px;width:' , self elementWidth greaseString , 'px;';
		with: element!

renderNavElementsOn: html 
	html div
		class: self cssOrientation;
		id: uid;
		with: [ 
			self visibleItems keysAndValuesDo: [ :index :element | 
				self 
					renderElement: element
					index: index
					on: html ] ]!

renderNavigationOn: html
	"reset offset for each full refresh"
	| theExtent clipExtent |
	offset := 1.
	created := self visibleItems.
	theExtent := self componentExtent.
	clipExtent := self clipExtent.
	html div
		class: self cssClass; 
		style: 'height:', theExtent y greaseString, 'px;width:', theExtent x greaseString ,'px' ;
		with: [
			self renderPreviousButtonOn: html.
			html div
				class: 'clip-region';
				class: self cssFloat;
				style: 'height:', clipExtent y greaseString, 'px;width:', clipExtent x greaseString ,'px' ;
				id: 'clip_', uid;
				with: [ self renderNavElementsOn: html ].
			self renderNextButtonOn: html ]!

renderNextButtonOn: html
	html div
		id: uid, '_next';
		style: self buttonStyle;
		class: self cssButton;
		onClick: (html prototype evaluator
					callback: [:script |
						self scriptMove: -1 for: uid on: script];
						return: false);
		with: self nextText!

renderPreviousButtonOn: html
	html div
		id: uid, '_prev';
		style: self buttonStyle;
		class: self cssButton;
		onClick: (html prototype evaluator
					callback: [:script |
						self scriptMove: 1 for: uid on: script];
						return: false);
		with: self prevText
		
!

scriptMove: anInteger for: id on: script
	"hide buttons to avoid clicks between move operation, works only for IE and firefox"
	
	| currentIndex nextIndex direction buttonId |
		currentIndex := self lastOffset. 
		anInteger = 1 
				ifTrue: [offset = 1 ifTrue: [^self].
					offset := offset - scrollInc.
					direction := '_prev']
				ifFalse: [(offset + scrollInc abs) > (items size) ifTrue: [^self].
					direction := '_next'.
					offset := offset + scrollInc].
		anInteger < 0 ifTrue: [
			nextIndex := (currentIndex + scrollInc) min: (items size).
			nextIndex > currentIndex ifTrue: [
			currentIndex + 1 to: nextIndex do: [:idx | | anItem |
				anItem := items at: idx.
				(created includes: anItem) ifFalse: [created add: anItem.
				script prototype element
					id: (self uid: 'head' at: idx);
					then: (script prototype element
						id: (self uid: 'head' at: idx - 1);
						insertAfter: [ :html | 
							self renderElement: (items at: idx) index: idx on: html ]) ] ] ] ].
		buttonId := uid,direction.
		script prototype element
			id: buttonId;
			styleAt: 'visibility' put: 'hidden'.
		script scriptaculous effect id: id;
			duration: animationSpeed;
			y: (self moveSizeY: anInteger); x: (self moveSizeX: anInteger);
			move;
			onAfterFinish: (PTElement new id: buttonId; styleAt: 'visibility' put: 'visible').
!

scrollInc
	^ scrollInc!

scrollInc: anObject
	scrollInc := anObject!

visibleItems
	^items copyFrom: offset to: (self lastOffset min: items size)! !
!SUCarousel categoriesFor: #animationSpeed!accessing!public! !
!SUCarousel categoriesFor: #animationSpeed:!accessing!public! !
!SUCarousel categoriesFor: #buttonStyle!private! !
!SUCarousel categoriesFor: #clipExtent!accessing-bounds!public! !
!SUCarousel categoriesFor: #componentExtent!accessing-bounds!public! !
!SUCarousel categoriesFor: #cssButton!accessing!public! !
!SUCarousel categoriesFor: #cssClass!accessing!public! !
!SUCarousel categoriesFor: #cssFloat!accessing!public! !
!SUCarousel categoriesFor: #cssOrientation!accessing!public! !
!SUCarousel categoriesFor: #elementExtent!accessing!public! !
!SUCarousel categoriesFor: #elementExtent:!accessing!public! !
!SUCarousel categoriesFor: #elementHeight!accessing!public! !
!SUCarousel categoriesFor: #elementMargin!accessing!public! !
!SUCarousel categoriesFor: #elementMargin:!accessing!public! !
!SUCarousel categoriesFor: #elementSize!accessing!public! !
!SUCarousel categoriesFor: #elementSizeWithMargins!accessing!public! !
!SUCarousel categoriesFor: #elementWidth!accessing!public! !
!SUCarousel categoriesFor: #initialize!initialization!public! !
!SUCarousel categoriesFor: #lastOffset!accessing!public! !
!SUCarousel categoriesFor: #moveSizeX:!private! !
!SUCarousel categoriesFor: #moveSizeY:!private! !
!SUCarousel categoriesFor: #navMargin!accessing!public! !
!SUCarousel categoriesFor: #navMargin:!accessing!public! !
!SUCarousel categoriesFor: #nextText!private! !
!SUCarousel categoriesFor: #numVisible!accessing!public! !
!SUCarousel categoriesFor: #numVisible:!accessing!public! !
!SUCarousel categoriesFor: #prevText!private! !
!SUCarousel categoriesFor: #renderElement:index:on:!public!rendering! !
!SUCarousel categoriesFor: #renderNavElementsOn:!public!rendering! !
!SUCarousel categoriesFor: #renderNavigationOn:!public!rendering! !
!SUCarousel categoriesFor: #renderNextButtonOn:!public!rendering! !
!SUCarousel categoriesFor: #renderPreviousButtonOn:!public!rendering! !
!SUCarousel categoriesFor: #scriptMove:for:on:!public!scripting! !
!SUCarousel categoriesFor: #scrollInc!accessing!public! !
!SUCarousel categoriesFor: #scrollInc:!accessing!public! !
!SUCarousel categoriesFor: #visibleItems!accessing!public! !

SUNavigationCarousel guid: (GUID fromString: '{DA943C4F-F8AB-47A2-A373-0F545BBF6928}')!
SUNavigationCarousel comment: ''!
!SUNavigationCarousel categoriesForClass!Unclassified! !
!SUNavigationCarousel methodsFor!

cssClass
	^ 'carousel'!

elementHeight
	"Answer the value of elementHeight"

	^ elementHeight!

elementHeight: anObject
	"Set the value of elementHeight"

	elementHeight := anObject!

initialize
	super initialize.
	visibleElements := 5.
	elementHeight := 14.
	offset := 1!

innerHeight
	^elementHeight * visibleElements
!

renderActionsForId: id on: html
	html table style: 'width:100%;margin-top:10px'; with:
		[html tableRow: [
			html tableData class: 'action'; with: 
				[html anchor onClick: ((html prototype evaluator)
								callback: [:script | self scriptMove: 1 for: id on: script];return: false);
								with: 'Previous'].
				html tableData style: 'width:100%'; with: [html space].
				html tableData class: 'action'; class: 'right'; 
						with: [html anchor
								onClick: ((html prototype evaluator)
								callback: [:script | self scriptMove: -1 for: id on: script];return: false);
								with: 'Next'] ] ]!

renderBodyOn: html
	html div
		id: (self uid: 'body' at: 0);
		class: 'body';
		with: self selected!

renderElement: element index: index on: html 
	| currentId |
	currentId := self 
		uid: 'head'
		at: index.
	html div
		id: currentId;
		class: 'active'
			if: self selected = element;
		style: 'height:' , self elementHeight greaseString , 'px';
		with: 
			[ html anchor
				onClick: (html prototype evaluator
						callback: 
							[ :script | 
							self 
								scriptSelected: element
								id: currentId
								on: script ];
						return: false);
				callback: [ self selected: element ];
				with: [ html div: element label ] ]!

renderNavElementsOn: html 
	| moveId |
	moveId := html nextId.
	html div
		class: 'nav';
		with: [
			html div
				style: 'height:' , self innerHeight greaseString , 'px';
				class: 'inner';
				with: [
					html div
						id: moveId;
						class: 'move';
						with: [ 
							items keysAndValuesDo: [ :index :element | 
								self 
									renderElement: element
									index: index
									on: html ] ] ].
			self 
				renderActionsForId: moveId
				on: html ]!

renderNavigationOn: html
	"reset offset for each full refresh"
	offset := 1.
	html div 
		class: self cssClass;
		with: [
			html table: [
				html tableRow: [
					html tableData: [self renderNavElementsOn: html].
					html tableData
						verticalAlign: 'top';
						with: [self renderBodyOn: html ] ] ] ]!

scriptMove: anInteger for: id on: script
	| elementsToMove |
	elementsToMove := (visibleElements - 1) .
	anInteger = 1 
			ifTrue: [offset = 1 ifTrue: [^self].
					offset := offset - elementsToMove]
			ifFalse: [(offset + elementsToMove abs) > items size ifTrue: [^self].
					offset := offset + elementsToMove].
	script scriptaculous effect
		id: id;
		duration: 0.2;
		x: 0; y: (self elementHeight * elementsToMove * anInteger);
		move !

scriptSelected: aComponent id: currentId on: aScript
	aScript prototype element
		id: (self uid: 'head' at: (self findIndex: self selected ifAbsent: []));
		removeClassName: 'active'.
	self selected: aComponent.
	aScript prototype element
		id: currentId;
		addClassName: 'active'.
	aScript prototype element
		id: (self uid: 'body' at: 0);
		update: self selected!

selected
	^ selected ifNil: [selected := items isEmpty ifFalse: [items first]]!

selected: anElement
	selected := anElement!

visible
	selected ifNil: [^#()].
	^Array with: selected!

visibleElements
	"Answer the value of visibleElements"

	^ visibleElements!

visibleElements: anObject
	"Set the value of visibleElements"

	visibleElements := anObject! !
!SUNavigationCarousel categoriesFor: #cssClass!accessing!public! !
!SUNavigationCarousel categoriesFor: #elementHeight!accessing!public! !
!SUNavigationCarousel categoriesFor: #elementHeight:!accessing!public! !
!SUNavigationCarousel categoriesFor: #initialize!initialization!public! !
!SUNavigationCarousel categoriesFor: #innerHeight!accessing!public! !
!SUNavigationCarousel categoriesFor: #renderActionsForId:on:!public!rendering! !
!SUNavigationCarousel categoriesFor: #renderBodyOn:!public!rendering! !
!SUNavigationCarousel categoriesFor: #renderElement:index:on:!public!rendering! !
!SUNavigationCarousel categoriesFor: #renderNavElementsOn:!public!rendering! !
!SUNavigationCarousel categoriesFor: #renderNavigationOn:!public!rendering! !
!SUNavigationCarousel categoriesFor: #scriptMove:for:on:!public!scripting! !
!SUNavigationCarousel categoriesFor: #scriptSelected:id:on:!public!scripting! !
!SUNavigationCarousel categoriesFor: #selected!accessing!public! !
!SUNavigationCarousel categoriesFor: #selected:!accessing!public! !
!SUNavigationCarousel categoriesFor: #visible!accessing!public! !
!SUNavigationCarousel categoriesFor: #visibleElements!accessing!public! !
!SUNavigationCarousel categoriesFor: #visibleElements:!accessing!public! !

SUTabPanel guid: (GUID fromString: '{76D7AB93-6B23-4E95-9B07-E8049AAA4987}')!
SUTabPanel comment: ''!
!SUTabPanel categoriesForClass!Unclassified! !
!SUTabPanel methodsFor!

cssClass
	^ 'tabPanel'!

renderNavigationOn: html
	html div
		class: self cssClass;
		with: [
			self renderTabsOn: html.
			self renderPanelOn: html ]!

renderPanelOn: html
	html div
		id: (self uid: 'body' at: 0);
		class: 'body';
		with: self selected!

renderTabsOn: html 
	| active |
	html unorderedList
		class: 'head';
		with: [
			items keysAndValuesDo: [ :index :element | 
				active := self selected = element.
				html listItem: [
					html anchor
						id: (self uid: 'head' at: index);
						class: 'active' if: active;
						onClick: (html prototype evaluator
							callback: [ :script | self scriptSelected: element on: script ];
							return: false);
						callback: [self selected: element];
						with: element label ] ] ]!

scriptSelected: aComponent on: aScript
	aScript prototype element
		id: (self uid: 'head' at: (self
			findIndex: self selected
			ifAbsent: [ ]));
		removeClassName: 'active'.
	self selected: aComponent.
	aScript prototype element
		id: (self uid: 'head' at: (self
			findIndex: self selected
			ifAbsent: [ ^ self ]));
		addClassName: 'active'.
	aScript prototype element
		id: (self uid: 'body' at: 0);
		update: self selected!

selected
	^ selected ifNil: [ selected := items isEmpty ifFalse: [ items first ] ]!

selected: anElement
	selected := anElement!

visible
	selected ifNil: [^#()].
	^Array with: selected! !
!SUTabPanel categoriesFor: #cssClass!accessing!public! !
!SUTabPanel categoriesFor: #renderNavigationOn:!public!rendering! !
!SUTabPanel categoriesFor: #renderPanelOn:!public!rendering! !
!SUTabPanel categoriesFor: #renderTabsOn:!public!rendering! !
!SUTabPanel categoriesFor: #scriptSelected:on:!public!scripting! !
!SUTabPanel categoriesFor: #selected!accessing!public! !
!SUTabPanel categoriesFor: #selected:!accessing!public! !
!SUTabPanel categoriesFor: #visible!accessing!public! !

SUHorizontalCarousel guid: (GUID fromString: '{C5764B90-06AA-466C-907A-AEA8E7BF4184}')!
SUHorizontalCarousel comment: ''!
!SUHorizontalCarousel categoriesForClass!Unclassified! !
!SUHorizontalCarousel methodsFor!

buttonStyle
	^'width:', navMargin greaseString, 'px;line-height:', self componentExtent y greaseString, 'px;'!

clipExtent
	| xSize ySize |
	xSize := elementExtent x + (2 * elementMargin).
	ySize := elementExtent y.
	^Point x: (numVisible * xSize) y: ySize + (2 * elementMargin)!

componentExtent
	| clipExtent |
	clipExtent := self clipExtent.
	^Point x: clipExtent x + (navMargin * 2) + 3 y: clipExtent y.!

cssButton
	^'buttonh'!

cssFloat
	^'carousel-float-h'!

cssOrientation
	^'carousel-list-h'!

elementSize
	^self elementExtent x!

moveSizeX: anInteger 
	^ self elementSizeWithMargins * scrollInc * anInteger!

nextText
	^'>'!

prevText
	^'<'! !
!SUHorizontalCarousel categoriesFor: #buttonStyle!private! !
!SUHorizontalCarousel categoriesFor: #clipExtent!accessing-bounds!public! !
!SUHorizontalCarousel categoriesFor: #componentExtent!accessing-bounds!public! !
!SUHorizontalCarousel categoriesFor: #cssButton!accessing!public! !
!SUHorizontalCarousel categoriesFor: #cssFloat!accessing!public! !
!SUHorizontalCarousel categoriesFor: #cssOrientation!accessing!public! !
!SUHorizontalCarousel categoriesFor: #elementSize!accessing!public! !
!SUHorizontalCarousel categoriesFor: #moveSizeX:!private! !
!SUHorizontalCarousel categoriesFor: #nextText!private! !
!SUHorizontalCarousel categoriesFor: #prevText!private! !

SUVerticalCarousel guid: (GUID fromString: '{18B71D59-18F8-4715-8E71-5A4F181AE070}')!
SUVerticalCarousel comment: ''!
!SUVerticalCarousel categoriesForClass!Unclassified! !
!SUVerticalCarousel methodsFor!

buttonStyle
	^'height:', navMargin greaseString, 'px;'!

clipExtent
	| xSize ySize |
	xSize := elementExtent x.
	ySize := elementExtent y + (2 * elementMargin).
	^ Point x: xSize + (2 * elementMargin) y: ySize * numVisible!

componentExtent
	| clipExtent |
	clipExtent := self clipExtent.
	^Point x: clipExtent x  y: clipExtent y + (navMargin * 2) + 3.!

cssButton
	^'buttonv'!

cssFloat
	^'carousel-float-v'!

cssOrientation
	^'carousel-list-v'!

elementSize
	^self elementExtent y!

moveSizeY: anInteger
	^(self elementSizeWithMargins * scrollInc * anInteger)!

nextText
	^'\/'!

prevText
	^'/\'! !
!SUVerticalCarousel categoriesFor: #buttonStyle!private! !
!SUVerticalCarousel categoriesFor: #clipExtent!accessing-bounds!public! !
!SUVerticalCarousel categoriesFor: #componentExtent!accessing-bounds!public! !
!SUVerticalCarousel categoriesFor: #cssButton!accessing!public! !
!SUVerticalCarousel categoriesFor: #cssFloat!accessing!public! !
!SUVerticalCarousel categoriesFor: #cssOrientation!accessing!public! !
!SUVerticalCarousel categoriesFor: #elementSize!accessing!public! !
!SUVerticalCarousel categoriesFor: #moveSizeY:!private! !
!SUVerticalCarousel categoriesFor: #nextText!private! !
!SUVerticalCarousel categoriesFor: #prevText!private! !

SUHorizontalSplitter guid: (GUID fromString: '{40AC727F-4903-4A18-95D2-6DAA9A4D3118}')!
SUHorizontalSplitter comment: ''!
!SUHorizontalSplitter categoriesForClass!Unclassified! !
!SUHorizontalSplitter methodsFor!

cssClass
	^ 'splitter-horizontal'!

draggable: aBeforeItem and: anAfterItem on: html 
	^ (super 
		draggable: aBeforeItem
		and: anAfterItem
		on: html)
		constraintVertical;
		onDrag: (JSStream on: '
				var splitter = arguments[0].element;
				offset = splitter.offsetTop - arguments[0]._originalTop;
				arguments[0]._originalTop = splitter.offsetTop;
				leftElement = arguments[0]._previous;
				leftHeight = leftElement.offsetHeight + offset;
				rightElement = arguments[0]._next;
				rightHeight = rightElement.offsetHeight - offset;
				if (leftHeight > ' , aBeforeItem min greaseString , ' && rightHeight > ' , anAfterItem min greaseString , ') {
					leftElement.style.height = leftHeight + "px";
					rightElement.style.height = rightHeight + "px";
				}');
		onEnd: (html prototype request
				callback: [ :value | aBeforeItem size: value ]
					value: (JSStream on: 'arguments[0].element.previous().offsetHeight + ''px''');
				callback: [ :value | anAfterItem size: value ]
					value: (JSStream on: 'arguments[0].element.next().offsetHeight + ''px'''))!

initOffsetScript
	^'drag._originalTop=splitter.offsetTop;'!

renderItem: anItem on: html
	html div style: 'height:' , anItem size; with: anItem body! !
!SUHorizontalSplitter categoriesFor: #cssClass!accessing!public! !
!SUHorizontalSplitter categoriesFor: #draggable:and:on:!public!scripts! !
!SUHorizontalSplitter categoriesFor: #initOffsetScript!public!scripts! !
!SUHorizontalSplitter categoriesFor: #renderItem:on:!public!rendering! !

SUVerticalSplitter guid: (GUID fromString: '{C3200BA5-6EFC-4B52-AE61-277C8162B3FF}')!
SUVerticalSplitter comment: ''!
!SUVerticalSplitter categoriesForClass!Unclassified! !
!SUVerticalSplitter methodsFor!

cssClass
	^ 'splitter-vertical'!

draggable: aBeforeItem and: anAfterItem on: html 
	^ (super 
		draggable: aBeforeItem
		and: anAfterItem
		on: html)
		constraintHorizontal;
		onDrag: (JSStream on: '
				var splitter = arguments[0].element;
				offset = splitter.offsetLeft - arguments[0]._originalLeft;
				arguments[0]._originalLeft = splitter.offsetLeft;
				leftElement = arguments[0]._previous;
				leftWidth = leftElement.offsetWidth + offset;
				rightElement = arguments[0]._next;
				rightWidth = rightElement.offsetWidth - offset;
				if (leftWidth > ' , aBeforeItem min greaseString , ' && rightWidth > ' , anAfterItem min greaseString , ') {
					leftElement.style.width = leftWidth + "px";
					rightElement.style.width = rightWidth + "px";
				}');
		onEnd: (html prototype request
				callback: [ :value | aBeforeItem size: value ]
					value: (JSStream on: 'arguments[0].element.previous().offsetWidth + ''px''');
				callback: [ :value | anAfterItem size: value ]
					value: (JSStream on: 'arguments[0].element.next().offsetWidth + ''px'''))!

initOffsetScript
	^'drag._originalLeft=splitter.offsetLeft;'!

renderItem: anItem on: html
	html div style: 'width:' , anItem size; with: anItem body! !
!SUVerticalSplitter categoriesFor: #cssClass!accessing!public! !
!SUVerticalSplitter categoriesFor: #draggable:and:on:!public!rendering! !
!SUVerticalSplitter categoriesFor: #initOffsetScript!public!rendering! !
!SUVerticalSplitter categoriesFor: #renderItem:on:!public!rendering! !

SUDatePicker guid: (GUID fromString: '{7BA23C18-695D-4A14-A249-CF7E690B9B85}')!
SUDatePicker comment: ''!
!SUDatePicker categoriesForClass!Unclassified! !
!SUDatePicker methodsFor!

ajaxCallbackFor: aDate on: html
	^html prototype evaluator
		callback: [:script | self scriptSelect: aDate on: script];
		return: false!

containerId
	"Answer the value of containerId"
	^ containerId!

containerId: anObject 
	"Set the value of containerId"
	containerId := anObject!

format
	"Answer the value of format"

	format ifNil: [format := #(2 1 3 $/ 1 1)].
	^format!

format: anObject
	"Set the value of format"

	format := anObject!

formattedResult
	^self date printFormat: self format!

initialize
	super initialize.
	open := false.
	self date: Date today!

isOpen
	^open!

nextMonthUpdateOn: aScript
	self nextMonth.
	self scriptUpdateOn: aScript!

nextYear
	self year: self year + 1!

nextYearUpdateOn: aScript
	self nextYear.
	self scriptUpdateOn: aScript
!

openOn: aScript 
	| anElement |
	anElement := aScript prototype element id: containerId.
	anElement	
		absolutize;
		styleAt: 'left'
			put: origin x greaseString , 'px';
		styleAt: 'top'
			put: origin y greaseString , 'px'.
	self isOpen
		ifFalse: [
			anElement update: self.
			open := true]!

origin
	^origin!

origin: aPoint
	origin := aPoint!

previousMonthUpdateOn: aScript
	self previousMonth.
	self scriptUpdateOn: aScript!

previousYear
	self year: self year - 1!

previousYearUpdateOn: aScript
	self previousYear.
	self scriptUpdateOn: aScript
!

renderBodyOn: html
	html table
		cellspacing: 0;
		class: 'main';
		with: [self renderCalendarOn: html ].

			!

renderCalendarOn: html
	html tableRow: [
		html tableHeading
			colSpan: 9;
			with: [self renderMonthNavigationOn: html ] ].
	html tableRow
			class: 'calendarTitle';
			with: [
				self weekDays do: [:each |
					html tableData
						class: 'weekDay';
						with: each ] ].
	self weeksDo: [:week | self renderRowForWeek: week on: html ].
	html tableRow: [
		html tableData
			colSpan: 9;
			with: [self renderYearNavigationOn: html] ]	

			!

renderCellForDate: aDate on: html
	html tableData
		class: 'day';
		class: 'daySelected' if: self date = aDate;
		with: [
			aDate monthIndex = self monthIndex ifTrue: [
					(self canSelect: aDate)
						ifTrue: [
							html anchor
								class: 'today' if: aDate = Date today;
								onClick: (self ajaxCallbackFor: aDate on: html);
								with: aDate dayOfMonth ]
						ifFalse: [ html text: aDate dayOfMonth ] ] ]!

renderContentOn: html
	uid ifNil: [uid := html nextId].
	html div
		id: uid;
		class: 'calendar';
		with: [self renderBodyOn: html]!

renderMonthNavigationOn: html
html table class: 'monthTable';
	cellspacing:0;
	with: [	
		html tableRow
			class: 'monthRow';
			with: [
				html tableData
					class: 'calendarPrevious';
					with: [
						html anchor
							callback: [self previousMonth];
							onClick: (html prototype evaluator
										callback: [:script |
										self previousMonthUpdateOn: script];
										return: false);
							with: '<<' ].
				html tableData class: 'monthCurrent'; with: (Date nameOfMonth: self monthIndex).
				html tableData
					class: 'calendarNext';
					with: [html anchor
							callback: [self nextMonth];
							onClick: (html prototype evaluator
										callback: [:script | 
											self nextMonthUpdateOn: script];
											return: false);
							with: '>>'] ] ]!

renderYearNavigationOn: html
	html table
		class: 'yearTable';
		cellspacing:0;
		with: [	
			html tableRow: [
				html tableData
					class: 'year';
					with: [
						html anchor
							callback: [self previousYear];
							onClick:	(html scriptaculous evaluator
										callback: [:script |
											self previousYearUpdateOn: script];
											return: false);
							with: (self year - 1) ].
				html tableData
					class: 'year';
					class: 'yearCurrent';
					with: self year displayString.
				html tableData
					class: 'year';
					with: [
						html anchor
							callback: [self nextYear];
							onClick: ((html prototype evaluator)
										callback: [:script | self nextYearUpdateOn: script];
										return: false);
							with: (self year + 1) ] ] ]!

scriptSelect: aDate on: script 
	"Ajax select"
	self select: aDate.
	widgetId isNil ifTrue: [ ^ self ].
	script prototype element
		id: widgetId;
		access: 'value';
		assign: self formattedResult.
	script prototype element
		id: uid;
		remove.
	open := false!

scriptUpdateOn: script
	script prototype element
		id: uid;
		update: [:r | self renderBodyOn: r]!

setOriginWith: aString
	| anArray |
	anArray := aString greaseSubStrings: ','.
	anArray size > 1
		ifTrue: [self origin: (Point x: (anArray at: 1) asNumber y: (anArray at: 2) asNumber + 20)].!

states
	"Answer a collection of states that should be backtracked."

	^ #()!

uid
	"Answer the value of uid"

	^ uid!

uid: anObject
	"Set the value of uid"

	uid := anObject!

updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: SUComponentLibrary / #datePickerCss!

widgetId
	"Answer the value of widgetId"

	^ widgetId!

widgetId: anObject
	"Set the value of widgetId"

	widgetId := anObject! !
!SUDatePicker categoriesFor: #ajaxCallbackFor:on:!public!scripting! !
!SUDatePicker categoriesFor: #containerId!accessing!public! !
!SUDatePicker categoriesFor: #containerId:!accessing!public! !
!SUDatePicker categoriesFor: #format!accessing!public! !
!SUDatePicker categoriesFor: #format:!accessing!public! !
!SUDatePicker categoriesFor: #formattedResult!accessing!public! !
!SUDatePicker categoriesFor: #initialize!initialization!public! !
!SUDatePicker categoriesFor: #isOpen!accessing!public! !
!SUDatePicker categoriesFor: #nextMonthUpdateOn:!actions!public! !
!SUDatePicker categoriesFor: #nextYear!actions!public! !
!SUDatePicker categoriesFor: #nextYearUpdateOn:!actions!public! !
!SUDatePicker categoriesFor: #openOn:!public!scripting! !
!SUDatePicker categoriesFor: #origin!accessing!public! !
!SUDatePicker categoriesFor: #origin:!accessing!public! !
!SUDatePicker categoriesFor: #previousMonthUpdateOn:!actions!public! !
!SUDatePicker categoriesFor: #previousYear!actions!public! !
!SUDatePicker categoriesFor: #previousYearUpdateOn:!actions!public! !
!SUDatePicker categoriesFor: #renderBodyOn:!public!rendering! !
!SUDatePicker categoriesFor: #renderCalendarOn:!public!rendering! !
!SUDatePicker categoriesFor: #renderCellForDate:on:!public!rendering! !
!SUDatePicker categoriesFor: #renderContentOn:!public!rendering! !
!SUDatePicker categoriesFor: #renderMonthNavigationOn:!public!rendering! !
!SUDatePicker categoriesFor: #renderYearNavigationOn:!public!rendering! !
!SUDatePicker categoriesFor: #scriptSelect:on:!public!scripting! !
!SUDatePicker categoriesFor: #scriptUpdateOn:!public!scripting! !
!SUDatePicker categoriesFor: #setOriginWith:!public! !
!SUDatePicker categoriesFor: #states!accessing!public! !
!SUDatePicker categoriesFor: #uid!accessing!public! !
!SUDatePicker categoriesFor: #uid:!accessing!public! !
!SUDatePicker categoriesFor: #updateRoot:!public!updating! !
!SUDatePicker categoriesFor: #widgetId!accessing!public! !
!SUDatePicker categoriesFor: #widgetId:!accessing!public! !

!SUDatePicker class methodsFor!

on: aId 
	^ self 
		on: aId
		container: nil!

on: aId container: buttonId 
	^ self new
		widgetId: aId;
		containerId: buttonId;
		yourself! !
!SUDatePicker class categoriesFor: #on:!instance creation!public! !
!SUDatePicker class categoriesFor: #on:container:!instance creation!public! !

SUDateTimePicker guid: (GUID fromString: '{6ECF9F3A-BB28-462B-A74B-2BF53C981E6A}')!
SUDateTimePicker comment: ''!
!SUDateTimePicker categoriesForClass!Unclassified! !
!SUDateTimePicker methodsFor!

ajaxCallbackFor: aDate on: html
	^html prototype evaluator
		callback: [:script | self select: aDate. self scriptUpdateOn: script];
		return: false!

convertToInteger: aString max: maxValue 
	| anInteger |
	anInteger := aString greaseInteger.
	anInteger isNil ifTrue: [ ^ 0 ].
	^ (anInteger max: 0) min: maxValue!

formattedResult
	^super formattedResult , ' ', (self withLeadingZero: hours) ,':', (self withLeadingZero: minutes), ':', (self withLeadingZero: seconds)!

hours
	^ hours!

hours: anObject
	hours := self convertToInteger: anObject max: 23!

initialize
	| now |
	super initialize.
	showSeconds := false.
	now := DateAndTime now.
	hours := now hour.
	minutes := now minute.
	seconds := 0!

minutes
	^ minutes!

minutes: anObject
	minutes := self convertToInteger: anObject max: 59!

renderBodyOn: html
	html table
		cellspacing: 0;
		class: 'main';
		with: [
			self renderCalendarOn: html.
			self renderTimeOn: html	].

			!

renderTimeOn: html
	html tableRow: [
		html tableData
			class: 'time';
			colSpan: 9;
			align: 'center';
			with: [
				html form 
					id: self timeId;
					with: [
						html textInput
							maxLength: 2;
							value: (self withLeadingZero: hours);
							callback: [:v | self hours: v].
						html text: ':'.
						html textInput
							maxLength: 2;
							value: (self withLeadingZero: minutes);
							callback: [:v | self minutes: v].
						showSeconds ifTrue: [
							html text: ':'.
							html textInput
								maxLength: 2;
								value: (self withLeadingZero: seconds);
								callback: [:v | self seconds: v] ].
						html space.
						html anchor
							class: 'button';
							onClick: (self triggerFormOn: html);
							with: 'Ok' ] ] ]!

seconds
	^ seconds!

seconds: anObject
	seconds := self convertToInteger: anObject max: 59!

timeId
	^'time_', uid!

triggerFormOn: html
	^html prototype evaluator
		triggerForm: self timeId;
		callback: [:script | self scriptSelect: self date on: script];
		return: false!

withLeadingZero: anInteger 
	^ anInteger < 10 
		ifTrue: [ '0' , anInteger greaseString ]
		ifFalse: [ anInteger greaseString ]! !
!SUDateTimePicker categoriesFor: #ajaxCallbackFor:on:!public!scripting! !
!SUDateTimePicker categoriesFor: #convertToInteger:max:!private! !
!SUDateTimePicker categoriesFor: #formattedResult!accessing!public! !
!SUDateTimePicker categoriesFor: #hours!accessing!public! !
!SUDateTimePicker categoriesFor: #hours:!accessing!public! !
!SUDateTimePicker categoriesFor: #initialize!initialization!public! !
!SUDateTimePicker categoriesFor: #minutes!accessing!public! !
!SUDateTimePicker categoriesFor: #minutes:!accessing!public! !
!SUDateTimePicker categoriesFor: #renderBodyOn:!public!rendering! !
!SUDateTimePicker categoriesFor: #renderTimeOn:!public!rendering! !
!SUDateTimePicker categoriesFor: #seconds!accessing!public! !
!SUDateTimePicker categoriesFor: #seconds:!accessing!public! !
!SUDateTimePicker categoriesFor: #timeId!accessing!public! !
!SUDateTimePicker categoriesFor: #triggerFormOn:!public!scripting! !
!SUDateTimePicker categoriesFor: #withLeadingZero:!private! !

SULightbox guid: (GUID fromString: '{C1C34154-EB6A-4DE8-BE3D-73D719BD7227}')!
SULightbox comment: ''!
!SULightbox categoriesForClass!Unclassified! !
!SULightbox methodsFor!

children
	^ super children copyWith: self delegate!

delegate
	^ delegate!

delegate: aComponent
	delegate := aComponent!

isDelegation
	^ true!

lighter
	^ 'updateLightbox();Event.observe(window,"resize",function(){updateLightbox();});'!

renderContentOn: html
	super renderContentOn: html.
	html div id: 'overlay'.
	html div
		id: 'lightbox';
		style: 'display: none';
		with: self delegate.
	html document addLoadScriptFirst: self lighter!

script
	^ 'Object.extend(Position, {
	windowBounds: function() {
		var x = window.innerWidth
			|| document.documentElement.clientWidth
			|| document.body.clientWidth
			|| 0;
		var y = window.innerHeight
			|| document.documentElement.clientHeight
			|| document.body.clientHeight
			|| 0;
		return [x, y];
	}
});
Object.extend(Element, {
	fullscreen: function(element) {
		element = $(element);
		var bounds = Position.windowBounds();
		element.style.position = "absolute";
		element.style.left = element.style.top = 0;
		element.style.width = bounds[0] + "px";
		element.style.height = bounds[1] + "px";
	},
	center: function(element) {
		element = $(element);
		var extent = Element.getDimensions(element);
		var bounds = Position.windowBounds();
		var x = (bounds[0] - extent.width) / 2;
		var y = (bounds[1] - extent.height) / 2;
		x = x < 0 ? 0 : x; y = y < 0 ? 0 : y;
		element.style.position = "absolute";
		element.style.left = x + "px";
		element.style.top = y + "px";
	}
});
function updateLightbox() {//ie6 fix hide all select elements not inside the lightbox
	if (Prototype.Browser.IE) {if (navigator.userAgent.indexOf("MSIE 6") !!= -1) 
								{$$("select").invoke("setStyle", {visibility: "hidden"})
								$("lightbox").descendants().each(function(item) {item.setStyle({visibility: "visible"})})}};
	Element.fullscreen("overlay");
	Element.center("lightbox");
	Element.show("lightbox");
};'!

style
	^ 'html { overflow: hidden; }
body { overflow: hidden; }
div#overlay {
	z-index: 9998;
	background-color: black;
	filter: alpha(opacity=40);
	-moz-opacity: 0.4;
	opacity: 0.4;
}
div#overlay[id] { position: fixed; }
div#lightbox { z-index: 9999; }'! !
!SULightbox categoriesFor: #children!accessing!public! !
!SULightbox categoriesFor: #delegate!accessing!public! !
!SULightbox categoriesFor: #delegate:!accessing!public! !
!SULightbox categoriesFor: #isDelegation!public!testing! !
!SULightbox categoriesFor: #lighter!accessing-scripts!public! !
!SULightbox categoriesFor: #renderContentOn:!public!rendering! !
!SULightbox categoriesFor: #script!accessing-scripts!public! !
!SULightbox categoriesFor: #style!accessing-scripts!public! !

"Binary Globals"!

