| package |
package := Package name: 'Scriptaculous-Tests-Components'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '33'.


package classNames
	add: #SUAccordionTest;
	add: #SUAllComponentTests;
	add: #SUCarouselHorizontalTest;
	add: #SUCarouselTest;
	add: #SUCarouselVerticalTest;
	add: #SUDatePickerTest;
	add: #SUDialogTest;
	add: #SUHorizontalSplitterTest;
	add: #SULightboxTest;
	add: #SUSmallBoxTest;
	add: #SUTabPanelTest;
	add: #SUTieredListTest;
	add: #SUTitlePaneTest;
	add: #SUTooltipTest;
	add: #SUTreeReportTest;
	add: #SUVerticalSplitterTest;
	add: #SUWindowTest;
	yourself.

package methodNames
	add: #SUAllFunctionalTests -> #renderChildrenOn:;
	add: 'GRPackage class' -> #scriptaculousTestsComponents;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: '..\Javascript\Javascript-Core';
	add: '..\Prototype\Prototype-Core';
	add: 'Scriptaculous-Components';
	add: 'Scriptaculous-Core';
	add: 'Scriptaculous-Tests-Core';
	add: '..\Seaside\Seaside-Component';
	add: '..\Seaside\Seaside-Tools-Core';
	add: '..\Seaside\Seaside-Widgets';
	yourself).

package!

"Class Definitions"!

WAComponent subclass: #SUDialogTest
	instanceVariableNames: 'answerBlock'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #SUSmallBoxTest
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #SUTooltipTest
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUAllTests subclass: #SUAllComponentTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUFunctionalTest subclass: #SUAccordionTest
	instanceVariableNames: 'accordion'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUFunctionalTest subclass: #SUCarouselHorizontalTest
	instanceVariableNames: 'carousel'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUFunctionalTest subclass: #SUCarouselTest
	instanceVariableNames: 'carousel'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUFunctionalTest subclass: #SUCarouselVerticalTest
	instanceVariableNames: 'carousel'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUFunctionalTest subclass: #SUDatePickerTest
	instanceVariableNames: 'component timeComponent'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUFunctionalTest subclass: #SUHorizontalSplitterTest
	instanceVariableNames: 'splitter'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUFunctionalTest subclass: #SULightboxTest
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUFunctionalTest subclass: #SUTabPanelTest
	instanceVariableNames: 'tabPanel'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUFunctionalTest subclass: #SUTieredListTest
	instanceVariableNames: 'tieredList'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUFunctionalTest subclass: #SUTitlePaneTest
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUFunctionalTest subclass: #SUTreeReportTest
	instanceVariableNames: 'treeReport'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUFunctionalTest subclass: #SUVerticalSplitterTest
	instanceVariableNames: 'splitter'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SUFunctionalTest subclass: #SUWindowTest
	instanceVariableNames: 'windows'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

scriptaculousTestsComponents
	^ self new
		name: 'Scriptaculous-Tests-Components';
		description: 'Functional and unit tests for the Scriptaculous-Components package.';
		addDependency: 'Scriptaculous-Components';
		addDependency: 'Scriptaculous-Tests-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #scriptaculousTestsComponents!*scriptaculous-tests-components!public! !

!SUAllFunctionalTests methodsFor!

renderChildrenOn: html
	"With Scriptaculous-Components loaded, we can display 'Example Source' using a lightbox. "

	html div id: 'content'; with: [
		selected do: [ :each |
			html heading: each key; render: each value.
			each value testClass isNil ifFalse: [
				html paragraph: [
					html anchor
						callback: [ self lightbox: (SUClassBrowser onClass: each value testClass) ];
						with: 'Example source' ] ] ] ]! !
!SUAllFunctionalTests categoriesFor: #renderChildrenOn:!*scriptaculous-tests-components!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

SUDialogTest guid: (GUID fromString: '{C5C4BCE8-FD6A-4435-A643-4BBA81A4AAC1}')!
SUDialogTest comment: ''!
!SUDialogTest categoriesForClass!Unclassified! !
!SUDialogTest methodsFor!

answer: aBlock
	aBlock fixCallbackTemps.
	answerBlock := aBlock!

renderContentOn: html
		html paragraph: 'Window answer test'.
		html paragraph: [
			html anchor
				onClick: (html prototype evaluator callback: [:s | answerBlock value: s]);
				with: 'OK']! !
!SUDialogTest categoriesFor: #answer:!accessing!public! !
!SUDialogTest categoriesFor: #renderContentOn:!public!rendering! !

SUSmallBoxTest guid: (GUID fromString: '{E4F62F89-81F8-4812-8DC0-D9DE000565AC}')!
SUSmallBoxTest comment: ''!
!SUSmallBoxTest categoriesForClass!Unclassified! !
!SUSmallBoxTest methodsFor!

coreClass
	"Answer the actual implementation of the feature."
	
	^ nil!

renderContentOn: html
	html div class: 'smallBox'; with: [
		html div class: 'header'.
		html div 
			class: 'content';
			with: text ]!

testClass
	"Answer the class that represents this example."
	
	^ self class!

text
	^ text!

text: anObject
	text := anObject! !
!SUSmallBoxTest categoriesFor: #coreClass!public!testing! !
!SUSmallBoxTest categoriesFor: #renderContentOn:!public!rendering! !
!SUSmallBoxTest categoriesFor: #testClass!public!testing! !
!SUSmallBoxTest categoriesFor: #text!accessing!public! !
!SUSmallBoxTest categoriesFor: #text:!accessing!public! !

SUTooltipTest guid: (GUID fromString: '{3E96321B-3926-4456-ABE7-FDDFE3D75E88}')!
SUTooltipTest comment: ''!
!SUTooltipTest categoriesForClass!Unclassified! !
!SUTooltipTest methodsFor!

initialize
	super initialize.
	text := ''!

renderContentOn: html
	html text: text!

text: aText
	text := aText!

textWithKey: aKey
	self text: (self class tooltips at: aKey asSymbol ifAbsent: ['Tooltip for key "', aKey , '" not found!!'])! !
!SUTooltipTest categoriesFor: #initialize!initialization!public! !
!SUTooltipTest categoriesFor: #renderContentOn:!public!rendering! !
!SUTooltipTest categoriesFor: #text:!accessing!public! !
!SUTooltipTest categoriesFor: #textWithKey:!accessing!public! !

!SUTooltipTest class methodsFor!

tooltips
	| dictionary |
	dictionary := Dictionary new.
	dictionary at: #hello put: 'Hello world!!'.
	dictionary at: #ok put: 'This is not the ok button!!'.
	^ dictionary! !
!SUTooltipTest class categoriesFor: #tooltips!accessing!public! !

SUAllComponentTests guid: (GUID fromString: '{886E607C-5B0F-476B-8FE9-BEB6178FFF27}')!
SUAllComponentTests comment: ''!
!SUAllComponentTests categoriesForClass!Unclassified! !
!SUAllComponentTests methodsFor!

initializeTabs
	tabs := OrderedCollection new
		add: 'Welcome' -> (Array
			with: 'Welcome' -> SUWelcomeTest new
			with: 'Counter' -> SUCounterTest new);
		add: 'Window' -> (Array
			with: 'Window' -> SUWindowTest new
			with: 'Lightbox' -> SULightboxTest new
			with: 'TitlePane' -> SUTitlePaneTest new
			with: 'Splitter Vertical'-> SUVerticalSplitterTest new
			with: 'Splitter Horizontal'-> SUHorizontalSplitterTest new);
		add: 'Navigation' -> (Array
			with: 'TabPanel' -> SUTabPanelTest new
			with: 'Accordion' -> SUAccordionTest new
			with: 'Carousel' -> SUCarouselTest new
			with: 'Carousel Horizontal'-> SUCarouselHorizontalTest new
			with: 'Carousel Vertical'-> SUCarouselVerticalTest new);
		add: 'Controls' -> (Array
			with: 'TieredList' -> SUTieredListTest new
			with: 'TreeReport' -> SUTreeReportTest new
			with: 'DatePicker' -> SUDatePickerTest new);
		yourself!

renderChildrenOn: html
	"Display 'Example Source' and 'Actual Source' using a lightbox. "

	html div id: 'content'; with: [
		selected do: [ :each |
			html heading: each key; render: each value.
			each value testClass isNil ifFalse: [
				html paragraph: [
					html anchor
						callback: [ self lightbox: (SUClassBrowser onClass: each value testClass) ];
						with: 'Example source'.
					each value coreClass isNil ifFalse: [
						html break.
						html anchor
							callback: [ self lightbox: (SUClassBrowser onClass: each value coreClass) ];
							with: 'Actual implementation' ] ] ]
				 ] ]!

title
	^ super title , ' Components'! !
!SUAllComponentTests categoriesFor: #initializeTabs!initialization!public! !
!SUAllComponentTests categoriesFor: #renderChildrenOn:!public!rendering! !
!SUAllComponentTests categoriesFor: #title!accessing!public! !

!SUAllComponentTests class methodsFor!

canBeRoot
	^ true!

description
	^ 'Scriptaculous Component Functional Test Suite'!

initialize
	(WAAdmin register: self asApplicationAt: 'javascript/scriptaculous-components')
		addLibrary: PTDeploymentLibrary;
		addLibrary: SUDeploymentLibrary;
		addLibrary: SUComponentLibrary;
		addLibrary: SUAllTestLibrary! !
!SUAllComponentTests class categoriesFor: #canBeRoot!initialization!public! !
!SUAllComponentTests class categoriesFor: #description!accessing!public! !
!SUAllComponentTests class categoriesFor: #initialize!initialization!public! !

SUAccordionTest guid: (GUID fromString: '{3339A4E1-2444-4288-B013-EEED090FEC48}')!
SUAccordionTest comment: ''!
!SUAccordionTest categoriesForClass!Unclassified! !
!SUAccordionTest methodsFor!

children
	^Array with: accordion!

coreClass
	^ SUAccordion!

initialize
	super initialize.
	accordion := SUAccordion new
		add: (SUCounterTest on: 1) label: 'Counter 1';
		add: (SUCounterTest on: 2) label: 'Counter 2';
		add: (SUCounterTest on: 3) label: 'Counter 3';
		yourself! !
!SUAccordionTest categoriesFor: #children!accessing!public! !
!SUAccordionTest categoriesFor: #coreClass!accessing!public! !
!SUAccordionTest categoriesFor: #initialize!initialization!public! !

SUCarouselHorizontalTest guid: (GUID fromString: '{576E8170-4D12-45CD-8142-E3C96D80339B}')!
SUCarouselHorizontalTest comment: ''!
!SUCarouselHorizontalTest categoriesForClass!Unclassified! !
!SUCarouselHorizontalTest methodsFor!

children
	^Array with: carousel!

coreClass
	^ SUHorizontalCarousel!

initialize
	super initialize.
	carousel := SUHorizontalCarousel new.
	carousel elementExtent: (Point 
			x: 80
			y: 80).
	1 
		to: 50
		do: 
			[ :idx | 
			carousel add: (SUSmallBoxTest new
					text: 'Test Box: ' , idx greaseString;
					yourself) ]! !
!SUCarouselHorizontalTest categoriesFor: #children!accessing!public! !
!SUCarouselHorizontalTest categoriesFor: #coreClass!accessing!public! !
!SUCarouselHorizontalTest categoriesFor: #initialize!initialization!public! !

SUCarouselTest guid: (GUID fromString: '{82EAF41D-B377-47DB-98D9-8F5262C76FC7}')!
SUCarouselTest comment: ''!
!SUCarouselTest categoriesForClass!Unclassified! !
!SUCarouselTest methodsFor!

children
	^Array with: carousel!

coreClass
	^ SUNavigationCarousel!

initialize
	super initialize.
	carousel := SUNavigationCarousel new.
	1 to: 10 do: [:idx | carousel add: (SUCounterTest on: idx) label: 'Counter ', idx displayString ].


	! !
!SUCarouselTest categoriesFor: #children!accessing!public! !
!SUCarouselTest categoriesFor: #coreClass!accessing!public! !
!SUCarouselTest categoriesFor: #initialize!initialization!public! !

SUCarouselVerticalTest guid: (GUID fromString: '{29847A95-5D78-4F38-9A7F-5BF7185A3331}')!
SUCarouselVerticalTest comment: ''!
!SUCarouselVerticalTest categoriesForClass!Unclassified! !
!SUCarouselVerticalTest methodsFor!

children
	^Array with: carousel!

coreClass
	^ SUHorizontalCarousel!

initialize
	super initialize.
	carousel := SUVerticalCarousel new.
	carousel
		elementExtent: (Point 
				x: 370
				y: 60);
		numVisible: 3;
		scrollInc: 3;
		navMargin: 14;
		animationSpeed: 0.3.
	1 
		to: 20
		do: 
			[ :idx | 
			carousel add: (SUSmallBoxTest new
					text: 'Test Box: ' , idx greaseString;
					yourself) ]! !
!SUCarouselVerticalTest categoriesFor: #children!accessing!public! !
!SUCarouselVerticalTest categoriesFor: #coreClass!accessing!public! !
!SUCarouselVerticalTest categoriesFor: #initialize!initialization!public! !

SUDatePickerTest guid: (GUID fromString: '{A9E89FCC-97D6-4671-BD8D-C2193EB3F86E}')!
SUDatePickerTest comment: ''!
!SUDatePickerTest categoriesForClass!Unclassified! !
!SUDatePickerTest methodsFor!

children
	^Array with: component with: timeComponent!

coreClass
	^ SUDatePicker!

openDatePickerOn: script
	component openOn: script
!

openDateTimePickerOn: script
	timeComponent openOn: script
!

renderContentOn: html
	| theId divId theId2 | 
	component := nil.
	timeComponent := nil.
	theId := html nextId.
	divId := html nextId.
	theId2 := html nextId.
	html div id: divId.
	html form: [
		html table: [
				html tableRow: [
					html tableData: [ html textInput id: theId ].
					html tableData: [
						html button value: 'Set date';
							onClick: (html prototype evaluator
								callback: [:v | self setupDatePickerOn: theId div: divId origin: v] value: (html prototype element id: theId; cumulativeOffset);
								callback: [:script | self openDatePickerOn: script];
											return: false) ] ].
				html tableRow: [
					html tableData: [ html textInput id: theId2 ].
					html tableData: [
						html button value: 'Set date & time';
							onClick: (html prototype evaluator
								callback: [:v | self setupDateTimePickerOn: theId2 div: divId origin: v] value: (html prototype element id: theId2; cumulativeOffset);
								callback: [:script | self openDateTimePickerOn: script];
											return: false) ] ] ] ].
!

setupDatePickerOn: theId div: divId origin: originString 
	component ifNil: 
		[ component := SUDatePicker 
			on: theId
			container: divId ].
	component setOriginWith: originString!

setupDateTimePickerOn: theId div: divId origin: originString 
	timeComponent ifNil: 
		[ timeComponent := SUDateTimePicker 
			on: theId
			container: divId ].
	timeComponent format: #(1 2 3 $. 1 1).
	timeComponent setOriginWith: originString! !
!SUDatePickerTest categoriesFor: #children!accessing!public! !
!SUDatePickerTest categoriesFor: #coreClass!accessing!public! !
!SUDatePickerTest categoriesFor: #openDatePickerOn:!public!rendering! !
!SUDatePickerTest categoriesFor: #openDateTimePickerOn:!public!rendering! !
!SUDatePickerTest categoriesFor: #renderContentOn:!public!rendering! !
!SUDatePickerTest categoriesFor: #setupDatePickerOn:div:origin:!public!rendering! !
!SUDatePickerTest categoriesFor: #setupDateTimePickerOn:div:origin:!public!rendering! !

SUHorizontalSplitterTest guid: (GUID fromString: '{BF0B444C-EEC7-412E-BE4E-F9ADF48A7819}')!
SUHorizontalSplitterTest comment: ''!
!SUHorizontalSplitterTest categoriesForClass!Unclassified! !
!SUHorizontalSplitterTest methodsFor!

children
	^ Array with: splitter!

coreClass
	^ SUHorizontalSplitter!

initialize
	super initialize.
	splitter := SUHorizontalSplitter new
		add: (SUCounterTest on: 1) size: '50px' min: 30;
		add: (SUCounterTest on: 2) size: '50px' min: 30;
		add: (SUCounterTest on: 3) size: '50px' min: 30;
		yourself! !
!SUHorizontalSplitterTest categoriesFor: #children!accessing!public! !
!SUHorizontalSplitterTest categoriesFor: #coreClass!accessing!public! !
!SUHorizontalSplitterTest categoriesFor: #initialize!initialization!public! !

SULightboxTest guid: (GUID fromString: '{CCB18439-10E8-4A5B-90F7-220056187477}')!
SULightboxTest comment: ''!
!SULightboxTest categoriesForClass!Unclassified! !
!SULightboxTest methodsFor!

inform: aString
	self lightbox: (WAFormDialog new addMessage: aString; yourself).
	self lightbox: (WAFormDialog new addMessage: 'Back for more'; yourself)!

renderContentOn: html
	html form
		style: 'text-align: center';
		with:[
			html div: [
				html text: 'What is your favorite transportation system ?'.
				3 timesRepeat:[html break].
				html select
					list:    #(Automobile Airplane Truck Boat Bicycle Horse Walking Swimming);
					selected: value;
					callback: [:v | value := v].
				html submitButton value: 'Ok'; callback: [self inform: value]]]!

style
	^'
div#lightbox {
	background: white;
	border: 1px solid #0000e8;
	padding: 2em;
	width: 40em;
	text-align: center;
}
div#overlay {
	background-color: black;
	filter: alpha(opacity=30);
	-moz-opacity: 0.3;
	opacity: 0.3;
}
'! !
!SULightboxTest categoriesFor: #inform:!public!user interface! !
!SULightboxTest categoriesFor: #renderContentOn:!public!rendering! !
!SULightboxTest categoriesFor: #style!public!rendering! !

SUTabPanelTest guid: (GUID fromString: '{F3385C21-5864-42E1-818D-6953E090BA51}')!
SUTabPanelTest comment: ''!
!SUTabPanelTest categoriesForClass!Unclassified! !
!SUTabPanelTest methodsFor!

children
	^ Array with: tabPanel!

coreClass
	^ SUTabPanel!

initialize
	super initialize.
	tabPanel := SUTabPanel new
		add: (SUCounterTest on: 1) label: 'Counter 1';
		add: (SUCounterTest on: 2) label: 'Counter 2';
		add: (SUCounterTest on: 3) label: 'Counter 3';
		yourself!

updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: SUComponentLibrary / #tabPanelCss! !
!SUTabPanelTest categoriesFor: #children!accessing!public! !
!SUTabPanelTest categoriesFor: #coreClass!accessing!public! !
!SUTabPanelTest categoriesFor: #initialize!initialization!public! !
!SUTabPanelTest categoriesFor: #updateRoot:!public!updating! !

SUTieredListTest guid: (GUID fromString: '{D3BED533-5BD9-4EC1-9E1A-91212A955E66}')!
SUTieredListTest comment: ''!
!SUTieredListTest categoriesForClass!Unclassified! !
!SUTieredListTest methodsFor!

children
	^Array with: tieredList!

coreClass
	^ SUTieredList!

initialize
	super initialize.
	tieredList := SUTieredList new
		labels: [ :value | value fullName ];
		children: [ :value | 
			value subclasses
				asSortedCollection: [ :a :b | a name < b name ] ];
		selection: (OrderedCollection with: Collection);
		yourself! !
!SUTieredListTest categoriesFor: #children!accessing!public! !
!SUTieredListTest categoriesFor: #coreClass!accessing!public! !
!SUTieredListTest categoriesFor: #initialize!initialization!public! !

SUTitlePaneTest guid: (GUID fromString: '{3A8C5761-3A66-4F0E-8440-87D5245FD06F}')!
SUTitlePaneTest comment: ''!
!SUTitlePaneTest categoriesForClass!Unclassified! !
!SUTitlePaneTest methodsFor!

children
	^Array with: component!

coreClass
	^ SUTitlePane!

initialize
	super initialize.
	component := self coreClass new title: 'Title';
		body: (SUFormTest new)
"		body: (SUCounterTest on: 1); yourself"
		
"		body: (SUCarouselTest new); yourself"

	


	! !
!SUTitlePaneTest categoriesFor: #children!accessing!public! !
!SUTitlePaneTest categoriesFor: #coreClass!accessing!public! !
!SUTitlePaneTest categoriesFor: #initialize!initialization!public! !

SUTreeReportTest guid: (GUID fromString: '{A8952039-3336-4C35-B8D5-BB771901F04C}')!
SUTreeReportTest comment: ''!
!SUTreeReportTest categoriesForClass!Unclassified! !
!SUTreeReportTest methodsFor!

children
	^ Array with: treeReport!

coreClass
	^ SUTreeReport!

initialize
	super initialize.
	treeReport := SUTreeReport new
		expand: Collection;
		roots: (Array with: Collection);
		children: [ :value | 
			value subclasses
				asSortedCollection: [ :a :b | a name < b name ] ];
		addColumn: [ :value | value name ]
			label: 'Class Name';
		addColumn: [ :value |
			[ :html |
				value instVarNames
					do: [ :each | html text: each ]
					separatedBy: [ html text: ', ' ] ] ]
			label: 'Instance Variables';
		yourself! !
!SUTreeReportTest categoriesFor: #children!accessing!public! !
!SUTreeReportTest categoriesFor: #coreClass!accessing!public! !
!SUTreeReportTest categoriesFor: #initialize!initialization!public! !

SUVerticalSplitterTest guid: (GUID fromString: '{5EC91E15-5ADC-44A8-AAE7-C7BE0BC4B25B}')!
SUVerticalSplitterTest comment: ''!
!SUVerticalSplitterTest categoriesForClass!Unclassified! !
!SUVerticalSplitterTest methodsFor!

children
	^ Array with: splitter!

coreClass
	^ SUVerticalSplitter!

initialize
	super initialize.
	splitter := SUVerticalSplitter new
		add: (SUCounterTest on: 1) size: '150px' min: 60;
		add: (SUCounterTest on: 2) size: '150px' min: 80;
		add: (SUCounterTest on: 3) size: '150px' min: 80;
		yourself! !
!SUVerticalSplitterTest categoriesFor: #children!accessing!public! !
!SUVerticalSplitterTest categoriesFor: #coreClass!accessing!public! !
!SUVerticalSplitterTest categoriesFor: #initialize!initialization!public! !

SUWindowTest guid: (GUID fromString: '{74F95C3B-5C9F-4256-A9A1-BD87AD4706D1}')!
SUWindowTest comment: ''!
!SUWindowTest categoriesForClass!Unclassified! !
!SUWindowTest methodsFor!

children
	^windows!

coreClass
	^ SUWindow!

initialize
	super initialize.
	windows := OrderedCollection 
					with: ((SUWindow on: [:w | SUCounterTest on: 10]) id: 'window_1'; zIndex: 1000; title: 'Window 1'; yourself)
					with: ((SUWindow on: [:w | SUFormTest new]) id: 'window_2';
								zIndex: 1001;
								origin: (300@100);
								extent: 500@240;
								title: 'Window 2';
								yourself)
					with: ((SUWindow on: [:w | SUTooltipTest new]) id: 'window_3';
								updateBlock: [:w :model | model textWithKey: (w tooltipKey)];
								zIndex: 1003;
								extent: 150@45;
								title: 'Tooltip';
								closeButtonEnabled: false;
								minimizeButtonEnabled: false;
								yourself).
	windows add: ((SUWindow on: [:w | SUDialogTest new
											answer: [:script | 
												script alert: 'Window will be closed'. 
												script add: (JSStream on: '$("overlay").hide()').
												w closeOn: script];
											yourself]) 
										id: 'dialog_window';
										closeButtonEnabled: false;
										minimizeButtonEnabled: false;
										zIndex: 9999;
										title: 'Window 4'; yourself).
!

renderContentOn: html 
	| aWindow |
	html div id: 'overlay'.
	html big: 'Window Test:'.
	html space.
	html anchor
		onClick: (html prototype evaluator callback: [ : script | windows first openOn: script ]) ;
		with: 'Open window 1'.
	html space: 2.
	html anchor
		onClick: (html prototype evaluator callback: [ : script | (windows at: 2) openOn: script ]) ;
		with: 'Open window 2'.
	html space: 2.
	html anchor
		onClick: (html prototype evaluator
					callback: [ : script | 
						script add: (JSStream on: 'Element.fullscreen("overlay")'). 
						(windows at: 4) openOn: script.
						script add: (JSStream on: 'Element.center("dialog_window")') ]) ;
		with: 'Open dialog window'.
	html space: 2.
	aWindow := windows at: 3.
	html anchor
		class: 'tt' ;
		attributeAt: 'rel'
			put: 'ok' ;
		with: 'Show tooltip 1'.
	html space: 2.
	html anchor
		class: 'tt' ;
		attributeAt: 'rel'
			put: 'hello' ;
		with: 'Show tooltip 2'.
	html space: 2.
	html anchor
		class: 'tt' ;
		attributeAt: 'rel'
			put: 'illegal' ;
		with: 'Show tooltip 3'.
	windows do: [:w | html render: w ].
	self 
		tooltipScriptOn: html
		window: aWindow!

script
	^ 'Object.extend(Position, {
	windowBounds: function() {
		var x = window.innerWidth
			|| document.documentElement.clientWidth
			|| document.body.clientWidth
			|| 0;
		var y = window.innerHeight
			|| document.documentElement.clientHeight
			|| document.body.clientHeight
			|| 0;
		return [x, y];
	}
});
Object.extend(Element, {
	fullscreen: function(element) {
		element = $(element);
		element.show();
		element.style.position = "absolute";
		element.style.left = element.style.top = 0;
		element.style.width = "100%";
		element.style.height = "5000px";
	},
	center: function(element) {
		element = $(element);
		var extent = Element.getDimensions(element);
		var bounds = Position.windowBounds();
		var x = (bounds[0] - extent.width) / 2;
		var y = (bounds[1] - extent.height) / 2;
		x = x < 0 ? 0 : x; y = y < 0 ? 0 : y;
		element.style.position = "absolute";
		element.style.left = x + "px";
		element.style.top = y + "px";
	}
});'!

style
	^ '
div#overlay {
	z-index: 9998;
	background-color: #336699;
	filter: alpha(opacity=30);
	-moz-opacity: 0.3;
	opacity: 0.3;
}
div#overlay[id] { position: fixed; }
'!

tooltipScriptOn: html window: aWindow
	"add an event handler to all anchors which have the class tt"
	"use the html rel attribute as tooltip index"
	
	html document addLoadScript: (html prototype selector
     	add: 'a.tt';
     	do: [ :each | each element on: 'mouseover' do: ((JSStream on: 'event.target._showState = true'),
				((JSStream on: 'event.target._showState') then:
					(html prototype evaluator 
						callback: [:v | | values |
								values := v greaseSubStrings: ','.
								aWindow originX: values first y: (values at: 2) ; tooltipKey: (values at: 3)]
						value: (JSStream on: '[event.clientX,event.clientY,event.target.rel]');
						callback: [:script | aWindow openOn: script hidden: true];
						onComplete: ((JSStream on: 'event.target._showState') then: (html prototype element id: aWindow windowId; show)));
						timeout: 2000)).
				each element on: 'mouseout' do: 	((JSStream on: 'event.target._showState = false'),
					((html prototype element id: aWindow windowId; visible) then:
						(html prototype evaluator 
							callback: [:script | aWindow closeOn: script ] ) ) ) ] )

	! !
!SUWindowTest categoriesFor: #children!accessing!public! !
!SUWindowTest categoriesFor: #coreClass!accessing!public! !
!SUWindowTest categoriesFor: #initialize!initialization!public! !
!SUWindowTest categoriesFor: #renderContentOn:!public!rendering! !
!SUWindowTest categoriesFor: #script!public!rendering! !
!SUWindowTest categoriesFor: #style!public!rendering! !
!SUWindowTest categoriesFor: #tooltipScriptOn:window:!public!scripting! !

"Binary Globals"!

