| package |
package := Package name: 'Seaside-Swazoo'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '19'.


package classNames
	add: #WAPluggableSite;
	add: #WorkingHTTPSetCookie2Field;
	add: #WorkingHTTPSetCookieField;
	yourself.

package methodNames
	add: 'GRPackage class' -> #seasideSwazoo;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: 'Grease\Grease-Core';
	add: 'Swazoo\Swazoo';
	yourself).

package!

"Class Definitions"!

HTTPSetCookieField subclass: #WorkingHTTPSetCookieField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WorkingHTTPSetCookieField subclass: #WorkingHTTPSetCookie2Field
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SwazooSite subclass: #WAPluggableSite
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

seasideSwazoo
	^ self new
		name: 'Seaside-Swazoo';
		description: 'A small set of Swazoo 2 extensions to make it run Seaside.';
		addDependency: 'Grease-Core';
		url: #seasideLGPLUrl;
		license: #LGPL;
		yourself
! !
!GRPackage class categoriesFor: #seasideSwazoo!*seaside-swazoo!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

WorkingHTTPSetCookieField guid: (GUID fromString: '{018B112F-4D84-4B47-802A-348F7B290BD4}')!
WorkingHTTPSetCookieField comment: 'A WorkingHTTPSetCookieField is a working implementation of HTTPSetCookieField. The problem with HTTPSetCookieField is that Swazoo developers think it is more important to be compliant with philosophical principles than Firefox and Internet Explorer. The HTTP spec says that any multi valued header field can legally be combined with a '',''. But Firefox and Internet Explorer don''t support this because the value of set cookie header can legally contain a '',''. So this implementaion does not combine set cookie headers. This allows you to set multiple cookies with one response.'!
!WorkingHTTPSetCookieField categoriesForClass!Unclassified! !
!WorkingHTTPSetCookieField methodsFor!

crlfOn: aStream 
	aStream crlf!

printOn: aStream
	self cookies
		do: [ :each | self printValue: each on: aStream ]
		separatedBy: [ self crlfOn: aStream ]
	!

printValue: aString on: aStream
	aStream
		nextPutAll: self name;
		nextPutAll: ': '.
	aStream nextPutAll: aString! !
!WorkingHTTPSetCookieField categoriesFor: #crlfOn:!printing!public! !
!WorkingHTTPSetCookieField categoriesFor: #printOn:!printing!public! !
!WorkingHTTPSetCookieField categoriesFor: #printValue:on:!printing!public! !

WorkingHTTPSetCookie2Field guid: (GUID fromString: '{04A48576-223C-426B-8D04-2C5A2A0F7AA8}')!
WorkingHTTPSetCookie2Field comment: '
A WorkingHTTPSetCookie2Field is a Set-Cookie2 header field, currently only suported by Opera.
'!
!WorkingHTTPSetCookie2Field categoriesForClass!Unclassified! !
!WorkingHTTPSetCookie2Field class methodsFor!

fieldName
	^'Set-Cookie2'! !
!WorkingHTTPSetCookie2Field class categoriesFor: #fieldName!accessing!public! !

WAPluggableSite guid: (GUID fromString: '{5B535085-FD3E-4900-BB19-58FDFEE978CF}')!
WAPluggableSite comment: ''!
!WAPluggableSite categoriesForClass!Unclassified! !
!WAPluggableSite methodsFor!

answerTo: aSwazooRequest
	^ handler process: aSwazooRequest!

helpResolve: aResolution 
	(self canAnswer and: [ aResolution siteMatch: self ]) ifFalse: [^nil].
	^self answerTo: aResolution request!

initializeWithHandler: aHandler
	handler := aHandler! !
!WAPluggableSite categoriesFor: #answerTo:!public!serving! !
!WAPluggableSite categoriesFor: #helpResolve:!public!serving-private! !
!WAPluggableSite categoriesFor: #initializeWithHandler:!initialization!public! !

!WAPluggableSite class methodsFor!

named: aString on: aHandler
	^self new
		name: aString;
		initializeWithHandler: aHandler;
		yourself! !
!WAPluggableSite class categoriesFor: #named:on:!instance creation!public! !

"Binary Globals"!

