| package |
package := Package name: 'Seaside-Pharo-Core'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '9'.


package methodNames
	add: #Bag -> #_restoreFromSnapshot:;
	add: #Bag -> #_snapshotCopy;
	add: #BlockClosure -> #renderOn:;
	add: #Dictionary -> #_restoreFromSnapshot:;
	add: #Dictionary -> #_snapshotCopy;
	add: #MessageSend -> #renderOn:;
	add: #Object -> #_restoreFromSnapshot:;
	add: #Object -> #_snapshotCopy;
	add: #OrderedCollection -> #_restoreFromSnapshot:;
	add: #OrderedCollection -> #_snapshotCopy;
	add: #PositionableStream -> #seasideMimeDocument;
	add: #PositionableStream -> #seasideMimeDocumentType:;
	add: #Set -> #_restoreFromSnapshot:;
	add: #Set -> #_snapshotCopy;
	add: 'GRPackage class' -> #seasideDolphinCore;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\..\Grease\Grease-Core';
	yourself).

package!

"Class Definitions"!


"Global Aliases"!


"Loose Methods"!

!Bag methodsFor!

_restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy!

_snapshotCopy
	^ self copy! !
!Bag categoriesFor: #_restoreFromSnapshot:!*seaside-pharo-core-backtracking!public! !
!Bag categoriesFor: #_snapshotCopy!*seaside-pharo-core-backtracking!public! !

!BlockClosure methodsFor!

renderOn: aRenderer
	self numArgs = 0
		ifTrue: [ self value ]
		ifFalse: [ self value: aRenderer ]! !
!BlockClosure categoriesFor: #renderOn:!*seaside-pharo-core!public! !

!Dictionary methodsFor!

_restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy!

_snapshotCopy
	^ self copy! !
!Dictionary categoriesFor: #_restoreFromSnapshot:!*seaside-pharo-core-backtracking!public! !
!Dictionary categoriesFor: #_snapshotCopy!*seaside-pharo-core-backtracking!public! !

!GRPackage class methodsFor!

seasideDolphinCore
	^(self new)
		name: 'Seaside-Dolphin-Core';
		addDependency: 'Seaside-Core';
		addDependency: 'Grease-Dolphin-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideDolphinCore!*seaside-pharo-core!public! !

!MessageSend methodsFor!

renderOn: html
	self value: html! !
!MessageSend categoriesFor: #renderOn:!*seaside-pharo-core!public! !

!Object methodsFor!

_restoreFromSnapshot: anObject
	self copyFrom: anObject!

_snapshotCopy
	^ self shallowCopy! !
!Object categoriesFor: #_restoreFromSnapshot:!*seaside-pharo-core-backtracking!public! !
!Object categoriesFor: #_snapshotCopy!*seaside-pharo-core-backtracking!public! !

!OrderedCollection methodsFor!

_restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy!

_snapshotCopy
	^ self copy! !
!OrderedCollection categoriesFor: #_restoreFromSnapshot:!*seaside-pharo-core-backtracking!public! !
!OrderedCollection categoriesFor: #_snapshotCopy!*seaside-pharo-core-backtracking!public! !

!PositionableStream methodsFor!

seasideMimeDocument
	^ self contents seasideMimeDocument!

seasideMimeDocumentType: aMimetype
	^self seasideMimeDocument mimeType: aMimetype; yourself! !
!PositionableStream categoriesFor: #seasideMimeDocument!*seaside-pharo-core!public! !
!PositionableStream categoriesFor: #seasideMimeDocumentType:!*seaside-pharo-core!public! !

!Set methodsFor!

_restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy!

_snapshotCopy
	^ self copy! !
!Set categoriesFor: #_restoreFromSnapshot:!*seaside-pharo-core-backtracking!public! !
!Set categoriesFor: #_snapshotCopy!*seaside-pharo-core-backtracking!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

"Binary Globals"!

