| package |
package := Package name: 'Seaside-Component'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '85'.


package classNames
	add: #WAAllPresenterGuide;
	add: #WAAnswerHandler;
	add: #WAChildrenNotCollectionError;
	add: #WAComponent;
	add: #WADecoration;
	add: #WADelegation;
	add: #WAInitialRequestVisitor;
	add: #WAPluggablePresenterVisitor;
	add: #WAPresenter;
	add: #WAPresenterGuide;
	add: #WARenderingGuide;
	add: #WATask;
	add: #WATaskNotDelegated;
	add: #WATaskVisitor;
	add: #WAUpdateStatesVisitor;
	add: #WAVisiblePresenterGuide;
	yourself.

package methodNames
	add: #WAPainter -> #acceptDecorated:;
	add: #WAPainterVisitor -> #visitComponent:;
	add: #WAPainterVisitor -> #visitDecoration:;
	add: #WAPainterVisitor -> #visitDecorationsOfComponent:;
	add: #WAPainterVisitor -> #visitDelegation:;
	add: #WAPainterVisitor -> #visitPresenter:;
	add: 'GRPackage class' -> #seasideComponent;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: 'Seaside-Core';
	yourself).

package!

"Class Definitions"!

WAError subclass: #WAChildrenNotCollectionError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAError subclass: #WATaskNotDelegated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPainter subclass: #WAPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPresenter subclass: #WAComponent
	instanceVariableNames: 'decoration'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPresenter subclass: #WADecoration
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #WATask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WADecoration subclass: #WAAnswerHandler
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WADecoration subclass: #WADelegation
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPainterVisitor subclass: #WAInitialRequestVisitor
	instanceVariableNames: 'request'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPainterVisitor subclass: #WAPluggablePresenterVisitor
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPainterVisitor subclass: #WAPresenterGuide
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPainterVisitor subclass: #WATaskVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPainterVisitor subclass: #WAUpdateStatesVisitor
	instanceVariableNames: 'snapshot'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPresenterGuide subclass: #WARenderingGuide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPresenterGuide subclass: #WAVisiblePresenterGuide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAVisiblePresenterGuide subclass: #WAAllPresenterGuide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

seasideComponent
	^ self new
		name: 'Seaside-Component';
		description: 'Stateful, reusable components to encapsulate a small part of a page.';
		addDependency: 'Seaside-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideComponent!*seaside-component!public! !

!WAPainter methodsFor!

acceptDecorated: aVisitor
	self accept: aVisitor! !
!WAPainter categoriesFor: #acceptDecorated:!*seaside-component!public! !

!WAPainterVisitor methodsFor!

visitComponent: aComponent
	self visitPresenter: aComponent!

visitDecoration: aDecoration
	self visitPresenter: aDecoration!

visitDecorationsOfComponent: aComponent
	aComponent decoration accept: self!

visitDelegation: aDelegation
	self visitDecoration: aDelegation!

visitPresenter: aPresenter
	self visitPainter: aPresenter! !
!WAPainterVisitor categoriesFor: #visitComponent:!*seaside-component!public! !
!WAPainterVisitor categoriesFor: #visitDecoration:!*seaside-component!public! !
!WAPainterVisitor categoriesFor: #visitDecorationsOfComponent:!*seaside-component!public! !
!WAPainterVisitor categoriesFor: #visitDelegation:!*seaside-component!public! !
!WAPainterVisitor categoriesFor: #visitPresenter:!*seaside-component!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

WAChildrenNotCollectionError guid: (GUID fromString: '{B4141113-0476-4650-96B6-112338640C9B}')!
WAChildrenNotCollectionError comment: ''!
!WAChildrenNotCollectionError categoriesForClass!Unclassified! !
WATaskNotDelegated guid: (GUID fromString: '{D2409109-45AA-47FB-A773-CAB2EC84F86D}')!
WATaskNotDelegated comment: ''!
!WATaskNotDelegated categoriesForClass!Unclassified! !
!WATaskNotDelegated methodsFor!

seasidePossibleCauses
	^#(
		'The Task is embedded in another Component but has not been included in the list of child Components returned by the Component''s #children method.'
		'The Task has an empty #go method.'
		'The Task does not call another Component in its #go method.'
		'The #go method is written to depend on the looping execution of Tasks. If the Task needs looping behaviour without calling a Component, implement the looping behaviour within the #go method.'
	)! !
!WATaskNotDelegated categoriesFor: #seasidePossibleCauses!accessing!public! !

WAPresenter guid: (GUID fromString: '{CAB2332A-E452-4EFA-A17E-000275C188CD}')!
WAPresenter comment: '
WAPresenter holds the functionality that is common to WAComponent and WADecoration. Subclasses of this class may have state and can be stored in instance variables of other Presenters.

You might want to subclass WAPresenter if you do not need the special abilities (decoration and call/answer) of WAComponent but do need one or more of the following:

	+ The ability to specify objects whose state should be backtracked (#states)
	+ The ability to provide CSS and JavaScript for the component (#style, #script)
	+ The ability to "embed" other persistent Presenters within this one (#children)

WAPresenter does not support call/answer or the addition of Decorations. If you need either of these features, you should subclass WAComponent instead.

Child Presenters:
It is common for a Presenter to display instances of other Presenters while rendering itself.  It does this by passing them into the #render: method of a renderer (typically an instance of WACanvas).  For example, this #renderContentOn: method simply renders a heading and then displays a counter component 
immediately below it:

	renderContentOn: html
		html heading level3; with: ''My Counter''.
		html render: myCounter.

It''s important that you use #render:, rather than directly calling the #renderContentOn: method of the subcomponent. The following is *not* correct:

	renderContentOn: html
		html heading level3; with: ''My Counter''.
		myCounter renderContentOn: html.   "DON''T DO THIS".

These sub-Presenters are usually instance variables of the Presenter that is "embedding" them.  They are commonly created as part of the Presenter''s #initialize method:

	initialize
		myCounter := WACounter new.

They may also be stored in a collection. One fairly common pattern is to keep a lazily initialized dictionary of sub-presenters that match a collection of model items. For example, if you wanted a BudgetItemRow subcomponent for each member of budgetItems, you might do something like this:

	initialize
		budgetRows := Dictionary new.

	rowForItem: anItem
		^budgetRows at: anItem ifAbsentPut: [ BudgetItemRow item: anItem ].

	renderContentOn: html
		self budgetItems
			do: [ :each | html render: (self rowForItem: each) ]
			separatedBy: [ html horizontalLine ].

Each parent Presenter *must* implement a #children method that returns a collection of all of the sub-Presenters that it might display on the next render. For the above two examples, #children might look like this:

	children
		^Array with: myCounter

or this:

	children
		^self budgetItems collect: [ :each | self rowForItem: each ].
		
Visibility:
A Presenter is visible if it is:
- the root of an application
- a child of a visible Presenter (returned by #children) that has not been #call:''d'!
!WAPresenter categoriesForClass!Unclassified! !
!WAPresenter methodsFor!

accept: aVisitor
	aVisitor visitPresenter: self!

allPresentersDo: aBlock
	(WAAllPresenterGuide client:
		(WAPluggablePresenterVisitor block: aBlock))
		start: self!

children
	"This method is really important. It should return a collection of all sub-presenters that will (or might) be rendered in #renderContentOn:. Components that are displayed using #call: are *not* children.

	If the contents returned by this method change over time make sure to return them in #states as well, otherwise the back button will fail."

	^ #()!

childrenDo: aBlock
	| children |
	children := self children.
	children isCollection ifFalse: [
		WAChildrenNotCollectionError signal: self class name greaseString, ' >> #children is not answering a collection of components' ].
	children do: [ :each | 
		each isNil
			ifFalse: [ aBlock value: each ] ]!

component
	"Many subclasses of WAComponent seem to have used #component to mean something different."
	self 
		greaseDeprecatedApi: 'WAPresenter>>#component'
		details: 'Use WAPresenter>>#decoratedComponent.'.
	^ self decoratedComponent!

decoratedComponent
	"For polymorphism with WADecoration"
	
	^ nil!

handleAnswer: anObject
	^ false!

initialRequest: aRequest
	"When a new session is started, all visible presenters (components or tasks) receive this message with the request as argument.

	A common usage for this is to initialize their state depending on the URL of the request. This is one building block for bookmarkable URL. The other is updateUrl: where you can manipulate the anchor urls generated by Seaside.

	You can not use #call: in here. Consider using a WATask instead and sending #call: in #go.

	See WABrowser for examples."!

isDecoration
	^ false!

renderContentOn: aRenderer
	"By default, render all our children in order. Presenters should override this method
	to specify how they should render themselves. By convention, implementations of this
	method that expect a Canvas renderer use 'html' as the parameter name.
	See also #rendererClass."
	
	self childrenDo: [ :each | aRenderer render: each ]!

renderUndecoratedWithContext: aRenderContext
	"Render ourselves directly on aRenderer without allowing our Decorations to be visited."
	
	self accept: aRenderContext visitor!

script
	"The same as #style except that it is for JavaScript. This is rarely used, consider using WAFileLibrary or exernal files instead."
	^ nil!

states
	"Answer a collection of states that should be backtracked."

	^ #()!

style
	"Returns a CSS stylesheet associated with this component. This stylesheet will be added to <head> section of the html document so it will be global and not scoped.

	This is done for all visible components (see class comment of WAComponent for what visible means).

	Nice for demos but consider using WAFileLibrary or exernal files instead."

	^ nil!

updateRoot: anHtmlRoot
	"This method allows you customize the <head> section of an HTML document. The API is very similar to the 'Canvas API' for rendering in the <body> section (where you 'draw' in #renderContentOn:).

	anHtmlRoot is an instance of WAHtmlRoot

	Whenever you override this method don't forget to send super"
	super updateRoot: anHtmlRoot.

	self script isNil ifFalse: [ anHtmlRoot addScript: self script ].
	self style isNil ifFalse: [ anHtmlRoot addStyle: self style ]!

updateStates: aSnapshot
	"This method allows to register objects for backtracking. Don't forget to send super in all cases."

	self states do: [ :each | aSnapshot register: each ]!

visiblePresentersDo: aBlock
	(WAVisiblePresenterGuide client:
		(WAPluggablePresenterVisitor block: aBlock))
		start: self! !
!WAPresenter categoriesFor: #accept:!public!visiting! !
!WAPresenter categoriesFor: #allPresentersDo:!convenience!public! !
!WAPresenter categoriesFor: #children!hooks!public! !
!WAPresenter categoriesFor: #childrenDo:!iterating!public! !
!WAPresenter categoriesFor: #component!public! !
!WAPresenter categoriesFor: #decoratedComponent!decorations!public! !
!WAPresenter categoriesFor: #handleAnswer:!delegation!public! !
!WAPresenter categoriesFor: #initialRequest:!hooks!public! !
!WAPresenter categoriesFor: #isDecoration!public!testing! !
!WAPresenter categoriesFor: #renderContentOn:!public!rendering! !
!WAPresenter categoriesFor: #renderUndecoratedWithContext:!public!rendering! !
!WAPresenter categoriesFor: #script!hooks!public! !
!WAPresenter categoriesFor: #states!hooks!public! !
!WAPresenter categoriesFor: #style!hooks!public! !
!WAPresenter categoriesFor: #updateRoot:!public!updating! !
!WAPresenter categoriesFor: #updateStates:!public!updating! !
!WAPresenter categoriesFor: #visiblePresentersDo:!convenience!public! !

WAComponent guid: (GUID fromString: '{5DAEC06E-BCA6-4E75-B42F-FDCEBB1E8DCC}')!
WAComponent comment: '
I am a Presenter with the additional abilities of wrapping myself with Decorations and displaying another Component with #call:.
		
Call/Answer:
If a sub-Component makes a #call: to another Component, that Component will appear in place of the sub-Component.  For example, if an embedded WACounter, stored in an instance variable called myCounter, made a #call: to DateSelector, that DateSelector would appear in the context of the counter''s parent, with the ''My Counter'' heading above it.

Since an embedded subcomponent has not been #call:''d, in general #answer: is a no-op.  However, the parent may attach an #onAnswer: block to the embedded subcomponent to be notified if it sends #answer:. This allows one component to be used both from #call: and through embedding. For example:

	initialize
		dateSelector := WADateSelector new 
			onAnswer: [ :date | self dateChosen: date ].
			
Visibility:
A component is visible if it:
- meets the visibility requirements of a Presenter; or
- is passed as an argument to #call: on a visible component'!
!WAComponent categoriesForClass!Unclassified! !
!WAComponent methodsFor!

accept: aVisitor
	aVisitor visitComponent: self!

acceptDecorated: aVisitor
	aVisitor visitDecorationsOfComponent: self!

activeComponent
	"Answer the visible component, this might be a different component being delegated to or the receiver itself."
	
	self visiblePresentersDo: [ :each | each isDecoration ifFalse: [ ^ each ] ]!

addDecoration: aDecoration
	"Add aDecoration to the receivers decoration chain. Answer the added decoration."
	
	| previous current |
	previous := nil.
	current := self decoration.
	[ current ~~ self and: [ self decoration: current shouldWrap: aDecoration ] ] whileTrue: [
		previous := current.
		current := current next ].
	aDecoration setNext: current.
	previous isNil
		ifTrue: [ self decoration: aDecoration ]
		ifFalse: [ previous setNext: aDecoration ].
	^ aDecoration!

allDecorationsDo: aBlock 
	| ea |
	self 
		greaseDeprecatedApi: 'WAComponent>>#allDecorationsDo:'
		details: 'Use aComponent decorations do: [ :each | ... ].'.
	ea := self decoration.
	[ ea notNil and: [ ea ~~ self ] ] whileTrue: 
		[ aBlock value: ea.
		ea := ea next ]!

answer
	self answer: self!

answer: anObject
	"Give back control back to the component from which the receiver was called.
	When returning, a component can additionally return anObject to the caller."

	self decoration handleAnswer: anObject!

call: aComponent onAnswer: aBlock
	"Pass control from the receiver to aComponent. The receiver will be temporarily replaced with aComponent. When #answer: is sent to aComponent, aBlock is evaluated. This can be used for continuation passing style programmation of a control flow. #call:onAnswer: does not block but
a RenderNotification is immediately signaled, aborting the current callback or task processing."

	self
		show: aComponent
		onAnswer: aBlock.
	WARenderNotification signal!

decoratedComponent
	"For polymorphism with WADecoration"

	^ self!

decorateWith: aDecoration during: aBlock
	"Decorate the receiver with aDecoration during the execution of aBlock."

	| result |
	self addDecoration: aDecoration.
	result := aBlock value.
	self removeDecoration: aDecoration.
	^ result!

decoration
	^ decoration contents!

decoration: aDecoration
	decoration contents: aDecoration!

decoration: oldDecoration shouldWrap: newDecoration
	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isDelegation and: [newDecoration isLocal]]!

decorations
	"Answer an ordered colleciton of all decorations active in the receiver."
	
	| current result |
	current := self decoration.
	result := OrderedCollection new.
	[ current = self ] whileFalse: [
		result add: current.
		current := current next ].
	^ result!

delegations
	"Answer an ordered colleciton of all delections active in the receiver."
	
	^ self decorations select: [ :each | each isDelegation ]!

home
	"Remove all delegations from the receiver, making sure that it is displayed again."
	
	self delegations do: [ :each | self removeDecoration: each ]!

initialize
	super initialize.
	decoration := WAValueHolder with: self!

onAnswer: aBlock
	"Adds an answer handler aBlock to the receiver."

	^ self addDecoration: (WAAnswerHandler new block: aBlock)!

removeDecoration: aDecoration 
	"Remove aDecoration from the chain of decorations. Answer nil if aDecoration is not present."

	| previous current |
	previous := nil.
	current := self decoration.
	[ current = self ] whileFalse: [
		current = aDecoration ifTrue: [
			previous isNil
				ifTrue: [ self decoration: current next ]
				ifFalse: [ previous setNext: current next ].
			^ aDecoration setNext: nil ].
		previous := current.
		current := current next ].
	^ nil!

show: aComponent
	"Pass control from the receiver to aComponent. The receiver will be temporarily replaced with aComponent. As opposed to #call: sending this message does not block and immediately returns."

	self
		show: aComponent
		onAnswer: [ :value | ]!

show: aComponent onAnswer: aBlock
	"Pass control from the receiver to aComponent. The receiver will be temporarily replaced with aComponent. When #answer: is sent to aComponent, aBlock is evaluated. This can be used for continuation passing style programmation of a control flow. #show:onAnswer: does not block."

	self
		show: aComponent
		onAnswer: aBlock
		delegation: (WADelegation new
			delegate: aComponent;
			yourself)!

show: aComponent onAnswer: aBlock delegation: aDelegation
	| event |
	event := nil.
	event := aComponent onAnswer: [ :value |
		aDelegation remove.
		event remove.
		aBlock valueWithPossibleArguments: (Array with: value) ].
	self addDecoration: aDelegation!

updateStates: aSnapshot
	super updateStates: aSnapshot.
	aSnapshot register: decoration! !
!WAComponent categoriesFor: #accept:!public!visiting! !
!WAComponent categoriesFor: #acceptDecorated:!public!visiting! !
!WAComponent categoriesFor: #activeComponent!convenience!public! !
!WAComponent categoriesFor: #addDecoration:!decorations!public! !
!WAComponent categoriesFor: #allDecorationsDo:!public! !
!WAComponent categoriesFor: #answer!delegation!public! !
!WAComponent categoriesFor: #answer:!delegation!public! !
!WAComponent categoriesFor: #call:onAnswer:!delegation!public! !
!WAComponent categoriesFor: #decoratedComponent!decorations!public! !
!WAComponent categoriesFor: #decorateWith:during:!decorations!public! !
!WAComponent categoriesFor: #decoration!accessing!public! !
!WAComponent categoriesFor: #decoration:!accessing!public! !
!WAComponent categoriesFor: #decoration:shouldWrap:!decorations!public! !
!WAComponent categoriesFor: #decorations!accessing!public! !
!WAComponent categoriesFor: #delegations!accessing!public! !
!WAComponent categoriesFor: #home!accessing!public! !
!WAComponent categoriesFor: #initialize!initialization!public! !
!WAComponent categoriesFor: #onAnswer:!delegation!public! !
!WAComponent categoriesFor: #removeDecoration:!decorations!public! !
!WAComponent categoriesFor: #show:!delegation!public! !
!WAComponent categoriesFor: #show:onAnswer:!delegation!public! !
!WAComponent categoriesFor: #show:onAnswer:delegation:!delegation!public! !
!WAComponent categoriesFor: #updateStates:!public!updating! !

!WAComponent class methodsFor!

canBeRoot
	"When returning true, the component can be registered as a standalone application from the config interface."

	^ false!

description
	^ self name! !
!WAComponent class categoriesFor: #canBeRoot!public!testing! !
!WAComponent class categoriesFor: #description!accessing!public! !

WADecoration guid: (GUID fromString: '{1AAA3E4B-CD23-4450-9679-09C69A3E308D}')!
WADecoration comment: '
I am an abstract decoration around instances of WAComponent. I can be added to aComponent by calling #addDecoration: and I change the basic behaviour or look of a component. There are several methods that can be overriden to archive this:

- #renderContentOn: to emit xhtml around the decorated component. Call #renderOwnerOn: to let the owner emit its output.

- #handleAnswer: to intercept the answer processing.'!
!WADecoration categoriesForClass!Unclassified! !
!WADecoration methodsFor!

accept: aVisitor
	aVisitor visitDecoration: self!

asComponent
	self 
		greaseDeprecatedApi: 'WADecoration>>#asComponent'
		details: 'Use WADecoration>>#decoratedComponent.'.
	^ self decoratedComponent!

decoratedComponent
	"Answer the Component decorated by this Decoration."
	
	^ self next decoratedComponent!

handleAnswer: anObject
	(self next handleAnswer: anObject) ifFalse:
		[self handleAnswer: anObject continueWith: [^ false]].
	^ true!

handleAnswer: anObject continueWith: aBlock
	aBlock value!

initialize
	super initialize.
	next := WAValueHolder new!

isDecoration
	^ true!

isDelegation
	"If #isDelegation is true, we do not want our 'next' presenter to be displayed."
	^ false!

isGlobal
	^ false!

isLocal
	^ (self isGlobal or: [self isDelegation]) not!

next
	"Answer the next decoration or component."

	^ next contents!

owner
	self 
		greaseDeprecatedApi: 'WADecoration>>#owner'
		details: 'Use WADecoration>>#next or WADecoration>>#component.'.
	^ next contents!

remove
	"Remove the decoration from the owning component."
	
	self decoratedComponent removeDecoration: self!

renderContentOn: html
	self renderNextOn: html!

renderNextOn: html
	self next renderUndecoratedWithContext: html context!

renderOwnerOn: html 
	self 
		greaseDeprecatedApi: 'WADecoration>>#renderOwnerOn:'
		details: 'Use renderNextOn:.'.
	self renderNextOn: html!

setNext: aDecoration
	next contents: aDecoration!

updateStates: aSnapshot
	super updateStates: aSnapshot.
	aSnapshot register: next! !
!WADecoration categoriesFor: #accept:!public!visiting! !
!WADecoration categoriesFor: #asComponent!public! !
!WADecoration categoriesFor: #decoratedComponent!accessing!public! !
!WADecoration categoriesFor: #handleAnswer:!delegation!public! !
!WADecoration categoriesFor: #handleAnswer:continueWith:!processing!public! !
!WADecoration categoriesFor: #initialize!initialization!public! !
!WADecoration categoriesFor: #isDecoration!public!testing! !
!WADecoration categoriesFor: #isDelegation!public!testing! !
!WADecoration categoriesFor: #isGlobal!public!testing! !
!WADecoration categoriesFor: #isLocal!public!testing! !
!WADecoration categoriesFor: #next!accessing!public! !
!WADecoration categoriesFor: #owner!public! !
!WADecoration categoriesFor: #remove!actions!public! !
!WADecoration categoriesFor: #renderContentOn:!public!rendering! !
!WADecoration categoriesFor: #renderNextOn:!public!rendering! !
!WADecoration categoriesFor: #renderOwnerOn:!public! !
!WADecoration categoriesFor: #setNext:!initialization!public! !
!WADecoration categoriesFor: #updateStates:!public!updating! !

!WADecoration class methodsFor!

canBeRoot
	^ false! !
!WADecoration class categoriesFor: #canBeRoot!public!testing! !

WATask guid: (GUID fromString: '{D07CBF67-D29C-417A-8714-1DC97CD68E5D}')!
WATask comment: '
I am a subclass of WAComponent, specialized for defining workflow.  The difference between a task and a component is the following:

Both of them are reusable, embeddable, callable pieces of user interface. A component has state (instance variables), behavior (it may change its state, and it may also choose to display other components with #call:), and appearance (it renders HTML). A Task has only the first two - it doesn''t render any HTML directly, but only through the components it calls. This is useful when what you want to encapsulate/embed/call is purely a process (show this component, then this one, then this one).

The key method for WATask is #go - as soon as a task is displayed, this method will get invoked, and will presumably #call: other components.

In terms of implementation, you can think of a WATask in the following way: it is a component which renders two things:
- a link whose callback invokes the #go method
- a header that immediately redirects to the URL of that link

Subclasses must not implement #renderContentOn:

An example can be found in WAConvenienceTest.
'!
!WATask categoriesForClass!Unclassified! !
!WATask methodsFor!

accept: aVisitor
	aVisitor visitTask: self!

execute
	"Internal method to start the task running. DO NOT OVERRIDE THIS METHOD!! Subclasses
	should implement #go to specify behaviour.
	We used to loop here but no longer need to because the TaskVisitor will
	rerun any Task that is found not to be delegated."
	
	self answer: self go!

go
	self subclassResponsibility!

isExecuting
	"Answer whether or not the task is currently executing."
	
	^ (self activeComponent == self) not!

renderContentOn: html
	"Tasks define behaviour and should not render themselves directly. Behaviour is defined
	in the #go method, which can use #call: and other methods to display components.
	
	In general, if this method is called, it means that the application has not been configured
	properly to use Flow and the task was never executed."

	WATaskNotDelegated signal: 'This task has no delegation.'	! !
!WATask categoriesFor: #accept:!public!visiting! !
!WATask categoriesFor: #execute!public!running! !
!WATask categoriesFor: #go!public!running! !
!WATask categoriesFor: #isExecuting!public!testing! !
!WATask categoriesFor: #renderContentOn:!public!rendering! !

WAAnswerHandler guid: (GUID fromString: '{B246700B-09AA-46ED-85D5-E34ECED67EF2}')!
WAAnswerHandler comment: ''!
!WAAnswerHandler categoriesForClass!Unclassified! !
!WAAnswerHandler methodsFor!

block: aBlock
	block := aBlock!

handleAnswer: anObject continueWith: aBlock
	block valueWithPossibleArguments: (Array with:  anObject)! !
!WAAnswerHandler categoriesFor: #block:!accessing!public! !
!WAAnswerHandler categoriesFor: #handleAnswer:continueWith:!delegation!public! !

WADelegation guid: (GUID fromString: '{5A9C07B0-292A-422B-BBCF-EA9131A45596}')!
WADelegation comment: ''!
!WADelegation categoriesForClass!Unclassified! !
!WADelegation methodsFor!

accept: aVisitor
	aVisitor visitDelegation: self!

children
	^ Array with: self delegate!

delegate
	^ delegate!

delegate: aComponent
	delegate := aComponent!

isDelegation
	^ true!

renderContentOn: html
	html render: self delegate! !
!WADelegation categoriesFor: #accept:!public!visiting! !
!WADelegation categoriesFor: #children!hooks!public! !
!WADelegation categoriesFor: #delegate!accessing!public! !
!WADelegation categoriesFor: #delegate:!accessing!public! !
!WADelegation categoriesFor: #isDelegation!public!testing! !
!WADelegation categoriesFor: #renderContentOn:!public!rendering! !

WAInitialRequestVisitor guid: (GUID fromString: '{886C283B-2C2E-4448-B595-2CEC693C51C6}')!
WAInitialRequestVisitor comment: ''!
!WAInitialRequestVisitor categoriesForClass!Unclassified! !
!WAInitialRequestVisitor methodsFor!

initializeWithRequest: aRequest
	self initialize.
	request := aRequest!

request
	^ request!

visitPresenter: aPresenter
	aPresenter initialRequest: self request! !
!WAInitialRequestVisitor categoriesFor: #initializeWithRequest:!initialization!public! !
!WAInitialRequestVisitor categoriesFor: #request!accessing!public! !
!WAInitialRequestVisitor categoriesFor: #visitPresenter:!public!visiting! !

!WAInitialRequestVisitor class methodsFor!

new
	^ self request: nil!

request: aRequest
	^ self basicNew initializeWithRequest: aRequest; yourself! !
!WAInitialRequestVisitor class categoriesFor: #new!instance creation!public! !
!WAInitialRequestVisitor class categoriesFor: #request:!instance creation!public! !

WAPluggablePresenterVisitor guid: (GUID fromString: '{1BAB7BBC-0233-4FF8-993E-4E7622465992}')!
WAPluggablePresenterVisitor comment: ''!
!WAPluggablePresenterVisitor categoriesForClass!Unclassified! !
!WAPluggablePresenterVisitor methodsFor!

block
	^ block!

initializeWithBlock: aBlock
	self initialize.
	block := aBlock!

visitPresenter: aPresenter
	self block value: aPresenter! !
!WAPluggablePresenterVisitor categoriesFor: #block!accessing!public! !
!WAPluggablePresenterVisitor categoriesFor: #initializeWithBlock:!initialization!public! !
!WAPluggablePresenterVisitor categoriesFor: #visitPresenter:!public!visiting! !

!WAPluggablePresenterVisitor class methodsFor!

block: aBlock
	^ self basicNew initializeWithBlock: aBlock; yourself!

new
	^ self block: [ :presenter | ]! !
!WAPluggablePresenterVisitor class categoriesFor: #block:!instance creation!public! !
!WAPluggablePresenterVisitor class categoriesFor: #new!instance creation!public! !

WAPresenterGuide guid: (GUID fromString: '{5221DA9F-B098-4EA9-B56F-99FEA8E7B09B}')!
WAPresenterGuide comment: '
PresenterGuides take another PainterVisitor as a client. When asked to visit a Component, they will first visit its Decorations. Along the way, they will ask their client to visit each Painter they come across.

This allows us to separate the behaviour of the various Presenter-tree traversal methods from the behaviour to perform on each Presenter we visit.'!
!WAPresenterGuide categoriesForClass!Unclassified! !
!WAPresenterGuide methodsFor!

client
	^ client!

initializeWithClient: aPainterVisitor
	self initialize.
	client := aPainterVisitor!

postCopyForRenderContext: aRenderContext
	super postCopyForRenderContext: aRenderContext.
	client := client copyForRenderContext: aRenderContext!

visit: aPainter
	aPainter acceptDecorated: self!

visitPainter: aPainter
	self client visit: aPainter! !
!WAPresenterGuide categoriesFor: #client!accessing!public! !
!WAPresenterGuide categoriesFor: #initializeWithClient:!initialization!public! !
!WAPresenterGuide categoriesFor: #postCopyForRenderContext:!copying!public! !
!WAPresenterGuide categoriesFor: #visit:!public!visiting! !
!WAPresenterGuide categoriesFor: #visitPainter:!public!visiting! !

!WAPresenterGuide class methodsFor!

client: aPainterVisitor
	^ self basicNew initializeWithClient: aPainterVisitor; yourself!

new
	^ self client: WAPainterVisitor new! !
!WAPresenterGuide class categoriesFor: #client:!instance creation!public! !
!WAPresenterGuide class categoriesFor: #new!instance creation!public! !

WATaskVisitor guid: (GUID fromString: '{F7DF57E3-C046-42D6-95D9-327E329AF8FF}')!
WATaskVisitor comment: ''!
!WATaskVisitor categoriesForClass!Unclassified! !
!WATaskVisitor methodsFor!

visitTask: aTask
	super visitTask: aTask.
	aTask isExecuting ifFalse: [
		[ aTask execute ]
			on: WARenderNotification
			do: [ :n | ] ]! !
!WATaskVisitor categoriesFor: #visitTask:!public!visiting! !

WAUpdateStatesVisitor guid: (GUID fromString: '{8906749E-7194-4419-A91E-BCC475CA6492}')!
WAUpdateStatesVisitor comment: ''!
!WAUpdateStatesVisitor categoriesForClass!Unclassified! !
!WAUpdateStatesVisitor methodsFor!

initializeWithSnapshot: aSnapshot
	self initialize.
	snapshot := aSnapshot!

snapshot
	^ snapshot!

visitPresenter: aPresenter
	aPresenter updateStates: self snapshot! !
!WAUpdateStatesVisitor categoriesFor: #initializeWithSnapshot:!initialization!public! !
!WAUpdateStatesVisitor categoriesFor: #snapshot!accessing!public! !
!WAUpdateStatesVisitor categoriesFor: #visitPresenter:!public!visiting! !

!WAUpdateStatesVisitor class methodsFor!

new
	^ self snapshot: WASnapshot new!

snapshot: aSnapshot
	^ self basicNew initializeWithSnapshot: aSnapshot; yourself! !
!WAUpdateStatesVisitor class categoriesFor: #new!instance creation!public! !
!WAUpdateStatesVisitor class categoriesFor: #snapshot:!instance creation!public! !

WARenderingGuide guid: (GUID fromString: '{A534FF21-5309-474E-B330-1E460BAA9CEA}')!
WARenderingGuide comment: 'Currently an empty class but still present for clarity and to allow cutomization of Rendering behaviour.'!
!WARenderingGuide categoriesForClass!Unclassified! !
WAVisiblePresenterGuide guid: (GUID fromString: '{C9C64139-9120-443B-997E-F5C3CC3D16B7}')!
WAVisiblePresenterGuide comment: 'Visit the tree of all Presenters and their registered #children. Do not visit a Decoration''s #next Decoration if the Decoration indicates that it is not visible.'!
!WAVisiblePresenterGuide categoriesForClass!Unclassified! !
!WAVisiblePresenterGuide methodsFor!

shouldVisitNextPresenterOf: aDecoration
	^ aDecoration isDelegation not!

visitDecoration: aDecoration
	super visitDecoration: aDecoration.
	(self shouldVisitNextPresenterOf: aDecoration)
		ifTrue: [ aDecoration next accept: self ]!

visitPresenter: aPresenter
	super visitPresenter: aPresenter.
	aPresenter childrenDo: [ :each | self visit: each ]! !
!WAVisiblePresenterGuide categoriesFor: #shouldVisitNextPresenterOf:!private! !
!WAVisiblePresenterGuide categoriesFor: #visitDecoration:!public!visiting! !
!WAVisiblePresenterGuide categoriesFor: #visitPresenter:!public!visiting! !

WAAllPresenterGuide guid: (GUID fromString: '{3A14BB23-7F6E-4C57-A3E1-03CFCC0527C3}')!
WAAllPresenterGuide comment: 'Visit the tree of all Presenters and their registered #children.'!
!WAAllPresenterGuide categoriesForClass!Unclassified! !
!WAAllPresenterGuide methodsFor!

shouldVisitNextPresenterOf: aDecoration
	^ true! !
!WAAllPresenterGuide categoriesFor: #shouldVisitNextPresenterOf:!private! !

"Binary Globals"!

