| package |
package := Package name: 'Seaside-Development'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '139'.


package classNames
	add: #WAClassnameHaloPlugin;
	add: #WAConfigureToolPlugin;
	add: #WADebugErrorHandler;
	add: #WADeprecatedToolFilter;
	add: #WADeprecation;
	add: #WADeprecationToolPlugin;
	add: #WADevelopmentConfiguration;
	add: #WADevelopmentFiles;
	add: #WAHalo;
	add: #WAHaloPlugin;
	add: #WAHaloVisitor;
	add: #WAInspector;
	add: #WAInspectorHaloPlugin;
	add: #WAModeHaloPlugin;
	add: #WANewSessionToolPlugin;
	add: #WAPluggableTool;
	add: #WAPrettyPrintedDocument;
	add: #WAStylesHaloPlugin;
	add: #WATerminateToolPlugin;
	add: #WATimingToolFilter;
	add: #WATimingToolPlugin;
	add: #WAToggleHalosToolPlugin;
	add: #WATool;
	add: #WAToolDecoration;
	add: #WAToolPlugin;
	add: #WAValidateToolPlugin;
	add: #WAViewer;
	add: #WAWalkback;
	add: #WAWalkbackErrorHandler;
	yourself.

package methodNames
	add: #WAPainter -> #canHaveHalo;
	add: #WAPainterVisitor -> #addHaloVisitor:;
	add: #WAPresenter -> #canHaveHalo;
	add: #WAPresenterGuide -> #addHaloVisitor:;
	add: #WARenderContext -> #addHaloVisitor:;
	add: #WARenderContext -> #disableHalos;
	add: #WARenderContext -> #enableHalos;
	add: #WARenderContext -> #halosEnabled;
	add: 'GRPackage class' -> #seasideDevelopment;
	add: 'WAAdmin class' -> #developmentToolsEnabled;
	add: 'WAAdmin class' -> #disableDevelopmentTools;
	add: 'WAAdmin class' -> #enableDevelopmentTools;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: 'Seaside-Canvas';
	add: 'Seaside-Component';
	add: 'Seaside-Core';
	add: 'Seaside-RenderLoop';
	add: 'Seaside-Tools-Core';
	add: 'Seaside-Tools-Web';
	add: 'Seaside-Widgets';
	yourself).

package!

"Class Definitions"!

WAObject subclass: #WAHalo
	instanceVariableNames: 'root mode plugins'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WASystemConfiguration subclass: #WADevelopmentConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAHtmlDocument subclass: #WAPrettyPrintedDocument
	instanceVariableNames: 'html indentLevel indentCloseTags firstLine'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAErrorHandler subclass: #WADebugErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WADebugErrorHandler subclass: #WAWalkbackErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFileLibrary subclass: #WADevelopmentFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPlugin subclass: #WAHaloPlugin
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPlugin subclass: #WAToolPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAHaloPlugin subclass: #WAClassnameHaloPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAHaloPlugin subclass: #WAInspectorHaloPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAHaloPlugin subclass: #WAModeHaloPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAHaloPlugin subclass: #WAStylesHaloPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAToolPlugin subclass: #WAConfigureToolPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAToolPlugin subclass: #WADeprecationToolPlugin
	instanceVariableNames: 'filter'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAToolPlugin subclass: #WANewSessionToolPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAToolPlugin subclass: #WATerminateToolPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAToolPlugin subclass: #WATimingToolPlugin
	instanceVariableNames: 'filter'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAToolPlugin subclass: #WAToggleHalosToolPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAToolPlugin subclass: #WAValidateToolPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #WATool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #WAWalkback
	instanceVariableNames: 'exception limit'
	classVariableNames: 'Current'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WALabelledFormDialog subclass: #WAViewer
	instanceVariableNames: 'presenter'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WATool subclass: #WADeprecation
	instanceVariableNames: 'table filter'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WATool subclass: #WAInspector
	instanceVariableNames: 'path selected input'
	classVariableNames: 'Current'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WATool subclass: #WAPluggableTool
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WADecoration subclass: #WAToolDecoration
	instanceVariableNames: 'plugins showHalos halos'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WARequestFilter subclass: #WADeprecatedToolFilter
	instanceVariableNames: 'notifications'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WARequestFilter subclass: #WATimingToolFilter
	instanceVariableNames: 'startTime previousTiming'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPainterVisitor subclass: #WAHaloVisitor
	instanceVariableNames: 'toolDecoration renderContext visitor'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

seasideDevelopment
	^ self new
		name: 'Seaside-Development';
		description: 'Web-based development tools and debugging support.';
		addDependency: 'Seaside-Tools-Web';
		addDependency: 'Seaside-Flow'; "For WAWalkbackErrorHandler"
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideDevelopment!*seaside-development!public! !

!WAAdmin class methodsFor!

developmentToolsEnabled
	^ self applicationDefaults parents includes: WADevelopmentConfiguration instance!

disableDevelopmentTools
	self applicationDefaults removeParent: WADevelopmentConfiguration instance!

enableDevelopmentTools
	self applicationDefaults addParent: WADevelopmentConfiguration instance! !
!WAAdmin class categoriesFor: #developmentToolsEnabled!*seaside-development!public! !
!WAAdmin class categoriesFor: #disableDevelopmentTools!*seaside-development!public! !
!WAAdmin class categoriesFor: #enableDevelopmentTools!*seaside-development!public! !

!WAPainter methodsFor!

canHaveHalo
	"Return true if this Painter should have a Halo displayed for it when Halos are
	enabled in the development environment."
	
	^ false! !
!WAPainter categoriesFor: #canHaveHalo!*seaside-development!public! !

!WAPainterVisitor methodsFor!

addHaloVisitor: aHaloVisitor
	^ aHaloVisitor
		visitor: self;
		yourself! !
!WAPainterVisitor categoriesFor: #addHaloVisitor:!*seaside-development!public! !

!WAPresenter methodsFor!

canHaveHalo
	^ true! !
!WAPresenter categoriesFor: #canHaveHalo!*seaside-development!public! !

!WAPresenterGuide methodsFor!

addHaloVisitor: aHaloVisitor
	client := client addHaloVisitor: aHaloVisitor.
	^ self! !
!WAPresenterGuide categoriesFor: #addHaloVisitor:!*seaside-development!public! !

!WARenderContext methodsFor!

addHaloVisitor: aHaloVisitor
	visitor := visitor addHaloVisitor: aHaloVisitor!

disableHalos
	self properties at: #halosEnabled put: false!

enableHalos
	self properties at: #halosEnabled put: true!

halosEnabled
	^ self properties at: #halosEnabled ifAbsent: [ false ]! !
!WARenderContext categoriesFor: #addHaloVisitor:!*seaside-development!public! !
!WARenderContext categoriesFor: #disableHalos!*seaside-development!public! !
!WARenderContext categoriesFor: #enableHalos!*seaside-development!public! !
!WARenderContext categoriesFor: #halosEnabled!*seaside-development!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

WAHalo guid: (GUID fromString: '{5FA36A60-3287-4E41-8326-95F31A1174D7}')!
WAHalo comment: ''!
!WAHalo categoriesForClass!Unclassified! !
!WAHalo methodsFor!

initializeOn: aComponent
	self initialize.
	root := aComponent.
	mode := WAValueHolder with: self modes first.
	plugins := WAHaloPlugin allSubclassesOn: self root for: self!

mode
	^ mode contents!

mode: aSymbol
	mode contents: aSymbol!

modes
	"Returns a list of possible display modes. These are selectors that are used to render the
	object we are wrapping. The current mode is selected by WAModeHaloPlugin."

	^ #( render source )!

modeSelector
	^ (self mode greaseString , ':visitor:') asSymbol!

plugins
	^ plugins!

render: html visitor: aPainterVisitor
	"Render the object we are wrapping normally. See #modes."
	
	aPainterVisitor visit: self root!

renderWithContext: aRenderContext visitor: aPainterVisitor
	"Render the halo using aRenderContext. aPainterVisitor is the visitor that the halo
	visitor is wrapping; calling #visit: on it will perform the action that would have taken
	place had the halo wrapper not been present.
	"
	| html |
	html := WARenderCanvas context: aRenderContext.
	html div class: 'wa-halo'; with: [
		html div class: 'wa-halo-header'; with: [
			(self plugins select: [ :each | each isActive ])
				do: [ :each | html render: each ]
				separatedBy: [ html text: ' ' ] ].
		html div class: 'wa-halo-body'; with: [
			self perform: self modeSelector with: html with: aPainterVisitor ] ].
	html flush!

root
	^ root!

source: html visitor: aPainterVisitor
	"Render the HTML source of the object we are wrapping using a pretty printed
	document. See #modes.
	Because we are using a new RenderContext, we can't use the passed-in visitor.
	Since we know we want to immediately render, we create a new RenderVisitor to get
	things rolling. Rendering will then continue with the visitors in the context."
	
	| context |
	html div class: 'wa-halo-source'; with: [
		context := html context copy.
		context disableHalos.

		context document: (WAPrettyPrintedDocument context: html context).
		(WARenderVisitor context: context) start: self root.
		context document close ]!

updateStates: aSnapshot
	"This class is not a Presenter but WAToolDecoration will make sure we get a chance
	to update the snapshot whenever it does."
	
	aSnapshot register: mode! !
!WAHalo categoriesFor: #initializeOn:!initialization!public! !
!WAHalo categoriesFor: #mode!accessing!public! !
!WAHalo categoriesFor: #mode:!accessing!public! !
!WAHalo categoriesFor: #modes!accessing!public! !
!WAHalo categoriesFor: #modeSelector!accessing!public! !
!WAHalo categoriesFor: #plugins!accessing!public! !
!WAHalo categoriesFor: #render:visitor:!public!rendering-modes! !
!WAHalo categoriesFor: #renderWithContext:visitor:!public!rendering! !
!WAHalo categoriesFor: #root!accessing!public! !
!WAHalo categoriesFor: #source:visitor:!public!rendering-modes! !
!WAHalo categoriesFor: #updateStates:!public!updating! !

!WAHalo class methodsFor!

on: aComponent
	^ self basicNew initializeOn: aComponent; yourself! !
!WAHalo class categoriesFor: #on:!instance creation!public! !

WADevelopmentConfiguration guid: (GUID fromString: '{6302016B-9635-4DEF-BD0A-3CA92749E9DF}')!
WADevelopmentConfiguration comment: ''!
!WADevelopmentConfiguration categoriesForClass!Unclassified! !
!WADevelopmentConfiguration methodsFor!

describeOn: config
	config at: #rootDecorationClasses addAll: (Array with: WAToolDecoration)!

parents
	^ Array with: WARenderLoopConfiguration instance! !
!WADevelopmentConfiguration categoriesFor: #describeOn:!description!public! !
!WADevelopmentConfiguration categoriesFor: #parents!description!public! !

!WADevelopmentConfiguration class methodsFor!

initialize
	WAAdmin applicationDefaults addParent: self instance! !
!WADevelopmentConfiguration class categoriesFor: #initialize!initialization!public! !

WAPrettyPrintedDocument guid: (GUID fromString: '{7B99B7E3-EBDB-409F-A5F3-0EF378E48EA5}')!
WAPrettyPrintedDocument comment: ''!
!WAPrettyPrintedDocument categoriesForClass!Unclassified! !
!WAPrettyPrintedDocument methodsFor!

attribute: aKey with: aValue 
	aValue == false ifTrue: [ ^ self ].
	html space.
	html span
		class: 'wa-attribute-key';
		with: aKey.
	html text: '='.
	html span
		class: 'wa-attribute-value';
		with: 
			[ html text: '"'.
			(self knownRefs includes: aKey) 
				ifTrue: 
					[ html anchor
						url: aValue greaseString;
						with: aValue ]
				ifFalse: 
					[ (self knownEvents includes: aKey) 
						ifTrue: 
							[ html anchor
								onClick: aValue;
								with: aValue ]
						ifFalse: 
							[ aValue == true 
								ifTrue: [ html text: aKey ]
								ifFalse: [ html render: aValue ] ] ].
			html text: '"' ]!

attributes: anAttributes
	anAttributes ifNil: [ ^ self ].
	anAttributes keysAndValuesDo: [ :key :value | self attribute: key with: value ]!

closeTag: aString
	indentLevel := indentLevel - 1.
	indentCloseTags removeLast
		ifTrue: [ self indent ].
	html text: '</'.
	html span 
		class: 'wa-tag'; 
		with: aString.
	html text: '>'!

document
	^ html document!

indent
	firstLine
		ifTrue: [ firstLine := false ]
		ifFalse: [ html break ].
	indentLevel timesRepeat: [ html space: 2 ]!

initializeWithRenderer: aRenderer
	self initializeWithStream: nil codec: nil.
	html := aRenderer.
	indentCloseTags := OrderedCollection with: false.
	indentLevel := 0.
	firstLine := true!

knownEvents
	^ #('onabort' 'onblur' 'onchange' 'onclick' 'ondblclick' 'onerror' 'onfocus' 'onkeydown' 'onkeypress' 'onkeyup' 'onload' 'onmousedown' 'onmousemove' 'onmouseout' 'onmouseover' 'onmouseup' 'onreset' 'onselect' 'onsubmit' 'onunload')!

knownRefs
	^ #('action' 'cite' 'classid' 'codebase' 'data' 'href' 'longdesc' 'profile' 'src' 'usemap')!

nextPut: aCharacter
	self xmlEncoder nextPut: aCharacter!

nextPutAll: aString
	self xmlEncoder nextPutAll: aString!

openTag: aString attributes: anAttributes closed: aBoolean
	self indent.
	html text: '<'.
	html span
		class: 'wa-tag';
		with: aString.
	self attributes: anAttributes.
	aBoolean
		ifTrue: [ html text: '/' ].
	html text: '>'.
	aBoolean
		ifFalse: [ indentLevel := indentLevel + 1 ].
	indentCloseTags removeLast; addLast: true; addLast: aBoolean!

print: anObject
	self document print: anObject!

xmlEncoder
	^ self document xmlEncoder! !
!WAPrettyPrintedDocument categoriesFor: #attribute:with:!private! !
!WAPrettyPrintedDocument categoriesFor: #attributes:!private! !
!WAPrettyPrintedDocument categoriesFor: #closeTag:!public!writing! !
!WAPrettyPrintedDocument categoriesFor: #document!accessing!public! !
!WAPrettyPrintedDocument categoriesFor: #indent!private! !
!WAPrettyPrintedDocument categoriesFor: #initializeWithRenderer:!initialization!public! !
!WAPrettyPrintedDocument categoriesFor: #knownEvents!configuration!public! !
!WAPrettyPrintedDocument categoriesFor: #knownRefs!configuration!public! !
!WAPrettyPrintedDocument categoriesFor: #nextPut:!public!writing! !
!WAPrettyPrintedDocument categoriesFor: #nextPutAll:!public!writing! !
!WAPrettyPrintedDocument categoriesFor: #openTag:attributes:closed:!public!writing! !
!WAPrettyPrintedDocument categoriesFor: #print:!public!writing! !
!WAPrettyPrintedDocument categoriesFor: #xmlEncoder!accessing!public! !

!WAPrettyPrintedDocument class methodsFor!

context: aRenderContext
	^ self basicNew initializeWithRenderer: (WAHtmlCanvas context: aRenderContext); yourself!

renderer: aRenderer 
	self 
		greaseDeprecatedApi: 'WAPrettyPrintedDocument class>>#renderer:'
		details: 'Use WAPrettyPrintedDocument class>>#context:.'.
	^ self context: aRenderer context! !
!WAPrettyPrintedDocument class categoriesFor: #context:!instance creation!public! !
!WAPrettyPrintedDocument class categoriesFor: #renderer:!public! !

WADebugErrorHandler guid: (GUID fromString: '{8C19AC07-66A1-45EC-AB28-3A8AC4E4EA18}')!
WADebugErrorHandler comment: 'I am like WAErrorHandler except that I open a debugger in the image for errors and warnings (not for internal errors).'!
!WADebugErrorHandler categoriesForClass!Unclassified! !
!WADebugErrorHandler methodsFor!

debugAndResume: anException
	self open: anException.

	"If the user closes the debugger, the process is terminated and the stack unwound.
	There was previously an #ifCurtailed: block around the #open: call above to try to
	catch the process termination so we could display a nice error page but this also
	ended up being called when the user restarted a context in the debugger.
	
	If they Proceed in the debugger, behaviour is platform-dependent. Currently, VW
	should resume the signaling context, so this method will not continue past the call
	to #open:. Squeak currently resumes the context that opened the Debugger, which
	results in the call to #open: returning."

	^ anException isResumable
		ifTrue: [ anException resume ]
		ifFalse: [ self unableToResumeResponse ]!

handleDefault: anException
	^ self debugAndResume: anException!

open: anException 
	GRPlatform current openDebuggerOn: anException!

unableToResumeResponse
	| content |
	content := WARenderCanvas builder
		fullDocument: true;
		rootBlock: [ :root | root title: 'Unable to proceed' ];
		render: [ :html |
			html heading level1; with: 'Unable to proceed - hit Refresh to retry'.
			html paragraph: 'Some exceptions cannot be resumed. You will usually see this page if you hit Proceed while debugging one of these exceptions. Your request was aborted but you can retry it by refreshing the page.' ].
	self requestContext respond: [ :response |
		response
			internalError;
			nextPutAll: content ]! !
!WADebugErrorHandler categoriesFor: #debugAndResume:!actions!public! !
!WADebugErrorHandler categoriesFor: #handleDefault:!actions!public! !
!WADebugErrorHandler categoriesFor: #open:!actions!public! !
!WADebugErrorHandler categoriesFor: #unableToResumeResponse!content!public! !

WAWalkbackErrorHandler guid: (GUID fromString: '{557593A7-DBDD-4C18-9064-13A48020F442}')!
WAWalkbackErrorHandler comment: '
I am the default development error handler that displays the stack frames and adds the option to display a debugger.

I delegate the rendering to WAWalkback.

This handler uses Components and depends on having a valid Session. If an error occurs outside of the Session scope it will simply use the superclass behaviour, which should be to open a debugger.'!
!WAWalkbackErrorHandler categoriesForClass!Unclassified! !
!WAWalkbackErrorHandler methodsFor!

open: anException 
	| answer |
	self requestContext request isXmlHttpRequest ifTrue: [ ^ super open: anException ].

	"If an error occurs trying to display the walkback component, we just use the super
	behaviour, which should be to open a debugger.."
	answer := true.
	[ self session isNil ifFalse: 
		[ answer := self session presenter call: (WAWalkback current exception: anException).
		"Exception handlers hold the request context because they are used in places where
		the dynamic variable is not present. Since this particular class depends on RenderLoop, 		however, it will be present and we need to update the stored value after doing a call."
		requestContext := WACurrentRequestContext value ] ] 
		on: Error
		do: [ :err | answer := true ].
	answer ifTrue: [ super open: anException ]! !
!WAWalkbackErrorHandler categoriesFor: #open:!private! !

!WAWalkbackErrorHandler class methodsFor!

initialize
	WAAdmin applicationExceptionHandlingDefaults at: #exceptionHandler put: self! !
!WAWalkbackErrorHandler class categoriesFor: #initialize!initialization!public! !

WADevelopmentFiles guid: (GUID fromString: '{5997B628-0E89-4E5B-A483-BDD55980B8DB}')!
WADevelopmentFiles comment: '
CSS and images used by the web-based development tools.

The icons are from the Tango Desktop Project (tango.freedesktop.org), they are licensed under the Creative Commons Attribution Share-Alike license.
'!
!WADevelopmentFiles categoriesForClass!Unclassified! !
!WADevelopmentFiles methodsFor!

codebrowserPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 213 9 22 18 55 41 59 82 2 72 0 0 1 203 73 68 65 84 56 203 165 147 77 104 19 65 20 199 127 51 221 163 72 22 34 45 226 177 224 41 160 88 43 1 15 130 21 132 120 236 69 208 182 39 175 165 23 21 60 138 32 197 32 245 34 126 128 154 22 138 49 189 91 26 17 77 92 16 237 193 98 211 141 27 76 253 192 213 108 235 16 21 90 145 205 120 48 67 179 109 106 43 190 203 255 13 204 251 207 111 102 222 131 255 12 97 146 226 93 250 128 25 224 216 86 122 120 136 188 169 147 0 151 71 47 157 1 102 14 30 119 216 142 182 18 88 77 189 1 240 237 249 57 182 163 87 79 74 221 172 59 45 141 211 222 84 64 89 21 88 221 147 167 172 10 252 232 122 216 86 95 76 75 6 199 138 28 233 31 6 24 55 4 196 227 113 196 137 165 63 139 125 77 101 77 125 223 39 127 79 50 116 237 25 31 158 140 51 183 16 132 64 135 213 122 31 165 20 245 122 125 195 75 7 65 128 155 73 173 21 123 203 124 45 77 117 0 61 17 3 219 182 177 109 59 82 236 251 62 110 38 197 224 88 145 197 199 25 94 149 151 81 165 28 64 207 200 100 99 246 175 4 230 228 129 116 129 197 124 134 185 183 10 85 202 241 115 255 69 206 159 189 48 11 136 77 9 180 214 20 210 189 12 92 121 138 55 125 135 202 231 239 168 249 7 188 239 26 166 179 205 55 70 8 180 214 100 179 89 126 201 67 204 59 14 239 62 213 89 122 61 5 189 105 118 173 172 0 218 52 161 110 75 16 134 33 187 63 166 121 244 165 155 251 185 28 221 242 37 59 251 110 145 76 38 113 93 151 55 149 5 140 139 92 79 80 173 86 241 60 143 145 201 6 71 59 43 172 238 72 16 30 24 37 145 72 96 89 22 150 101 69 186 120 3 65 44 22 67 107 77 173 86 67 107 141 148 18 173 53 66 8 132 16 173 219 27 17 3 165 20 142 227 108 58 117 198 100 125 24 131 137 155 183 175 159 250 135 41 158 48 201 111 90 157 232 152 121 9 252 18 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray!

developmentCss
	^ '/* toolbar */
body { margin-bottom: 25px !!important; /*matches toolbar min-height + padding and margin*/}
.wa-toolbar {
	left: 0;
	right: 0;
	bottom: 0;
	z-index: 20;
	padding: 2px;
	position: fixed;
	text-align: left;
	background-color: #eee;
	border-top: 1px solid #aaa;
	min-height: 20px;
}
.wa-toolbar { vertical-align: middle; }
.wa-toolbar, .wa-toolbar * {
	color: #444;
	font-size: 14px;
	font-family: "Helvetica Neue", Helvetica, Verdana, Arial, sans-serif;
}
.wa-toolbar a {
	padding-left: 3px;
	padding-right: 3px;
	text-decoration: none;
}
.wa-toolbar a:hover {
	text-decoration: underline;
}
.wa-toolbar .wa-deprecationtoolplugin {
	color: #ff7000;
}

/* halos */
.wa-halo {
	margin: 4px;
	text-align: left;
	border: 1px solid #aaa;
}

.wa-halo .wa-halo-header {
	padding: 2px 4px ;
	overflow: hidden;
	background-color: #eee;
	border-bottom: 1px solid #aaa;
}
.wa-halo .wa-halo-header,
.wa-halo .wa-halo-header * {
	color: #444;
	font-size: 14px;
	font-family: "Helvetica Neue", Helvetica, Verdana, Arial, sans-serif;
}
.wa-halo .wa-halo-header a {
	text-decoration: none;
}
.wa-halo .wa-halo-header .wa-classnamehaloplugin,
.wa-halo .wa-halo-header .wa-browserhaloplugin,
.wa-halo .wa-halo-header .wa-inspectorhaloplugin,
.wa-halo .wa-halo-header .wa-styleshaloplugin {
	float: left;
	display: block;
	padding-right: 4px;
}
.wa-halo .wa-halo-header .wa-classnamehaloplugin {
	font-weight: bold;
	padding-right: 8px;
}
.wa-halo .wa-halo-header .wa-browserhaloplugin, .window .window-titlebar .wa-browserhaloplugin {
	background: url(codebrowser.png) no-repeat;
}
.wa-halo .wa-halo-header .wa-inspectorhaloplugin, .window .window-titlebar .wa-inspectorhaloplugin {
	background: url(inspector.png) no-repeat;
}
.wa-halo .wa-halo-header .wa-styleshaloplugin, .window .window-titlebar .wa-styleshaloplugin {
	background: url(styleeditor.png) no-repeat;
}
.wa-halo .wa-halo-header .wa-browserhaloplugin a,
.wa-halo .wa-halo-header .wa-inspectorhaloplugin a,
.wa-halo .wa-halo-header .wa-styleshaloplugin a {
	width: 16px;
	outline: none;
	display: block;
	text-indent: -32000px;
	background-position: 0 50%;
}
.wa-halo .wa-halo-header .wa-modehaloplugin {
	float: right;
	display: block;
	padding-right: 4px;
}
.wa-halo .wa-halo-header .wa-modehaloplugin a {
	text-decoration: none;
}
.wa-halo .wa-halo-header .wa-modehaloplugin a:hover {
	text-decoration: underline;
}
.wa-halo .wa-halo-header .wa-modehaloplugin a.active {
	font-weight: bold;
}

.wa-halo .wa-halo-body {
	clear: both;
}
.wa-halo .wa-halo-body .wa-halo-source {
	padding: 2px 4px;
	background-color: #fff;
}
.wa-halo .wa-halo-body .wa-halo-source,
.wa-halo .wa-halo-body .wa-halo-source * {
	color: #444;
	line-height: 1;
	font-size: 12px;
	font-family: Monaco, "Courier New", Courier, serif;
}
.wa-halo .wa-halo-body .wa-halo-source .wa-tag {
	color: navy;
	font-weight: bold;
}
.wa-halo .wa-halo-body .wa-halo-source .wa-attribute-key {
	color: navy;
}
.wa-halo .wa-halo-body .wa-halo-source .wa-attribute-value,
.wa-halo .wa-halo-body .wa-halo-source .wa-attribute-value a {
	color: purple;
	text-decoration: none;
}
.wa-halo .wa-halo-body .wa-halo-source .wa-attribute-value a:hover {
	text-decoration: underline;
}'!

inspectorPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 6 98 75 71 68 0 240 0 240 0 239 52 6 103 27 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 213 11 5 16 15 5 37 253 173 47 0 0 1 246 73 68 65 84 56 203 157 146 77 107 19 81 24 133 159 59 201 36 77 154 102 134 74 82 10 10 181 93 104 26 69 20 193 133 184 20 10 85 119 226 38 191 192 111 169 244 31 136 182 36 65 68 20 116 89 119 85 16 197 77 168 59 65 236 162 84 40 164 137 86 171 150 80 53 141 205 71 39 77 50 51 215 69 72 73 66 82 170 103 119 15 239 61 239 225 188 71 60 121 250 120 49 247 39 119 140 61 64 85 213 231 19 183 38 47 182 144 211 209 187 150 220 35 238 77 223 145 237 162 78 41 235 92 62 191 185 235 118 77 211 59 242 78 33 196 206 35 153 76 118 28 10 133 66 93 133 119 28 180 15 102 50 25 102 95 204 2 144 152 75 0 208 180 107 119 7 223 190 175 146 74 167 57 122 106 140 109 197 139 105 43 184 100 133 212 252 107 38 110 223 140 196 162 247 159 53 254 40 237 14 52 93 35 149 78 115 232 228 24 159 11 94 6 7 2 140 28 8 82 18 62 180 209 113 252 154 62 115 237 198 149 227 93 29 36 230 18 12 135 79 179 82 112 115 233 204 16 190 30 21 211 182 81 29 10 239 150 37 193 35 227 54 75 111 22 0 1 160 116 10 75 122 3 12 13 232 88 182 100 219 52 169 212 44 202 85 139 126 159 155 95 101 181 37 9 69 74 137 148 118 75 48 110 183 11 132 160 92 181 168 214 36 155 91 53 220 170 131 253 253 30 164 16 45 93 112 2 182 105 154 45 78 108 99 131 53 163 138 223 163 162 247 185 176 45 137 223 227 228 211 70 129 125 61 150 157 107 114 174 212 43 234 66 211 116 52 77 231 194 185 243 164 23 222 18 236 19 124 249 153 39 155 43 145 55 42 124 92 89 167 84 174 144 91 122 229 44 21 139 63 26 2 34 26 159 154 177 44 43 210 124 13 195 48 112 56 84 78 156 141 176 188 86 100 203 84 24 236 149 172 47 190 100 248 224 8 0 31 230 223 167 30 62 120 116 88 116 107 216 213 235 151 167 2 129 224 100 51 231 235 245 17 30 13 243 59 155 173 247 101 245 43 130 127 68 44 30 149 13 145 255 18 0 148 88 60 106 1 148 13 131 191 6 140 246 211 127 51 231 46 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray!

selectorsToInclude
	^ #( developmentCss )!

styleeditorPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 214 4 9 20 4 42 36 195 187 166 0 0 2 112 73 68 65 84 56 203 173 147 221 75 83 113 24 199 63 155 155 110 57 245 164 169 232 24 180 240 173 50 207 48 74 144 68 27 82 209 141 43 147 145 136 226 159 97 36 236 70 130 174 162 232 38 34 42 86 104 26 42 5 74 47 243 5 65 212 110 52 148 48 95 74 156 107 206 236 156 249 50 117 110 167 139 58 232 130 186 144 30 248 193 247 226 249 124 248 61 207 143 31 28 172 146 107 156 213 74 119 119 183 114 16 216 180 15 222 19 184 65 116 67 167 27 228 223 167 211 13 226 31 112 226 126 184 198 89 173 104 84 24 232 183 55 54 10 73 201 41 16 217 37 184 178 66 95 107 171 4 84 44 222 110 89 150 229 96 219 204 204 76 89 93 109 61 85 85 85 212 56 171 105 111 123 169 87 5 157 246 250 122 135 226 245 18 24 25 1 69 225 136 77 132 212 52 94 127 15 140 249 46 86 230 100 103 153 15 23 228 159 160 188 188 92 133 117 64 36 14 224 42 60 40 42 41 73 88 236 233 97 119 99 131 104 56 204 178 94 199 156 205 198 194 217 211 230 230 155 46 163 86 27 135 40 138 108 132 130 60 122 248 88 7 68 0 180 234 112 74 40 4 202 222 78 190 230 230 225 63 83 76 83 83 51 62 159 143 188 188 60 218 59 94 176 24 76 222 108 56 89 89 168 246 169 2 79 48 16 32 45 63 31 157 193 192 252 229 75 248 47 216 185 238 172 197 231 243 97 52 26 233 31 232 227 211 236 23 4 177 250 208 146 144 237 138 17 76 31 79 126 254 166 191 87 193 100 226 104 105 41 19 69 133 92 113 92 99 109 109 13 69 81 88 95 15 50 60 58 202 80 192 138 201 168 195 159 146 105 143 17 124 168 73 170 141 27 44 211 188 21 38 232 26 241 144 62 61 133 167 239 61 130 32 32 203 50 119 238 221 229 227 143 12 66 187 113 108 135 35 49 239 170 3 208 155 37 123 162 152 195 192 173 49 182 36 3 130 55 132 102 106 146 150 251 207 8 71 34 172 104 173 44 109 9 164 101 89 9 200 219 100 202 126 79 140 0 32 204 38 74 244 87 150 204 195 196 235 102 241 246 26 176 228 22 99 200 182 112 42 43 129 213 245 29 62 15 116 72 54 105 201 21 35 8 123 5 207 106 116 206 97 201 201 96 97 122 25 128 236 226 45 178 114 94 49 120 99 202 247 77 41 72 4 200 148 253 30 155 180 228 122 50 249 110 92 21 104 0 28 117 86 49 122 46 208 127 190 193 34 24 73 37 202 46 235 138 159 161 167 43 146 118 40 189 162 203 61 63 254 183 143 161 81 131 163 206 42 238 28 219 113 233 205 146 93 189 85 252 92 188 235 95 240 127 169 159 24 23 11 103 188 240 115 88 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !
!WADevelopmentFiles categoriesFor: #codebrowserPng!images!public! !
!WADevelopmentFiles categoriesFor: #developmentCss!public!styles! !
!WADevelopmentFiles categoriesFor: #inspectorPng!images!public! !
!WADevelopmentFiles categoriesFor: #selectorsToInclude!accessing!public! !
!WADevelopmentFiles categoriesFor: #styleeditorPng!images!public! !

WAHaloPlugin guid: (GUID fromString: '{DDB115A0-E093-4F2F-979C-66A5B08A0856}')!
WAHaloPlugin comment: 'Abstract root class for all halo tools. They add functionality to the halo toolbar.'!
!WAHaloPlugin categoriesForClass!Unclassified! !
!WAHaloPlugin methodsFor!

initializeRoot: aRootObject requestor: aRequestorObject
	self initializeRequestor: aRequestorObject.
	root := aRootObject.
!

open: aComponent onAnswer: aBlock
	| component decoration |
	component := self session presenter.
	decoration := component decorations
		detect: [ :each | each isKindOf: WAToolDecoration ]
		ifNone: [ nil ].
	decoration isNil
		ifTrue: [ ^ super open: aComponent onAnswer: aBlock ].
	component removeDecoration: decoration.
	super open: aComponent onAnswer: [ :value |
		component addDecoration: decoration.
		aBlock value: value ]!

renderContentOn: html
	html div
		class: self cssClass;
		with: [ super renderContentOn: html ]!

root

	^root! !
!WAHaloPlugin categoriesFor: #initializeRoot:requestor:!initialization!public! !
!WAHaloPlugin categoriesFor: #open:onAnswer:!actions!public! !
!WAHaloPlugin categoriesFor: #renderContentOn:!public!rendering! !
!WAHaloPlugin categoriesFor: #root!accessing!public! !

!WAHaloPlugin class methodsFor!

allSubclassesOn: aTargetObject for: aRequestorObject
	| plugins |
	plugins := self allSubclasses
		collect: [ :each | each on: aTargetObject for: aRequestorObject ].
	^ plugins sorted!

on: aTargetObject for: aRequestorObject
	^ self basicNew initializeRoot: aTargetObject requestor: aRequestorObject! !
!WAHaloPlugin class categoriesFor: #allSubclassesOn:for:!instance creation!public! !
!WAHaloPlugin class categoriesFor: #on:for:!instance creation!public! !

WAToolPlugin guid: (GUID fromString: '{6E5A21A3-20FF-4644-A699-F2711B70C062}')!
WAToolPlugin comment: 'Abstract root class for all development tool bar tools.'!
!WAToolPlugin categoriesForClass!Unclassified! !
!WAToolPlugin methodsFor!

open: aComponent onAnswer: aBlock
	| component |
	component := self requestor decoratedComponent.
	component removeDecoration: self requestor.
	super open: aComponent onAnswer: [ :value |
		component addDecoration: self requestor.
		aBlock value: value ]! !
!WAToolPlugin categoriesFor: #open:onAnswer:!actions!public! !

!WAToolPlugin class methodsFor!

allSubclassesFor: aRequestorObject
	| plugins |
	plugins := self allSubclasses
		collect: [ :each | each for: aRequestorObject ].
	^ plugins sorted!

for: aRequestorObject
	^ self basicNew initializeRequestor: aRequestorObject! !
!WAToolPlugin class categoriesFor: #allSubclassesFor:!instance creation!public! !
!WAToolPlugin class categoriesFor: #for:!instance creation!public! !

WAClassnameHaloPlugin guid: (GUID fromString: '{AB0EAB1F-122F-4D5F-8A02-9C88B38900D0}')!
WAClassnameHaloPlugin comment: 'I display the class name of the component class.'!
!WAClassnameHaloPlugin categoriesForClass!Unclassified! !
!WAClassnameHaloPlugin methodsFor!

priority
	^ 100!

renderContentOn: html
	html div class: self cssClass; with: self root className! !
!WAClassnameHaloPlugin categoriesFor: #priority!accessing!public! !
!WAClassnameHaloPlugin categoriesFor: #renderContentOn:!public!rendering! !

WAInspectorHaloPlugin guid: (GUID fromString: '{1EE328B5-7933-4CC5-8592-DD2A75AC4728}')!
WAInspectorHaloPlugin comment: 'I open an inspector on the component class.'!
!WAInspectorHaloPlugin categoriesForClass!Unclassified! !
!WAInspectorHaloPlugin methodsFor!

execute
	self open: (WAInspector current on: self root)!

isActive
	^ WAInspector current notNil!

label
	^ 'Inspector'!

priority
	^ 600!

tooltip
	^ 'Object Inspector'! !
!WAInspectorHaloPlugin categoriesFor: #execute!actions!public! !
!WAInspectorHaloPlugin categoriesFor: #isActive!public!testing! !
!WAInspectorHaloPlugin categoriesFor: #label!accessing!public! !
!WAInspectorHaloPlugin categoriesFor: #priority!accessing!public! !
!WAInspectorHaloPlugin categoriesFor: #tooltip!accessing!public! !

WAModeHaloPlugin guid: (GUID fromString: '{AC23D2FE-D702-4697-8849-71D63A95D1C5}')!
WAModeHaloPlugin comment: 'I control the rendering modes of the halo.'!
!WAModeHaloPlugin categoriesForClass!Unclassified! !
!WAModeHaloPlugin methodsFor!

priority
	^ 900!

renderContentOn: html
	html div class: self cssClass; with: [
		self requestor modes
			do: [ :each |
				html anchor
					class: 'active' if: self requestor mode = each;
					callback: [ self requestor mode: each ];
					with: (self labelForSelector: each) ]
			separatedBy: [ html text: ' / ' ] ]! !
!WAModeHaloPlugin categoriesFor: #priority!accessing!public! !
!WAModeHaloPlugin categoriesFor: #renderContentOn:!public!rendering! !

WAStylesHaloPlugin guid: (GUID fromString: '{7CE008F3-0EED-4C77-92CF-A0E5EA3C39DD}')!
WAStylesHaloPlugin comment: 'I open the style editor on the component class.'!
!WAStylesHaloPlugin categoriesForClass!Unclassified! !
!WAStylesHaloPlugin methodsFor!

execute
	self open: (WAPluggableTool on: (WAViewer on: self root))!

label
	^ 'Styles'!

priority
	^ 700!

tooltip
	^ 'CSS Style Editor'! !
!WAStylesHaloPlugin categoriesFor: #execute!actions!public! !
!WAStylesHaloPlugin categoriesFor: #label!accessing!public! !
!WAStylesHaloPlugin categoriesFor: #priority!accessing!public! !
!WAStylesHaloPlugin categoriesFor: #tooltip!accessing!public! !

WAConfigureToolPlugin guid: (GUID fromString: '{AEB53E08-03D0-42DC-9EEC-75BCC02FE735}')!
WAConfigureToolPlugin comment: 'I display the configuration dialog for the currently active application'!
!WAConfigureToolPlugin categoriesForClass!Unclassified! !
!WAConfigureToolPlugin methodsFor!

execute
	self open: (WAPluggableTool on: self application configurationComponent)!

label
	^ 'Configure'!

priority
	^ 200! !
!WAConfigureToolPlugin categoriesFor: #execute!actions!public! !
!WAConfigureToolPlugin categoriesFor: #label!accessing!public! !
!WAConfigureToolPlugin categoriesFor: #priority!accessing!public! !

WADeprecationToolPlugin guid: (GUID fromString: '{996D5F65-A0DB-466F-9978-5CCAAB207EF0}')!
WADeprecationToolPlugin comment: 'I display deprecation warnings.'!
!WADeprecationToolPlugin categoriesForClass!Unclassified! !
!WADeprecationToolPlugin methodsFor!

execute
	self open: (WADeprecation on: filter)!

initializeRequestor: aRequestorObject
	super initializeRequestor: aRequestorObject.
	filter := self session filters
		detect: [ :each | each isKindOf: WADeprecatedToolFilter ]
		ifNone: [ self session addFilter: WADeprecatedToolFilter new ]!

isActive
	^ filter notifications notEmpty!

label
	^ 'Deprecated (' , filter notifications size printString , ')'!

priority
	^ 700! !
!WADeprecationToolPlugin categoriesFor: #execute!actions!public! !
!WADeprecationToolPlugin categoriesFor: #initializeRequestor:!initialization!public! !
!WADeprecationToolPlugin categoriesFor: #isActive!public!testing! !
!WADeprecationToolPlugin categoriesFor: #label!accessing!public! !
!WADeprecationToolPlugin categoriesFor: #priority!accessing!public! !

WANewSessionToolPlugin guid: (GUID fromString: '{97C6D5F4-AC89-47EC-83FE-6F183654D20F}')!
WANewSessionToolPlugin comment: 'I create a new session.'!
!WANewSessionToolPlugin categoriesForClass!Unclassified! !
!WANewSessionToolPlugin methodsFor!

execute
	self session unregister.
	self requestContext redirectTo: self application url!

label
	^ 'New Session'!

priority
	^ 100! !
!WANewSessionToolPlugin categoriesFor: #execute!actions!public! !
!WANewSessionToolPlugin categoriesFor: #label!accessing!public! !
!WANewSessionToolPlugin categoriesFor: #priority!accessing!public! !

!WANewSessionToolPlugin class methodsFor!

title
	^'New Session'! !
!WANewSessionToolPlugin class categoriesFor: #title!accessing!public! !

WATerminateToolPlugin guid: (GUID fromString: '{0345E21F-9428-4FFC-BD65-382C60E8AFB6}')!
WATerminateToolPlugin comment: 'I try to terminate the process handling this session. This can work of you''re at 100% CPU.'!
!WATerminateToolPlugin categoriesForClass!Unclassified! !
!WATerminateToolPlugin methodsFor!

isActive
	^ self application preferenceAt: #sessionAllowTermination!

label
	^ 'Terminate'!

priority
	^ 600!

renderContentOn: html
	html anchor
		class: self cssClass;
		url: (html actionUrl
			withField: 'terminate');
		with: self label! !
!WATerminateToolPlugin categoriesFor: #isActive!public!testing! !
!WATerminateToolPlugin categoriesFor: #label!accessing!public! !
!WATerminateToolPlugin categoriesFor: #priority!accessing!public! !
!WATerminateToolPlugin categoriesFor: #renderContentOn:!public!rendering! !

WATimingToolPlugin guid: (GUID fromString: '{792743F8-8CED-4778-B19E-78E0D545D354}')!
WATimingToolPlugin comment: 'I display render and callback times.'!
!WATimingToolPlugin categoriesForClass!Unclassified! !
!WATimingToolPlugin methodsFor!

initializeRequestor: aRequestorObject
	super initializeRequestor: aRequestorObject.
	filter := self session filters
		detect: [ :each | each isKindOf: WATimingToolFilter ]
		ifNone: [ self session addFilter: WATimingToolFilter new ]!

priority
	^ 900!

renderContentOn: html
	html span class: self cssClass; with: [
		html span
			title: 'Callback Time';
			with: filter previousTiming.
		html text: '/'.
		html span
			title: 'Render Time';
			with: filter currentTiming.
		html text: ' ms' ]! !
!WATimingToolPlugin categoriesFor: #initializeRequestor:!initialization!public! !
!WATimingToolPlugin categoriesFor: #priority!accessing!public! !
!WATimingToolPlugin categoriesFor: #renderContentOn:!public!rendering! !

WAToggleHalosToolPlugin guid: (GUID fromString: '{72FE626F-E64C-4685-B4BA-A21B1FDF7CCD}')!
WAToggleHalosToolPlugin comment: 'I toggle halos on and off.'!
!WAToggleHalosToolPlugin categoriesForClass!Unclassified! !
!WAToggleHalosToolPlugin methodsFor!

execute
	 self requestor toggleHalos!

label
	^ 'Halos'!

priority
	^ 300! !
!WAToggleHalosToolPlugin categoriesFor: #execute!actions!public! !
!WAToggleHalosToolPlugin categoriesFor: #label!accessing!public! !
!WAToggleHalosToolPlugin categoriesFor: #priority!accessing!public! !

WAValidateToolPlugin guid: (GUID fromString: '{AC56EF4B-A8A6-4E39-87F5-06756F17901D}')!
WAValidateToolPlugin comment: 'I validate and XHTML page by sending it to the W3C validator. I only work if the website is publically available.'!
!WAValidateToolPlugin categoriesForClass!Unclassified! !
!WAValidateToolPlugin methodsFor!

label
	^ 'XHTML'!

priority
	^ 800!

renderContentOn: html
	html anchor
		class: self cssClass;
		title: 'Validate XHTML';
		url: 'http://validator.w3.org/check/referer';
		with: self label! !
!WAValidateToolPlugin categoriesFor: #label!accessing!public! !
!WAValidateToolPlugin categoriesFor: #priority!accessing!public! !
!WAValidateToolPlugin categoriesFor: #renderContentOn:!public!rendering! !

WATool guid: (GUID fromString: '{BE0BEDE6-E554-4E2C-B66A-E88195E27CDE}')!
WATool comment: 'A WATool is the common base class for tools called from the development tool bar. Is doesn''t do anything but including WADevelopmentFiles.'!
!WATool categoriesForClass!Unclassified! !
!WATool methodsFor!

updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	WAToolFiles default updateRoot: anHtmlRoot.
	WADevelopmentFiles default updateRoot: anHtmlRoot! !
!WATool categoriesFor: #updateRoot:!public!updating! !

WAWalkback guid: (GUID fromString: '{5CF02EBB-19AD-4B9C-A4BC-D83C22CF33E2}')!
WAWalkback comment: '
An abstract component that renders an exeception stack with temporary variables. Platforms should implement a concrete subclass and register that subclass when it is loaded.

By default this class renders only the top few stack frames, but offers the option to render all. It also offers the option to open a debugger in the image or to proceed with the execution and answers true and false, respectively.

'!
!WAWalkback categoriesForClass!Unclassified! !
!WAWalkback methodsFor!

defaultLimit
	"The default number of frames to display in the walkback."
	
	^ 5!

exception
	^ exception!

exceptionDescription
	"Return a short string describing the exception."

	| e |
	^ String streamContents: [ :stream |
		e := self exception.
		stream nextPutAll: e class name.
		e messageText isNil ifFalse: [
			stream nextPutAll: ': '; nextPutAll: e messageText ] ]!

frameCount
	"Return the number of frames or contexts in the walkback."
	
	self subclassResponsibility!

initializeWithException: anException
	self initialize.
	exception := anException!

limit
	"The maximum number of frames to display."

	^ limit ifNil: [ limit := self defaultLimit min: self frameCount ]!

limit: anInteger
	limit := anInteger!

renderContentOn: html
	self renderHeadingOn: html.
	self renderToolsOn: html.
	self renderExceptionOn: html.
	self renderStackOn: html!

renderExceptionOn: html
	| problems |
	problems := self exception seasidePossibleCauses.
	problems isEmpty ifTrue: [ ^ self ].
	html heading level: 3; with: 'Possible Causes'.
	html unorderedList list: problems!

renderHeadingOn: html
	html heading level: 1; with: 'Seaside Walkback'.
	html heading level: 2; with: self exceptionDescription!

renderStackOn: html
	"Render the walkback itself"
	
	self subclassResponsibility!

renderToolsOn: html
	html paragraph: [
		html anchor
			callback: [ self answer: true ];
			title: 'Open a debugger in your IDE and block until you hit "Proceed"';
			with: 'Debug'.
		self exception isResumable ifTrue: [
			html space.
			html anchor
				callback: [ self answer: false ];
				with: 'Proceed' ].
		self limit < self frameCount ifTrue: [
			html space.
			html anchor
				callback: [ self limit: self frameCount ];
				with: 'Full Stack' ] ]!

updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: self exceptionDescription.
	anHtmlRoot bodyAttributes addClass: 'walkback'.
	WAToolFiles default updateRoot: anHtmlRoot! !
!WAWalkback categoriesFor: #defaultLimit!accessing!public! !
!WAWalkback categoriesFor: #exception!accessing!public! !
!WAWalkback categoriesFor: #exceptionDescription!accessing!public! !
!WAWalkback categoriesFor: #frameCount!accessing!public! !
!WAWalkback categoriesFor: #initializeWithException:!initialization!public! !
!WAWalkback categoriesFor: #limit!accessing!public! !
!WAWalkback categoriesFor: #limit:!accessing!public! !
!WAWalkback categoriesFor: #renderContentOn:!public!rendering! !
!WAWalkback categoriesFor: #renderExceptionOn:!public!rendering! !
!WAWalkback categoriesFor: #renderHeadingOn:!public!rendering! !
!WAWalkback categoriesFor: #renderStackOn:!public!rendering! !
!WAWalkback categoriesFor: #renderToolsOn:!public!rendering! !
!WAWalkback categoriesFor: #updateRoot:!public!updating! !

!WAWalkback class methodsFor!

current
	^ Current!

current: aWalkbackClass
	Current := aWalkbackClass!

exception: anException
	^ self basicNew initializeWithException: anException; yourself!

select
	self current: self!

unselect
	(self current = self) ifTrue: [ self current: nil ]! !
!WAWalkback class categoriesFor: #current!public!registration! !
!WAWalkback class categoriesFor: #current:!public!registration! !
!WAWalkback class categoriesFor: #exception:!instance creation!public! !
!WAWalkback class categoriesFor: #select!public!registration! !
!WAWalkback class categoriesFor: #unselect!public!registration! !

WAViewer guid: (GUID fromString: '{BC40184B-3727-4375-B864-1CAE54EF65DE}')!
WAViewer comment: ''!
!WAViewer categoriesForClass!Unclassified! !
!WAViewer methodsFor!

buttons
	^ #(save)!

compile: aString 
	GRPlatform current 
		compile: aString
		into: presenter class
		classified: #rendering!

model
	^ presenter!

presenter: aPresenter
	presenter := aPresenter!

renderContentOn: html 
	html heading
		level3;
		with: presenter greaseString.
	super renderContentOn: html!

renderCssOn: html
	html textArea
		rows: 20;
		columns: 80;
		value: presenter style;
		callback: [ :css |
			self compile: 'style ', GRPlatform current newline,
				'	^ ', css asString printString ]!

rows
	^ #(css)!

save!

script
	^ 'self.opener.location=self.opener.location'! !
!WAViewer categoriesFor: #buttons!accessing!public! !
!WAViewer categoriesFor: #compile:!actions!public! !
!WAViewer categoriesFor: #model!accessing!public! !
!WAViewer categoriesFor: #presenter:!accessing!public! !
!WAViewer categoriesFor: #renderContentOn:!public!rendering! !
!WAViewer categoriesFor: #renderCssOn:!public!rendering! !
!WAViewer categoriesFor: #rows!accessing!public! !
!WAViewer categoriesFor: #save!actions!public! !
!WAViewer categoriesFor: #script!accessing!public! !

!WAViewer class methodsFor!

on: aPresenter
	^ self new presenter: aPresenter! !
!WAViewer class categoriesFor: #on:!instance creation!public! !

WADeprecation guid: (GUID fromString: '{AD11D04A-CFA9-4E3A-85A7-ACD176DD1E4D}')!
WADeprecation comment: ''!
!WADeprecation categoriesForClass!Unclassified! !
!WADeprecation methodsFor!

buildTable
	^ WATableReport new
		rowPeriod: 1;
		rowColors: #( '#eee' 'white' );
		rows: self notifications;
		columns: (Array
			with: (WAReportColumn selector: #messageText title: 'Deprecated')
			with: (WAReportColumn selector: #details title: 'Details'))
		yourself!

children
	^ Array with: self table!

filter: aFilter
	filter := aFilter!

notifications
	^ filter notifications!

renderContentOn: html
	html div
		class: 'tool';
		with: [
			html render: self table.
			html anchor
				callback: [ self resetDeprecationWarnings ];
				with: 'Reset deprecation warnings' ]
	!

resetDeprecationWarnings
	filter reset.
	self answer!

table
	^ table ifNil: [ table := self buildTable ]! !
!WADeprecation categoriesFor: #buildTable!private! !
!WADeprecation categoriesFor: #children!accessing!public! !
!WADeprecation categoriesFor: #filter:!accessing!public! !
!WADeprecation categoriesFor: #notifications!accessing!public! !
!WADeprecation categoriesFor: #renderContentOn:!public!rendering! !
!WADeprecation categoriesFor: #resetDeprecationWarnings!actions!public! !
!WADeprecation categoriesFor: #table!accessing!public! !

!WADeprecation class methodsFor!

on: filter
	^self new filter: filter; yourself! !
!WADeprecation class categoriesFor: #on:!instance creation!public! !

WAInspector guid: (GUID fromString: '{D8C89FE0-1C07-493C-917D-A3949F1C1142}')!
WAInspector comment: '
This is an abstract implementation of a web-based object inspector. Platforms should implement their own subclasses, specifying behaviour for all unimplemented methods.

Note that #openNativeInspectorOn: on the class-side also needs to be implemented.

Also subclasses probably want to implement #initialize and #unload on the class-side to call ''self select'' and ''self unselect'' respectively. This will ensure they are registered as the current implementation when they are loaded.'!
!WAInspector categoriesForClass!Unclassified! !
!WAInspector methodsFor!

actions
	"A list of action selectors used to render buttons in the Inspector."

	^ #(doIt inspectIt)!

children
	^ Array with: path!

chooseObject: anObject named: aString
	"Choose a new object to be inspected, adding aString to the navigation path."

	path pushSegment: anObject name: aString.
	selected := nil!

doIt
	"Execute the code in the textarea. We return the result so subclasses can do something
	with it if desired."
	
	^ self evaluate!

evaluate
	"Evaluate the code in the textarea and return the result."
	
	self subclassResponsibility!

fieldsFor: anObject
	"Return a sequenceable collection of Associations representing labels and values
	of instance variables, etc. which should be displayed when inspecting anObject."

	self subclassResponsibility!

initialize
	super initialize.
	path := WAPath new!

inspectIt
	"Evaluate the code in the textarea and then inspect the result."
	| result |
	result := self evaluate.
	self 
		chooseObject: result
		named: result greaseString!

isPrimitiveType: anObject
	"Return a boolean indicating whether anObject is a primitive type in the system.
	Primitive types will not be rendered with a link allowing them to be inspected."

	^ anObject isNumber or: [ #(nil true false) includes: anObject ]!

object
	^ path currentSegment!

object: anObject 
	self 
		chooseObject: anObject
		named: anObject greaseString!

renderContentOn: html
	html heading
		level: 1;
		with: (self object printStringLimitedTo: 50).
	html render: path.
	html form: [
		self renderMembersOn: html.
		self renderEditAreaOn: html ]!

renderEditAreaOn: html
	html textArea
		value: input;
		callback: [ :value | input := value ].
	html break.
	self actions do: [ :each |
		html submitButton
			callback: [ self perform: each ];
			text: each ]!

renderMembersOn: html
	| members radioGroup |
	selected := nil.
	members := self fieldsFor: self object.
	members isEmpty ifTrue: [ ^ self ].
	radioGroup := html radioGroup.
	radioGroup
		callback: [ :value | selected := value ];
		selected: selected.
	html table: [
		members do: [ :association |
			self
				renderRow: association value
				named: association key
				group: radioGroup
				on: html ] ]!

renderRow: anObject named: aString group: aRadioGroup on: html
	| radioButton |
	html tableRow: [
		html tableHeading: [
			radioButton := aRadioGroup radioButton
				ensureId;
				value: aString;
				yourself.
			html label for: radioButton id; with: [
				(self isPrimitiveType: anObject)
					ifTrue: [ html text: aString ]
					ifFalse: [
						html anchor
							callback: [ self chooseObject: anObject named: aString ];
							with: aString ] ] ].
		html tableData: (anObject printStringLimitedTo: 100) ]!

style
	^ 'form {
	padding: 2px;
	margin: 0;
}
form th {
	text-align: left;
	padding-right: 2em;
}
form textarea {
	width: 100%;
	height: 100px;
	border: 1px solid #aaa;
}'! !
!WAInspector categoriesFor: #actions!actions!public! !
!WAInspector categoriesFor: #children!hooks!public! !
!WAInspector categoriesFor: #chooseObject:named:!actions!public! !
!WAInspector categoriesFor: #doIt!actions!public! !
!WAInspector categoriesFor: #evaluate!actions!public! !
!WAInspector categoriesFor: #fieldsFor:!private! !
!WAInspector categoriesFor: #initialize!initialization!public! !
!WAInspector categoriesFor: #inspectIt!actions!public! !
!WAInspector categoriesFor: #isPrimitiveType:!public!testing! !
!WAInspector categoriesFor: #object!accessing!public! !
!WAInspector categoriesFor: #object:!accessing!public! !
!WAInspector categoriesFor: #renderContentOn:!public!rendering! !
!WAInspector categoriesFor: #renderEditAreaOn:!public!rendering! !
!WAInspector categoriesFor: #renderMembersOn:!public!rendering! !
!WAInspector categoriesFor: #renderRow:named:group:on:!public!rendering! !
!WAInspector categoriesFor: #style!hooks!public! !

!WAInspector class methodsFor!

current
	^ Current!

current: anInspectorClass
	Current := anInspectorClass!

on: anObject
	^ self new object: anObject; yourself!

select
	self current: self!

unselect
	(self current = self) ifTrue: [ self current: nil ]! !
!WAInspector class categoriesFor: #current!public!registration! !
!WAInspector class categoriesFor: #current:!public!registration! !
!WAInspector class categoriesFor: #on:!instance creation!public! !
!WAInspector class categoriesFor: #select!public!registration! !
!WAInspector class categoriesFor: #unselect!public!registration! !

WAPluggableTool guid: (GUID fromString: '{5E3B270D-598B-45CA-AFDC-BCEA0B05672E}')!
WAPluggableTool comment: '
A WAPluggableTool is a wrapper component around tools that can''t be made subclasses of WATool. WATool is only really needed to provide the icon image.

Instance Variables
	component:		<WAComponent>

component
	- the component to render
'!
!WAPluggableTool categoriesForClass!Unclassified! !
!WAPluggableTool methodsFor!

children
	^Array with: component!

initializeWith: aComponent
	self initialize.
	component := aComponent.
	component onAnswer: [ self answer ]! !
!WAPluggableTool categoriesFor: #children!accessing!public! !
!WAPluggableTool categoriesFor: #initializeWith:!initialization!public! !

!WAPluggableTool class methodsFor!

on: aComponent
	^self basicNew
		initializeWith: aComponent;
		yourself! !
!WAPluggableTool class categoriesFor: #on:!instance creation!public! !

WAToolDecoration guid: (GUID fromString: '{27F446FB-63D2-45D5-8FB5-E34F8D7A49BA}')!
WAToolDecoration comment: ''!
!WAToolDecoration categoriesForClass!Unclassified! !
!WAToolDecoration methodsFor!

haloFor: aComponent
	^ halos at: aComponent ifAbsentPut: [ WAHalo on: aComponent ]!

initialize
	super initialize.
	showHalos := WAValueHolder with: false.
	halos := GRPlatform current weakDictionaryOfSize: 20.
	plugins := WAToolPlugin allSubclassesFor: self!

isGlobal
	^ true!

plugins
	^ plugins!

renderChildOn: html
	self showHalos ifTrue: [
		html context addHaloVisitor: (WAHaloVisitor decoration: self context: html context).
		html context enableHalos ].
	self renderNextOn: html.
	html context disableHalos!

renderContentOn: html
	self renderChildOn: html.
	self renderToolbarOn: html!

renderToolbarOn: html
	html div class: 'wa-toolbar'; with: [
		(self plugins select: [ :each | each isActive ])
			do: [ :each | html render: each ]
			separatedBy: [ html text: ' ' ] ]!

showHalos
	^ showHalos contents!

states
	^ Array with: showHalos!

toggleHalos
	showHalos contents: showHalos contents not!

updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	WADevelopmentFiles default updateRoot: anHtmlRoot!

updateStates: aSnapshot
	super updateStates: aSnapshot.
	"Create halos for all visible presenters at the end of the action phase so that we
	can properly snapshot their initial values (otherwise they get created in the render
	phase and we have no snapshot of the state for that render)."
	self showHalos ifTrue: [ self visiblePresentersDo: [ :each | self haloFor: each ] ].
	aSnapshot register: halos.
	halos do: [ :each  | each updateStates: aSnapshot ]! !
!WAToolDecoration categoriesFor: #haloFor:!plugin-halos!public! !
!WAToolDecoration categoriesFor: #initialize!initialization!public! !
!WAToolDecoration categoriesFor: #isGlobal!public!testing! !
!WAToolDecoration categoriesFor: #plugins!accessing!public! !
!WAToolDecoration categoriesFor: #renderChildOn:!public!rendering! !
!WAToolDecoration categoriesFor: #renderContentOn:!public!rendering! !
!WAToolDecoration categoriesFor: #renderToolbarOn:!public!rendering! !
!WAToolDecoration categoriesFor: #showHalos!plugin-halos!public! !
!WAToolDecoration categoriesFor: #states!accessing!public! !
!WAToolDecoration categoriesFor: #toggleHalos!plugin-halos!public! !
!WAToolDecoration categoriesFor: #updateRoot:!public!updating! !
!WAToolDecoration categoriesFor: #updateStates:!public!updating! !

!WAToolDecoration class methodsFor!

canBeRoot
	^ true! !
!WAToolDecoration class categoriesFor: #canBeRoot!public!testing! !

WADeprecatedToolFilter guid: (GUID fromString: '{6B061B6E-5D26-40BA-9AC1-2DEDFBCD1EE4}')!
WADeprecatedToolFilter comment: ''!
!WADeprecatedToolFilter categoriesForClass!Unclassified! !
!WADeprecatedToolFilter methodsFor!

deprecated: aNotification
	"Adds a deprecated warning aNotification to the receiver. Remove old deprecation warnings that have the same message and detail text."

	notifications := notifications reject: [ :each | 
		(each messageText = aNotification messageText)
			and: [ each details = aNotification details ] ].
	notifications add: aNotification.
	aNotification resume!

handleFiltered: aRequestContext 
	[ super handleFiltered: aRequestContext ] 
		on: GRDeprecatedApiNotification
		do: [ :notification | self deprecated: notification ]!

initialize
	super initialize.
	self reset!

notifications
	^ notifications!

reset
	notifications := OrderedCollection new! !
!WADeprecatedToolFilter categoriesFor: #deprecated:!actions!public! !
!WADeprecatedToolFilter categoriesFor: #handleFiltered:!processing!public! !
!WADeprecatedToolFilter categoriesFor: #initialize!initialization!public! !
!WADeprecatedToolFilter categoriesFor: #notifications!accessing!public! !
!WADeprecatedToolFilter categoriesFor: #reset!actions!public! !

WATimingToolFilter guid: (GUID fromString: '{8598F94F-CD3D-4E65-9F89-3B7D02E8A428}')!
WATimingToolFilter comment: ''!
!WATimingToolFilter categoriesForClass!Unclassified! !
!WATimingToolFilter methodsFor!

currentTiming
	"Answer the running timing, or 0 if no value is available."

	^ startTime isNil ifTrue: [ 0 ] ifFalse: [ Time millisecondsSince: startTime ]!

handleFiltered: aRequestContext
	startTime := Time millisecondClockValue.
	[ super handleFiltered: aRequestContext ]
		ensure: [ previousTiming := self currentTiming ]!

previousTiming
	"Answer the previous timing, or 0 if no value is available."

	^ previousTiming ifNil: [ 0 ]! !
!WATimingToolFilter categoriesFor: #currentTiming!accessing!public! !
!WATimingToolFilter categoriesFor: #handleFiltered:!processing!public! !
!WATimingToolFilter categoriesFor: #previousTiming!accessing!public! !

WAHaloVisitor guid: (GUID fromString: '{E051B5A6-1454-4F03-8708-B30E340727EC}')!
WAHaloVisitor comment: ''!
!WAHaloVisitor categoriesForClass!Unclassified! !
!WAHaloVisitor methodsFor!

initializeWithToolDecoration: aToolDecoration renderContext: aRenderContext
	self initialize.
	toolDecoration := aToolDecoration.
	renderContext := aRenderContext!

postCopyForRenderContext: aRenderContext
	super postCopyForRenderContext: aRenderContext.
	renderContext := aRenderContext.
	visitor := visitor copyForRenderContext: aRenderContext!

renderContext
	^ renderContext!

toolDecoration
	^ toolDecoration!

visitor
	^ visitor!

visitor: anObject
	visitor := anObject!

visitPainter: aPainter 
	| halo |
	(self renderContext halosEnabled and: [ aPainter canHaveHalo ]) 
		ifTrue: [
			halo := self toolDecoration haloFor: aPainter.
			halo renderWithContext: self renderContext visitor: visitor ]
		ifFalse: [ visitor visit: aPainter ]
	! !
!WAHaloVisitor categoriesFor: #initializeWithToolDecoration:renderContext:!initialization!public! !
!WAHaloVisitor categoriesFor: #postCopyForRenderContext:!copying!public! !
!WAHaloVisitor categoriesFor: #renderContext!accessing!public! !
!WAHaloVisitor categoriesFor: #toolDecoration!accessing!public! !
!WAHaloVisitor categoriesFor: #visitor!accessing!public! !
!WAHaloVisitor categoriesFor: #visitor:!accessing!public! !
!WAHaloVisitor categoriesFor: #visitPainter:!public!visiting! !

!WAHaloVisitor class methodsFor!

decoration: aToolDecoration context: aRenderContext
	^ self basicNew
		initializeWithToolDecoration: aToolDecoration renderContext: aRenderContext;
		yourself! !
!WAHaloVisitor class categoriesFor: #decoration:context:!instance creation!public! !

"Binary Globals"!

