| package |
package := Package name: 'Seaside-Dolphin-Core'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '9'.


package classNames
	add: #SeasideIcons;
	yourself.

package methodNames
	add: #Array -> #restoreFromSnapshot:;
	add: #Bag -> #restoreFromSnapshot:;
	add: #Bag -> #snapshotCopy;
	add: #BlockClosure -> #renderOn:;
	add: #Dictionary -> #restoreFromSnapshot:;
	add: #Dictionary -> #snapshotCopy;
	add: #LookupTable -> #snapshotCopy;
	add: #MessageSend -> #renderOn:;
	add: #Object -> #restoreFromSnapshot:;
	add: #Object -> #snapshotCopy;
	add: #OrderedCollection -> #restoreFromSnapshot:;
	add: #OrderedCollection -> #snapshotCopy;
	add: #PositionableStream -> #seasideMimeDocument;
	add: #PositionableStream -> #seasideMimeDocumentType:;
	add: #SequenceableCollection -> #restoreFromSnapshot:;
	add: #Set -> #restoreFromSnapshot:;
	add: #Set -> #snapshotCopy;
	add: 'GRObject class' -> #icon;
	add: 'GRPackage class' -> #seasideDolphinCore;
	add: 'WAObject class' -> #icon;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: '..\..\Dolphin Blog\Internal Bitmaps and Icons';
	add: 'Seaside-Core';
	yourself).

package!

"Class Definitions"!

Object subclass: #SeasideIcons
	instanceVariableNames: ''
	classVariableNames: 'Icons'
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!Array methodsFor!

restoreFromSnapshot: anArray
	
	#eamAdded.
	anArray keysAndValuesDo: [:eachKey :eachValue | self at: eachKey put: eachValue ]
	
! !
!Array categoriesFor: #restoreFromSnapshot:!public! !

!Bag methodsFor!

restoreFromSnapshot: anObject
	self elements: anObject elements!

snapshotCopy
	^ self copy! !
!Bag categoriesFor: #restoreFromSnapshot:!*seaside-squeak-platform!public! !
!Bag categoriesFor: #snapshotCopy!*seaside-squeak-platform!public! !

!BlockClosure methodsFor!

renderOn: aRenderer
	self numArgs = 0
		ifTrue: [ self value ]
		ifFalse: [ self value: aRenderer ]! !
!BlockClosure categoriesFor: #renderOn:!*seaside-pharo-core!public! !

!Dictionary methodsFor!

restoreFromSnapshot: aDictionary

	self removeAllKeys: self keys.
	aDictionary keysAndValuesDo: [:eachKey :eachValue  | self at: eachKey put: eachValue]!

snapshotCopy

	| copy |
	copy := self copyEmpty.
	self associationsDo: [:each | copy uncheckedAdd: each copy].
	^copy! !
!Dictionary categoriesFor: #restoreFromSnapshot:!public! !
!Dictionary categoriesFor: #snapshotCopy!public! !

!GRObject class methodsFor!

icon
	^SeasideIcons pharo! !
!GRObject class categoriesFor: #icon!public! !

!GRPackage class methodsFor!

seasideDolphinCore
	^(self new)
		name: 'Seaside-Dolphin-Core';
		addDependency: 'Seaside-Core';
		addDependency: 'Grease-Dolphin-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideDolphinCore!*seaside-pharo-core!public! !

!LookupTable methodsFor!

snapshotCopy

	^self copy! !
!LookupTable categoriesFor: #snapshotCopy!public! !

!MessageSend methodsFor!

renderOn: html
	self value: html! !
!MessageSend categoriesFor: #renderOn:!*seaside-pharo-core!public! !

!Object methodsFor!

restoreFromSnapshot: anObject
	self copyFrom: anObject!

snapshotCopy
	^ self shallowCopy! !
!Object categoriesFor: #restoreFromSnapshot:!*seaside-squeak-platform!public! !
!Object categoriesFor: #snapshotCopy!*seaside-squeak-platform!public! !

!OrderedCollection methodsFor!

restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy!

snapshotCopy
	^ self copy! !
!OrderedCollection categoriesFor: #restoreFromSnapshot:!*seaside-squeak-platform!public! !
!OrderedCollection categoriesFor: #snapshotCopy!*seaside-squeak-platform!public! !

!PositionableStream methodsFor!

seasideMimeDocument
	^ self contents seasideMimeDocument!

seasideMimeDocumentType: aMimetype
	^self seasideMimeDocument mimeType: aMimetype; yourself! !
!PositionableStream categoriesFor: #seasideMimeDocument!*seaside-pharo-core!public! !
!PositionableStream categoriesFor: #seasideMimeDocumentType:!*seaside-pharo-core!public! !

!SequenceableCollection methodsFor!

restoreFromSnapshot: aCollection

	#eamAdded.
	self removeAll.
	self addAll: aCollection
	
! !
!SequenceableCollection categoriesFor: #restoreFromSnapshot:!public! !

!Set methodsFor!

restoreFromSnapshot: anObject
	self elements: anObject elements!

snapshotCopy
	^ self copy! !
!Set categoriesFor: #restoreFromSnapshot:!*seaside-squeak-platform!public! !
!Set categoriesFor: #snapshotCopy!*seaside-squeak-platform!public! !

!WAObject class methodsFor!

icon
	(self name beginsWith: 'SU') ifTrue: [^SeasideIcons scriptaculous].
	(self name beginsWith: 'JQ') ifTrue: [^SeasideIcons jQuery].
	^SeasideIcons seaside! !
!WAObject class categoriesFor: #icon!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

SeasideIcons guid: (GUID fromString: '{3D5FF56F-618D-4B85-8947-604E7F1C4C6A}')!
SeasideIcons comment: ''!
!SeasideIcons categoriesForClass!Kernel-Objects! !
!SeasideIcons class methodsFor!

icon
	^self seaside!

icons
	^Icons ifNil: [Icons := LookupTable new]!

jQuery
	^self icons at: #jQuery ifAbsentPut: [self jQueryResource]!

jQueryResource
	"Private - Generated from:
	self createIconMethodOfSize: 48@48 fromFile: 'jquery.png'.
	"
	^InternalIcon fromBytes: #[137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 48 0 0 0 48 8 6 0 0 0 87 2 249 135 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 9 112 72 89 115 0 0 14 194 0 0 14 194 1 21 40 74 128 0 0 20 204 73 68 65 84 104 67 213 90 247 119 147 103 154 157 159 38 216 146 139 108 201 69 110 114 147 187 229 94 36 119 203 189 97 32 6 76 47 166 247 222 67 232 4 76 39 244 50 180 64 40 33 132 26 8 153 76 218 108 72 159 100 72 159 204 100 103 219 63 241 236 189 207 39 25 123 179 123 118 206 217 159 150 115 222 163 194 167 239 123 159 118 239 125 158 215 191 49 199 184 36 56 46 95 130 227 243 37 40 62 239 31 90 230 152 92 9 178 231 72 48 22 95 205 190 21 132 239 131 227 92 122 15 190 14 188 199 189 67 18 10 36 216 81 104 188 250 158 53 248 154 127 228 217 252 29 247 202 61 155 236 174 158 223 240 95 80 28 30 150 80 36 33 14 174 66 188 55 30 240 108 225 115 2 191 247 45 62 60 22 134 198 224 119 3 198 23 248 54 134 107 226 141 223 243 126 161 73 101 18 154 234 17 75 122 181 132 101 214 72 120 6 94 157 30 9 77 46 49 174 193 179 185 134 62 111 240 179 125 239 19 240 138 125 241 158 220 43 247 108 138 243 27 64 111 233 230 139 37 148 175 216 64 8 172 212 197 135 112 67 248 81 112 60 23 60 200 104 233 194 117 252 236 40 193 70 75 117 241 30 254 107 184 249 176 244 26 177 186 154 197 86 216 33 17 69 157 18 145 223 42 225 89 117 98 73 117 27 247 129 35 184 140 103 241 126 255 195 162 83 225 64 189 63 246 200 104 13 53 192 127 1 55 59 228 198 207 110 62 244 123 159 135 147 203 177 153 10 177 56 177 176 41 245 142 110 42 23 159 61 186 249 40 247 243 98 175 30 39 246 170 113 18 85 54 74 172 185 77 250 127 188 38 40 26 41 136 197 247 255 171 17 234 72 35 67 126 109 128 230 22 211 2 249 203 252 102 46 199 186 112 83 46 195 8 227 123 62 204 5 111 151 192 187 85 98 195 102 108 121 45 216 84 3 210 163 74 83 80 175 193 10 67 186 68 150 141 144 184 166 25 146 208 54 7 175 51 213 8 91 94 171 88 82 96 44 174 9 138 202 194 202 30 100 128 47 242 254 12 24 252 58 16 29 238 21 245 101 207 246 215 0 139 141 69 71 3 6 109 30 97 50 82 136 55 133 97 209 217 88 89 250 227 240 244 74 137 40 108 19 123 197 24 172 209 18 85 210 37 214 236 90 173 3 51 174 161 87 173 217 245 18 83 51 94 146 71 173 144 148 209 171 37 177 123 169 196 53 76 197 239 58 212 0 222 203 28 145 46 230 200 204 255 98 128 81 23 67 215 160 20 211 12 129 131 253 6 60 11 159 175 168 20 49 10 37 52 17 53 129 197 247 188 198 28 153 33 230 168 76 205 211 136 188 38 108 174 87 28 29 115 37 161 101 134 196 84 141 17 107 78 189 58 193 196 77 193 171 54 164 79 66 83 159 164 79 222 44 25 211 118 136 115 252 70 189 62 10 81 97 10 241 186 64 107 42 94 211 254 111 6 152 25 114 108 42 52 17 197 136 156 14 75 171 208 244 96 74 88 156 110 124 143 188 198 53 166 8 24 0 207 134 38 151 73 180 103 148 56 58 231 137 115 194 11 240 48 60 91 63 81 35 16 100 207 146 192 240 20 24 155 5 35 91 196 209 58 91 50 250 94 146 236 5 135 37 107 246 62 73 237 93 167 81 225 253 3 195 83 37 32 212 33 129 97 73 248 29 211 136 17 103 17 251 193 195 120 29 168 189 65 233 52 36 2 38 96 120 136 47 167 173 57 141 18 81 208 166 233 97 203 107 214 60 14 77 42 214 141 169 1 120 8 225 48 174 113 170 164 142 91 39 89 115 247 193 136 13 18 223 52 77 194 51 171 176 241 116 9 176 36 106 180 52 2 173 179 36 99 198 46 113 45 59 41 174 229 167 96 196 30 113 180 207 5 26 53 107 250 208 0 46 115 84 134 81 119 190 84 30 242 170 160 128 52 215 154 52 106 228 87 6 88 210 144 211 216 56 115 58 166 118 60 80 163 87 34 75 71 72 56 242 56 4 105 196 60 53 97 83 65 128 48 107 65 43 242 121 161 100 206 218 37 121 43 79 75 198 244 237 216 232 12 68 14 105 129 148 24 22 146 160 233 17 158 237 149 216 134 105 146 54 101 171 228 173 56 35 133 47 92 150 130 53 191 147 52 24 28 83 53 86 189 29 24 158 44 195 66 113 189 205 169 70 152 225 168 160 24 212 154 111 145 32 13 64 49 214 127 107 128 25 86 91 17 238 152 218 137 146 56 124 49 214 66 137 107 238 147 168 242 145 234 109 146 12 243 212 28 157 9 82 114 75 52 96 209 9 239 187 150 30 149 162 141 87 36 123 118 63 188 58 219 48 0 27 81 3 108 105 154 231 188 54 233 249 229 146 187 228 168 148 108 185 46 229 187 110 75 222 178 163 146 130 239 232 48 194 98 0 140 14 8 77 68 228 16 13 68 47 48 44 89 211 80 235 3 247 97 221 145 237 21 158 193 69 33 36 93 229 33 31 145 5 131 128 162 225 249 164 17 75 225 77 20 27 242 218 209 53 15 16 56 92 66 193 154 244 2 55 198 58 32 147 198 214 78 64 81 110 147 130 181 231 164 116 199 235 146 187 240 160 36 13 159 143 255 171 28 72 11 147 213 169 36 103 117 53 2 62 167 73 230 236 93 82 188 233 138 84 30 122 75 74 183 94 151 156 249 251 197 1 104 141 40 108 151 96 212 158 201 134 116 66 45 12 99 74 89 96 64 24 13 64 84 16 73 149 44 76 29 144 88 8 153 157 132 73 222 138 43 48 96 52 44 163 22 41 128 98 195 230 153 18 153 115 118 75 226 200 69 90 7 100 189 64 220 132 6 48 47 173 57 94 228 255 52 201 158 211 175 27 114 239 189 143 244 56 6 143 46 17 91 118 157 66 109 160 37 73 76 40 80 115 4 16 11 15 139 40 233 68 241 174 146 130 213 167 164 234 208 35 169 56 240 72 163 145 61 103 175 36 118 45 208 84 13 5 172 170 190 33 210 33 93 205 228 7 214 38 158 73 112 33 73 134 1 186 185 148 48 41 121 28 62 3 34 75 134 75 234 152 53 226 66 152 139 55 95 149 28 122 116 212 98 20 97 163 230 95 0 67 138 112 178 136 108 185 94 45 216 220 249 123 165 108 251 13 169 126 249 109 41 90 143 188 30 191 70 34 11 91 213 235 244 190 9 30 52 133 193 8 160 22 235 43 174 97 138 100 76 221 34 37 27 47 137 187 255 142 120 96 120 233 214 27 120 230 17 73 155 248 130 214 144 29 80 28 9 62 177 17 68 242 9 36 237 18 89 220 133 239 186 193 51 221 250 222 134 226 39 176 12 49 32 174 126 178 100 206 216 41 69 27 46 73 217 238 59 200 237 35 146 140 8 16 22 233 13 133 58 228 36 141 177 194 203 113 13 147 97 192 30 113 239 188 41 117 39 223 151 178 109 87 37 123 230 118 229 130 48 108 150 204 74 3 2 66 144 207 136 68 80 108 190 230 187 163 109 54 174 123 9 207 185 0 35 238 74 229 193 183 80 19 111 232 231 236 121 123 37 109 210 70 64 242 114 73 232 88 128 107 231 41 123 39 0 177 226 91 102 225 153 211 36 166 122 188 26 24 158 85 139 218 25 84 3 73 221 139 181 32 203 144 207 158 253 143 36 111 249 49 212 195 66 229 1 133 58 20 165 98 59 188 25 6 85 25 83 59 78 114 230 236 18 207 75 55 197 251 187 143 164 114 223 61 201 71 97 146 164 108 64 40 138 57 94 63 44 56 126 0 145 152 183 244 104 66 235 76 56 107 7 54 125 17 6 60 146 170 163 127 144 202 195 111 75 217 75 111 72 33 28 152 187 244 4 82 120 63 160 183 95 210 167 237 84 4 35 119 112 143 76 93 146 96 56 129 101 48 19 167 130 33 11 214 93 16 207 190 55 165 10 41 145 191 242 56 34 224 51 0 57 25 16 66 178 73 86 30 80 18 115 143 144 204 105 155 164 124 251 85 105 56 255 137 212 157 120 79 202 80 152 25 83 183 74 108 221 4 141 2 107 96 88 80 156 46 190 167 180 160 124 160 17 14 24 145 49 5 207 92 121 76 74 54 95 134 227 110 74 233 246 155 82 244 226 85 201 95 123 17 70 156 148 156 5 47 75 214 172 61 106 64 74 207 74 229 19 2 13 117 23 145 144 196 135 122 49 138 152 68 195 162 170 122 249 29 169 61 241 174 20 174 57 137 162 92 44 214 172 26 213 43 132 56 3 21 80 7 148 17 5 45 146 214 187 18 249 124 94 35 208 112 254 83 169 62 252 123 20 233 25 252 110 153 68 21 119 104 49 43 52 6 197 139 201 130 232 89 211 180 40 25 137 200 252 22 137 175 31 47 169 61 75 37 179 111 171 228 46 58 4 32 56 5 0 57 11 178 59 45 57 139 142 74 22 162 144 62 117 187 164 160 54 19 144 122 49 149 99 13 98 77 163 96 44 82 190 24 48 32 123 254 1 197 231 154 19 31 72 221 233 15 165 120 253 89 113 142 89 142 130 109 208 194 101 58 208 139 68 23 162 3 83 43 169 107 142 20 44 63 34 181 199 223 149 198 87 190 18 239 133 47 164 2 17 204 153 187 87 18 154 167 67 130 0 126 81 63 129 161 64 36 24 160 11 247 32 193 177 9 178 164 148 43 27 251 245 84 234 216 181 146 54 121 139 110 90 189 222 187 30 100 185 196 151 54 221 90 123 170 203 40 169 177 39 18 157 201 47 230 114 129 4 158 189 15 164 254 204 19 241 158 251 88 74 55 93 146 244 9 107 129 42 109 74 26 36 19 62 156 30 37 156 134 64 90 196 214 141 151 172 190 109 226 134 225 94 68 160 249 234 83 141 68 249 214 107 146 53 125 43 54 54 78 209 130 169 67 35 2 130 19 6 106 66 29 1 201 65 157 195 107 152 86 118 120 56 182 126 10 54 220 135 53 29 191 159 160 68 202 126 130 253 6 9 143 124 68 40 39 7 104 231 232 135 81 215 146 99 82 129 226 245 158 251 84 26 47 125 46 238 29 215 177 137 45 98 135 96 35 155 146 9 77 136 2 139 153 100 99 70 1 69 20 119 2 49 150 105 218 84 31 125 7 6 124 45 109 175 125 39 245 39 222 87 168 164 62 50 140 168 209 223 83 176 105 81 7 163 46 240 74 198 165 236 80 172 7 65 89 156 149 40 206 58 200 143 6 120 187 65 127 199 92 231 198 201 192 218 131 83 11 33 10 140 94 24 68 166 197 89 102 212 64 238 194 35 8 255 67 120 240 115 105 126 245 107 169 220 123 23 48 185 79 177 155 122 134 77 14 139 88 55 64 72 69 97 91 128 4 177 245 147 64 126 219 192 7 215 165 225 220 19 233 188 253 23 105 189 254 13 234 232 125 32 202 69 195 8 232 42 146 15 33 152 27 102 58 146 87 148 91 124 169 105 10 119 162 190 210 6 22 163 204 122 51 164 4 216 24 10 32 4 138 152 82 133 169 100 3 153 146 52 1 243 134 1 57 243 14 74 5 136 165 241 194 103 240 226 183 82 123 236 29 20 242 25 64 233 18 120 186 75 219 68 53 128 168 66 72 5 237 7 195 107 36 28 98 123 238 130 3 248 253 93 105 185 250 103 105 187 245 147 180 248 140 96 36 178 250 12 161 23 85 218 173 94 165 183 9 199 129 72 75 53 6 14 225 125 159 51 197 200 111 3 237 186 158 51 199 24 207 1 33 82 66 132 101 214 106 196 163 33 0 237 88 81 238 145 32 180 38 164 87 147 97 64 214 204 221 226 217 117 75 33 177 253 214 15 120 125 34 229 59 110 160 160 152 203 19 52 188 170 50 53 5 120 99 10 59 32 10 96 145 236 152 210 179 66 10 86 157 210 130 110 190 246 84 218 223 248 73 90 111 124 11 146 251 0 80 123 3 6 238 151 212 209 171 36 206 59 85 175 15 199 134 66 32 15 88 140 148 14 84 164 106 136 143 55 2 40 69 216 56 225 26 107 110 35 54 221 43 241 128 81 7 138 154 196 198 168 90 11 154 177 124 6 164 79 126 81 202 182 188 42 222 179 127 196 195 127 148 150 107 127 150 234 35 111 67 195 31 87 173 66 236 53 24 25 176 72 78 240 133 219 104 110 202 193 144 189 42 7 74 54 190 130 244 121 15 191 127 42 29 119 254 138 104 252 136 154 250 66 25 183 8 60 147 53 115 23 248 5 200 130 212 139 42 29 174 40 199 198 198 146 2 129 70 132 225 68 4 125 9 29 70 17 24 237 30 37 241 80 197 201 61 171 196 57 105 179 164 1 161 146 158 95 41 177 94 164 118 94 131 88 92 94 35 2 41 61 203 164 104 237 25 60 252 29 53 128 30 244 34 157 202 182 191 166 237 32 61 192 208 7 50 55 137 68 208 56 129 132 69 132 56 200 78 121 1 221 15 57 66 41 80 180 238 44 4 219 67 105 186 252 165 180 190 254 131 180 189 254 147 52 189 250 20 247 254 80 60 187 111 75 17 82 51 23 178 129 68 70 168 78 238 158 47 137 29 240 110 107 159 177 218 103 169 178 77 29 179 66 210 113 191 140 190 29 232 59 250 181 41 74 157 184 9 50 99 190 68 121 122 36 20 93 99 176 211 99 24 144 208 54 83 92 139 15 72 213 193 7 210 118 243 59 233 188 255 139 180 188 246 189 212 128 230 243 32 49 18 135 47 208 169 3 243 145 5 71 157 67 104 84 118 70 46 83 58 88 115 26 16 218 9 16 117 107 193 176 199 165 114 255 125 160 218 39 168 135 239 96 8 234 226 218 55 90 99 181 64 172 202 61 119 193 220 87 149 111 200 198 121 75 14 131 204 14 98 29 192 62 64 106 203 142 72 62 82 146 8 151 183 10 196 182 240 48 100 197 54 73 68 77 218 145 210 132 214 32 206 169 252 48 106 175 30 43 153 192 110 230 61 81 168 235 193 223 97 196 63 75 211 43 95 32 135 175 131 45 183 169 254 81 13 2 143 251 73 205 47 155 105 4 145 138 161 183 87 244 128 141 151 138 11 236 202 8 214 160 46 52 26 55 190 81 231 16 165 154 175 252 73 26 46 124 170 164 89 125 12 90 232 208 99 213 96 158 253 15 177 222 212 229 222 247 0 250 232 150 20 18 8 230 238 65 26 45 67 151 56 86 107 34 36 177 20 53 50 136 137 35 32 131 25 178 162 245 231 148 200 218 239 252 44 93 111 254 139 180 35 5 106 143 255 65 138 55 156 23 231 68 54 227 99 53 103 169 243 89 104 42 242 240 234 143 4 141 32 49 49 119 19 59 230 169 124 206 135 48 44 219 246 170 84 29 120 0 205 244 46 234 236 35 200 143 143 117 213 159 249 72 106 78 126 8 65 247 158 84 28 250 189 26 225 238 191 167 162 178 232 197 203 144 23 16 118 51 119 2 13 23 163 206 198 2 210 235 180 191 8 178 27 197 143 20 246 55 52 85 154 123 46 132 177 234 229 199 8 251 83 141 64 215 189 95 16 145 175 160 115 222 210 102 36 5 70 70 129 220 136 14 20 118 106 132 111 13 54 130 179 80 27 70 136 177 152 62 36 33 253 152 239 46 164 71 49 250 6 162 146 27 181 80 1 230 167 244 112 239 125 83 202 177 233 210 29 183 208 32 93 211 46 143 61 2 229 125 234 216 213 58 178 137 46 135 2 133 132 14 113 96 34 7 228 34 120 80 210 12 104 33 54 7 68 146 244 41 155 164 116 219 53 120 233 159 224 253 31 101 56 162 208 169 70 124 173 157 148 11 185 154 56 194 232 212 252 70 104 239 234 91 154 90 108 102 56 189 208 73 71 153 132 163 54 56 90 100 143 157 12 161 71 80 200 66 15 157 187 224 16 242 253 8 100 252 49 244 203 71 132 122 44 163 15 155 30 7 13 212 57 95 161 146 18 131 105 73 1 105 134 250 212 129 25 39 135 232 47 184 158 77 167 241 48 54 28 252 33 251 91 207 158 59 42 41 24 129 238 71 255 174 70 52 162 30 220 224 138 220 133 7 212 8 234 20 118 90 148 2 68 35 63 196 146 128 184 180 57 7 225 81 6 132 64 18 128 116 84 203 115 99 241 77 211 65 128 115 33 8 23 0 32 22 41 84 59 218 49 122 196 168 38 186 114 140 14 128 41 6 233 109 19 32 91 27 123 78 4 1 22 161 73 229 128 110 72 12 242 136 163 216 72 33 206 112 152 219 49 248 113 202 152 213 24 125 156 6 15 60 70 209 125 47 195 31 253 155 116 191 245 31 128 214 191 32 111 159 24 70 44 62 12 111 46 215 22 144 77 62 7 82 126 35 148 140 200 216 212 59 148 225 148 3 32 37 78 178 57 173 166 209 156 78 179 24 35 32 171 153 106 54 190 194 64 166 137 234 31 162 29 166 32 58 157 64 138 114 126 74 13 196 222 157 90 41 12 154 41 4 122 40 56 217 167 133 84 226 66 52 25 80 56 17 19 135 45 82 186 229 138 34 69 59 8 105 56 162 192 116 162 17 13 136 12 81 34 111 197 113 140 86 214 160 141 236 197 131 57 82 44 48 70 133 212 57 44 236 65 169 245 76 243 24 90 136 172 174 10 151 195 130 65 75 245 15 127 79 195 201 198 132 104 8 71 157 195 162 211 99 42 114 0 96 245 69 8 81 50 34 192 155 176 195 97 133 91 115 155 53 156 57 243 246 72 5 82 169 225 226 103 96 213 159 17 5 24 1 67 104 80 227 165 47 129 243 15 148 252 50 166 110 214 235 163 221 61 234 85 134 87 243 147 69 134 13 168 112 99 90 49 42 38 232 156 192 40 232 29 223 10 192 171 174 104 124 23 13 61 100 215 235 216 60 5 227 30 108 95 163 74 187 84 186 179 134 226 90 48 221 198 152 222 134 218 24 26 1 29 101 176 240 48 249 2 198 70 149 141 212 121 39 33 144 132 68 62 32 185 49 149 152 82 29 183 255 138 239 190 148 26 200 13 70 138 117 227 68 241 177 115 138 246 140 86 162 9 245 107 120 228 174 170 80 212 4 165 244 115 102 138 53 44 53 134 155 230 130 120 195 198 169 135 232 76 74 10 202 23 234 48 78 0 147 199 172 148 100 104 41 214 75 44 50 132 105 55 180 6 248 16 226 170 78 159 179 145 167 213 104 48 198 136 19 48 86 184 234 36 24 250 161 180 0 78 59 239 34 157 30 254 235 0 58 181 130 173 153 102 21 104 206 139 54 94 86 36 73 233 93 171 158 98 184 181 5 68 248 121 156 196 230 133 131 49 22 227 224 101 12 117 225 56 32 13 53 17 39 220 84 155 14 240 136 115 194 70 52 248 123 49 20 67 111 140 110 141 141 61 83 150 210 101 8 10 209 243 102 244 176 218 184 192 8 194 22 11 138 243 75 103 239 106 68 226 168 78 30 216 113 81 46 179 30 186 31 251 162 1 163 216 204 212 158 250 0 248 126 71 10 215 157 131 33 251 84 220 81 184 57 218 48 18 105 156 164 48 77 150 142 198 230 162 128 235 92 124 207 239 216 86 198 163 247 72 68 155 74 66 205 152 182 25 77 61 100 5 196 36 27 252 140 153 253 122 190 16 87 55 73 209 146 195 1 238 215 20 233 59 224 48 107 143 137 197 147 70 14 88 137 26 218 238 213 40 3 242 166 121 152 21 185 119 191 33 245 103 159 64 160 253 0 35 254 62 144 82 157 247 255 38 173 144 9 172 151 26 72 3 194 112 233 38 12 114 65 126 212 54 217 24 193 176 241 73 159 188 73 13 115 142 95 175 139 239 201 61 153 16 108 57 16 120 121 112 84 33 200 142 191 45 193 128 77 199 44 75 0 22 136 68 124 243 12 137 196 230 195 112 148 69 192 240 13 155 125 39 52 60 228 27 56 98 66 36 208 175 154 176 72 70 28 145 240 44 32 9 53 145 3 14 224 52 142 26 134 146 187 3 29 88 231 221 191 65 59 253 162 139 239 41 161 217 208 176 110 234 33 27 170 33 8 137 90 229 136 14 231 168 37 152 198 113 250 199 197 247 252 174 124 247 93 149 17 85 16 122 212 78 53 104 168 56 248 42 88 119 94 201 141 35 149 72 20 46 37 55 29 77 22 254 181 1 254 163 85 82 53 83 9 56 204 129 43 49 158 28 193 144 59 58 231 194 147 91 165 112 237 105 141 6 71 48 36 188 214 27 80 176 212 79 16 129 212 80 92 148 34 237 183 127 70 100 190 151 38 244 7 13 151 255 36 222 139 159 75 61 20 106 221 217 143 165 238 204 199 82 59 176 62 145 154 211 79 116 42 82 133 225 111 57 230 68 249 208 65 212 82 28 0 71 97 244 169 158 215 12 49 82 125 136 148 208 67 105 118 250 60 198 228 97 158 94 136 139 124 231 87 60 15 214 49 8 36 68 172 119 146 106 162 236 185 253 16 127 231 145 46 247 32 210 62 80 84 106 67 81 119 96 211 170 163 104 12 94 59 192 226 132 222 54 112 72 43 228 9 101 122 51 12 110 190 250 173 52 94 121 42 222 75 95 73 221 185 207 164 154 253 2 244 17 155 34 182 168 172 189 120 48 51 61 111 164 13 246 133 166 74 207 233 80 248 67 6 91 52 128 99 138 161 103 196 60 17 65 113 107 52 140 137 49 15 151 45 104 36 56 109 102 167 228 28 183 1 16 122 68 138 113 70 224 217 115 31 161 127 79 217 154 233 67 212 106 133 231 41 159 7 47 118 107 205 232 157 155 24 145 243 232 15 78 253 17 74 244 177 78 230 242 80 180 233 147 208 180 96 114 199 142 45 28 145 231 116 90 55 141 180 97 4 252 39 166 67 15 249 56 107 97 59 199 67 61 158 174 115 49 34 131 162 161 70 176 184 145 82 126 181 201 179 174 196 174 69 122 158 192 67 142 124 108 160 24 40 84 134 113 161 7 163 153 10 200 142 202 61 183 177 238 96 210 113 79 87 5 62 123 118 223 82 85 90 2 201 204 225 1 39 115 60 111 72 30 185 20 164 229 67 26 159 215 21 84 124 158 215 81 187 255 48 222 248 51 6 163 136 245 180 92 255 212 128 125 41 79 195 141 191 103 208 83 16 69 39 157 67 26 167 143 156 221 43 225 225 156 24 40 101 43 192 80 10 199 172 241 152 30 83 156 165 142 94 41 25 19 55 232 92 41 103 214 78 201 157 187 27 45 100 191 184 48 142 103 43 153 131 207 217 179 118 40 84 58 199 175 211 230 135 80 75 145 103 52 252 208 57 184 183 22 43 143 181 252 105 204 161 150 254 249 2 247 136 211 122 238 217 111 0 15 22 130 244 20 220 56 1 215 67 100 223 153 148 158 166 251 9 136 117 225 51 68 53 12 137 15 196 100 144 144 91 53 17 113 154 5 207 238 137 131 222 120 140 226 19 26 167 104 62 115 206 20 139 211 76 254 159 142 70 144 223 60 131 211 83 123 61 32 231 81 46 15 19 161 169 248 28 62 143 18 154 57 31 139 35 38 95 173 114 175 67 254 216 131 186 218 132 227 26 30 217 240 239 15 104 25 15 145 253 139 51 72 54 15 3 11 157 16 187 33 255 103 254 206 2 101 104 201 240 246 224 0 176 39 178 108 100 15 148 106 143 189 118 92 79 156 119 98 79 92 211 20 99 121 167 244 216 241 153 255 199 107 172 5 29 61 150 108 47 126 235 233 97 127 59 240 28 220 123 216 224 231 241 249 92 186 55 238 145 215 186 122 134 217 179 226 52 133 254 191 255 251 79 46 234 196 88 242 246 119 80 0 0 0 0 73 69 78 68 174 66 96 130]!

pharo
	^self icons at: #pharo ifAbsentPut: [self pharoResource]!

pharoResource
	"Generated from:
	self createIconMethodOfSize: 48@48 fromFile: 'pharo.png'.
	"
	^InternalIcon fromBytes: #[137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 48 0 0 0 48 8 6 0 0 0 87 2 249 135 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 9 112 72 89 115 0 0 14 194 0 0 14 194 1 21 40 74 128 0 0 12 87 73 68 65 84 104 67 205 89 235 87 83 247 154 238 204 247 249 112 62 204 120 230 140 61 51 218 165 130 160 168 109 21 244 180 182 245 130 29 111 173 178 67 61 162 199 138 30 17 17 2 202 77 132 144 130 23 8 9 129 144 144 11 144 144 4 146 189 119 194 53 36 33 225 146 16 216 225 18 136 9 87 81 176 133 105 103 214 172 53 179 102 254 0 247 51 59 218 89 211 117 102 230 67 63 156 164 89 235 89 251 75 214 111 63 207 239 125 127 207 239 125 223 253 206 59 81 248 213 154 61 68 173 217 75 214 154 60 172 176 173 15 69 77 70 228 212 202 145 95 223 134 66 185 9 15 212 61 40 85 247 82 165 234 46 222 59 192 95 68 129 210 207 123 133 76 111 35 100 198 126 178 81 223 207 54 27 105 168 58 244 104 237 84 161 197 216 10 141 94 7 181 206 0 173 201 194 152 123 93 18 79 240 59 194 23 122 149 236 157 126 241 238 207 123 203 159 241 223 42 109 7 161 105 51 145 154 182 78 214 66 25 49 52 208 142 57 111 27 252 78 13 60 221 74 12 118 42 224 238 37 55 70 134 71 25 111 112 157 26 11 190 202 247 204 190 74 193 47 37 26 122 149 138 48 170 84 164 65 165 98 199 122 90 241 45 163 5 187 166 199 127 206 170 241 195 80 3 158 91 106 16 114 118 98 106 204 203 122 231 214 217 177 185 87 164 39 184 206 139 169 128 201 208 230 86 95 224 85 242 196 220 90 90 175 217 42 54 43 84 140 177 78 194 14 107 196 88 34 69 248 15 103 13 190 183 84 99 85 39 64 80 254 0 126 163 18 163 253 118 216 199 22 224 240 45 82 54 95 56 182 2 34 228 125 193 87 252 177 217 53 210 110 177 51 22 153 122 163 163 242 27 12 62 126 136 217 186 34 124 43 227 99 185 46 15 193 234 28 48 21 119 48 36 21 193 166 167 64 219 167 65 15 76 83 164 109 42 214 2 214 9 223 220 154 217 55 187 246 122 176 199 205 246 52 170 209 121 175 24 182 252 28 248 242 174 35 116 55 29 211 119 46 193 151 245 123 12 253 49 3 125 15 203 65 54 182 65 75 142 114 240 80 173 228 112 108 5 184 152 21 98 200 191 76 186 153 101 182 223 216 13 74 248 4 237 87 174 192 146 65 192 113 249 60 188 151 82 49 252 213 41 56 121 159 163 63 237 31 65 231 229 193 88 35 71 75 135 59 2 74 109 112 197 86 128 109 56 76 244 143 134 200 190 145 16 107 105 54 192 152 119 15 173 167 142 195 144 122 20 244 201 35 232 59 121 8 221 39 14 193 122 236 16 104 14 29 215 175 67 43 172 131 74 103 231 224 164 154 117 182 216 10 160 29 1 194 226 156 33 41 199 12 219 33 82 160 237 234 53 40 15 236 134 102 127 28 180 7 226 160 63 176 139 195 78 232 247 71 176 3 109 68 26 212 37 85 80 180 244 113 176 81 77 234 222 232 11 24 13 173 114 206 179 154 60 198 57 15 109 159 20 235 233 17 166 165 195 197 170 5 34 40 190 186 12 217 129 68 40 246 199 67 115 32 158 19 177 11 173 251 118 64 189 231 61 40 19 183 65 113 246 44 100 185 37 144 214 27 161 80 88 24 173 193 33 113 249 22 9 151 111 41 217 233 157 143 206 165 22 33 239 11 188 228 123 103 86 73 218 198 48 26 189 125 67 34 35 33 185 87 9 241 197 116 136 223 223 131 198 3 9 104 230 4 104 246 239 66 243 222 247 32 219 189 13 245 59 223 133 248 196 9 136 50 115 81 91 213 12 133 172 115 195 104 26 100 156 190 48 53 56 182 144 239 24 15 71 231 82 243 4 94 16 99 129 151 102 111 224 197 107 139 109 156 85 104 186 81 41 84 162 234 86 33 30 157 189 128 167 239 39 65 204 69 65 198 165 146 146 19 208 152 184 29 162 157 191 197 163 109 127 139 71 31 125 140 234 75 153 168 46 170 129 66 170 135 137 116 177 206 177 48 235 30 155 39 29 209 186 19 134 167 86 136 209 233 231 228 200 212 115 214 68 187 33 21 181 161 36 71 128 242 244 76 8 143 165 226 113 82 2 106 146 118 67 188 47 30 210 125 113 16 113 187 255 232 189 173 168 124 247 175 33 248 224 3 84 156 190 128 138 235 5 104 168 106 132 81 223 7 231 216 60 156 190 121 42 106 2 34 214 233 230 172 211 197 44 177 250 246 62 212 60 172 3 63 253 22 138 78 125 137 242 195 71 80 149 184 19 213 123 118 225 241 222 56 60 73 138 71 85 220 54 8 184 221 47 251 205 175 240 32 33 30 165 31 125 134 226 243 151 33 46 172 130 190 133 230 4 132 223 8 176 121 162 116 43 115 37 0 225 28 95 224 66 190 192 182 42 205 168 202 41 67 214 167 231 192 79 62 138 210 125 251 32 140 219 142 202 221 59 80 153 184 11 130 189 187 241 112 231 63 160 244 183 91 80 244 55 127 133 251 219 255 30 247 146 246 35 255 200 49 60 205 186 7 173 220 0 135 55 204 149 21 209 20 224 9 167 216 199 185 67 199 213 50 109 45 22 191 164 82 186 33 200 46 69 57 239 26 202 62 75 69 105 210 94 148 236 73 68 73 98 60 138 119 239 194 253 248 93 200 143 143 67 94 92 28 10 127 247 9 202 191 248 10 213 55 248 168 47 171 217 212 169 72 191 195 19 166 7 198 194 5 220 51 58 135 184 155 179 187 136 99 56 152 69 194 208 225 144 168 85 22 70 222 104 100 107 238 11 81 78 92 5 255 224 17 240 247 189 143 188 132 68 228 237 220 129 187 123 146 144 253 254 97 220 58 124 12 197 188 175 241 56 95 0 133 184 13 154 166 14 191 94 111 171 143 228 126 100 189 200 186 127 198 106 255 79 150 230 106 248 72 25 76 58 2 60 235 80 136 180 184 131 172 162 209 0 1 231 68 89 31 165 34 43 66 56 97 47 110 109 223 142 155 251 14 226 250 199 167 113 237 204 31 80 194 175 130 84 102 2 233 152 225 16 160 76 125 211 233 220 58 127 25 179 14 77 219 229 35 180 221 126 82 219 53 193 138 106 219 80 116 179 8 215 63 57 135 91 159 157 195 157 227 220 185 72 61 143 226 175 50 81 158 85 140 234 210 90 212 213 104 54 149 45 221 126 179 35 64 155 6 102 10 72 199 108 116 210 230 255 11 173 84 235 34 26 245 110 178 161 221 197 86 86 169 144 155 89 140 203 199 211 112 243 139 175 145 123 37 23 37 119 30 226 169 64 138 102 46 58 166 78 59 231 251 78 191 201 50 82 31 137 92 132 188 169 123 58 138 105 243 127 168 168 150 117 17 213 242 30 178 186 169 155 45 44 107 194 205 175 75 64 164 94 198 141 63 20 162 160 184 30 66 41 9 181 105 8 125 195 115 152 153 255 14 129 197 13 202 255 108 253 109 218 188 243 11 104 236 171 21 189 68 149 162 159 172 82 244 177 130 90 35 74 203 155 112 159 203 243 234 106 37 26 149 22 180 91 189 160 29 83 24 240 132 49 58 189 138 1 223 34 211 222 63 45 41 81 216 136 34 133 61 185 64 222 29 219 8 8 21 14 162 74 229 36 133 74 59 251 84 213 15 137 178 27 50 37 13 131 217 133 190 193 73 120 167 150 49 204 44 113 62 191 128 62 207 60 12 3 51 27 210 78 47 83 212 100 163 10 155 108 249 37 178 190 148 152 29 224 72 70 9 85 46 66 168 113 147 149 234 65 182 209 236 131 222 54 131 126 239 2 184 14 13 225 213 239 177 241 195 191 99 110 105 3 46 102 25 157 246 25 40 104 31 158 104 135 216 98 89 63 91 44 31 32 139 154 122 99 59 35 18 42 29 41 149 26 119 190 80 237 162 154 233 9 191 121 112 110 195 54 182 8 187 111 241 205 174 59 57 116 244 49 144 233 28 168 172 39 81 90 103 70 65 141 25 119 158 152 145 253 196 76 101 63 234 140 173 128 50 185 243 93 97 139 59 69 216 226 34 34 185 109 29 14 49 246 241 37 150 116 206 161 197 58 14 137 206 141 135 18 10 57 101 74 252 62 235 9 50 114 37 184 122 95 142 107 165 45 17 80 87 75 213 188 95 194 97 126 115 169 217 124 139 60 231 196 50 233 152 88 102 91 186 24 84 42 250 145 89 222 142 139 183 197 56 78 148 224 131 79 111 224 232 249 123 248 252 170 16 105 57 210 8 168 139 217 146 216 10 104 48 76 110 109 48 251 146 37 157 19 105 98 163 87 44 210 141 48 181 186 97 182 88 218 131 27 2 3 190 188 43 199 233 155 117 72 189 242 13 62 77 43 65 218 173 26 220 122 160 194 3 49 133 82 49 73 149 138 200 216 10 16 115 228 235 205 62 190 184 99 140 44 109 26 96 178 30 211 27 25 101 6 92 40 208 224 243 172 70 124 124 181 22 199 191 22 225 243 27 34 156 207 18 35 91 160 5 103 189 208 118 141 71 64 181 118 249 162 223 19 255 244 62 19 119 248 8 169 217 103 150 116 250 94 231 213 245 176 231 243 91 145 196 171 193 158 139 143 176 231 203 111 144 120 174 2 191 187 82 139 51 57 114 100 148 181 67 208 60 0 125 255 52 38 130 235 96 184 249 168 47 214 163 197 28 153 139 200 149 185 201 187 141 46 246 74 85 23 206 220 211 227 112 166 28 199 178 20 56 155 171 4 239 158 26 233 247 91 54 47 21 183 250 51 30 180 211 156 0 74 111 155 166 34 228 199 103 215 10 198 195 49 30 238 158 171 232 37 206 84 244 145 103 5 189 236 233 7 22 156 42 236 196 73 190 14 151 202 205 184 43 234 66 165 210 142 50 89 159 159 47 178 212 95 125 104 224 9 154 109 60 93 239 20 47 178 243 227 220 100 218 59 31 227 241 250 158 28 51 145 112 199 76 38 222 49 179 41 249 20 78 20 211 184 80 110 1 191 113 16 98 243 4 232 225 112 4 148 201 249 44 93 32 120 91 54 71 28 235 191 17 189 250 255 39 111 26 229 38 210 163 220 80 119 148 155 11 61 208 78 136 51 68 131 204 153 202 126 246 108 69 239 230 249 242 110 255 133 114 154 230 203 92 148 216 204 80 17 242 164 59 92 192 225 77 217 124 87 61 186 53 75 225 75 206 110 26 75 171 238 152 34 90 28 97 194 49 245 130 112 77 174 38 59 163 245 177 227 13 249 192 43 254 200 204 26 169 25 120 198 8 13 204 70 142 98 20 183 27 135 252 215 68 142 250 139 2 154 199 111 112 240 68 157 62 30 233 10 243 34 228 77 206 183 221 86 132 60 7 254 109 185 151 172 54 77 147 109 206 121 210 57 185 74 14 78 174 230 115 66 162 211 27 12 7 214 9 79 96 205 60 18 88 123 109 245 46 177 173 246 16 196 244 116 4 84 141 201 255 191 82 229 167 55 237 109 133 135 200 110 30 51 103 203 189 175 171 58 167 216 86 71 152 117 76 174 178 156 0 146 19 16 29 75 117 115 59 53 58 187 150 63 18 88 167 186 124 43 148 214 17 166 34 228 235 200 169 130 90 114 234 205 46 62 181 78 110 21 91 3 201 79 173 51 105 121 250 41 34 77 49 69 164 136 25 226 164 148 17 159 110 240 51 95 52 250 89 190 97 22 82 219 60 122 39 158 163 119 252 57 213 235 91 137 142 128 72 174 122 102 95 164 112 159 135 8 218 179 200 107 181 5 121 34 114 138 87 207 145 175 51 189 237 176 196 214 201 228 90 107 128 95 99 153 38 243 244 211 100 154 98 146 76 17 79 146 135 196 211 204 193 250 192 198 65 201 28 50 180 33 84 245 44 128 244 44 129 246 46 81 36 183 86 244 62 55 253 137 155 188 125 241 255 116 88 181 244 20 33 178 206 152 107 232 233 215 121 237 83 44 39 128 77 169 243 179 73 117 51 236 142 186 103 248 59 209 2 78 105 22 80 104 89 128 126 104 1 134 225 69 202 192 157 151 232 9 248 209 149 26 236 161 173 226 222 80 178 164 63 148 150 71 135 137 52 125 152 56 216 178 72 124 105 156 23 103 152 22 152 76 114 129 189 160 159 199 39 234 48 246 202 66 72 108 12 33 161 33 140 248 250 48 78 170 194 155 185 228 188 191 221 61 79 27 220 11 5 29 63 58 85 84 173 53 66 158 3 95 220 55 71 230 89 66 36 71 150 252 160 101 129 76 214 173 48 71 12 47 55 62 234 92 195 135 134 53 36 180 189 196 118 245 11 196 55 47 99 159 124 30 135 100 65 156 84 6 253 215 141 207 234 117 195 139 188 14 247 82 10 231 72 209 111 47 197 189 65 66 210 31 52 115 207 215 124 42 196 94 212 135 217 15 53 11 108 130 118 149 221 214 254 29 182 24 255 25 91 12 63 96 75 251 247 216 162 251 39 236 108 125 137 131 234 69 156 104 158 141 128 58 38 159 77 23 68 187 193 23 88 67 91 57 36 115 72 227 119 47 138 111 119 175 48 127 236 121 206 94 160 87 113 180 99 21 28 121 236 214 189 68 92 251 58 118 234 95 33 201 176 142 67 198 117 28 229 162 241 73 251 202 230 103 45 243 254 227 138 0 125 66 62 91 112 76 57 27 253 158 248 71 242 252 10 203 28 153 105 93 97 206 117 173 111 28 237 218 196 135 212 6 18 59 191 195 118 253 183 28 249 53 36 233 86 113 80 187 130 147 198 101 164 155 150 112 139 94 196 117 211 130 255 146 254 89 125 106 115 144 23 33 127 82 30 131 185 80 5 29 36 4 93 65 115 133 37 248 58 195 250 156 61 108 221 196 22 235 191 97 11 245 175 248 181 249 95 240 235 142 239 177 75 191 142 131 186 101 156 104 125 134 171 198 32 138 169 32 164 189 115 28 130 84 157 37 6 105 243 83 103 136 8 168 176 62 35 57 1 108 134 117 21 63 87 128 164 43 16 125 187 140 181 128 255 2 206 108 60 34 17 40 67 181 0 0 0 0 73 69 78 68 174 66 96 130]!

scriptaculous
	^self icons at: #scriptaculous ifAbsentPut: [self scriptaculousResource]!

scriptaculousResource
	"Private - Generated from:
	self createIconMethodOfSize: 48@48 fromFile: 'SU.png'.
	"
	^InternalIcon fromBytes: #[137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 48 0 0 0 48 8 6 0 0 0 87 2 249 135 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 9 112 72 89 115 0 0 14 194 0 0 14 194 1 21 40 74 128 0 0 15 5 73 68 65 84 104 67 237 88 103 87 27 89 182 173 159 56 221 19 122 166 231 117 156 238 118 187 157 19 237 108 12 24 155 140 77 48 96 114 206 57 137 40 64 9 33 16 34 231 156 51 6 12 56 237 217 247 74 37 74 18 120 60 243 225 205 122 107 189 210 218 171 170 206 189 247 156 125 194 13 37 229 81 218 31 240 127 25 138 127 250 23 240 197 31 40 115 226 81 218 23 110 120 246 211 246 57 9 194 89 125 84 125 206 251 105 54 61 101 143 216 71 197 167 250 159 225 192 191 54 240 57 36 254 55 250 40 143 51 190 132 47 190 160 204 9 255 244 47 221 240 236 167 237 115 226 240 89 125 84 125 206 251 105 54 61 101 254 236 163 226 83 253 149 199 153 127 132 55 2 50 191 132 138 199 25 108 119 33 128 125 85 60 102 31 129 160 236 191 32 56 231 111 8 201 251 6 145 133 255 64 76 217 5 36 84 94 67 106 221 93 228 52 5 160 72 31 118 38 242 91 158 177 79 16 178 26 252 145 92 251 59 226 43 174 32 170 248 23 132 21 124 39 117 170 188 180 124 180 28 196 179 226 45 248 119 223 159 229 126 141 136 194 31 17 83 122 30 201 53 126 36 20 136 210 142 104 52 218 50 97 25 170 194 224 180 241 76 216 199 91 208 57 92 11 67 127 41 234 172 201 40 164 179 169 117 119 16 91 126 137 78 124 239 14 214 167 56 41 1 89 127 130 55 2 41 251 87 80 199 136 104 197 148 253 70 242 183 80 216 250 76 18 49 14 148 97 100 206 138 141 221 121 0 31 207 196 225 241 30 182 246 150 177 180 57 129 254 233 118 180 246 230 163 184 61 2 169 245 119 241 188 228 156 134 195 31 249 172 194 147 155 18 152 253 103 120 35 136 178 79 225 105 222 215 8 37 241 200 226 159 100 196 74 218 35 209 220 147 5 211 64 57 236 19 205 146 252 244 114 63 150 54 38 232 196 34 22 55 198 49 181 228 192 208 172 25 227 11 221 152 94 233 199 194 250 40 86 182 166 177 190 51 79 39 86 48 183 54 132 129 25 163 204 90 77 103 18 178 27 31 227 121 233 57 102 247 7 60 163 189 160 236 63 185 224 201 77 121 146 243 103 120 35 136 50 21 79 114 254 194 118 39 84 89 120 161 136 250 121 36 85 223 64 133 241 5 204 67 21 146 224 220 218 48 150 55 167 72 122 129 164 39 48 67 162 99 243 93 232 26 169 147 14 150 118 68 49 67 175 160 119 228 177 116 170 165 163 203 91 83 56 60 222 199 206 254 58 214 182 231 48 79 199 108 99 58 212 210 137 244 250 123 120 89 121 153 129 250 209 205 209 59 176 74 112 46 39 161 23 158 240 93 69 112 238 87 108 119 66 149 69 151 254 140 87 53 55 145 219 28 200 250 45 198 236 234 160 171 76 120 115 93 34 242 130 188 121 176 92 58 249 138 37 246 36 231 43 89 110 233 186 251 116 38 82 58 33 50 225 125 9 153 104 19 125 50 116 247 16 83 126 222 205 81 27 80 241 172 60 205 251 10 222 8 166 76 197 211 188 191 178 221 9 85 150 88 115 141 181 26 134 22 123 14 6 166 59 176 186 61 235 67 98 117 123 6 253 83 109 140 124 38 39 103 8 18 170 174 202 32 68 149 252 36 159 51 26 238 67 223 155 135 169 101 7 222 127 120 135 15 31 63 224 227 71 49 95 128 181 157 57 150 155 9 109 142 2 58 17 129 164 154 27 110 142 218 128 138 103 58 112 66 208 253 156 79 153 10 77 251 51 202 4 50 27 31 160 137 196 134 230 76 88 216 24 197 235 131 13 31 7 68 221 219 198 234 81 105 138 65 118 211 35 196 87 94 148 65 8 47 252 22 209 165 63 33 174 226 2 106 173 137 44 35 11 222 190 59 196 251 247 111 233 196 123 169 103 151 229 36 202 113 96 166 3 141 221 233 180 119 159 118 255 38 109 187 121 185 158 21 103 131 23 10 248 174 66 211 22 66 153 64 81 123 8 186 199 117 216 222 95 193 254 209 14 9 28 249 56 32 38 165 113 176 20 249 173 79 144 82 231 199 50 248 213 199 78 73 71 56 250 166 244 156 3 123 82 135 200 132 184 196 156 216 222 95 149 243 195 50 92 137 2 125 48 237 126 45 109 187 121 185 158 21 103 131 23 10 249 174 66 211 22 74 153 64 137 33 28 142 169 22 146 223 198 209 219 3 25 61 239 107 113 99 12 93 163 181 40 55 62 71 86 211 67 196 87 93 242 177 83 106 136 248 60 7 218 158 210 238 223 165 109 55 47 215 179 226 108 248 59 194 206 64 104 17 219 189 80 110 138 146 233 21 169 127 247 65 164 254 131 143 3 34 122 189 147 205 208 217 146 25 193 167 72 170 189 230 163 167 212 24 193 245 191 237 212 12 236 48 3 43 212 209 57 82 133 66 225 64 209 255 200 241 97 94 80 194 216 32 16 126 6 194 138 217 238 133 74 203 11 140 204 91 124 86 30 173 23 206 137 104 68 91 95 62 202 140 81 72 209 249 249 232 41 51 69 126 158 3 237 207 56 246 27 57 62 220 11 74 120 201 55 16 136 96 135 211 160 182 107 239 37 134 80 206 129 122 110 64 139 216 59 220 194 49 51 225 125 237 114 98 47 172 143 72 39 244 125 121 40 234 8 69 124 245 5 196 85 255 134 216 170 243 196 175 168 234 140 165 3 122 188 126 179 129 189 55 91 216 63 220 198 193 209 46 87 181 25 174 78 118 150 87 43 26 122 82 145 213 252 144 28 191 117 242 244 130 18 89 250 45 4 34 74 191 211 64 188 251 66 237 155 223 22 136 246 129 60 76 44 117 203 52 239 211 9 239 75 204 13 225 132 200 68 223 180 32 146 130 140 230 123 72 111 188 141 212 70 63 36 235 110 160 190 59 145 109 122 108 189 94 194 230 235 69 108 188 94 192 250 238 28 198 151 108 232 26 171 69 147 61 29 197 116 60 69 119 147 196 201 71 192 139 151 18 85 254 29 4 34 203 190 215 64 188 251 34 138 50 129 44 18 169 179 189 164 145 106 233 196 214 222 146 143 3 90 193 252 198 8 44 35 21 40 54 134 162 176 35 24 121 237 129 200 209 63 66 83 111 154 116 110 117 123 154 231 161 113 46 201 35 152 93 27 64 247 68 61 116 221 201 200 105 245 39 249 91 204 220 111 12 50 249 8 120 241 82 162 43 190 135 64 84 249 15 26 136 119 95 68 83 38 144 210 112 131 37 17 44 35 40 140 205 175 15 201 213 232 237 251 35 124 248 224 92 203 181 151 136 236 232 66 39 140 195 165 104 180 167 162 220 18 141 220 54 127 84 89 95 160 181 47 27 182 241 26 88 199 170 96 25 173 128 105 164 20 186 158 100 20 27 66 144 198 76 37 214 93 97 217 157 147 124 162 201 49 186 226 71 60 215 64 121 94 73 193 191 137 132 218 11 44 131 155 140 208 67 180 56 178 48 60 111 194 206 193 154 172 95 225 132 247 181 127 184 131 213 29 214 245 138 131 100 107 209 96 79 70 94 219 99 102 35 136 89 9 65 153 57 28 165 166 48 148 152 66 229 123 14 157 75 107 242 67 66 221 37 196 215 156 71 76 213 207 36 253 131 228 25 83 245 19 98 170 127 113 67 121 81 245 15 252 71 168 228 56 162 204 28 33 73 9 130 194 9 145 9 239 75 100 69 56 38 218 38 57 57 59 6 11 144 223 30 192 57 241 59 18 235 47 209 254 143 18 207 201 69 133 39 39 103 123 76 53 119 240 154 115 136 175 61 239 134 34 132 66 144 168 187 132 148 198 235 200 110 189 143 34 67 48 42 59 163 101 138 107 186 98 81 203 122 47 183 68 162 208 240 68 182 167 54 221 100 106 47 74 133 249 29 1 104 118 164 163 111 166 5 51 107 125 216 218 95 150 101 164 61 219 124 228 62 241 158 251 133 112 98 121 107 18 3 179 109 208 247 231 208 70 20 50 91 239 74 61 49 213 252 154 147 119 79 196 214 252 76 210 191 32 174 246 28 94 214 145 39 29 78 210 93 117 67 137 173 229 201 178 225 50 50 90 126 231 228 242 71 141 45 14 29 67 5 112 76 55 211 80 187 44 143 177 197 46 244 76 234 228 202 83 99 139 165 131 65 72 107 190 69 197 63 115 220 109 148 90 66 209 232 72 134 125 186 17 139 155 99 146 168 32 44 136 139 75 28 210 132 67 194 49 145 165 69 158 159 70 22 44 82 95 177 49 152 228 72 146 16 100 221 16 239 66 94 71 226 245 34 192 23 144 212 112 5 41 77 55 104 219 207 13 37 174 238 23 190 220 68 190 225 49 42 173 81 48 115 18 77 44 219 184 4 174 225 141 172 105 177 198 127 228 18 55 79 71 58 217 94 130 186 238 56 228 182 243 120 192 177 73 13 151 144 214 114 3 89 109 119 209 58 144 133 113 142 253 212 132 22 206 189 57 122 77 253 235 232 159 105 101 64 98 168 135 101 65 93 241 181 39 16 188 4 94 234 248 221 65 27 201 77 87 145 74 158 25 173 119 144 165 127 224 134 18 95 127 14 121 29 143 80 219 19 15 243 104 9 35 110 196 210 214 184 52 114 252 246 141 140 164 184 132 193 249 141 97 12 206 181 163 141 68 139 77 193 140 204 57 42 191 136 148 230 171 72 111 189 137 122 123 34 28 51 205 88 219 157 197 238 155 245 83 231 131 208 39 244 10 253 194 150 206 158 128 68 234 72 36 209 132 250 95 89 38 231 88 38 140 120 195 5 188 106 188 76 189 183 24 172 7 40 50 61 97 144 3 248 252 136 228 239 187 161 36 112 160 40 1 227 72 17 35 223 37 201 239 28 172 186 202 192 121 78 23 215 193 241 46 55 155 5 58 49 4 235 120 37 42 172 17 16 99 19 27 126 163 161 139 140 208 21 84 118 69 194 60 86 130 201 21 110 112 59 147 167 110 112 66 159 56 117 138 76 140 211 94 83 95 42 203 226 42 117 92 146 164 19 116 191 202 231 212 230 107 140 246 45 20 24 3 88 25 145 104 232 77 146 21 82 104 124 34 231 141 10 69 16 168 237 137 67 255 156 158 81 99 217 28 191 62 117 41 148 169 103 155 136 236 0 251 214 113 140 24 155 216 32 156 112 162 200 20 132 230 254 84 206 5 29 166 215 122 121 36 94 254 228 6 55 189 230 128 126 48 75 70 57 149 89 124 213 36 156 56 47 159 51 245 126 172 140 7 50 40 45 116 178 115 172 12 77 142 20 148 89 194 72 254 142 27 74 82 227 5 166 62 30 131 11 237 216 59 218 196 225 219 125 158 48 143 125 12 31 190 221 147 132 150 182 199 209 61 89 139 106 91 52 196 216 164 198 223 220 40 177 60 69 219 80 150 116 112 110 99 80 206 35 239 203 185 34 189 195 187 247 199 152 88 177 161 165 63 141 115 232 58 50 244 55 57 143 110 35 167 227 30 163 238 143 18 243 19 102 57 76 218 169 235 137 69 131 35 145 206 68 48 3 92 126 91 253 220 80 94 53 95 128 206 145 128 225 69 35 35 188 203 131 153 168 123 231 135 133 246 218 59 220 196 242 246 164 44 51 243 104 17 42 186 194 89 54 162 116 46 226 85 179 19 229 214 80 24 70 242 49 186 100 102 41 242 75 237 208 247 75 77 232 22 54 68 54 71 22 205 104 236 123 133 148 150 171 200 110 191 131 66 115 128 212 91 221 253 28 117 246 56 150 77 34 106 122 94 208 17 110 112 230 64 228 27 31 202 126 194 89 21 74 114 203 69 42 73 196 232 178 25 71 239 246 157 199 1 215 167 157 214 129 157 131 21 185 206 59 102 26 161 31 200 64 105 231 83 78 94 238 29 68 114 139 19 149 182 8 88 198 75 48 181 218 195 141 141 135 60 126 240 120 95 34 242 130 188 56 129 14 206 183 67 215 251 18 201 212 145 103 100 185 112 124 243 64 42 90 7 51 208 62 148 13 195 112 30 29 137 69 161 137 103 34 234 79 109 189 140 180 86 46 24 250 107 110 40 41 173 151 80 215 27 11 199 92 35 54 246 196 234 177 198 50 218 147 78 28 144 192 198 222 28 22 54 135 48 178 100 128 109 178 138 37 146 201 168 60 71 129 233 17 82 91 46 35 171 253 150 52 94 220 25 4 61 219 6 231 245 146 188 88 8 142 88 142 114 31 16 63 177 15 72 157 59 216 220 227 223 46 204 80 223 108 51 201 242 196 105 9 98 228 195 164 222 134 190 4 86 196 75 58 22 143 250 222 56 148 89 159 33 207 112 207 73 94 127 133 196 249 135 64 27 39 184 11 74 42 133 213 61 145 176 78 148 114 226 217 105 124 146 169 95 103 141 30 97 237 245 52 198 150 76 232 156 40 33 241 12 212 59 226 80 222 21 130 34 179 63 114 12 183 165 194 2 211 67 84 118 135 163 169 255 21 39 111 29 102 55 250 92 159 154 98 46 57 151 96 117 39 22 58 69 38 23 182 134 89 102 38 216 103 234 97 26 45 148 99 5 241 122 71 60 106 237 49 212 23 129 178 174 103 40 178 4 32 207 196 37 179 227 150 155 124 186 36 206 57 227 130 146 214 118 21 229 182 16 180 15 103 114 37 106 98 153 216 101 212 143 223 29 96 102 221 206 101 177 0 37 214 64 20 152 31 32 219 224 135 116 246 215 162 172 43 152 105 79 134 109 170 10 147 171 54 30 37 22 125 207 66 140 188 32 47 116 174 237 78 99 124 165 83 246 215 194 48 146 139 198 254 36 84 145 124 113 103 32 114 141 119 33 184 9 168 246 100 212 219 175 33 179 253 186 27 74 58 5 197 214 0 122 255 2 29 35 217 232 157 173 199 228 90 23 214 25 253 169 53 27 211 172 131 97 52 87 182 181 13 103 176 76 210 60 32 50 215 63 215 44 201 203 181 255 200 249 113 35 230 146 216 59 118 223 172 98 251 128 31 44 12 138 208 57 189 214 131 190 249 38 152 198 11 165 222 54 6 174 101 48 149 101 19 135 170 158 8 148 90 131 24 172 135 200 49 222 134 224 38 32 72 187 137 119 92 103 70 184 243 187 160 100 26 174 35 207 124 23 37 93 129 168 178 135 75 146 246 153 26 76 172 90 157 96 180 68 196 38 87 187 56 57 249 191 38 51 164 197 194 214 16 86 119 167 100 228 5 121 177 194 136 235 205 241 142 204 228 220 230 0 102 54 28 12 70 183 212 215 79 242 214 201 82 105 167 113 128 171 76 111 52 202 187 67 104 63 8 69 157 254 200 55 223 71 174 233 54 178 141 126 200 52 220 112 130 164 5 84 210 217 29 55 161 66 201 50 210 27 13 42 122 66 160 31 78 69 207 76 53 198 86 204 92 58 71 249 221 187 193 137 253 90 150 129 239 191 205 167 239 85 34 242 130 252 192 66 11 35 222 200 204 214 73 157 150 137 34 180 141 8 242 9 50 96 133 157 143 220 68 179 72 214 13 35 247 5 21 46 121 182 129 196 137 28 195 45 55 148 108 19 133 26 148 216 2 81 215 23 13 253 72 26 44 147 197 92 157 234 185 196 26 25 189 78 76 175 247 96 118 179 207 23 156 184 98 242 74 184 218 71 150 59 208 51 91 3 227 56 203 111 44 27 237 36 45 116 54 13 38 162 190 239 5 170 123 195 81 102 11 66 190 133 147 212 69 52 155 119 55 76 183 200 203 5 151 60 199 72 226 94 80 114 216 73 194 236 68 161 149 127 188 210 137 42 123 40 29 121 78 131 47 105 56 21 109 163 233 232 24 205 132 129 100 62 7 173 195 41 104 24 136 71 141 35 146 136 64 21 9 87 217 195 80 209 243 12 101 221 65 44 25 126 145 89 31 32 207 114 199 77 212 205 69 229 228 197 77 229 152 107 246 131 10 197 253 98 161 208 5 181 163 184 171 50 231 253 247 211 97 166 92 133 187 207 137 62 49 54 135 70 85 228 10 189 46 120 202 79 136 105 73 122 114 240 212 171 228 209 160 68 231 9 180 3 180 242 51 159 85 29 94 122 60 117 158 56 159 71 135 84 104 131 226 230 162 213 247 9 157 66 191 146 111 189 13 129 188 206 19 228 179 225 52 124 150 51 26 61 103 233 212 234 201 183 210 150 11 158 250 181 156 60 3 172 237 167 20 116 221 129 64 190 245 4 5 116 232 52 168 206 126 250 238 169 75 213 171 213 167 29 95 208 69 91 46 120 234 213 234 113 6 249 52 208 129 187 84 32 224 116 196 27 133 148 169 56 171 207 127 83 174 20 218 238 66 224 196 17 190 107 72 159 233 128 141 206 170 112 7 129 122 132 46 21 26 185 167 78 97 195 5 151 125 95 14 39 125 60 185 105 198 82 7 29 184 71 7 4 156 142 120 163 136 50 21 30 109 221 236 171 194 173 131 122 60 228 103 233 188 71 157 78 156 216 247 124 246 180 123 210 166 142 83 239 255 239 128 140 248 127 49 3 255 4 57 6 77 188 28 27 238 117 0 0 0 0 73 69 78 68 174 66 96 130]!

seaside
	^self icons at: #seaside ifAbsentPut: [self seasideResource]!

seasideResource
	"Generated from:
	self createIconMethodOfSize: 48@48 fromFile: 'Seaside.png'.
	"
	^InternalIcon fromBytes: #[137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 48 0 0 0 48 8 6 0 0 0 87 2 249 135 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 9 112 72 89 115 0 0 14 194 0 0 14 194 1 21 40 74 128 0 0 10 139 73 68 65 84 104 67 237 153 121 112 149 213 25 198 31 2 40 136 160 142 138 21 45 210 22 133 138 138 86 64 91 40 168 64 162 34 160 162 162 236 130 136 168 160 214 90 17 168 130 177 150 170 160 130 74 235 110 93 235 210 218 85 254 105 157 113 155 105 173 109 181 117 7 76 130 38 18 74 32 4 8 89 238 119 250 123 206 253 174 198 142 3 55 154 204 192 140 153 121 231 126 223 123 207 61 231 121 222 243 110 231 68 250 234 239 19 11 20 188 90 168 121 239 159 170 219 78 239 166 195 118 41 187 92 39 21 212 142 85 101 102 172 146 204 57 200 24 101 150 244 213 248 93 134 196 19 3 117 124 24 167 144 57 23 240 159 146 72 246 233 160 238 187 4 137 87 138 52 35 76 128 192 56 8 152 196 121 200 217 74 86 21 234 63 16 104 183 211 147 248 75 161 174 15 19 33 48 17 224 38 97 2 147 145 179 148 204 57 84 139 32 208 102 167 38 241 220 112 221 21 38 65 96 42 160 39 164 187 48 35 75 34 140 81 232 219 73 125 118 106 2 43 10 181 60 76 134 192 69 128 190 32 221 1 19 184 10 2 196 70 73 145 222 133 192 110 59 45 9 8 252 58 76 129 192 101 128 182 216 141 206 71 22 66 96 46 122 226 97 209 225 42 222 153 9 60 27 206 7 232 213 128 158 139 140 79 73 252 4 2 203 208 95 161 164 126 180 234 247 144 142 222 41 73 188 116 154 126 31 166 2 244 58 128 3 58 51 37 117 163 31 67 224 30 244 183 241 78 124 84 20 169 4 2 187 231 75 226 120 169 227 98 105 250 95 165 231 223 151 54 174 148 234 95 147 222 29 32 245 205 119 142 188 198 85 140 215 75 145 192 34 128 26 236 172 148 0 159 145 192 189 188 255 52 155 149 110 232 165 133 219 153 180 237 138 195 212 251 181 67 180 112 213 1 90 179 102 79 82 113 27 37 0 79 86 75 193 159 22 2 106 43 115 116 200 11 92 62 131 202 199 233 229 48 13 160 75 0 185 28 185 54 117 35 118 34 220 137 254 65 222 77 130 29 105 28 165 204 249 7 235 202 38 243 182 27 211 85 67 215 14 212 11 153 193 184 218 0 133 77 189 149 252 183 59 59 214 85 73 89 103 37 37 187 127 150 128 73 240 251 189 243 193 150 215 152 170 73 250 71 184 16 160 203 0 121 15 114 19 50 41 27 7 225 38 244 191 228 249 33 228 110 228 82 228 52 37 155 11 181 225 227 19 85 222 48 76 219 50 133 232 70 34 4 59 133 48 108 59 157 239 79 128 196 161 89 240 185 29 88 93 144 125 126 79 106 104 81 2 53 83 244 78 184 24 160 182 254 125 200 157 200 133 17 76 18 230 160 55 248 135 83 18 30 179 0 253 76 244 23 243 252 163 236 206 56 99 69 253 85 10 245 252 174 250 104 37 31 118 193 242 184 208 234 182 74 112 167 96 2 196 66 166 191 116 117 94 150 205 119 208 182 169 90 27 46 3 144 173 127 127 106 233 43 83 2 23 164 49 240 40 239 222 137 244 251 176 28 253 82 222 29 51 183 32 142 31 187 30 217 172 230 24 37 235 14 4 52 238 83 182 55 174 116 16 159 123 100 99 224 86 233 15 45 234 255 143 159 160 161 46 94 97 126 234 235 182 182 65 22 35 52 118 97 108 234 90 222 1 199 130 119 8 87 138 4 236 114 183 34 63 67 230 32 116 178 245 199 41 84 31 134 251 244 80 178 225 88 164 191 146 114 200 56 136 87 72 111 2 126 72 190 134 221 238 184 99 165 246 143 157 164 225 13 211 85 155 153 9 160 187 0 100 144 182 242 3 169 101 169 7 225 108 244 206 64 6 111 189 131 249 23 41 129 219 121 246 119 151 32 167 32 223 87 82 215 79 97 243 16 37 219 232 167 182 225 74 85 236 134 93 232 95 82 77 103 105 226 151 5 223 118 241 32 13 169 156 170 85 180 13 141 177 117 176 229 240 249 240 4 64 237 38 57 75 3 50 67 59 17 9 208 82 68 224 22 7 50 113 16 238 64 111 151 113 247 122 18 66 208 102 134 146 165 114 5 145 216 216 122 166 146 82 226 192 65 75 241 152 1 248 182 205 34 96 43 23 15 80 97 201 20 221 191 117 166 62 114 6 9 87 176 176 131 206 126 107 48 6 253 43 244 79 162 127 60 125 183 27 217 85 168 204 225 44 244 110 43 236 46 38 229 32 38 75 133 89 232 201 70 153 97 89 224 177 253 160 16 198 172 69 64 55 80 67 214 246 204 102 157 115 37 234 153 186 228 5 254 183 35 117 192 235 227 117 121 249 116 189 211 48 91 13 153 217 76 252 3 196 160 23 179 192 189 44 240 8 207 6 11 240 204 83 89 9 79 55 33 144 11 214 235 83 2 99 24 67 134 137 117 194 243 208 177 134 147 25 63 156 231 17 8 173 70 140 133 59 208 47 70 63 95 201 38 190 251 160 189 146 37 210 31 1 126 84 62 224 219 84 77 215 243 49 79 219 210 179 153 232 135 233 130 206 235 119 33 248 113 120 12 253 99 77 8 60 153 18 120 234 115 118 224 134 212 133 200 235 177 205 246 78 56 223 227 239 161 136 241 62 63 184 245 240 206 56 131 217 21 111 81 168 165 13 47 223 95 201 243 5 42 5 248 169 249 128 215 7 19 52 51 230 101 11 65 21 183 56 103 125 251 240 53 89 50 97 33 122 103 24 47 236 212 119 51 130 59 69 203 217 173 252 110 194 254 158 84 26 93 104 52 207 163 16 187 204 169 217 231 112 37 122 239 200 207 17 187 162 73 224 102 141 116 175 235 15 87 242 118 39 85 23 72 147 0 207 71 30 127 107 38 232 197 24 148 169 196 66 147 123 119 111 239 194 132 132 233 232 167 241 236 195 139 155 54 87 92 44 249 153 35 165 15 246 174 170 184 78 56 35 37 96 203 219 93 8 76 27 35 6 177 119 213 49 97 241 51 6 168 37 232 63 222 79 201 49 109 180 0 216 237 243 128 158 29 242 250 24 77 206 129 140 217 195 149 213 59 96 255 116 81 242 46 224 82 209 114 151 243 236 134 141 244 153 153 142 224 26 241 68 150 59 19 167 224 13 54 156 142 190 169 245 105 232 226 78 154 0 62 31 171 182 63 157 82 113 185 77 212 129 53 251 196 86 97 92 222 224 211 129 5 175 140 210 195 141 211 148 137 133 201 21 212 224 156 163 93 238 9 200 232 42 94 216 139 218 98 185 197 169 168 225 118 244 4 121 116 161 27 17 167 72 199 146 9 216 117 108 125 187 207 201 8 57 62 44 64 111 208 174 198 254 180 251 145 125 106 78 128 0 21 152 148 115 78 115 9 196 241 167 112 41 245 187 97 186 175 106 162 214 70 55 201 137 99 99 94 234 235 6 111 191 117 224 165 249 61 60 0 32 167 78 191 91 111 159 118 90 180 11 153 128 221 205 59 230 221 32 195 132 209 232 125 0 50 112 19 79 73 215 141 87 40 237 164 132 158 251 145 47 68 160 233 143 186 119 214 136 55 70 235 165 120 195 96 193 223 99 223 239 133 109 233 92 243 6 240 72 192 45 132 197 68 76 130 34 23 70 162 119 22 114 26 117 170 244 206 56 54 78 74 211 168 143 160 78 10 254 158 216 72 46 81 72 243 127 6 44 131 190 52 137 116 130 206 115 14 215 228 151 11 245 74 195 56 42 176 125 221 105 209 41 215 125 12 96 195 67 0 114 187 144 107 25 76 142 96 15 35 82 87 116 211 102 151 179 144 189 226 37 0 213 183 97 16 237 3 113 209 232 184 34 222 156 60 106 217 177 146 61 148 252 93 170 164 125 216 183 165 72 120 158 54 251 238 166 94 197 71 106 238 71 163 105 39 124 11 231 59 32 44 24 30 4 144 43 176 197 36 188 67 88 62 18 160 48 125 18 176 38 70 234 12 183 162 199 165 234 6 16 184 28 96 54 125 143 70 206 189 19 59 220 200 103 85 223 108 21 190 73 186 215 235 182 36 137 220 92 5 211 122 232 90 187 67 204 66 62 58 26 188 171 176 9 56 107 17 180 225 28 244 174 11 185 140 99 2 110 230 92 209 9 224 122 146 196 134 111 43 113 234 172 232 70 255 51 12 61 70 169 165 216 149 209 7 153 196 145 132 102 107 16 136 115 174 29 161 183 99 219 236 236 100 224 38 97 144 118 51 87 92 87 116 103 25 247 66 118 159 220 14 220 141 222 58 186 209 58 210 118 37 45 180 187 206 210 142 10 27 105 161 107 233 145 170 250 160 227 16 195 65 190 130 165 240 166 86 248 123 111 152 138 93 180 194 109 77 130 216 65 233 180 73 241 138 149 59 151 46 189 11 169 132 165 232 237 102 30 75 118 171 99 23 215 246 138 39 176 176 186 29 132 190 193 206 28 201 169 108 159 236 46 44 147 126 3 252 230 117 163 249 240 173 44 210 210 152 85 150 0 200 153 199 173 129 211 101 17 226 172 117 51 122 103 31 7 177 1 147 153 26 169 232 13 51 20 26 104 18 27 221 142 219 221 40 140 245 140 167 255 15 222 137 149 28 37 63 194 173 62 246 97 134 119 31 104 10 191 64 113 219 33 135 117 69 90 150 57 35 5 106 240 246 119 231 122 31 212 1 232 230 44 230 121 23 66 130 179 254 120 37 91 176 236 198 111 42 172 59 132 147 215 17 156 127 57 15 212 250 52 70 102 171 163 110 172 39 128 75 58 100 45 239 79 215 5 19 224 170 187 122 79 105 255 29 130 106 206 128 218 147 245 140 155 181 176 40 245 105 91 211 109 178 27 184 38 253 125 4 127 28 217 230 8 53 252 179 187 74 94 220 79 111 173 236 162 26 183 204 17 40 183 15 229 7 43 89 127 148 130 79 97 149 156 5 156 74 227 141 4 113 96 215 242 243 125 210 51 205 193 183 195 177 91 135 235 217 216 93 22 67 192 53 1 160 241 128 226 214 217 233 213 122 158 13 222 150 239 82 160 89 76 154 59 215 246 62 70 186 226 117 105 93 238 210 202 150 182 203 148 237 133 11 237 139 245 33 177 202 36 210 139 173 183 56 90 242 251 175 239 16 88 190 3 54 15 213 159 29 176 225 26 128 186 103 114 175 227 83 150 139 28 193 153 144 215 13 126 99 31 213 29 216 78 179 153 247 243 78 86 237 33 210 243 6 105 201 223 164 242 28 25 127 250 102 206 146 35 192 181 74 35 115 28 157 47 190 29 142 171 62 81 111 24 116 184 20 2 110 173 79 204 102 31 159 43 26 105 63 40 84 161 134 254 254 162 189 180 156 201 14 216 225 132 220 135 14 150 70 225 39 43 56 11 215 55 221 25 63 191 32 193 165 5 171 243 166 33 122 39 54 103 110 167 125 179 192 141 130 239 64 27 144 173 223 161 187 236 165 240 112 87 113 35 162 126 121 128 255 255 33 187 125 87 58 239 57 105 229 191 165 170 167 165 87 25 192 221 110 11 254 109 30 204 97 159 44 18 206 132 0 224 27 185 26 169 39 133 110 1 252 198 111 41 121 179 155 42 248 207 198 200 47 185 164 91 137 142 72 126 167 179 230 44 182 121 16 109 183 173 62 148 59 205 126 88 29 169 161 130 174 39 69 150 118 213 22 142 84 211 90 165 0 53 7 228 246 198 214 244 87 237 54 110 208 182 146 254 170 169 164 27 72 127 235 232 105 42 40 66 253 219 105 126 75 173 211 106 243 172 239 173 218 234 67 1 222 131 194 116 16 237 0 192 63 36 5 222 184 187 158 98 209 158 173 182 112 75 77 92 214 77 43 43 191 22 187 201 96 224 165 84 206 63 181 213 91 252 115 120 96 75 173 209 170 243 220 209 73 231 249 63 41 101 29 178 215 223 20 165 245 44 152 223 93 78 171 34 107 198 228 115 165 162 71 165 39 112 248 121 220 97 246 104 198 79 191 26 250 63 41 246 138 87 13 159 102 76 0 0 0 0 73 69 78 68 174 66 96 130]!

start
	^self icons at: #start ifAbsentPut: [self startResource]!

startResource
	"Private - Generated from:
	self createIconMethodOfSize: 48@48 fromFile: 'Start.png'.
	"
	^InternalIcon fromBytes: #[137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 48 0 0 0 48 8 6 0 0 0 87 2 249 135 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 9 112 72 89 115 0 0 14 194 0 0 14 194 1 21 40 74 128 0 0 12 87 73 68 65 84 104 67 237 153 123 120 147 245 21 199 163 19 104 41 93 108 107 47 233 37 41 233 45 77 105 218 38 105 115 105 218 52 73 147 230 250 230 210 220 83 96 130 50 17 40 80 81 25 40 165 181 220 134 34 23 231 112 32 90 25 151 2 162 226 101 8 168 8 45 165 80 160 64 91 160 64 21 1 55 16 152 236 15 209 41 191 223 206 239 165 101 113 195 233 158 149 212 63 150 231 57 207 251 228 109 158 244 124 206 249 158 75 126 47 131 241 19 95 84 157 194 69 61 35 111 178 214 23 35 75 189 236 144 177 174 104 149 230 233 252 71 53 181 5 122 93 173 136 167 95 166 31 38 122 73 52 164 182 182 246 222 159 248 149 161 253 88 48 0 213 32 239 181 204 151 238 50 206 151 172 210 55 20 62 169 125 74 228 148 79 205 203 47 121 76 48 82 58 93 26 237 218 228 250 5 163 150 113 47 3 51 238 9 173 151 255 225 191 125 15 96 158 252 26 181 72 126 150 122 86 222 110 152 39 93 175 125 90 52 87 241 40 223 39 159 156 93 82 50 89 48 146 100 130 64 252 172 178 17 12 96 93 160 192 182 197 10 100 91 90 114 211 180 64 214 169 123 90 188 89 62 49 167 94 49 153 239 147 77 17 20 40 95 81 134 245 67 252 236 50 0 117 128 108 203 148 184 114 141 26 185 54 235 144 109 157 230 60 245 114 89 171 97 121 241 230 138 101 178 185 170 133 82 119 225 19 121 57 226 154 156 20 197 204 220 168 159 141 156 168 6 153 203 220 32 107 34 0 142 85 42 236 122 75 143 125 173 54 236 254 200 114 221 249 158 225 51 219 22 109 167 121 173 106 131 110 153 124 182 100 42 159 146 61 150 83 40 170 22 177 249 181 252 161 202 90 229 125 131 46 167 126 0 75 131 12 85 174 43 199 222 102 10 143 185 224 195 129 19 46 236 107 179 33 247 78 51 178 109 213 29 169 248 189 226 213 162 106 254 116 2 33 174 22 140 146 62 39 13 39 16 116 38 6 243 21 156 1 26 160 5 0 62 247 226 170 211 110 28 232 168 68 190 22 27 170 220 97 236 165 154 52 31 148 191 32 91 173 93 42 125 162 116 65 161 93 86 205 27 37 170 230 179 149 181 121 247 15 170 156 250 139 152 72 200 73 0 246 81 120 244 159 1 224 19 15 174 130 44 4 142 184 176 167 197 122 165 114 187 241 20 181 73 221 106 108 44 89 163 93 34 125 130 150 83 117 78 97 49 64 12 106 119 10 238 66 52 64 43 0 92 242 224 209 231 189 120 76 47 216 73 31 246 31 174 252 214 179 215 242 85 229 142 138 235 212 38 85 171 110 133 108 181 116 50 111 186 116 74 142 165 120 90 118 206 160 118 167 96 0 90 66 173 86 92 117 9 50 240 153 23 143 62 11 214 237 5 41 57 191 131 122 248 134 134 216 174 239 33 114 34 53 81 190 92 62 75 53 79 232 46 156 202 207 23 76 206 132 97 199 15 253 176 163 234 100 244 42 65 213 203 161 136 181 216 67 3 248 1 192 7 117 224 69 85 157 30 20 56 230 186 233 39 16 36 19 205 214 43 206 29 230 179 118 40 108 210 157 84 207 73 230 22 76 202 240 10 31 201 40 17 79 203 229 134 92 78 193 0 14 26 192 134 3 151 2 56 112 14 58 81 143 23 156 119 211 16 85 144 137 209 32 39 82 19 222 86 59 114 127 104 185 105 221 170 59 174 89 46 221 92 240 72 70 93 254 175 51 124 226 41 217 161 31 118 183 0 100 176 204 245 181 209 190 12 4 206 129 116 250 0 2 199 1 160 19 100 213 69 228 228 198 254 118 232 78 0 81 185 211 244 153 169 73 221 170 89 33 221 172 90 34 169 43 93 88 232 46 132 154 40 154 146 158 44 122 82 196 12 73 119 181 215 21 185 172 52 128 20 36 164 161 139 184 234 50 200 7 106 32 112 218 131 252 199 221 40 64 236 24 116 165 99 0 113 212 131 3 71 73 139 37 221 201 118 221 177 195 116 222 188 85 219 165 95 171 220 168 94 33 153 45 158 154 69 9 171 121 34 249 164 172 196 16 2 72 154 108 245 18 104 163 106 152 194 22 60 250 50 41 98 112 180 15 192 15 50 10 116 192 251 35 183 32 72 97 143 57 5 114 58 10 16 109 118 236 220 109 193 212 91 218 142 242 149 242 70 209 164 204 26 225 196 12 83 225 36 94 102 200 0 168 103 36 144 1 9 100 64 141 61 251 45 56 240 5 68 255 60 56 124 6 50 208 233 166 179 224 135 200 251 9 4 201 68 23 153 17 240 153 99 110 12 133 77 67 56 62 48 246 154 54 171 62 44 91 33 121 89 249 188 248 241 210 249 5 20 129 16 62 204 99 201 199 101 69 222 53 24 10 36 68 0 40 0 176 175 87 99 247 126 51 246 93 241 96 223 69 112 248 44 56 220 13 215 78 176 227 224 44 72 199 7 0 228 125 0 32 0 14 238 187 176 255 152 19 59 91 169 171 214 157 250 30 195 22 229 254 138 198 226 53 202 231 139 30 23 78 74 55 11 39 165 9 133 211 120 172 187 10 96 6 0 11 0 216 0 192 217 102 198 158 171 30 236 253 28 28 236 5 71 79 192 21 156 245 129 179 94 136 56 49 31 129 1 35 247 171 78 194 208 235 241 98 111 135 227 219 202 125 230 27 214 157 186 191 17 8 146 137 144 200 201 4 25 48 1 128 185 14 0 64 66 206 86 51 246 66 13 248 46 220 2 240 159 4 71 79 128 195 93 96 0 65 59 223 9 139 30 152 31 238 5 224 111 85 167 0 240 152 227 59 231 65 235 55 246 102 211 13 203 123 186 30 237 58 229 135 138 103 11 27 101 11 69 51 139 106 243 108 153 99 57 188 172 113 41 137 89 3 45 39 2 96 168 43 106 130 223 194 200 186 86 141 93 205 22 236 135 101 206 7 93 200 223 11 218 239 113 35 223 73 184 146 237 180 235 182 33 0 64 190 110 23 34 0 1 128 244 30 119 34 207 81 128 56 108 255 59 181 219 116 69 255 102 121 175 250 149 146 142 146 223 73 214 137 231 229 207 74 27 155 108 227 142 75 17 103 140 73 78 26 80 57 233 1 0 172 201 48 23 0 94 3 128 61 80 196 231 97 255 249 244 22 128 239 52 56 218 227 66 254 147 16 113 128 240 119 3 68 183 19 249 186 192 224 74 222 211 112 112 245 118 187 145 167 203 141 236 173 54 100 218 97 192 218 45 26 164 92 83 124 84 188 160 96 93 250 216 148 153 105 191 74 177 146 76 132 6 224 19 200 194 105 55 242 66 148 189 93 0 1 197 234 131 182 73 204 219 1 247 250 172 255 158 27 186 145 243 160 131 118 222 184 221 240 149 102 163 234 90 201 139 178 139 210 197 162 237 121 179 70 45 78 117 37 142 77 117 39 148 114 60 241 169 161 1 128 69 206 7 5 76 23 46 76 95 207 33 176 118 176 131 196 160 255 31 0 35 87 242 30 238 87 182 56 176 21 230 1 137 124 249 70 213 85 197 11 146 51 194 217 185 7 5 51 178 215 240 38 164 213 176 84 209 186 56 117 156 96 164 58 46 62 52 0 103 160 179 64 187 164 29 7 39 221 251 193 246 245 89 11 92 251 173 239 158 237 3 27 54 189 75 203 6 147 200 19 231 51 188 236 55 185 246 164 134 100 109 188 55 34 121 72 110 88 98 88 74 20 151 49 176 43 6 169 1 29 212 128 126 110 33 162 94 131 223 196 253 53 112 27 0 32 250 1 90 9 128 11 156 119 97 23 152 115 79 37 118 236 182 99 226 188 97 155 254 43 205 250 178 107 138 149 210 139 69 11 132 45 130 26 222 58 174 45 113 30 199 148 56 46 73 19 83 22 198 10 99 71 38 70 198 176 88 140 225 3 154 1 109 157 200 165 155 43 110 210 1 128 165 81 5 78 245 21 241 105 31 180 74 47 242 182 123 144 231 32 88 27 56 223 10 142 19 107 113 33 87 179 19 217 63 178 35 106 7 200 6 34 175 249 163 234 154 252 5 201 217 252 218 156 118 193 140 172 245 153 15 113 107 147 203 227 124 73 202 152 50 150 44 134 71 71 158 56 47 98 12 25 112 0 45 0 128 33 115 99 217 29 0 188 255 4 216 79 0 156 0 224 68 206 230 74 100 221 69 33 227 59 122 90 54 36 242 196 121 238 152 164 109 169 158 132 249 172 138 7 124 17 73 67 4 119 69 54 193 17 32 25 32 0 144 5 200 64 16 192 25 200 64 23 100 224 48 68 191 221 141 220 7 220 216 213 230 162 139 213 190 219 134 168 93 22 100 216 86 113 67 179 161 236 122 233 31 100 151 139 22 11 219 114 159 228 53 113 220 9 11 217 182 184 135 227 213 49 170 187 38 155 96 0 253 28 144 208 28 81 19 28 228 34 203 171 0 240 177 249 214 28 128 26 128 46 4 237 18 0 14 3 64 59 68 191 205 137 109 123 172 216 178 203 132 12 239 234 144 122 131 242 75 136 252 121 241 130 188 174 252 217 252 173 89 143 114 231 39 104 99 199 198 105 162 203 19 74 163 179 239 154 108 238 4 80 1 0 84 48 0 105 163 39 1 0 86 105 207 17 208 252 33 40 218 3 78 76 65 171 52 252 169 2 105 94 47 67 138 213 146 75 226 5 130 46 126 53 119 119 230 120 206 114 182 131 53 62 60 57 188 112 88 202 176 52 38 155 25 53 160 90 255 161 47 211 66 6 192 154 180 36 3 180 132 32 3 23 97 10 147 65 214 3 0 176 78 187 14 87 34 59 172 204 214 189 20 134 200 127 173 217 164 188 94 178 90 114 185 104 73 193 97 136 252 219 89 227 216 47 166 249 82 106 82 204 241 150 17 156 17 217 0 145 20 147 21 243 67 43 244 61 125 167 219 3 115 194 77 0 52 0 80 14 0 230 70 56 27 109 54 225 42 56 23 242 159 131 5 237 12 204 128 110 24 82 135 236 152 106 54 35 195 206 10 164 222 162 188 174 88 13 178 89 36 232 206 127 58 251 109 254 164 180 101 108 43 107 74 146 49 214 17 175 136 151 132 39 133 39 147 118 201 72 102 132 255 91 208 224 88 30 99 124 15 57 142 36 215 1 57 166 87 3 0 88 147 26 0 76 175 1 64 11 0 192 185 144 31 126 208 248 122 1 0 22 53 123 187 21 27 119 235 81 249 59 42 84 210 40 189 92 184 88 208 157 51 149 187 39 243 33 246 202 84 59 171 154 201 141 208 48 211 134 11 65 54 35 153 28 230 253 241 241 241 17 119 108 151 0 64 156 191 125 68 63 16 207 25 250 1 52 181 66 26 192 177 207 132 253 151 97 120 157 131 162 61 229 192 142 14 152 176 187 97 72 189 89 118 85 177 70 114 161 104 105 65 91 126 45 20 236 4 206 138 180 64 74 13 219 144 80 201 100 15 23 70 114 35 51 98 57 177 9 177 252 216 17 28 14 39 140 161 100 220 23 146 12 104 231 228 131 132 10 154 8 128 113 109 41 0 24 177 239 11 15 118 125 234 192 182 78 10 153 219 12 168 252 221 178 171 197 175 72 78 23 52 140 58 144 59 139 183 49 123 50 119 62 219 201 26 79 52 31 167 140 150 146 200 63 192 30 206 34 209 79 79 79 31 38 18 137 200 176 250 161 71 82 3 93 3 183 0 202 107 11 104 0 123 171 17 123 224 39 165 163 215 134 205 71 140 168 226 99 13 42 221 40 187 32 92 148 123 32 253 193 148 55 82 125 137 243 147 42 98 71 135 167 132 139 65 235 89 68 243 76 38 243 254 216 216 216 17 196 121 151 235 246 19 156 129 41 210 31 107 101 244 28 128 65 166 135 65 102 124 73 129 45 219 52 200 218 110 66 166 189 186 175 117 239 171 175 171 223 40 189 92 188 186 176 45 191 142 191 145 11 206 67 171 156 192 42 139 173 136 76 141 204 138 98 69 177 71 164 143 0 223 99 71 36 39 39 135 147 200 223 46 80 70 136 158 163 153 224 96 203 84 39 105 50 213 73 145 97 105 49 210 175 41 65 186 215 203 110 150 111 40 249 82 245 170 252 124 201 202 162 19 146 197 5 91 115 103 100 209 145 103 149 199 86 36 202 152 5 36 242 196 249 40 110 20 147 163 228 132 241 249 252 161 12 23 131 60 43 32 145 15 77 244 73 118 130 15 119 13 243 101 168 252 183 69 55 75 159 19 127 167 88 36 186 36 111 200 239 46 154 147 183 87 56 35 103 69 246 216 145 227 161 88 69 36 242 209 208 231 137 222 233 130 5 231 201 147 26 34 157 1 105 139 63 38 153 127 253 123 48 128 254 25 201 13 85 189 232 154 172 62 239 115 201 28 65 123 225 204 81 219 242 107 178 87 142 154 200 171 73 119 167 192 144 26 10 91 101 24 59 129 200 6 156 79 150 38 135 243 93 240 148 166 95 247 3 209 22 255 23 128 138 57 69 127 45 253 77 222 167 226 199 179 59 10 166 241 222 16 60 146 177 132 87 149 54 57 195 201 177 167 26 227 37 209 32 155 8 110 68 92 116 122 244 47 191 39 155 91 142 135 78 54 193 144 193 25 208 205 22 255 69 62 45 231 104 238 67 220 247 121 1 206 178 145 166 196 137 204 44 166 138 153 193 204 103 102 14 27 201 100 51 162 98 178 24 145 131 46 155 96 0 115 157 92 6 207 6 166 91 235 229 155 0 96 149 124 106 206 179 0 240 84 86 21 231 193 84 51 75 23 149 29 149 3 16 169 36 242 241 241 140 136 100 88 17 72 183 25 84 217 4 3 88 103 151 164 16 8 123 131 194 85 241 148 152 130 12 232 114 39 164 150 102 123 57 5 233 250 148 52 226 56 189 30 8 24 17 12 62 99 40 61 97 73 183 25 76 217 220 161 78 130 167 99 191 158 7 71 211 255 109 17 255 255 243 119 41 2 255 0 93 132 235 124 102 146 56 126 0 0 0 0 73 69 78 68 174 66 96 130]!

stop
	^self icons at: #stop ifAbsentPut: [self stopResource]!

stopResource
	"Private - Generated from:
	self createIconMethodOfSize: 48@48 fromFile: 'Stop.png'.
	"
	^InternalIcon fromBytes: #[137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 48 0 0 0 48 8 6 0 0 0 87 2 249 135 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 9 112 72 89 115 0 0 14 194 0 0 14 194 1 21 40 74 128 0 0 11 65 73 68 65 84 104 67 221 154 107 83 147 215 22 199 61 223 227 244 123 212 23 231 140 87 16 36 120 35 128 129 152 64 32 16 72 8 23 5 2 4 16 21 84 188 160 104 171 181 181 181 218 218 240 117 58 199 34 17 84 8 40 222 166 19 208 119 39 235 252 255 251 217 59 121 114 37 237 248 230 216 153 223 60 79 210 25 179 126 123 175 189 246 218 91 119 237 250 18 254 91 11 133 254 185 22 234 251 122 35 212 91 151 8 134 157 121 4 240 29 81 255 47 136 247 108 94 226 115 134 0 222 53 126 60 179 240 227 115 54 43 62 191 115 197 231 43 130 215 185 226 114 57 87 234 234 156 43 181 181 206 231 14 199 215 241 35 71 190 202 27 115 6 191 30 10 247 174 5 195 177 117 59 221 248 76 2 164 39 182 214 77 130 177 181 64 46 221 248 78 211 25 136 173 105 86 253 129 152 69 103 236 133 194 111 209 110 104 143 189 240 17 95 236 185 102 25 207 101 95 107 108 185 149 120 99 203 46 87 108 185 174 46 182 92 83 67 250 158 215 212 236 150 93 187 254 145 37 193 145 93 15 245 254 150 8 246 254 23 164 210 116 227 189 59 156 74 116 145 158 20 4 64 40 181 214 69 130 41 136 40 86 3 221 25 58 187 82 171 154 151 29 129 148 69 103 10 2 160 195 162 221 175 105 79 61 111 35 109 169 21 226 243 165 32 0 90 83 16 0 45 169 229 38 87 10 2 169 101 135 35 69 137 21 135 163 190 176 0 70 158 129 191 30 24 148 183 145 168 124 152 60 39 31 38 200 148 124 24 183 120 63 113 214 98 124 210 34 58 161 120 23 29 207 48 134 119 69 84 222 141 146 49 48 42 111 71 200 136 69 36 146 230 205 112 68 222 12 15 91 12 13 201 38 57 61 32 155 189 189 178 25 10 202 122 107 139 172 54 54 10 2 151 149 154 154 133 29 4 194 169 183 145 49 249 115 250 146 124 154 255 38 135 219 242 233 38 185 101 113 99 62 195 220 77 249 100 184 126 67 62 105 62 94 159 19 197 181 235 22 87 175 89 92 185 170 185 130 167 197 54 153 157 181 56 127 94 182 199 199 101 27 50 239 3 1 89 111 106 42 95 224 195 228 148 10 92 30 199 242 249 245 55 17 197 99 145 95 200 175 22 143 126 201 240 16 239 138 71 154 135 34 63 255 108 241 224 129 197 79 63 21 230 199 31 69 200 237 219 34 16 146 169 41 217 230 76 120 60 127 83 224 17 130 123 128 0 238 227 7 201 15 248 195 21 247 69 190 39 63 88 220 251 62 195 119 120 87 220 179 184 251 29 184 43 114 135 220 177 248 246 91 27 24 172 111 52 12 156 92 187 38 114 233 34 4 206 66 32 12 129 83 178 236 168 65 10 29 46 145 66 168 48 9 44 82 230 252 167 121 252 33 156 1 6 127 15 129 222 198 143 222 198 143 222 194 15 221 194 255 35 243 183 50 220 156 23 49 220 184 41 66 230 110 104 230 68 144 70 114 253 58 2 51 32 64 6 121 245 170 6 163 205 17 191 50 43 130 20 146 139 51 34 23 206 67 96 82 182 122 123 228 181 199 13 129 195 242 12 2 113 71 117 145 69 92 72 128 163 206 224 175 224 135 175 224 7 103 241 131 179 248 33 114 25 63 100 184 116 25 35 166 185 120 9 1 128 25 140 32 153 70 48 228 194 180 141 11 120 7 200 117 57 127 78 228 220 148 74 23 142 184 156 37 147 42 120 153 154 128 64 8 2 205 242 204 81 13 129 170 29 4 80 30 63 140 159 197 12 96 116 31 35 215 239 51 31 49 242 12 30 11 47 29 188 93 160 88 224 51 58 240 105 19 56 3 54 48 112 112 206 4 111 11 124 18 129 79 78 64 130 140 203 86 56 8 129 38 8 84 149 16 192 78 170 54 39 8 188 167 0 170 140 90 172 204 119 166 141 26 121 112 217 54 242 133 70 189 232 200 219 2 87 65 3 53 226 122 212 213 200 35 112 194 224 21 227 10 37 112 202 8 28 194 12 84 22 72 33 35 128 77 233 125 116 18 2 200 105 86 26 46 86 230 123 169 180 41 150 50 89 35 111 27 113 19 184 74 149 2 129 79 32 112 69 84 177 213 211 13 1 23 102 224 16 102 160 44 129 9 212 119 44 66 150 71 86 24 166 83 58 101 202 200 117 6 174 130 183 229 121 161 81 255 43 2 238 147 8 190 178 184 0 27 49 246 50 108 9 222 141 105 1 214 118 35 144 181 88 177 64 47 233 133 90 114 177 22 73 155 98 129 51 101 108 35 47 19 99 248 60 134 25 232 146 87 16 136 67 32 126 184 98 33 94 93 32 133 178 5 198 177 171 162 4 114 35 98 125 103 58 81 64 229 60 3 71 101 33 69 171 140 189 194 232 133 90 44 109 114 115 190 152 64 115 35 131 223 65 160 19 51 128 38 140 61 76 70 0 27 17 5 24 124 86 174 155 10 195 167 73 25 157 54 170 52 154 10 99 22 107 145 124 183 45 86 147 243 50 142 145 87 140 42 182 66 1 121 181 163 0 122 246 85 180 192 47 41 128 6 140 253 139 60 196 38 198 157 148 235 33 45 192 145 71 208 121 37 210 4 175 107 123 110 206 155 180 81 37 210 94 105 80 109 236 139 118 28 11 183 128 192 70 83 131 44 85 31 148 120 213 193 133 197 234 3 249 85 136 135 14 246 237 108 125 217 61 102 4 208 6 80 32 47 215 109 181 221 44 86 179 49 217 75 164 61 223 237 129 167 131 206 84 155 116 224 81 140 188 98 68 177 21 236 148 191 47 192 62 6 93 166 204 32 247 167 205 174 154 83 101 184 229 219 211 166 80 109 231 166 148 149 46 246 5 107 75 25 91 224 18 141 64 32 2 129 14 8 212 99 6 14 148 158 1 235 196 212 153 98 223 206 214 87 117 143 108 194 184 160 211 193 155 150 64 47 212 116 240 122 71 85 45 129 201 119 60 237 41 51 145 147 46 172 243 233 148 177 141 250 24 70 126 204 10 94 162 195 146 164 128 203 41 79 171 14 128 253 197 83 168 160 0 59 72 244 246 114 1 163 127 161 64 240 74 192 214 14 216 119 212 146 21 198 218 164 210 139 85 167 139 10 92 49 172 130 151 232 16 4 252 16 168 99 240 59 8 168 115 106 71 234 237 224 144 124 100 137 100 219 139 195 135 234 95 34 24 161 8 70 6 39 41 137 224 15 38 195 67 25 134 6 69 6 207 88 156 57 157 1 39 43 81 244 139 12 144 190 108 250 123 241 57 44 210 175 233 235 17 81 132 240 29 9 74 178 205 35 27 245 71 75 11 240 102 128 7 237 231 56 171 190 25 24 144 143 156 250 107 232 125 152 18 56 234 73 8 127 24 9 6 109 116 227 29 116 119 137 116 5 108 116 226 93 19 232 16 81 248 69 58 73 187 69 71 91 14 62 17 63 105 21 105 215 248 91 240 185 69 146 238 6 89 63 238 144 197 67 251 201 194 98 101 129 42 164 4 112 59 192 3 246 155 112 88 62 114 164 153 26 28 101 156 75 165 197 107 225 245 100 192 33 67 12 167 220 34 105 154 241 174 113 55 137 40 92 34 205 228 164 69 83 99 6 212 120 33 234 187 6 17 151 6 11 87 64 210 121 84 214 107 171 118 22 120 14 129 21 35 128 131 183 58 80 48 85 122 48 242 56 88 43 140 136 122 66 134 40 41 155 12 14 31 146 6 34 232 229 5 221 164 130 34 74 70 139 240 137 54 65 161 190 179 139 65 164 185 1 2 199 180 192 62 72 236 43 54 3 62 39 239 101 86 124 109 169 205 112 175 108 143 66 96 6 229 146 79 28 233 164 13 211 235 35 152 222 86 162 133 90 33 66 140 76 238 147 98 10 35 149 35 100 151 50 114 233 167 37 150 172 63 38 137 35 85 242 71 37 4 42 246 45 252 167 114 111 254 70 198 155 49 235 66 73 11 140 97 209 242 88 199 103 31 22 90 59 114 182 141 216 68 218 32 210 6 17 31 209 34 70 40 253 196 236 180 114 166 32 65 40 162 100 180 136 125 118 204 44 165 159 152 41 180 209 201 250 227 90 96 47 4 246 148 16 80 55 97 62 107 6 198 176 185 240 80 29 69 169 99 245 232 192 2 244 131 14 44 64 63 129 140 66 47 190 118 60 137 146 178 3 57 37 9 65 37 169 133 90 33 99 48 114 45 16 51 40 81 72 130 100 195 137 50 4 188 94 167 117 149 215 10 129 176 108 71 33 112 25 13 28 183 124 150 193 0 170 138 194 84 21 93 89 236 213 133 114 134 60 65 93 89 40 147 139 145 83 79 8 250 32 167 128 68 171 91 146 39 235 36 113 180 90 254 168 216 83 98 6 40 224 197 61 100 75 139 22 192 200 243 118 128 229 148 181 157 165 146 4 81 46 13 221 16 50 228 150 77 85 50 11 148 77 51 99 29 152 45 131 249 142 37 84 149 78 136 180 19 200 96 15 72 98 23 46 91 224 89 139 55 181 137 69 203 91 49 117 229 97 246 1 86 162 30 148 83 5 106 63 9 65 200 16 164 28 37 181 96 90 14 51 213 69 32 195 217 202 3 179 22 48 32 37 59 33 102 232 128 16 72 162 18 37 142 29 46 61 3 113 204 192 51 175 39 246 204 235 77 189 198 77 216 22 71 126 14 45 53 59 76 83 137 88 141 112 71 147 1 82 184 242 16 28 186 21 70 12 39 40 33 74 14 66 36 119 214 208 97 138 161 27 130 221 144 75 3 161 46 2 161 64 27 54 178 70 73 28 175 41 79 32 238 245 164 94 163 234 108 177 13 190 201 54 26 149 200 44 100 182 1 253 4 85 73 145 179 253 83 134 244 65 134 244 18 204 84 88 147 22 212 51 168 62 83 22 130 61 16 34 33 27 104 226 4 36 61 46 73 156 112 148 33 224 241 196 226 158 83 150 0 91 226 121 30 37 209 70 179 139 84 253 141 173 175 97 111 115 26 50 100 128 253 140 238 105 216 215 12 96 150 72 63 161 144 198 8 42 49 155 32 37 123 33 66 194 54 148 88 64 146 45 205 146 168 171 221 65 192 237 118 46 121 220 177 37 8 188 50 2 188 163 156 69 37 98 87 57 140 102 109 8 139 153 12 66 102 16 50 20 58 3 17 50 8 145 51 6 200 156 1 167 53 185 114 74 76 55 108 74 78 207 88 145 103 18 149 168 60 1 55 4 78 185 45 1 158 170 120 225 122 21 23 89 92 200 35 236 64 209 23 17 202 12 107 153 33 200 144 97 200 24 134 32 68 6 53 74 210 38 119 26 179 68 204 76 237 240 100 55 154 112 30 41 99 6 220 205 16 104 182 4 216 200 221 193 149 34 59 82 190 143 162 185 163 68 90 132 18 90 132 50 17 72 24 210 34 144 26 50 104 169 33 136 112 182 6 245 44 113 166 118 32 137 146 154 64 59 93 114 31 88 116 187 156 75 16 120 234 110 78 109 96 129 110 177 145 187 139 243 192 28 206 3 211 120 55 167 36 138 140 66 132 140 96 54 12 17 200 40 40 147 43 196 25 178 205 82 122 134 140 76 233 103 18 123 67 153 2 46 8 52 89 2 12 250 30 78 99 55 112 180 156 65 41 53 103 85 35 194 83 147 17 201 146 129 196 8 129 68 30 144 24 49 51 101 75 57 123 250 21 120 79 98 47 72 52 28 43 103 6 44 129 85 180 11 111 81 101 182 120 177 138 156 223 162 16 234 184 2 27 20 73 18 108 80 105 176 65 37 21 237 26 212 111 214 112 133 47 27 108 84 201 78 108 80 220 164 202 96 19 27 217 139 157 54 50 43 133 44 129 21 244 242 107 232 38 95 161 57 123 133 246 120 3 221 225 134 171 17 52 168 235 13 222 16 108 184 192 73 167 172 55 90 108 160 95 49 172 55 158 192 119 4 93 100 131 29 180 197 24 201 191 10 131 143 215 84 148 63 3 75 245 117 18 63 90 139 43 12 220 69 130 165 170 138 12 184 92 226 5 211 211 42 112 232 128 224 120 167 120 138 227 158 97 145 125 187 98 47 126 148 236 249 108 20 109 167 159 184 79 238 94 106 118 245 97 6 22 226 206 186 133 248 145 218 133 120 21 46 82 243 56 136 239 14 46 64 96 1 1 47 44 86 88 240 221 192 67 135 197 158 207 206 147 131 123 250 159 84 238 207 255 139 238 223 27 26 190 138 67 34 142 13 109 209 121 162 62 126 212 81 207 91 96 178 152 197 1 124 214 224 112 205 3 118 62 123 241 157 5 79 79 159 147 39 149 255 222 253 123 197 191 242 255 169 1 255 218 158 127 251 253 255 192 151 240 111 83 190 44 135 255 1 58 18 247 46 176 68 57 88 0 0 0 0 73 69 78 68 174 66 96 130]! !
!SeasideIcons class categoriesFor: #icon!constants!public! !
!SeasideIcons class categoriesFor: #icons!private! !
!SeasideIcons class categoriesFor: #jQuery!constants!public! !
!SeasideIcons class categoriesFor: #jQueryResource!constants!private! !
!SeasideIcons class categoriesFor: #pharo!constants!public! !
!SeasideIcons class categoriesFor: #pharoResource!constants!public! !
!SeasideIcons class categoriesFor: #scriptaculous!constants!public! !
!SeasideIcons class categoriesFor: #scriptaculousResource!constants!private! !
!SeasideIcons class categoriesFor: #seaside!constants!public! !
!SeasideIcons class categoriesFor: #seasideResource!constants!public! !
!SeasideIcons class categoriesFor: #start!constants!public! !
!SeasideIcons class categoriesFor: #startResource!constants!private! !
!SeasideIcons class categoriesFor: #stop!constants!public! !
!SeasideIcons class categoriesFor: #stopResource!constants!private! !

"Binary Globals"!

