| package |
package := Package name: 'Seaside-Dolphin-Email'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '6'.


package classNames
	add: #WAEmailErrorHandler;
	yourself.

package methodNames
	add: #GRDolphinPlatform -> #seasideDeliverEmailMessage:;
	add: 'GRPackage class' -> #seasideDolphinEmail;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: '..\Grease\Grease-Dolphin-Core';
	add: 'Seaside-Core';
	add: 'Seaside-Email';
	yourself).

package!

"Class Definitions"!

WAErrorHandler subclass: #WAEmailErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRDolphinPlatform methodsFor!

seasideDeliverEmailMessage: aWAEmailMessage

	self
		deliverMailFrom: aWAEmailMessage from greaseString
		to: aWAEmailMessage recipients
		text: aWAEmailMessage plainMessage
! !
!GRDolphinPlatform categoriesFor: #seasideDeliverEmailMessage:!email!public! !

!GRPackage class methodsFor!

seasideDolphinEmail
	^(self new)
		name: 'Seaside-Dolphin-Email';
		description: 'Pharo implementation classes for the package "Seaside-Email".';
		addDependency: 'Seaside-Email';
		addDependency: 'Seaside-Dolphin-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideDolphinEmail!*seaside-pharo-email!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

WAEmailErrorHandler guid: (GUID fromString: '{2CE7C281-3AEE-4D73-BE83-FEF494A6D2CA}')!
WAEmailErrorHandler comment: '
A WAEmailErrorHandler is an error handler that sends out email messages with the stack strace. This is an abstract class that has to be subclassed. Subclasses must override #to and #from that return an instance of WAEmailAddress. It''s also recommened to override #handleDefault: to generate a custom HTML response.
'!
!WAEmailErrorHandler categoriesForClass!Unclassified! !
!WAEmailErrorHandler methodsFor!

bodyFor: anError
	^WAStringEmailBody string: (String streamContents: [ :stream |
		anError signalerContext errorReportOn: stream ])!

from
	"ansers the WAEmailAddress instance used as a sender addresst"
	self subclassResponsibility!

handleError: anException
	self sendFailFor: anException.
	^super handleError: anException!

sendFailFor: anError
	| message |
	message := WAEmailMessage
		from: self from
		to: self to
		subject: (self subjectFor: anError).
	message body: (self bodyFor: anError).
	message send!

subjectFor: anError
	^anError signalerContext printString!

to
	"ansers the WAEmailAddress instance to which the error mail should be sent"
	self subclassResponsibility! !
!WAEmailErrorHandler categoriesFor: #bodyFor:!private! !
!WAEmailErrorHandler categoriesFor: #from!private! !
!WAEmailErrorHandler categoriesFor: #handleError:!actions!public! !
!WAEmailErrorHandler categoriesFor: #sendFailFor:!private! !
!WAEmailErrorHandler categoriesFor: #subjectFor:!private! !
!WAEmailErrorHandler categoriesFor: #to!private! !

"Binary Globals"!

