| package |
package := Package name: 'Seaside-Examples'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '19'.


package classNames
	add: #WACounter;
	add: #WAExampleBrowser;
	add: #WAExampleComponent;
	add: #WAFileLibraryDemo;
	add: #WAMultiCounter;
	yourself.

package methodNames
	add: 'GRPackage class' -> #seasideExamples;
	add: 'WAComponent class' -> #headerForExampleBrowser;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: 'Seaside-Canvas';
	add: 'Seaside-Component';
	add: 'Seaside-Core';
	add: 'Seaside-Tools-Core';
	yourself).

package!

"Class Definitions"!

WAFileLibrary subclass: #WAFileLibraryDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #WAExampleComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAExampleComponent subclass: #WACounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAExampleComponent subclass: #WAExampleBrowser
	instanceVariableNames: 'class selector component hasAnswer answer'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAExampleComponent subclass: #WAMultiCounter
	instanceVariableNames: 'counters'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

seasideExamples
	^ self new
		name: 'Seaside-Examples';
		description: 'Simple example applications and components.';
		addDependency: 'Seaside-Component';
		addDependency: 'Seaside-Canvas';
		addDependency: 'Seaside-Tools-Core'; "for WAAdmin"
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideExamples!*seaside-examples!public! !

!WAComponent class methodsFor!

headerForExampleBrowser
	^self name = self description
		ifTrue: [ self name ]
		ifFalse: [ self description , ' (' , self name , ')' ]! !
!WAComponent class categoriesFor: #headerForExampleBrowser!*seaside-examples-misc!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

WAFileLibraryDemo guid: (GUID fromString: '{BE24F7EC-F195-4293-816C-3934D991B14B}')!
WAFileLibraryDemo comment: ''!
!WAFileLibraryDemo categoriesForClass!Unclassified! !
!WAFileLibraryDemo methodsFor!

mainCss
	^'/* Pier

   Copyright (c) 2003-2006 Lukas Renggli
   Copyright (c) 2005-2006 Software Composition Group, University of Berne
*/

* {
	margin: 0px;
	padding: 0px;
}

body {
	font-family: "Helvetica Neue", Helvetica, Verdana, Arial, sans-serif;
	font-size: 12px;
	color: #111111;
	margin: 10px;
}

img {
	border: none;
}

td,
th {
	text-align: left;
	vertical-align: top;
}

a {
	text-decoration: none;
	color: #092565;
}

a:hover {
	text-decoration: underline;
}

.broken {
    color: #aa0000;
}

.protected {
    color: #aaaaaa;
}'!

mainJpg
	^ #(255 216 255 224 0 16 74 70 73 70 0 1 1 1 0 72 0 72 0 0 255 225 0 22 69 120 105 102 0 0 77 77 0 42 0 0 0 8 0 0 0 0 0 0 255 219 0 67 0 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 255 219 0 67 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 255 192 0 17 8 0 4 2 152 3 1 34 0 2 17 1 3 17 1 255 196 0 24 0 1 0 3 1 0 0 0 0 0 0 0 0 0 0 0 0 0 1 7 9 10 255 196 0 38 16 0 2 3 0 1 1 8 3 1 0 0 0 0 0 0 0 0 1 17 81 145 7 2 6 8 9 40 49 54 116 195 65 103 129 183 255 196 0 20 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 255 196 0 20 17 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 255 218 0 12 3 1 0 2 17 3 17 0 63 0 235 191 191 103 181 250 190 7 87 216 85 254 17 73 62 9 229 249 83 230 63 181 191 230 188 74 0 26 177 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 94 137 47 225 32 0 0 0 0 0 132 253 84 145 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 132 42 88 128 1 10 150 33 10 150 32 0 66 165 136 66 165 136 0 16 169 98 16 169 98 0 4 42 88 140 168 241 117 73 112 55 16 66 75 204 143 100 255 0 31 173 121 108 0 44 254 226 126 215 233 248 29 63 88 0 15 255 217) asByteArray! !
!WAFileLibraryDemo categoriesFor: #mainCss!accessing!public! !
!WAFileLibraryDemo categoriesFor: #mainJpg!public!uploaded! !

WAExampleComponent guid: (GUID fromString: '{E0F93E15-5680-4FFE-A9E2-EEEA0FAC3BC8}')!
WAExampleComponent comment: ''!
!WAExampleComponent categoriesForClass!Unclassified! !
!WAExampleComponent methodsFor!

rendererClass
	^ WARenderCanvas! !
!WAExampleComponent categoriesFor: #rendererClass!public!rendering! !

!WAExampleComponent class methodsFor!

canBeRoot
	^ true! !
!WAExampleComponent class categoriesFor: #canBeRoot!public!testing! !

WACounter guid: (GUID fromString: '{D0602C87-6DDC-419B-9214-5653C98D941D}')!
WACounter comment: '
A WACounter is component that displays a number. Additionally it has two links that allow the user to increase or decrease this number by 1. 

The lesson to learn here is how the Seaside callback mechanism is used, how anchors can be used to trigger actions.

Instance Variables
	count:		<Integer>

count
	- the number to display, default 0
'!
!WACounter categoriesForClass!Unclassified! !
!WACounter methodsFor!

count
	^ count!

count: anInteger
	count := anInteger!

decrease
	count := count - 1!

increase
	count := count + 1!

initialize
	super initialize.
	self count: 0!

renderContentOn: html
	html heading: count.
	html anchor
		callback: [ self increase ];
		with: '++'.
	html space.
	html anchor
		callback: [ self decrease ];
		with: '--'!

states
	^ Array with: self! !
!WACounter categoriesFor: #count!accessing!public! !
!WACounter categoriesFor: #count:!accessing!public! !
!WACounter categoriesFor: #decrease!actions!public! !
!WACounter categoriesFor: #increase!actions!public! !
!WACounter categoriesFor: #initialize!initialization!public! !
!WACounter categoriesFor: #renderContentOn:!public!rendering! !
!WACounter categoriesFor: #states!accessing!public! !

!WACounter class methodsFor!

description
	^ 'A very simple Seaside application'!

example
	^ self new!

handlerName
	^'examples/counter'!

initialize
	WAAdmin register: self asApplicationAt: self handlerName! !
!WACounter class categoriesFor: #description!accessing!public! !
!WACounter class categoriesFor: #example!examples!public! !
!WACounter class categoriesFor: #handlerName!accessing!public! !
!WACounter class categoriesFor: #initialize!initialization!public! !

WAExampleBrowser guid: (GUID fromString: '{04E37215-0F32-45A7-9A97-AFFB591919E9}')!
WAExampleBrowser comment: '
I browse all the examples available in the system ie all the results of class methods beginning with #example... 

point your browser to localhost:xxx/seaside/examples

If you want to see these examples

/seaside/config app:
- add a new application named "examples"
- choose WAExampleBrowser as the root component
'!
!WAExampleBrowser categoriesForClass!Unclassified! !
!WAExampleBrowser methodsFor!

allClasses
	^ (WAComponent allSubclasses
		select: [ :each |
			each class selectors
				anySatisfy: [ :sel | sel beginsWithSubCollection: self selectorPrefix ] ])
		asSortedCollection: [ :a :b | a name < b name ]!

allSelectors
	^ (class class selectors select: [ :each | each beginsWithSubCollection: self selectorPrefix ]) sorted!

children
	^ Array with: component!

class: aClass
	class := aClass.
	self selector: self allSelectors first!

component: aComponent
	component := aComponent.
	hasAnswer := false.
	answer := nil.
	component onAnswer: [ :value | hasAnswer := true. answer := value ]!

initialize
	super initialize.
	self class: self allClasses first!

renderChooserOn: html
	html div class: 'chooser'; with: [
		html form: [
			html div: [
				html select
					selected: class;
					list: self allClasses;
					onChange: 'submit()';
					callback: [ :value | self class: value ] ] ].
		self allSelectors size > 1 ifTrue: [
			html form: [
				html div: [
					html select
						selected: selector;
						list: self allSelectors;
						onChange: 'submit()';
						callback: [ :value | self selector: value ] ] ] ] ]!

renderComponentOn: html

	html heading level4; with: component class headerForExampleBrowser.
	html div
		class: 'component';
		with: component.
	hasAnswer ifTrue: [
		html div
			class: 'answer';
			with: answer printString ]!

renderContentOn: html
	self renderChooserOn: html.
	self renderComponentOn: html!

selector: aSymbol
	selector := aSymbol.
	self component: (class perform: selector)!

selectorPrefix
	^ 'example'!

states
	^ Array with: self!

style
	^ '.chooser {
	background-color: #eee;
	padding: 5px;
}
.chooser form,
.chooser form div {
	display: inline;
}
.chooser form select {
	margin-right: 5px;
}
.component {
	padding: 5px;
}
.answer {
	background-color: #eee;
	padding: 5px;
}'! !
!WAExampleBrowser categoriesFor: #allClasses!helper!public! !
!WAExampleBrowser categoriesFor: #allSelectors!helper!public! !
!WAExampleBrowser categoriesFor: #children!accessing!public! !
!WAExampleBrowser categoriesFor: #class:!accessing!public! !
!WAExampleBrowser categoriesFor: #component:!accessing!public! !
!WAExampleBrowser categoriesFor: #initialize!initialization!public! !
!WAExampleBrowser categoriesFor: #renderChooserOn:!public!rendering! !
!WAExampleBrowser categoriesFor: #renderComponentOn:!public!rendering! !
!WAExampleBrowser categoriesFor: #renderContentOn:!public!rendering! !
!WAExampleBrowser categoriesFor: #selector:!accessing!public! !
!WAExampleBrowser categoriesFor: #selectorPrefix!helper!public! !
!WAExampleBrowser categoriesFor: #states!accessing!public! !
!WAExampleBrowser categoriesFor: #style!accessing!public! !

!WAExampleBrowser class methodsFor!

description
	^'Browse through Seaside examples'!

initialize
	WAAdmin register: self asApplicationAt: 'examples/examplebrowser'! !
!WAExampleBrowser class categoriesFor: #description!accessing!public! !
!WAExampleBrowser class categoriesFor: #initialize!class initialization!public! !

WAMultiCounter guid: (GUID fromString: '{7F586C30-23DF-4992-A1E4-212A4C4BB2DC}')!
WAMultiCounter comment: '
A WAMultiCounter is a component that consits of several instances of WACounter. Be sure to understand WACounter.

The lesson to learn here is how Seaside components can be composed of other components.

Instance Variables
	counters:		<Collection<WACounter>>

counters
	- a Collection of components (instances of WACounter) 
'!
!WAMultiCounter categoriesForClass!Unclassified! !
!WAMultiCounter methodsFor!

children
	^ counters!

initialize
	super initialize.
	counters := (1 to: 5) collect: [ :each | WACounter new ]!

renderContentOn: html
	counters
		do: [ :each | html render: each ]
		separatedBy: [ html horizontalRule ]! !
!WAMultiCounter categoriesFor: #children!accessing!public! !
!WAMultiCounter categoriesFor: #initialize!initialization!public! !
!WAMultiCounter categoriesFor: #renderContentOn:!public!rendering! !

!WAMultiCounter class methodsFor!

description
	^'Multiple Seaside components on one page'!

initialize
	WAAdmin register: self asApplicationAt: 'examples/multicounter'! !
!WAMultiCounter class categoriesFor: #description!accessing!public! !
!WAMultiCounter class categoriesFor: #initialize!initialization!public! !

"Binary Globals"!

