| package |
package := Package name: 'Seaside-Tests-Canvas'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '50'.


package classNames
	add: #WAAbstractCanvasBrushTest;
	add: #WABuilderCanvasTest;
	add: #WACanvasBrushTest;
	add: #WAEmailAddressTest;
	add: #WAFormCharEncodingFromCodecTest;
	add: #WAFormCharEncodingFromHandlerTest;
	add: #WAFormTagTest;
	add: #WAPredictableCache;
	add: #WARenderingTest;
	add: #WAResourceBaseUrlTest;
	yourself.

package methodNames
	add: 'GRPackage class' -> #seasideTestsCanvas;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: 'Seaside-Canvas';
	add: 'Seaside-Core';
	add: 'Seaside-Tests-Core';
	add: '..\..\Camp Smalltalk\SUnit\SUnit';
	yourself).

package!

"Class Definitions"!

WACache subclass: #WAPredictableCache
	instanceVariableNames: 'nextKey'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #WAEmailAddressTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAContextTest subclass: #WAAbstractCanvasBrushTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAContextTest subclass: #WABuilderCanvasTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAContextTest subclass: #WARenderingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAAbstractCanvasBrushTest subclass: #WACanvasBrushTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAAbstractCanvasBrushTest subclass: #WAFormCharEncodingFromCodecTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAAbstractCanvasBrushTest subclass: #WAFormCharEncodingFromHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasBrushTest subclass: #WAFormTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasBrushTest subclass: #WAResourceBaseUrlTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

seasideTestsCanvas
	^ self new
		name: 'Seaside-Tests-Canvas';
		description: 'Unit tests for the package Seaside-Canvas.';
		addDependency: 'Seaside-Canvas';
		addDependency: 'Seaside-Tests-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideTestsCanvas!*seaside-tests-canvas!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

WAPredictableCache guid: (GUID fromString: '{EA88A0B2-EDA1-43FF-838F-532BE6AA6388}')!
WAPredictableCache comment: '
A WAPredictableCache is a WACache that uses incrementing numbers as cache keys. This way the keys are predictable. This is useful for tests.
'!
!WAPredictableCache categoriesForClass!Unclassified! !
!WAPredictableCache methodsFor!

initialize
	super initialize.
	nextKey := 1!

store: anObject
	"Store anObject in the cache, generating a new random key. Return the key."
	
	| key |
	mutex critical: [
		key := nextKey greaseString.
		nextKey := nextKey + 1.
		objectsByKey at: key put: anObject.
		keysByObject at: anObject put: key.
		self notifyStored: anObject key: key ].
	
	^ key! !
!WAPredictableCache categoriesFor: #initialize!initialization!public! !
!WAPredictableCache categoriesFor: #store:!public! !

WAEmailAddressTest guid: (GUID fromString: '{FA139199-1118-4559-86C0-0198543F6128}')!
WAEmailAddressTest comment: ''!
!WAEmailAddressTest categoriesForClass!Unclassified! !
!WAEmailAddressTest methodsFor!

render: anObject
	^ WARenderer builder
		documentClass: WAHtmlDocument;
		render: anObject!

testAddress
	| address |
	address := WAEmailAddress address: 'philippe.marschall@gmail.com'.
	self assert: address address = 'philippe.marschall@gmail.com'.
	self assert: address username isNil.
	self assert: address greaseString = 'philippe.marschall@gmail.com'!

testAddressUsername
	| address |
	address := WAEmailAddress 
		address: 'philippe.marschall@gmail.com'
		username: 'Philippe Marschall'.
	self assert: address address = 'philippe.marschall@gmail.com'.
	self assert: address username = 'Philippe Marschall'.
	self assert: address greaseString = '"Philippe Marschall" <philippe.marschall@gmail.com>'!

testEmpty
	| address |
	address := WAEmailAddress address: (String 
			with: Character cr
			with: Character lf) , 'philippe.marschall@gmail.com'.
	self assert: address address = ''.
	self assert: address username isNil.
	self assert: address greaseString = ''!

testGreaseString
	| address |
	address := WAEmailAddress 
		address: 'philippe.marschall@gmail.com'
		username: 'Philippe Marschall'.
	self assert: address greaseString = '"Philippe Marschall" <philippe.marschall@gmail.com>'!

testInjection
	| address |
	address := WAEmailAddress address: 'philippe.marschall@gmail.com' , (String 
				with: Character cr
				with: Character lf) , 'Evil-Header: evil-value'.
	self assert: address address = 'philippe.marschall@gmail.com'.
	self assert: address username isNil.
	self assert: address greaseString = 'philippe.marschall@gmail.com'!

testRendering
	| address |
	address := WAEmailAddress
		address: 'philippe.marschall@gmail.com'
		username: 'Philippe Marschall'.
	self assert: address address = 'philippe.marschall@gmail.com'.
	self assert: address username = 'Philippe Marschall'.
	self assert: (self render: address) = 'Philippe Marschall &lt;philippe.marschall@gmail.com&gt;'.! !
!WAEmailAddressTest categoriesFor: #render:!private! !
!WAEmailAddressTest categoriesFor: #testAddress!public!tests! !
!WAEmailAddressTest categoriesFor: #testAddressUsername!public!tests! !
!WAEmailAddressTest categoriesFor: #testEmpty!public!tests! !
!WAEmailAddressTest categoriesFor: #testGreaseString!public!tests! !
!WAEmailAddressTest categoriesFor: #testInjection!public!tests! !
!WAEmailAddressTest categoriesFor: #testRendering!public!tests! !

WAAbstractCanvasBrushTest guid: (GUID fromString: '{9850B032-18F2-468D-BCA2-283020876B07}')!
WAAbstractCanvasBrushTest comment: ''!
!WAAbstractCanvasBrushTest categoriesForClass!Unclassified! !
!WAAbstractCanvasBrushTest methodsFor!

assert: aBlock gives: aString
	| html |
	html := self builder
		render: aBlock.
	self
		assert: html = aString
		description:	'Expected: ' , aString printString , ', Actual: ' , html printString
		resumable: true!

builder
	^ WARenderCanvas builder! !
!WAAbstractCanvasBrushTest categoriesFor: #assert:gives:!private! !
!WAAbstractCanvasBrushTest categoriesFor: #builder!private! !

!WAAbstractCanvasBrushTest class methodsFor!

isAbstract
	^ self name = #WAAbstractCanvasBrushTest! !
!WAAbstractCanvasBrushTest class categoriesFor: #isAbstract!public!testing! !

WABuilderCanvasTest guid: (GUID fromString: '{465E4633-3E09-4806-A9DD-CCEE7DAC56A3}')!
WABuilderCanvasTest comment: ''!
!WABuilderCanvasTest categoriesForClass!Unclassified! !
!WABuilderCanvasTest methodsFor!

testBody
	| actual |
	actual := WARenderCanvas builder render: [ :html |
		html unorderedList: [
			html listItem: 'an item' ] ].
	self assert: actual = '<ul><li>an item</li></ul>'!

testFullDocument
	| actual |
	actual := WARenderCanvas builder fullDocument: true; render: [ :html |
		html unorderedList: [
			html listItem: 'an item' ] ].
	self assert: actual = '<html><head><title></title></head><body onload="onLoad()"><ul><li>an item</li></ul><script type="text/javascript">/*<!![CDATA[*/function onLoad(){};/*]]>*/</script></body></html>'!

testFullDocumentWithBlock
	| actual |
	actual := WARenderCanvas builder fullDocument: true;
		rootBlock: [ :root |
			root title: 'title' ];
		render: [ :html |
			html unorderedList: [
				html listItem: 'an item' ] ].
	self assert: actual =  '<html><head><title>title</title></head><body onload="onLoad()"><ul><li>an item</li></ul><script type="text/javascript">/*<!![CDATA[*/function onLoad(){};/*]]>*/</script></body></html>'! !
!WABuilderCanvasTest categoriesFor: #testBody!public!tests! !
!WABuilderCanvasTest categoriesFor: #testFullDocument!public!tests! !
!WABuilderCanvasTest categoriesFor: #testFullDocumentWithBlock!public!tests! !

WARenderingTest guid: (GUID fromString: '{89798CA6-C6A3-481B-B3F2-53872666FB06}')!
WARenderingTest comment: ''!
!WARenderingTest categoriesForClass!Unclassified! !
!WARenderingTest methodsFor!

assert: aBlock gives: aString
	| html |
	html := WARenderCanvas builder
		fullDocument: true;
		rootBlock: aBlock;
		render: [ :canvas | ].
	self assert: '<html><head>' , aString , '</head><body onload="onLoad()"><script type="text/javascript">/*<!![CDATA[*/function onLoad(){};/*]]>*/</script></body></html>' = html!

testConditionalComment
	self
		assert: [ :html |
			html if greaterThan; orEqual; ie55; do: [
				html script
					defer;
					url: 'http://www.example.com/bugs.js' ] ]
		gives: '<title></title><!!--[if gte IE 5.5]><script defer="defer" src="http://www.example.com/bugs.js"></script><!![endif]-->'.
		
	self
		assert: [ :html |
			html if not; ie; do: [
				html script
					url: 'http://www.example.com/bugs.js' ] ]
		gives: '<title></title><!!--[if !! IE]><script src="http://www.example.com/bugs.js"></script><!![endif]-->'!

testContentType
	self
		assert: [ :html |
			html meta contentType: 'application/xhtml+xml' seasideMimeType  ]
		gives: '<title></title><meta http-equiv="Content-Type" content="application/xhtml+xml"/>'.
	self
		assert: [ :html |
			html meta contentType: 'application/xhtml+xml'  ]
		gives: '<title></title><meta http-equiv="Content-Type" content="application/xhtml+xml"/>'!

testJavascript
	self
		assert: [ :html |
			html javascript
				add: 'true & false'  ]
		gives: '<title></title><script type="text/javascript">/*<!![CDATA[*/true & false/*]]>*/</script>'!

testLinkElement
	self
		assert: [ :html |
			html stylesheet
				addAural;
				addTeletype;
				title: 'aTilte';
				url: 'http://example.com/style.css'  ]
		gives: '<title></title><link rel="stylesheet" type="text/css" media="aural, tty" title="aTilte" href="http://example.com/style.css"/>'!

testLinkElementWithContent
	self
		assert: [ :html |
			html stylesheet
				add: 'div > em { color: blue; }'  ]
		gives: '<title></title><style type="text/css">/*<!![CDATA[*/div > em { color: blue; }/*]]>*/</style>'.
	self
		assert: [ :html |
			html stylesheet
				add: 'E[foo$="bar"]'  ]
		gives: '<title></title><style type="text/css">/*<!![CDATA[*/E[foo$="bar"]/*]]>*/</style>'
	!

testRevealedConditionalComment
		self assert: [ :html |
			html revealedIf ie7; do: [
				html script
					defer;
					url: 'http://www.example.com/bugs.js' ] ]
		gives: '<title></title><!!--[if IE 7]><!!--><script defer="defer" src="http://www.example.com/bugs.js"></script><!!--<!![endif]-->'! !
!WARenderingTest categoriesFor: #assert:gives:!private! !
!WARenderingTest categoriesFor: #testConditionalComment!public!tests! !
!WARenderingTest categoriesFor: #testContentType!public!tests! !
!WARenderingTest categoriesFor: #testJavascript!public!tests! !
!WARenderingTest categoriesFor: #testLinkElement!public!tests! !
!WARenderingTest categoriesFor: #testLinkElementWithContent!public!tests! !
!WARenderingTest categoriesFor: #testRevealedConditionalComment!public!tests! !

WACanvasBrushTest guid: (GUID fromString: '{A55F8384-228C-4382-8CDC-E422D5A26314}')!
WACanvasBrushTest comment: ''!
!WACanvasBrushTest categoriesForClass!Unclassified! !
!WACanvasBrushTest methodsFor!

createHandlers
	^ Array with: (WARegistry new
		 cache: WAPredictableCache new;
		yourself)!

testAnchor
	self
		assert: [ :html | html anchor ]
		gives: '<a></a>'.
	self
		assert: [ :html | html anchor callback: [ ]; with: 'foo' ]
		gives: '<a href="/?1">foo</a>'.
	self
		assert: [ :html |
			html anchor callback: [ ]; with: 'foo'.
			html anchor callback: [ ]; with: 'bar' ]
		gives: '<a href="/?1">foo</a><a href="/?2">bar</a>'.
	self
		assert: [ :html |
			html anchor
				extraPath: 'zork';
				callback: [ ];
				with: 'foo'. ]
		gives: '<a href="/zork?1">foo</a>'.
	self
		assert: [ :html |
			html anchor
				extraParameters: 'zork';
				callback: [ ];
				with: 'foo'. ]
		gives: '<a href="/?zork&amp;1">foo</a>'!

testAnchorAttributes
	self
		assert: [ :html | html anchor charset: 'utf-8' ]
		gives: '<a charset="utf-8"></a>'.
	self
		assert: [ :html | html anchor name: 'foo' ]
		gives: '<a name="foo"></a>'.
	self
		assert: [ :html | html anchor relationship: 'home' ]
		gives: '<a rel="home"></a>'.
	self
		assert: [ :html | html anchor relationship: 'home'; relationship: 'parent' ]
		gives: '<a rel="home parent"></a>'.
	self
		assert: [ :html | html anchor reverse: 'home' ]
		gives: '<a rev="home"></a>'.
	self
		assert: [ :html | html anchor reverse: 'home'; reverse: 'parent' ]
		gives: '<a rev="home parent"></a>'.
	self
		assert: [ :html | html anchor target: '_new' ]
		gives: '<a target="_new"></a>'.
	self
		assert: [ :html | html anchor type: 'text/plain' ]
		gives: '<a type="text/plain"></a>'.
	self
		assert: [ :html | html anchor document: 'income: 1$' mimeType: 'text/plain' fileName: 'taxes.txt' ]
		gives: '<a type="text/plain" href="/?_key=1"></a>'.
	self
		assert: [ :html | html anchor document: 'income: 1$' mimeType: 'text/plain' ]
		gives: '<a type="text/plain" href="/?_key=2"></a>'.
	self
		assert: [ :html | html anchor document: 'income: 1$' ]
		gives: '<a href="/?_key=3"></a>'
!

testAnchorCallback
	self
		assert: [ :html | html anchor callback: [ ] ]
		gives: '<a href="/?1"></a>'.
		
	self
		assert: [ :html | 
			self 
				should: [ html anchor callback: [ :value | ] ]
				raise: Error ]
		gives: '<a></a>'!

testAnchorUrl
	| url string |
	url := WAUrl new.
	url
		host: 'www.seaside.st';
		addToPath: 'foo bar&zork<blah';
		addField: '1' value: nil;
		addField: '2' value: 123;
		addField: '3' value: 'foo bar&zork'.
	string := 'http://www.seaside.st/foo%20bar%26zork%3Cblah?1&amp;2=123&amp;3=foo%20bar%26zork'.
	self
		assert: [ :html | html anchor url: url; with: url ]
		gives: '<a href="' , string , '">' , string , '</a>'!

testBasicNesting
	self assert: [ :html | html div ] gives: '<div></div>'.
	self assert: [ :html | html div: 1 ] gives: '<div>1</div>'.
	self assert: [ :html | html div: 'foo' ] gives: '<div>foo</div>'!

testBlock
	self
		assert: [ :html | html strong: [ html text: 'nes'; text: 'sie' ] ]
		gives: '<strong>nessie</strong>'.
	self
		assert: [ :html | html strong: [ :html2 | html2 text: 'nes'; text: 'sie' ] ]
		gives: '<strong>nessie</strong>'.!

testBreakTag
	self
		assert: [ :html | html break ]
		gives: '<br/>'!

testButton
	self
		assert: [ :html | html button ]
		gives: '<button type="submit" class="submit"></button>'.
	self
		assert: [ :html | html button text: 'foo' ]
		gives: '<button type="submit" class="submit">foo</button>'.
	self
		assert: [ :html | html button with: 'foo' ]
		gives: '<button type="submit" class="submit">foo</button>'.
	self
		assert: [ :html | html button beSubmit ]
		gives: '<button type="submit" class="submit"></button>'.
	self
		assert: [ :html | html button bePush ]
		gives: '<button type="button" class="button"></button>'.
	self
		assert: [ :html | html button beReset ]
		gives: '<button type="reset" class="reset"></button>'!

testCancelButton
	self
		assert: [ :html | html cancelButton ]
		gives: '<input type="submit" class="submit"/>'.
	self
		assert: [ :html | html cancelButton callback: [ ] ]
		gives: '<input name="1" type="submit" class="submit"/>'.
	self
		assert: [ :html | html cancelButton on: #value of: self ]
		gives: '<input value="Value" name="1" type="submit" class="submit"/>'.
	self
		assert: [ :html | html cancelButton: 'foo' ]
		gives: '<input value="foo" type="submit" class="submit"/>'.
	self
		assert: [ :html | html cancelButton text: 'bar' ]
		gives: '<input value="bar" type="submit" class="submit"/>'.
	self
		assert: [ :html | html cancelButton with: 'zork' ]
		gives: '<input value="zork" type="submit" class="submit"/>'!

testCanvasHtml
	self assert: [ :html | html html: '<' ] gives: '<'.
	self assert: [ :html | html html: '>' ] gives: '>'.
	self assert: [ :html | html html: '"' ] gives: '"'.
	self assert: [ :html | html html: '&' ] gives: '&'.
	self
		assert: [ :html | html html: '<div title="&amp;">' ]
		gives: '<div title="&amp;">'!

testCanvasNil
	self assert: [ :html | html text: nil ] gives: ''.
	self assert: [ :html | html render: nil ] gives: ''!

testCanvasText
	self assert: [ :html | html text: '<' ] gives: '&lt;'.
	self assert: [ :html | html text: '>' ] gives: '&gt;'.
	self assert: [ :html | html text: '"' ] gives: '&quot;'.
	self assert: [ :html | html text: '&' ] gives: '&amp;'.
	self
		assert: [ :html | html text: '<div title="&amp;">' ]
		gives: '&lt;div title=&quot;&amp;amp;&quot;&gt;'!

testCanvasWithLineBreaks
	self
		assert: [ :html | html withLineBreaks: 'a
b
c' ] gives: 'a<br/>b<br/>c'!

testCanvasWithLineBreaksAndUrls
	self
		assert: [ :html | html withLineBreaksAndUrls: '1. This is http://www.seaside.st online.
2. This is http://www.squeak.org online.' ]
		gives: '1. This is <a href="http://www.seaside.st">http://www.seaside.st</a> online.<br/>2. This is <a href="http://www.squeak.org">http://www.squeak.org</a> online.'!

testCanvasWithUrls
	self
		assert: [ :html | html withUrls: 'This is http://www.seaside.st online.' ]
		gives: 'This is <a href="http://www.seaside.st">http://www.seaside.st</a> online.'!

testCheckboxTag
	self
		assert: [ :html | html checkbox ]
		gives: '<input type="checkbox" class="checkbox"/>'.
	self
		assert: [ :html | html checkbox value: true ]
		gives: '<input checked="checked" type="checkbox" class="checkbox"/>'.
	self
		assert: [ :html | html checkbox value: false; callback: [ :value | ] ]
		gives: '<input name="1" type="checkbox" class="checkbox"/><input name="2" type="hidden" class="hidden"/>'.
	self
		assert: [ :html | html checkbox value: true; callback: [ :value | ] ]
		gives: '<input checked="checked" name="1" type="checkbox" class="checkbox"/><input name="2" type="hidden" class="hidden"/>'!

testClosingTimes
	self assert: [ :html | html div; div ] gives: '<div></div><div></div>'.
	self assert: [ :html | html break; div ] gives: '<br/><div></div>'.
	self assert: [ :html | html div; break ] gives: '<div></div><br/>'.
	self assert: [ :html | html break; break ] gives: '<br/><br/>'.

	self assert: [ :html | html div: [ html div ]; div ] gives: '<div><div></div></div><div></div>'.
	self assert: [ :html | html div: [ html break ]; div ] gives: '<div><br/></div><div></div>'.
	self assert: [ :html | html div: [ html div ]; break ] gives: '<div><div></div></div><br/>'.
	self assert: [ :html | html div: [ html break ]; break ] gives: '<div><br/></div><br/>'!

testCoreAttributesClass
	self
		assert: [ :html | html div class: 'foo' ]
		gives: '<div class="foo"></div>'.
	self
		assert: [ :html | html div class: 'foo'; class: 'bar' ]
		gives: '<div class="foo bar"></div>'!

testCoreAttributesId
	self
		assert: [ :html | html div id: 'foo' ]
		gives: '<div id="foo"></div>'.
	self
		assert: [ :html | html div id: 'foo'; id: 'bar' ]
		gives: '<div id="bar"></div>'.
	self
		assert: [ :html | self assert: (html div id: 'foo'; id) = 'foo' ]
		gives: '<div id="foo"></div>'.
	self
		assert: [ :html | self assert: (html div id) isNil ]
		gives: '<div></div>'!

testCoreAttributesStyle
	self
		assert: [ :html | html div style: 'left: 0' ]
		gives: '<div style="left: 0"></div>'.
	self
		assert: [ :html | html div style: 'left: 0'; style: 'top: 2' ]
		gives: '<div style="left: 0;top: 2"></div>'!

testCoreAttributesTitle
	self
		assert: [ :html | html div title: 'Seaside' ]
		gives: '<div title="Seaside"></div>'!

testEditTag
	self
		assert: [ :html | html inserted: 'foo' ]
		gives: '<ins>foo</ins>'.
	self
		assert: [ :html | html deleted: 'bar' ]
		gives: '<del>bar</del>'!

testEnsureId
	self
		assert: [ :html | self assert: (html div ensureId = 'id1') ]
		gives: '<div id="id1"></div>'.
	self
		assert: [ :html | self assert: (html div id: 'foo'; ensureId) = 'foo' ]
		gives: '<div id="foo"></div>'!

testEventAttributes
	self
		assert: [ :html | html div onBlur: 1; onBlur: 2 ]
		gives: '<div onblur="1;2"></div>'.
	self
		assert: [ :html | html div onChange: 1; onChange: 2 ]
		gives: '<div onchange="1;2"></div>'.
	self
		assert: [ :html | html div onClick: 1; onClick: 2 ]
		gives: '<div onclick="1;2"></div>'.
	self
		assert: [ :html | html div onDoubleClick: 1; onDoubleClick: 2 ]
		gives: '<div ondblclick="1;2"></div>'!

testExtendedNesting
	self assert: [ :html | html div: nil ] gives: '<div></div>'.
	self assert: [ :html | html div: #( 1 $a ) ] gives: '<div>1a</div>'.
	self assert: [ :html | html div: [ html span ] ] gives: '<div><span></span></div>'!

testFieldSetTag
	self
		assert: [ :html | html fieldSet: 'foo' ]
		gives: '<fieldset>foo</fieldset>'.
	self
		assert: [ :html | html fieldSet legend: 'bar'; with: 'zork' ]
		gives: '<fieldset><legend>bar</legend>zork</fieldset>'!

testHeadingTag
	self
		assert: [ :html | html heading ]
		gives: '<h1></h1>'.
	self
		assert: [ :html | html heading level: 2; with: 'foo' ]
		gives: '<h2>foo</h2>'.
	self
		assert: [ :html | html heading level: 0; with: 'foo' ]
		gives: '<h1>foo</h1>'.
	self
		assert: [ :html | html heading level: 7; with: 'foo' ]
		gives: '<h6>foo</h6>'!

testHorizontalRuleTag
	self
		assert: [ :html | html horizontalRule ]
		gives: '<hr/>'!

testImageButton
	self
		assert: [ :html | html imageButton ]
		gives: '<input type="image" class="image"/>'!

testImageTag
	self
		assert: [ :html | html image url: 'http://www.seaside.st/logo.jpeg' ]
		gives: '<img alt="" src="http://www.seaside.st/logo.jpeg"/>'.
		
	self
		assert: [ :html |
			html image
				title: 'Seaside';
				altText: 'the Seaside logo';
				url: 'http://www.seaside.st/logo.jpeg' ]
		gives: '<img alt="the Seaside logo" title="Seaside" src="http://www.seaside.st/logo.jpeg"/>'!

testKeyboardAttributes
	self
		assert: [ :html | html anchor accessKey: $a ]
		gives: '<a accesskey="a"></a>'.
	self
		assert: [ :html | html anchor tabIndex: 3 ]
		gives: '<a tabindex="3"></a>'!

testLabelTag
	self
		assert: [ :html | html label: 'foo' ]
		gives: '<label>foo</label>'.
	self
		assert: [ :html | html label for: 'bar'; with: 'zork' ]
		gives: '<label for="bar">zork</label>'!

testLastId
	self
		assert: [ :html | self assert: html lastId isNil ]
		gives: ''.
	self
		assert: [ :html | html nextId. html text: html lastId; text: html lastId ]
		gives: 'id1id1'.
	self
		assert: [ :html | html anchor ensureId; callback: [ ]. self assert: html lastId = 'id1' ]
		gives: '<a id="id1" href="/?2"></a>'!

testMapTag
	self
		assert: [ :html | html map callback: [ :point | ]; with: [ html image url: 'seaside.jpg' ] ]
		gives: '<a href="/?1="><img alt="" ismap="ismap" src="seaside.jpg"/></a>'!

testMultiSelectTag
	self
		assert: [ :html | html multiSelect ]
		gives: '<select multiple="multiple"></select>'.
	self
		assert: [ :html | html multiSelect list: #(1 2) ]
		gives: '<select multiple="multiple"><option>1</option><option>2</option></select>'.
	self
		assert: [ :html | html multiSelect list: #(1 2); labels: [ :v | 2 * v ] ]
		gives: '<select multiple="multiple"><option>2</option><option>4</option></select>'.
	self
		assert: [ :html | html multiSelect list: #(1 2); enabled: [ :v | v even ] ]
		gives: '<select multiple="multiple"><option disabled="disabled">1</option><option>2</option></select>'.
	self
		assert: [ :html | html multiSelect list: #(3 4); callback: [ :v | ] ]
		gives: '<select name="1" multiple="multiple"><option value="1">3</option><option value="2">4</option></select><input name="2" type="hidden" class="hidden"/>'!

testNextId
	self
		assert: [ :html | html div id: html nextId ]
		gives: '<div id="id1"></div>'.
	self
		assert: [ :html | html div id: 'foo'; id: html nextId ]
		gives: '<div id="id1"></div>'!

testOrderedListTag
	self
		assert: [ :html | html orderedList ]
		gives: '<ol></ol>'.
	self
		assert: [ :html | html orderedList add: 1 ]
		gives: '<ol><li>1</li></ol>'.
	self
		assert: [ :html | html orderedList addAll: #( 1 2 ) ]
		gives: '<ol><li>1</li><li>2</li></ol>'.
	self
		assert: [ :html | html orderedList list: #( 1 2 ) ]
		gives: '<ol><li>1</li><li>2</li></ol>'.
	self
		assert: [ :html | html orderedList list: #( 1 2 ); with: [ html listItem: 3 ] ]
		gives: '<ol><li>1</li><li>2</li><li>3</li></ol>'.
	self
		assert: [ :html | html orderedList add: 2; labels: [ :e | 2 * e ] ]
		gives: '<ol><li>4</li></ol>'.
	self
		assert: [ :html | html orderedList add: 2; labels: [ :e | 2 * e ]; with: [ html listItem: 5 ] ]
		gives: '<ol><li>4</li><li>5</li></ol>'!

testParagraphTag
	self
		assert: [ :html | html paragraph ]
		gives: '<p></p>'.
	self
		assert: [ :html | html paragraph: 'foo' ]
		gives: '<p>foo</p>'!

testPasswordInput
	self
		assert: [ :html | html passwordInput ]
		gives: '<input type="password" class="password"/>'.
	self
		assert: [ :html | html passwordInput callback: [ :value | ] ]
		gives: '<input name="1" type="password" class="password"/>'.
	self
		assert: [ :html | html passwordInput: 'foo' ]
		gives: '<input value="foo" type="password" class="password"/>'.
	self
		assert: [ :html | html passwordInput value: 'bar' ]
		gives: '<input value="bar" type="password" class="password"/>'.
	self
		assert: [ :html | html passwordInput text: 'zork' ]
		gives: '<input value="zork" type="password" class="password"/>'.
	self
		assert: [ :html | html passwordInput callback: [ :value | ]; value: 'foo bar&zork' ]
		gives: '<input name="1" value="foo bar&amp;zork" type="password" class="password"/>'!

testScriptTag
	self
		assert: [ :html | html script: 'alert("<foo>")' ]
		gives: '<script type="text/javascript">/*<!![CDATA[*/alert("<foo>")/*]]>*/</script>'.
	self
		assert: [ :html | html script: 'true & false' ]
		gives: '<script type="text/javascript">/*<!![CDATA[*/true & false/*]]>*/</script>'.
	self
		assert: [ :html | html script defer; with: 'alert("<foo>")' ]
		gives: '<script defer="defer" type="text/javascript">/*<!![CDATA[*/alert("<foo>")/*]]>*/</script>'!

testSelectTag
	self
		assert: [ :html | html select ]
		gives: '<select></select>'.
	self
		assert: [ :html | html select list: #(1 2) ]
		gives: '<select><option>1</option><option>2</option></select>'.
	self
		assert: [ :html | html select list: #(1 2); labels: [ :v | 2 * v ] ]
		gives: '<select><option>2</option><option>4</option></select>'.
	self
		assert: [ :html | html select list: #(1 2); enabled: [ :v | v even ] ]
		gives: '<select><option disabled="disabled">1</option><option>2</option></select>'.
	self
		assert: [ :html | html select list: #(1 2); callback: [ :v | ] ]
		gives: '<select name="1"><option value="1">1</option><option value="2">2</option></select>'!

testSubmitButton
	self
		assert: [ :html | html submitButton ]
		gives: '<input type="submit" class="submit"/>'.
	self
		assert: [ :html | html submitButton callback: [ ] ]
		gives: '<input name="1" type="submit" class="submit"/>'.
	self
		assert: [ :html | 
			self 
				should: [ html submitButton callback: [ :value | ] ]
				raise: Error ]
		gives: '<input type="submit" class="submit"/>'.
	self
		assert: [ :html | html submitButton on: #value of: self ]
		gives: '<input value="Value" name="1" type="submit" class="submit"/>'.
	self
		assert: [ :html | html submitButton: 'foo' ]
		gives: '<input value="foo" type="submit" class="submit"/>'.
	self
		assert: [ :html | html submitButton text: 'bar' ]
		gives: '<input value="bar" type="submit" class="submit"/>'.
	self
		assert: [ :html | html submitButton with: 'zork' ]
		gives: '<input value="zork" type="submit" class="submit"/>'!

testSymbolRendering
	self
		assert: [ :html | html div id: #aSymbol; with: #aSecondSymbol ]
		gives: '<div id="aSymbol">aSecondSymbol</div>'.
	self
		assert: [ :html | html div: [ html text: #aSecondSymbol ] ]
		gives: '<div>aSecondSymbol</div>'.
	self
		assert: [ :html | html div: [ html render: #aSecondSymbol ] ]
		gives: '<div>aSecondSymbol</div>'!

testTable
	self
		assert: [ :html | html table ]
		gives: '<table></table>'.
	self
		assert: [ :html | html table cellpadding: 0; cellspacing: 1 ]
		gives: '<table cellpadding="0" cellspacing="1"></table>'.
	self
		assert: [ :html | html table frame: 'box'; rules: 'groups' ]
		gives: '<table frame="box" rules="groups"></table>'.
	self
		assert: [ :html | html table summary: 'a short summary' ]
		gives: '<table summary="a short summary"></table>'!

testTableColumn
	self
		assert: [ :html | html tableColumn ]
		gives: '<col/>'.
	self
		assert: [ :html | html tableColumn character: '.'; characterOffset: 2 ]
		gives: '<col char="." charoff="2"/>'.
	self
		assert: [ :html | html tableColumn align: 'right'; verticalAlign: 'top' ]
		gives: '<col align="right" valign="top"/>'.
	self
		assert: [ :html | html tableColumn span: 3; width: '20' ]
		gives: '<col span="3" width="20"/>'!

testTableColumnGroup
	self
		assert: [ :html | html tableColumnGroup ]
		gives: '<colgroup></colgroup>'.
	self
		assert: [ :html | html tableColumnGroup character: '.'; characterOffset: 2 ]
		gives: '<colgroup char="." charoff="2"></colgroup>'.
	self
		assert: [ :html | html tableColumnGroup align: 'right'; verticalAlign: 'top' ]
		gives: '<colgroup align="right" valign="top"></colgroup>'.
	self
		assert: [ :html | html tableColumnGroup span: 3; width: '20' ]
		gives: '<colgroup span="3" width="20"></colgroup>'!

testTableData
	self
		assert: [ :html | html tableData ]
		gives: '<td></td>'.
	self
		assert: [ :html | html tableData character: '.'; characterOffset: 2 ]
		gives: '<td char="." charoff="2"></td>'.
	self
		assert: [ :html | html tableData align: 'right'; verticalAlign: 'top' ]
		gives: '<td align="right" valign="top"></td>'.
	self
		assert: [ :html | html tableData abbreviation: 'short'; with: 'longer' ]
		gives: '<td abbr="short">longer</td>'.
	self
		assert: [ :html | html tableData axis: 'time' ]
		gives: '<td axis="time"></td>'.
	self
		assert: [ :html | html tableData colSpan: 2; rowSpan: 3 ]
		gives: '<td colspan="2" rowspan="3"></td>'.
	self
		assert: [ :html | html tableData headers: 'zork' ]
		gives: '<td headers="zork"></td>'.
	self
		assert: [ :html | html tableData scope: 'colgroup' ]
		gives: '<td scope="colgroup"></td>'!

testTableFull
	self
		assert: [ :html | 
			html table: [
				html tableCaption: 'title'.
				html tableColumnGroup: [
					html tableColumn.
					html tableColumn ].
				html tableHead: [
					html tableRow: [ 
						html tableHeading: 'a1'.
						html tableHeading: 'a2' ] ].
				html tableFoot: [
					html tableRow: [ 
						html tableData: 'b1'.
						html tableData: 'b2' ] ].
				html tableBody: [
					html tableRow: [ 
						html tableData: 'c1'.
						html tableData: 'c2' ].
					html tableRow: [ 
						html tableData: 'd1'.
						html tableData: 'd2' ] ] ] ]
		gives: '<table><caption>title</caption><colgroup><col/><col/></colgroup><thead><tr><th>a1</th><th>a2</th></tr></thead><tfoot><tr><td>b1</td><td>b2</td></tr></tfoot><tbody><tr><td>c1</td><td>c2</td></tr><tr><td>d1</td><td>d2</td></tr></tbody></table>'!

testTableHeading
	self
		assert: [ :html | html tableHeading ]
		gives: '<th></th>'.
	self
		assert: [ :html | html tableHeading character: '.'; characterOffset: 2 ]
		gives: '<th char="." charoff="2"></th>'.
	self
		assert: [ :html | html tableHeading align: 'right'; verticalAlign: 'top' ]
		gives: '<th align="right" valign="top"></th>'.
	self
		assert: [ :html | html tableHeading abbreviation: 'short'; with: 'longer' ]
		gives: '<th abbr="short">longer</th>'.
	self
		assert: [ :html | html tableHeading axis: 'time' ]
		gives: '<th axis="time"></th>'.
	self
		assert: [ :html | html tableHeading colSpan: 2; rowSpan: 3 ]
		gives: '<th colspan="2" rowspan="3"></th>'.
	self
		assert: [ :html | html tableHeading headers: 'zork' ]
		gives: '<th headers="zork"></th>'.
	self
		assert: [ :html | html tableHeading scope: 'colgroup' ]
		gives: '<th scope="colgroup"></th>'!

testTextArea
	self
		assert: [ :html | html textArea ]
		gives: '<textarea rows="auto" cols="auto"></textarea>'.
	self
		assert: [ :html | html textArea columns: 4 ]
		gives: '<textarea rows="auto" cols="4"></textarea>'.
	self
		assert: [ :html | html textArea rows: 40 ]
		gives: '<textarea rows="40" cols="auto"></textarea>'.
	self
		assert: [ :html | html textArea callback: [ :value | ] ]
		gives: '<textarea rows="auto" cols="auto" name="1"></textarea>'.
	self
		assert: [ :html | html textArea: 'foo bar&zork' ]
		gives: '<textarea rows="auto" cols="auto">foo bar&amp;zork</textarea>'.
	self
		assert: [ :html | html textArea text: 'foo bar&zork' ]
		gives: '<textarea rows="auto" cols="auto">foo bar&amp;zork</textarea>'.
	self
		assert: [ :html | html textArea value: 'foo bar&zork' ]
		gives: '<textarea rows="auto" cols="auto">foo bar&amp;zork</textarea>'.
	self
		assert: [ :html | html textArea with: 'foo bar&zork' ]
		gives: '<textarea rows="auto" cols="auto">foo bar&amp;zork</textarea>'.
	self
		assert: [ :html | html textArea callback: [ :value | ]; with: 'foo bar&zork' ]
		gives: '<textarea rows="auto" cols="auto" name="1">foo bar&amp;zork</textarea>'!

testTextInput
	self
		assert: [ :html | html textInput ]
		gives: '<input type="text" class="text"/>'.
	self
		assert: [ :html | html textInput callback: [ :value | ] ]
		gives: '<input name="1" type="text" class="text"/>'.
	self
		assert: [ :html | html textInput: 'foo' ]
		gives: '<input value="foo" type="text" class="text"/>'.
	self
		assert: [ :html | html textInput value: 'bar' ]
		gives: '<input value="bar" type="text" class="text"/>'.
	self
		assert: [ :html | html textInput text: 'zork' ]
		gives: '<input value="zork" type="text" class="text"/>'.
	self
		assert: [ :html | html textInput callback: [ :value | ]; value: 'foo bar&zork' ]
		gives: '<input name="1" value="foo bar&amp;zork" type="text" class="text"/>'!

testUnorderedListTag
	self
		assert: [ :html | html unorderedList ]
		gives: '<ul></ul>'.
	self
		assert: [ :html | html unorderedList add: 1 ]
		gives: '<ul><li>1</li></ul>'.
	self
		assert: [ :html | html unorderedList addAll: #( 1 2 ) ]
		gives: '<ul><li>1</li><li>2</li></ul>'.
	self
		assert: [ :html | html unorderedList list: #( 1 2 ) ]
		gives: '<ul><li>1</li><li>2</li></ul>'.
	self
		assert: [ :html | html unorderedList list: #( 1 2 ); with: [ html listItem: 3 ] ]
		gives: '<ul><li>1</li><li>2</li><li>3</li></ul>'.
	self
		assert: [ :html | html unorderedList add: 2; labels: [ :e | 2 * e ] ]
		gives: '<ul><li>4</li></ul>'.
	self
		assert: [ :html | html unorderedList add: 2; labels: [ :e | 2 * e ]; with: [ html listItem: 5 ] ]
		gives: '<ul><li>4</li><li>5</li></ul>'! !
!WACanvasBrushTest categoriesFor: #createHandlers!configuration!public! !
!WACanvasBrushTest categoriesFor: #testAnchor!public!tests-tags-anchors! !
!WACanvasBrushTest categoriesFor: #testAnchorAttributes!public!tests-tags-anchors! !
!WACanvasBrushTest categoriesFor: #testAnchorCallback!public!tests-tags-anchors! !
!WACanvasBrushTest categoriesFor: #testAnchorUrl!public!tests-tags-anchors! !
!WACanvasBrushTest categoriesFor: #testBasicNesting!public!tests! !
!WACanvasBrushTest categoriesFor: #testBlock!public!tests-tags! !
!WACanvasBrushTest categoriesFor: #testBreakTag!public!tests-tags! !
!WACanvasBrushTest categoriesFor: #testButton!public!tests-tags-forms! !
!WACanvasBrushTest categoriesFor: #testCancelButton!public!tests-tags-forms! !
!WACanvasBrushTest categoriesFor: #testCanvasHtml!public!tests-encoding! !
!WACanvasBrushTest categoriesFor: #testCanvasNil!public!tests-encoding! !
!WACanvasBrushTest categoriesFor: #testCanvasText!public!tests-encoding! !
!WACanvasBrushTest categoriesFor: #testCanvasWithLineBreaks!public!tests-encoding! !
!WACanvasBrushTest categoriesFor: #testCanvasWithLineBreaksAndUrls!public!tests-encoding! !
!WACanvasBrushTest categoriesFor: #testCanvasWithUrls!public!tests-encoding! !
!WACanvasBrushTest categoriesFor: #testCheckboxTag!public!tests-tags-forms! !
!WACanvasBrushTest categoriesFor: #testClosingTimes!public!tests! !
!WACanvasBrushTest categoriesFor: #testCoreAttributesClass!public!tests-attributes! !
!WACanvasBrushTest categoriesFor: #testCoreAttributesId!public!tests-attributes! !
!WACanvasBrushTest categoriesFor: #testCoreAttributesStyle!public!tests-attributes! !
!WACanvasBrushTest categoriesFor: #testCoreAttributesTitle!public!tests-attributes! !
!WACanvasBrushTest categoriesFor: #testEditTag!public!tests-tags! !
!WACanvasBrushTest categoriesFor: #testEnsureId!public!tests! !
!WACanvasBrushTest categoriesFor: #testEventAttributes!public!tests-attributes! !
!WACanvasBrushTest categoriesFor: #testExtendedNesting!public!tests! !
!WACanvasBrushTest categoriesFor: #testFieldSetTag!public!tests-tags! !
!WACanvasBrushTest categoriesFor: #testHeadingTag!public!tests-tags! !
!WACanvasBrushTest categoriesFor: #testHorizontalRuleTag!public!tests-tags! !
!WACanvasBrushTest categoriesFor: #testImageButton!public!tests-tags-forms! !
!WACanvasBrushTest categoriesFor: #testImageTag!public!tests-tags! !
!WACanvasBrushTest categoriesFor: #testKeyboardAttributes!public!tests-attributes! !
!WACanvasBrushTest categoriesFor: #testLabelTag!public!tests-tags! !
!WACanvasBrushTest categoriesFor: #testLastId!public!tests! !
!WACanvasBrushTest categoriesFor: #testMapTag!public!tests-tags-anchors! !
!WACanvasBrushTest categoriesFor: #testMultiSelectTag!public!tests-tags-forms! !
!WACanvasBrushTest categoriesFor: #testNextId!public!tests! !
!WACanvasBrushTest categoriesFor: #testOrderedListTag!public!tests-tags! !
!WACanvasBrushTest categoriesFor: #testParagraphTag!public!tests-tags! !
!WACanvasBrushTest categoriesFor: #testPasswordInput!public!tests-tags-forms! !
!WACanvasBrushTest categoriesFor: #testScriptTag!public!tests-tags! !
!WACanvasBrushTest categoriesFor: #testSelectTag!public!tests-tags-forms! !
!WACanvasBrushTest categoriesFor: #testSubmitButton!public!tests-tags-forms! !
!WACanvasBrushTest categoriesFor: #testSymbolRendering!public!tests-encoding! !
!WACanvasBrushTest categoriesFor: #testTable!public!tests-tags-tables! !
!WACanvasBrushTest categoriesFor: #testTableColumn!public!tests-tags-tables! !
!WACanvasBrushTest categoriesFor: #testTableColumnGroup!public!tests-tags-tables! !
!WACanvasBrushTest categoriesFor: #testTableData!public!tests-tags-tables! !
!WACanvasBrushTest categoriesFor: #testTableFull!public!tests-tags-tables! !
!WACanvasBrushTest categoriesFor: #testTableHeading!public!tests-tags-tables! !
!WACanvasBrushTest categoriesFor: #testTextArea!public!tests-tags-forms! !
!WACanvasBrushTest categoriesFor: #testTextInput!public!tests-tags-forms! !
!WACanvasBrushTest categoriesFor: #testUnorderedListTag!public!tests-tags! !

WAFormCharEncodingFromCodecTest guid: (GUID fromString: '{5D7DAFF7-5D35-4863-8CBF-6411741C4BEC}')!
WAFormCharEncodingFromCodecTest comment: '
I test that the encoding of the codec on the request context overwrites the encoding on the application.
'!
!WAFormCharEncodingFromCodecTest categoriesForClass!Unclassified! !
!WAFormCharEncodingFromCodecTest methodsFor!

createCodec
	^ GRCodec forEncoding: 'iso-8859-1'!

createHandlers
	| handler |
	handler := WARequestHandler new.
	handler preferenceAt: #charSet put: 'utf-16'.
	^ Array with: handler!

testCharCodingWithHandler
	"569: Encoding information doesn't get included in the response"
	self
		assert: [ :html |
			html basicForm ]
		gives: '<form accept-charset="iso-8859-1" method="post" action="/"></form>'.
! !
!WAFormCharEncodingFromCodecTest categoriesFor: #createCodec!configuration!public! !
!WAFormCharEncodingFromCodecTest categoriesFor: #createHandlers!configuration!public! !
!WAFormCharEncodingFromCodecTest categoriesFor: #testCharCodingWithHandler!public!testing! !

WAFormCharEncodingFromHandlerTest guid: (GUID fromString: '{2F0445F5-8E8B-44A3-97E7-D25460366930}')!
WAFormCharEncodingFromHandlerTest comment: 'I test that the encoding from the handler is taken if a handler is present but a codec is missing.'!
!WAFormCharEncodingFromHandlerTest categoriesForClass!Unclassified! !
!WAFormCharEncodingFromHandlerTest methodsFor!

createHandlers
	| handler |
	handler := WARequestHandler new.
	handler preferenceAt: #charSet put: 'utf-16'.
	^ Array with: handler!

testCharCodingWithHandler
	"445:WABasicFormTag does not honour character encoding setting"
	self
		assert: [ :html |
			html basicForm ]
		gives: '<form accept-charset="utf-16" method="post" action="/"></form>'.
! !
!WAFormCharEncodingFromHandlerTest categoriesFor: #createHandlers!configuration!public! !
!WAFormCharEncodingFromHandlerTest categoriesFor: #testCharCodingWithHandler!public!tests! !

WAFormTagTest guid: (GUID fromString: '{4E39857C-C234-4ACC-AC9E-4BF03D8B2A7E}')!
WAFormTagTest comment: ''!
!WAFormTagTest categoriesForClass!Unclassified! !
!WAFormTagTest methodsFor!

assertUserAgent: aString isInternetExplorer: aBoolean
	self userAgent: aString.
	WARenderCanvas builder
		render: [ :html |
			self assert: html form isInternetExplorer = aBoolean ]!

testBasicForm
	self
		assert: [ :html |
			html basicForm ]
		gives: '<form accept-charset="utf-8" method="post" action="/"></form>'.
!

testDefaultAction
	self userAgent: 'Mozilla/5.0 (Windows; U; Windows NT 5.1; de; rv:1.8.1.3) Gecko/20070309 Firefox/2.0.0.3'.
	self
		assert: [ :html |
			html form defaultAction: [  ] ]
		gives: '<form accept-charset="utf-8" method="post" action="/"><div><input tabindex="-1" value="Default" name="1" style="position: absolute; top: -100em" type="submit" class="submit"/></div></form>'.
	
	self userAgent: 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)'.
	self
		assert: [ :html |
			html form
				defaultAction: [  ] ]
		gives: '<form accept-charset="utf-8" method="post" action="/"><div><input tabindex="-1" value="Default" name="1" style="position: absolute; top: -100em" type="submit" class="submit"/><input tabindex="-1" name="2" style="position: absolute; top: -100em" type="text" class="text"/></div></form>'.!

testDefaultActionGet
	self userAgent: 'Mozilla/5.0 (Windows; U; Windows NT 5.1; de; rv:1.8.1.3) Gecko/20070309 Firefox/2.0.0.3'.
	self
		assert: [ :html |
			html form get; defaultAction: [  ] ]
		gives: '<form accept-charset="utf-8" method="get" action="/"><div><input tabindex="-1" value="Default" name="1" style="position: absolute; top: -100em" type="submit" class="submit"/></div><div></div></form>'.
	
	self userAgent: 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)'.
	self
		assert: [ :html |
			html form get; defaultAction: [  ] ]
		gives: '<form accept-charset="utf-8" method="get" action="/"><div><input tabindex="-1" value="Default" name="1" style="position: absolute; top: -100em" type="submit" class="submit"/><input tabindex="-1" name="2" style="position: absolute; top: -100em" type="text" class="text"/></div><div></div></form>'.!

testIsGet
	self userAgent: 'Mozilla/5.0 (Windows; U; Windows NT 5.1; de; rv:1.8.1.3) Gecko/20070309 Firefox/2.0.0.3'.
	self
		assert: [ :html | self assert: html form get isGet ]
		gives: '<form accept-charset="utf-8" method="get" action="/"><div></div></form>'.!

testIsInternetExplorer
	self assertUserAgent: 'Mozilla/5.0 (compatible; Konqueror/3.2; Linux 2.6.2) (KHTML, like Gecko)' isInternetExplorer: false.
	self assertUserAgent: 'Mozilla/4.0 (compatible; MSIE 6.0; MSIE 5.5; Windows NT 5.1) Opera 7.04 [de]' isInternetExplorer: false.
	self assertUserAgent: 'Opera/9.10 (Windows NT 5.0; U; de)' isInternetExplorer: false.
	self assertUserAgent: 'Mozilla/5.0 (Windows; U; Windows NT 5.0; de-DE; rv:1.6) Gecko/20040206 Firefox/1.0.1' isInternetExplorer: false.
	self assertUserAgent: 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0; WOW64; SLCC1; .NET CLR 2.0.50727; .NET CLR 3.0.04506)' isInternetExplorer: true.
	self assertUserAgent: 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)' isInternetExplorer: true.
	self assertUserAgent: 'Lynx/2.8.4rel.1 libwww-FM/2.14 SSL-MM/1.4.1 OpenSSL/0.9.6c' isInternetExplorer: false.
	self assertUserAgent: 'Mozilla/5.0 (Windows; U; Windows NT 5.1; de-AT; rv:1.8.1.2) Gecko/20070222 SeaMonkey/1.1.1' isInternetExplorer: false.
	self assertUserAgent: 'Mozilla/5.0 (Windows; U; Windows NT 5.1; de; rv:1.8.1.3) Gecko/20070309 Firefox/2.0.0.3' isInternetExplorer: false.!

userAgent: aString
	self requestContext request headers at: 'user-agent' put: aString! !
!WAFormTagTest categoriesFor: #assertUserAgent:isInternetExplorer:!private! !
!WAFormTagTest categoriesFor: #testBasicForm!public!tests! !
!WAFormTagTest categoriesFor: #testDefaultAction!public!tests! !
!WAFormTagTest categoriesFor: #testDefaultActionGet!public!tests! !
!WAFormTagTest categoriesFor: #testIsGet!public!tests! !
!WAFormTagTest categoriesFor: #testIsInternetExplorer!public!tests! !
!WAFormTagTest categoriesFor: #userAgent:!private! !

WAResourceBaseUrlTest guid: (GUID fromString: '{3D9F618A-FB92-4C52-8A70-5CFB64179CB0}')!
WAResourceBaseUrlTest comment: ''!
!WAResourceBaseUrlTest categoriesForClass!Unclassified! !
!WAResourceBaseUrlTest methodsFor!

assertRoot: aBlock gives: aString
	| html |
	html := self builder
		fullDocument: true;
		rootBlock: aBlock;
		render: [ :canvas | ].
	self assert: html = ('<html><head><title></title>', aString, '</head><body onload="onLoad()"><script type="text/javascript">/*<!![CDATA[*/function onLoad(){};/*]]>*/</script></body></html>')!

builder
	^ super builder
		resourceUrl: (WAUrl absolute: self resourceBaseUrl);
		yourself!

resourceBaseUrl
	^ 'https://www.seaside.st/resources/'!

testAbsoluteFtpUrl
	self
		assert: [ :html | html anchor resourceUrl: 'ftp://www.google.com/track.js' ]
		gives: '<a href="ftp://www.google.com/track.js"></a>'!

testAbsoluteHttpsUrl
	self
		assert: [ :html | html anchor resourceUrl: 'https://www.google.com/track.js' ]
		gives: '<a href="https://www.google.com/track.js"></a>'!

testAbsoluteHttpUrl
	self
		assert: [ :html | html anchor resourceUrl: 'http://www.google.com/track.js' ]
		gives: '<a href="http://www.google.com/track.js"></a>'!

testFileNameWithHttp
	self
		assert: [ :html | html image resourceUrl: 'http.gif' ]
		gives: '<img alt="" src="',self resourceBaseUrl,'http.gif"/>'!

testImageTag
	self
		assert: [ :html | html image resourceUrl: 'logo.jpeg' ]
		gives: '<img alt="" src="',self resourceBaseUrl,'logo.jpeg"/>'!

testRootScript
	self
		assertRoot: [ :html | html javascript resourceUrl: 'main.js' ]
		gives: '<script type="text/javascript" src="',self resourceBaseUrl,'main.js"></script>'!

testScriptTag
	self
		assert: [ :html | html script resourceUrl: 'track.js' ]
		gives: '<script src="',self resourceBaseUrl,'track.js" type="text/javascript">/*<!![CDATA[*//*]]>*/</script>'!

testSylesheet
	self
		assertRoot: [ :html | html stylesheet resourceUrl: 'main.css' ]
		gives: '<link rel="stylesheet" type="text/css" href="',self resourceBaseUrl,'main.css"/>'! !
!WAResourceBaseUrlTest categoriesFor: #assertRoot:gives:!private! !
!WAResourceBaseUrlTest categoriesFor: #builder!private! !
!WAResourceBaseUrlTest categoriesFor: #resourceBaseUrl!private! !
!WAResourceBaseUrlTest categoriesFor: #testAbsoluteFtpUrl!public!tests! !
!WAResourceBaseUrlTest categoriesFor: #testAbsoluteHttpsUrl!public!tests! !
!WAResourceBaseUrlTest categoriesFor: #testAbsoluteHttpUrl!public!tests! !
!WAResourceBaseUrlTest categoriesFor: #testFileNameWithHttp!public!tests! !
!WAResourceBaseUrlTest categoriesFor: #testImageTag!public!tests! !
!WAResourceBaseUrlTest categoriesFor: #testRootScript!public!tests! !
!WAResourceBaseUrlTest categoriesFor: #testScriptTag!public!tests! !
!WAResourceBaseUrlTest categoriesFor: #testSylesheet!public!tests! !

"Binary Globals"!

