| package |
package := Package name: 'Seaside-Tests-Component'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '31'.


package classNames
	add: #WAComponentStub;
	add: #WAComponentTest;
	add: #WADecorationStub;
	yourself.

package methodNames
	add: 'GRPackage class' -> #seasideTestsComponent;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: 'Seaside-Component';
	add: 'Seaside-Core';
	add: '..\..\Camp Smalltalk\SUnit\SUnit';
	yourself).

package!

"Class Definitions"!

WAComponent subclass: #WAComponentStub
	instanceVariableNames: 'initialRequestBlock updateRootBlock updateUrlBlock updateStatesBlock renderBlock childrenBlock'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WADecoration subclass: #WADecorationStub
	instanceVariableNames: 'initialRequestBlock updateRootBlock updateUrlBlock updateStatesBlock renderBlock childrenBlock'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #WAComponentTest
	instanceVariableNames: 'log root decoration1 decoration2 child1 child2 child3 child4'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

seasideTestsComponent
	^ self new
		name: 'Seaside-Tests-Component';
		description: 'Unit tests for the package Seaside-Component.';
		addDependency: 'Seaside-Component';
		addDependency: 'Seaside-Tests-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideTestsComponent!*seaside-tests-component!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

WAComponentStub guid: (GUID fromString: '{20FEBDC7-4655-4E8F-9BDE-3F84F9143068}')!
WAComponentStub comment: ''!
!WAComponentStub categoriesForClass!Unclassified! !
!WAComponentStub methodsFor!

children
	^ childrenBlock isNil
		ifTrue: [ super children ]
		ifFalse: [ childrenBlock value ]!

initialRequest: aRequest
	super initialRequest: aRequest.
	initialRequestBlock isNil
		ifFalse: [ initialRequestBlock value: aRequest ]!

onChildren: aBlock
	childrenBlock := aBlock!

onInitialRequest: aBlock
	initialRequestBlock := aBlock!

onRender: aBlock
	renderBlock := aBlock!

onUpdateRoot: aBlock
	updateRootBlock := aBlock!

onUpdateStates: aBlock
	updateStatesBlock := aBlock!

onUpdateUrl: aBlock
	updateUrlBlock := aBlock!

renderContentOn: html
	renderBlock isNil 
		ifTrue: [ super renderContentOn: html ]
		ifFalse: [ renderBlock value: html ]!

updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	updateRootBlock isNil
		ifFalse: [ updateRootBlock value: anHtmlRoot ]!

updateStates: aSnapshot
	super updateStates: aSnapshot.
	updateStatesBlock isNil
		ifFalse: [ updateStatesBlock value: aSnapshot ]!

updateUrl: aUrl
	super updateUrl: aUrl.
	updateUrlBlock isNil
		ifFalse: [ updateUrlBlock value: aUrl ]! !
!WAComponentStub categoriesFor: #children!accessing!public! !
!WAComponentStub categoriesFor: #initialRequest:!initialization!public! !
!WAComponentStub categoriesFor: #onChildren:!events!public! !
!WAComponentStub categoriesFor: #onInitialRequest:!events!public! !
!WAComponentStub categoriesFor: #onRender:!events!public! !
!WAComponentStub categoriesFor: #onUpdateRoot:!events!public! !
!WAComponentStub categoriesFor: #onUpdateStates:!events!public! !
!WAComponentStub categoriesFor: #onUpdateUrl:!events!public! !
!WAComponentStub categoriesFor: #renderContentOn:!public!rendering! !
!WAComponentStub categoriesFor: #updateRoot:!public!updating! !
!WAComponentStub categoriesFor: #updateStates:!public!updating! !
!WAComponentStub categoriesFor: #updateUrl:!public!updating! !

WADecorationStub guid: (GUID fromString: '{C509B1E3-295F-4288-A2B3-97CE8235FC0D}')!
WADecorationStub comment: ''!
!WADecorationStub categoriesForClass!Unclassified! !
!WADecorationStub methodsFor!

children
	^ childrenBlock isNil
		ifTrue: [ super children ]
		ifFalse: [ super children , childrenBlock value ]!

initialRequest: aRequest
	super initialRequest: aRequest.
	initialRequestBlock isNil
		ifFalse: [ initialRequestBlock value: aRequest ]!

onChildren: aBlock
	childrenBlock := aBlock!

onInitialRequest: aBlock
	initialRequestBlock := aBlock!

onRender: aBlock
	renderBlock := aBlock!

onUpdateRoot: aBlock
	updateRootBlock := aBlock!

onUpdateStates: aBlock
	updateStatesBlock := aBlock!

onUpdateUrl: aBlock
	updateUrlBlock := aBlock!

renderContentOn: html
	renderBlock isNil 
		ifTrue: [ super renderContentOn: html ]
		ifFalse: [ renderBlock value: html value: [ super renderContentOn: html ] ]!

updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	updateRootBlock isNil
		ifFalse: [ updateRootBlock value: anHtmlRoot ]!

updateStates: aSnapshot
	super updateStates: aSnapshot.
	updateStatesBlock isNil
		ifFalse: [ updateStatesBlock value: aSnapshot ]!

updateUrl: aUrl
	super updateUrl: aUrl.
	updateUrlBlock isNil
		ifFalse: [ updateUrlBlock value: aUrl ]! !
!WADecorationStub categoriesFor: #children!accessing!public! !
!WADecorationStub categoriesFor: #initialRequest:!initialization!public! !
!WADecorationStub categoriesFor: #onChildren:!events!public! !
!WADecorationStub categoriesFor: #onInitialRequest:!events!public! !
!WADecorationStub categoriesFor: #onRender:!events!public! !
!WADecorationStub categoriesFor: #onUpdateRoot:!events!public! !
!WADecorationStub categoriesFor: #onUpdateStates:!events!public! !
!WADecorationStub categoriesFor: #onUpdateUrl:!events!public! !
!WADecorationStub categoriesFor: #renderContentOn:!public!rendering! !
!WADecorationStub categoriesFor: #updateRoot:!public!updating! !
!WADecorationStub categoriesFor: #updateStates:!public!updating! !
!WADecorationStub categoriesFor: #updateUrl:!public!updating! !

WAComponentTest guid: (GUID fromString: '{74BD5821-4AE5-4648-8AE4-D18C117FD6BA}')!
WAComponentTest comment: ''!
!WAComponentTest categoriesForClass!Unclassified! !
!WAComponentTest methodsFor!

assertLog: anArray
	self
		assert: log asArray = anArray
		description: 'Expected ' , anArray printString , ', but got ' , log asArray printString.
	log := OrderedCollection new!

assertRenders: aString
	| guide |
	guide := self renderingGuide start: root.
	self assert: guide client renderContext document stream contents = aString!

log: aString
	log add: aString!

renderContext
	^ WARenderContext new
		actionUrl: WAUrl new;
		document: (WAHtmlDocument on: (WriteStream on: String new));
		yourself!

renderingGuide
	| context guide |
	context := self renderContext.
	guide := WARenderingGuide client: (WARenderVisitor context: context).
	context visitor: guide.
	^ guide!

setUp
	super setUp.
	log := OrderedCollection new.
	root := WAComponentStub new.
	decoration1 := WADecorationStub new.
	decoration2 := WADecorationStub new.
	child1 := WAComponentStub new.
	child2 := WAComponentStub new.
	child3 := WAComponentStub new.
	child4 := WAComponentStub new!

testActiveComponent

	" single root component "
	self assert: root activeComponent = root.

	" add two children "
	root onChildren: [ Array with: child1 with: child2 ].
	self assert: root activeComponent = root.
	self assert: child1 activeComponent = child1.
	self assert: child2 activeComponent = child2.

	" add two decorations "
	root addDecoration: decoration1; addDecoration: decoration2.
	self assert: root activeComponent = root.
	self assert: child1 activeComponent = child1.
	self assert: child2 activeComponent = child2.
	
	" delegate to another component "
	child2 show: child3.
	self assert: root activeComponent = root.
	self assert: child1 activeComponent = child1.
	self assert: child2 activeComponent = child3.
	self assert: child3 activeComponent = child3.
	
	" delegate to yet another component "
	child3 show: child4.
	self assert: root activeComponent = root.
	self assert: child1 activeComponent = child1.
	self assert: child2 activeComponent = child4.
	self assert: child3 activeComponent = child4.
	self assert: child4 activeComponent = child4
	!

testAddDecoration
	self assert: (root addDecoration: decoration1) = decoration1.
	self assert: (root decorations size = 1).
	self assert: (root decorations first = decoration1).
	
	self assert: (root addDecoration: decoration2) = decoration2.
	self assert: (root decorations size = 2).
	self assert: (root decorations first = decoration2).
	self assert: (root decorations last = decoration1)!

testChildrenNotCollectionError
	"for background see: http://code.google.com/p/seaside/issues/detail?id=586"
	root onChildren: [^ Array with: child4].
	child1 onChildren: [^ self].
	child2 onChildren: [^ child4].
	
	self shouldnt: [ root children ] raise: WAChildrenNotCollectionError.

	self should: [child1 children] 
		raise: WAChildrenNotCollectionError
		description: 'Testing WAPresenter  >> #childrenDo: with #children return ^self'.

	self should: [child2 children] 
		raise: WAChildrenNotCollectionError
		description: 'Testing WAPresenter  >> #childrenDo with #children forgetting to return an array:'.!

testDecorations
	self assert: root decorations isEmpty.
	root show: child1.
	self assert: root decorations size = 1.
	root addDecoration: decoration1.
	self assert: root decorations size = 2
!

testDelegations
	self assert: root delegations isEmpty.
	root show: child1.
	self assert: root delegations size = 1.
	root addDecoration: decoration1.
	self assert: root delegations size = 1!

testHome
	root show: child1.
	child1 show: child2.
	self assert: root activeComponent = child2.
	self assert: child1 activeComponent = child2.
	
	root home.
	self assert: root activeComponent = root.
	self assert: child1 activeComponent = child2.
	self assert: child2 activeComponent = child2.
	
	child1 home.
	self assert: root activeComponent = root.
	self assert: child1 activeComponent = child1.
	self assert: child2 activeComponent = child2.
	
	child2 home.
	self assert: root activeComponent = root.
	self assert: child1 activeComponent = child1.
	self assert: child2 activeComponent = child2!

testInitialRequest
	| request guide |
	request := WARequest new.

	root onInitialRequest: [ :each |
		self assert: each = request.
		self log: 'root' ].
	child1 onInitialRequest: [ :each |
		self assert: each = request.
		self log: 'child1' ].
	child2 onInitialRequest: [ :each |
		self assert: each = request.
		self log: 'child2' ].
	child3 onInitialRequest: [ :each |
		self assert: each = request.
		self log: 'child3' ].
	decoration1 onInitialRequest: [ :each |
		self assert: each = request.
		self log: 'decoration1' ].
	decoration2 onInitialRequest: [ :each |
		self assert: each = request.
		self log: 'decoration2' ].

	guide := WAAllPresenterGuide client: (WAInitialRequestVisitor request: request).

	" single root component "
	guide start: root.
	self assertLog: #('root').

	" add two children "
	root onChildren: [ Array with: child1 with: child2 ].
	guide start: root.
	self assertLog: #('root' 'child1' 'child2').

	" add two decorations "
	root addDecoration: decoration1; addDecoration: decoration2.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child2').
	
	
	" delegate to another component "
	child2 show: child3.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child3' 'child2')!

testRemoveDecoration
	root addDecoration: decoration1; addDecoration: decoration2.
	self assert: (root removeDecoration: decoration2) = decoration2.
	self assert: (root decorations size = 1).
	self assert: (root decorations first = decoration1).
	
	root addDecoration: decoration2.
	self assert: (root removeDecoration: decoration1) = decoration1.
	self assert: (root decorations size = 1).
	self assert: (root decorations first = decoration2).
	
	self assert: (root removeDecoration: decoration1) isNil.
	self assert: (root decorations size = 1).
	self assert: (root decorations first = decoration2).

	self assert: (root removeDecoration: decoration2) = decoration2.
	self assert: (root decorations isEmpty).
		
	self assert: (root removeDecoration: decoration2) isNil!

testRenderingChildren
	root onChildren: [ Array with: child1 with: child2 ].
	child1 onRender: [ :html | html text: '1' ].
	child2 onRender: [ :html | html text: '2' ].
	self assertRenders: '12'.
	
	root onRender: [ :html | html text: 'a'; render: child1; text: 'b'; render: child2; text: 'c' ].
	self assertRenders: 'a1b2c'.
	
	root onChildren: [ Array with: child2 with: child1 ].
	self assertRenders: 'a1b2c'.

	root onRender: [ :html | html text: 'a'; render: child2; text: 'b'; render: child1; text: 'c' ].
	self assertRenders: 'a2b1c'!

testRenderingDecoration
	root onRender: [ :html | html text: 'r' ].
	root addDecoration: decoration1.
	
	decoration1 onRender: [ :html :cc | html text: '1'. cc value ].
	self assertRenders: '1r'.
	
	decoration1 onRender: [ :html :cc | cc value. html text: '1' ].
	self assertRenders: 'r1'.
	
	decoration1 onRender: [ :html :cc | html text: '1' ].
	self assertRenders: '1'!

testRenderingDelegation
	root onRender: [ :html | html text: 'r' ].
	child1 onRender: [ :html | html text: '1' ].
	child2 onRender: [ :html | html text: '2' ].
	child3 onRender: [ :html | html text: '3' ].
	
	root show: child1.
	self assertRenders: '1'.
	
	child1 show: child2.
	self assertRenders: '2'.
	
	child2 answer.
	self assertRenders: '1'.
	
	root show: child3.
	self assertRenders: '3'.
	
	root home.
	self assertRenders: 'r'
	
	
	!

testUpdateRoot
	| htmlRoot guide |
	htmlRoot := WAHtmlRoot new.

	root onUpdateRoot: [ :each |
		self assert: each = htmlRoot.
		self log: 'root' ].
	child1 onUpdateRoot: [ :each |
		self assert: each = htmlRoot.
		self log: 'child1' ].
	child2 onUpdateRoot: [ :each |
		self assert: each = htmlRoot.
		self log: 'child2' ].
	child3 onUpdateRoot: [ :each |
		self assert: each = htmlRoot.
		self log: 'child3' ].
	decoration1 onUpdateRoot: [ :each |
		self assert: each = htmlRoot.
		self log: 'decoration1' ].
	decoration2 onUpdateRoot: [ :each |
		self assert: each = htmlRoot.
		self log: 'decoration2' ].

	guide := WAVisiblePresenterGuide client: (WAUpdateRootVisitor root: htmlRoot).

	" single root component "
	guide start: root.
	self assertLog: #('root').

	" add two children "
	root onChildren: [ Array with: child1 with: child2 ].
	guide start: root.
	self assertLog: #('root' 'child1' 'child2').

	" add two decorations "
	root addDecoration: decoration1; addDecoration: decoration2.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child2').
	
	" delegate to another component "
	child2 show: child3.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child3')!

testUpdateStates
	| snapshot guide |
	snapshot := WASnapshot new.

	root onUpdateStates: [ :each |
		self assert: each = snapshot.
		self log: 'root' ].
	child1 onUpdateStates: [ :each |
		self assert: each = snapshot.
		self log: 'child1' ].
	child2 onUpdateStates: [ :each |
		self assert: each = snapshot.
		self log: 'child2' ].
	child3 onUpdateStates: [ :each |
		self assert: each = snapshot.
		self log: 'child3' ].
	decoration1 onUpdateStates: [ :each |
		self assert: each = snapshot.
		self log: 'decoration1' ].
	decoration2 onUpdateStates: [ :each |
		self assert: each = snapshot.
		self log: 'decoration2' ].

	guide := WAAllPresenterGuide client: (WAUpdateStatesVisitor snapshot: snapshot).

	" single root component "
	guide start: root.
	self assertLog: #('root').

	" add two children "
	root onChildren: [ Array with: child1 with: child2 ].
	guide start: root.
	self assertLog: #('root' 'child1' 'child2').

	" add two decorations "
	root addDecoration: decoration1; addDecoration: decoration2.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child2').
	
	" delegate to another component "
	child2 show: child3.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child3' 'child2')!

testUpdateUrl
	| url guide |
	url := WAUrl new.

	root onUpdateUrl: [ :each |
		self assert: each = url.
		self log: 'root' ].
	child1 onUpdateUrl: [ :each |
		self assert: each = url.
		self log: 'child1' ].
	child2 onUpdateUrl: [ :each |
		self assert: each = url.
		self log: 'child2' ].
	child3 onUpdateUrl: [ :each |
		self assert: each = url.
		self log: 'child3' ].
	decoration1 onUpdateUrl: [ :each |
		self assert: each = url.
		self log: 'decoration1' ].
	decoration2 onUpdateUrl: [ :each |
		self assert: each = url.
		self log: 'decoration2' ].

	guide := WAVisiblePresenterGuide client: (WAUpdateUrlVisitor url: url).

	" single root component "
	guide start: root.
	self assertLog: #('root').

	" add two children "
	root onChildren: [ Array with: child1 with: child2 ].
	guide start: root.
	self assertLog: #('root' 'child1' 'child2').

	" add two decorations "
	root addDecoration: decoration1; addDecoration: decoration2.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child2').
	
	" delegate to another component "
	child2 show: child3.
	guide start: root.
	self assertLog: #('decoration2' 'decoration1' 'root' 'child1' 'child3')! !
!WAComponentTest categoriesFor: #assertLog:!private! !
!WAComponentTest categoriesFor: #assertRenders:!private! !
!WAComponentTest categoriesFor: #log:!private! !
!WAComponentTest categoriesFor: #renderContext!accessing!public! !
!WAComponentTest categoriesFor: #renderingGuide!accessing!public! !
!WAComponentTest categoriesFor: #setUp!public!running! !
!WAComponentTest categoriesFor: #testActiveComponent!public!tests! !
!WAComponentTest categoriesFor: #testAddDecoration!public!tests! !
!WAComponentTest categoriesFor: #testChildrenNotCollectionError!public!tests! !
!WAComponentTest categoriesFor: #testDecorations!public!tests! !
!WAComponentTest categoriesFor: #testDelegations!public!tests! !
!WAComponentTest categoriesFor: #testHome!public!tests! !
!WAComponentTest categoriesFor: #testInitialRequest!public!tests! !
!WAComponentTest categoriesFor: #testRemoveDecoration!public!tests! !
!WAComponentTest categoriesFor: #testRenderingChildren!public!tests-rendering! !
!WAComponentTest categoriesFor: #testRenderingDecoration!public!tests-rendering! !
!WAComponentTest categoriesFor: #testRenderingDelegation!public!tests-rendering! !
!WAComponentTest categoriesFor: #testUpdateRoot!public!tests! !
!WAComponentTest categoriesFor: #testUpdateStates!public!tests! !
!WAComponentTest categoriesFor: #testUpdateUrl!public!tests! !

"Binary Globals"!

