| package |
package := Package name: 'Seaside-Tests-Dolphin-Functional'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '12'.


package classNames
	add: #WAImageFunctionalTest;
	add: #WAPharoFunctionalTestsDefaultHandlersTest;
	yourself.

package methodNames
	add: #GRDolphinPlatform -> #seasideGarbageCollect;
	add: 'GRPackage class' -> #seasideTestsDolphinFunctional;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: '..\Grease\Grease-Dolphin-Core';
	add: 'Seaside-Core';
	add: 'Seaside-Session';
	add: 'Seaside-Tests-Environment';
	add: 'Seaside-Tests-Functional';
	yourself).

package!

"Class Definitions"!

WAFunctionalTest subclass: #WAImageFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAEnvironmentDefaultHandlersTest subclass: #WAPharoFunctionalTestsDefaultHandlersTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRDolphinPlatform methodsFor!

seasideGarbageCollect
	MemoryManager current collectGarbage! !
!GRDolphinPlatform categoriesFor: #seasideGarbageCollect!public! !

!GRPackage class methodsFor!

seasideTestsDolphinFunctional
	^(self new)
		name: 'Seaside-Tests-Dolphin-Functional';
		description: 'Pharo specific functional Seaside test suite.';
		addDependency: 'Seaside-Tests-Functional';
		addDependency: 'Seaside-Tests-Environment';
		addDependency: 'Seaside-Dolphin-Environment';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideTestsDolphinFunctional!*seaside-tests-pharo-functional!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

WAImageFunctionalTest guid: (GUID fromString: '{5657C742-0BBB-4C1E-B6CB-9A667B70380F}')!
WAImageFunctionalTest comment: ''!
!WAImageFunctionalTest categoriesForClass!Unclassified! !
!WAImageFunctionalTest methodsFor!

formClass
	^Smalltalk at: #Form ifAbsent: []!

haloDebugForm
	^self formClass
		extent: 16@16
		depth: 1
		fromArray: #( 0 0 0 50331648 25165824 12582912 281018368 415236096 264241152 132120576 7340032 3670016 1572864 0 0 0)
		offset: 0@0!

haloPaintForm
	^self formClass
		extent: 16@16
		depth: 1
		fromArray: #( 0 0 0 402653184 503316480 192937984 213909504 73400320 103809024 51904512 25690112 14155776 7340032 0 0 0)
		offset: 0@0!

haloViewForm
	^self formClass
		extent: 16@16
		depth: 1
		fromArray: #( 0 0 0 0 132120576 486014976 770965504 1341259776 669253632 467140608 132120576 0 0 0 0 0)
		offset: 0@0!

isSupported
	^self formClass notNil!

label
	^'Image'!

renderContentOn: html
	self isSupported
		ifTrue: [ self renderImagesOn: html ]
		ifFalse: [ self renderNotSupportedOn: html ]!

renderImagesOn: html
	html form: [
		html div: [
			html text: 'This one is clickable: '.
			html imageButton
				callback: [ self inform: 'ok' onAnswer: [ ] ];
				form: self haloDebugForm ] ].
		
	html paragraph: [
		html image
			form: self haloViewForm;
			altText: 'Halo-View'.
		html space.
		html image
			document: self haloPaintForm
			mimeType: 'image/png'
			fileName: 'Paint.png';
			altText: 'Halo-Paint' ]!

renderNotSupportedOn: html
	html heading: 'Your image doesn''t have the Form class'! !
!WAImageFunctionalTest categoriesFor: #formClass!accessing!public! !
!WAImageFunctionalTest categoriesFor: #haloDebugForm!accessing!public! !
!WAImageFunctionalTest categoriesFor: #haloPaintForm!accessing!public! !
!WAImageFunctionalTest categoriesFor: #haloViewForm!accessing!public! !
!WAImageFunctionalTest categoriesFor: #isSupported!public!testing! !
!WAImageFunctionalTest categoriesFor: #label!accessing!public! !
!WAImageFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAImageFunctionalTest categoriesFor: #renderImagesOn:!public!rendering! !
!WAImageFunctionalTest categoriesFor: #renderNotSupportedOn:!public!rendering! !

WAPharoFunctionalTestsDefaultHandlersTest guid: (GUID fromString: '{8C7D1C66-B188-4FB4-AB00-F6D439193DBC}')!
WAPharoFunctionalTestsDefaultHandlersTest comment: ''!
!WAPharoFunctionalTestsDefaultHandlersTest categoriesForClass!Unclassified! !
!WAPharoFunctionalTestsDefaultHandlersTest methodsFor!

testAllTests
	| app |
	app := self defaultDispatcher entryPointAt: 'tests/functional'.
	self assert: app class == WAApplication.
	self assert: app isApplication.
	self deny: app isDispatcher.
	self deny: app parent isNil.
	self assert: app name = 'functional'.
	self assert: app url pathString = '/tests/functional'!

testDefaultTests
	| app |
	app := self defaultDispatcher entryPointAt: 'tests'.
	self assert: app class == WADispatcher.
	self assert: app isDispatcher.
	self deny: app isRoot.
	self deny: app isApplication.
	self deny: app parent isNil.
	self assert: app name = 'tests'.
	self assert: app url pathString = '/tests'! !
!WAPharoFunctionalTestsDefaultHandlersTest categoriesFor: #testAllTests!public!tests! !
!WAPharoFunctionalTestsDefaultHandlersTest categoriesFor: #testDefaultTests!public!tests! !

"Binary Globals"!

