| package |
package := Package name: 'Seaside-Tests-Environment'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '24'.


package classNames
	add: #WAEnvironmentDefaultHandlersTest;
	add: #WAHtmlFileHandlerListingTest;
	add: #WALegacyRedirectionHandlerTest;
	yourself.

package methodNames
	add: 'GRPackage class' -> #seasideTestsEnvironment;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: 'Seaside-Core';
	add: 'Seaside-Environment';
	add: 'Seaside-Tests-Core';
	add: 'Seaside-Tools-Core';
	add: '..\..\Camp Smalltalk\SUnit\SUnit';
	yourself).

package!

"Class Definitions"!

TestCase subclass: #WAEnvironmentDefaultHandlersTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAContextTest subclass: #WALegacyRedirectionHandlerTest
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFileHandlerListingTest subclass: #WAHtmlFileHandlerListingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

seasideTestsEnvironment
	^ self new
		name: 'Seaside-Tests-Environment';
		description: 'Unit tests for the package Seaside-Environment.';
		addDependency: 'Seaside-Environment';
		addDependency: 'Seaside-Tests-Component';
		addDependency: 'Seaside-Tests-RenderLoop';
		addDependency: 'Seaside-Tests-Session';
		addDependency: 'Seaside-Tests-Canvas';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideTestsEnvironment!*seaside-tests-environment!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

WAEnvironmentDefaultHandlersTest guid: (GUID fromString: '{736F138B-0DE6-4B78-93D4-828135B02493}')!
WAEnvironmentDefaultHandlersTest comment: ''!
!WAEnvironmentDefaultHandlersTest categoriesForClass!Unclassified! !
!WAEnvironmentDefaultHandlersTest methodsFor!

defaultDispatcher
	^ WAAdmin defaultDispatcher!

testDefaultFiles
	| app |
	app := self defaultDispatcher entryPointAt: 'files'.
	self assert: app class == WAFileHandler.
	self deny: app isDispatcher.
	self deny: app isApplication.
	self deny: app parent isNil.
	self assert: app name = 'files'.
	self assert: app url pathString = '/files'!

testDefaultRoot
	| app |
	app := self defaultDispatcher.
	self assert: app class == WADispatcher.
	self assert: app isDispatcher.
	self assert: app isRoot.
	self deny: app isApplication.
	self assert: app parent isNil.
	self assert: app name = ''.
	self assert: app url pathString = '/'!

testInvalidConfig
	| app |
	app := self defaultDispatcher handlerAt: 'examplesxyz/counter' ifAbsent: [nil].
	self assert: app isNil.
	app := self defaultDispatcher handlerAt: 'examples/counterxyz' ifAbsent: [nil].
	self assert: app isNil.
	! !
!WAEnvironmentDefaultHandlersTest categoriesFor: #defaultDispatcher!private! !
!WAEnvironmentDefaultHandlersTest categoriesFor: #testDefaultFiles!public!tests! !
!WAEnvironmentDefaultHandlersTest categoriesFor: #testDefaultRoot!public!tests! !
!WAEnvironmentDefaultHandlersTest categoriesFor: #testInvalidConfig!public!tests! !

WALegacyRedirectionHandlerTest guid: (GUID fromString: '{A67124A5-4117-47A1-B725-F719B7B910ED}')!
WALegacyRedirectionHandlerTest comment: ''!
!WALegacyRedirectionHandlerTest categoriesForClass!Unclassified! !
!WALegacyRedirectionHandlerTest methodsFor!

createHandlers
	^ Array with: handler!

createRequest
	^ WARequest
		method: 'GET'
		uri: '/seaside/pier/environment/pier.png?view=PRDownloadView'
		version: 1.1
		!

setUp
	handler := WALegacyRedirectionHandler new!

testKeepParameters
	| responseUrl response |
	[ handler handleFiltered: self requestContext ]
		on: WAResponseNotification
		do: [ :notification | "ignore" ].
	response := self requestContext response.
	self assert: response status = 301.
	responseUrl := response headerAt: 'Location'.
	self assert: responseUrl greaseString = '/pier/environment/pier.png?view=PRDownloadView'! !
!WALegacyRedirectionHandlerTest categoriesFor: #createHandlers!configuration!public! !
!WALegacyRedirectionHandlerTest categoriesFor: #createRequest!configuration!public! !
!WALegacyRedirectionHandlerTest categoriesFor: #setUp!configuration!public! !
!WALegacyRedirectionHandlerTest categoriesFor: #testKeepParameters!public!testing! !

WAHtmlFileHandlerListingTest guid: (GUID fromString: '{1D4A5F21-CD70-4175-9566-F848126EEF39}')!
WAHtmlFileHandlerListingTest comment: ''!
!WAHtmlFileHandlerListingTest categoriesForClass!Unclassified! !
!WAHtmlFileHandlerListingTest methodsFor!

expectedMimeType
	^ WAMimeType textHtml!

handlerClass
	^ WAHtmlFileHandlerListing! !
!WAHtmlFileHandlerListingTest categoriesFor: #expectedMimeType!public!testing! !
!WAHtmlFileHandlerListingTest categoriesFor: #handlerClass!public!testing! !

"Binary Globals"!

