| package |
package := Package name: 'Seaside-Tests-Functional'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '124'.


package classNames
	add: #WAAllFunctionalTests;
	add: #WABatchFunctionalTest;
	add: #WAButtonFunctionalTest;
	add: #WACallbackFunctionalTest;
	add: #WACallbackSecurityFunctionalTest;
	add: #WACanvasTableFunctionalTest;
	add: #WAContextFunctionalTest;
	add: #WACookieFunctionalTest;
	add: #WADateSelectorFunctionalTest;
	add: #WADateTimeFunctionalTest;
	add: #WADelayFunctionalTest;
	add: #WADelegationFunctionalTest;
	add: #WADelegationTask;
	add: #WAEmptyTestTask;
	add: #WAEncodingFunctionalTest;
	add: #WAExceptionFunctionalTest;
	add: #WAExpiryFunctionalTest;
	add: #WAExpirySession;
	add: #WAFilterFunctionalTest;
	add: #WAFunctionalTaskTest;
	add: #WAFunctionalTest;
	add: #WAHomeFunctionalTest;
	add: #WAIframeFunctionalTest;
	add: #WAImageMapFunctionalTest;
	add: #WAInputElementContainer;
	add: #WAInputGetFunctionalTest;
	add: #WAInputPostFunctionalTest;
	add: #WAInputPostMultipartFunctionalTest;
	add: #WAKeyGeneratorFunctionalTest;
	add: #WALotsaLinksFunctionalTest;
	add: #WAManyTasksFunctionalTest;
	add: #WAMiniCalendarFunctionalTest;
	add: #WAModelFunctionalTest;
	add: #WAParameterFunctionalTest;
	add: #WAParentFunctionalTest;
	add: #WAPathFunctionalTest;
	add: #WAPerformanceFunctionalTest;
	add: #WAPhraseElementsFunctionalTest;
	add: #WAPopupCloseTestComponent;
	add: #WAPopupFunctionalTest;
	add: #WARequestFunctionalTest;
	add: #WARubyFunctionalTest;
	add: #WASvgFunctionalTest;
	add: #WATableReportFunctionalTest;
	add: #WATaskErrorFunctionalTest;
	add: #WATestsFunctionalPlatformTest;
	add: #WATrailFunctionalTest;
	add: #WATrailingSlashFunctionalTest;
	add: #WATrailTestComponent;
	add: #WATreeFunctionalTest;
	add: #WAUploadFunctionalTest;
	add: #WAUrlEncodingFunctionalTest;
	yourself.

package methodNames
	add: #GRPlatform -> #seasideGarbageCollect;
	add: 'GRPackage class' -> #seasideTestsFunctional;
	add: 'WAPresenter class' -> #isFunctionalTest;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: 'Seaside-Canvas';
	add: 'Seaside-Component';
	add: 'Seaside-Core';
	add: 'Seaside-Session';
	add: 'Seaside-Tests-Core';
	add: 'Seaside-Tools-Core';
	add: 'Seaside-Widgets';
	add: '..\..\Camp Smalltalk\SUnit\SUnit';
	yourself).

package!

"Class Definitions"!

WAComponent subclass: #WAAllFunctionalTests
	instanceVariableNames: 'classes current'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #WAFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #WAInputElementContainer
	instanceVariableNames: 'textInput textArea singleSelection singleSelectionOptional singleSelectionCustom multiSelection nestedSelection nestedMultiSelection checkbox radio upload hiddenInput radioCustom'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #WAPopupCloseTestComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #WATrailTestComponent
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WABatchFunctionalTest
	instanceVariableNames: 'batcher'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAButtonFunctionalTest
	instanceVariableNames: 'input'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WACallbackFunctionalTest
	instanceVariableNames: 'transcript'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WACallbackSecurityFunctionalTest
	instanceVariableNames: 'letter number'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WACanvasTableFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAContextFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WACookieFunctionalTest
	instanceVariableNames: 'firstKey firstValue firstPath secondKey secondValue secondPath'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WADateSelectorFunctionalTest
	instanceVariableNames: 'beginDate endDate beginTime endTime beginDAT endDAT'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WADateTimeFunctionalTest
	instanceVariableNames: 'date time message'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WADelayFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WADelegationFunctionalTest
	instanceVariableNames: 'task'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAEncodingFunctionalTest
	instanceVariableNames: 'urlencoded multipart get'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAExceptionFunctionalTest
	instanceVariableNames: 'renderError'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAExpiryFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAFilterFunctionalTest
	instanceVariableNames: 'child'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAHomeFunctionalTest
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAIframeFunctionalTest
	instanceVariableNames: 'calendar'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAImageMapFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAInputGetFunctionalTest
	instanceVariableNames: 'inputElements'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAInputPostFunctionalTest
	instanceVariableNames: 'inputElements hasBody ran'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAInputPostMultipartFunctionalTest
	instanceVariableNames: 'inputElements hasBody ran'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAKeyGeneratorFunctionalTest
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WALotsaLinksFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAManyTasksFunctionalTest
	instanceVariableNames: 'tasks selection'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAMiniCalendarFunctionalTest
	instanceVariableNames: 'calendar'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAModelFunctionalTest
	instanceVariableNames: 'state user pass test'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAParameterFunctionalTest
	instanceVariableNames: 'wasExecuted values'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAParentFunctionalTest
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAPathFunctionalTest
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAPerformanceFunctionalTest
	instanceVariableNames: 'duration referenceDict builder'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAPhraseElementsFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAPopupFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WARequestFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WARubyFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WASvgFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WATableReportFunctionalTest
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WATrailFunctionalTest
	instanceVariableNames: 'component trail'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WATrailingSlashFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WATreeFunctionalTest
	instanceVariableNames: 'selected tree'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAUploadFunctionalTest
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAUrlEncodingFunctionalTest
	instanceVariableNames: 'input'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WATask subclass: #WADelegationTask
	instanceVariableNames: 'component1 component2'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WATask subclass: #WAEmptyTestTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WATask subclass: #WAFunctionalTaskTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTaskTest subclass: #WATaskErrorFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WASession subclass: #WAExpirySession
	instanceVariableNames: ''
	classVariableNames: 'Created Unregistered'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #WATestsFunctionalPlatformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

seasideTestsFunctional
	^ self new
		name: 'Seaside-Tests-Functional';
		description: 'Functional Seaside test suite.';
		addDependency: 'Seaside-Environment';
		addDependency: 'Seaside-Widgets';
		addDependency: 'Seaside-Tests-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideTestsFunctional!*seaside-tests-functional!public! !

!GRPlatform methodsFor!

seasideGarbageCollect
	"this is only needed by the functional tests"
	self subclassResponsibility! !
!GRPlatform categoriesFor: #seasideGarbageCollect!*seaside-tests-functional!public! !

!WAPresenter class methodsFor!

isFunctionalTest
	^ false! !
!WAPresenter class categoriesFor: #isFunctionalTest!*seaside-tests-functional!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

WAAllFunctionalTests guid: (GUID fromString: '{3348CE66-5698-4AA7-AE2F-C5752732ACE0}')!
WAAllFunctionalTests comment: '
If you want to see these examples:

/seaside/config app:
- add a new application named "tests"
- choose WAAllTests as the root component
'!
!WAAllFunctionalTests categoriesForClass!Unclassified! !
!WAAllFunctionalTests methodsFor!

children
	^ Array with: current contents!

initialize
	super initialize.
	self initializeTests!

initializeTests
	classes := (WAPresenter allSubclasses select: [ :each | each isFunctionalTest ])
				asSortedCollection: [ :a :b | a name < b name ].
	current := WAValueHolder with: classes first new!

initialRequest: aRequest 
	super initialRequest: aRequest.
	self requestContext consumer nextIfPresentDo: 
		[ :className | 
		classes do: 
			[ :each | 
			"#greaseString is required because of Symbol <-> String comparison"
			each name greaseString = className ifTrue: [ self selected: each ] ] ]!

next
	| nextIndex |
	nextIndex := self selectionIndex \\ classes size + 1.
	self selected: (classes at: nextIndex)
	!

previous
	| nextIndex |
	nextIndex := (self selectionIndex + classes size - 2 \\ classes size) + 1.
	self selected: (classes at: nextIndex)!

renderContentOn: html
	html heading: self class description.
	html form: [
		html paragraph: [
			html anchor
				callback: [ self previous ];
				with: [ html html: '&larr;' ].
			html select
				list: classes;
				onChange: 'submit()';
				selected: self selected;
				labels: [ :value | value name ];
				callback: [ :value | self selected: value ].
			html anchor
				callback: [ self next ];
				with: [ html html: '&rarr;' ].
			html text: ' '; submitButton: 'Restart' ] ].
	html horizontalRule.
	html render: current contents!

selected
	^ current contents class!

selected: aClass
	current contents: aClass new.
	(current contents respondsTo: #parent:)
		ifTrue: [ current contents parent: self ]!

selectionIndex
	^classes indexOf: self selected!

states
	^ Array with: current!

updateUrl: aUrl
	super updateUrl: aUrl.
	aUrl addToPath: self selected name! !
!WAAllFunctionalTests categoriesFor: #children!accessing-readonly!public! !
!WAAllFunctionalTests categoriesFor: #initialize!initialization!public! !
!WAAllFunctionalTests categoriesFor: #initializeTests!initialization!public! !
!WAAllFunctionalTests categoriesFor: #initialRequest:!initialization!public! !
!WAAllFunctionalTests categoriesFor: #next!actions!public! !
!WAAllFunctionalTests categoriesFor: #previous!actions!public! !
!WAAllFunctionalTests categoriesFor: #renderContentOn:!public!rendering! !
!WAAllFunctionalTests categoriesFor: #selected!accessing!public! !
!WAAllFunctionalTests categoriesFor: #selected:!accessing!public! !
!WAAllFunctionalTests categoriesFor: #selectionIndex!private! !
!WAAllFunctionalTests categoriesFor: #states!accessing-readonly!public! !
!WAAllFunctionalTests categoriesFor: #updateUrl:!private! !

!WAAllFunctionalTests class methodsFor!

canBeRoot
	^ true!

description
	^ 'Seaside Functional Test Suite'!

initialize
	(WAAdmin register: self asApplicationAt: 'tests/functional')
		preferenceAt: #sessionClass put: WAExpirySession! !
!WAAllFunctionalTests class categoriesFor: #canBeRoot!public!testing! !
!WAAllFunctionalTests class categoriesFor: #description!accessing!public! !
!WAAllFunctionalTests class categoriesFor: #initialize!initialization!public! !

WAFunctionalTest guid: (GUID fromString: '{42703AE7-BA9C-4FF2-A211-84A3E8CF937D}')!
WAFunctionalTest comment: ''!
!WAFunctionalTest categoriesForClass!Unclassified! !
!WAFunctionalTest class methodsFor!

isFunctionalTest
	^ (self name = #WAFunctionalTest) not! !
!WAFunctionalTest class categoriesFor: #isFunctionalTest!public!testing! !

WAInputElementContainer guid: (GUID fromString: '{27E1EA47-8770-4B6E-8700-E59B132F55EC}')!
WAInputElementContainer comment: ''!
!WAInputElementContainer categoriesForClass!Unclassified! !
!WAInputElementContainer methodsFor!

elements
	^ #( Quito Dakar Sydney Bamako )!

nestedElements
	^ #(('Functional' ('Haskell ' 'Lisp' 'ML')) ('Dataflow' ('Hartmann pipelines' 'G' 'Max' 'Prograph')) ('Fourth-generation' ('Today' 'Ubercode' 'Uniface')))!

renderCheckboxOn: html
	self
		renderLabel: 'Checkbox'
		input: [
			html label: [
				html checkbox
					value: checkbox;
					callback: [ :value | checkbox := value ].
				html text: 'Checked' ] ]
		output: checkbox printString
		on: html!

renderContentOn: html
	self renderHeadingOn: html.
	self renderTextInputOn: html.
	self renderTextAreaOn: html.
	self renderHiddenInputOn: html.
	self renderCheckboxOn: html.
	self renderRadioButtonsOn: html.
	self renderRadioButtonsCustomOn: html.
	self renderSingleSelectionOn: html.
	self renderSingleSelectionCustomOn: html.
	self renderSingleSelectionOptionalOn: html.
	self renderMultiSelectionOn: html.
	self renderNestedSelectionOn: html.
	self renderNestedMultiSelectionOn: html.
	self renderUploadOn: html!

renderHeadingOn: html
	html tableRow: [
		html tableHeading.
		html tableHeading: 'Control'.
		html tableHeading: 'Print String' ]!

renderHiddenInputOn: html
	| string |
	string := hiddenInput ifNil: [ 'Seaside' ].
	self
		renderLabel: 'Hidden Input'
		input: [
			html render: string.			
			html hiddenInput
				value: string;
				callback: [ :value | hiddenInput := value ] ]
		output: hiddenInput printString
		on: html!

renderLabel: aString input: anInputBlock output: anOutputBlock on: html
	html tableRow: [
		html tableHeading: aString.
		html tableData: anInputBlock.
		html tableData: anOutputBlock ]!

renderMultiSelectionOn: html 
	self 
		renderLabel: 'Multi Selection'
		input: 
			[ html multiSelect
				list: self elements;
				titles: [ :each | 'Title: ' , each greaseString ];
				selected: multiSelection;
				callback: [ :value | multiSelection := value ] ]
		output: 
			[ multiSelection isEmptyOrNil ifFalse: 
				[ "empty lists are invalid HTML"
				html unorderedList list: multiSelection ] ]
		on: html!

renderNestedMultiSelectionOn: html
	| selectTag |
	self
		renderLabel: 'Nested Multi Selection'
		input: [
			selectTag := html multiSelect.
			selectTag
				size: 6;
				callback: [:value | nestedMultiSelection := value ];
				selected: nestedMultiSelection;
				with: [
					self nestedElements do: [ :list |
						html optionGroup
							label: list first;
							with: [
								list second do: [ :each |
									html option
										value: each with: selectTag ;
										with: each ] ] ] ] ]
		output: [ nestedMultiSelection isNil ifFalse: [ html unorderedList list: nestedMultiSelection ] ]
		on: html!

renderNestedSelectionOn: html
	| selectTag |
	self
		renderLabel: 'Nested Selection'
		input: [
			selectTag := html select.
			selectTag
				callback: [:value | nestedSelection := value ];
				selected: nestedSelection;
				with: [
					self nestedElements do: [ :list |
						html optionGroup
							label: list first;
							with: [
								list second do: [ :each |
									html option
										value: each with: selectTag;
										with: each ] ] ] ] ]
		output: nestedSelection printString
		on: html!

renderRadioButtonsCustomOn: html
	self
		renderLabel: 'Radiogroup (Custom)'
		input: [
			html radioGroup: [ :group |
					self elements do: [ :each |
						html label: [ 
							html radioButton
								group: group;
								selected: radioCustom = each;
								callback: [ radioCustom := each ].
							html text: each ].
						html break ] ] ]
		output: radioCustom printString
		on: html!

renderRadioButtonsOn: html
	self
		renderLabel: 'Radiogroup'
		input: [
			html radioGroup
				callback: [:value | radio := value];
				selected: radio;
				with: [ :group |
					self elements do: [ :each |
						html label: [ 
							group radioButton value: each.
							html text: each ].
						html break ] ] ]
		output: radio printString
		on: html!

renderSingleSelectionCustomOn: html 
	self 
		renderLabel: 'Single Selection (Custom)'
		input: [
			html select
				dispatchCallback;
				with: [
					self elements do: [ :each |
						html option
							label: 'Short: ' , (each copyFrom: 1 to: 3);
							callback: [ singleSelectionCustom := each ];
							selected: (singleSelectionCustom = each);
							with: 'Custom:' , each greaseString  ] ] ]
		output: singleSelectionCustom printString
		on: html!

renderSingleSelectionOn: html 
	self 
		renderLabel: 'Single Selection'
		input: 
			[ html select
				list: self elements;
				titles: [ :each | 'Title: ' , each greaseString ];
				selected: singleSelection;
				callback: [ :value | singleSelection := value ] ]
		output: singleSelection printString
		on: html!

renderSingleSelectionOptionalOn: html
	self
		renderLabel: 'Single Selection (Optional)'
		input: [
			html select
				beOptional;
				list: self elements;
				optionalLabel: '(none)';
				selected: singleSelectionOptional;
				callback: [ :value | singleSelectionOptional := value ] ]
		output: singleSelectionOptional printString
		on: html!

renderTextAreaOn: html
	self
		renderLabel: 'Text Area'
		input: [
			html textArea
				rows: 3;
				columns: 17;
				value: textArea;
				callback: [ :value | textArea := value ] ]
		output: textArea printString
		on: html!

renderTextInputOn: html
	self
		renderLabel: 'Text Input'
		input: [
			html textInput
				value: textInput;
				callback: [ :value | textInput := value ] ]
		output: textInput printString
		on: html!

renderUploadOn: html
	self
		renderLabel: 'Upload'
		input: [ html fileUpload callback: [ :file | upload := file ] ]
		output: upload printString
		on: html! !
!WAInputElementContainer categoriesFor: #elements!accessing!public! !
!WAInputElementContainer categoriesFor: #nestedElements!accessing!public! !
!WAInputElementContainer categoriesFor: #renderCheckboxOn:!public!rendering-elements! !
!WAInputElementContainer categoriesFor: #renderContentOn:!public!rendering! !
!WAInputElementContainer categoriesFor: #renderHeadingOn:!public!rendering! !
!WAInputElementContainer categoriesFor: #renderHiddenInputOn:!public!rendering-elements! !
!WAInputElementContainer categoriesFor: #renderLabel:input:output:on:!public!rendering! !
!WAInputElementContainer categoriesFor: #renderMultiSelectionOn:!public!rendering-elements! !
!WAInputElementContainer categoriesFor: #renderNestedMultiSelectionOn:!public!rendering-elements! !
!WAInputElementContainer categoriesFor: #renderNestedSelectionOn:!public!rendering-elements! !
!WAInputElementContainer categoriesFor: #renderRadioButtonsCustomOn:!public!rendering-elements! !
!WAInputElementContainer categoriesFor: #renderRadioButtonsOn:!public!rendering-elements! !
!WAInputElementContainer categoriesFor: #renderSingleSelectionCustomOn:!public!rendering-elements! !
!WAInputElementContainer categoriesFor: #renderSingleSelectionOn:!public!rendering-elements! !
!WAInputElementContainer categoriesFor: #renderSingleSelectionOptionalOn:!public!rendering-elements! !
!WAInputElementContainer categoriesFor: #renderTextAreaOn:!public!rendering-elements! !
!WAInputElementContainer categoriesFor: #renderTextInputOn:!public!rendering-elements! !
!WAInputElementContainer categoriesFor: #renderUploadOn:!public!rendering-elements! !

WAPopupCloseTestComponent guid: (GUID fromString: '{37DA5230-289F-4EAD-906B-A8E472ECD100}')!
WAPopupCloseTestComponent comment: ''!
!WAPopupCloseTestComponent categoriesForClass!Unclassified! !
!WAPopupCloseTestComponent methodsFor!

renderContentOn: html
	html anchor callback: [self requestContext closeThisPopup]; with: 'Close me'.
	html break.
	html anchor callback: [self requestContext closeThisPopupAndReloadOpener]; with: 'Close me and reload opener'.
	! !
!WAPopupCloseTestComponent categoriesFor: #renderContentOn:!public!rendering! !

WATrailTestComponent guid: (GUID fromString: '{301D38E1-73CF-4E13-B7BC-7FFC73015FDF}')!
WATrailTestComponent comment: ''!
!WATrailTestComponent categoriesForClass!Unclassified! !
!WATrailTestComponent methodsFor!

count: aNumber
	count := aNumber!

initialize
	super initialize.
	count := 1!

renderContentOn: html
	html heading
		level: 1;
		with: self trailName.

	html anchor
		callback: [ self show: (self class new count: count+1; yourself) ];
		with: 'Call'.
		
	html space.
		
	html anchor
		callback: [ self answer ];
		with: 'Answer'!

trailName
	^ 'Item ' , count greaseString , ' (' , self identityHash greaseString , ')'! !
!WATrailTestComponent categoriesFor: #count:!accessing!public! !
!WATrailTestComponent categoriesFor: #initialize!initialization!public! !
!WATrailTestComponent categoriesFor: #renderContentOn:!public!rendering! !
!WATrailTestComponent categoriesFor: #trailName!accessing!public! !

WABatchFunctionalTest guid: (GUID fromString: '{EB360B82-DC12-4803-8935-9579B31EEBBA}')!
WABatchFunctionalTest comment: ''!
!WABatchFunctionalTest categoriesForClass!Unclassified! !
!WABatchFunctionalTest methodsFor!

children
	^ Array with: batcher!

initialize
	super initialize.
	batcher := WAAlphabeticBatchedList new items: Collection allSubclasses!

renderContentOn: html
	html render: batcher.
	html unorderedList
		list: batcher batch! !
!WABatchFunctionalTest categoriesFor: #children!accessing!public! !
!WABatchFunctionalTest categoriesFor: #initialize!initialization!public! !
!WABatchFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !

WAButtonFunctionalTest guid: (GUID fromString: '{D46BF752-21CB-43C4-9607-F52375753B31}')!
WAButtonFunctionalTest comment: ''!
!WAButtonFunctionalTest categoriesForClass!Unclassified! !
!WAButtonFunctionalTest methodsFor!

initialize
	super initialize.
	self input: 'a text'!

input
	^input!

input: aString
	input := aString!

renderContentOn: html
	html form: [
		html div: [
			self renderInputOn: html.
			self renderSubmitOn: html.
			self renderResetOn: html.
			self renderPushOn: html ] ]!

renderInputOn: html
	html table: [
		html tableRow: [
			html tableHeading: 'Value:'.
			html tableData: self input ].
		html tableRow: [
			html tableHeading: 'Input:'.
			html tableData: [
				html textInput
					on: #input of: self ] ] ]!

renderPushOn: html
	html heading level2 with: 'Push'.
	html paragraph: 'Clicking the button should not do anything.'.
	html button bePush; with: 'Push'!

renderResetOn: html
	html heading level2 with: 'Reset'.
	html paragraph: 'Clicking the button should not submit the form and reset the value in "Input"'.
	html button beReset; with: 'Reset'!

renderSubmitOn: html
	html heading level2 with: 'Submit'.
	html paragraph: 'Clicking the button should submit the form and update the value in "Value:" with the value in "Input"'.
	html button with: 'Submit'! !
!WAButtonFunctionalTest categoriesFor: #initialize!initialization!public! !
!WAButtonFunctionalTest categoriesFor: #input!accessing!public! !
!WAButtonFunctionalTest categoriesFor: #input:!accessing!public! !
!WAButtonFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAButtonFunctionalTest categoriesFor: #renderInputOn:!public!rendering! !
!WAButtonFunctionalTest categoriesFor: #renderPushOn:!public!rendering! !
!WAButtonFunctionalTest categoriesFor: #renderResetOn:!public!rendering! !
!WAButtonFunctionalTest categoriesFor: #renderSubmitOn:!public!rendering! !

WACallbackFunctionalTest guid: (GUID fromString: '{EB959CE2-629E-4ED7-A033-A579751D549B}')!
WACallbackFunctionalTest comment: ''!
!WACallbackFunctionalTest categoriesForClass!Unclassified! !
!WACallbackFunctionalTest methodsFor!

append: aString
	transcript nextPutAll: aString; nextPut: Character cr!

initialize
	super initialize.
	transcript := WriteStream on: String new!

renderContentOn: html 
	html paragraph: 'Depending on the way the form is submitted the following actions should be triggered and logged:'.
	html orderedList list: #( 
		'Default: Text, Default'
		'Before: Text'
		'Before Submit: Text, Before Submit'
		'Before Cancel: Before Cancel'
		'After: Text'
		'After Submit: Text, After Submit'
		'After Cancel: After Cancel'
	).
	html form
		defaultAction: [ self append: 'Default' ] ;
		with: [
			html div: [
				"div for validation"
				html submitButton
					text: 'Before'.
				html submitButton
					callback:  [ self append: 'Before Submit' ];
					text: 'Before Submit'.
				html cancelButton
					callback:  [ self append: 'Before Cancel' ];
					text: 'Before Cancel'.
				html break.
				html textInput
					value: 'Some Text';
					callback: [ :value | self append: 'Text: ' , value ].
				html break.
				html submitButton
					text: 'After'.
				html submitButton
					callback:  [ self append: 'After Submit' ];
					text: 'After Submit'.
				html cancelButton
					callback:  [ self append: 'After Cancel' ];
					text: 'After Cancel' ] ].
	html preformatted: transcript contents.
	transcript reset! !
!WACallbackFunctionalTest categoriesFor: #append:!accessing!public! !
!WACallbackFunctionalTest categoriesFor: #initialize!initialization!public! !
!WACallbackFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !

WACallbackSecurityFunctionalTest guid: (GUID fromString: '{83714085-CF48-4EE2-8A1A-625955931899}')!
WACallbackSecurityFunctionalTest comment: ''!
!WACallbackSecurityFunctionalTest categoriesForClass!Unclassified! !
!WACallbackSecurityFunctionalTest methodsFor!

initialize
	super initialize.
	number := 1.
	letter := $A.!

renderContentOn: html 
	self renderInstructionsOn: html.
	html form: 
		[ html div: 
			[ self renderNumberListOn: html.
			self renderLetterListOn: html.
			html submitButton ] ].
	html paragraph: 'This should always be a NUMBER: ' , number greaseString.
	html paragraph: 'This should always be a LETTER: ' , letter greaseString.
	html paragraph: 
		[ | url |
		url := html actionUrl greaseString.
		html anchor
			url: '#';
			onClick: 'swapCallbacks("' , url , '","letter-list", "number-list")';
			with: 'Try to break it' ]!

renderInstructionsOn: html
	html paragraph: 'This test requires JavaScript. The list boxes should behave normally when used with the submit button. The link will try to submit the value C to the number listbox and the value 3 to the letter list box.'.
	html paragraph: 'Current behaviour results in C and 3 being selected in the appropriate lists. What is essential, however, is only that the values are not selected in the wrong list because this might allow an attacker to trick seaside into running methods on the wrong objects.'.!

renderLetterListOn: html
	html select
		id: 'letter-list';
		size: 3;
		selected: letter;
		list: (Array with: $A with: $B with: $C);
		callback: [ :value | letter := value ]!

renderNumberListOn: html
	html select
		id: 'number-list';
		size: 3;
		selected: number;
		list: (Array with: 1 with: 2 with: 3);
		callback: [ :value | number := value ]!

script
^ '
function swapCallbacks(url, list1id, list2id) {
	list1 = document.getElementById(list1id);
	list2 = document.getElementById(list2id);
	
	document.location = url
		+ "&" + list1.name + "=" + list2.options[2].value
		+ "&" + list2.name + "=" + list1.options[2].value;
}
		
'!

states
	^ Array with: self! !
!WACallbackSecurityFunctionalTest categoriesFor: #initialize!initialization!public! !
!WACallbackSecurityFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WACallbackSecurityFunctionalTest categoriesFor: #renderInstructionsOn:!public!rendering! !
!WACallbackSecurityFunctionalTest categoriesFor: #renderLetterListOn:!public!rendering! !
!WACallbackSecurityFunctionalTest categoriesFor: #renderNumberListOn:!public!rendering! !
!WACallbackSecurityFunctionalTest categoriesFor: #script!accessing!public! !
!WACallbackSecurityFunctionalTest categoriesFor: #states!accessing!public! !

WACanvasTableFunctionalTest guid: (GUID fromString: '{170C3DF1-0294-48DE-BD6B-0EE3789960CC}')!
WACanvasTableFunctionalTest comment: ''!
!WACanvasTableFunctionalTest categoriesForClass!Unclassified! !
!WACanvasTableFunctionalTest methodsFor!

entities
	^#(
		('non-breaking space' ('&nbsp;' '&#160;' '&#xA0;'))
		('ampersand' ('&amp;' '&#38;' '&#x26;'))
		('less than sign' ('&lt;' '&#60;' '&#x3C;'))
		('greater than sign' ('&gt;' '&#62;' '&#x3E;'))
		('euro sign' ('&euro;' '&#8364;' '&#x20AC;'))
	)!

exchangeRates
	^#(
		('EUR' 1.70)
		('USD' 1.30)
		('DKK' 23.36)
		('SEK' 19.32)
	)!

renderContentOn: html
	html div
		class: 'wacanvastabletest';
		with: [
			self renderEntityTableOn: html.
			self renderCurrencyTableOn: html ]!

renderCurrencyTableBodyOn: html
	html tableBody title: 'Table body';
		with: [
			self exchangeRates do: [:each |
				html tableRow: [
					html tableHeading: each first.
					html tableData align: 'char'; character: $.;
						with: each second]]]!

renderCurrencyTableHeadOn: html
	html tableHead title: 'Table header';
		with: [
			html tableRow: [
				html tableHeading: 'Currency'.
				html tableHeading: 'Rate']]!

renderCurrencyTableOn: html
	html table
 		summary: 'This table shows exchange rates against the Swiss Franc';
		with: [
			html tableCaption: 'Currencies against Swiss Franc (CHF)'.
			html tableColumnGroup.
			html tableColumnGroup width: '100px'; align: 'char'; character: $..
			self renderCurrencyTableHeadOn: html.
			self renderCurrencyTableBodyOn: html]!

renderEntityTableBodyOn: html
	html tableBody: [
		self entities do: [:eachEntity |
			html tableRow: [
				html tableData scope: 'row';
					with: eachEntity first.
				eachEntity second do: [ :each |
					html tableData: each ].
				eachEntity second do: [ :each |
					html tableData align: 'center';
						with: [ html html: each ] ] ] ] ]!

renderEntityTableColumnGroupsOn: html
	html tableColumnGroup.
	html tableColumnGroup span: 3.
	html tableColumnGroup span: 3; align: 'center'!

renderEntityTableFootOn: html
	html tableFoot: [
		html tableRow: [
			html tableData align: 'center'; colSpan: 7;
				with: '5 entities shown']]!

renderEntityTableHeadOn: html
	html tableHead: [
		html tableRow: [
			#('Character' 'Entity' 'Decimal' 'Hex') do: [:each |
				html tableHeading scope: 'col'; rowSpan: 2;
					with: each].
			html tableHeading scope: 'colgroup'; colSpan: 3;
				with: 'Rendering in Your Browser'
		].
		html tableRow: [
			#('Entity' 'Decimal' 'Hex') do: [:each |
				html tableHeading scope: 'col'; with: each]
		].
	]!

renderEntityTableOn: html
	html table
 		summary: 'This table gives the character entity reference,
                decimal character reference, and hexadecimal character
                reference for 8-bit Latin-1 characters, as well as the
                rendering of each in your browser.';
		with: [
			html tableCaption: 'HTML 4.0 entities'.
			self renderEntityTableColumnGroupsOn: html.
			self renderEntityTableHeadOn: html.
			self renderEntityTableFootOn: html.
			self renderEntityTableBodyOn: html]!

style
	^'
.wacanvastabletest table {
	border-collapse: collapse;
	border:1px solid black;
	margin:0px auto; /* center */
}

.wacanvastabletest caption {
	margin:0px auto; /* center */
}
.wacanvastabletest caption {
	font-weight: bold;
	padding: 0.5em 0 1em 0;
}
.wacanvastabletest td, .wacanvastabletest th {
	padding: 3px;
	border:1px solid black;
}
'! !
!WACanvasTableFunctionalTest categoriesFor: #entities!public!samples! !
!WACanvasTableFunctionalTest categoriesFor: #exchangeRates!public!samples! !
!WACanvasTableFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WACanvasTableFunctionalTest categoriesFor: #renderCurrencyTableBodyOn:!public!rendering! !
!WACanvasTableFunctionalTest categoriesFor: #renderCurrencyTableHeadOn:!public!rendering! !
!WACanvasTableFunctionalTest categoriesFor: #renderCurrencyTableOn:!public!rendering! !
!WACanvasTableFunctionalTest categoriesFor: #renderEntityTableBodyOn:!public!rendering! !
!WACanvasTableFunctionalTest categoriesFor: #renderEntityTableColumnGroupsOn:!public!rendering! !
!WACanvasTableFunctionalTest categoriesFor: #renderEntityTableFootOn:!public!rendering! !
!WACanvasTableFunctionalTest categoriesFor: #renderEntityTableHeadOn:!public!rendering! !
!WACanvasTableFunctionalTest categoriesFor: #renderEntityTableOn:!public!rendering! !
!WACanvasTableFunctionalTest categoriesFor: #style!public!rendering! !

WAContextFunctionalTest guid: (GUID fromString: '{95E01197-8370-4538-922B-5A2984B07E5D}')!
WAContextFunctionalTest comment: ''!
!WAContextFunctionalTest categoriesForClass!Unclassified! !
!WAContextFunctionalTest methodsFor!

renderContentOn: html
	self renderExplanationOn: html.
	html table: [
		self renderLabel: 'Codec:' value:  self requestContext codec on: html.
		self renderLabel: 'Session:' value:  self requestContext session on: html.
		self renderLabel: 'Application:' value:  self requestContext application on: html.
		self renderLabel: 'Request:' value:  self requestContext request on: html.
		self renderLabel: 'Response:' value:  self requestContext response on: html.
		self renderRequestHandlersOn: html.
		self renderPropertiesOn: html ]!

renderExplanationOn: html

	html paragraph: 'The purpose of this test is to make sure WAContext and WACurrentContext work correctly. For each label you should see the print string of one or several matching objects. For the ''Request Handlers'' the first object should be a WASession or subclass, the second a WAApplication and then one or several WADispatchers matching the path.'!

renderLabel: aString value: anObject on: html
	html tableRow: [
		html tableHeading: aString.
		html tableData: anObject ]!

renderPropertiesOn: html
	html tableRow: [
		html tableHeading: 'Properties:'.
		html tableData: [
			| properties |
			properties := self requestContext properties.
			properties isEmpty ifFalse: [
				html definitionList: [
					properties keysAndValuesDo: [ :key :value |
						html definitionTerm: key.
						html definitionData: value ] ] ] ] ]!

renderRequestHandlersOn: html 
	html tableRow: [
		html tableHeading: 'Request Handlers:'.
		html tableData: [ 
			html orderedList list: self requestContext handlers ] ]! !
!WAContextFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAContextFunctionalTest categoriesFor: #renderExplanationOn:!public!rendering! !
!WAContextFunctionalTest categoriesFor: #renderLabel:value:on:!public!rendering! !
!WAContextFunctionalTest categoriesFor: #renderPropertiesOn:!public!rendering! !
!WAContextFunctionalTest categoriesFor: #renderRequestHandlersOn:!public!rendering! !

WACookieFunctionalTest guid: (GUID fromString: '{7A663E77-F271-42D3-8600-1927FC4FC4D5}')!
WACookieFunctionalTest comment: ''!
!WACookieFunctionalTest categoriesForClass!Unclassified! !
!WACookieFunctionalTest methodsFor!

addBoth
	self requestContext response addCookie: self firstCookie.
	self requestContext response addCookie: self secondCookie.
	
	self resetFirst.
	self resetSecond!

addFirst
	self requestContext response addCookie: self firstCookie.
	
	self resetFirst!

cookies
	^ self requestContext request cookies!

firstCookie
	^self requestContext newCookie
		key: self firstKey;
		value: self firstValue;
		path: self firstPath;
		yourself!

firstKey
	^ firstKey!

firstKey: aString
	firstKey := aString!

firstPath
	^ firstPath!

firstPath: aString
	firstPath := aString!

firstValue
	^ firstValue!

firstValue: aString
	firstValue := aString!

initialize
	super initialize.
	self firstPath: self application url pathString.
	self secondPath: self application url pathString.!

remove: aCookie
	self requestContext response deleteCookie: aCookie!

renderCombiningOn: html
	html listItem: 'Setting both cookies should work in Kom and is broken in Swazoo.'!

renderContentOn: html
	self renderExplanationOn: html.

	html form: [
		html table: [
			self renderHeadingsOn: html.
			self renderCookiesOn: html.
			self renderInputOn: html ] ]!

renderCookiesOn: html
	self cookies do: [ :each |
		html tableRow: [
			html tableData: each key.
			html tableData: each value.
			html tableData: each path.
			html tableData: each domain.
			html tableData: each ports.
			html tableData: [
				html submitButton
					callback: [ self remove: each ];
					text: 'remove' ] ] ]!

renderExplanationOn: html
	html unorderedList: [
		self renderFirefoxOn: html.
		self renderSafariOn: html.
		self renderOperaOn: html.
		self renderRemoveOn: html ]!

renderFirefoxOn: html
	html listItem: 'On Firefox the path is not supposed to work. But if you look under Settings -> Cookies the cookie should be saved with the correct path.'!

renderHeadingsOn: html
	html tableRow: [
		html tableHeading: 'Key'.
		html tableHeading: 'Value'.
		html tableHeading: 'Path'.
		html tableHeading: 'Domain'.
		html tableHeading: 'Ports'.
		html tableHeading ]!

renderInputFirstOn: html
	html tableRow: [
		self renderInputForCookie: #first on: html.
		html tableData: [
			html submitButton
				on: #addFirst of: self ] ]!

renderInputForCookie: aSymbol on: html
	html tableData: [
		html textInput
			on: (aSymbol, #Key) asSymbol of: self ].
	html tableData: [
		html textInput
			on: (aSymbol, #Value) asSymbol of: self ].
	html tableData: [
		html textInput
			on: (aSymbol, #Path) asSymbol of: self ].
	html tableData.
	html tableData.!

renderInputOn: html
	self renderInputFirstOn: html.
	self renderInputSecondOn: html!

renderInputSecondOn: html
	html tableRow: [
		self renderInputForCookie: #second on: html.
		html tableData: [
			html submitButton
				on: #addBoth of: self ] ]!

renderOperaOn: html
	html listItem: 'Opera is supposed to work perfectly.'!

renderRemoveOn: html
	html listItem: 'Removing should work on Firefox and Safari but only if the path is unchanged. On Opera it should delete the value and the path.'!

renderSafariOn: html
	html listItem: 'On Safari the path is not supposed to work. But if you look under Preferences -> Security -> Show Cookies the cookie should be saved with the correct path.'!

resetFirst
	self firstKey: nil.
	self firstValue: nil.
	self firstPath: self application url pathString!

resetSecond
	self secondKey: nil.
	self secondValue: nil.
	self secondPath: self application url pathString!

secondCookie
	^self requestContext newCookie
		key: self secondKey;
		value: self secondValue;
		path: self secondPath;
		yourself!

secondKey
	^ secondKey!

secondKey: aString
	secondKey := aString!

secondPath
	^ secondPath!

secondPath: aString
	secondPath := aString!

secondValue
	^ secondValue!

secondValue: aString
	secondValue := aString! !
!WACookieFunctionalTest categoriesFor: #addBoth!actions!public! !
!WACookieFunctionalTest categoriesFor: #addFirst!actions!public! !
!WACookieFunctionalTest categoriesFor: #cookies!accessing!public! !
!WACookieFunctionalTest categoriesFor: #firstCookie!accessing!public! !
!WACookieFunctionalTest categoriesFor: #firstKey!accessing!public! !
!WACookieFunctionalTest categoriesFor: #firstKey:!accessing!public! !
!WACookieFunctionalTest categoriesFor: #firstPath!accessing!public! !
!WACookieFunctionalTest categoriesFor: #firstPath:!accessing!public! !
!WACookieFunctionalTest categoriesFor: #firstValue!accessing!public! !
!WACookieFunctionalTest categoriesFor: #firstValue:!accessing!public! !
!WACookieFunctionalTest categoriesFor: #initialize!initialization!public! !
!WACookieFunctionalTest categoriesFor: #remove:!actions!public! !
!WACookieFunctionalTest categoriesFor: #renderCombiningOn:!public!rendering-explanation! !
!WACookieFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WACookieFunctionalTest categoriesFor: #renderCookiesOn:!public!rendering! !
!WACookieFunctionalTest categoriesFor: #renderExplanationOn:!public!rendering! !
!WACookieFunctionalTest categoriesFor: #renderFirefoxOn:!public!rendering-explanation! !
!WACookieFunctionalTest categoriesFor: #renderHeadingsOn:!public!rendering! !
!WACookieFunctionalTest categoriesFor: #renderInputFirstOn:!public!rendering! !
!WACookieFunctionalTest categoriesFor: #renderInputForCookie:on:!public!rendering! !
!WACookieFunctionalTest categoriesFor: #renderInputOn:!public!rendering! !
!WACookieFunctionalTest categoriesFor: #renderInputSecondOn:!public!rendering! !
!WACookieFunctionalTest categoriesFor: #renderOperaOn:!public!rendering-explanation! !
!WACookieFunctionalTest categoriesFor: #renderRemoveOn:!public!rendering-explanation! !
!WACookieFunctionalTest categoriesFor: #renderSafariOn:!public!rendering-explanation! !
!WACookieFunctionalTest categoriesFor: #resetFirst!private! !
!WACookieFunctionalTest categoriesFor: #resetSecond!private! !
!WACookieFunctionalTest categoriesFor: #secondCookie!accessing!public! !
!WACookieFunctionalTest categoriesFor: #secondKey!accessing!public! !
!WACookieFunctionalTest categoriesFor: #secondKey:!accessing!public! !
!WACookieFunctionalTest categoriesFor: #secondPath!accessing!public! !
!WACookieFunctionalTest categoriesFor: #secondPath:!accessing!public! !
!WACookieFunctionalTest categoriesFor: #secondValue!accessing!public! !
!WACookieFunctionalTest categoriesFor: #secondValue:!accessing!public! !

WADateSelectorFunctionalTest guid: (GUID fromString: '{B465E324-BA21-44BF-80E4-48F6386E5473}')!
WADateSelectorFunctionalTest comment: ''!
!WADateSelectorFunctionalTest categoriesForClass!Unclassified! !
!WADateSelectorFunctionalTest methodsFor!

children
	^(OrderedCollection new)
		add: beginDate;
		add: endDate;
		add: beginTime;
		add: endTime;
		add: beginDAT;
		add: endDAT;
		yourself!

computeDuration
	| dateDiff |
	dateDiff := (endDAT dateAndTime asDate - beginDAT dateAndTime asDate) days.
	dateDiff isZero 
		ifFalse: 
			[ self 
				inform: dateDiff greaseString , ' day(s)'
				onAnswer: [ ] ]
		ifTrue: 
			[ self 
				inform: (endDAT dateAndTime asTime subtractTime: beginDAT dateAndTime asTime) asSeconds greaseString , ' second(s)'
				onAnswer: [ ] ]!

initialize
	super initialize.
	beginDate := WADateSelector new.
	endDate := WADateSelector new.
	endDate date: (Date today addDays: 1).

	beginTime := WATimeSelector new.
	beginTime time: Time now.
	endTime := WATimeSelector new.
	endTime time: (beginTime time addSeconds: 3600).

	beginDAT := WADateTimeSelector new.
	endDAT := WADateTimeSelector new.
	endDAT dateAndTime: beginDAT dateAndTime + 1 days + 1 hours!

renderContentOn: html

	self renderDateSelectorsOn: html.
	html horizontalRule.
	self renderTimeSelectorsOn: html.
	html horizontalRule.
	self renderDateTimeSelectorsOn: html!

renderDateSelectorsOn: html 
	html heading
		level3;
		with: 'Dates'.
	html form: 
		[ html table: 
			[ html tableRow: 
				[ html
					tableData: 'From';
					tableData: beginDate ].
			html tableRow: 
				[ html
					tableData: 'To';
					tableData: endDate ] ].
		html div: 
			[ html submitButton
				callback: 
					[ self 
						inform: (endDate date - beginDate date) days greaseString , ' day(s)'
						onAnswer: [ ] ];
				text: 'Compute duration' ] ]!

renderDateTimeSelectorsOn: html
	html heading level3; with: 'Dates and Times'.
	html form: [
		html table: [
			html tableRow: [
				html tableData: 'From'; tableData: beginDAT ].
			html tableRow: [
				html tableData: 'To'; tableData: endDAT ] ].
		html div: [
			html submitButton
				callback: [ self computeDuration ];
				text: 'Compute duration' ] ]!

renderTimeSelectorsOn: html 
	html heading
		level3;
		with: 'Times'.
	html form: 
		[ html table: 
			[ html tableRow: 
				[ html
					tableData: 'From';
					tableData: beginTime ].
			html tableRow: 
				[ html
					tableData: 'To';
					tableData: endTime ] ].
		html div: 
			[ html submitButton
				callback: 
					[ self 
						inform: (endTime time subtractTime: beginTime time) asSeconds greaseString , ' seconds(s)'
						onAnswer: [ ] ];
				text: 'Compute duration' ] ]! !
!WADateSelectorFunctionalTest categoriesFor: #children!accessing!public! !
!WADateSelectorFunctionalTest categoriesFor: #computeDuration!actions!public! !
!WADateSelectorFunctionalTest categoriesFor: #initialize!initialization!public! !
!WADateSelectorFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WADateSelectorFunctionalTest categoriesFor: #renderDateSelectorsOn:!public!rendering! !
!WADateSelectorFunctionalTest categoriesFor: #renderDateTimeSelectorsOn:!public!rendering! !
!WADateSelectorFunctionalTest categoriesFor: #renderTimeSelectorsOn:!public!rendering! !

WADateTimeFunctionalTest guid: (GUID fromString: '{EC22A183-71D5-4157-BD0E-0AC9ECA66EDF}')!
WADateTimeFunctionalTest comment: ''!
!WADateTimeFunctionalTest categoriesForClass!Unclassified! !
!WADateTimeFunctionalTest methodsFor!

date
	^date!

date: aDate
	date := aDate!

renderContentOn: html
	self renderDateTimeOn: html.
	self renderDeadDateTimeOn: html!

renderDateTimeOn: html 
	html heading
		level3;
		with: 'Form with #dateInput and #timeInput'.
	html form
		defaultAction: [ message := 'Default action: ' , date greaseString , ' ' , time greaseString ];
		with: [
			html div: [
				" use #callback: and #with: "
				html dateInput
					callback: [ :value | self date: value ];
					with: self date.
				html space: 10.
				" use #on:of: "
				html timeInput
					withSeconds;
					on: #time of: self.
				html break.
				html text: message.
				html break.
				html submitButton 
					callback: [ message := 'Button action: ' , date greaseString , ' ' , time greaseString ] ] ]!

renderDeadDateTimeOn: html
	html heading
		level: 3;
		with: 'Div with #dateInput and #timeInput, no callback'.
	html form: [
		html div: [
			html dateInput value: Date today.
			html space: 10.
			html timeInput withSeconds; with: Time now.
			html break.
			html withLineBreaks: 'The year portion of the date should be visible.
				The seconds portion of the time should be visible.
				Exactly one date and one time selector should be visible.' ] ]!

time
	^time!

time: aTime
	time := aTime! !
!WADateTimeFunctionalTest categoriesFor: #date!accessing!public! !
!WADateTimeFunctionalTest categoriesFor: #date:!accessing!public! !
!WADateTimeFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WADateTimeFunctionalTest categoriesFor: #renderDateTimeOn:!public!rendering! !
!WADateTimeFunctionalTest categoriesFor: #renderDeadDateTimeOn:!public!rendering! !
!WADateTimeFunctionalTest categoriesFor: #time!accessing!public! !
!WADateTimeFunctionalTest categoriesFor: #time:!accessing!public! !

WADelayFunctionalTest guid: (GUID fromString: '{4152E6F2-1DEA-4054-A06E-942FB2224D18}')!
WADelayFunctionalTest comment: ''!
!WADelayFunctionalTest categoriesForClass!Unclassified! !
!WADelayFunctionalTest methodsFor!

go
	self show: (WAComponent new
		addMessage: '3 seconds';
		addDecoration: (WADelayedAnswerDecoration new delay: 3);
		yourself)!

renderContentOn: html
	html paragraph: 'Clicking the following anchor should replace it with the message "3 seconds" for 3 seconds and then restore it.'.
	html paragraph: [
		html anchor
			callback: [ self go ];
			with: 'Start' ]! !
!WADelayFunctionalTest categoriesFor: #go!actions!public! !
!WADelayFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !

WADelegationFunctionalTest guid: (GUID fromString: '{94704006-FDA0-42AA-8A5B-1B31BDE7CEB1}')!
WADelegationFunctionalTest comment: 'http://code.google.com/p/seaside/issues/detail?id=71'!
!WADelegationFunctionalTest categoriesForClass!Unclassified! !
!WADelegationFunctionalTest methodsFor!

children
	^ Array with: task!

initialize
	super initialize.
	task := WADelegationTask new!

renderContentOn: html
	html orderedList: [
		html listItem: 'Click button of Step 1'.
		html listItem: 'Click back-button'.
		html listItem: 'Click button of Step 1'.
		html listItem: 'Click button of Step 2' ].
	html paragraph: 'Step 1 and Step 2 should have consistent number of visible presenters. Especially there should never be two WAAnswerDecorations.'.
	
	html heading level: 2; with: 'Application'.
	html render: task.
	
	html heading level: 2; with: 'Visible Presenters'.
	html table: [
		html tableRow: [
			html tableHeading: 'Presenter'.
			html tableHeading.
			html tableHeading: 'Next'.
			html tableHeading ].
		self visiblePresentersDo: [ :each |
			html tableRow: [
				html tableData: each printString.
				html tableData: each identityHash.
				html tableData: (each isDecoration
					ifTrue: [ each next printString ]
					ifFalse: [ each decoration printString ]).
				html tableData: (each isDecoration
					ifTrue: [ each next identityHash ]
					ifFalse: [ each decoration identityHash ]) ] ] ]! !
!WADelegationFunctionalTest categoriesFor: #children!accessing!public! !
!WADelegationFunctionalTest categoriesFor: #initialize!initialization!public! !
!WADelegationFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !

WAEncodingFunctionalTest guid: (GUID fromString: '{4EC2947F-C836-490A-B099-25753483BE74}')!
WAEncodingFunctionalTest comment: '
A WAEncodingTest test whether Seaside correctly handles non-ASCII strings. Unfortunately due to differences in server setup and source code encodings this test requires manual interaction.
'!
!WAEncodingFunctionalTest categoriesForClass!Unclassified! !
!WAEncodingFunctionalTest methodsFor!

get
	^ get!

get: aString
	get := aString!

initialize
	super initialize.
	self urlencoded: 'urlencoded'.
	self multipart: 'multipart'.
	self get: 'get'!

multipart
	^multipart!

multipart: aString
	multipart := aString!

renderCharacterByCharacter: aString on: html
	"Display aString character by character, but wrap each character into a span so it ends up individually in the output stream. If the codec does not convert to the internal encoding of Smalltalk the result is broken. Either choose an appropriate codec or be aware of the concequences."
	
	self requestContext codec name = '(none)'
	"Character by character rendering will fail for the NullCoded in case of multi byte characters. Don't test it."
		ifTrue: [ ^self ].
	aString 	do: [ :each | html span: each ]!

renderClassName: aString on: html 
	aString isNil ifTrue: [ ^ self ].
	html paragraph: [
		html strong: 'Class: '.
		html text: aString class name ]!

renderContentOn: html
	self renderExplanationOn: html.
	self renderUrlencodedOn: html.
	self renderMultipartOn: html.
	self renderGetOn: html!

renderExplanationOn: html
	html unorderedList: [
		html listItem: [
			html text: 'Go to the '.
			html anchor
				url: 'http://www.columbia.edu/kermit/utf8.html';
				with: 'UTF-8 Sampler'.
			html text: ' and select some "foreign" text.' ].
		html listItem: 'Copy and paste it into the urlencoded text field below and click the submit button.'.
		html listItem: 'The heading, textfield, character field and submitt button should all display the text without any error.'.
		html listItem: 'Submit again without changing anything, again everything should display normally.'.
		html listItem: 'Repeat this process for the multipart field. Make sure to pick at least every of these languages: German, Czech, Korean.' ]!

renderGetOn: html

	html heading level2;
		with: 'GET'.
	html heading level3;
		with: self get.
	self renderCharacterByCharacter: self get on: html.
	html form
		get;
		with: [
			html div: [
				html textInput
					on: #get of: self.
				html submitButton
					text: self get ] ].
	self renderClassName: self get on: html!

renderMultipartOn: html

	html heading level2;
		with: 'Multipart'.
	html heading level3;
		with: self multipart.
	self renderCharacterByCharacter: self multipart on: html.
	html form
		multipart;
		with: [
			html div: [
				html textInput
					on: #multipart of: self.
				html submitButton
					text: self multipart ] ].
	self renderClassName: self multipart on: html!

renderUrlencodedOn: html

	html heading level2;
		with: 'Urlencoded'.
	html heading level3;
		with: self urlencoded.
	self renderCharacterByCharacter: self urlencoded on: html.
	html form: [
		html div: [
			html textInput
				on: #urlencoded of: self.
			html submitButton
				text: self urlencoded ] ].
	self renderClassName: self urlencoded on: html!

urlencoded
	^urlencoded!

urlencoded: aString
	urlencoded := aString! !
!WAEncodingFunctionalTest categoriesFor: #get!accessing!public! !
!WAEncodingFunctionalTest categoriesFor: #get:!accessing!public! !
!WAEncodingFunctionalTest categoriesFor: #initialize!initialization!public! !
!WAEncodingFunctionalTest categoriesFor: #multipart!accessing!public! !
!WAEncodingFunctionalTest categoriesFor: #multipart:!accessing!public! !
!WAEncodingFunctionalTest categoriesFor: #renderCharacterByCharacter:on:!public!rendering! !
!WAEncodingFunctionalTest categoriesFor: #renderClassName:on:!public!rendering! !
!WAEncodingFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAEncodingFunctionalTest categoriesFor: #renderExplanationOn:!public!rendering! !
!WAEncodingFunctionalTest categoriesFor: #renderGetOn:!public!rendering! !
!WAEncodingFunctionalTest categoriesFor: #renderMultipartOn:!public!rendering! !
!WAEncodingFunctionalTest categoriesFor: #renderUrlencodedOn:!public!rendering! !
!WAEncodingFunctionalTest categoriesFor: #urlencoded!accessing!public! !
!WAEncodingFunctionalTest categoriesFor: #urlencoded:!accessing!public! !

WAExceptionFunctionalTest guid: (GUID fromString: '{DEF2EDC4-DD8E-4C48-A553-103D139245D8}')!
WAExceptionFunctionalTest comment: ''!
!WAExceptionFunctionalTest categoriesForClass!Unclassified! !
!WAExceptionFunctionalTest methodsFor!

exceptionFilter
	^ self application filters detect: [ :each | each isExceptionFilter ] ifNone: [ nil ]!

initialize
	super initialize.
	renderError := false!

raiseDeprecated
	self 
		greaseDeprecatedApi: 'WAExceptionFunctionalTest>>#raiseDeprecated'
		details: 'Test action phase deprecation.'.
	self 
		inform: 
			[ :html | 
			self 
				greaseDeprecatedApi: 'WAExceptionFunctionalTest>>#raiseDeprecated'
				details: 'Test render phase deprecation.'.
			html paragraph: 'To be displayed' ]
		onAnswer: [ ]!

raiseError
	| result |
	result := self error: 'Test Error'.
	self 
		inform: 'Signalling the error returned: ' , result greaseString
		onAnswer: [ ]!

raiseHalt
	| context |
	self halt.
	"You should be able to step over the following line and have the current request context
	successfully stored in the variable.
	You should also (ideally anyway, it works on Squeak) be able to Inspect the value of
	'self requestContext' in the Debugger and get a result.
	Finally, you should be able to restart this method in the Debugger and do the above
	again successfully."
	context := self requestContext.
	self inform: 'To be displayed' onAnswer: [ ]!

raiseResumable
	1 / 0.
	self inform: 'To be displayed' onAnswer: [ ]!

raiseWarning
	self notify: 'Test Warning'.
	self inform: 'To be displayed' onAnswer: [ ]!

renderContentOn: html
	html div class: 'errorTest'; with: [
		self renderHandlerConfigurationOn: html.
		self renderPartsOn: html ]!

renderDeprecatedOn: html 
	html heading: 'Deprecated'.
	html paragraph: 'The link should cause a deprecated warning to appear in the toolbar. Clicking on the link should display a single action and a single render deprecation.'.
	html anchor
		callback: [ self raiseDeprecated ];
		with: 'Raise deprecated'!

renderErrorOn: html 
	html heading: 'Error'.
	html paragraph: 'Behaviour is exception-handler-dependent. If a Debugger is opened, closing the debugger window should at least result in the socket being closed and should not lock the session. Proceeding from the Debugger should be handled gracefully but behaviour is platform-dependent. On Pharo and GemStone, you should see an error page in the browser. On VW, you should see a message indicating that nil was returned.'.
	html anchor
		callback: [ self raiseError ];
		with: 'Raise error'!

renderHaltOn: html 
	html heading: 'Halt'.
	html paragraph: 'Behaviour is handler-dependent. In most cases, a Debugger should open in in the image. There are comments in the #raiseHalt method suggesting other things that should be tested from within the Debugger. Clicking on proceed should display the information message "To be displayed".'.
	html anchor
		callback: [ self raiseHalt ];
		with: 'Halt execution'!

renderHandlerConfigurationOn: html
	| attribute filter |
	filter := self exceptionFilter.
	filter isNil ifTrue: [
		html paragraph: 'Exception handler configuration attribute not found!!'.
		^ self ].
	attribute := filter configuration attributeAt: #exceptionHandler.

	html form: [
		html div: [
			html select
				beOptional;
				optionalLabel: '(inherited default)';
				list: attribute options asArray;
				selected: (filter configuration at: attribute key);
				callback: [ :value | 
					value isNil
						ifTrue: [ filter configuration removeExpressionAt: attribute key ifAbsent: [] ]
						ifFalse: [ filter configuration takeValue: value forAttribute: attribute ] ].
			html submitButton with: 'Set Handler' ] ]!

renderPartsOn: html
	self renderHaltOn: html.
	self renderErrorOn: html.
	self renderRenderErrorOn: html.
	self renderResumableErrorOn: html.
	self renderWarningOn: html.
	self renderDeprecatedOn: html!

renderRenderErrorOn: html
	"This is really hacky. We're trying to avoid depending on Flow here. Don't try this
	at home kids."
	renderError ifTrue: [ renderError := false. self error: 'Error during rendering.' ].
	
	html heading: 'Error During Rendering'.
	html paragraph: 'This will trigger an error during the next render phase.'.
	html anchor
		callback: [ renderError := true ];
		with: 'Raise error'!

renderResumableErrorOn: html 
	html heading: 'Resumable error'.
	html paragraph: 'Behaviour is handler-dependent. If a Debugger is opened, clicking on proceed should display the message "To be displayed".'.
	html anchor
		callback: [ self raiseResumable ];
		with: 'Raise zero divide'!

renderWarningOn: html 
	html heading: 'Warning'.
	html paragraph: 'In Pharo and GemStone the warning test works the same as the resumable error test.'.
	html paragraph: 'In VisualWorks the warning test works the same as the halt test.'.
	html anchor
		callback: [ self raiseWarning ];
		with: 'Raise warning'! !
!WAExceptionFunctionalTest categoriesFor: #exceptionFilter!accessing!public! !
!WAExceptionFunctionalTest categoriesFor: #initialize!initialization!public! !
!WAExceptionFunctionalTest categoriesFor: #raiseDeprecated!actions!public! !
!WAExceptionFunctionalTest categoriesFor: #raiseError!actions!public! !
!WAExceptionFunctionalTest categoriesFor: #raiseHalt!actions!public! !
!WAExceptionFunctionalTest categoriesFor: #raiseResumable!actions!public! !
!WAExceptionFunctionalTest categoriesFor: #raiseWarning!actions!public! !
!WAExceptionFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAExceptionFunctionalTest categoriesFor: #renderDeprecatedOn:!public!rendering! !
!WAExceptionFunctionalTest categoriesFor: #renderErrorOn:!public!rendering! !
!WAExceptionFunctionalTest categoriesFor: #renderHaltOn:!public!rendering! !
!WAExceptionFunctionalTest categoriesFor: #renderHandlerConfigurationOn:!public!rendering! !
!WAExceptionFunctionalTest categoriesFor: #renderPartsOn:!public!rendering! !
!WAExceptionFunctionalTest categoriesFor: #renderRenderErrorOn:!public!rendering! !
!WAExceptionFunctionalTest categoriesFor: #renderResumableErrorOn:!public!rendering! !
!WAExceptionFunctionalTest categoriesFor: #renderWarningOn:!public!rendering! !

WAExpiryFunctionalTest guid: (GUID fromString: '{762D9F96-35EB-421E-AE49-C1AFD55BC303}')!
WAExpiryFunctionalTest comment: ''!
!WAExpiryFunctionalTest categoriesForClass!Unclassified! !
!WAExpiryFunctionalTest methodsFor!

redirect
	"we need to build the url we redirect to because we just expired the session in this test"
	| url |
	url := self application url.
	url addAllToPath: self requestContext consumer upToEnd.
	^ self requestContext responseGenerator
		redirectTo: url;
		respond!

renderActionsOn: html
	html
		paragraph: [ 
			(html anchor)
				url: (self application url with: self class name);
				with: 'New Session'.
			html break.
			(html anchor)
				callback: [ self session unregister . self redirect ];
				with: 'Expire'.
			html break.
			(html anchor)
				callback: [ WAExpirySession resetCounters ];
				with: 'Reset Counters'.
			html break.
			(html anchor)
				callback: [ GRPlatform current seasideGarbageCollect ];
				with: 'Garbage Collect'.
			html break.
			(html anchor)
				callback: [ 
							self application clear.
							GRPlatform current seasideGarbageCollect.
							self redirect ];
				with: 'Clear Cache'.
			html break.
			(html anchor)
				callback: [ 
							self application clear.
							WAExpirySession resetCounters.
							GRPlatform current seasideGarbageCollect.
							self redirect ];
				with: 'Reset All' ]!

renderContentOn: html
	self renderStatsOn: html.
	self renderActionsOn: html!

renderStatsOn: html
	html table: [
		html tableRow: [
			html tableHeading: 'Total session instances'.
			html tableData: WAExpirySession allInstances size ].
		html tableRow: [
			html tableHeading: 'Cached session instances for this Application'.
			html tableData: self application cache size ].
		html tableRow: [
			html tableHeading: 'Total component instances'.
			html tableData: self class allInstances size ].
		html tableRow: [
			html tableHeading: 'Sessions created'.
			html tableData: WAExpirySession created ].
		html tableRow: [
			html tableHeading: 'Sessions unregistered'.
			html tableData: WAExpirySession unregistered ] ]! !
!WAExpiryFunctionalTest categoriesFor: #redirect!public!rendering! !
!WAExpiryFunctionalTest categoriesFor: #renderActionsOn:!public!rendering! !
!WAExpiryFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAExpiryFunctionalTest categoriesFor: #renderStatsOn:!public!rendering! !

WAFilterFunctionalTest guid: (GUID fromString: '{50035047-9052-4134-BCE3-AC7BE393847D}')!
WAFilterFunctionalTest comment: ''!
!WAFilterFunctionalTest categoriesForClass!Unclassified! !
!WAFilterFunctionalTest methodsFor!

authentication
	| filter |
	"We could use #filterWith:during: but that requires Flow."
	filter := WAAuthenticationFilter new
			authenticator: self;
			yourself.
	self session addFilter: filter.
	child inform: 'Congratulations, you have been authenticated. The new filter should be visible in the list above. Clicking on "ok" should remove the filter. Using the back button and hitting refresh should show the filter again.' onAnswer: [ self session removeFilter: filter ]!

children
	^ Array with: child!

initialize
	super initialize.
	child := WAComponent new!

protector
	| filter |
	"We could use #filterWith:during: but that requires Flow."
	filter := WAProtectionFilter new.
	self session addFilter: filter.
	child inform: 'Open this page on a different computer by copying the complete URL to a machine with a different IP address. Seaside should reply with a forbidden message. Closing this dialog should remove the filter.' onAnswer: [ self session removeFilter: filter ]!

renderActionsOn: html
	html paragraph: [
		html anchor
			callback: [ self authentication ];
			with: 'Basic Authentication'.
		html text: ' (admin/seaside)'.
		html break.
		html anchor
			callback: [ self protector ];
			with: 'Session Protector' ].
	html horizontalRule.
	html paragraph: self children!

renderContentOn: html
	self renderFiltersOn: html.
	self renderActionsOn: html!

renderFiltersOn: html
	html paragraph: 'Below a list of filters wrapping the current session:'.
	html orderedList list: self session filters!

verifyPassword: aPasswordString forUser: aUserString
	^ aUserString = 'admin' and: [ aPasswordString = 'seaside' ]! !
!WAFilterFunctionalTest categoriesFor: #authentication!actions!public! !
!WAFilterFunctionalTest categoriesFor: #children!accessing!public! !
!WAFilterFunctionalTest categoriesFor: #initialize!initialization!public! !
!WAFilterFunctionalTest categoriesFor: #protector!actions!public! !
!WAFilterFunctionalTest categoriesFor: #renderActionsOn:!public!rendering! !
!WAFilterFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAFilterFunctionalTest categoriesFor: #renderFiltersOn:!public!rendering! !
!WAFilterFunctionalTest categoriesFor: #verifyPassword:forUser:!private! !

WAHomeFunctionalTest guid: (GUID fromString: '{E07BCBC5-5C81-413B-B3CC-D83224DB3EE5}')!
WAHomeFunctionalTest comment: ''!
!WAHomeFunctionalTest categoriesForClass!Unclassified! !
!WAHomeFunctionalTest methodsFor!

children
	^ Array with: main!

initialize
	super initialize.
	main := self message: 'Root Component'!

message: aString
	^ WAComponent new
		addMessage: aString;
		yourself!

renderContentOn: html
	html paragraph: 'Clicking home should always bring back the root component.'.
	html paragraph: [
		html anchor
			callback: [ main show: (self message: 'Called Component') ];
			with: 'call'.
		html space.
		html anchor
			callback: [ main home ];
			with: 'home' ].
	html render: main! !
!WAHomeFunctionalTest categoriesFor: #children!accessing!public! !
!WAHomeFunctionalTest categoriesFor: #initialize!initialization!public! !
!WAHomeFunctionalTest categoriesFor: #message:!accessing!public! !
!WAHomeFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !

WAIframeFunctionalTest guid: (GUID fromString: '{B971602C-D960-488D-A231-60E93E7EC033}')!
WAIframeFunctionalTest comment: ''!
!WAIframeFunctionalTest categoriesForClass!Unclassified! !
!WAIframeFunctionalTest methodsFor!

children
	^ Array with: calendar!

initialize
	super initialize.
	calendar := WAMiniCalendar new!

renderContentOn: html
	html paragraph: 'With #contents:'.
	html iframe
		contents: calendar.
	html paragraph: 'With #url:'.
	html iframe
		url: (WATestingFiles / #samplePng).
	html paragraph: 'With #document:'.
	html iframe
		document: WATestingFiles default samplePng
		mimeType: 'image/png'!

style
	^ 'iframe {
	border: 1px solid gray;
	width: 100%;
}'! !
!WAIframeFunctionalTest categoriesFor: #children!accessing!public! !
!WAIframeFunctionalTest categoriesFor: #initialize!initialization!public! !
!WAIframeFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAIframeFunctionalTest categoriesFor: #style!public!rendering! !

WAImageMapFunctionalTest guid: (GUID fromString: '{16F94403-BA41-449C-8986-E0C1BD63AE26}')!
WAImageMapFunctionalTest comment: ''!
!WAImageMapFunctionalTest categoriesForClass!Unclassified! !
!WAImageMapFunctionalTest methodsFor!

renderContentOn: html 
	html heading
		level: 3;
		with: 'A byte array with server side map (ismap)'.
	html paragraph: 'Click anywhere on the Style Editor icon and you should get informed about the position where you clicked.'.
	html paragraph: 
		[ html map
			title: 'Click anywhere on the style editor icon';
			callback: 
				[ :aPoint | 
				self 
					inform: 'Clicked at ' , aPoint greaseString , ' on the Style Editor Icon'
					onAnswer: [ ] ];
			with: 
				[ html image
					altText: 'Style Editor Icon';
					width: '40%';
					url: WATestingFiles / #samplePng ] ]! !
!WAImageMapFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !

WAInputGetFunctionalTest guid: (GUID fromString: '{E92C54CC-8FBE-4B18-BBDE-2F534AFB5F2A}')!
WAInputGetFunctionalTest comment: ''!
!WAInputGetFunctionalTest categoriesForClass!Unclassified! !
!WAInputGetFunctionalTest methodsFor!

children
	^Array with: inputElements!

initialize
	super initialize.
	inputElements := WAInputElementContainer new!

renderContentOn: html
	self renderExplanationOn: html.
	html form
		get;
		with: [
			html table: inputElements.
			html div: [
				"div for validation"
				html submitButton ] ]!

renderExplanationOn: html
	html paragraph: 'This form uses a HTTP GET request. The upload is not supposed to work.'! !
!WAInputGetFunctionalTest categoriesFor: #children!accessing!public! !
!WAInputGetFunctionalTest categoriesFor: #initialize!initialization!public! !
!WAInputGetFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAInputGetFunctionalTest categoriesFor: #renderExplanationOn:!public!rendering! !

WAInputPostFunctionalTest guid: (GUID fromString: '{F6108E52-B0EC-4029-B224-5BB5B138F2D6}')!
WAInputPostFunctionalTest comment: ''!
!WAInputPostFunctionalTest categoriesForClass!Unclassified! !
!WAInputPostFunctionalTest methodsFor!

children
	^Array with: inputElements!

initialize
	super initialize.
	inputElements := WAInputElementContainer new.
	ran := false!

readRequestBody
	ran := true.
	hasBody := self requestContext request rawBody notNil!

renderContentOn: html
	self renderExplanationOn: html.
	html form: [
		html table: inputElements.
		html div: [
			self renderRequestBodyOn: html.
			"div for validation"
			html submitButton ] ]!

renderExplanationOn: html
	html paragraph: 'This form uses an URL-encoded POST request. The upload is not supposed to work.'!

renderRequestBodyOn: html
	html hiddenInput
		callback: [ self readRequestBody ].
	html strong: 'Request Body:'.
	ran
		ifTrue: [ html text: (hasBody ifTrue: [ 'Success' ] ifFalse: [ 'Fail' ]) ]
		ifFalse: [ html text: 'Not Run' ].
	html break! !
!WAInputPostFunctionalTest categoriesFor: #children!accessing!public! !
!WAInputPostFunctionalTest categoriesFor: #initialize!initialization!public! !
!WAInputPostFunctionalTest categoriesFor: #readRequestBody!actions!public! !
!WAInputPostFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAInputPostFunctionalTest categoriesFor: #renderExplanationOn:!public!rendering! !
!WAInputPostFunctionalTest categoriesFor: #renderRequestBodyOn:!public!rendering! !

WAInputPostMultipartFunctionalTest guid: (GUID fromString: '{F07902CB-287E-4C49-8FC6-6BAF65014753}')!
WAInputPostMultipartFunctionalTest comment: ''!
!WAInputPostMultipartFunctionalTest categoriesForClass!Unclassified! !
!WAInputPostMultipartFunctionalTest methodsFor!

children
	^Array with: inputElements!

initialize
	super initialize.
	inputElements := WAInputElementContainer new.
	ran := false!

readRequestBody
	ran := true.
	hasBody := self requestContext request rawBody notNil!

renderContentOn: html
	self renderExplanationOn: html.
	html form
		multipart;
		with: [
			html table: inputElements.
			html div: [
				self renderRequestBodyOn: html.
				"div for validation"
				html submitButton ] ]!

renderExplanationOn: html
	html paragraph: 'This form uses a multipart POST request. The upload is supposed to accept a file.'!

renderRequestBodyOn: html
	html hiddenInput
		callback: [ self readRequestBody ].
	html strong: 'Request Body:'.
	ran
		ifTrue: [ html text: (hasBody ifTrue: [ 'Success' ] ifFalse: [ 'Fail' ]) ]
		ifFalse: [ html text: 'Not Run' ].
	html break! !
!WAInputPostMultipartFunctionalTest categoriesFor: #children!accessing!public! !
!WAInputPostMultipartFunctionalTest categoriesFor: #initialize!initialization!public! !
!WAInputPostMultipartFunctionalTest categoriesFor: #readRequestBody!actions!public! !
!WAInputPostMultipartFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAInputPostMultipartFunctionalTest categoriesFor: #renderExplanationOn:!public!rendering! !
!WAInputPostMultipartFunctionalTest categoriesFor: #renderRequestBodyOn:!public!rendering! !

WAKeyGeneratorFunctionalTest guid: (GUID fromString: '{2E01973D-0BCF-48CB-B3DD-C426BAA1853A}')!
WAKeyGeneratorFunctionalTest comment: ''!
!WAKeyGeneratorFunctionalTest categoriesForClass!Unclassified! !
!WAKeyGeneratorFunctionalTest methodsFor!

renderContentOn: html
	self renderExplanationOn: html.
	key isNil
		ifTrue: [ self renderKeyGeneratorOn: html ]
		ifFalse: [ self renderKeyOn: html ]!

renderExplanationOn: html
	html paragraph: 'This test should display a dialog for creating a secret key. After submitting the form the public key should be displayed.'.
	html paragraph: 'This test does not work on IE'!

renderKeyGeneratorOn: html
	html form: [
		html keyGenerator
			callback: [ :k | key := k ].
		html submitButton ]!

renderKeyOn: html
	html render: key! !
!WAKeyGeneratorFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAKeyGeneratorFunctionalTest categoriesFor: #renderExplanationOn:!public!rendering! !
!WAKeyGeneratorFunctionalTest categoriesFor: #renderKeyGeneratorOn:!public!rendering! !
!WAKeyGeneratorFunctionalTest categoriesFor: #renderKeyOn:!public!rendering! !

WALotsaLinksFunctionalTest guid: (GUID fromString: '{3F144800-0E85-4199-A759-7208522AFBDB}')!
WALotsaLinksFunctionalTest comment: ''!
!WALotsaLinksFunctionalTest categoriesForClass!Unclassified! !
!WALotsaLinksFunctionalTest methodsFor!

renderContentOn: html 
	self renderExplanationOn: html.
	html unorderedList: 
		[ 1 
			to: 5000
			do: 
				[ :each | 
				html listItem: 
					[ html anchor
						name: each greaseString;
						callback: 
							[ self 
								inform: each
								onAnswer: [ self session jumpToAnchor: each greaseString ] ];
						with: each ] ] ]!

renderExplanationOn: html
	html paragraph: [
		html text: 'This test serves three purposes:'.
		html orderedList: [
			html listItem: 'First it is a regression test, earlier versions of Seaside could only handle a limited number of callbacks per page. The oldest links (low numbers) would use their callback. Clicking on any link should display this number with a button.'.
			html listItem: 'Second it serves as a raw rendering speed benchmark.'.
			html listItem: 'Third it tests WASession >> #jumpToAnchor:. After confirming the number you should return to the page and be automatically at the place where the link is.' ] ]! !
!WALotsaLinksFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WALotsaLinksFunctionalTest categoriesFor: #renderExplanationOn:!public!rendering! !

WAManyTasksFunctionalTest guid: (GUID fromString: '{CE6C86E1-E0BF-48A0-B93E-6CCC41F37D3E}')!
WAManyTasksFunctionalTest comment: ''!
!WAManyTasksFunctionalTest categoriesForClass!Unclassified! !
!WAManyTasksFunctionalTest methodsFor!

addTask
	selection contents notNil ifTrue: [ tasks add: selection contents new ]!

children
	^ tasks!

initialize
	super initialize.
	tasks := OrderedCollection new.
	selection := WAValueHolder new.
	tasks add: WADelegationTask new!

renderContentOn: html
	html form: [ 
		html div: [
			html paragraph: 'Adding WAEmptyTestTask is expected to cause an infinite recursion and should raise an exception.'.
			html select
				list: (self taskClasses asSortedCollection: [ :a :b | a name <= b name ]);
				on: #contents of: selection.
			html submitButton
				callback: [ self addTask ];
				with: 'Add'.
			html submitButton
				callback: [ self showTask ];
				with: 'Show' ] ].
	self renderTasksOn: html!

renderTasksOn: html
	tasks do: [ :each |
		html div: [
			html div: each.
			html anchor
				callback: [ tasks remove: each ];
				with: '(remove task)' ] ]!

showTask
	selection contents notNil ifTrue: [ self show: selection contents new ]!

states
	^ Array with: tasks!

taskClasses
	^ WATask allSubclasses select: [:each | each subclasses isEmpty]! !
!WAManyTasksFunctionalTest categoriesFor: #addTask!actions!public! !
!WAManyTasksFunctionalTest categoriesFor: #children!hooks!public! !
!WAManyTasksFunctionalTest categoriesFor: #initialize!initialization!public! !
!WAManyTasksFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAManyTasksFunctionalTest categoriesFor: #renderTasksOn:!public!rendering! !
!WAManyTasksFunctionalTest categoriesFor: #showTask!actions!public! !
!WAManyTasksFunctionalTest categoriesFor: #states!initialization!public! !
!WAManyTasksFunctionalTest categoriesFor: #taskClasses!accessing!public! !

WAMiniCalendarFunctionalTest guid: (GUID fromString: '{09CE2CF3-1E12-483E-80C5-F5DB778988DA}')!
WAMiniCalendarFunctionalTest comment: ''!
!WAMiniCalendarFunctionalTest categoriesForClass!Unclassified! !
!WAMiniCalendarFunctionalTest methodsFor!

children
	^Array with: calendar!

initialize
	super initialize.
	calendar := WAMiniCalendar new!

renderContentOn: html
	html render: calendar.

	html div: [
		html strong: 'selected:'.
		html space.
		html render: calendar date ]! !
!WAMiniCalendarFunctionalTest categoriesFor: #children!accessing!public! !
!WAMiniCalendarFunctionalTest categoriesFor: #initialize!initialization!public! !
!WAMiniCalendarFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !

WAModelFunctionalTest guid: (GUID fromString: '{533DA2A3-CF8E-4A37-8E94-294186F76859}')!
WAModelFunctionalTest comment: ''!
!WAModelFunctionalTest categoriesForClass!Unclassified! !
!WAModelFunctionalTest methodsFor!

logoff
	state := #OFF.
	test ifTrue: [ self inform: 'Logged off' onAnswer: [ ] ]!

logon
	user isEmptyOrNil
		ifTrue:
			[ self inform: 'Nope !!' onAnswer: [ ] ]
		ifFalse:
			[ state := #ON.
			test ifTrue: [ self inform: 'Logged on' onAnswer: [ ] ] ]!

pass
	"Answer the value of pass"

	^ pass!

pass: anObject
	"Set the value of pass"

	pass := anObject!

renderButtonOn: html
	| action |
	action := state == #ON ifTrue: [ #logoff ] ifFalse: [ #logon ].
	html div: [
		"div for validation"
		html submitButton
			on: action of: self ]!

renderContentOn: html
	html form
		id: 'myform';
		with: [
			html table: [
				self renderUsernameOn: html.
				self renderPasswordOn: html.
				self renderFeedbackOn: html ].
			html div: [
				self renderButtonOn: html ]]!

renderFeedbackOn: html
	html tableRow: [
		html tableData: [
			html label
				for: #withFeedback;
				with: 'With Feedback:' ].
		html tableData: [
			html checkbox
				id: #withFeedback;
				on: #test of: self ] ]!

renderPasswordOn: html
	html tableRow: [
		html tableData: [
			html label
				for: #pass;
				with: 'Password:' ].
		html tableData: [
			html passwordInput
				id: #pass;
				on: #pass of: self ] ]!

renderUsernameOn: html
	html tableRow: [
		html tableData: [
			html label
				for: #userid;
				with: 'Username:' ].
		html tableData: [
			html textInput
				id: #userid;
				on: #user of: self ] ]!

test
	"Answer the value of test"

	^ test!

test: anObject
	"Set the value of test"

	test := anObject!

user
	"Answer the value of user"

	^ user!

user: anObject
	"Set the value of user"

	user := anObject! !
!WAModelFunctionalTest categoriesFor: #logoff!actions!public! !
!WAModelFunctionalTest categoriesFor: #logon!actions!public! !
!WAModelFunctionalTest categoriesFor: #pass!accessing!public! !
!WAModelFunctionalTest categoriesFor: #pass:!accessing!public! !
!WAModelFunctionalTest categoriesFor: #renderButtonOn:!public!rendering! !
!WAModelFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAModelFunctionalTest categoriesFor: #renderFeedbackOn:!public!rendering! !
!WAModelFunctionalTest categoriesFor: #renderPasswordOn:!public!rendering! !
!WAModelFunctionalTest categoriesFor: #renderUsernameOn:!public!rendering! !
!WAModelFunctionalTest categoriesFor: #test!accessing!public! !
!WAModelFunctionalTest categoriesFor: #test:!accessing!public! !
!WAModelFunctionalTest categoriesFor: #user!accessing!public! !
!WAModelFunctionalTest categoriesFor: #user:!accessing!public! !

WAParameterFunctionalTest guid: (GUID fromString: '{8D67DE0D-B385-4E61-B91F-A51DB7490FF6}')!
WAParameterFunctionalTest comment: 'A WAParameterFunctionalTest tests whether GET and POST fiedls are merged in WARequest >> #fields.'!
!WAParameterFunctionalTest categoriesForClass!Unclassified! !
!WAParameterFunctionalTest methodsFor!

actionUrlFor: html
	| url |
	url := html actionUrl copy.
	url
		addField: self parameterName
		value: self firstParameterValue.
	^url!

firstParameterValue
	^'firstValue'!

initialize
	super initialize.
	wasExecuted := false!

parameterName
	^'parameter'!

renderContentOn: html
	self renderExplanationOn: html.
	wasExecuted
		ifTrue: [ self renderExecutedOn: html ]
		ifFalse: [ self renderNotExecutedOn: html ]!

renderExecutedOn: html
	html strong: (self wasSuccessful ifTrue: [ 'success' ] ifFalse: [ 'fail' ])!

renderExplanationOn: html
	html paragraph: 'This test makes sure the server passes both GET and POST paramters to Seaside. Simply hit ''run test'' and ''success'' should be displayed. If ''fail'' is displayed or ''run test'' is displayed again then the test has failed.'!

renderNotExecutedOn: html
	html form
		action: (self actionUrlFor: html);
		with: [
		 	html div: [
				html hiddenInput
					name: self parameterName;
					value: self secondParameterValue.
				html submitButton
					callback: [ self runTest ];
					text: 'run test' ] ]!

runTest
	values := self requestContext request fields allAt: self parameterName.
	wasExecuted := true!

secondParameterValue
	^'secondValue'!

wasSuccessful
	^ values notNil
		and: [ values isCollection
		and: [ values isString not
		and: [ values size = 2
		and: [ (values includes: self firstParameterValue)
		and: [ (values includes: self secondParameterValue) ] ] ] ] ]! !
!WAParameterFunctionalTest categoriesFor: #actionUrlFor:!accessing!public! !
!WAParameterFunctionalTest categoriesFor: #firstParameterValue!accessing!public! !
!WAParameterFunctionalTest categoriesFor: #initialize!initialization!public! !
!WAParameterFunctionalTest categoriesFor: #parameterName!accessing!public! !
!WAParameterFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAParameterFunctionalTest categoriesFor: #renderExecutedOn:!public!rendering! !
!WAParameterFunctionalTest categoriesFor: #renderExplanationOn:!public!rendering! !
!WAParameterFunctionalTest categoriesFor: #renderNotExecutedOn:!public!rendering! !
!WAParameterFunctionalTest categoriesFor: #runTest!actions!public! !
!WAParameterFunctionalTest categoriesFor: #secondParameterValue!accessing!public! !
!WAParameterFunctionalTest categoriesFor: #wasSuccessful!public!testing! !

WAParentFunctionalTest guid: (GUID fromString: '{D262F914-4F64-4085-A2C4-E2A1E3CF60C9}')!
WAParentFunctionalTest comment: ''!
!WAParentFunctionalTest categoriesForClass!Unclassified! !
!WAParentFunctionalTest methodsFor!

parent: aComponent
	parent := aComponent!

renderContentOn: html
	self renderExplanationOn: html.
	self renderSwapParentOn: html!

renderExplanationOn: html
	html paragraph: 'This regression tests checks if #call:onAnswer: on the parent component works. If you click "swap parent" "Test passes!!" should appear without a tab panel.'!

renderSwapParentOn: html
	html paragraph: [
		html anchor
			callback: [ self swap ];
			with: 'swap parent' ]!

swap
	parent inform: 'Test passes!!' onAnswer: []! !
!WAParentFunctionalTest categoriesFor: #parent:!accessing!public! !
!WAParentFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAParentFunctionalTest categoriesFor: #renderExplanationOn:!public!rendering! !
!WAParentFunctionalTest categoriesFor: #renderSwapParentOn:!public!rendering! !
!WAParentFunctionalTest categoriesFor: #swap!actions!public! !

WAPathFunctionalTest guid: (GUID fromString: '{1BB0B335-5649-487A-B32A-A58A38FAD20A}')!
WAPathFunctionalTest comment: ''!
!WAPathFunctionalTest categoriesForClass!Unclassified! !
!WAPathFunctionalTest methodsFor!

renderContentOn: html
	string notNil ifTrue: [ html anchor name: string ].
	
	html paragraph: 'Whatever you submit below should be added to the URL both as a path element and a fragment (the part after #).'.
	html form: [
		html div: [
			html textInput on: #string of: self.
			html submitButton ] ]!

string
	^ string!

string: anObject
	string := anObject!

updateUrl: aUrl 
	super updateUrl: aUrl.
	string isNil ifTrue: [ ^self ].
	
	aUrl addToPath: string.
	aUrl fragment: string! !
!WAPathFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAPathFunctionalTest categoriesFor: #string!accessing!public! !
!WAPathFunctionalTest categoriesFor: #string:!accessing!public! !
!WAPathFunctionalTest categoriesFor: #updateUrl:!path!public! !

WAPerformanceFunctionalTest guid: (GUID fromString: '{0677FC33-8F45-4BF0-B142-B88A36513106}')!
WAPerformanceFunctionalTest comment: ''!
!WAPerformanceFunctionalTest categoriesForClass!Unclassified! !
!WAPerformanceFunctionalTest methodsFor!

initialize
	super initialize.
	builder := WARenderCanvas builder!

renderAnchorsOn: canvas
	self renderInline: [:html | 
		html unorderedList: [
			html listItem: [
					html anchor
						name: 'name';
						callback: [];
						with: 'Anchor' ] ] ]
		factor: 1
		key: #anchor
		on: canvas
!

renderBreakOn: canvas
	self renderInline: [:html | 
			html break]
		factor: 1/50
		key: #seasideBR
		on: canvas
		
	!

renderCallbackOn: canvas
	self renderInline: [:html | 
			html button callback: []; with: '' ]
		key: #callback
		on: canvas!

renderContentOn: html 
	duration := 0.
	referenceDict ifNil: [ referenceDict := self class referenceDict ].
	self renderExplanationOn: html.
	self renderAnchorsOn: html.
	self renderScriptOn: html.
	self renderTableOn: html.
	self renderLineBreaksOn: html.
	self renderCallbackOn: html.
	self renderFormOn: html.
	self renderIdTestOn: html.
	self renderTextOn: html.
	self renderHtmlTextOn: html.
	self renderBreakOn: html.
	self renderNativeBreakOn: html.
	html div
		class: 'result';
		with: 'Seaside Performance Index: ' , duration greaseString!

renderExplanationOn: html
	html paragraph: 'Test rendering speed (Reference: Intel Core 2 Duo E6750, Seaside 3.0; Pharo 1.0, ~ 1400 SPI)'!

renderFormOn: canvas 
	self 
		renderInline: 
			[ :html | 
			html form: 
				[ html button value: 'OK'.
				html fileUpload.
				html select
					list: #('a' 'b' );
					labels: [ :v | v greaseString ].
				html radioButton.
				html textInput
					size: 20;
					value: ''.
				html textArea
					rows: 3;
					columns: 17;
					value: ''.
				html checkbox value: true.
				html passwordInput value: 'pw' ] ]
		key: #form
		on: canvas!

renderHtmlTextOn: canvas
	self renderInline: [:html |
			html html: 'abcdefghijklmnopqrstuvwxyz&amp;0123456789' ]
		factor: 1/50
		key: #nativeText
		on: canvas
		
!

renderIdTestOn: canvas
	self renderInline: [:html | | id1 |
			id1 := html nextId.
			html span id: id1; with: id1.
			html break ]
		key: #id 
		on: canvas
		
	!

renderInline: aBlock factor: factor key: key on: html 
	| startTime endTime count backColor anAssociation title referenceValue spi context document renderer stream runTime |
	count := 0.
	runTime := 200.
	anAssociation := referenceDict 
		at: key
		ifAbsent: [ 'Undefined' -> 100000 ].
	title := anAssociation key.
	referenceValue := anAssociation value.
	stream := WriteStream on: String new.
	document := builder documentClass 
		on: stream
		codec: builder codec.
	context := WARenderContext new.
	context document: document.
	context
		actionUrl: builder actionUrl;
		resourceUrl: builder resourceUrl.
	renderer := builder rendererClass context: context.
	builder 
		openDocument: document
		context: context.
	html div
		class: 'bench';
		with: 
			[ html heading: title.
			startTime := Time millisecondClockValue.
			endTime := startTime + runTime.
			[ Time millisecondClockValue < endTime ] whileTrue: 
				[ count := count + 1.
				renderer
					render: aBlock;
					flush ] ].
	builder closeDocument: document.
	spi := (count / referenceValue * (10000 / runTime)) rounded.
	backColor := spi > 100 
		ifTrue: [ '#5f5' ]
		ifFalse: 
			[ spi < 50 
				ifTrue: [ '#f55' ]
				ifFalse: [ '#55f' ] ].
	duration := duration + spi.
	html div
		style: 'float:left;padding:4px';
		with: 
			[ html big: spi greaseString , ' SPI'.
			html span
				class: 'iteration';
				with: '(' , count greaseString , ' iterations)'.
			html break.
			html div
				class: 'rect';
				style: 'background:' , backColor , ';width:' , (spi * 2) greaseString , 'px' ].
	html div style: 'clear:both'!

renderInline: aBlock key: key on: html
	self renderInline: aBlock factor: 1 key: key on: html!

renderLineBreaksOn: canvas
	self renderInline: [:html |
			html withLineBreaks: 'a
			b
			c' ]
		key: #lineBreak
		on: canvas
		
	!

renderNativeBreakOn: canvas
	self renderInline: [:html |
			html html: '<br/>' ]
		factor: 1/50
		key: #nativeBR
		on: canvas
		
	!

renderScriptOn: canvas
	self
		renderInline: [:html | 
				html script: 'self.close()']
		key: #script
		on: canvas!

renderTableOn: canvas
	self renderInline: [:html | 
				html table: [html tableRow: [ html tableData: 'data' ] ] ] 
		key: #table
		on: canvas!

renderTextOn: canvas
	self renderInline: [:html |
			html text: 'abcdefghijklmnopqrstuvwxyz&0123456789' ]
		factor: 1/50
		key: #seasideText
		on: canvas
		
!

style
	^ 'h1 {margin:0;padding:0}
	div.bench {padding-left:4px;position:relative;height:38px;width:400px;border: 1px solid #ccc;overflow:hidden;float:left}
	div.result {margin:6px;color:#008aff;font-size:200%;font-weight:bold}
	span.iteration {margin-left:6px}
	div.rect {position:relative;border: 1px solid #ccc;;height:12px}
	'! !
!WAPerformanceFunctionalTest categoriesFor: #initialize!initialization!public! !
!WAPerformanceFunctionalTest categoriesFor: #renderAnchorsOn:!public!rendering! !
!WAPerformanceFunctionalTest categoriesFor: #renderBreakOn:!public!rendering! !
!WAPerformanceFunctionalTest categoriesFor: #renderCallbackOn:!public!rendering! !
!WAPerformanceFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAPerformanceFunctionalTest categoriesFor: #renderExplanationOn:!public!rendering! !
!WAPerformanceFunctionalTest categoriesFor: #renderFormOn:!public!rendering! !
!WAPerformanceFunctionalTest categoriesFor: #renderHtmlTextOn:!public!rendering! !
!WAPerformanceFunctionalTest categoriesFor: #renderIdTestOn:!public!rendering! !
!WAPerformanceFunctionalTest categoriesFor: #renderInline:factor:key:on:!public!rendering! !
!WAPerformanceFunctionalTest categoriesFor: #renderInline:key:on:!public!rendering! !
!WAPerformanceFunctionalTest categoriesFor: #renderLineBreaksOn:!public!rendering! !
!WAPerformanceFunctionalTest categoriesFor: #renderNativeBreakOn:!public!rendering! !
!WAPerformanceFunctionalTest categoriesFor: #renderScriptOn:!public!rendering! !
!WAPerformanceFunctionalTest categoriesFor: #renderTableOn:!public!rendering! !
!WAPerformanceFunctionalTest categoriesFor: #renderTextOn:!public!rendering! !
!WAPerformanceFunctionalTest categoriesFor: #style!public!rendering! !

!WAPerformanceFunctionalTest class methodsFor!

referenceDict
	| dict |
	dict := Dictionary new.
	dict at: #anchor put: 'Anchor Test' -> 1800.
	dict at: #script put: 'Script Test' -> 5300.
	dict at: #table put: 'Table Test' -> 5280.
	dict at: #lineBreak put: 'Line Break Test' -> 4550.
	dict at: #callback put: 'Callback Test' -> 2130.
	dict at: #form put: 'Form Test' -> 270.
	dict at: #id put: 'Generate ID''s Test' -> 4300.
	dict at: #seasideText put: 'Seaside Text Rendering Test' -> 6500.
	dict at: #nativeText put: 'Native Text Rendering Test' -> 26000.
	dict at: #seasideBR put: 'Seaside (br) Rendering Test' -> 23000.
	dict at: #nativeBR put: 'Native (br) Rendering Test' -> 78000.
	^dict! !
!WAPerformanceFunctionalTest class categoriesFor: #referenceDict!accessing!public! !

WAPhraseElementsFunctionalTest guid: (GUID fromString: '{2EDCA990-5488-48CC-822F-37F788CB457A}')!
WAPhraseElementsFunctionalTest comment: ''!
!WAPhraseElementsFunctionalTest categoriesForClass!Unclassified! !
!WAPhraseElementsFunctionalTest methodsFor!

renderAbbreviatedOn: html

	html heading level2; with: '<abbr>'.

	html paragraph: [
		html abbreviated
			title: 'World Wide Web';
			with: 'WWW' ]!

renderAcronymOn: html

	html heading level2; with: '<acronym>'.

	html paragraph: [
		html acronym
			title: 'Federal Bureau of Investigation';
			with: 'F.B.I.' ]!

renderAddressOn: html

	html heading level2; with: '<address>'.

	html address: [
		#(
			'Newsletter editor'
			'J.R. Brown'
			'JimquickPost News, Jimquick, CT 01234'
			'Tel (123) 456 7890')
			do: [ :each | html text: each ]
			separatedBy: [ html break ] ]!

renderCodeOn: html

	html heading level2; with: '<code>'.

	html paragraph: [
		html text: 'Expressions like '.
		html code: 'a[i++] + b[i++]'.
		html text: ' should not be used, since they cause undefined behavior' ]!

renderContentOn: html
	self renderHarryOn: html.
	self renderAbbreviatedOn: html.
	self renderAcronymOn: html.
	self renderKeyboardInputOn: html.
	self renderVariableOn: html.
	self renderCodeOn: html.
	self renderDefinitionOn: html.
	self renderSampleOn: html.
	self renderAddressOn: html.
	self renderModificationOn: html!

renderDefinitionOn: html

	html heading level2; with: '<dfn>'.

	html paragraph: [
		html definition: 'Ichthyology'.
		html text: ' is the branch of natural science which studies fish.' ]!

renderHarryOn: html

	html heading level2; with: '<cite>, <q>, <strong>'.

	html paragraph: [
		html text: 'As '.
		html citation: 'Harry S. Truman'.
		html text: ' said, '.
		html quote: 'The buck stops here.'.

		html break.

		html text: 'More information can be found in '.
		html citation: '[ISO-0000]'.
		html text: '.'.

		html break.

		html text: 'Please refer to the following reference number in future correspondence: '.
		html strong: '1-234-55' ]!

renderKeyboardInputOn: html

	html heading level2; with: '<kbd>'.

	html paragraph: [
		html text: 'Finally, type '.
		html keyboard: 'logout'.
		html text: ' and press the return key.' ]!

renderModificationOn: html

	html heading level2; with: '<ins>, <del>'.

	html paragraph: [
		html text: 'A Sheriff can employ '.
		html deleted
			title: 'Changed as a result of the SECURE bill.';
			cite: 'http://www.w3.org/TR/html401/struct/text.html#edef-del';
			datetime: '1994-11-05T08:15:30-05:00';
			with: 3.
		html inserted
			title: 'Changed as a result of the SECURE bill.';
			cite: 'http://www.w3.org/TR/html401/struct/text.html#edef-del';
			datetime: '1994-11-05T08:15:30-05:00';
			with: 5.
		html text: ' deputies.' ]!

renderSampleOn: html

	html heading level2; with: '<samp>'.

	html paragraph: [
		html text: 'If you select the ''champion'' option, you will receive the message '.
		html sample: 'The monkey is not a caterpillar'.
		html text: '.' ]!

renderVariableOn: html

	html heading level2; with: '<var>'.

	html paragraph: [
		html text: 'In the simplest case, the command for deleting a file in Unix is'.
		html break.
		html keyboard: 'rm'.
		html space.
		html variable: 'filename' ]! !
!WAPhraseElementsFunctionalTest categoriesFor: #renderAbbreviatedOn:!public!rendering! !
!WAPhraseElementsFunctionalTest categoriesFor: #renderAcronymOn:!public!rendering! !
!WAPhraseElementsFunctionalTest categoriesFor: #renderAddressOn:!public!rendering! !
!WAPhraseElementsFunctionalTest categoriesFor: #renderCodeOn:!public!rendering! !
!WAPhraseElementsFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAPhraseElementsFunctionalTest categoriesFor: #renderDefinitionOn:!public!rendering! !
!WAPhraseElementsFunctionalTest categoriesFor: #renderHarryOn:!public!rendering! !
!WAPhraseElementsFunctionalTest categoriesFor: #renderKeyboardInputOn:!public!rendering! !
!WAPhraseElementsFunctionalTest categoriesFor: #renderModificationOn:!public!rendering! !
!WAPhraseElementsFunctionalTest categoriesFor: #renderSampleOn:!public!rendering! !
!WAPhraseElementsFunctionalTest categoriesFor: #renderVariableOn:!public!rendering! !

WAPopupFunctionalTest guid: (GUID fromString: '{9A8C7D8D-65D0-4BD2-8FF2-8AA552102630}')!
WAPopupFunctionalTest comment: ''!
!WAPopupFunctionalTest categoriesForClass!Unclassified! !
!WAPopupFunctionalTest methodsFor!

calendarLoop
	self session presenter
		show: WAMiniCalendar new
		onAnswer: [ :answer | self requestContext closeThisPopup ]!

popupCloseTest
	self session presenter show: WAPopupCloseTestComponent new!

renderContentOn: html 
	html paragraph: [
		html popupAnchor
			callback: [ self calendarLoop ];
			with: 'popup'.
		html break.
		html popupAnchor
			extent: 300 @ 300;
			callback: [ self calendarLoop ];
			with: 'popup with extent'.
		html break.
		html popupAnchor
			position: 100 @ 100;
			callback: [ self calendarLoop ];
			with: 'popup with position'.
		html break.
		html popupAnchor
			location: true;
			callback: [ self calendarLoop ];
			with: 'popup with location'.
		html break.
		html popupAnchor
			resizable: false;
			callback: [ self calendarLoop ];
			with: 'popup not resizable'.
		html break.
		html popupAnchor
			resizable: false;
			extent: 300 @ 300;
			position: 50 @ 50;
			callback: [ self popupCloseTest  ];
			with: 'popup with close button']! !
!WAPopupFunctionalTest categoriesFor: #calendarLoop!actions!public! !
!WAPopupFunctionalTest categoriesFor: #popupCloseTest!actions!public! !
!WAPopupFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !

WARequestFunctionalTest guid: (GUID fromString: '{8723B06A-9AD0-49CC-98B6-D9DB8CA11088}')!
WARequestFunctionalTest comment: ''!
!WARequestFunctionalTest categoriesForClass!Unclassified! !
!WARequestFunctionalTest methodsFor!

renderAcceptCharsetFor: aRequest on: html
	html definitionTerm: 'Accept-Charset:'.
	self renderQualifiedValues: aRequest acceptCharset on: html!

renderAcceptEncodingFor: aRequest on: html
	html definitionTerm: 'Accept-Encoding:'.
	self renderQualifiedValues: aRequest acceptEncoding on: html!

renderAcceptFor: aRequest on: html
	html definitionTerm: 'Accept:'.
	self renderQualifiedValues: aRequest accept on: html!

renderAcceptLanguageFor: aRequest on: html
	html definitionTerm: 'Accept-Language:'.
	self renderQualifiedValues: aRequest acceptLanguage on: html!

renderContentOn: html
	| request |
	html paragraph: 'This tests whether the server delivers the remote address correctly and headers can be parsed correctly.'.
	request := self requestContext request.
	html definitionList: [
		self renderRemoteAddressFor: request on: html.
		self renderAcceptFor: request on: html.
		self renderAcceptCharsetFor: request on: html.
		self renderAcceptEncodingFor: request on: html.
		self renderAcceptLanguageFor: request on: html ]!

renderQualifiedValue: aQualifiedValue on: html
	html listItem: [
		| quality |
		html render: aQualifiedValue value.
		quality := aQualifiedValue quality.
		quality = Float infinity
			ifTrue: [ html superscript: [ html html: '&infin;' ] ]
			ifFalse: [ html superscript: quality ] ]!

renderQualifiedValues: aCollection on: html
	html definitionData: [
		aCollection isNil
			ifTrue: [ html text: 'N/A' ]
			ifFalse: [
				html orderedList: [
					aCollection do: [ :each |
						self renderQualifiedValue: each on: html ] ] ] ]!

renderRemoteAddressFor: aRequest on: html
	html definitionTerm: 'Remote Address:'.
	html definitionData: aRequest remoteAddress! !
!WARequestFunctionalTest categoriesFor: #renderAcceptCharsetFor:on:!public!rendering! !
!WARequestFunctionalTest categoriesFor: #renderAcceptEncodingFor:on:!public!rendering! !
!WARequestFunctionalTest categoriesFor: #renderAcceptFor:on:!public!rendering! !
!WARequestFunctionalTest categoriesFor: #renderAcceptLanguageFor:on:!public!rendering! !
!WARequestFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WARequestFunctionalTest categoriesFor: #renderQualifiedValue:on:!public!rendering! !
!WARequestFunctionalTest categoriesFor: #renderQualifiedValues:on:!public!rendering! !
!WARequestFunctionalTest categoriesFor: #renderRemoteAddressFor:on:!public!rendering! !

WARubyFunctionalTest guid: (GUID fromString: '{0ED35697-E0B2-49BB-A122-13D1DD903CDE}')!
WARubyFunctionalTest comment: '
Examples taken directly from spec:
http://www.w3.org/TR/2001/REC-ruby-20010531/
'!
!WARubyFunctionalTest categoriesForClass!Unclassified! !
!WARubyFunctionalTest methodsFor!

renderComplexOn: html
	html heading level2; with: 'Complex ruby markup'.
	html ruby: [
		html rubyBaseContainer: [
			html rubyBase: 10.
			html rubyBase: 31.
			html rubyBase: 2002 ].
		html rubyTextContainer: [
			html rubyText: 'Month'.
			html rubyText: 'Day'.
			html rubyText: 'Year' ].
		html rubyTextContainer: [
			html rubyText
				span: 3;
				with: 'Expiration Date' ] ]!

renderContentOn: html
	self renderSimpleOn: html.
	self renderSimpleParenthesesOn: html.
	self renderComplexOn: html!

renderSimpleOn: html
	html heading level2; with: 'Simple ruby markup'.
	html ruby: [
		html rubyBase: 'WWW'.
		html rubyText: 'World Wide Web' ]!

renderSimpleParenthesesOn: html
	html heading level2; with: 'Simple ruby markup with parentheses'.
	html ruby: [
		html rubyBase: 'WWW'.
		html rubyParentheses: '('.
		html rubyText: 'World Wide Web'.
		html rubyParentheses: ')' ]! !
!WARubyFunctionalTest categoriesFor: #renderComplexOn:!public!rendering! !
!WARubyFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WARubyFunctionalTest categoriesFor: #renderSimpleOn:!public!rendering! !
!WARubyFunctionalTest categoriesFor: #renderSimpleParenthesesOn:!public!rendering! !

WASvgFunctionalTest guid: (GUID fromString: '{A9791F58-EC53-496B-B1C8-C794E6DF0D25}')!
WASvgFunctionalTest comment: ''!
!WASvgFunctionalTest categoriesForClass!Unclassified! !
!WASvgFunctionalTest methodsFor!

renderContentOn: html
	html object
		type: 'image/svg+xml' seasideMimeType;
		width: 600;
		height: 800;
		standby: 'loading tiger';
		url: 'http://croczilla.com/bits_and_pieces/svg/samples/tiger/tiger.svg';
		with: 'Your browser doesn''t support SVG'! !
!WASvgFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !

WATableReportFunctionalTest guid: (GUID fromString: '{F9C3B19A-C148-4859-9513-55809CEC3016}')!
WATableReportFunctionalTest comment: ''!
!WATableReportFunctionalTest categoriesForClass!Unclassified! !
!WATableReportFunctionalTest methodsFor!

children
	^ Array with: report!

initialize
	super initialize.
	report := WATableReport new
		rows: WAComponent allSubclasses asArray;
		columns: (OrderedCollection new
			add: (WAReportColumn
				selector: #fullName title: 'Name'
				onClick: [ :each | self inform: each description onAnswer: [ ] ]);
			add: ((WAReportColumn
				selector: #canBeRoot title: 'Can Be Root')
				sortBlock: [ :a :b | a ]);
			add: (WAReportColumn
				renderBlock: [ :each :html | html emphasis: each description ]
				title: 'Description');
			yourself);
		rowColors: #(lightblue lightyellow);
		rowPeriod: 1;
		yourself! !
!WATableReportFunctionalTest categoriesFor: #children!accessing!public! !
!WATableReportFunctionalTest categoriesFor: #initialize!initialization!public! !

WATrailFunctionalTest guid: (GUID fromString: '{880F9F23-01AE-4269-9ADA-29F89AF3FC33}')!
WATrailFunctionalTest comment: ''!
!WATrailFunctionalTest categoriesForClass!Unclassified! !
!WATrailFunctionalTest methodsFor!

children
	^ Array with: trail with: component!

initialize
	super initialize.
	component := WATrailTestComponent new.
	trail := WATrail on: component!

renderContentOn: html
	html render: trail.
	html div: component! !
!WATrailFunctionalTest categoriesFor: #children!accessing!public! !
!WATrailFunctionalTest categoriesFor: #initialize!initialization!public! !
!WATrailFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !

WATrailingSlashFunctionalTest guid: (GUID fromString: '{B1DEDE98-6DD6-46FD-86D6-94D30A159F3B}')!
WATrailingSlashFunctionalTest comment: ''!
!WATrailingSlashFunctionalTest categoriesForClass!Unclassified! !
!WATrailingSlashFunctionalTest methodsFor!

baseUrlWithSlash: aBoolean 
	^ self application url
		addToPath: self class name greaseString;
		addField: 'slash'
			value: aBoolean greaseString;
		slash: aBoolean;
		yourself!

renderContentOn: html
	self renderExplanationOn: html.
	self renderLinksOn: html!

renderExplanationOn: html
	html paragraph: 'This tests whether the sever adapter correctly passes the tailing slash of the request URL to the request context.'.
	html paragraph: 'Click each of the links below, and the status should change from "not run" to "success".'!

renderLinksOn: html
	html table: [
		html tableRow: [
			html tableData: [
				self renderSlashSuccess: true on: html ].
			html tableData: [
				html anchor
				url: (self baseUrlWithSlash: true);
				with: 'With Slash' ] ].
		
		html tableRow: [
			html tableData: [
				self renderSlashSuccess: false on: html ].
			html tableData: [
				html anchor
				url: (self baseUrlWithSlash: false);
				with: 'Without Slash' ] ] ]!

renderSlashSuccess: aBoolean on: html 
	| request hasTrailingSlash expectedSlash |
	request := self requestContext request.
	hasTrailingSlash := request url slash.
	expectedSlash := request fields 
		at: 'slash'
		ifAbsent: [ nil ].
	expectedSlash isNil 
		ifTrue: [ html strong: 'not run' ]
		ifFalse: 
			[ aBoolean greaseString = expectedSlash 
				ifTrue: 
					[ hasTrailingSlash greaseString = expectedSlash 
						ifTrue: [ html strong: 'success' ]
						ifFalse: [ html strong: 'fail' ] ]
				ifFalse: [ html strong: 'not run' ] ]! !
!WATrailingSlashFunctionalTest categoriesFor: #baseUrlWithSlash:!private! !
!WATrailingSlashFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WATrailingSlashFunctionalTest categoriesFor: #renderExplanationOn:!public!rendering! !
!WATrailingSlashFunctionalTest categoriesFor: #renderLinksOn:!public!rendering! !
!WATrailingSlashFunctionalTest categoriesFor: #renderSlashSuccess:on:!private! !

WATreeFunctionalTest guid: (GUID fromString: '{B63BE5A6-55C9-4FBF-804D-7F1D7E9852A2}')!
WATreeFunctionalTest comment: ''!
!WATreeFunctionalTest categoriesForClass!Unclassified! !
!WATreeFunctionalTest methodsFor!

children
	^Array with: tree!

initialize
	super initialize.
	tree := WATree new
		root: Collection;
		labelBlock: [ :class | class name ];
		childrenBlock: [ :class | class subclasses ];
		selectBlock: [ :class | selected := class name ];
		canSelectBlock: [ :class | class subclasses notEmpty ];
		yourself!

renderContentOn: html
	self renderExplanationOn: html.
	self renderTreeOn: html!

renderExplanationOn: html
	html paragraph: [
		html text: 'This is a functional test for WATree.'.
		html orderedList: [
			html listItem: 'Clicking on ''+'' should expand a node'.
			html listItem: 'Clicking on ''-'' should collapse a node'.
			html listItem: 'Clicking on a node should display its name after ''Selected:'''.
			html listItem: 'Leaf nodes should not be clickable' ] ]!

renderTreeOn: html
	html strong: 'Selected:'.
	html render: selected.
	
	html render: tree!

states
	^Array with: self! !
!WATreeFunctionalTest categoriesFor: #children!accessing!public! !
!WATreeFunctionalTest categoriesFor: #initialize!initialization!public! !
!WATreeFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WATreeFunctionalTest categoriesFor: #renderExplanationOn:!public!rendering! !
!WATreeFunctionalTest categoriesFor: #renderTreeOn:!public!rendering! !
!WATreeFunctionalTest categoriesFor: #states!accessing!public! !

WAUploadFunctionalTest guid: (GUID fromString: '{E71CB13A-9D87-4DA7-9312-2EDB01F28EC4}')!
WAUploadFunctionalTest comment: ''!
!WAUploadFunctionalTest categoriesForClass!Unclassified! !
!WAUploadFunctionalTest methodsFor!

renderContentOn: html
	html heading: 'Upload File'.
	self renderExplanationOn: html.
	self renderUploadOn: html.
	file isNil ifTrue: [ ^ self ].
	self renderDownloadLinksOn: html.
	self renderFileContentsOn: html!

renderDownloadLinksOn: html
	html paragraph: [
		| contents |
		self renderIsByteArray: file rawContents on: html.
		html break.
		contents := file contentType isBinary
			ifTrue: [ file rawContents ]
			ifFalse: [
				"we don't use #contentsDecoded because no browser sends them because operating systems suck at files"
				file contentsDecodedUsing: 'ISO-8859-1' ].
		html anchor
			document: contents
				mimeType: file contentType
				fileName: file fileName;
			with: file fileName , ' (' , file contentType greaseString , ')'.
		html break.
		html anchor
			document: file rawContents;
			with: file fileName ]!

renderExplanationOn: html
	html paragraph: 'If "fail: wrong contents of WAFile" shows up then that means the contents of the WAFile are a String but should be a ByteArray.'!

renderFileContentsOn: html 
	file size <= 16r10000
		ifTrue: [ html preformatted: (file contentsDecodedUsing: 'ISO-8859-1') ]
		ifFalse: [
			html break.
			html text: 'file size is: ', file size greaseString, ' bytes' ]!

renderIsByteArray: aCollection on: html
	aCollection isString ifTrue: [
		html strong: 'fail: raw contents of WAFile should be a ByteArray not a String' ]!

renderUploadOn: html

	html form
		multipart;
		with: [
			html div: [
				"div for HTML validation"
				html fileUpload callback: [ :f | file := f ].
				html submitButton text: 'Load' ] ]! !
!WAUploadFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAUploadFunctionalTest categoriesFor: #renderDownloadLinksOn:!public!rendering! !
!WAUploadFunctionalTest categoriesFor: #renderExplanationOn:!public!rendering! !
!WAUploadFunctionalTest categoriesFor: #renderFileContentsOn:!public!rendering! !
!WAUploadFunctionalTest categoriesFor: #renderIsByteArray:on:!public!rendering! !
!WAUploadFunctionalTest categoriesFor: #renderUploadOn:!public!rendering! !

WAUrlEncodingFunctionalTest guid: (GUID fromString: '{475B5E53-CDEB-4268-BCBB-83AC4D2E260A}')!
WAUrlEncodingFunctionalTest comment: ''!
!WAUrlEncodingFunctionalTest categoriesForClass!Unclassified! !
!WAUrlEncodingFunctionalTest methodsFor!

initialize
	super initialize.
	input := 'input'!

input
	^input!

input: aString
	input := aString!

parameter
	| fieldValue request urlValue |
	request := self requestContext request.
	fieldValue := request at: 'input' ifAbsent: [ nil ].
	urlValue := request url queryFields at: 'input' ifAbsent: [ nil ].
	^(urlValue = input and: [ fieldValue = input ])
		ifTrue: [ fieldValue ]
		ifFalse: [ 'fail!!' ]!

path
	| path |
	path := self requestContext request url path last.
	^path = input
		ifTrue: [ path ]
		ifFalse: [ 'fail!!' ]!

renderContentOn: html
	self renderExplanationOn: html.

	html form
		get;
		with: [
			html div: [
				html textInput
					on: #input of: self.
				html submitButton ]].
		
	html definitionList: [
		html definitionTerm: 'Input'.
		html definitionData: self input.
		
		html definitionTerm: 'Parameter'.
		html definitionData: self parameter.
		
		html definitionTerm: 'Path'.
		html definitionData: self path ]!

renderExplanationOn: html
	html paragraph: 'This tests whether url encoding works.'.
	html unorderedList: [
		html listItem: [
			html text: 'Go to the '.
			html anchor
				url: 'http://www.columbia.edu/kermit/utf8.html';
				with: 'UTF-8 Sampler'.
			html text: ' and select some "foreign" text.' ].
		html listItem: 'Copy and paste it into the urlencoded text field below and click the submit button.'.
		html listItem: 'The text should be displayed below "Input", "Parameter" and "Path" without any error.'.
		html listItem: 'The text may appear in the address bar of the browser.'.
		html listItem: 'Repeat this process. Make sure to pick at least every of these languages: German, Czech, Korean.' ]!

updateUrl: aUrl
	super updateUrl: aUrl.
	input isEmptyOrNil ifTrue: [ ^ self ].
	aUrl addToPath: input.
	aUrl addField: 'input' value: input! !
!WAUrlEncodingFunctionalTest categoriesFor: #initialize!initialization!public! !
!WAUrlEncodingFunctionalTest categoriesFor: #input!accessing!public! !
!WAUrlEncodingFunctionalTest categoriesFor: #input:!accessing!public! !
!WAUrlEncodingFunctionalTest categoriesFor: #parameter!accessing!public! !
!WAUrlEncodingFunctionalTest categoriesFor: #path!accessing!public! !
!WAUrlEncodingFunctionalTest categoriesFor: #renderContentOn:!public!rendering! !
!WAUrlEncodingFunctionalTest categoriesFor: #renderExplanationOn:!public!rendering! !
!WAUrlEncodingFunctionalTest categoriesFor: #updateUrl:!public!updating! !

WADelegationTask guid: (GUID fromString: '{990AC1E6-A893-430C-B777-0410C53D8E52}')!
WADelegationTask comment: ''!
!WADelegationTask categoriesForClass!Unclassified! !
!WADelegationTask methodsFor!

children
	"Even if we component1 and component2, we have to return them as children as otherwise their decorations are not properly backtracked. See WADecorationTest."
	
	^ Array with: component1 with: component2!

go
	self call: component1 onAnswer: [ :a1 |
		self call: component2 onAnswer: [ ] ]!

initialize
	super initialize.
	component1 := WAFormDialog new
		addMessage: 'Step 1';
		yourself.
	component2 := WAFormDialog new
		addMessage: 'Step 2';
		yourself! !
!WADelegationTask categoriesFor: #children!accessing!public! !
!WADelegationTask categoriesFor: #go!public!running! !
!WADelegationTask categoriesFor: #initialize!initialization!public! !

WAEmptyTestTask guid: (GUID fromString: '{863E675C-26D5-411A-85F4-8CA66CC3E08F}')!
WAEmptyTestTask comment: ''!
!WAEmptyTestTask categoriesForClass!Unclassified! !
!WAEmptyTestTask methodsFor!

go
	"do nothing. I wonder what happens?"! !
!WAEmptyTestTask categoriesFor: #go!public!running! !

WAFunctionalTaskTest guid: (GUID fromString: '{6BB0485A-B278-4A18-849D-BF62218DC982}')!
WAFunctionalTaskTest comment: ''!
!WAFunctionalTaskTest categoriesForClass!Unclassified! !
!WAFunctionalTaskTest class methodsFor!

isFunctionalTest
	^ (self name = #WAFunctionalTaskTest) not! !
!WAFunctionalTaskTest class categoriesFor: #isFunctionalTest!public!testing! !

WATaskErrorFunctionalTest guid: (GUID fromString: '{7E7F972B-6549-408E-994A-42F879DE8205}')!
WATaskErrorFunctionalTest comment: ''!
!WATaskErrorFunctionalTest categoriesForClass!Unclassified! !
!WATaskErrorFunctionalTest methodsFor!

go
	self confirm: 'Raise an exception?' onAnswer: [ :answer |
		[ answer ifTrue: [ self error: 'foo' ] ]
			on: Error
			do: [ :error | self inform: 'Caught: ', error description onAnswer: [] ] ]! !
!WATaskErrorFunctionalTest categoriesFor: #go!processing!public! !

WAExpirySession guid: (GUID fromString: '{181CB1CB-DBBD-4CE1-9453-2FDC5760FE15}')!
WAExpirySession comment: ''!
!WAExpirySession categoriesForClass!Unclassified! !
!WAExpirySession methodsFor!

initialize
	super initialize.
	Created := Created + 1!

unregistered
	super unregistered.
	Unregistered := Unregistered + 1! !
!WAExpirySession categoriesFor: #initialize!initialization!public! !
!WAExpirySession categoriesFor: #unregistered!notifications!public! !

!WAExpirySession class methodsFor!

created
	^ Created!

initialize
	self resetCounters!

resetCounters
	Unregistered := 0.
	Created := 0!

unregistered
	^ Unregistered! !
!WAExpirySession class categoriesFor: #created!accessing!public! !
!WAExpirySession class categoriesFor: #initialize!class initialization!public! !
!WAExpirySession class categoriesFor: #resetCounters!actions!public! !
!WAExpirySession class categoriesFor: #unregistered!accessing!public! !

WATestsFunctionalPlatformTest guid: (GUID fromString: '{37C92C40-23D9-4EFF-875B-F42759C6258B}')!
WATestsFunctionalPlatformTest comment: ''!
!WATestsFunctionalPlatformTest categoriesForClass!Unclassified! !
!WATestsFunctionalPlatformTest methodsFor!

testGarbageCollect
	self 
		shouldnt: [ GRPlatform current seasideGarbageCollect ]
		raise: MessageNotUnderstood! !
!WATestsFunctionalPlatformTest categoriesFor: #testGarbageCollect!public!tests! !

"Binary Globals"!

