| package |
package := Package name: 'Seaside-Tests-HTML5'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '17'.


package classNames
	add: #WACanvasTagTest;
	add: #WAHtml5ContentTest;
	add: #WAHtml5ElementsTest;
	add: #WAHtml5InputTest;
	add: #WAVideoTest;
	yourself.

package methodNames
	add: 'GRPackage class' -> #seasideTestsHTML5;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Grease\Grease-Core';
	add: 'Seaside-Tests-Functional';
	add: 'Seaside-Tools-Web';
	yourself).

package!

"Class Definitions"!

WAFunctionalTest subclass: #WACanvasTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAHtml5ContentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAHtml5ElementsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAHtml5InputTest
	instanceVariableNames: 'required autofocus pattern search range email url number datetimelocal datetime date time month week color telephone'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFunctionalTest subclass: #WAVideoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

seasideTestsHTML5
	^ self new
		name: 'Seaside-Tests-HTML5';
		description: 'Unit tests for the package Seaside-HTML5.';
		addDependency: 'Seaside-HTML5';
		addDependency: 'Seaside-Tests-Functional';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideTestsHTML5!*seaside-tests-html5!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

WACanvasTagTest guid: (GUID fromString: '{6907BFAA-FAA1-4E62-AB42-76240201CF2E}')!
WACanvasTagTest comment: ''!
!WACanvasTagTest categoriesForClass!Unclassified! !
!WACanvasTagTest methodsFor!

drawFunction
	"http://developer.mozilla.org/samples/canvas-tutorial/2_7_canvas_combined.html"
	^
'function drawShape(){
  // get the canvas element using the DOM
  var canvas = document.getElementById(''tutorial'');

  // Make sure we don''t execute when canvas isn''t supported
  if (canvas.getContext){

    // use getContext to use the canvas for drawing
    var ctx = canvas.getContext(''2d'');

    // Draw shapes
    roundedRect(ctx,12,12,150,150,15);
    roundedRect(ctx,19,19,150,150,9);
    roundedRect(ctx,53,53,49,33,10);
    roundedRect(ctx,53,119,49,16,6);
    roundedRect(ctx,135,53,49,33,10);
    roundedRect(ctx,135,119,25,49,10);

    // Character 1
    ctx.beginPath();
    ctx.arc(37,37,13,Math.PI/7,-Math.PI/7,false);
    ctx.lineTo(34,37);
    ctx.fill();

    // blocks
    for(i=0;i<8;i++){
      ctx.fillRect(51+i*16,35,4,4);
    }
    for(i=0;i<6;i++){
      ctx.fillRect(115,51+i*16,4,4);
    }
    for(i=0;i<8;i++){
      ctx.fillRect(51+i*16,99,4,4);
    }

    // character 2
    ctx.beginPath();
    ctx.moveTo(83,116);
    ctx.lineTo(83,102);
    ctx.bezierCurveTo(83,94,89,88,97,88);
    ctx.bezierCurveTo(105,88,111,94,111,102);
    ctx.lineTo(111,116);
    ctx.lineTo(106.333,111.333);
    ctx.lineTo(101.666,116);
    ctx.lineTo(97,111.333);
    ctx.lineTo(92.333,116);
    ctx.lineTo(87.666,111.333);
    ctx.lineTo(83,116);
    ctx.fill();
    ctx.fillStyle = "white";
    ctx.beginPath();
    ctx.moveTo(91,96);
    ctx.bezierCurveTo(88,96,87,99,87,101);
    ctx.bezierCurveTo(87,103,88,106,91,106);
    ctx.bezierCurveTo(94,106,95,103,95,101);
    ctx.bezierCurveTo(95,99,94,96,91,96);
    ctx.moveTo(103,96);
    ctx.bezierCurveTo(100,96,99,99,99,101);
    ctx.bezierCurveTo(99,103,100,106,103,106);
    ctx.bezierCurveTo(106,106,107,103,107,101);
    ctx.bezierCurveTo(107,99,106,96,103,96);
    ctx.fill();
    ctx.fillStyle = "black";
    ctx.beginPath();
    ctx.arc(101,102,2,0,Math.PI*2,true);
    ctx.fill();
    ctx.beginPath();
    ctx.arc(89,102,2,0,Math.PI*2,true);
    ctx.fill();
  } else {
    alert(''You need Safari or Firefox 1.5+ to see this demo.'');
  }
}

function roundedRect(ctx,x,y,width,height,radius){
  ctx.beginPath();
  ctx.moveTo(x,y+radius);
  ctx.lineTo(x,y+height-radius);
  ctx.quadraticCurveTo(x,y+height,x+radius,y+height);
  ctx.lineTo(x+width-radius,y+height);
  ctx.quadraticCurveTo(x+width,y+height,x+width,y+height-radius);
  ctx.lineTo(x+width,y+radius);
  ctx.quadraticCurveTo(x+width,y,x+width-radius,y);
  ctx.lineTo(x+radius,y);
  ctx.quadraticCurveTo(x,y,x,y+radius);
  ctx.stroke();
}
'!

label
	^'<canvas>'!

renderContentOn: html
	html script: self drawFunction.
	html canvas id: 'tutorial'; width: 150; height: 150.
	html script: 'drawShape()'
! !
!WACanvasTagTest categoriesFor: #drawFunction!private! !
!WACanvasTagTest categoriesFor: #label!accessing!public! !
!WACanvasTagTest categoriesFor: #renderContentOn:!public!rendering! !

WAHtml5ContentTest guid: (GUID fromString: '{3880C7D6-C69D-4CB7-97CD-DAC9DEDD8AE7}')!
WAHtml5ContentTest comment: ''!
!WAHtml5ContentTest categoriesForClass!Unclassified! !
!WAHtml5ContentTest methodsFor!

label
	^'Html 5 Content Model'!

renderContentOn: html
	html header: [
		html heading level1;
			with: [
				html anchor
					url: 'http://www.elharo.com/blog';
					with: 'Mokka mit Schlag' ] ].
	html section: [
		html article: [
			html heading level2;
				with: [
					html anchor
						url: '/blog/birding/2007/04/23/spring-comes-and-goes-in-sussex-county/';
						with: 'Spring Comes (and Goes) in Sussex County' ].
				html paragraph: 'Yesterday I joined the Brooklyn Bird Club for our annual trip to Western New Jersey, specifically Hyper Humus, a relatively recently discovered hot spot. It started out as a nice winter morning when we arrived at the site at 7:30 A.M., progressed to Spring around 10:00 A.M., and reached early summer by 10:15.' ].
		html article: [
			html heading level2;
				with: [
					html anchor
						url: '/blog/birding/2007/04/23/but-does-it-count-for-your-life-list/';
						with: 'But does it count for your life list?' ].
			html paragraph: [
				html text: 'Seems you can now go '.
				html anchor
					url: 'http://www.wired.com/science/discoveries/news/ 2007/04/cone_sf';
					with: 'bird watching via the Internet'.
				html text: '. I haven''t been able to test it out yet (20 user limit apparently) but this is certainly cool. Personally, I can''t imagine it replacing actually being out in the field by any small amount. On the other hand, I''ve always found it quite sad to meet senior birders who are no longer able to hold binoculars steady or get to the park. I can imagine this might be of some interest to them. At least one elderly birder did a big year on TV, after he could no longer get out so much. This certainly tops that.' ] ] ].
	
	html navigation: [
		html anchor
			url: '/blog/page/2/';
			with: '<< Previous Entries' ].
		
	html navigation: [
		html unorderedList: [
			html listItem: [
				html heading level2;
					with: 'Info'.
				html unorderedList: [
					html listItem: [
						html anchor
							url: '/blog/comment-policy/';
							with: 'Comment Policy' ].
					html listItem: [
						html anchor
							url: '/blog/todo-list/';
							with: 'Todo List' ] ] ].
			html listItem: [
				html heading level2;
					with: 'Archives'.
				html unorderedList: [
					html listItem: [
						html anchor
							url: '/blog/2007/04/';
							with: 'April 2007' ].
					html listItem: [
						html anchor
							url: '/blog/2007/02/';
							with: 'February 2007' ] ] ].
					html listItem: [
						html anchor
							url: '/blog/2007/01/';
							with: 'January 2007' ] ] ].
				
	html aside: [
		html heading level3
			with: '.xf-value'.
		html paragraph: [
			html text: 'The '.
			html code: '.xf-value'.
			html text: ' selector used here styles the input field value but not its label. This is actually inconsistent with the current CSS3 draft. The example really should use the '.
			html code: '::value'.
			html text: 'pseudo-class instead like so:' ].
		html preformatted: 
'input::value { width: 20em; }
#ccnumber::value { width: 18em }
#zip::value { width: 12em }
#state::value { width: 3em  }'. 
		html paragraph: 'However, Firefox doesn''t yet support this syntax' ].
				
	html footer: [
		html paragraph: 'Copyright 2007 Elliotte Rusty Harold' ]! !
!WAHtml5ContentTest categoriesFor: #label!accessing!public! !
!WAHtml5ContentTest categoriesFor: #renderContentOn:!public!rendering! !

WAHtml5ElementsTest guid: (GUID fromString: '{B698F972-85EC-4AE6-A967-D93A2070EF71}')!
WAHtml5ElementsTest comment: ''!
!WAHtml5ElementsTest categoriesForClass!Unclassified! !
!WAHtml5ElementsTest methodsFor!

label
	^'Html 5 Elements'!

renderContentOn: html
	self renderFigureOn: html.
	self renderMarkedOn: html.
	self renderMeterOn: html.
	self renderProgressOn: html.
	self renderDialogOn: html.
	self renderTimeOn: html.
	self renderDetailsOn: html.
	self renderDatagridOn: html.
	self renderMenuOn: html!

renderDatagridOn: html
	html heading level2; with: '<datagrid>'.

	html datagrid: [
		html table: [
			html tableRow: [
				html tableData: 'Jones'.
				html tableData: 'Allison'.
				html tableData: 'A-'.
				html tableData: 'B+'.
				html tableData: 'A' ].
			html tableRow: [
				html tableData: 'Smith'.
				html tableData: 'Johnny'.
				html tableData: 'A'.
				html tableData: 'C+'.
				html tableData: 'A' ].
			html tableRow: [
				html tableData: 'Willis'.
				html tableData: 'Sydney'.
				html tableData: 'C-'.
				html tableData: 'D'.
				html tableData: 'F' ].
			html tableRow: [
				html tableData: 'Wilson'.
				html tableData: 'Frank'.
				html tableData: 'B-'.
				html tableData: 'B+'.
				html tableData: 'A' ]  ] ]!

renderDetailsOn: html
	html heading level2; with: '<details>'.
	
	html details: [
		html legend: '[Sibley, 2000]'.
		html paragraph: 'Sibley, David Allen, The Sibley Guide to Birds, 
(New York: Chanticleer Press, 2000) p. 247' ]!

renderDialogOn: html
	html heading level2; with: '<dialog>'.
	
	html dialog: [
		html definitionTerm: 'Costello'.
		html definitionData: 'Look, you gotta first baseman?'.
		html definitionTerm: 'Abbott'.
		html definitionData: 'Certainly.'.
		html definitionTerm: 'Costello'.
		html definitionData: 'Who''s playing first?'.
		html definitionTerm: 'Abbott'.
		html definitionData: 'That''s right.'.
		html definitionTerm: 'Costello'.
		html definitionData: 'When you pay off the first baseman every month, who gets the money?'.
		html definitionTerm: 'Abbott'.
		html definitionData: 'Every dollar of it'. ]!

renderFigureOn: html
	html heading level2; with: '<figure>'.
	html figure: [
		html legend: 'The Profiler Icon'.
		html space.
		html image url: WAToolFiles / #profilerPng; altText: 'profiler' ]!

renderHeaderOn: html
	html heading level2; with: '<header>'.
	
	html header: [
		html paragraph: 'Welcome to...'.
		html heading level1; with: 'Voidwars!!' ]!

renderMarkedOn: html
	html heading level2; with: '<m> (kitten)'.
	
	html paragraph: [
		html text: 'I also have some '.
		html marked: 'kitten'.
		html text: 's who are visiting me these days. They''re really cute. I think they like my garden!!' ]!

renderMenuOn: html
	html heading level2; with: '<menu>'.

	html menu: [
		html command label: 'Do 1st Command'.
		html command label: 'Do 2nd Command'.
		html command label: 'Do 3rd Command' ]!

renderMeterOn: html
	html heading level2; with: '<meter>'.
	
	html meter: '75%'.
	html break.
	html meter: '3/4'.
	html break.
	html meter: '6 blocks used (out of 8 total)'.
	html break.
	html meter: 'max: 100; current: 75'.
	html break.
	html meter
		min: 0;
		max: 100;
		value: 75.!

renderProgressOn: html
	html heading level2; with: '<progress>'.
	
	html progress: '75%'!

renderTimeOn: html
	html heading level2; with: '<time>'.
	
	html paragraph: [
		html text: 'Our first date was '.
		html time
			datetime: '2006-09-23';
			with: 'a saturday'.
		html text: '.' ].
	
	html paragraph: [
		html text: 'We stopped talking at '.
		html time
			datetime: '2006-09-24 05:00 -7';
			with: '5am the next morning'.
		html text: '.' ].
	
	html paragraph: [
		html text: 'Many people get up at '.
		html time: '08:00'.
		html text: '.' ]! !
!WAHtml5ElementsTest categoriesFor: #label!accessing!public! !
!WAHtml5ElementsTest categoriesFor: #renderContentOn:!public!rendering! !
!WAHtml5ElementsTest categoriesFor: #renderDatagridOn:!public!rendering! !
!WAHtml5ElementsTest categoriesFor: #renderDetailsOn:!public!rendering! !
!WAHtml5ElementsTest categoriesFor: #renderDialogOn:!public!rendering! !
!WAHtml5ElementsTest categoriesFor: #renderFigureOn:!public!rendering! !
!WAHtml5ElementsTest categoriesFor: #renderHeaderOn:!public!rendering! !
!WAHtml5ElementsTest categoriesFor: #renderMarkedOn:!public!rendering! !
!WAHtml5ElementsTest categoriesFor: #renderMenuOn:!public!rendering! !
!WAHtml5ElementsTest categoriesFor: #renderMeterOn:!public!rendering! !
!WAHtml5ElementsTest categoriesFor: #renderProgressOn:!public!rendering! !
!WAHtml5ElementsTest categoriesFor: #renderTimeOn:!public!rendering! !

WAHtml5InputTest guid: (GUID fromString: '{8FFCB747-77C4-45E7-86A9-4077A1492FE4}')!
WAHtml5InputTest comment: ''!
!WAHtml5InputTest categoriesForClass!Unclassified! !
!WAHtml5InputTest methodsFor!

autofocus
	^autofocus!

autofocus: aString
	autofocus := aString!

color
	^color!

color: aString
	color := aString!

date
	^date!

date: anObject
	date := anObject!

datetime
	^datetime!

datetime: anObject
	datetime := anObject!

datetimelocal
	^datetimelocal!

datetimelocal: anObject
	datetimelocal := anObject!

email
	^ email!

email: anObject
	email := anObject!

label
	^'Html 5 Input'!

month
	^month!

month: anObject
	month := anObject!

number
	^number!

number: anObject
	number := anObject!

pattern
	^pattern!

pattern: aString
	pattern := aString!

range
	^ range!

range: anObject
	range := anObject!

renderContentOn: html
	html form: [
		html table: [
			html tableRow: [
				html tableHeading: [ html label: 'required' ].
				html tableData: [
					html textInput
						required;
						on: #required of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'autofocus' ].
				html tableData: [
					html textInput
						autofocus;
						on: #autofocus of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'pattern ([0-9][A-Z]{3})' ].
				html tableData: [
					html textInput
						pattern: '[0-9][A-Z]{3}';
						on: #pattern of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'search' ].
				html tableData: [
					html searchInput
						autosave: 'Seaside';
						placeholder: 'placeholder ...';
						results: 5;
						incremental: false;
						on: #search of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'range (6..12) by 2' ].
				html tableData: [ html rangeInput
					min: 6;
					max: 12;
					step: 2;
					on: #range of: self.
				html space.
				html render: self range ] ].
			html tableRow: [
				html tableHeading: [ html label: 'email' ].
				html tableData: [
					html emailInput
						on: #email of: self ].
				html tableData: self email class name ].
			html tableRow: [
				html tableHeading: [ html label: 'url' ].
				html tableData: [
					html urlInput
					on: #url of: self ].
				html tableData: self url class name ].
			html tableRow: [
				html tableHeading: [ html label: 'number' ].
				html tableData: [
					html numberInput
						on: #number of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'datetimelocal' ].
				html tableData: [
					html dateTimeLocalInput
						on: #datetimelocal of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'datetime' ].
				html tableData: [
					html dateTimeInput
						on: #datetime of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'date' ].
				html tableData: [
					html dateInput5
						on: #date of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'time' ].
				html tableData: [
					html timeInput5
						on: #time of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'month' ].
				html tableData: [
					html monthInput
						step: 3;
						on: #month of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'week' ].
				html tableData: [
					html weekInput
						on: #week of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'color' ].
				html tableData: [
					html colorInput
						on: #color of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'telephone' ].
				html tableData: [
					html telephoneInput
						on: #telephone of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'datalist' ].
				html tableData: [ 
					html datalist: [
						html option: 'HTML'.
						html option disabled: true; with: 'XHTML' ] ] ] ].
		html submitButton ]!

required
	^required!

required: aString
	required := aString!

search
	^ search!

search: anObject
	search := anObject!

telephone
	^telephone!

telephone: anObject
	telephone := anObject!

time
	^ time!

time: anObject
	time := anObject!

url
	^ url!

url: anObject
	url := anObject!

week
	^week!

week: anObject
	week := anObject! !
!WAHtml5InputTest categoriesFor: #autofocus!accessing!public! !
!WAHtml5InputTest categoriesFor: #autofocus:!accessing!public! !
!WAHtml5InputTest categoriesFor: #color!accessing!public! !
!WAHtml5InputTest categoriesFor: #color:!accessing!public! !
!WAHtml5InputTest categoriesFor: #date!accessing!public! !
!WAHtml5InputTest categoriesFor: #date:!accessing!public! !
!WAHtml5InputTest categoriesFor: #datetime!accessing!public! !
!WAHtml5InputTest categoriesFor: #datetime:!accessing!public! !
!WAHtml5InputTest categoriesFor: #datetimelocal!accessing!public! !
!WAHtml5InputTest categoriesFor: #datetimelocal:!accessing!public! !
!WAHtml5InputTest categoriesFor: #email!accessing!public! !
!WAHtml5InputTest categoriesFor: #email:!accessing!public! !
!WAHtml5InputTest categoriesFor: #label!accessing!public! !
!WAHtml5InputTest categoriesFor: #month!accessing!public! !
!WAHtml5InputTest categoriesFor: #month:!accessing!public! !
!WAHtml5InputTest categoriesFor: #number!accessing!public! !
!WAHtml5InputTest categoriesFor: #number:!accessing!public! !
!WAHtml5InputTest categoriesFor: #pattern!accessing!public! !
!WAHtml5InputTest categoriesFor: #pattern:!accessing!public! !
!WAHtml5InputTest categoriesFor: #range!accessing!public! !
!WAHtml5InputTest categoriesFor: #range:!accessing!public! !
!WAHtml5InputTest categoriesFor: #renderContentOn:!public!rendering! !
!WAHtml5InputTest categoriesFor: #required!accessing!public! !
!WAHtml5InputTest categoriesFor: #required:!accessing!public! !
!WAHtml5InputTest categoriesFor: #search!accessing!public! !
!WAHtml5InputTest categoriesFor: #search:!accessing!public! !
!WAHtml5InputTest categoriesFor: #telephone!accessing!public! !
!WAHtml5InputTest categoriesFor: #telephone:!accessing!public! !
!WAHtml5InputTest categoriesFor: #time!accessing!public! !
!WAHtml5InputTest categoriesFor: #time:!accessing!public! !
!WAHtml5InputTest categoriesFor: #url!accessing!public! !
!WAHtml5InputTest categoriesFor: #url:!accessing!public! !
!WAHtml5InputTest categoriesFor: #week!accessing!public! !
!WAHtml5InputTest categoriesFor: #week:!accessing!public! !

WAVideoTest guid: (GUID fromString: '{45ABED7F-446E-4E7E-8193-5DC8C1A88388}')!
WAVideoTest comment: ''!
!WAVideoTest categoriesForClass!Unclassified! !
!WAVideoTest methodsFor!

label
	^'<video>'!

renderContentOn: html
	html video 
		url: 'http://people.opera.com/howcome/2007/video/A_New_Computer--small.ogg';
		with: 'Theora decoder not found'! !
!WAVideoTest categoriesFor: #label!accessing!public! !
!WAVideoTest categoriesFor: #renderContentOn:!public!rendering! !

"Binary Globals"!

