| package |
package := Package name: 'Seaside-Tests-InternetExplorer'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '9'.


package methodNames
	add: #WAResponseTest -> #testForceSafe;
	add: #WAResponseTest -> #testIMeanIt;
	add: #WAResponseTest -> #testImNice;
	add: 'GRPackage class' -> #seasideTestsInternetExplorer;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Grease\Grease-Core';
	add: 'Seaside-Tests-Core';
	yourself).

package!

"Class Definitions"!


"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

seasideTestsInternetExplorer
	^ self new
		name: 'Seaside-Tests-InternetExplorer';
		description: 'Unit tests for the package Seaside-InternetExplorer.';
		addDependency: 'Seaside-InternetExplorer';
		addDependency: 'Seaside-Tests-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideTestsInternetExplorer!*seaside-tests-internetexplorer!public! !

!WAResponseTest methodsFor!

testForceSafe
	self response forceSafe.
	self assert: (self response headerAt: 'X-Download-Options') = 'noopen'.
	self assert: (self response headers size) = 1!

testIMeanIt
	self response iMeanIt.
	self assert: (self response headerAt: 'X-Content-Type-Options') = 'nosniff'.
	self assert: (self response headers size) = 1!

testImNice
	self response imNice.
	self assert: (self response headerAt: 'P3P') = 'CP="CAO PSA OUR"'.
	self assert: (self response headers size) = 1! !
!WAResponseTest categoriesFor: #testForceSafe!*seaside-tests-internetexplorer!public! !
!WAResponseTest categoriesFor: #testIMeanIt!*seaside-tests-internetexplorer!public! !
!WAResponseTest categoriesFor: #testImNice!*seaside-tests-internetexplorer!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

"Binary Globals"!

