| package |
package := Package name: 'Seaside-Tests-Tools-Web'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '15'.


package classNames
	add: #WACloneHandlerTest;
	add: #WADispatcherComponentTest;
	add: #WAToolsWebDefaultHandlersTest;
	yourself.

package methodNames
	add: 'GRPackage class' -> #seasideTestsToolsWeb;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: 'Seaside-Component';
	add: 'Seaside-Core';
	add: 'Seaside-RenderLoop';
	add: 'Seaside-Session';
	add: 'Seaside-Tests-Core';
	add: 'Seaside-Tests-Environment';
	add: 'Seaside-Tools-Core';
	add: 'Seaside-Tools-Web';
	add: '..\..\Camp Smalltalk\SUnit\SUnit';
	yourself).

package!

"Class Definitions"!

TestCase subclass: #WACloneHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAContextTest subclass: #WADispatcherComponentTest
	instanceVariableNames: 'configApplication rootHandler childHandler normalApplication'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAEnvironmentDefaultHandlersTest subclass: #WAToolsWebDefaultHandlersTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

seasideTestsToolsWeb
	^ self new
		name: 'Seaside-Tests-Tools-Web';
		description: 'Unit tests for the package Seaside-Tools-Web.';
		addDependency: 'Seaside-Tools-Web';
		addDependency: 'Seaside-Tests-Environment';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideTestsToolsWeb!*seaside-tests-tools-web!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

WACloneHandlerTest guid: (GUID fromString: '{B1D8416E-77AF-4B28-90B7-81D4144E30A7}')!
WACloneHandlerTest comment: ''!
!WACloneHandlerTest categoriesForClass!Unclassified! !
!WACloneHandlerTest methodsFor!

testCloneApplication
	| app handler key clone |
	app := WADispatcher new register: WAApplication new at: 'app'.
	handler := WARequestHandler new.
	key := app register: handler.
	
	clone := app cloneHandler.
	
	self assert: key = (app keyFor: handler).
	self should: [ clone keyFor: handler ] raise: Error.! !
!WACloneHandlerTest categoriesFor: #testCloneApplication!public!tests! !

WADispatcherComponentTest guid: (GUID fromString: '{88946FCA-F939-487D-B2E5-595AE14C17A3}')!
WADispatcherComponentTest comment: ''!
!WADispatcherComponentTest categoriesForClass!Unclassified! !
!WADispatcherComponentTest methodsFor!

createHandlers
	^Array
		with: rootHandler
		with: configApplication
		with: WASession new!

setUp
	super setUp.
	rootHandler := WADispatcher new.
	rootHandler := rootHandler register: WADispatcher new at: 'seaside'.
	childHandler := rootHandler register: WADispatcher new at: 'child'.
	configApplication := WAAdmin register: WAApplication 
		at: 'config'
		in: rootHandler.
	configApplication configuration addParent: WARenderLoopConfiguration instance.
	configApplication 
		preferenceAt: #rootClass
		put: WAConfigurationBrowser.
	normalApplication := WAApplication 
		register: 'counter'
		in: childHandler.
	normalApplication configuration addParent: WARenderLoopConfiguration instance.
	normalApplication 
		preferenceAt: #rootClass
		put: WAConfigurationBrowser!

testNestedDispatcher
	| configComponent |
	configComponent := WAConfigurationBrowser on: rootHandler.
	self requestContextWithUrl: '/config/child'.
	self requestContext consumer next.
	self requestContext session properties at: #presenter put: WAComponent new.
	configComponent initialRequest: self requestContext request.
	self assert: configComponent dispatcher == childHandler!

testUnregister
	| url |
	url := normalApplication url.
	url path removeFirst.
	self assert: (WAAdmin unregister: url pathString in: rootHandler) = normalApplication.
	self assert: (WAAdmin unregister: url pathString in: rootHandler) isNil.
	
	url := childHandler url.
	url path removeFirst.
	self assert: (WAAdmin unregister: url pathString in: rootHandler) = childHandler.
	self assert: (WAAdmin unregister: url pathString in: rootHandler) isNil.
	
	self assert: (WAAdmin unregister: '/not-existing' in: rootHandler) isNil! !
!WADispatcherComponentTest categoriesFor: #createHandlers!private! !
!WADispatcherComponentTest categoriesFor: #setUp!public!running! !
!WADispatcherComponentTest categoriesFor: #testNestedDispatcher!public!tests! !
!WADispatcherComponentTest categoriesFor: #testUnregister!public!tests! !

WAToolsWebDefaultHandlersTest guid: (GUID fromString: '{E8DAEADE-1A4E-48D5-9079-E6DCFA0F4417}')!
WAToolsWebDefaultHandlersTest comment: ''!
!WAToolsWebDefaultHandlersTest categoriesForClass!Unclassified! !
!WAToolsWebDefaultHandlersTest methodsFor!

testDefaultConfig
	| app |
	app := self defaultDispatcher entryPointAt: 'config'.
	self assert: app class == WAApplication.
	self assert: app isApplication.
	self deny: app isDispatcher.
	self deny: app parent isNil.
	self assert: app name = 'config'.
	self assert: app url pathString = '/config'! !
!WAToolsWebDefaultHandlersTest categoriesFor: #testDefaultConfig!public!tests! !

"Binary Globals"!

