| package |
package := Package name: 'Seaside-Widgets'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '18'.


package classNames
	add: #WAAlphabeticBatchedList;
	add: #WABatchedList;
	add: #WABatchSelection;
	add: #WACanvasWidget;
	add: #WAChoiceDialog;
	add: #WADateSelector;
	add: #WADateTable;
	add: #WADateTimeSelector;
	add: #WADelayedAnswerDecoration;
	add: #WAFormDecoration;
	add: #WAFormDialog;
	add: #WAInputDialog;
	add: #WALabelledFormDialog;
	add: #WAMessageDecoration;
	add: #WAMiniCalendar;
	add: #WANavigation;
	add: #WANavigationBar;
	add: #WANavigationFiles;
	add: #WAPath;
	add: #WAReportColumn;
	add: #WASelection;
	add: #WASelectionDateTable;
	add: #WASimpleNavigation;
	add: #WATableReport;
	add: #WATimeSelector;
	add: #WATrail;
	add: #WATree;
	add: #WAValidationDecoration;
	add: #WAValidationNotification;
	add: #WAWidgetDecoration;
	add: #WAWindowDecoration;
	add: #WAYesOrNoDialog;
	yourself.

package methodNames
	add: #WAComponent -> #addMessage:;
	add: #WAComponent -> #chooseFrom:caption:onAnswer:;
	add: #WAComponent -> #chooseFrom:default:caption:onAnswer:;
	add: #WAComponent -> #chooseFrom:default:onAnswer:;
	add: #WAComponent -> #chooseFrom:onAnswer:;
	add: #WAComponent -> #confirm:onAnswer:;
	add: #WAComponent -> #inform:onAnswer:;
	add: #WAComponent -> #request:default:onAnswer:;
	add: #WAComponent -> #request:label:default:onAnswer:;
	add: #WAComponent -> #request:label:onAnswer:;
	add: #WAComponent -> #request:onAnswer:;
	add: #WAComponent -> #validateWith:;
	add: 'GRPackage class' -> #seasideWidgets;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: '..\..\IDB\IDB DateAndTime';
	add: 'Seaside-Canvas';
	add: 'Seaside-Component';
	add: 'Seaside-Core';
	yourself).

package!

"Class Definitions"!

WANotification subclass: #WAValidationNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAReportColumn
	instanceVariableNames: 'clickBlock formatBlock hasTotal title sortBlock valueBlock cssClass'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFileLibrary subclass: #WANavigationFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAComponent subclass: #WACanvasWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WAAlphabeticBatchedList
	instanceVariableNames: 'items currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WABatchedList
	instanceVariableNames: 'items batchSize currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WABatchSelection
	instanceVariableNames: 'batcher linkSelector textSelector'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WADateSelector
	instanceVariableNames: 'day month year startYear endYear'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WADateTable
	instanceVariableNames: 'rows startDate endDate datesCache'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WADateTimeSelector
	instanceVariableNames: 'dateSelector timeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WAFormDialog
	instanceVariableNames: 'validationError form'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WAInputDialog
	instanceVariableNames: 'label value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WAMiniCalendar
	instanceVariableNames: 'monthIndex year date canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WANavigation
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WANavigationBar
	instanceVariableNames: 'actionsSelector owner'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WAPath
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WASelection
	instanceVariableNames: 'items labelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WATableReport
	instanceVariableNames: 'sortColumn isReversed columns rowPeriod rowColors rows'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WATimeSelector
	instanceVariableNames: 'second hour minute startHour endHour'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WATrail
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACanvasWidget subclass: #WATree
	instanceVariableNames: 'root selected expanded childrenBlock labelBlock canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WADateTable subclass: #WASelectionDateTable
	instanceVariableNames: 'cellBlock dateSelectionStart dateSelectionEnd rowSelectionStart rowSelectionEnd'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFormDialog subclass: #WAChoiceDialog
	instanceVariableNames: 'options selection'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFormDialog subclass: #WALabelledFormDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFormDialog subclass: #WAYesOrNoDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WANavigation subclass: #WASimpleNavigation
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WADecoration subclass: #WAWidgetDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAWidgetDecoration subclass: #WADelayedAnswerDecoration
	instanceVariableNames: 'delay'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAWidgetDecoration subclass: #WAFormDecoration
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAWidgetDecoration subclass: #WAMessageDecoration
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAWidgetDecoration subclass: #WAValidationDecoration
	instanceVariableNames: 'message validationBlock exceptionClass'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAWidgetDecoration subclass: #WAWindowDecoration
	instanceVariableNames: 'title cssClass'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

seasideWidgets
	^ self new
		name: 'Seaside-Widgets';
		description: 'Various sample Decorations and Components that require Canvas.';
		addDependency: 'Seaside-Canvas';
		addDependency: 'Seaside-Component';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideWidgets!*seaside-widgets!public! !

!WAComponent methodsFor!

addMessage: aString
	"Add a decoration that displays a level 3 heading with aString around the receiver. Answer the decoration, so don't forget #yourself."
	
	^ self addDecoration: (WAMessageDecoration new message: aString; yourself)!

chooseFrom: aCollection caption: aString onAnswer: aBlock
	"Choose an item from the given aCollection with caption aString. Evaluate aBlock with the selected item."
	
	self chooseFrom: aCollection default: nil caption: aString onAnswer: aBlock!

chooseFrom: aCollection default: anObject caption: aString onAnswer: aBlock
	"Choose an item from the given aCollection, the default anObject and the caption aString. Evaluate aBlock with the selected item."
	
	self 
		call: (WAChoiceDialog new
			addMessage: aString;
			options: aCollection;
			selection: anObject;
			yourself)
		onAnswer: aBlock!

chooseFrom: aCollection default: anObject onAnswer: aBlock
	"Choose an item from the given aCollection and the default anObject. Evaluate aBlock with the selected item."
	
	self chooseFrom: aCollection default: anObject caption: nil onAnswer: aBlock!

chooseFrom: aCollection onAnswer: aBlock
	"Choose an item from the given aCollection. Evaluate aBlock with the selected item."

	self chooseFrom: aCollection default: nil caption: nil onAnswer: aBlock!

confirm: aString onAnswer: aBlock
	"Display a yes/no dialog with caption aString. Evaluate aBlock passing in true if the response is yes, false if no."

	self
		call: (WAYesOrNoDialog new
			addMessage: aString;
			yourself)
		onAnswer: aBlock!

inform: aString	onAnswer: aBlock	
	"Display a dialog with aString to the user until he clicks the ok button. Continue by evaluating aBlock."

	self 
		call: (WAFormDialog new
			addMessage: aString;
			yourself)
		onAnswer: aBlock!

request: aRequestString default: aDefaultString onAnswer: aBlock
	"Display an input dialog with the question aRequestString and the default string aDefaultString. Passes the answer into aBlock."

	self request: aRequestString label: nil default: aDefaultString onAnswer: aBlock!

request: aRequestString label: aLabelString default: aDefaultString onAnswer: aBlock
	"Display an input dialog with the question aRequestString, the button label aLabelString and the default string aDefaultString. Passes the answer into aBlock."
	
	self
		call: (WAInputDialog new
			addMessage: aRequestString;
			default: aDefaultString;
			label: aLabelString;
			yourself)
		onAnswer: aBlock!

request: aRequestString label: aLabelString onAnswer: aBlock
	"Display an input dialog with the question aRequestString and the button label aLabelString. Passes the answer into aBlock."

	self request: aRequestString label: aLabelString default: nil onAnswer: aBlock!

request: aString onAnswer: aBlock
	"Display an input dialog with the question aRequestString. Passes the answer into aBlock."

	self request: aString default: nil onAnswer: aBlock!

validateWith: aBlock
	^ self addDecoration: (WAValidationDecoration new validateWith: aBlock)! !
!WAComponent categoriesFor: #addMessage:!*seaside-widgets-decorations!public! !
!WAComponent categoriesFor: #chooseFrom:caption:onAnswer:!*seaside-widgets-dialogs!public! !
!WAComponent categoriesFor: #chooseFrom:default:caption:onAnswer:!*seaside-widgets-dialogs!public! !
!WAComponent categoriesFor: #chooseFrom:default:onAnswer:!*seaside-widgets-dialogs!public! !
!WAComponent categoriesFor: #chooseFrom:onAnswer:!*seaside-widgets-dialogs!public! !
!WAComponent categoriesFor: #confirm:onAnswer:!*seaside-widgets-dialogs!public! !
!WAComponent categoriesFor: #inform:onAnswer:!*seaside-widgets-dialogs!public! !
!WAComponent categoriesFor: #request:default:onAnswer:!*seaside-widgets-dialogs!public! !
!WAComponent categoriesFor: #request:label:default:onAnswer:!*seaside-widgets-dialogs!public! !
!WAComponent categoriesFor: #request:label:onAnswer:!*seaside-widgets-dialogs!public! !
!WAComponent categoriesFor: #request:onAnswer:!*seaside-widgets-dialogs!public! !
!WAComponent categoriesFor: #validateWith:!*seaside-widgets-decorations!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

WAValidationNotification guid: (GUID fromString: '{5D4F2435-4BCA-4567-8B52-52D21B66A689}')!
WAValidationNotification comment: 'I am signaled to indicate that a validation has occurred.  See: Object>>validationError:, WAComponent>>validateWith: and WAValidationDecoration.'!
!WAValidationNotification categoriesForClass!Unclassified! !
WAReportColumn guid: (GUID fromString: '{C1719D07-419F-4E14-BC7C-DB6A1AD38468}')!
WAReportColumn comment: '
WAReportColumn displays a column, one cell at a time, of a WAReportTable. Columns can be sorted, have a title, can have a total, and its element can be links. The valueBlock obtains the output (an object) to display for each row from the row''s object.  The formatBlock is used to convert the valueBlock output to a string. If you need html markup to display the result, use the two argument form of valueBlock. However, columns with two argument valueBlock can not be sorted. See class methods for shortcut methods for setting the value block. 

For more information see:
	WATableReport

Instance Variables:
	clickBlock	<BlockClosure [:rowObject | ]>	When clickBlock is set items in column will be anchors. clickBlock is called with the selected object when anchor is clicked on. Typically clickBlock calls a component which generates a new page.
	formatBlock	<BlockClosure [:object | ]>	Should convert the result of the one-argument valueBlock to the string to be displayed. If formatBlock is nil then  "displayString" is sent to the result of valueBlock for the display string for this column.  
	hasTotal	<Boolean>	If true the column will display the sum of all elements in the column, sum is displayed in the last row.
	sortBlock	<BlockClosure [:a :b | ]>	Used to sort the element in the column. Arguments are the value from the one argument valueBlock
	title	<String>	Column header 
	valueBlock	<BlockClosure [:rowObject | ] or [:rowObject :aWARenderCanvas |] >	
		[:rowObject | ] this form results in an object that is to be displayed in a column cell, argument is the object for a given row (see WATableReport)
		[:rowObject :aWARenderCanvas |] this form is to render the value for a column cell from rowObject directly on aWRenderCanvas
cssClass
	title <String> CSS class
	the CSS class assigned to the <td>-tag in this column 

'!
!WAReportColumn categoriesForClass!Unclassified! !
!WAReportColumn methodsFor!

canChoose
	^ clickBlock notNil!

canRender
	^valueBlock argumentCount > 1!

canSort
	^self canRender not and: [sortBlock notNil]!

chooseRow: row
	^ clickBlock value: row!

clickBlock: aBlock
	clickBlock := aBlock!

columnClickBlock: aBlock
	self clickBlock: [:r | aBlock value: (self valueForRow: r)]!

cssClass
	^ cssClass!

cssClass: aString
	cssClass := aString!

formatBlock: anObject
	formatBlock := anObject!

hasTotal: aBoolean
	hasTotal := aBoolean!

index: aNumber
	valueBlock := [:row | row at: aNumber]!

initialize
	super initialize.
	formatBlock := [ :x | x greaseString ].
	sortBlock := [ :a :b | a <= b ].
	valueBlock := [ :row | nil ].
	clickBlock := nil.
	title := 'Untitled'.
	hasTotal := false!

renderValue: anObject on: html
	valueBlock value: anObject value: html!

selector: aSymbol
	valueBlock := [:row | row perform: aSymbol]!

sortBlock: anObject
	sortBlock := anObject!

sortRows: anArray
	|assocs|
	assocs := anArray collect: [:ea | ea -> (self valueForRow: ea)].
	assocs := assocs asSortedCollection: [:a :b | sortBlock value: a value value: b value].
	^ assocs collect: [:ea | ea key]!

textForRow: row
	^ formatBlock value: (self valueForRow: row)!

title
	^title!

title: aString
	title := aString!

totalForRows: aCollection
	^ hasTotal
		ifFalse: ['']
		ifTrue: [ formatBlock value: (aCollection inject: 0 into: [:sum :r | sum + (self valueForRow: r)])]!

valueBlock: aBlock
	valueBlock := aBlock!

valueForRow: row
	^ valueBlock value: row! !
!WAReportColumn categoriesFor: #canChoose!public! !
!WAReportColumn categoriesFor: #canRender!public!rendering! !
!WAReportColumn categoriesFor: #canSort!public! !
!WAReportColumn categoriesFor: #chooseRow:!public! !
!WAReportColumn categoriesFor: #clickBlock:!accessing!public! !
!WAReportColumn categoriesFor: #columnClickBlock:!accessing!public! !
!WAReportColumn categoriesFor: #cssClass!accessing!public! !
!WAReportColumn categoriesFor: #cssClass:!accessing!public! !
!WAReportColumn categoriesFor: #formatBlock:!accessing!public! !
!WAReportColumn categoriesFor: #hasTotal:!accessing!public! !
!WAReportColumn categoriesFor: #index:!accessing!public! !
!WAReportColumn categoriesFor: #initialize!initialization!public! !
!WAReportColumn categoriesFor: #renderValue:on:!public!rendering! !
!WAReportColumn categoriesFor: #selector:!accessing!public! !
!WAReportColumn categoriesFor: #sortBlock:!accessing!public! !
!WAReportColumn categoriesFor: #sortRows:!public! !
!WAReportColumn categoriesFor: #textForRow:!public! !
!WAReportColumn categoriesFor: #title!public! !
!WAReportColumn categoriesFor: #title:!accessing!public! !
!WAReportColumn categoriesFor: #totalForRows:!public! !
!WAReportColumn categoriesFor: #valueBlock:!accessing!public! !
!WAReportColumn categoriesFor: #valueForRow:!public! !

!WAReportColumn class methodsFor!

renderBlock: aBlock title: aString
	^ self new
		title: aString;
		valueBlock: aBlock;
		yourself!

selector: aSymbol
	^ self selector: aSymbol title: aSymbol capitalized!

selector: aSymbol title: aString
	^ self selector: aSymbol title: aString onClick: nil!

selector: aSymbol title: aString onClick: aBlock
	^ self new
		title: aString;
		selector: aSymbol;
		clickBlock: aBlock;
		yourself! !
!WAReportColumn class categoriesFor: #renderBlock:title:!instance creation!public! !
!WAReportColumn class categoriesFor: #selector:!instance creation!public! !
!WAReportColumn class categoriesFor: #selector:title:!instance creation!public! !
!WAReportColumn class categoriesFor: #selector:title:onClick:!instance creation!public! !

WANavigationFiles guid: (GUID fromString: '{46A052D4-39D1-4837-9F7B-F6B3D4D82303}')!
WANavigationFiles comment: 'Provides CSS to render WANavigation using tabs.'!
!WANavigationFiles categoriesForClass!Unclassified! !
!WANavigationFiles methodsFor!

mainCss
	^' /* this is from http://kalsey.com/tools/csstabs/ - would also be nice to do http://www.alistapart.com/articles/slidingdoors/ */
.kalsey .navigation-options {
	border-bottom : 1px solid #ccc;
	margin : 0;
	padding-bottom : 19px;
	padding-left : 10px;
}

.kalsey .navigation-options ul, .kalsey .navigation-options li	{
	display : inline;
	list-style-type : none;
	margin : 0;
	padding : 0;
}


.kalsey .navigation-options a:link, .kalsey .navigation-options a:visited	{
	background : #E8EBF0;
	border : 1px solid #ccc;
	color : #666;
	float : left;
	font-size : small;
	font-weight : normal;
	line-height : 14px;
	margin-right : 8px;
	padding : 2px 10px 2px 10px;
	text-decoration : none;
}

.kalsey .navigation-options a:link.active, .kalsey .navigation-options a:visited.active	{
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-options ul a:hover	{
	color : #f00;
}

.kalsey .navigation-options .option-selected a {
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-content {
	background : #fff;
	border : 1px solid #ccc;
	border-top : none;
	clear : both;
	margin : 0px;
	padding : 15px;
	line-height: 1.1;  /* IE6 CSS workaround - http://www.dracos.co.uk/web/css/ie6floatbug/ */
}

/* customization */
.kalsey .navigation-content tbody tr th, .kalsey .navigation-content tfoot tr th {
	text-align: right;
	vertical-align: top;
}

.kalsey .navigation-content h2 {
	font-size: 1.2em;
}

.kalsey .navigation-content tbody.right tr td, .kalsey .navigation-content tfoot.right tr td {
	text-align: right;
}

'!

selectorsToInclude
	^#(mainCss)! !
!WANavigationFiles categoriesFor: #mainCss!public!styles! !
!WANavigationFiles categoriesFor: #selectorsToInclude!accessing!public! !

WACanvasWidget guid: (GUID fromString: '{CF0713F4-03C9-4171-BEED-78522DB9789F}')!
WACanvasWidget comment: 'A common superclass for all widgets that want to use WARenderCanvas as their renderer.'!
!WACanvasWidget categoriesForClass!Unclassified! !
!WACanvasWidget methodsFor!

rendererClass
	"Make sure we use WARenderCanvas even if a different renderer is default."
	^ WARenderCanvas! !
!WACanvasWidget categoriesFor: #rendererClass!public!rendering! !

WAAlphabeticBatchedList guid: (GUID fromString: '{A7D19628-C723-43F7-9592-052309AD0ADF}')!
WAAlphabeticBatchedList comment: '
WAAlphabeticBatchedList organizes a collection of items into pages for display. A page contains all items whose string representation (item displayString) starts with the same character. WAAlphabeticBatchedList only displays the navigation (alphabet with links) for the list. Your code needs to display the current page.

Use WAAlphabeticBatchedList>>items: to set the collections of items.
Use WAAlphabeticBatchedList>>batch to get the items to display on the current page

See WABatchTest for example of usage.
Select "Batch" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	currentPage	<Character>	the character of the curent page
	items	<(Collection of: (Object ))> collection of the items managed by WAAlphabeticBatchedList. Collection is sorted before items are displayed.
'!
!WAAlphabeticBatchedList categoriesForClass!Unclassified! !
!WAAlphabeticBatchedList methodsFor!

allPages
	^ 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'!

batch
	^ items select: [ :each | each greaseString asUppercase first = self currentPage ]!

currentPage
	^ currentPage ifNil: [currentPage := self validPages first]!

currentPage: aCharacter
	currentPage := aCharacter!

isOnFirstPage
	^ self validPages first = self currentPage!

isOnLastPage
	^ self validPages last = self currentPage!

items
	^ items!

items: aCollection
	items := aCollection!

nextPage
	self isOnLastPage ifFalse: [currentPage := self validPages after: currentPage]!

previousPage
	self isOnFirstPage ifFalse: [currentPage := self validPages before: currentPage]!

renderContentOn: html
	items isEmpty
		ifTrue: [ ^ self ].
	html div
		class: 'batch';
		with: [
			self renderPreviousOn: html.
			self renderPagesOn: html.
			self renderNextOn: html ]!

renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchor callback: [ self nextPage ]; with: '>>' ]
		ifTrue: [ html text: '>>' ]!

renderPagesOn: html
	self allPages
		do: [ :char |
			currentPage = char
				ifFalse: [
					(self validPages includes: char)
						ifTrue: [ html anchor callback: [self currentPage: char]; with: char]
						ifFalse: [ html text: char ] ]
				ifTrue: [ html strong: char ] ]
		separatedBy: [ html space ]!

renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchor callback: [ self previousPage ]; with: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space!

states
	^ Array with: self!

validPages
	^ (items collect: [ :each | each greaseString asUppercase first ]) asSet sorted! !
!WAAlphabeticBatchedList categoriesFor: #allPages!accessing-calculated!public! !
!WAAlphabeticBatchedList categoriesFor: #batch!accessing-calculated!public! !
!WAAlphabeticBatchedList categoriesFor: #currentPage!accessing!public! !
!WAAlphabeticBatchedList categoriesFor: #currentPage:!accessing!public! !
!WAAlphabeticBatchedList categoriesFor: #isOnFirstPage!public!testing! !
!WAAlphabeticBatchedList categoriesFor: #isOnLastPage!public!testing! !
!WAAlphabeticBatchedList categoriesFor: #items!accessing!public! !
!WAAlphabeticBatchedList categoriesFor: #items:!accessing!public! !
!WAAlphabeticBatchedList categoriesFor: #nextPage!actions!public! !
!WAAlphabeticBatchedList categoriesFor: #previousPage!actions!public! !
!WAAlphabeticBatchedList categoriesFor: #renderContentOn:!public!rendering! !
!WAAlphabeticBatchedList categoriesFor: #renderNextOn:!public!rendering! !
!WAAlphabeticBatchedList categoriesFor: #renderPagesOn:!public!rendering! !
!WAAlphabeticBatchedList categoriesFor: #renderPreviousOn:!public!rendering! !
!WAAlphabeticBatchedList categoriesFor: #states!accessing!public! !
!WAAlphabeticBatchedList categoriesFor: #validPages!accessing-calculated!public! !

WABatchedList guid: (GUID fromString: '{82B715B1-A16C-4444-B893-4E2689110E6D}')!
WABatchedList comment: '
WABatchedList helps display a collection of items across multiple pages. WABatchedList organizes a collection into pages (or batches) of batchSize items each and renders navigation links for a user to moved between pages. WABatchedList>>batch returns the items to display in the current page or batch. Your code has to display the items.

See WABatchSelection for example of usage.

Instance Variables:
	batchSize	<Integer>	number of items to display on a single page
	currentPage	<Integer>	 index of current page, starts a 1
	items	<SequenceableCollection of Objects>	objects organized into pages for display

'!
!WABatchedList categoriesForClass!Unclassified! !
!WABatchedList methodsFor!

batch
	^ self items copyFrom: self startIndex to: self endIndex!

batchSize
	^ batchSize!

batchSize: aNumber
	batchSize := aNumber!

currentPage
	^ currentPage!

currentPage: aNumber
	currentPage := aNumber!

endIndex
	^ self currentPage * self batchSize min: self items size!

initialize
	super initialize.
	self batchSize: 10.
	self currentPage: 1!

isOnFirstPage
	^ self currentPage = 1!

isOnLastPage
	^ self currentPage = self maxPages!

items
	^ items!

items: aCollection
	items := aCollection!

maxPages
	^ (self items size / self batchSize) ceiling!

nextPage
	self isOnLastPage ifFalse: [self currentPage: self currentPage + 1]!

pageRange
	^ self pageRangeStart to: self pageRangeEnd!

pageRangeEnd
	^ self maxPages min: self currentPage + 9!

pageRangeStart
	^ 1 max: self currentPage - 9!

previousPage
	self isOnFirstPage ifFalse: [self currentPage: self currentPage - 1]!

renderContentOn: html
	self maxPages = 0
		ifTrue: [ ^ self ].
	html div
		class: 'batch';
		with: [
			self renderPreviousOn: html.
			self renderPagesOn: html.
			self renderNextOn: html ]!

renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchor callback: [ self nextPage ]; with: '>>' ]
		ifTrue: [ html text: '>>' ]!

renderPagesOn: html
	self pageRange
		do: [ :index |
			self currentPage = index
				ifFalse: [html anchor callback: [self currentPage: index]; with: index]
				ifTrue: [html strong: index ] ]
		separatedBy: [ html space ]!

renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchor callback: [ self previousPage ]; with: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space!

startIndex
	^ (self currentPage - 1) * self batchSize + 1!

states
	^ Array with: self! !
!WABatchedList categoriesFor: #batch!accessing-calculated!public! !
!WABatchedList categoriesFor: #batchSize!accessing!public! !
!WABatchedList categoriesFor: #batchSize:!accessing!public! !
!WABatchedList categoriesFor: #currentPage!accessing!public! !
!WABatchedList categoriesFor: #currentPage:!accessing!public! !
!WABatchedList categoriesFor: #endIndex!accessing-calculated!public! !
!WABatchedList categoriesFor: #initialize!initialization!public! !
!WABatchedList categoriesFor: #isOnFirstPage!public!testing! !
!WABatchedList categoriesFor: #isOnLastPage!public!testing! !
!WABatchedList categoriesFor: #items!accessing!public! !
!WABatchedList categoriesFor: #items:!accessing!public! !
!WABatchedList categoriesFor: #maxPages!accessing-calculated!public! !
!WABatchedList categoriesFor: #nextPage!actions!public! !
!WABatchedList categoriesFor: #pageRange!accessing-calculated!public! !
!WABatchedList categoriesFor: #pageRangeEnd!accessing-calculated!public! !
!WABatchedList categoriesFor: #pageRangeStart!accessing-calculated!public! !
!WABatchedList categoriesFor: #previousPage!actions!public! !
!WABatchedList categoriesFor: #renderContentOn:!public!rendering! !
!WABatchedList categoriesFor: #renderNextOn:!public!rendering! !
!WABatchedList categoriesFor: #renderPagesOn:!public!rendering! !
!WABatchedList categoriesFor: #renderPreviousOn:!public!rendering! !
!WABatchedList categoriesFor: #startIndex!accessing-calculated!public! !
!WABatchedList categoriesFor: #states!accessing!public! !

!WABatchedList class methodsFor!

example
	^self new
		items: (1 to: 100);
		yourself! !
!WABatchedList class categoriesFor: #example!accessing!public! !

WABatchSelection guid: (GUID fromString: '{5BCF8682-6668-49B0-AD0E-2F39FC32EE7A}')!
WABatchSelection comment: '
WABatchSelection displays a list of objects. The list is show N (currently 8) items per page, with links to navigate to other pages if needed. Objects in the list must implement one method that returns text description of the item and one method that returns a name or label used as the link users click to select the item. The text description is displayed below the link.

Example
	items := OrderedCollection new.
	1 to: 20 do: [:each | items add: (Contact new name: each; phoneNumber: ''54321'';yourself)].
	selection := WABatchSelection items: items link: #name text: #phoneNumber.
	result := self call: selection.

	where the Contact class has methodsinstance vars "phoneNumber" and "name", with
	setter & getter methods.

Instance Variables:
	batcher	<WABatchedList>	description of batcher
	linkSelector	<Symbol>	method sent to items in list for link text
	textSelector	<Symbol>	method sent to items in list for text description

'!
!WABatchSelection categoriesForClass!Unclassified! !
!WABatchSelection methodsFor!

batchSize
    ^batcher batchSize!

batchSize: aSize
    batcher batchSize: aSize!

children
	^ Array with: batcher!

choose: anItem
	self answer: anItem!

items: aCollection
	batcher := WABatchedList new
		items: aCollection;
		batchSize: 8;
		yourself!

linkSelector: aSymbol
	linkSelector := aSymbol!

renderContentOn: html
	html unorderedList: [
		batcher batch do: [ :each |
			html anchor
				callback: [ self choose: each ];
				with: (each perform: linkSelector).
			html break.
			html text: (each perform: textSelector).
			html paragraph ] ].
	html div
		style: 'text-align: center';
		with: batcher!

textSelector: aSymbol
	textSelector := aSymbol! !
!WABatchSelection categoriesFor: #batchSize!accessing!public! !
!WABatchSelection categoriesFor: #batchSize:!accessing!public! !
!WABatchSelection categoriesFor: #children!accessing!public! !
!WABatchSelection categoriesFor: #choose:!commands!public! !
!WABatchSelection categoriesFor: #items:!accessing!public! !
!WABatchSelection categoriesFor: #linkSelector:!accessing!public! !
!WABatchSelection categoriesFor: #renderContentOn:!public!rendering! !
!WABatchSelection categoriesFor: #textSelector:!accessing!public! !

!WABatchSelection class methodsFor!

items: aCollection link: linkSelector text: textSelector
	^ self new
		items: aCollection;
		linkSelector: linkSelector;
		textSelector: textSelector;
		yourself! !
!WABatchSelection class categoriesFor: #items:link:text:!instance creation!public! !

WADateSelector guid: (GUID fromString: '{674FE991-E46A-4178-B72D-E81FE1791FCC}')!
WADateSelector comment: '
WADateSelector displays dropdown menus (html select) allowing a user to delect a date within a range. "startYear" and "endYear" define the range of selectable dates. Date displayed in month, day, year format. WADateSelector>>date returns date user selected as a Date object.

See WADateSelectorTest for sample of usage.
Select "Date Selector" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	day	<Integer 1-31> selected day
	endYear	<Integer>	end of range of dates user is allowed to select, not required to use 4 digits
	month	<Integer 1-12>	selected month
	startYear	<Integer>	 start of range of dates user is allowed to select, not required to use 4 digits
	year	<Integer>	selected year

'!
!WADateSelector categoriesForClass!Unclassified! !
!WADateSelector methodsFor!

date
	(self privateIsValidDay: day monthNumber: month year: year)
		ifFalse: [self error: 'Invalid date'].
	^ self dateClass year: year month: month day: day!

date: aDate
	day := aDate dayOfMonth.
	month := aDate monthIndex.
	year := aDate year!

dateClass
	^ Date!

dateIsValid
	[self date] on: Error do: [:e | ^ false].
	^ true!

day
	^day!

day: anObject
	^day := anObject!

days
	^ 1 to: 31!

endYear
	^ endYear!

endYear: anInteger
	endYear := anInteger!

initialize
	super initialize.
	startYear := Date today year - 1.
	endYear := Date today year + 5.
	self date: self dateClass today!

labelForDay: aNumber
	^ aNumber!

labelForMonth: aNumber
	^ Date nameOfMonth: aNumber!

labelForYear: aNumber
	^ aNumber!

month
	^month!

month: anObject
	^month := anObject!

months
	^ 1 to: 12!

privateIsValidDay: theDay monthNumber: theMonth year: theYear
	| daysInMonth |
	(theMonth between: 1 and: 12) ifFalse: [^false].
	daysInMonth := Date daysInMonth: (Date nameOfMonth: theMonth) forYear: theYear.
	^(theDay between: 1 and: daysInMonth)!

renderContentOn: html
	html select
		list: self months;
		on: #month of: self;
		labels: [ :each | self labelForMonth: each ].

	html select
		list: self days;
		on: #day of: self;
		labels: [ :each | self labelForDay: each ].

	html select
		list: self yearRange;
		on: #year of: self;
		labels: [ :each | self labelForYear: each ].

	self dateIsValid ifFalse: [self renderValidationErrorOn: html]!

renderValidationErrorOn: html
	html span
		class: 'error';
		with: 'invalid date'!

startYear
	^ startYear!

startYear: anInteger
	startYear := anInteger!

year
	^year!

year: anObject
	^year := anObject!

yearRange
	^ self startYear to: self endYear! !
!WADateSelector categoriesFor: #date!accessing!public! !
!WADateSelector categoriesFor: #date:!accessing!public! !
!WADateSelector categoriesFor: #dateClass!private! !
!WADateSelector categoriesFor: #dateIsValid!public!testing! !
!WADateSelector categoriesFor: #day!accessing!public! !
!WADateSelector categoriesFor: #day:!accessing!public! !
!WADateSelector categoriesFor: #days!accessing!public! !
!WADateSelector categoriesFor: #endYear!accessing!public! !
!WADateSelector categoriesFor: #endYear:!accessing!public! !
!WADateSelector categoriesFor: #initialize!initialization!public! !
!WADateSelector categoriesFor: #labelForDay:!accessing!public! !
!WADateSelector categoriesFor: #labelForMonth:!accessing!public! !
!WADateSelector categoriesFor: #labelForYear:!accessing!public! !
!WADateSelector categoriesFor: #month!accessing!public! !
!WADateSelector categoriesFor: #month:!accessing!public! !
!WADateSelector categoriesFor: #months!accessing!public! !
!WADateSelector categoriesFor: #privateIsValidDay:monthNumber:year:!private! !
!WADateSelector categoriesFor: #renderContentOn:!public!rendering! !
!WADateSelector categoriesFor: #renderValidationErrorOn:!public!rendering! !
!WADateSelector categoriesFor: #startYear!accessing!public! !
!WADateSelector categoriesFor: #startYear:!accessing!public! !
!WADateSelector categoriesFor: #year!accessing!public! !
!WADateSelector categoriesFor: #year:!accessing!public! !
!WADateSelector categoriesFor: #yearRange!accessing!public! !

WADateTable guid: (GUID fromString: '{0F992ACD-59E0-4D41-9EB9-3AC407B6DA03}')!
WADateTable comment: '
WADateTable renders a table containing dates from startDate to endDate. The table contains one column for each date from startDate to endDate. The top row of the table groups columns by month and labels each month (January 2008). The second row contains the date of each month (1-31) in the date range. The table also contains "rows size" rows. The first column of these rows contains the contents of the instance variable "rows". Rest of the cells are empty.

Basically this is an abstract superclass for WASelectionDateTable

Instance Variables:
	datesCache	<(SequenceableCollection of: Date>	contains a date object for each date in the range startDate-endDate
	endDate	<Date>	end date of the range displayed in the table
	rows	<SequenceableCollection>	labels of the rows
	startDate	<Date>	start date of the range displayed in the table

'!
!WADateTable categoriesForClass!Unclassified! !
!WADateTable methodsFor!

datesDo: aBlock separatedBy: monthlyBlock
	| month |
	month := datesCache first monthIndex.
	datesCache do: [ :date |
		date monthIndex = month ifFalse: [month := date monthIndex. monthlyBlock value].
		aBlock value: date ].
	monthlyBlock value!

endDate: aDate
	endDate := aDate.
	self updateDatesCache!

monthsAndLengthsDo: aTwoArgumentBlock
	| count last |
	count := 0.
	last := nil.
	self
		datesDo: [ :each |
			count := count + 1.
			last := each ]
		separatedBy: [
			aTwoArgumentBlock value: last month value: count.
			count := 0 ]!

renderCellForDate: aDate row: anObject index: aNumber on: html
	html tableData: [html space]!

renderContentOn: html
	html table
		class: 'DateTable';
		border: 1;
		with: [
			html tableRow: [
				self renderMonthHeadingsOn: html ].
			html tableRow: [
				self renderDayHeadingsOn: html ].
			rows keysAndValuesDo: [ :index :each | 
				html tableRow: [
					self
						renderRow: each
						index: index
						on: html ] ] ]!

renderDayHeadingsOn: html
	self renderHeadingSpacerOn: html.
	self
		datesDo: [:date |
			html tableHeading
				class: 'DayHeading';
				with: date dayOfMonth ]
		separatedBy: [ self renderHeadingSpacerOn: html ]!

renderHeadingForRow: anObject on: html
	html tableHeading
		class: 'RowHeading';
		with: anObject!

renderHeadingSpacerOn: html
	html tableData: ''!

renderMonthHeadingsOn: html
	self monthsAndLengthsDo: [ :month :length |
		self renderHeadingSpacerOn: html.
		html tableHeading
			colSpan: length;
			class: 'MonthHeading';
			with: [
				html text: month name.
				html space.
				html text: month year ] ]!

renderRow: anObject index: aNumber on: html
	self renderHeadingForRow: anObject on: html.
	self
		datesDo: [ :date | self renderCellForDate: date row: anObject index: aNumber on: html]
		separatedBy: [ self renderHeadingSpacerOn: html ]!

rows: aCollection
	rows := aCollection!

startDate: aDate
	startDate := aDate.
	self updateDatesCache!

updateDatesCache
	| date |
	(startDate isNil or: [endDate isNil]) ifTrue: [^ self].

	datesCache := OrderedCollection new.
	date := startDate.
	[date > endDate] whileFalse:
		[datesCache add: date.
		date := date next]! !
!WADateTable categoriesFor: #datesDo:separatedBy:!enumerating!public! !
!WADateTable categoriesFor: #endDate:!accessing!public! !
!WADateTable categoriesFor: #monthsAndLengthsDo:!enumerating!public! !
!WADateTable categoriesFor: #renderCellForDate:row:index:on:!public!rendering! !
!WADateTable categoriesFor: #renderContentOn:!public!rendering! !
!WADateTable categoriesFor: #renderDayHeadingsOn:!public!rendering! !
!WADateTable categoriesFor: #renderHeadingForRow:on:!public!rendering! !
!WADateTable categoriesFor: #renderHeadingSpacerOn:!public!rendering! !
!WADateTable categoriesFor: #renderMonthHeadingsOn:!public!rendering! !
!WADateTable categoriesFor: #renderRow:index:on:!public!rendering! !
!WADateTable categoriesFor: #rows:!accessing!public! !
!WADateTable categoriesFor: #startDate:!accessing!public! !
!WADateTable categoriesFor: #updateDatesCache!actions!public! !

WADateTimeSelector guid: (GUID fromString: '{B48D66A1-B86D-47CD-987F-C3D95AE3C14F}')!
WADateTimeSelector comment: '
WADateTimeSelector allows the user to select a date and time in a given range dropdown menus (html select). Actual work done by WADateSelector and WATimeSelector. Date range is default range of WADateSelector.

See WADateSelectorTest for sample of usage.
Select "Date Selector" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	dateSelector	<WADateSelector>	presents date selection to user
	timeSelector	<WATimeSelector>	presents time selection to user

'!
!WADateTimeSelector categoriesForClass!Unclassified! !
!WADateTimeSelector methodsFor!

children

	^ Array with: dateSelector with: timeSelector!

dateAndTime

	^ DateAndTime date: dateSelector date time: timeSelector time!

dateAndTime: anObject

	dateSelector date: anObject asDate.
	timeSelector time: anObject asTime!

initialize
	super initialize.
	dateSelector := WADateSelector new.
	timeSelector := WATimeSelector new!

renderContentOn: html

	html span: dateSelector.
	html span: [html strong: ' : '].
	html span: timeSelector! !
!WADateTimeSelector categoriesFor: #children!accessing!public! !
!WADateTimeSelector categoriesFor: #dateAndTime!accessing!public! !
!WADateTimeSelector categoriesFor: #dateAndTime:!accessing!public! !
!WADateTimeSelector categoriesFor: #initialize!initialization!public! !
!WADateTimeSelector categoriesFor: #renderContentOn:!public!rendering! !

WAFormDialog guid: (GUID fromString: '{9F0654C4-7A59-40EC-83A0-A484F0A01A9C}')!
WAFormDialog comment: '
WAFormDialog is an empty html form. Used in WAComponent>>inform: to create a dialog component that displays text and an "Ok" button to close the component. See subclasses for sample usage & more functionality.

Instance Variables:
	form	<WAFormDecoration> Decorator that generates form tags
	validationError	<String>	Text descriping invalid data entered by user. Displayed when not nil. Set to nil when user submits form.
'!
!WAFormDialog categoriesForClass!Unclassified! !
!WAFormDialog methodsFor!

addForm
	form := WAFormDecoration new buttons: self buttons.
	self addDecoration: form!

addFormByDefault
	^ true!

buttons
	^ #(ok)!

defaultButton
	^self buttons first!

divClass
	^ self class name!

initialize
	super initialize.
	self addFormByDefault ifTrue: [self addForm]!

isValid
	^ validationError isNil!

model
	^ self!

ok
	self answer!

removeForm
	form isNil
		ifFalse: [ self removeDecoration: form ]!

renderContentOn: html
	html hiddenInput 
		callback: [ validationError := nil ].
	validationError isNil
		ifFalse: [ self renderValidationError: validationError on: html ].
	html div
		class: self divClass;
		with: [ self renderDialogOn: html ]!

renderDialogOn: html!

renderSpacerRowOn: html
	html div class: 'dialog-spacer'; with: [ html space ]!

renderValidationError: aString on: html
	html span class: 'dialog-validation'; with: aString!

validationError: aString
	validationError := aString! !
!WAFormDialog categoriesFor: #addForm!actions!public! !
!WAFormDialog categoriesFor: #addFormByDefault!public!testing! !
!WAFormDialog categoriesFor: #buttons!accessing!public! !
!WAFormDialog categoriesFor: #defaultButton!accessing!public! !
!WAFormDialog categoriesFor: #divClass!accessing!public! !
!WAFormDialog categoriesFor: #initialize!initialization!public! !
!WAFormDialog categoriesFor: #isValid!public!testing! !
!WAFormDialog categoriesFor: #model!accessing!public! !
!WAFormDialog categoriesFor: #ok!actions!public! !
!WAFormDialog categoriesFor: #removeForm!actions!public! !
!WAFormDialog categoriesFor: #renderContentOn:!public!rendering! !
!WAFormDialog categoriesFor: #renderDialogOn:!public!rendering! !
!WAFormDialog categoriesFor: #renderSpacerRowOn:!public!rendering! !
!WAFormDialog categoriesFor: #renderValidationError:on:!public!rendering! !
!WAFormDialog categoriesFor: #validationError:!public!validation! !

WAInputDialog guid: (GUID fromString: '{CF429FC1-46F1-45B5-BB9A-BA9B6002ED29}')!
WAInputDialog comment: '
WAInputDialog generates a simple form with a text input field and a submit button. The instance variable "value" is used for initial value of the text field and hold the text entered by user. WAInputDialog answers with text entered by user (value of "value"). See WAComponent>>request:label:default: for sample use and easy way to use WAInputDialog.

Instance Variables:
	label	<String>	label of submit button
	value	<Object | String>	
'!
!WAInputDialog categoriesForClass!Unclassified! !
!WAInputDialog methodsFor!

default: aString
	value := aString!

label
	^label ifNil: [ label := 'OK' ]!

label: aString
	label := aString!

renderContentOn: html
	html form
		defaultAction: [ self answer: value ];
		with: [
			html div: [
				html textInput on: #value of: self.
				html space.
				html submitButton
					callback: [ self answer: value ];
					text: self label ] ]!

value
	^value!

value: aString
	value := aString! !
!WAInputDialog categoriesFor: #default:!accessing!public! !
!WAInputDialog categoriesFor: #label!accessing!public! !
!WAInputDialog categoriesFor: #label:!accessing!public! !
!WAInputDialog categoriesFor: #renderContentOn:!public!rendering! !
!WAInputDialog categoriesFor: #value!accessing!public! !
!WAInputDialog categoriesFor: #value:!accessing!public! !

WAMiniCalendar guid: (GUID fromString: '{ED6B1FEF-7856-4D97-9F76-F667DA3A26E7}')!
WAMiniCalendar comment: '
WAMiniCalendar renders a monthly calendar. Users can navigate by month, year, or select a year and a month. Users can select a date in the calendar. Set canSelectBlock to control which dates a user can select. Use selectBlock to perform an action when a user selects a date. WAMiniCalendar>>date returns the selected date.

Select "Mini Calendar" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	canSelectBlock		<BlockClosure with date argument>	return true if date argument should be rendered with a link, ie user can select that date
	date		<WAValueHolder on a date>	Selected date
	monthIndex		<WAValueHolder on an Integer>	Currently displayed month
	year		<WAValueHolder on an Integer>	Currently displayed year
	selectBlock		<BlockClosure with date argument> called when user selects a date

'!
!WAMiniCalendar categoriesForClass!Unclassified! !
!WAMiniCalendar methodsFor!

canSelect: aDate
	^ canSelectBlock value: aDate!

canSelectBlock: aBlock
	canSelectBlock := aBlock!

date
	^ date contents!

date: aDate 
	date contents: aDate.
	monthIndex contents: aDate monthIndex.
	year contents: aDate year!

initialize
	super initialize.
	monthIndex := WAValueHolder with: Date today monthIndex.
	year := WAValueHolder with: Date today year.
	date := WAValueHolder new.
	canSelectBlock := [:value | true].
	selectBlock := [:value | self answer: value]!

monthHeading
	^ self monthName , ' ' , self year greaseString!

monthIndex
	^ monthIndex contents!

monthIndex: anInteger 
	monthIndex contents: anInteger!

monthName
	^ Date nameOfMonth: self monthIndex!

monthNames
	^ (1 to: 12)
		collect: [:each | Date nameOfMonth: each]!

nextMonth
	self monthIndex = 12
		ifTrue: [ self monthIndex: 1; year: self year + 1]
		ifFalse: [ self monthIndex: self monthIndex + 1 ]!

previousMonth
	self monthIndex = 1
		ifTrue: [ self monthIndex: 12; year: self year - 1]
		ifFalse: [ self monthIndex: self monthIndex - 1 ]
!

renderCellForDate: aDate on: html
	html tableData: [
		(aDate monthIndex = self monthIndex and: [ aDate year = self year ])
			ifTrue: [
				html span
					class: (self date = aDate ifTrue: [ 'calendarArchiveDate' ]);
					with: [
						(self canSelect: aDate) 
							ifTrue: [
								html anchor
									callback: [ self select: aDate ];
									with: aDate dayOfMonth ]
							ifFalse: [ html text: aDate dayOfMonth ] ] ] ]!

renderContentOn: html
	html div
		class: 'calendar';
		with: [
			html div
				class: 'calendarCaption';
				with: [ self renderMonthHeadingOn: html ].
			html table: [
				html tableRow
					class: 'calendarTitle';
					with: [
						self weekDays do: [ :each |
							html tableData: each ] ].
						self weeksDo: [ :week |
							self renderRowForWeek: week on: html ] ].
			self renderMonthNavigationOn: html.
			html
				space;
				space.
			self renderYearNavigationOn: html ]!

renderMonthHeadingOn: html
	html form: [
		html div: [
			html select
				list: (1 to: 12);
				on: #monthIndex of: self;
				labels: [ :index | Date nameOfMonth: index ].
			html textInput
				maxLength: 4;
				on: #year of: self.
			html submitButton text: 'Refresh' ] ]!

renderMonthNavigationOn: html
	| tab |
	tab := #(12 1 2 3 4 5 6 7 8 9 10 11 12 1).
	html span
		class: 'calendarPrevious';
		with: [
			html anchor
				callback: [ self previousMonth ];
				with: ((self monthNames at: (tab at: self monthIndex)) first: 3)].
	html space.
	html span
		class: 'calendarNext';
		with: [
			html anchor
				callback: [ self nextMonth ];
				with: ((self monthNames at: (tab at: self monthIndex + 2)) first: 3)].!

renderRowForWeek: initialDay on: html
	html tableRow: [
		0 to: 6 do: [ :each |
			self renderCellForDate: (initialDay addDays: each) on: html ] ]!

renderYearNavigationOn: html
	html span
		class: 'calendarPrevious';
		with: [
			html anchor
				callback: [ self year: self year - 1 ];
				with: self year - 1 ].
	html space.
	html span
		class: 'calendarNext';
		with: [
			html anchor
				callback: [ self year: self year + 1 ];
				with: self year + 1 ]!

select: aDate
	self date: aDate.
	selectBlock value: aDate!

selectBlock: aBlock
	selectBlock := aBlock!

states
	^Array with: date with: monthIndex with: year!

weekDays
	^ #(Sun Mon Tue Wed Thu Fri Sat)!

weeksDo: aBlock
	| day nextMonth |
	day := Date newDay: 1 month: (Date nameOfMonth: self monthIndex) year: self year.
	day := day subtractDays: (day dayOfWeek - 1).
	nextMonth := (self monthIndex \\ 12) + 1.
	[ day monthIndex = nextMonth ] whileFalse: [
		aBlock value: day.
		day := day addDays: 7 ]!

year
	^year contents!

year: anIntegerOrString 
	year contents: (anIntegerOrString greaseInteger ifNil: [ 1900 ])! !
!WAMiniCalendar categoriesFor: #canSelect:!public!testing! !
!WAMiniCalendar categoriesFor: #canSelectBlock:!accessing!public! !
!WAMiniCalendar categoriesFor: #date!accessing-delegated!public! !
!WAMiniCalendar categoriesFor: #date:!accessing-delegated!public! !
!WAMiniCalendar categoriesFor: #initialize!initialization!public! !
!WAMiniCalendar categoriesFor: #monthHeading!private! !
!WAMiniCalendar categoriesFor: #monthIndex!accessing-delegated!public! !
!WAMiniCalendar categoriesFor: #monthIndex:!accessing-delegated!public! !
!WAMiniCalendar categoriesFor: #monthName!private! !
!WAMiniCalendar categoriesFor: #monthNames!localization!public! !
!WAMiniCalendar categoriesFor: #nextMonth!action!public! !
!WAMiniCalendar categoriesFor: #previousMonth!action!public! !
!WAMiniCalendar categoriesFor: #renderCellForDate:on:!public!rendering! !
!WAMiniCalendar categoriesFor: #renderContentOn:!public!rendering! !
!WAMiniCalendar categoriesFor: #renderMonthHeadingOn:!public!rendering! !
!WAMiniCalendar categoriesFor: #renderMonthNavigationOn:!public!rendering! !
!WAMiniCalendar categoriesFor: #renderRowForWeek:on:!public!rendering! !
!WAMiniCalendar categoriesFor: #renderYearNavigationOn:!public!rendering! !
!WAMiniCalendar categoriesFor: #select:!action!public! !
!WAMiniCalendar categoriesFor: #selectBlock:!accessing!public! !
!WAMiniCalendar categoriesFor: #states!accessing!public! !
!WAMiniCalendar categoriesFor: #weekDays!private! !
!WAMiniCalendar categoriesFor: #weeksDo:!private! !
!WAMiniCalendar categoriesFor: #year!accessing-delegated!public! !
!WAMiniCalendar categoriesFor: #year:!accessing-delegated!public! !

!WAMiniCalendar class methodsFor!

canBeRoot
	^ true!

example
	^self new! !
!WAMiniCalendar class categoriesFor: #canBeRoot!public!testing! !
!WAMiniCalendar class categoriesFor: #example!accessing!public! !

WANavigation guid: (GUID fromString: '{04837CD6-5406-41AA-95CC-C08C1D3A2E92}')!
WANavigation comment: ''!
!WANavigation categoriesForClass!Unclassified! !
!WANavigation methodsFor!

initialize
	super initialize.
	selection := WAValueHolder new!

labelForOption: anObject 
	^ anObject greaseString!

options
	^ #()!

renderContentOn: html
	html div class: 'kalsey'; with: [
		html div
			class: 'navigation-options';
			with: [ self renderOptionsOn: html ].
		html div
			class: 'navigation-content';
			with: [ self renderSelectionOn: html ] ]!

renderOptionsOn: html
	html unorderedList
		list: self options;
		selected: self selection;
		callback: [ :value | self select: value ];
		labels: [ :each | self labelForOption: each ]!

renderSelectionOn: html!

select: anObject
	selection contents: anObject.
	self selectionChanged!

selection
	^ selection contents!

selectionChanged!

states
	^ Array with: selection! !
!WANavigation categoriesFor: #initialize!initialization!public! !
!WANavigation categoriesFor: #labelForOption:!public!query! !
!WANavigation categoriesFor: #options!accessing!public! !
!WANavigation categoriesFor: #renderContentOn:!public!rendering! !
!WANavigation categoriesFor: #renderOptionsOn:!public!rendering! !
!WANavigation categoriesFor: #renderSelectionOn:!public!rendering! !
!WANavigation categoriesFor: #select:!public!selection! !
!WANavigation categoriesFor: #selection!public!selection! !
!WANavigation categoriesFor: #selectionChanged!public!selection! !
!WANavigation categoriesFor: #states!public!selection! !

WANavigationBar guid: (GUID fromString: '{375596C4-CF8C-4DD7-B5D4-CE7B48F1EFA0}')!
WANavigationBar comment: '
WANavigationBar provides navigation links for a component, the WANavigationBar''s owner. WANavigationBar is vertical in that all items in the bar are rendered in a column. WANavigationBar''s owner typically is a top level component that renders a number of children components, including the WANavigationBar. When a user selects an item in the WANavigationBar a message is sent to the owner, so it can change.

The owner component needs to implement the method indicated by the instance variable "actionsSelector", the default value is "actions". This method returns a collections of symbols. The symbols become the list of items in the navigation bar. The first letter of the symbol is capitalized when displayed. If the symbol represents a 0-argument method it is rendered as a link. When the user clicks on the link the original symbol is send as a message to the owner component. If the symbol represents a 1-argument method it is rendered as a label followed by a text input box. The user has to know that they hit enter after filling the text box.

Instance Variables:
	actionsSelector	<ByteSymbol>	Symbol sent to owner to get a list of items to be listed in the navigation bar. Default value is "actions".
	owner	<WAComponent>	This is the navigation bar for the component "owner".'!
!WANavigationBar categoriesForClass!Unclassified! !
!WANavigationBar methodsFor!

actions
	^ self target perform: actionsSelector!

actionsSelector: aSymbol
	actionsSelector := aSymbol!

initialize
	super initialize.
	actionsSelector := #actions!

owner: anObject
	owner := anObject!

renderContentOn: html
	self actions do: [ :symbol |
		symbol numArgs = 0
			ifTrue: [ self renderLink: symbol on: html ]
			ifFalse: [ self renderInput: symbol on: html ] ]!

renderInput: aSymbol on: html
	html form: [
		html strong: aSymbol capitalized.
		html space.
		html textInput
			callback: [ :value |
				self target perform: aSymbol with: value ] ]!

renderLink: aSymbol on: html
	html anchor
		on: aSymbol of: self target.
	html break!

target
	^ owner activeComponent! !
!WANavigationBar categoriesFor: #actions!accessing!public! !
!WANavigationBar categoriesFor: #actionsSelector:!accessing!public! !
!WANavigationBar categoriesFor: #initialize!initialization!public! !
!WANavigationBar categoriesFor: #owner:!accessing!public! !
!WANavigationBar categoriesFor: #renderContentOn:!public!rendering! !
!WANavigationBar categoriesFor: #renderInput:on:!public!rendering! !
!WANavigationBar categoriesFor: #renderLink:on:!public!rendering! !
!WANavigationBar categoriesFor: #target!accessing!public! !

WAPath guid: (GUID fromString: '{A06CB1DF-B7F9-4921-ACEB-E7D1CA400584}')!
WAPath comment: '
WAPath represents a path navigation (breadcrumbs) for a web page and displays standard breadcrumbs(xxx >> yyy >> zzz). WAPath maintains a stack of associations, one for each "location" or "page" in the path. The association key is the text that is displayed in the breadcrimb. The association value is an object of your choosing, which your code uses to restore that "page". 

To add to the path use the method WAPath>>pushSegment: anObject name: ''lulu''. The name: arguement is the association key, the segment: argument is the association value.

The method WAPath>>currentSegment returns object associated with the current "page". Your code is not notified when the user clicks on a link in the WAPath object. So when you render a page call WAPath>>currentSegment to get the current object, and generate the page accordingly.

See WAInspector for example use.

Use WATrail to handle breadcrumbs for sequences of call: and answers:.

Instance Variables:
	stack	<Array of associations(String->Object) > History of the page. Keys -> display string, values -> object used in helping generating page.

'!
!WAPath categoriesForClass!Unclassified! !
!WAPath methodsFor!

choose: anAssociation 
	"Install a new stack of navigation from the old one and the specified association."
	| newStack |
	newStack := WriteStream on: Array new.
	stack do: 
		[ :ea | 
		newStack nextPut: ea.
		ea == anAssociation ifTrue: 
			[ stack := newStack contents.
			^ self ] ]!

currentSegment
	^ stack isEmpty
		ifTrue: [nil]
		ifFalse: [stack last value]!

initialize
	super initialize.
	stack := #()!

pushSegment: anObject name: aString
	stack := stack, (Array with: aString -> anObject)!

renderContentOn: html
	stack isEmpty 
		ifTrue: [ ^ self ].
	html div class: 'path'; with: [
		stack allButLast do: [ :assoc |
			html anchor 
				callback: [ self choose: assoc ]; 
				with: assoc key.
			html text: ' >> '].
		html strong: stack last key ]!

states
	^ Array with: self! !
!WAPath categoriesFor: #choose:!behavior!public! !
!WAPath categoriesFor: #currentSegment!accessing!public! !
!WAPath categoriesFor: #initialize!initialization!public! !
!WAPath categoriesFor: #pushSegment:name:!behavior!public! !
!WAPath categoriesFor: #renderContentOn:!public!rendering! !
!WAPath categoriesFor: #states!accessing!public! !

!WAPath class methodsFor!

example
	^self new
		pushSegment: 123 name: 'xxx';
		pushSegment: 456 name: 'yyy';
		pushSegment: 789 name: 'zzz';
		yourself! !
!WAPath class categoriesFor: #example!example!public! !

WASelection guid: (GUID fromString: '{A23E445C-D72F-4265-BC53-ECC6B13884FA}')!
WASelection comment: '
WASelection creates a selectable list. Items can be any object. If optional labelBlock is not given the string versions of the items are displayed to user, otherwise labelBlock is used to generate the text to display for each item. Returns the item selected by user, (not the index nor the text shown the user). 

	| selection |
	selection := WASelection new.
	selection items: #(1 ''cat'' ''rat'').
	selection 
		labelBlock: [:item | item = 1 ifTrue: [''First''] ifFalse: [item asUppercase]].
	result := self call: selection.
	self inform: result printString

Instance Variables:
	items	<Array of Objects> 	
	labelBlock	<One arg Block>	

'!
!WASelection categoriesForClass!Unclassified! !
!WASelection methodsFor!

initialize
	super initialize.
	items := #().
	labelBlock := [ :each | each greaseString ]!

items
	^ items!

items: aCollection
	items := aCollection!

labelBlock
	^ labelBlock!

labelBlock: aBlock
	labelBlock := aBlock!

renderContentOn: html
	html unorderedList
		list: self items;
		labels: self labelBlock;
		callback: [ :value | self answer: value ]! !
!WASelection categoriesFor: #initialize!initialization!public! !
!WASelection categoriesFor: #items!accessing!public! !
!WASelection categoriesFor: #items:!accessing!public! !
!WASelection categoriesFor: #labelBlock!accessing!public! !
!WASelection categoriesFor: #labelBlock:!accessing!public! !
!WASelection categoriesFor: #renderContentOn:!public!rendering! !

WATableReport guid: (GUID fromString: '{A470E073-B468-4A6A-92AB-9EF4256CAC05}')!
WATableReport comment: '
WATableReport presents tabular data. A WATableReport contains a collections of objects, one per row, and a collection of WAReportColumns. The WAReportColumn objects are configured to produce the text for the table cell based on the each row object. Each column has a header and an optional column sum. The table can be sorted on a column by clicking its header, unless the column handles rendering on the canvas itself. A table can be given a set of html colors (rowColors), used to colors the rows to aid in viewing. 

For more information see:
	Example - WATableReportTestm (initialization code below)
	WATableReport Tutorial - http://www.cdshaffer.com/david/Seaside/WATableReport/index.html

Instance Variables:
	columns	<Collection of WAReportColumn>	Each WAReportColumn produces the text for each table cell in a column  
	isReversed	<Boolean>	true if the current sort column is to be sorted in reverse order
	rowColors	<Collection of String/Symbol>	Each element is a string for an html color, which is used as a background color for table rows
	rowPeriod	<Integer>	Each color in rowColors is used for rowPeriod consectutive rows before using the next row color.
	rows	<Collection of Object>	Each element of the collection provides the data for a row in the table.
	sortColumn	<WAValueHolder on WAReportColumn>	Column used to sort the the table rows

Example:
	WATableReport new
		rows: WAComponent allSubclasses asArray;
		columns: (OrderedCollection new
			add: (WAReportColumn
				selector: #fullName title: ''Name''
				onClick: [ :each | self inform: each description ]);
			add: ((WAReportColumn
				selector: #canBeRoot title: ''Can Be Root'')
				sortBlock: [ :a :b | a ]);
			add: (WAReportColumn
				renderBlock: [ :each :html | html emphasis: each description ]
				title: ''Description'');
			yourself);
		rowColors: #(lightblue lightyellow);
		rowPeriod: 1;
		yourself'!
!WATableReport categoriesForClass!Unclassified! !
!WATableReport methodsFor!

chooseRow: aRow column: aColumn
	aColumn chooseRow: aRow!

colorForRowNumber: aNumber
	^ rowColors at: ((aNumber - 1 // rowPeriod) \\ rowColors size) + 1 ifAbsent: [ '#fff' ]!

columns: anArray
	columns := anArray!

initialize
	super initialize.
	isReversed := false.
	rows := #().
	columns := #().
	sortColumn := WAValueHolder new.
	rowColors := #('#fff' '#eee').
	rowPeriod := 1!

isReversed
	^ isReversed!

renderColumn: aColumn row: aRow on: html
	| text |
	aColumn canRender ifTrue: [
		html tableData
			class: aColumn cssClass;
			with: [ aColumn renderValue: aRow on: html ].
		^ self ].
	text := aColumn textForRow: aRow.
	text isEmpty ifTrue: [ text := ' ' ].
	html tableData
		class: aColumn cssClass;
		with: [
			aColumn canChoose
				ifFalse: [ html text: text ]
				ifTrue: [
					html anchor
						callback: [ self chooseRow: aRow column: aColumn ];
						with: text ] ]!

renderContentOn: html
	html table: [
		html tableHead: [ self renderTableHeaderOn: html ].
		html tableFoot: [ self renderTableFooterOn: html ].
		html tableBody: [ self renderRowsOn: html ] ]!

renderFooterForColumn: aColumn on: html
	html tableData
		class: aColumn cssClass;
		with: (aColumn totalForRows: rows)!

renderHeaderForColumn: aColumn on: html
	html tableHeading
		class: aColumn cssClass;
		with: [
			aColumn canSort
				ifTrue: [
					html anchor
						callback: [self sortColumn: aColumn];
						with: aColumn title]
				ifFalse: [ html text: aColumn title ] ]!

renderRowNumber: index item: row on: html
	html tableRow
		style: 'background-color: ' , (self colorForRowNumber: index);
		with: [
			columns do: [ :each |
				self renderColumn: each row: row on: html ] ]!

renderRowsOn: html 
	self rows keysAndValuesDo: [ :index :row | 
		self renderRowNumber: index item: row on: html ]!

renderTableFooterOn: html
	html tableRow: [
		columns do: [ :each |
			self renderFooterForColumn: each on: html] ]!

renderTableHeaderOn: html
	html tableRow: [
		columns do: [ :each |
			self renderHeaderForColumn: each on: html ] ]!

reverse
	isReversed := isReversed not!

rowColors: colorArray
	rowColors := colorArray!

rowPeriod: aNumber
	rowPeriod := aNumber!

rows
	| r |
	self sortColumn ifNil: [^ rows].
	r := self sortColumn sortRows: rows.
	^ self isReversed ifTrue: [r reverse] ifFalse: [r]!

rows: anArray
	rows := anArray!

sortColumn
	^ sortColumn contents!

sortColumn: anObject
	isReversed := anObject = self sortColumn and: [ isReversed not ].
	sortColumn contents: anObject!

states
	^ Array with: sortColumn! !
!WATableReport categoriesFor: #chooseRow:column:!private! !
!WATableReport categoriesFor: #colorForRowNumber:!private! !
!WATableReport categoriesFor: #columns:!accessing!public! !
!WATableReport categoriesFor: #initialize!initialization!public! !
!WATableReport categoriesFor: #isReversed!public!testing! !
!WATableReport categoriesFor: #renderColumn:row:on:!public!rendering! !
!WATableReport categoriesFor: #renderContentOn:!public!rendering! !
!WATableReport categoriesFor: #renderFooterForColumn:on:!public!rendering! !
!WATableReport categoriesFor: #renderHeaderForColumn:on:!public!rendering! !
!WATableReport categoriesFor: #renderRowNumber:item:on:!public!rendering! !
!WATableReport categoriesFor: #renderRowsOn:!public!rendering! !
!WATableReport categoriesFor: #renderTableFooterOn:!public!rendering! !
!WATableReport categoriesFor: #renderTableHeaderOn:!public!rendering! !
!WATableReport categoriesFor: #reverse!public!state variables! !
!WATableReport categoriesFor: #rowColors:!accessing!public! !
!WATableReport categoriesFor: #rowPeriod:!accessing!public! !
!WATableReport categoriesFor: #rows!accessing!public! !
!WATableReport categoriesFor: #rows:!accessing!public! !
!WATableReport categoriesFor: #sortColumn!public!state variables! !
!WATableReport categoriesFor: #sortColumn:!public!state variables! !
!WATableReport categoriesFor: #states!accessing!public! !

WATimeSelector guid: (GUID fromString: '{AFC6C533-C2C6-4F7B-A12E-7BBE5AA5C056}')!
WATimeSelector comment: '
WATimeSelector displays dropdown menus (html select) allowing a user to delect a time within a range. "startHour" and "endHour" define the range of selectable times. Time is displayed in 24 hour format. WATimeSelector>>time returns time user selected as a Time object.

See WADateSelectorTest for sample of usage.
Select "Date Selector" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	endHour	<Integer 0-23>	end of time interval for selectable times
	hour	<Integer 0-23>	selected hour
	minute	<Integer 0-59>	selected minute
	second	<Integer 0-59>	selected second
	startHour	<Integer 0-23>	start of time interval for selectable times
'!
!WATimeSelector categoriesForClass!Unclassified! !
!WATimeSelector methodsFor!

date: aDate
	second := aDate dayOfMonth.
	hour := aDate monthIndex.
	minute := aDate year!

days
	^ 1 to: 31!

endHour
	^endHour!

endHour: anInteger
	endHour := anInteger!

hour
	^hour!

hour: anObject
	^hour := anObject!

initialize
	super initialize.
	startHour := 0.
	endHour := 23.
	self time: Time midnight!

minute
	^minute!

minute: anObject
	^minute := anObject!

privateIsValidSecond: theSecond hourNumber: theHour minuteNumber: theMinute

	^ (theHour between: 0 and: 23)
		and: [ (theMinute between: 0 and: 59)
		and: [ theSecond between: 0 and: 59 ] ]!

renderContentOn: html
	html select
		list: (0 to: 23);
		on: #hour of: self.
	html  select
		list: (0 to: 59);
		on: #minute of: self.
	html  select
		list: (0 to: 59);
		on: #second of: self.

	self timeIsValid ifFalse: [self renderValidationErrorOn: html]!

renderValidationErrorOn: html
	html span
		class: 'error';
		with: 'invalid time'!

second
	^second!

second: anObject
	^second := anObject!

startHour
	^startHour!

startHour: anInteger
	startHour := anInteger!

time
	(self
		privateIsValidSecond: second
		hourNumber: hour
		minuteNumber: minute) ifFalse: [self error: 'Invalid time'].
	^self timeClass
		hour: hour
		minute: minute
		second: second!

time: aTime
	second := aTime second.
	hour := aTime hour.
	minute := aTime minute!

timeClass
	^Time!

timeIsValid
	[self time] on: Error do: [:e | ^ false].
	^ true! !
!WATimeSelector categoriesFor: #date:!accessing!public! !
!WATimeSelector categoriesFor: #days!accessing!public! !
!WATimeSelector categoriesFor: #endHour!accessing!public! !
!WATimeSelector categoriesFor: #endHour:!accessing!public! !
!WATimeSelector categoriesFor: #hour!accessing!public! !
!WATimeSelector categoriesFor: #hour:!accessing!public! !
!WATimeSelector categoriesFor: #initialize!initialization!public! !
!WATimeSelector categoriesFor: #minute!accessing!public! !
!WATimeSelector categoriesFor: #minute:!accessing!public! !
!WATimeSelector categoriesFor: #privateIsValidSecond:hourNumber:minuteNumber:!private! !
!WATimeSelector categoriesFor: #renderContentOn:!public!rendering! !
!WATimeSelector categoriesFor: #renderValidationErrorOn:!public!rendering! !
!WATimeSelector categoriesFor: #second!accessing!public! !
!WATimeSelector categoriesFor: #second:!accessing!public! !
!WATimeSelector categoriesFor: #startHour!accessing!public! !
!WATimeSelector categoriesFor: #startHour:!accessing!public! !
!WATimeSelector categoriesFor: #time!accessing!public! !
!WATimeSelector categoriesFor: #time:!accessing!public! !
!WATimeSelector categoriesFor: #timeClass!private! !
!WATimeSelector categoriesFor: #timeIsValid!public!testing! !

WATrail guid: (GUID fromString: '{55512A54-0AE3-4EB6-9833-BA6E4DA50004}')!
WATrail comment: '
WATrail implements breadcrumbs for pages generated using a sequence of WAComponent>>call: methods. Each component in the call sequence that is to appear in the breadcrumb must implement the method "trailName", which returns the text displayed in the breadcrumb. 

Instantiate (WATrail on: rootComponent) an WATrail object on the first component (root) of the breadcrumb. When the root component, or subsequent component, transfers control via "self call:" the WATrail object is automatically updated and will display the correct call sequence in the breadcrumb. When a user clicks on a link in the breadcrumb the call sequence is automatically updated.

The breadcrumb is placed in a div with class "trail" and each crumb is separated with the character ''>'', which is inside a span of class "separator" to aid in using CSS to format the breadcrumbs.

Instance Variables:
	root	<WAComponent>	first component in the breadcrumb and in the call sequence.

'!
!WATrail categoriesForClass!Unclassified! !
!WATrail methodsFor!

renderContentOn: html
	| last selected |
	last := nil.
	html div
		class: 'trail';
		with: [
			root visiblePresentersDo: [ :each | 
				(each isDecoration and: [ each isDelegation ]) ifTrue: [
					(each decoratedComponent respondsTo: #trailName) ifTrue: [
						last := each.
						html anchor
							callback: [ each remove ];
							with: (each decoratedComponent perform: #trailName).
						html span
							class: 'separator';
							with: self separator ] ] ].
			selected := last isNil
				ifTrue: [ root ]
				ifFalse: [ last delegate ].
			(selected respondsTo: #trailName) ifTrue: [
				html text: (selected perform: #trailName) ] ]!

root: anObject
	root := anObject!

separator
	
	^' > '! !
!WATrail categoriesFor: #renderContentOn:!public!rendering! !
!WATrail categoriesFor: #root:!accessing!public! !
!WATrail categoriesFor: #separator!accessing!public! !

!WATrail class methodsFor!

on: anObject
	^ self new root: anObject! !
!WATrail class categoriesFor: #on:!instance creation!public! !

WATree guid: (GUID fromString: '{ADB67152-D576-410C-B214-AE82355E60E7}')!
WATree comment: '
WATree implements a tree menu, which supports nesting, collapsing and expanding. Prefixes items with "+/-" to indicate items that can be expanded/collapsed.

See class methods for simple example.


Instance Variables:
	canSelectBlock	<BlockClosure [:nodeInTree | ]>	returns true if user can select the argument of the block, if true node is an anchor
	childrenBlock	<BlockClosure [:nodeInTree | ]>	returns children (or subnodes) of the given node in the tree, sent to all nodes
	expanded	<IdentitySet>	Collection of all nodes that are currently expanded
	labelBlock	<[:nodeInTree | ]> returns text to display for given node
	root	<Object>	root or top level node in tree, childrenBlock is used to determine roots subnodes
	selectBlock	<BlockClosure [:selectedNode | ]>	called when an node is selected, put a callback to your code here
	selected	<Object>	currently selected node


'!
!WATree categoriesForClass!Unclassified! !
!WATree methodsFor!

canSelect: aNode
	^self selectBlock notNil
		and: [ self canSelectBlock isNil
			or: [ self canSelectBlock value: aNode ] ]!

canSelectBlock
	^canSelectBlock!

canSelectBlock: aBlock
	canSelectBlock := aBlock!

childrenBlock
	^childrenBlock!

childrenBlock: aBlock
	childrenBlock := aBlock!

childrenOf: aNode
	| children |
	children := self childrenBlock value: aNode.
	^ children ifNil: [ Array new ]!

collapse: aNode
	expanded remove: aNode!

expand: aNode
	expanded add: aNode!

expandAll: aCollection
	expanded addAll: aCollection!

hasChildren: aNode
	^(self childrenOf: aNode)
		isEmpty not!

initialize
	super initialize.
	expanded := IdentitySet new.
	self selectBlock: [ :node | self answer: node ].
	self childrenBlock: [ :node | Array new ].
	self labelBlock: [ :node | node greaseString ]!

isExpanded: aNode
	^expanded includes: aNode!

labelBlock
	^labelBlock!

labelBlock: aBlock
	labelBlock := aBlock!

labelOf: aNode
	^self labelBlock value: aNode!

renderContentOn: html
	self renderTreeOn: html!

renderNode: aNode on: html
	html listItem: [
		self renderNodeButton: aNode on: html.
		self renderNodeLabel: aNode on: html.
		self renderNodeChildren: aNode on: html ]!

renderNodeButton: aNode on: html 
	| isExpanded |
	html span
		class: 'button';
		with: 
			[ (self hasChildren: aNode) ifTrue: 
				[ isExpanded := self isExpanded: aNode.
				self 
					renderNodeButtonLink: aNode
					action: (GRDelayedSend 
							receiver: self
							selector: (isExpanded 
									ifTrue: [ #collapse: ]
									ifFalse: [ #expand: ])
							argument: aNode)
					text: (isExpanded 
							ifTrue: [ '-' ]
							ifFalse: [ '+' ])
					on: html ] ]!

renderNodeButtonLink: aNode action: aBlock text: anObject on: html
	html anchor callback: aBlock; with: anObject!

renderNodeChildren: aNode on: html
	| children |
	children := self childrenOf: aNode.
	children isEmpty ifFalse: [
		(self isExpanded: aNode) ifTrue: [
			html unorderedList: [
				children do: [ :each |
					self renderNode: each on: html ] ] ] ]!

renderNodeLabel: aNode on: html 
	| label |
	html span
		class: 'label';
		class: (self selected == aNode 
				ifTrue: [ 'active' ]
				ifFalse: [ 'inactive' ]);
		with: 
			[ label := self labelOf: aNode.
			(self canSelect: aNode) 
				ifFalse: [ html render: label ]
				ifTrue: 
					[ self 
						renderNodeLabelLink: aNode
						action: (GRDelayedSend 
								receiver: self
								selector: #select:
								argument: aNode)
						text: label
						on: html ] ]!

renderNodeLabelLink: aNode action: aBlock text: anObject on: html
	html anchor callback: aBlock; with: anObject!

renderTreeOn: html
	html unorderedList: [ self renderNode: self root on: html ]!

root
	^root!

root: aNode
	root := aNode!

select: aNode 
	(self canSelect: aNode) ifFalse: [ ^ self ].
	self selected: aNode.
	self selectBlock isNil ifFalse: [ self selectBlock value: aNode ]!

selectBlock
	^selectBlock!

selectBlock: aBlock
	selectBlock := aBlock!

selected
	^selected!

selected: aNode
	selected := aNode!

states
	^ Array with: expanded! !
!WATree categoriesFor: #canSelect:!public!testing! !
!WATree categoriesFor: #canSelectBlock!accessing-configuration!public! !
!WATree categoriesFor: #canSelectBlock:!accessing-configuration!public! !
!WATree categoriesFor: #childrenBlock!accessing-configuration!public! !
!WATree categoriesFor: #childrenBlock:!accessing-configuration!public! !
!WATree categoriesFor: #childrenOf:!accessing-nodes!public! !
!WATree categoriesFor: #collapse:!actions!public! !
!WATree categoriesFor: #expand:!actions!public! !
!WATree categoriesFor: #expandAll:!actions!public! !
!WATree categoriesFor: #hasChildren:!public!testing! !
!WATree categoriesFor: #initialize!initialization!public! !
!WATree categoriesFor: #isExpanded:!public!testing! !
!WATree categoriesFor: #labelBlock!accessing-configuration!public! !
!WATree categoriesFor: #labelBlock:!accessing-configuration!public! !
!WATree categoriesFor: #labelOf:!accessing-nodes!public! !
!WATree categoriesFor: #renderContentOn:!public!rendering! !
!WATree categoriesFor: #renderNode:on:!public!rendering-nodes! !
!WATree categoriesFor: #renderNodeButton:on:!public!rendering-nodes! !
!WATree categoriesFor: #renderNodeButtonLink:action:text:on:!public!rendering-nodes! !
!WATree categoriesFor: #renderNodeChildren:on:!public!rendering-nodes! !
!WATree categoriesFor: #renderNodeLabel:on:!public!rendering-nodes! !
!WATree categoriesFor: #renderNodeLabelLink:action:text:on:!public!rendering-nodes! !
!WATree categoriesFor: #renderTreeOn:!public!rendering! !
!WATree categoriesFor: #root!accessing!public! !
!WATree categoriesFor: #root:!accessing!public! !
!WATree categoriesFor: #select:!actions!public! !
!WATree categoriesFor: #selectBlock!accessing-configuration!public! !
!WATree categoriesFor: #selectBlock:!accessing-configuration!public! !
!WATree categoriesFor: #selected!accessing!public! !
!WATree categoriesFor: #selected:!accessing!public! !
!WATree categoriesFor: #states!accessing!public! !

!WATree class methodsFor!

exampleClassBrowser
	^ self new
		root: Collection;
		labelBlock: [ :class | class name ];
		childrenBlock: [ :class | class subclasses ];
		yourself!

root: anObject
	^ self new
		root: anObject;
		yourself!

root: anObject path: anArray
	^ (self root: anObject)
		expandAll: anArray;
		selected: anArray last;
		yourself! !
!WATree class categoriesFor: #exampleClassBrowser!examples!public! !
!WATree class categoriesFor: #root:!instance creation!public! !
!WATree class categoriesFor: #root:path:!instance creation!public! !

WASelectionDateTable guid: (GUID fromString: '{1076DCD9-A599-4C58-B820-933EF5BEF526}')!
WASelectionDateTable comment: '
WASelectionDateTable renders a table containing dates and rows. A user can select a continuous block of cells in the table.  The table contains one column for each date from startDate to endDate. The top row of the table groups columns by month and labels each month (January 2008). The second row contains the date of each month  (1-30) in the date range. The table also contains "rows size" rows. The first column of these rows contains the contents of the instance variable "rows". Rest of the cells contents are given by "cellBlock". 

Instance Variables:
	cellBlock	<BlockClosure [:rowIndex :date | ]>	returns text for the cell in row "rowIndex" and column for "date"
	dateSelectionEnd	<Date>	last selected date
	dateSelectionStart	<Date>	first selected date
	rowSelectionEnd	<Integer>	index of last selected row
	rowSelectionStart	<Integer>	index of first selected row

'!
!WASelectionDateTable categoriesForClass!Unclassified! !
!WASelectionDateTable methodsFor!

clearSelection
	dateSelectionStart := dateSelectionEnd := rowSelectionStart := rowSelectionEnd := nil!

colorForDate: aDate rowIndex: aNumber
	^ (self hasSelection
		and: [self selectionContainsDate: aDate rowIndex: aNumber])
			ifTrue: ['lightgrey']
			ifFalse: ['white']!

endDate: aDate
	self clearSelection.
	super endDate: aDate!

endDateSelection
	^ dateSelectionStart isNil
		ifFalse: [ dateSelectionStart max: dateSelectionEnd ]!

endRow
	^ rowSelectionStart max: rowSelectionEnd!

endRowSelection
	^ rowSelectionStart isNil
		ifFalse: [ rows at: (rowSelectionStart max: rowSelectionEnd) ]!

hasSelection
	^ dateSelectionStart notNil!

renderCellForDate: aDate row: anObject index: aNumber on: html
	| text |
	html tableData
		style: 'background-color: ', (self colorForDate: aDate rowIndex: aNumber);
		align: 'center';
		with: [
			text := cellBlock value: anObject value: aDate.
			html anchor callback: [self selectDate: aDate rowIndex: aNumber]; with: text ]!

rows: aCollection
	self clearSelection.
	super rows: aCollection!

rowsAndDatesDisplay: aBlock
	cellBlock := aBlock!

selectAll
	dateSelectionStart := startDate.
	dateSelectionEnd := endDate.
	rowSelectionStart := 1.
	rowSelectionEnd := rows size!

selectDate: aDate rowIndex: rowIndex
	self hasSelection
		ifFalse: [dateSelectionStart := dateSelectionEnd := aDate. rowSelectionStart := rowSelectionEnd := rowIndex]
		ifTrue: [dateSelectionEnd := aDate. rowSelectionEnd := rowIndex]!

selectedRows
	^ rows copyFrom: self startRow to: self endRow!

selectionContainsDate: aDate rowIndex: aNumber
	^ ((aDate between: dateSelectionStart and: dateSelectionEnd) or: [aDate between: dateSelectionEnd and: dateSelectionStart])
		and: [(aNumber between: rowSelectionStart and: rowSelectionEnd) or: [aNumber between: rowSelectionEnd and: rowSelectionStart]]!

startDate: aDate
	self clearSelection.
	super startDate: aDate!

startDateSelection
	^ dateSelectionStart isNil
		ifFalse: [ dateSelectionStart min: dateSelectionEnd ]!

startRow
	^ rowSelectionStart min: rowSelectionEnd!

startRowSelection
	^ rowSelectionStart isNil
		ifFalse: [ rows at: (rowSelectionStart min: rowSelectionEnd) ]!

style
	^ 'td a {text-decoration: none}'! !
!WASelectionDateTable categoriesFor: #clearSelection!public!selecting! !
!WASelectionDateTable categoriesFor: #colorForDate:rowIndex:!private! !
!WASelectionDateTable categoriesFor: #endDate:!accessing!public! !
!WASelectionDateTable categoriesFor: #endDateSelection!private! !
!WASelectionDateTable categoriesFor: #endRow!private! !
!WASelectionDateTable categoriesFor: #endRowSelection!private! !
!WASelectionDateTable categoriesFor: #hasSelection!public!testing! !
!WASelectionDateTable categoriesFor: #renderCellForDate:row:index:on:!public!rendering! !
!WASelectionDateTable categoriesFor: #rows:!accessing!public! !
!WASelectionDateTable categoriesFor: #rowsAndDatesDisplay:!private! !
!WASelectionDateTable categoriesFor: #selectAll!editor access!public! !
!WASelectionDateTable categoriesFor: #selectDate:rowIndex:!private! !
!WASelectionDateTable categoriesFor: #selectedRows!private! !
!WASelectionDateTable categoriesFor: #selectionContainsDate:rowIndex:!private! !
!WASelectionDateTable categoriesFor: #startDate:!accessing!public! !
!WASelectionDateTable categoriesFor: #startDateSelection!private! !
!WASelectionDateTable categoriesFor: #startRow!private! !
!WASelectionDateTable categoriesFor: #startRowSelection!private! !
!WASelectionDateTable categoriesFor: #style!public!rendering! !

WAChoiceDialog guid: (GUID fromString: '{357FF029-15A4-448F-98DC-0DF6CB053F04}')!
WAChoiceDialog comment: '
WAChoiceDialog produces a form with select tag (dropdown menu) on a collection of options and "Ok" and "Cancel" buttons. Options can be any object. Returns actual object selected or nil if user select "Cancel". WAChoiceDialog is used to implement the chooseFrom:caption: convenience method in WAComponent.

	| selection |
	selection := WAChoiceDialog options: #(''Smalltalk'' ''Perl'' ''Python'' ''Ruby'' 9).
	result := self call: selection.
	self inform: result printString

Instance Variables:
	options	<Collection of Objects> objects in list
	selection	<Object>	object selected by user or nil if user cancels

'!
!WAChoiceDialog categoriesForClass!Unclassified! !
!WAChoiceDialog methodsFor!

buttons
	^ #(ok cancel)!

cancel
	self answer: nil!

ok
	self answer: self selection!

options
	^ options!

options: aCollection
	options := aCollection!

renderContentOn: html
	html select
		list: self options;
		selected: self selection;
		callback: [ :value | self selection: value ]!

selection
	^ selection!

selection: anObject
	selection := anObject! !
!WAChoiceDialog categoriesFor: #buttons!accessing!public! !
!WAChoiceDialog categoriesFor: #cancel!actions!public! !
!WAChoiceDialog categoriesFor: #ok!actions!public! !
!WAChoiceDialog categoriesFor: #options!accessing!public! !
!WAChoiceDialog categoriesFor: #options:!accessing!public! !
!WAChoiceDialog categoriesFor: #renderContentOn:!public!rendering! !
!WAChoiceDialog categoriesFor: #selection!accessing!public! !
!WAChoiceDialog categoriesFor: #selection:!accessing!public! !

!WAChoiceDialog class methodsFor!

example
	^ self options: #('Perl' 'Python' 'Ruby' 'Smalltalk') selection: 'Smalltalk'!

options: aCollection
	^ self options: aCollection selection: nil!

options: aCollection selection: anObject
	^ self new
		options: aCollection;
		selection: anObject;
		yourself
		! !
!WAChoiceDialog class categoriesFor: #example!examples!public! !
!WAChoiceDialog class categoriesFor: #options:!instance creation!public! !
!WAChoiceDialog class categoriesFor: #options:selection:!instance creation!public! !

WALabelledFormDialog guid: (GUID fromString: '{B3F7AD20-6D86-4098-806A-13F4B827B11A}')!
WALabelledFormDialog comment: '
WALabelledFormDialog is an abstract class for generating html forms. Given a data model WALabelledFormDialog displays a label and input field for each instance variable of interest. User supplied data is placed in the data model.

Subclasses need to implment the methods labelForSelector:, model, and rows. The "model" method just returns the object whose fields we wish to populate with date. The "rows" method returns a collections of symbols. One symbol for each row of data in the dialog. The symbol is used generate the accessor methods for the data in the model. The method "labelForSelector:" returns the labels for each row and each submit button in the form.

A standard text input field is used for each row of data. To use other html widgets for input for = a datum implement the method renderXXXOn: where XXX is the symbol for the row. See "renderNameOn:" in example below.

The default form has one button "Ok". Override the "buttons" method to change the text or number of submit buttons on the form. Override the "defaultButton" method to indicate which button is the default. For each button in the form the subclass needs a method with the same name as the button, which is called when the user clicks that button. See example below.

LabelledFormDialogExample subclass of WALabelledFormDialog instance methods
	initialize
		super initialize.
		contact := Contact new. "contact is an inst var"
		self addMessage: ''Please enter the followning information''.

	model
		^ contact

	ok
		self answer: contact

	cancel
		self answer

	rows
		^ #(name phoneNumber)

	buttons
		#(ok cancel)

	labelForSelector: aSymbol
		aSymbol == #name ifTrue: [^''Your Name''].
		aSymbol == #phoneNumber ifTrue: [^''Phone Number''].
		aSymbol == #ok ifTrue: [^''Ok''].
		aSymbol == #cancel ifTrue: [^''Cancel''].
		^ super labelForSelector: aSymbol

	renderNameOn: html 
		"Show how to specily special input instead of using simple text field."
		(html select)
				list: #(''Roger'' ''Pete'');
				selected: ''Roger'';
				callback: [:v | contact name: v]

Contact Class used above has instance variables name, phoneNumber with standard getter and setter methods
'!
!WALabelledFormDialog categoriesForClass!Unclassified! !
!WALabelledFormDialog methodsFor!

renderDefaultFieldForSelector: aSymbol on: html
	html textInput
		on: aSymbol of: self model!

renderDialogOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]]!

renderFieldForSelector: aSymbol on: html
	| renderSelector |
	renderSelector := self renderingSelectorFor: aSymbol.
	(self respondsTo: renderSelector)
		ifTrue: [self perform: renderSelector with: html]
		ifFalse: [self renderDefaultFieldForSelector: aSymbol on: html]!

renderingSelectorFor: aSymbol
	^ ('render', aSymbol capitalized, 'On:') asSymbol!

renderLabelForSelector: aSymbol on: html
	html text: (self labelForSelector: aSymbol)!

renderRowForSelector: aSymbol on: html
	html div
		id: 'dialog-row-' , aSymbol;
		class: 'dialog-row';
		with: [
			html span
				class: 'dialog-form-label';
				with: [self renderLabelForSelector: aSymbol on: html].
			html span
				class: 'dialog-form-field';
				with: [self renderFieldForSelector: aSymbol on: html]]!

renderTableRowsOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]]!

rows
	^ #()!

style
	^ '
.dialog-row {
	clear: both;
	/*set position: relative to handle the ie disappearing text bug*/
	position: relative;
	margin-top: 3px;
}

.dialog-form-label {
	width: 100px;
	float: left;
	text-align: right;
	padding: 2px 6px;
	margin-right: 4px;
	margin-top: 2px;
}

.dialog-form-field {
	text-align: left;
	padding: 2px;
	margin-top: 2px;
	float: left;
}

.dialog-buttons {
	clear: both;
	padding: 10px;
	text-align: center
}

.dialog-spacer {
	clear: both;
	height: 10px;
}
	'! !
!WALabelledFormDialog categoriesFor: #renderDefaultFieldForSelector:on:!public!rendering! !
!WALabelledFormDialog categoriesFor: #renderDialogOn:!public!rendering! !
!WALabelledFormDialog categoriesFor: #renderFieldForSelector:on:!public!rendering! !
!WALabelledFormDialog categoriesFor: #renderingSelectorFor:!public!rendering! !
!WALabelledFormDialog categoriesFor: #renderLabelForSelector:on:!public!rendering! !
!WALabelledFormDialog categoriesFor: #renderRowForSelector:on:!public!rendering! !
!WALabelledFormDialog categoriesFor: #renderTableRowsOn:!public!rendering! !
!WALabelledFormDialog categoriesFor: #rows!accessing!public! !
!WALabelledFormDialog categoriesFor: #style!accessing!public! !

WAYesOrNoDialog guid: (GUID fromString: '{9C3791EC-D376-46CB-9F81-3E79714C3FE8}')!
WAYesOrNoDialog comment: 'WAYesOrNoDialog displays a yes/no dialog. Returns boolean indicating user selection. See WAComponent>>confirm: for sample usage and easy way to use WAYesOrNoDialog.'!
!WAYesOrNoDialog categoriesForClass!Unclassified! !
!WAYesOrNoDialog methodsFor!

buttons
	^ #(yes no)!

no
	self answer: false!

yes
	self answer: true! !
!WAYesOrNoDialog categoriesFor: #buttons!accessing!public! !
!WAYesOrNoDialog categoriesFor: #no!accessing!public! !
!WAYesOrNoDialog categoriesFor: #yes!accessing!public! !

!WAYesOrNoDialog class methodsFor!

example
	^ self new! !
!WAYesOrNoDialog class categoriesFor: #example!examples!public! !

WASimpleNavigation guid: (GUID fromString: '{0BB1931C-6CC7-421C-AEF8-1FE9BE26C73C}')!
WASimpleNavigation comment: '
I''m a simple tab panel, that can be styled with stylesheets. New tabs can be added using #add:label:

You may want to add the WANavigationFiles library to your application for some default CSS styling.'!
!WASimpleNavigation categoriesForClass!Unclassified! !
!WASimpleNavigation methodsFor!

add: aComponent label: aString
	components add: aString -> aComponent!

children
	^ Array with: self selectedComponent!

components
	^ components!

initialize
	super initialize.
	components := OrderedCollection new!

labels
	"Return the tabs labels"

	^ self options!

options
	^ components collect: [ :each | each key ]!

renderSelectionOn: html
	html render: self selectedComponent!

selectedComponent
	^ (components detect: [ :each | each key = self selection ] ifNone: [ ^ nil ]) value!

selectFirst
	"Selects the first added component as active."
	
	components notEmpty
		ifTrue: [ self select: components first key ]! !
!WASimpleNavigation categoriesFor: #add:label:!behavior!public! !
!WASimpleNavigation categoriesFor: #children!accessing!public! !
!WASimpleNavigation categoriesFor: #components!accessing!public! !
!WASimpleNavigation categoriesFor: #initialize!initialize!public! !
!WASimpleNavigation categoriesFor: #labels!accessing!public! !
!WASimpleNavigation categoriesFor: #options!accessing!public! !
!WASimpleNavigation categoriesFor: #renderSelectionOn:!public!rendering! !
!WASimpleNavigation categoriesFor: #selectedComponent!accessing!public! !
!WASimpleNavigation categoriesFor: #selectFirst!behavior!public! !

WAWidgetDecoration guid: (GUID fromString: '{3E3C92B3-86A2-4952-8968-EBB60D099B9B}')!
WAWidgetDecoration comment: ''!
!WAWidgetDecoration categoriesForClass!Unclassified! !
!WAWidgetDecoration methodsFor!

rendererClass
	"Make sure we use WARenderCanvas even if a different renderer is default."
	^ WARenderCanvas! !
!WAWidgetDecoration categoriesFor: #rendererClass!public!rendering! !

WADelayedAnswerDecoration guid: (GUID fromString: '{E49206BA-6FA3-47A3-A03F-B54047B6B634}')!
WADelayedAnswerDecoration comment: '
WADelayedAnswerDecoration adds a delay in displaying a component. 

See WADelayTest for sample usage.
Select ''Delay" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	delay	<Integer>	delay length in seconds 

'!
!WADelayedAnswerDecoration categoriesForClass!Unclassified! !
!WADelayedAnswerDecoration methodsFor!

delay
	^ delay ifNil: [ 1 ]!

delay: aNumber
	delay := aNumber!

updateRoot: anHtmlRoot 
	| url |
	super updateRoot: anHtmlRoot.
	url := anHtmlRoot context actionUrl withField:
				(anHtmlRoot context callbacks store:
					(WAActionCallback on: [ self decoratedComponent answer ])).
	anHtmlRoot meta 
		redirectAfter: self delay
		to: url greaseString! !
!WADelayedAnswerDecoration categoriesFor: #delay!accessing!public! !
!WADelayedAnswerDecoration categoriesFor: #delay:!accessing!public! !
!WADelayedAnswerDecoration categoriesFor: #updateRoot:!path!public! !

WAFormDecoration guid: (GUID fromString: '{0FD6F550-FCFC-4807-934E-530F2B90908F}')!
WAFormDecoration comment: '
A WAFormDecoration places its component inside an html form tag. The buttons inst var must be set. The component that a WAFormDecoration decorates must implement the method "defaultButton", which returns the string/symbol of the default button (one selected by default) of the form. Don''t place any decorators between WAFormDecoration and its component otherwise "defaultButton" method fails. For each string/symbol in the buttons inst var the decorated component must implement a method of the same name, which is called when the button is selected.

Instance Variables
	buttons:		<Collection of strings or symbols>

buttons
	- list of strings or symbols, each string/symbol is the label (first letter capitalized) for a button and the name of the callback method on component when button is pressed, 
'!
!WAFormDecoration categoriesForClass!Unclassified! !
!WAFormDecoration methodsFor!

buttons
	^ buttons!

buttons: selectorArray
	buttons := selectorArray!

defaultAction
	self decoratedComponent perform: self decoratedComponent defaultButton!

renderButtonForSelector: aSymbol on: html
	html submitButton on: aSymbol of: self decoratedComponent!

renderButtonsOn: html
	html div class: 'dialog-buttons'; with: [
		self buttons do: [ :each |
			html  span
				class: 'dialog-button-' , each;
				with: [ self renderButtonForSelector: each on: html ] ] ]!

renderContentOn: html
	html form
		defaultAction: [ self defaultAction ];
		with: [
			html div: [
				self renderNextOn: html.
				self renderButtonsOn: html ] ]! !
!WAFormDecoration categoriesFor: #buttons!accessing!public! !
!WAFormDecoration categoriesFor: #buttons:!accessing!public! !
!WAFormDecoration categoriesFor: #defaultAction!actions!public! !
!WAFormDecoration categoriesFor: #renderButtonForSelector:on:!public!rendering! !
!WAFormDecoration categoriesFor: #renderButtonsOn:!public!rendering! !
!WAFormDecoration categoriesFor: #renderContentOn:!public!rendering! !

WAMessageDecoration guid: (GUID fromString: '{E8FB37A7-CA0A-4A60-AEB4-E97C0518313D}')!
WAMessageDecoration comment: '
I add a string message on top of the WAComponent I decorate. For example if change WACounter>>initialize as below the text "Counter Example" will appear on above the counter when rendered.

WACounter>>initialize
	super initialize.
	self count: 0.
	self addMessage: ''Counter Example''	"added line"

'!
!WAMessageDecoration categoriesForClass!Unclassified! !
!WAMessageDecoration methodsFor!

message: aString
	message := aString!

renderContentOn: html
	html heading level3; with: message.
	self renderNextOn: html! !
!WAMessageDecoration categoriesFor: #message:!accessing!public! !
!WAMessageDecoration categoriesFor: #renderContentOn:!public!rendering! !

WAValidationDecoration guid: (GUID fromString: '{77123E39-28DC-46B6-ADA9-94470AD1E103}')!
WAValidationDecoration comment: '
A WAValidationDecoration validates its component form data when the component returns using "answer" or "answer:". A WAValidationDecoration can be added to component via the method "validateWith:" as below.

	SampleLoginComponent>>intialize
		form := WAFormDecoration new buttons: self buttons.
		self addDecoration: form.
		self validateWith: [:answerArgOrSelf | answerArgOrSelf validate].
		self addMessage: ''Please enter the following information''.

If component returns via "answer:" the answer: argument is passed to the validate block. If the component returns using "answer" the sender of "answer" is passed to the validate block.

Instance Variables
	exceptionClass:		<Notification>
	message:		<String>
	validationBlock:		<one arg block>

exceptionClass
	- Type of notication that is raised by validation code when validation fails. Default value is WAValidationNotification

message
	- String message displayed on validation failure. Obtained from the notification

validationBlock
	- One arg block, 
'!
!WAValidationDecoration categoriesForClass!Unclassified! !
!WAValidationDecoration methodsFor!

exceptionClass
	^exceptionClass ifNil: [exceptionClass := WAValidationNotification]!

exceptionClass: aClass
	exceptionClass := aClass!

handleAnswer: anObject
	^(super handleAnswer: anObject)
		or: [(self validate: anObject) not]!

handleAnswer: anObject continueWith: aBlock
	(self validate: anObject) ifTrue: [aBlock value]!

initialize
	super initialize.
	message := WAValueHolder new!

renderContentOn: html
	message contents isNil ifFalse: [
		html div
			class: 'validation-error';
			with: message contents ].
	self renderNextOn: html!

states
	^ Array with: message!

validate: anObject
	^ [ validationBlock value: anObject.
	message contents: nil.
	true ]
		on: self exceptionClass
		do: [ :exception |
			message contents: exception messageText.
			exception return: false ]!

validateWith: aBlock
	validationBlock := aBlock! !
!WAValidationDecoration categoriesFor: #exceptionClass!accessing!public! !
!WAValidationDecoration categoriesFor: #exceptionClass:!accessing!public! !
!WAValidationDecoration categoriesFor: #handleAnswer:!call/answer!public! !
!WAValidationDecoration categoriesFor: #handleAnswer:continueWith:!public!request processing! !
!WAValidationDecoration categoriesFor: #initialize!initialization!public! !
!WAValidationDecoration categoriesFor: #renderContentOn:!public!rendering! !
!WAValidationDecoration categoriesFor: #states!accessing!public! !
!WAValidationDecoration categoriesFor: #validate:!public!request processing! !
!WAValidationDecoration categoriesFor: #validateWith:!convenience!public! !

WAWindowDecoration guid: (GUID fromString: '{C29CBAB5-26E4-48CF-AD06-4CECB33A1578}')!
WAWindowDecoration comment: '
WAWindowDecoration adds a simple title and close button in a bordered area at the top of the page. When closed button is selected nil is "answer"ed. Useful for a quick & dirty dialog window. Used by WAPlugin and SCTestRunner.

Instance Variables:
	cssClass	<String>	String added to "window-title " to generate cssClass for the title
	title	<String>	title of page
'!
!WAWindowDecoration categoriesForClass!Unclassified! !
!WAWindowDecoration methodsFor!

cssClass: aString
	cssClass := aString!

isGlobal
	^ true!

renderCloseButtonOn: html
	html anchor
		title: 'Close';
		callback: [ self decoratedComponent answer: nil ];
		with: [ html html: '&times;' ]!

renderContentOn: html
	html div class: 'window'; with: [
		html div class: 'window-titlebar'; with: [
			html div class: 'window-title'; class: cssClass; with: title.
			html div class: 'window-close'; with: [ self renderCloseButtonOn: html ] ].
		html div class: 'window-content'; with: [ self renderNextOn: html ] ]!

title: aString
	title := aString! !
!WAWindowDecoration categoriesFor: #cssClass:!accessing!public! !
!WAWindowDecoration categoriesFor: #isGlobal!public!testing! !
!WAWindowDecoration categoriesFor: #renderCloseButtonOn:!public!rendering! !
!WAWindowDecoration categoriesFor: #renderContentOn:!public!rendering! !
!WAWindowDecoration categoriesFor: #title:!accessing!public! !

!WAWindowDecoration class methodsFor!

title: aTitle
	^self new
		title: aTitle;
		yourself! !
!WAWindowDecoration class categoriesFor: #title:!instance creation!public! !

"Binary Globals"!

