| package |
package := Package name: 'Seaside-Tests-Pharo-Core'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '14'.


package classNames
	add: #WAEncoderPharoTest;
	add: #WAFormTestCase;
	add: #WAPharoDocumentHandlerTest;
	add: #WAPharoFileLibraryTest;
	add: #WAPharoMimeDocumentTest;
	yourself.

package methodNames
	add: 'GRPackage class' -> #seasideTestsPharoCore;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\..\..\Grease\Grease-Core';
	add: '..\..\Seaside-Core';
	add: '..\Seaside-Tests-Core';
	add: '..\..\..\..\Camp Smalltalk\SUnit\SUnit';
	yourself).

package!

"Class Definitions"!

TestCase subclass: #WAFormTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAContextTest subclass: #WAPharoFileLibraryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAEncoderTest subclass: #WAEncoderPharoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFormTestCase subclass: #WAPharoDocumentHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFormTestCase subclass: #WAPharoMimeDocumentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GRPackage class methodsFor!

seasideTestsPharoCore
	^ self new
		name: 'Seaside-Tests-Pharo-Core';
		addDependency: 'Seaside-Pharo-Core';
		addDependency: 'Seaside-Tests-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideTestsPharoCore!*seaside-tests-pharo-core!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

WAFormTestCase guid: (GUID fromString: '{585016F3-2661-4045-897C-9001D7900167}')!
WAFormTestCase comment: ''!
!WAFormTestCase categoriesForClass!Unclassified! !
!WAFormTestCase methodsFor!

formClassExists
	^ Smalltalk hasClassNamed: #Form!

sampleForm
	^(Smalltalk classNamed: #Form)
		extent: 16@16
		depth: 1
		fromArray: #( 0 0 0 50331648 25165824 12582912 281018368 415236096 264241152 132120576 7340032 3670016 1572864 0 0 0)
		offset: 0@0! !
!WAFormTestCase categoriesFor: #formClassExists!private! !
!WAFormTestCase categoriesFor: #sampleForm!private! !

!WAFormTestCase class methodsFor!

isAbstract
	^ self name = #WAFormTestCase! !
!WAFormTestCase class categoriesFor: #isAbstract!public!testing! !

WAPharoFileLibraryTest guid: (GUID fromString: '{1769F72E-653A-48A0-83FB-10066E611237}')!
WAPharoFileLibraryTest comment: ''!
!WAPharoFileLibraryTest categoriesForClass!Unclassified! !
!WAPharoFileLibraryTest methodsFor!

compileUseNewCompiler
	^Preferences
		valueOfFlag: #compileUseNewCompiler
		ifAbsent: [ false ]!

hasNewCompiler
	Preferences
		valueOfFlag: #compileUseNewCompiler
		ifAbsent: [ ^false ].
	^true!

testAddAllFilesIn
	| directoryName |
	directoryName := 'XXXUsedBySeasideTests'.
	FileDirectory default createDirectory: directoryName.
	[| directory library |
	directory := FileDirectory default directoryNamed: directoryName.
	[(directory forceNewFileNamed: '.Seaside_Store') in: [ :stream | stream close ].
	(directory forceNewFileNamed: 'foo') in: [ :stream | stream close ].
	SystemChangeNotifier uniqueInstance doSilently: [
		library := WAFileLibrary
			subclass: #XXXTestFileLibrary
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: 'Uncategorized'.
		[ library addAllFilesIn: directory pathName.
		self assert: library selectors size = 1 ] "reject .Seaside_Store"
			ensure: [ library removeFromSystem ] ] ]
		ensure: [ directory deleteLocalFiles ] ]
		ensure: [ FileDirectory default deleteDirectory: directoryName ]!

testCompileByteArrayLiteralSource
	| library data file source expected |
	self hasNewCompiler ifFalse: [ ^ self ].
	self 
		useCompileUseNewCompiler: true
		during: 
			[ self assert: self compileUseNewCompiler.
			library := WATestingFiles default.
			data := (1 to: 255) asByteArray.
			file := WAFile new
				contentType: WAMimeType imageJpeg;
				contents: data;
				fileName: 'demo.jpeg';
				yourself.
			library addFile: file.
			
			[ source := WATestingFiles sourceCodeAt: #demoJpeg.
			expected := 'demoJpeg
	^ #[1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255]'.
			self assert: source greaseString = expected ] ensure: [ library removeFile: file fileName ] ]!

testCompileByteArrayWithCacheSource
	| library data file source expected |
	self 
		useCompileUseNewCompiler: false
		during: 
			[ self deny: self compileUseNewCompiler.
			library := WATestingFiles default.
			data := (1 to: 255) asByteArray.
			file := WAFile new
				contentType: WAMimeType imageJpeg;
				contents: data;
				fileName: 'demo.jpeg';
				yourself.
			library addFile: file.
			
			[ source := WATestingFiles sourceCodeAt: #demoJpeg.
			expected := 'demoJpeg
	^ #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255) asByteArray'.
			self assert: source greaseString = expected ] ensure: [ library removeFile: file fileName ] ]!

useCompileUseNewCompiler: aBoolean during: aBlock
	| oldValue |
	oldValue := self compileUseNewCompiler.
	[ Preferences setPreference: #compileUseNewCompiler toValue: aBoolean.
	aBlock value ]
		ensure: [
			self hasNewCompiler ifTrue: [
				Preferences setPreference: #compileUseNewCompiler toValue: oldValue ] ]! !
!WAPharoFileLibraryTest categoriesFor: #compileUseNewCompiler!private! !
!WAPharoFileLibraryTest categoriesFor: #hasNewCompiler!private! !
!WAPharoFileLibraryTest categoriesFor: #testAddAllFilesIn!public!tests! !
!WAPharoFileLibraryTest categoriesFor: #testCompileByteArrayLiteralSource!public!tests! !
!WAPharoFileLibraryTest categoriesFor: #testCompileByteArrayWithCacheSource!public!tests! !
!WAPharoFileLibraryTest categoriesFor: #useCompileUseNewCompiler:during:!private! !

WAEncoderPharoTest guid: (GUID fromString: '{684A09CD-54A7-474D-B195-A167C3E856EB}')!
WAEncoderPharoTest comment: ''!
!WAEncoderPharoTest categoriesForClass!Unclassified! !
!WAEncoderPharoTest methodsFor!

createCodec
	^ GRCodec forEncoding: 'utf-8'!

stripLeadingCharFrom: aString 
	"strips the leadingChar from every character in the given string"
	^ String streamContents: 
		[ :stream | 
		aString do: 
			[ :each | 
			stream nextPut: (Character 
					leadingChar: 0
					code: each greaseInteger) ] ]!

testEncodedLatin1Url
	self
		assert: (String with: (Character codePoint: 233) with: (Character codePoint: 228))
		encoder: WAUrlEncoder
		gives: '%C3%A9%C3%A4'!

testEncodedSupplementaryMultilingualPlane
	"The Supplementary Multilingual Plane (SMP: Plane 1, U+010000 - U+01FFFF)
	http://www.unicode.org/charts/PDF/U10140.pdf
	Ancient Greek Zero Sign"
	| zero |
	zero := (Character codePoint: 65930) greaseString.
	self 
		assert: zero
		encoder: WAXmlEncoder
		gives: zero!

testEncodedSupplementaryMultilingualPlaneUrl
	"The Supplementary Multilingual Plane (SMP: Plane 1, U+010000 - U+01FFFF)
	http://www.unicode.org/charts/PDF/U10140.pdf
	Ancient Greek Zero Sign"
	| zero |
	zero := (Character codePoint: 65930) greaseString.
	self 
		assert: zero
		encoder: WAUrlEncoder
		gives: '%F0%90%86%8A'!

testEncodedUnicode
	"this makes sure the encoder doesn't fall on the nose with unicode"
	| hiraA hiraO hiraAO ea |
	ea := String 
		with: (Character codePoint: 233)
		with: (Character codePoint: 228).
	self 
		assert: ea
		encoder: WAXmlEncoder
		gives: ea.
	hiraA := (Character codePoint: 12354) greaseString.	"HIRAGANA LETTER A"
	hiraO := (Character codePoint: 12362) greaseString.	"HIRAGANA LETTER O"
	hiraAO := hiraA , hiraO.
	self 
		assert: hiraA
		encoder: WAXmlEncoder
		gives: hiraA.
	self 
		assert: hiraO
		encoder: WAXmlEncoder
		gives: hiraO.
	self 
		assert: hiraAO
		encoder: WAXmlEncoder
		gives: hiraAO!

testEncodedUnicodeUrl
	"this makes sure the encoder doesn't fall on the nose with unicode"
	| hiraA hiraO hiraAO ea |
	ea := String 
		with: (Character codePoint: 233)
		with: (Character codePoint: 228).
	self 
		assert: ea
		encoder: WAXmlEncoder
		gives: ea.
	hiraA := (Character codePoint: 12354) greaseString.	"HIRAGANA LETTER A"
	hiraO := (Character codePoint: 12362) greaseString.	"HIRAGANA LETTER O"
	hiraAO := hiraA , hiraO.
	self 
		assert: hiraA
		encoder: WAUrlEncoder
		gives: '%E3%81%82'.
	self 
		assert: hiraO
		encoder: WAUrlEncoder
		gives: '%E3%81%8A'.
	self 
		assert: hiraAO
		encoder: WAUrlEncoder
		gives: '%E3%81%82' , '%E3%81%8A'!

testLanguageTag
	"this makes sure the encoder doesn't fall on the nose with unicode"
	"Make Japanese String from unicode. see http://www.unicode.org/charts/PDF/U3040.pdf"
	| leading hiraA hiraO hiraAO |
	leading := (Smalltalk classNamed: #JapaneseEnvironment) leadingChar.
	hiraA := (Character 
		leadingChar: leading
		code: 12354) greaseString.	"HIRAGANA LETTER A"
	hiraO := (Character 
		leadingChar: leading
		code: 12362) greaseString.	"HIRAGANA LETTER O"
	hiraAO := hiraA , hiraO.
	self 
		assert: hiraA
		encoder: WAXmlEncoder
		gives: (self stripLeadingCharFrom: hiraA).
	self 
		assert: hiraO
		encoder: WAXmlEncoder
		gives: (self stripLeadingCharFrom: hiraO).
	self 
		assert: hiraAO
		encoder: WAXmlEncoder
		gives: (self stripLeadingCharFrom: hiraAO)! !
!WAEncoderPharoTest categoriesFor: #createCodec!configuration!public! !
!WAEncoderPharoTest categoriesFor: #stripLeadingCharFrom:!private! !
!WAEncoderPharoTest categoriesFor: #testEncodedLatin1Url!public!tests! !
!WAEncoderPharoTest categoriesFor: #testEncodedSupplementaryMultilingualPlane!public!tests! !
!WAEncoderPharoTest categoriesFor: #testEncodedSupplementaryMultilingualPlaneUrl!public!tests! !
!WAEncoderPharoTest categoriesFor: #testEncodedUnicode!public!tests! !
!WAEncoderPharoTest categoriesFor: #testEncodedUnicodeUrl!public!tests! !
!WAEncoderPharoTest categoriesFor: #testLanguageTag!public!tests! !

WAPharoDocumentHandlerTest guid: (GUID fromString: '{A7948F67-7BF6-4F6F-98A4-0F81D226508B}')!
WAPharoDocumentHandlerTest comment: ''!
!WAPharoDocumentHandlerTest categoriesForClass!Unclassified! !
!WAPharoDocumentHandlerTest methodsFor!

testForm
	| handler context |
	self formClassExists ifFalse: [ ^ self ].
	
	handler := WADocumentHandler
		document: self sampleForm
		mimeType: self sampleForm defaultMimeType
		fileName: nil.
	
	context := WARequestContext request: WARequest new response: WABufferedResponse new.
	[ handler handle: context ] on: WAResponseNotification do: [ :n | ].
	
	self assert: context response notNil!

testFormWithMimeTypeGif
	"Test that requesting a form as GIF actually results in a GIF"
	| handler |
	self formClassExists ifFalse: [ ^ self ].
	
	handler := WADocumentHandler
		document: self sampleForm
		mimeType: WAMimeType imageGif
		fileName: nil.
	
	self assert: (handler document contents beginsWith: #(16r47 16r49 16r46 16r38) asByteArray) "GIF Magic number"!

testFormWithMimeTypeJpeg
	"Test that requesting a form as JPEG actually results in a JPEG"
	| handler |
	self formClassExists ifFalse: [ ^ self ].
	
	handler := WADocumentHandler
		document: self sampleForm
		mimeType: WAMimeType imageJpeg
		fileName: nil.
	
	self assert: (handler document contents beginsWith: #(16rFF 16rD8 16rFF 16rE0) asByteArray) "JPEG Magic number"!

testFormWithoutMimeType
	"Test that requesting a form without a mime type works"
	| handler |
	self formClassExists ifFalse: [ ^ self ].
	
	handler := WADocumentHandler
		document: self sampleForm
		mimeType: nil
		fileName: nil.
	
	self assert: handler document contents isEmptyOrNil not! !
!WAPharoDocumentHandlerTest categoriesFor: #testForm!public!tests! !
!WAPharoDocumentHandlerTest categoriesFor: #testFormWithMimeTypeGif!public!tests! !
!WAPharoDocumentHandlerTest categoriesFor: #testFormWithMimeTypeJpeg!public!tests! !
!WAPharoDocumentHandlerTest categoriesFor: #testFormWithoutMimeType!public!tests! !

WAPharoMimeDocumentTest guid: (GUID fromString: '{E106220E-7E35-46C6-A9C2-0E72D46AB230}')!
WAPharoMimeDocumentTest comment: ''!
!WAPharoMimeDocumentTest categoriesForClass!Unclassified! !
!WAPharoMimeDocumentTest methodsFor!

testAsMIMEDocumentForm
	| form document |
	self formClassExists ifFalse: [ ^ self ].
	
	form := self sampleForm.
	document := form seasideMimeDocument.
	self assert: document contentType = WAMimeType imageGif.
	self assert: (document content isKindOf: ByteArray)!

testAsMIMEDocumentFormColon
	| form document |
	self formClassExists ifFalse: [ ^ self ].
	
	form := self sampleForm.
	document := form seasideMimeDocumentType: WAMimeType imageJpeg.
	self assert: document contentType = WAMimeType imageJpeg.
	self assert: (document content isKindOf: ByteArray)!

testAsMIMEDocumentFormColonString
	| form document |
	self formClassExists ifFalse: [ ^ self ].
	form := self sampleForm.
	document := form seasideMimeDocumentType: WAMimeType imageJpeg greaseString.
	self assert: document contentType = WAMimeType imageJpeg.
	self assert: (document content isKindOf: ByteArray)!

testAsMIMEDocumentFormUnknown
	| form |
	self formClassExists ifFalse: [ ^ self ].
	
	form := self sampleForm.
	self should: [ form seasideMimeDocumentType: 'foo/bar' ] raise: Error.
	self should: [ form seasideMimeDocumentType: 'foo/bar' seasideMimeType ] raise: Error.
	self should: [ form seasideMimeDocumentType: 'image/zork' ] raise: Error.
	self should: [ form seasideMimeDocumentType: 'image/zork' seasideMimeType ] raise: Error.!

testAsMIMEDocumentMorph
	| morph document |
	morph := EllipseMorph new
		color: Color red;
		borderWidth: 1;
		borderColor: Color black;
		extent: 12 @ 12;
		yourself.
	document := morph seasideMimeDocument.
	self assert: document contentType = WAMimeType imageGif.
	self assert: (document content isKindOf: ByteArray)!

testAsMIMEDocumentMorphColol
	| morph document |
	morph := EllipseMorph new
		color: Color red;
		borderWidth: 1;
		borderColor: Color black;
		extent: 12 @ 12;
		yourself.
	document := morph seasideMimeDocumentType: WAMimeType imageJpeg.
	self assert: document contentType = WAMimeType imageJpeg.
	self assert: (document content isKindOf: ByteArray)!

testAsMIMEDocumentStream
	| document |
	document := 'dolphin' readStream seasideMimeDocument.
	self assert: document contentType = WAMimeType textPlain.
	self assert: document content = 'dolphin'!

testAsMIMEDocumentStreamColon
	| document |
	document := 'monkey' readStream seasideMimeDocument.
	document mimeType: 'text/html'.
	self assert: document contentType = WAMimeType textHtml.
	self assert: document content = 'monkey'!

testBinaryStreamSeasideMimeDocumentType
	| document mpeg |
	mpeg := WAMimeType main: 'audio' sub: 'mpeg'.
	document :=  #(1 2 3 4) asByteArray readStream seasideMimeDocumentType: mpeg.
	self assert: document mimeType = mpeg.
	self assert: document contents = #(1 2 3 4) asByteArray !

testTextStreamSeasideMimeDocumentType
	| document csv |
	csv := WAMimeType main: 'text' sub: 'csv'.
	document := 'foo,bar' readStream seasideMimeDocumentType: csv.
	self assert: document mimeType = csv.
	self assert: document contents = 'foo,bar'! !
!WAPharoMimeDocumentTest categoriesFor: #testAsMIMEDocumentForm!public!tests! !
!WAPharoMimeDocumentTest categoriesFor: #testAsMIMEDocumentFormColon!public!tests! !
!WAPharoMimeDocumentTest categoriesFor: #testAsMIMEDocumentFormColonString!public!tests! !
!WAPharoMimeDocumentTest categoriesFor: #testAsMIMEDocumentFormUnknown!public!tests! !
!WAPharoMimeDocumentTest categoriesFor: #testAsMIMEDocumentMorph!public!tests! !
!WAPharoMimeDocumentTest categoriesFor: #testAsMIMEDocumentMorphColol!public!tests! !
!WAPharoMimeDocumentTest categoriesFor: #testAsMIMEDocumentStream!public!tests! !
!WAPharoMimeDocumentTest categoriesFor: #testAsMIMEDocumentStreamColon!public!tests! !
!WAPharoMimeDocumentTest categoriesFor: #testBinaryStreamSeasideMimeDocumentType!public!tests! !
!WAPharoMimeDocumentTest categoriesFor: #testTextStreamSeasideMimeDocumentType!public!tests! !

"Binary Globals"!

