| package |
package := Package name: 'Swazoo Tests'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '2.2.jsc'.


package classNames
	add: #CompositeResourceTest;
	add: #FileResourceTest;
	add: #HeaderFieldTest;
	add: #HelloWorldResourceTest;
	add: #HomeResourceTest;
	add: #HTTPPostTest;
	add: #HTTPRequestTest;
	add: #HTTPResponseTest;
	add: #HTTPServerTest;
	add: #RedirectionResourceTest;
	add: #ResourceTest;
	add: #SiteIdentifierTest;
	add: #SiteTest;
	add: #SwazooBaseExtensionsTest;
	add: #SwazooBufferTest;
	add: #SwazooCacheControlTest;
	add: #SwazooCompilerTest;
	add: #SwazooConfigurationTest;
	add: #SwazooServerTest;
	add: #SwazooSocketTest;
	add: #SwazooStreamTest;
	add: #SwazooURITest;
	add: #URIParsingTest;
	add: #URIResolutionTest;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Sport\Sport';
	add: '..\..\Camp Smalltalk\SUnit\SUnit';
	add: 'Swazoo';
	yourself).

package!

"Class Definitions"!

TestCase subclass: #CompositeResourceTest
	instanceVariableNames: 'composite'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #FileResourceTest
	instanceVariableNames: 'resource'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #HeaderFieldTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #HelloWorldResourceTest
	instanceVariableNames: 'hello'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #HomeResourceTest
	instanceVariableNames: 'resource'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #HTTPPostTest
	instanceVariableNames: 'request'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #HTTPRequestTest
	instanceVariableNames: 'request'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #HTTPResponseTest
	instanceVariableNames: 'response'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #HTTPServerTest
	instanceVariableNames: 'server stream'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #RedirectionResourceTest
	instanceVariableNames: 'resource'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #ResourceTest
	instanceVariableNames: 'resource'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SiteIdentifierTest
	instanceVariableNames: 'identifier'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SiteTest
	instanceVariableNames: 'site'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SwazooBaseExtensionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SwazooBufferTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SwazooCacheControlTest
	instanceVariableNames: 'resource cacheTarget request cacheControl'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SwazooCompilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SwazooConfigurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SwazooServerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SwazooSocketTest
	instanceVariableNames: 'input output'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SwazooStreamTest
	instanceVariableNames: 'input output'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SwazooURITest
	instanceVariableNames: 'fooURI barURI queryURI'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #URIParsingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #URIResolutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

CompositeResourceTest guid: (GUID fromString: '{2EB54664-424F-48A2-BA30-3B86F56E30C5}')!
CompositeResourceTest comment: ''!
!CompositeResourceTest categoriesForClass!Unclassified! !
!CompositeResourceTest methodsFor!

sampleInSite
	| site |
	site := SwazooSite new.
	site host: 'swazoo.org' ip: '127.0.0.1' port: 8200.
	site addResource: composite!

setUp
	composite := CompositeResource uriPattern: '/'!

testAddResource
	| child |
	composite addResource: (child := HelloWorldResource uriPattern: 'hello.html').
	self assert: composite children size = 1.
	self assert: composite children first == child.
	self assert: child parent == composite!

testAddResources
	| child1 child2 |
	child1 := HelloWorldResource uriPattern: 'hello1.html'.
	child2 := HelloWorldResource uriPattern: 'hello2.html'.
	composite addResources: (Array with: child1 with: child2).
	self assert: composite children size = 2.
	composite children
		do: 
			[:each | 
			self assert: (composite children includes: each).
			self assert: each parent == composite]!

testCurrentUrl
	| child leaf |	
	self sampleInSite.
	self assert: composite currentUrl = 'http://swazoo.org:8200/'.
	composite addResource: (child := CompositeResource uriPattern: 'foo').
	self assert: child currentUrl = 'http://swazoo.org:8200/foo/'.
	child addResource: (leaf := HelloWorldResource uriPattern: 'hi.html').
	self assert: leaf currentUrl = 'http://swazoo.org:8200/foo/hi.html'.!

testEmptyURIPatternInvalid
	composite uriPattern: ''.
	self deny: composite isValidlyConfigured!

testNilURIPatternDoesNothing
	| pattern |
	pattern := composite uriPattern.
	composite uriPattern: nil.
	self assert: composite uriPattern = pattern!

testValidlyConfigured
	self assert: composite isValidlyConfigured! !
!CompositeResourceTest categoriesFor: #sampleInSite!public!testing! !
!CompositeResourceTest categoriesFor: #setUp!public!running! !
!CompositeResourceTest categoriesFor: #testAddResource!public!testing! !
!CompositeResourceTest categoriesFor: #testAddResources!public!testing! !
!CompositeResourceTest categoriesFor: #testCurrentUrl!public!testing! !
!CompositeResourceTest categoriesFor: #testEmptyURIPatternInvalid!public!testing! !
!CompositeResourceTest categoriesFor: #testNilURIPatternDoesNothing!public!testing! !
!CompositeResourceTest categoriesFor: #testValidlyConfigured!public!testing! !

FileResourceTest guid: (GUID fromString: '{0D623F1B-5E2B-43EA-80A9-BE7BB8045ACB}')!
FileResourceTest comment: ''!
!FileResourceTest categoriesForClass!Unclassified! !
!FileResourceTest methodsFor!

setUp
	| directory firstFile ws |
	directory := SpFilename named: 'fResTest'.
	directory exists ifFalse: [directory makeDirectory].
	firstFile :=  (SpFilename named: 'fResTest') construct: 'abc.html'.
	ws := firstFile writeStream.
	[ws nextPutAll: 'hello'] ensure: [ws close].
	resource := FileResource uriPattern: 'foo' filePath: 'fResTest'!

tearDown
	((SpFilename named: 'fResTest') construct: 'abc.html') delete.
	(SpFilename named: 'fResTest') delete!

testContentType
	self assert: (resource contentTypeFor: '.txt') = 'text/plain'.
	self assert: (resource contentTypeFor: '.html') = 'text/html'
!

testDirectoryIndex
	| request response |
	request := HTTPGet request: 'foo/'.
	resource directoryIndex: 'abc.html'.
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response code = 200.
	self assert: request resourcePath size = 1.
	self assert: request resourcePath first = 'foo'!

testETag
	"Filename etags do not have the leading and trailing double quotes.  Header fields add the quotes as necessary"

	| request response etag |
	request := HTTPGet request: 'foo/abc.html'.
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response code = 200.
	self 
		assert: (etag := (response headers fieldOfClass: HTTPETagField) entityTag) 
				notNil.
	request := HTTPGet request: 'foo/abc.html'.
	request headers addField: (HTTPIfNoneMatchField new addEntityTag: etag).
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response code = 304.
	self assert: (response headers fieldOfClass: HTTPETagField) entityTag = etag.
	request := HTTPGet request: 'foo/abc.html'.
	request headers addField: (HTTPIfNoneMatchField new valueFrom: '"wrong"').
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response code = 200.
	self assert: (response headers fieldOfClass: HTTPETagField) entityTag = etag!

testExistantFile
	| request response |
	request := HTTPGet request: 'foo/abc.html'.
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response code = 200.
	self assert: request resourcePath size = 1.
	self assert: request resourcePath first = 'foo'!

testNonexistantFile
	| request response |
	request := HTTPGet request: 'foo/notThere.html'.
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response isNil!

testRedirection
	| request response |
	request := HTTPGet request: 'foo'.
	resource directoryIndex: 'abc.html'.
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response code = 301.
	self assert: (response headers fieldNamed: 'Location') uri asString 
				= 'http://foo/'.
	self assert: (response headers fieldNamed: 'Location') uri host = 'foo'!

testRelativeFile
"it doesn't work anyway!!
	| request response |
	request := HTTPGet request: 'foo/../', resource fileDirectory tail, '/abc.html'.
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response isNil
"!

testSafeConstruct
	| request response |
	request := HTTPGet request: 'foo/../abc.html'.
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response code = 200.
	request := HTTPGet request: 'foo/.. /./abc.html'.
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response code = 200! !
!FileResourceTest categoriesFor: #setUp!public!running! !
!FileResourceTest categoriesFor: #tearDown!public!running! !
!FileResourceTest categoriesFor: #testContentType!public!testing! !
!FileResourceTest categoriesFor: #testDirectoryIndex!public!testing! !
!FileResourceTest categoriesFor: #testETag!public!testing! !
!FileResourceTest categoriesFor: #testExistantFile!public!testing! !
!FileResourceTest categoriesFor: #testNonexistantFile!public!testing! !
!FileResourceTest categoriesFor: #testRedirection!public!testing! !
!FileResourceTest categoriesFor: #testRelativeFile!public!testing! !
!FileResourceTest categoriesFor: #testSafeConstruct!public!testing! !

HeaderFieldTest guid: (GUID fromString: '{7364179F-645E-48EF-AD03-D014CC71A063}')!
HeaderFieldTest comment: ''!
!HeaderFieldTest categoriesForClass!Unclassified! !
!HeaderFieldTest methodsFor!

testCombine
	"Entity tags must be quoted strings - RFC 2616 3.11"

	| header1 header2 header3 |
	header1 := HeaderField fromLine: 'If-Match: "a"'.
	header2 := HeaderField fromLine: 'If-Match: "b","c"'.
	header3 := HeaderField fromLine: 'If-Match: "d"'.
	header1 combineWith: header2.
	self assert: header1 valuesAsString = '"a","b","c"'.
	header1 combineWith: header3.
	self assert: header1 valuesAsString = '"a","b","c","d"'!

testContentTypeMultiple
	"   HTTP/1.1 header field values can be folded onto multiple lines if the
   continuation line begins with a space or horizontal tab. All linear
   white space, including folding, has the same semantics as SP. A
   recipient MAY replace any linear white space with a single SP before
   interpreting the field value or forwarding the message downstream.

       LWS            = [CRLF] 1*( SP | HT )"

	| requestStream request field |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET / HTTP/1.1';
		nextPutLine: 'Host: 127.0.0.1';
		nextPutLine: 'Content-Type: text/html; ';
		nextPutLine: ' charset=iso-8859-1';
		crlf.
	request := HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents).
	field := request headers fieldNamed: 'content-type'.
	self assert: field name = 'Content-Type'.
	self assert: field mediaType = 'text/html'.
	self assert: (field transferCodings at: 'charset') = 'iso-8859-1'!

testValues
	"Entity tags are held internally as simple strings.  Any necessary leading and trailing double quotes are added by the header fields as needed.  Note that it is OK to have a comma in an entity tag - see the second of the group of 3 tags below."

	| header |
	header := HeaderField fromLine: 'If-Match: "xyzzy" '.
	self assert: header name = 'If-Match'.
	self assert: header entityTags first = 'xyzzy'.
	header := HeaderField 
				fromLine: 'If-Match: "xyzzy", "r2d2,xxxx", "c3piozzzz" '.
	self assert: header name = 'If-Match'.
	self assert: header entityTags first = 'xyzzy'.
	self assert: (header entityTags at: 2) = 'r2d2,xxxx'.
	self assert: header entityTags last = 'c3piozzzz'! !
!HeaderFieldTest categoriesFor: #testCombine!public!testing! !
!HeaderFieldTest categoriesFor: #testContentTypeMultiple!public!testing! !
!HeaderFieldTest categoriesFor: #testValues!public!testing! !

HelloWorldResourceTest guid: (GUID fromString: '{F3D3C8C6-6FF5-45DD-8312-BD763121A9DB}')!
HelloWorldResourceTest comment: ''!
!HelloWorldResourceTest categoriesForClass!Unclassified! !
!HelloWorldResourceTest methodsFor!

setUp
	hello := HelloWorldResource uriPattern: 'hello.html'!

testResponse
	| request response |
	request := HTTPGet request: 'hello.html'.
	response := URIResolution resolveRequest: request startingAt: hello.
	self assert: response code = 200.
	self assert: request resourcePath size = 1.
	self assert: request resourcePath first = 'hello.html'! !
!HelloWorldResourceTest categoriesFor: #setUp!public!running! !
!HelloWorldResourceTest categoriesFor: #testResponse!public!testing! !

HomeResourceTest guid: (GUID fromString: '{A3A4A988-4C17-4E78-A392-5D3A5B6C5BAD}')!
HomeResourceTest comment: ''!
!HomeResourceTest categoriesForClass!Unclassified! !
!HomeResourceTest methodsFor!

setUp
	resource := HomeResource uriPattern: '/' filePath: 'home'!

testRootFileFor
	| request |
	request := HTTPGet request: '/~someUser'.
	URIResolution new initializeRequest: request.
	self assert: (resource rootFileFor: request) asString 
				= (((SpFilename named: 'home') construct: 'someUser') construct: 'html') asString!

testValidateHomePath
	self assert: (resource validateHomePath: '~somebody').
	self assert: (resource validateHomePath: '~somebodyElse').
	self deny: (resource validateHomePath: 'someplace').
	self deny: (resource validateHomePath: 'some~body')! !
!HomeResourceTest categoriesFor: #setUp!public!running! !
!HomeResourceTest categoriesFor: #testRootFileFor!public!running! !
!HomeResourceTest categoriesFor: #testValidateHomePath!public!running! !

HTTPPostTest guid: (GUID fromString: '{40368149-7F8B-4CFA-ADAE-3583AC76AF7E}')!
HTTPPostTest comment: ''!
!HTTPPostTest categoriesForClass!Unclassified! !
!HTTPPostTest methodsFor!

crlf
	^String with: Character cr with: Character lf.!

fileContents
	"HTTPRequestTest new fileContents"
	| stream |
	stream := SwazooStream on: String new.
	stream
		nextPutLine: 'BEGIN:VCALENDAR';
		nextPutLine: 'PRODID:-//Squeak-iCalendar//-';
		nextPutLine: 'VERSION:2.0';
		nextPutLine: 'X-WR-CALNAME:test';
		nextPutLine: 'METHOD:PUBLISH';
		nextPutLine: 'BEGIN:VEVENT';
		nextPutLine: 'UID:an event with a start date and not date and time';
		nextPutLine: 'CATEGORIES:category1,category2';
		nextPutLine: 'CREATED:20050501T110231Z';
		nextPutLine: 'SEQUENCE:0';
		nextPutLine: 'SUMMARY:aTitle';
		nextPutLine: 'PRIORITY:5';
		nextPutLine: 'DTSTART;VALUE=DATE:20050425';
		nextPutLine: 'END:VEVENT';
		nextPutLine: 'END:VCALENDAR'.

	^stream writeBuffer contents asString!

postDashes
	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'POST  /document/aab.html HTTP/1.1';
		nextPutLine: 'Host: biart.eranova.si';
		nextPutLine: 'Content-Type: multipart/form-data; boundary= boundary';
		nextPutLine: 'Content-Length: 149';
            crlf;
		nextPutLine: '--boundary';
		nextPutLine: 'Content-Disposition: form-data; name="id5273"';
		crlf; 
		nextPutLine: '----';
		nextPutLine: '--boundary';
		nextPutLine: 'Content-Disposition: form-data; name="field2"';
		crlf; 
		nextPutLine: '- --';
		nextPutLine: '--boundary--'.

	^HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents)!

postEmpty
	"post entity with empty value"
	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'POST  /document/aab.html HTTP/1.1';
		nextPutLine: 'Host: biart.eranova.si';
		nextPutLine: 'Content-Type: multipart/form-data; boundary= boundary';
		nextPutLine: 'Content-Length: 75';
            crlf;
		nextPutLine: '--boundary';
		nextPutLine: 'Content-Disposition: form-data; name="id5273"';
		crlf; 
		nextPutLine: '';
		nextPutLine: '--boundary--'.

	^HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents)!

postFile
	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'POST  /document/aab.html HTTP/1.1';
		nextPutLine: 'Connection: Keep-Alive';
		nextPutLine: 'User-Agent: Mozilla/4.72 [en] (X11; I; Linux 2.3.51 i686)';
		nextPutLine: 'Host: biart.eranova.si';
		nextPutLine: 'Referer: http://www.bar.com/takeMeThere.html';
		nextPutLine: 'Content-Type: multipart/form-data; boundary= -----------------20752836116568320241700153999';
		nextPutLine: 'Content-Length: ', (527+self fileContents size) printString;
            crlf;
		nextPutLine: '-------------------20752836116568320241700153999';
		nextPutLine: 'Content-Disposition: form-data; name="id5273"';
		crlf; 
		nextPutLine: 'main';
		nextPutLine: '-------------------20752836116568320241700153999';
		nextPutLine: 'Content-Disposition: form-data; name="field2"';
		crlf; crlf;
		nextPutLine: '-------------------20752836116568320241700153999';
		nextPutLine: 'Content-Disposition: form-data; name="field7"; filename="event.ical"';
		nextPutLine: 'Content-Type: application/octet-stream';
		crlf;

		nextPutAll: self fileContents;

		crlf;
		nextPutLine: '-------------------20752836116568320241700153999';
		nextPutLine: 'Content-Disposition: form-data; name="attach"';
		crlf;
		nextPutLine: 'Attach';
		nextPutLine: '-------------------20752836116568320241700153999--'.

	^HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents)!

postPreambleEpilogue
	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'POST  /document/aab.html HTTP/1.1';
		nextPutLine: 'Host: biart.eranova.si';
		nextPutLine: 'Content-Type: multipart/form-data; boundary= boundary';
		nextPutLine: 'Content-Length: 146';
            crlf;
		nextPutLine: 'This is a multi-part message in MIME format';
		nextPutLine: '--boundary';
		nextPutLine: 'Content-Disposition: form-data; name="id5273"';
		crlf; 
		nextPutLine: 'main';
		nextPutLine: '--boundary--';
		nextPutLine: 'This is the epilogue'.

	^HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents)!

postSimple
	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'POST  /document/aab.html HTTP/1.1';
		nextPutLine: 'Host: biart.eranova.si';
		nextPutLine: 'Content-Type: multipart/form-data; boundary= boundary';
		nextPutLine: 'Content-Length: 79';
            crlf;
		nextPutLine: '--boundary';
		nextPutLine: 'Content-Disposition: form-data; name="id5273"';
		crlf; 
		nextPutLine: 'main';
		nextPutLine: '--boundary--'.

	^HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents)!

postUrlEncoded
	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'POST  /document/aab.html HTTP/1.1';
		nextPutLine: 'Host: biart.eranova.si';
		nextPutLine: 'Content-Type: application/x-www-form-urlencoded';
		nextPutLine: 'Content-Length: 36';
            crlf;
		nextPutAll: 'home=Cosby+one&favorite+flavor=flies'.

	^HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents)!

testBlockCopy
	"streaming with 8k blocks for performance"
	"this is just a basic test with content shorter that one block"
	| boundary message in out |
	boundary := '--boundary--'.
	message := 'just something'. 
	in := SwazooStream on: message, self crlf, boundary.
	out := WriteStream on: String new.
	HTTPPost new blockStreamingFrom: in to: out until: boundary.
	self assert: out contents = message.!

testPost10Simple
	"just one entity"
	| post |
	post := self postSimple.
	self assert: post isPostDataEmpty not.
	self assert: (post postDataStringAt: 'id5273') = 'main'.!

testPost2Empty
	"post entity with empty value"
	| post |
	post := self postEmpty.
	self assert: post isPostDataEmpty not.
	self assert: (post postDataStringAt: 'id5273') = ''.!

testPost3Dashes
	"some ---- inside post data"
	| post |
	post := self postDashes.
	self assert: post isPostDataEmpty not.
	self assert: (post postDataStringAt: 'id5273') = '----'.
	self assert: (post postDataStringAt: 'field2') = '- --'.!

testPost40File
	| post |
	post := self postFile.
	self assert: post isPostDataEmpty not.
	self assert: (post postDataStringAt: 'id5273') = 'main'.
	self assert: (post postDataStringAt: 'field2') = ''.
	self assert: (post postDataAt: 'field7') filename = 'event.ical'.
	self assert: ((post postDataStringAt: 'field7') readStream upTo: Character cr) = 'BEGIN:VCALENDAR'.
	self assert: (post postDataStringAt: 'field7') = self fileContents.
	self assert: (post postDataStringAt: 'attach') = 'Attach'.!

testPost41FileStreamed
	| post stream |
	post := self postFile.
	stream := WriteStream on: ByteArray new.
	post postDataAt: 'field7' streamTo: stream.
	self assert: (post isPostDataStreamedAt: 'field7').
	self deny: post postData isParsed. "post data read from socket defered"
	self assert: (post postDataStringAt: 'id5273') = 'main'. 
	self assert: post postData isParsed.  "first access to post data trigger full read and parse"
	self assert: (post postDataAt: 'field7') filename = 'event.ical'.
	self assert: (stream contents asString readStream upTo: Character cr) = 'BEGIN:VCALENDAR'.
	self assert: stream contents asString = self fileContents.
	self assert: (post postDataStringAt: 'attach') = 'Attach'.!

testPost42FileContentType
	| post |
	post := self postFile. "set the data to the post"
	self assert: post isPostDataEmpty not. "read the content of the stream"
	self assert: (post postDataAt: 'field7') contentType = 'application/octet-stream'.!

testPost5UrlEncoded
	"just one entity"
	| post |
	post := self postUrlEncoded.
	self assert: post isPostDataEmpty not.
	self assert: (post postDataStringAt: 'home') = 'Cosby one'.
	self assert: (post postDataStringAt: 'favorite flavor') = 'flies'.!

testPostPreambleEpilogue
	"mime preamble before first part and epilogue at the end. See #postPreambleEpilogue"
	| post |
	post := self postPreambleEpilogue.
	self assert: post isPostDataEmpty not.
	self assert: (post postDataStringAt: 'id5273') = 'main'.!

testPostRawEntity
	| requestStream post |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'POST /foobar HTTP/1.0';
		nextPutLine: 'Host: foo.com';
		nextPutLine: 'Content-Type: text/plain';
		nextPutLine: 'Content-Length: 12';
		crlf;
		nextPutLine: 'Hello, World'.
	post := HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents).
	self assert: post isPostDataEmpty.
	self assert: post entityBody = 'Hello, World'!

testPostUrlEncodedData
	| requestStream post |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'POST / HTTP/1.1';
		nextPutLine: 'Host: foo.com';
		nextPutLine: 'Content-Type: application/x-www-form-urlencoded';
		nextPutLine: 'Content-Length: 31';
		crlf;
		nextPutLine: 'address=+fs&product=&quantity=1'.
	post := HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents).
	self assert: (post postDataAt: 'address') value = ' fs'.
	self assert: (post postDataAt: 'product') value = ''.
	self assert: (post postDataAt: 'quantity') value = '1'! !
!HTTPPostTest categoriesFor: #crlf!public!requests! !
!HTTPPostTest categoriesFor: #fileContents!public!requests! !
!HTTPPostTest categoriesFor: #postDashes!public!requests! !
!HTTPPostTest categoriesFor: #postEmpty!public!requests! !
!HTTPPostTest categoriesFor: #postFile!public!requests! !
!HTTPPostTest categoriesFor: #postPreambleEpilogue!public!requests! !
!HTTPPostTest categoriesFor: #postSimple!public!requests! !
!HTTPPostTest categoriesFor: #postUrlEncoded!public!requests! !
!HTTPPostTest categoriesFor: #testBlockCopy!public!testing-mime parsing! !
!HTTPPostTest categoriesFor: #testPost10Simple!public!testing-posts! !
!HTTPPostTest categoriesFor: #testPost2Empty!public!testing-posts! !
!HTTPPostTest categoriesFor: #testPost3Dashes!public!testing-posts! !
!HTTPPostTest categoriesFor: #testPost40File!public!testing-file posts! !
!HTTPPostTest categoriesFor: #testPost41FileStreamed!public!testing-file posts! !
!HTTPPostTest categoriesFor: #testPost42FileContentType!public!testing-file posts! !
!HTTPPostTest categoriesFor: #testPost5UrlEncoded!public!testing-posts! !
!HTTPPostTest categoriesFor: #testPostPreambleEpilogue!public!testing-posts! !
!HTTPPostTest categoriesFor: #testPostRawEntity!public!testing-posts! !
!HTTPPostTest categoriesFor: #testPostUrlEncodedData!public!testing-posts! !

HTTPRequestTest guid: (GUID fromString: '{111DDAB9-B8A7-4BD3-848C-05F3D984717A}')!
HTTPRequestTest comment: ''!
!HTTPRequestTest categoriesForClass!Unclassified! !
!HTTPRequestTest methodsFor!

basicGet
	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET / HTTP/1.1';
		nextPutLine: 'Host: foo.com';
		crlf.
	^HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents)!

basicGetHTTP10
	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET / HTTP/1.0';
		crlf.
	^HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents)!

basicGetHTTP10Keepalive
	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET / HTTP/1.0';
		nextPutLine: 'Connection: Keep-Alive';
		crlf.
	^HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents)!

basicHead
	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'HEAD / HTTP/1.1';
		nextPutLine: 'Host: foo.com';
		crlf.
	^HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents)!

crlfOn: aStream 
	aStream
		nextPut: Character cr;
		nextPut: Character lf!

fullGet
	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET /aaa/bbb/ccc.html?foo=bar&baz=quux HTTP/1.1';
		nextPutLine: 'Connection: Keep-Alive';
		nextPutLine: 'User-Agent: Mozilla/4.72 [en] (X11; I; Linux 2.3.51 i686)';
		nextPutLine: 'Host: foo.com:8888';
		nextPutLine: 'Referer: http://www.bar.com/takeMeThere.html';
		crlf.
	^HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents)!

getMultiValueHeader
	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET /aaa/bbb/ccc.html?foo=bar&baz=quux HTTP/1.1';
		nextPutLine: 'Content-Type: multipart/form-data; boundary= --boundary';
		crlf.
	^HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents)!

portedGet
	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET / HTTP/1.1';
		nextPutLine: 'Host: foo.com:8888';
		crlf.
	^HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents)!

test10ConnectionClose
	request := self basicGetHTTP10.
	self assert: request wantsConnectionClose!

test10KeepAliveConnectionClose
	request := self basicGetHTTP10Keepalive.
	self deny: request wantsConnectionClose!

testBasicGet
	request := self basicGet.
	self assert: request isGet.
	self assert: request isHttp11.
	self deny: request isHead.
	self deny: request isPost.
	self deny: request isPut!

testBasicGetHost
	request := self basicGet.
	self assert: request host = 'foo.com'!

testBasicGetHTTP10
	request := self basicGetHTTP10.
	self assert: request isGet.
	self assert: request isHttp10.
	self deny: request isHead.
	self deny: request isPost.
	self deny: request isPut!

testBasicGetPort
	request := self basicGet.
	self assert: request port = 80!

testBasicHead
	request := self basicHead.
	self assert: request isHead.
	self deny: request isGet.
	self deny: request isPost.
	self deny: request isPut!

testConnection
	request := self fullGet.
	self assert: request connection = 'Keep-Alive'!

testGetMultiValueHeader
	| header |
	request := self getMultiValueHeader.
	header := request headerAt: 'Content-Type' ifAbsent: [nil].
	self assert: header mediaType = 'multipart/form-data'.
	self assert: (header transferCodings at: 'boundary') = '--boundary'.
	self assert: header valuesAsString = 'multipart/form-data boundary=--boundary'.

" 'Content-Type: multipart/form-data; boundary= --boundary'; "!

testHeaderAtIfPresent
	request := self basicGet.
	self assert: (request headers 
				fieldOfClass: HTTPIfRangeField
				ifPresent: [:header | header == (request headers fieldOfClass: HTTPIfRangeField)]
				ifAbsent: [true]).
	self assert: (request headers 
				fieldOfClass: HTTPHostField
				ifPresent: [:header | header == (request headers fieldOfClass: HTTPHostField)]
				ifAbsent: [false])!

testMissingContentType
	| requestStream result |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'POST /foobar HTTP/1.0';
		nextPutLine: 'Host: foo.com';
"	      nextPutLine: 'Content-Type: text/plain'. <-- this is missing!! - and should be for this test"
		nextPutLine: 'Content-Length: 12';
		crlf;
		nextPutLine: 'Hello, World'.
	result := SpExceptionContext 
		for: [(HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents)) 
				ensureFullRead] "because of defered post data parsing"
		on: SpError
		do: [:ex | ex].
	self assert: result class == SwazooHTTPPostError.
	^self!

testNo11ConnectionClose
	request := self basicGet.
	self deny: request wantsConnectionClose!

testNoEqualsQueries
	"The last assert here used to check that 'request queryAt: 'WSDL'' is nil, but a test for an empty string is more consistent with query argument formats."

	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET /test/typed.asmx?WSDL HTTP/1.1';
		nextPutLine: 'Host: foo.com:8888';
		crlf.
	request := HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents).
	self assert: (request includesQuery: 'WSDL').
	self assert: (request queryAt: 'WSDL') isEmpty!

testPortedGetPort
	request := self portedGet.
	self assert: request port = 8888!

testReferer
	request := self fullGet.
	self 
		assert: request referer asString = 'http://www.bar.com/takeMeThere.html'!

testRequestWithCRButNoLF

"	| requestStream result |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutAll: 'GET / HTTP/1.1';
		cr.
	result := SpExceptionContext 
				for: [HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents)]
				on: SpError
				do: [:ex | ex].
	self assert: result class == SwazooHTTPParseError.
	^self"!

testUserAgent
	request := self fullGet.
	self 
		assert: request userAgent = 'Mozilla/4.72 [en] (X11; I; Linux 2.3.51 i686)'! !
!HTTPRequestTest categoriesFor: #basicGet!public!requests-gets! !
!HTTPRequestTest categoriesFor: #basicGetHTTP10!public!requests-gets! !
!HTTPRequestTest categoriesFor: #basicGetHTTP10Keepalive!public!requests-gets! !
!HTTPRequestTest categoriesFor: #basicHead!public!requests-gets! !
!HTTPRequestTest categoriesFor: #crlfOn:!private! !
!HTTPRequestTest categoriesFor: #fullGet!public!requests-gets! !
!HTTPRequestTest categoriesFor: #getMultiValueHeader!public!requests-gets! !
!HTTPRequestTest categoriesFor: #portedGet!public!requests-gets! !
!HTTPRequestTest categoriesFor: #test10ConnectionClose!public!testing-other! !
!HTTPRequestTest categoriesFor: #test10KeepAliveConnectionClose!public!testing-other! !
!HTTPRequestTest categoriesFor: #testBasicGet!public!testing-gets! !
!HTTPRequestTest categoriesFor: #testBasicGetHost!public!testing-gets! !
!HTTPRequestTest categoriesFor: #testBasicGetHTTP10!public!testing-gets! !
!HTTPRequestTest categoriesFor: #testBasicGetPort!public!testing-gets! !
!HTTPRequestTest categoriesFor: #testBasicHead!public!testing-gets! !
!HTTPRequestTest categoriesFor: #testConnection!public!testing-other! !
!HTTPRequestTest categoriesFor: #testGetMultiValueHeader!public!testing-gets! !
!HTTPRequestTest categoriesFor: #testHeaderAtIfPresent!public!testing-other! !
!HTTPRequestTest categoriesFor: #testMissingContentType!public!testing-other! !
!HTTPRequestTest categoriesFor: #testNo11ConnectionClose!public!testing-other! !
!HTTPRequestTest categoriesFor: #testNoEqualsQueries!public!testing-other! !
!HTTPRequestTest categoriesFor: #testPortedGetPort!public!testing-gets! !
!HTTPRequestTest categoriesFor: #testReferer!public!testing-other! !
!HTTPRequestTest categoriesFor: #testRequestWithCRButNoLF!public!testing-other! !
!HTTPRequestTest categoriesFor: #testUserAgent!public!testing-other! !

HTTPResponseTest guid: (GUID fromString: '{870FBCB5-2657-4FB6-9325-0A62A587F8FA}')!
HTTPResponseTest comment: ''!
!HTTPResponseTest categoriesForClass!Unclassified! !
!HTTPResponseTest methodsFor!

crlf
	^String with: Character cr with: Character lf!

testInternalServerError
	| ws rs |
	response := HTTPResponse internalServerError.
	ws := SwazooStream on: String new.
	response printStatusOn: ws.
	rs := SwazooStream on: ws writeBuffer contents.
	self assert: rs nextLine = 'HTTP/1.1 500 Internal Server Error'!

testOK
	| ws rs |
	response := HTTPResponse ok.
	ws := SwazooStream on: String new.
	response printStatusOn: ws.
	rs := SwazooStream on: ws writeBuffer contents.
	self assert: rs nextLine = 'HTTP/1.1 200 OK'!

testResponseTypes
	self assert: (HTTPResponse badRequest) isBadRequest.
	self assert: (HTTPResponse found) isFound.
	self assert: (HTTPResponse internalServerError) isInternalServerError.
	self assert: (HTTPResponse movedPermanently) isMovedPermanently.
	self assert: (HTTPResponse notFound) isNotFound.
	self assert: (HTTPResponse notImplemented) isNotImplemented.
	self assert: (HTTPResponse notModified) isNotModified.
	self assert: (HTTPResponse ok) isOk.
	self assert: (HTTPResponse redirectLink) isRedirectLink.
	self assert: (HTTPResponse seeOther) isSeeOther.! !
!HTTPResponseTest categoriesFor: #crlf!private! !
!HTTPResponseTest categoriesFor: #testInternalServerError!public!testing! !
!HTTPResponseTest categoriesFor: #testOK!public!testing! !
!HTTPResponseTest categoriesFor: #testResponseTypes!public!testing! !

HTTPServerTest guid: (GUID fromString: '{381FB71E-7D37-46FE-9F86-62A00D5116AF}')!
HTTPServerTest comment: ''!
!HTTPServerTest categoriesForClass!Unclassified! !
!HTTPServerTest methodsFor!

setUp
	| socket |
	(Delay forMilliseconds: 100) wait.
	server := HTTPServer new.
	[server ip: 'localhost'; port: 8123.
	server start]
		fork.
	(Delay forMilliseconds: 100) wait.
" 	stream := (SocketAccessor newTCPclientToHost: 'localhost' port: 8123) 
				readAppendStream"
	socket := SpSocket connectToServerOnHost:  'localhost' port: 8123.
	stream := SwazooStream socket: socket !

tearDown
	server stop.
	stream close.
	stream := nil.
	Delay forMilliseconds: 500.
!

testServing
	self assert: server isServing!

testStopServing
	server stop.
	self deny: server isServing! !
!HTTPServerTest categoriesFor: #setUp!public!running! !
!HTTPServerTest categoriesFor: #tearDown!public!running! !
!HTTPServerTest categoriesFor: #testServing!public!tests! !
!HTTPServerTest categoriesFor: #testStopServing!public!tests! !

RedirectionResourceTest guid: (GUID fromString: '{148811F7-A5D6-4ACE-8042-C1359F138812}')!
RedirectionResourceTest comment: ''!
!RedirectionResourceTest categoriesForClass!Unclassified! !
!RedirectionResourceTest methodsFor!

setUp
	resource := RedirectionResource uriPattern: 'foo'
				targetUri: 'http://abc.def.com'!

testGetResource
	| request response |
	request := HTTPGet request: 'foo'.
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response code = 301.
	self assert: (response headers fieldNamed: 'Location') uri asString 
				= 'http://abc.def.com'.
	self assert: request resourcePath size = 1.
	self assert: request resourcePath first = 'foo'! !
!RedirectionResourceTest categoriesFor: #setUp!public!running! !
!RedirectionResourceTest categoriesFor: #testGetResource!public!testing! !

ResourceTest guid: (GUID fromString: '{03AAB7DC-D07B-43A4-A639-C2552A06B399}')!
ResourceTest comment: ''!
!ResourceTest categoriesForClass!Unclassified! !
!ResourceTest methodsFor!

basicGet: uri
	| ws |
	ws := WriteStream on: String new.
	ws nextPutAll: 'GET ', uri, ' HTTP/1.1'.
	self crlfOn: ws.
	ws nextPutAll: 'Host: swazoo.org'.
	self crlfOn: ws.
	self crlfOn: ws.
	^HTTPRequest readFrom: (ReadStream on: ws contents)!

basicGetUri: uriString
	| ws |
	ws := WriteStream on: String new.
	ws nextPutAll: 'GET ' , uriString , ' HTTP/1.1'.
	self crlfOn: ws.
	ws nextPutAll: 'Host: swazoo.org'.
	self crlfOn: ws.
	self crlfOn: ws.
	^HTTPRequest readFrom: (ReadStream on: ws contents)!

basicGetUri: uriString host: hostname port: port 
	| ws |
	ws := WriteStream on: String new.
	ws nextPutAll: 'GET ' , uriString , ' HTTP/1.1'.
	self crlfOn: ws.
	ws nextPutAll: 'Host: ' , hostname.
	port notNil 
		ifTrue: 
			[ws
				nextPut: $:;
				print: port].
	self crlfOn: ws.
	self crlfOn: ws.
	^HTTPRequest readFrom: (ReadStream on: ws contents)!

crlfOn: aStream 
	aStream
		nextPut: Character cr;
		nextPut: Character lf!

setUp
	resource := SwazooResource uriPattern: 'foo'!

testEmptyURIPatternInvalid
	resource uriPattern: ''.
	self deny: resource isValidlyConfigured!

testEnabledByDefault
	self assert: resource isEnabled!

testNilURIPatternDoesNothing
	| pattern |
	pattern := resource uriPattern.
	resource uriPattern: nil.
	self assert: resource uriPattern = pattern!

testValidlyConfigured
	self assert: resource isValidlyConfigured! !
!ResourceTest categoriesFor: #basicGet:!private! !
!ResourceTest categoriesFor: #basicGetUri:!private! !
!ResourceTest categoriesFor: #basicGetUri:host:port:!private! !
!ResourceTest categoriesFor: #crlfOn:!private! !
!ResourceTest categoriesFor: #setUp!public!running! !
!ResourceTest categoriesFor: #testEmptyURIPatternInvalid!public!testing! !
!ResourceTest categoriesFor: #testEnabledByDefault!public!testing! !
!ResourceTest categoriesFor: #testNilURIPatternDoesNothing!public!testing! !
!ResourceTest categoriesFor: #testValidlyConfigured!public!testing! !

SiteIdentifierTest guid: (GUID fromString: '{F207B2E2-37D2-4DDC-BAB8-BB8AE8006E90}')!
SiteIdentifierTest comment: ''!
!SiteIdentifierTest categoriesForClass!Unclassified! !
!SiteIdentifierTest methodsFor!

setUp
	identifier := SiteIdentifier 
				host: 'localhost'
				ip: '127.0.0.1'
				port: 80!

testCaseInsensitiveMatch
	| another |
	another := SiteIdentifier 
				host: 'lOCaLhOST'
				ip: '127.0.0.1'
				port: 80.
	self assert: (identifier match: another)!

testCurrentUrl
	self assert: identifier currentUrl = 'http://localhost'.
		identifier := SiteIdentifier 
				host: 'localhost'
				ip: '127.0.0.1'
				port: 81.
	self assert: identifier currentUrl = 'http://localhost:81'!

testHostMismatch
	| another |
	another := SiteIdentifier 
				host: 'thisIsMyMachine'
				ip: '127.0.0.1'
				port: 80.
	self deny: (identifier match: another)!

testIPMismatch
	| another |
	another := SiteIdentifier 
				host: 'localhost'
				ip: '127.0.0.2'
				port: 80.
	self deny: (identifier match: another)!

testMatch
	| another |
	another := SiteIdentifier 
				host: 'localhost'
				ip: '127.0.0.1'
				port: 80.
	self assert: (identifier match: another)!

testPortMismatch
	| another |
	another := SiteIdentifier 
				host: 'localhost'
				ip: '127.0.0.1'
				port: 81.
	self deny: (identifier match: another)! !
!SiteIdentifierTest categoriesFor: #setUp!public!running! !
!SiteIdentifierTest categoriesFor: #testCaseInsensitiveMatch!public!testing! !
!SiteIdentifierTest categoriesFor: #testCurrentUrl!public!testing! !
!SiteIdentifierTest categoriesFor: #testHostMismatch!public!testing! !
!SiteIdentifierTest categoriesFor: #testIPMismatch!public!testing! !
!SiteIdentifierTest categoriesFor: #testMatch!public!testing! !
!SiteIdentifierTest categoriesFor: #testPortMismatch!public!testing! !

SiteTest guid: (GUID fromString: '{A2106CB2-A435-4908-8951-5CFBF83829AB}')!
SiteTest comment: ''!
!SiteTest categoriesForClass!Unclassified! !
!SiteTest methodsFor!

addSecondAlias
	site addAlias: (SiteIdentifier 
				host: 'swazoo2.org'
				ip: '127.0.0.2'
				port: 8202).!

setUp
	super setUp.
	site := SwazooSite new.
	site addAlias: (SiteIdentifier 
				host: 'swazoo.org'
				ip: '127.0.0.1'
				port: 8200)!

testCurrentUrl
	site currentUrl = 'http://swazoo.org:8200'.
	self addSecondAlias.
	site currentUrl = 'http://swazoo.org:8200'.!

testCurrentUrl80
	| aSite |
	aSite := SwazooSite new.
	aSite addAlias: (SiteIdentifier
			host: 'swazoo.org'
			ip: '127.0.0.1'
			port: 80).
	aSite currentUrl = 'http://swazoo.org'.
	aSite currentUrl = 'http://swazoo.org'! !
!SiteTest categoriesFor: #addSecondAlias!public!running! !
!SiteTest categoriesFor: #setUp!public!running! !
!SiteTest categoriesFor: #testCurrentUrl!public!testing! !
!SiteTest categoriesFor: #testCurrentUrl80!public!testing! !

SwazooBaseExtensionsTest guid: (GUID fromString: '{A481D3B7-EC6C-4D22-B6E3-9583CB3150A2}')!
SwazooBaseExtensionsTest comment: ''!
!SwazooBaseExtensionsTest categoriesForClass!Unclassified! !
!SwazooBaseExtensionsTest methodsFor!

testCharacterArrayTrimBlanks
	self 
		assert: (HTTPString trimBlanksFrom: '   a b c d e f g') = 'a b c d e f g'.
	self assert: (HTTPString trimBlanksFrom: 'no blanks') = 'no blanks'.
	self assert: (HTTPString trimBlanksFrom: ' leading') = 'leading'.
	self assert: (HTTPString trimBlanksFrom: 'trailing ') = 'trailing'.
	self assert: (HTTPString trimBlanksFrom: '') = ''.
	self 
		assert: (HTTPString 
				trimBlanksFrom: (String with: Character cr with: Character lf)) isEmpty!

testFilenameEtag
	"The filename etag is a simple string and does not contain double quotes.  Header fields apply double quotes as necessary when writing themselves."

	| fn etag1 etag2 |
	fn := SpFilename named: 'etagTest'.
	[fn writeStream nextPut: $-; close. "create file"
	etag1 := fn etag.
	(Delay forSeconds: 1) wait.
	fn appendStream nextPut: $-; close. "modify file"
	etag2 := fn etag.

	self assert: (etag1 isKindOf: String).
	self assert: (etag2 isKindOf: String).
	self deny: etag1 = etag2] 
		ensure: [fn delete]!

testStringNewRandom
	| sizes strings |
	sizes := #(5 20 6127 2 100).
	strings := sizes collect: [:each |  HTTPString newRandomString: each].
	strings with: sizes do: [:string :size | self assert: string size = size]! !
!SwazooBaseExtensionsTest categoriesFor: #testCharacterArrayTrimBlanks!public!testing! !
!SwazooBaseExtensionsTest categoriesFor: #testFilenameEtag!public!testing! !
!SwazooBaseExtensionsTest categoriesFor: #testStringNewRandom!public!testing! !

SwazooBufferTest guid: (GUID fromString: '{9F4A1FEC-5641-491F-8D12-667E12EA2D48}')!
SwazooBufferTest comment: ''!
!SwazooBufferTest categoriesForClass!Unclassified! !
!SwazooBufferTest methodsFor!

testBoundaryFull
	| boundary buffer |
	boundary := '--boundary--'.
	buffer := SwazooBuffer on: 'just--boundary--something'.  "full boundary"
	self assert: (buffer signsOfBoundary: boundary) = boundary size.!

testBoundaryMixed
	| boundary buffer |
	boundary := '--boundary--'.
	buffer := SwazooBuffer on: 'yes,--just--boundary--something'.  "partial, later full boundary"
	self assert: (buffer signsOfBoundary: boundary) = boundary size.!

testBoundaryOnEdge
	"part of boundary at the end of this buffer, remaining probably in the next"
	| boundary buffer |
	boundary := '--boundary--'.
	buffer := SwazooBuffer on: 'just something-'.  "just first char of boundary"
	self assert: (buffer signsOfBoundary: boundary) = 1.
	buffer := SwazooBuffer on: 'just something--'.  "two chars"
	self assert: (buffer signsOfBoundary: boundary) = 2.
	buffer := SwazooBuffer on: 'just something--bound'.  "half"
	self assert: (buffer signsOfBoundary: boundary) = 7.
	buffer := SwazooBuffer on: 'just something--boundary--'.  "full boundary at the edge"
	self assert: (buffer signsOfBoundary: boundary) = boundary size.!

testBoundaryOnEdgeMixed
	"signs of boundary in the middle part at the end of this buffer, remaining probably in the next"
	| boundary buffer |
	boundary := '--boundary--'.
	buffer := SwazooBuffer on: 'just-something-'.  "sign in the middle, one char at the end"
	self assert: (buffer signsOfBoundary: boundary) = 1.
	buffer := SwazooBuffer on: 'just-something--'.  "two chars"
	self assert: (buffer signsOfBoundary: boundary) = 2.
	buffer := SwazooBuffer on: 'just-so--mething--bound'.  "even more mixed case"
	self assert: (buffer signsOfBoundary: boundary) = 7.!

testBoundarySimple
	| boundary buffer |
	boundary := '--boundary--'.
	buffer := SwazooBuffer on: 'just something'.  "no boundary"
	self assert: (buffer signsOfBoundary: boundary) = 0.
	buffer := SwazooBuffer on: 'just-something'.  "sign of boundary"
	self assert: (buffer signsOfBoundary: boundary) = 0.
	buffer := SwazooBuffer on: 'just--something'.  "more sign of boundary"
	self assert: (buffer signsOfBoundary: boundary) = 0.
	buffer := SwazooBuffer on: 'just--boundary--something'.  "full boundary"
	self assert: (buffer signsOfBoundary: boundary) = boundary size.!

testIndexOfBoundary
	"index of start of boundary in buffer, both full or partial at the edge/end of buffer"
	| boundary buffer |
	boundary := '--boundary--'.
	buffer := SwazooBuffer on: 'just something'.  "no boundary"
	self assert: (buffer indexOfBoundary: boundary) = 0.
	buffer := SwazooBuffer on: 'just--boundary--something-'.  "full boundary"
	self assert: (buffer indexOfBoundary: boundary) = 5.
	buffer := SwazooBuffer on: 'just something--boun'.  "partial boundary at the edge"
	self assert: (buffer indexOfBoundary: boundary) = 15.
	buffer := SwazooBuffer on: 'just something-'.  "partial boundary, one char only"
	self assert: (buffer indexOfBoundary: boundary) = 15.
	buffer := SwazooBuffer on: 'just-som--ething--boun'.  "mixed case with partial at the edge"
	self assert: (buffer indexOfBoundary: boundary) = 17.! !
!SwazooBufferTest categoriesFor: #testBoundaryFull!public!testing-mime boundary! !
!SwazooBufferTest categoriesFor: #testBoundaryMixed!public!testing-mime boundary! !
!SwazooBufferTest categoriesFor: #testBoundaryOnEdge!public!testing-mime boundary! !
!SwazooBufferTest categoriesFor: #testBoundaryOnEdgeMixed!public!testing-mime boundary! !
!SwazooBufferTest categoriesFor: #testBoundarySimple!public!testing-mime boundary! !
!SwazooBufferTest categoriesFor: #testIndexOfBoundary!public!testing-mime boundary! !

SwazooCacheControlTest guid: (GUID fromString: '{8589898C-2F91-4ABF-8144-4A9414F08B9B}')!
SwazooCacheControlTest comment: ''!
!SwazooCacheControlTest categoriesForClass!Unclassified! !
!SwazooCacheControlTest methodsFor!

setUp
	| directory firstFile ws |
	directory := SpFilename named: 'fResTest'.
	directory exists ifFalse: [directory makeDirectory].
	firstFile := directory construct: 'abc.html'.
	ws := firstFile writeStream.
	[ws nextPutAll: 'hello'] ensure: [ws close].
	resource := FileResource uriPattern: 'foo' filePath: 'fResTest'.
	request := HTTPGet request: 'foo/abc.html'.
	URIResolution resolveRequest: request startingAt: resource.
	cacheControl := SwazooCacheControl new request: request
				cacheTarget: (cacheTarget := resource fileFor: request)!

tearDown
	((SpFilename named: 'fResTest') construct: 'abc.html') delete.
	(SpFilename named: 'fResTest') delete!

testIfModifiedSinceModified
	| response timestampInThePast |
	request := HTTPGet request: 'foo/abc.html'.
	timestampInThePast := SpTimestamp fromDate: (Date today subtractDays: 1)
				andTime: Time now.
	request headers addField: (HTTPIfModifiedSinceField new 
				valueFrom: timestampInThePast asRFC1123String).
	cacheControl := SwazooCacheControl new request: request
				cacheTarget: cacheTarget.
	self assert: cacheControl isNotModified not.
	self assert: cacheControl isIfModifiedSince.
	response := HTTPResponse ok.
	cacheControl addResponseHeaders: response.
	self 
		assert: (response headers fieldNamed: 'ETag') entityTag = cacheTarget etag.
	self assert: (response headers fieldNamed: 'Last-Modified') timestamp 
				= cacheTarget lastModified!

testIfModifiedSinceNot
	| response |
	request headers 
		addField: (HTTPIfModifiedSinceField new valueFrom: cacheTarget lastModified asRFC1123String).
	self assert: cacheControl isNotModified.
	self assert: cacheControl isIfModifiedSince not.
	response := HTTPResponse notModified.
	cacheControl addResponseHeaders: response.
	self assert: (response headers fieldNamed: 'ETag') entityTag = cacheTarget etag.
	self assert: (response headers fieldNamed: 'Last-Modified') timestamp = cacheTarget lastModified!

testIfNoneMatchHeaderMatch
	"same etag"

	| response |
	request headers addField: (HTTPIfNoneMatchField new addEntityTag: cacheTarget etag).
	self assert: cacheControl isNotModified.
	self deny: cacheControl isIfNoneMatch.

	"do NOT include last-modified"
	response := HTTPResponse notModified.
	cacheControl addResponseHeaders: response.
	self assert: (response headers fieldNamed: 'ETag') entityTag = cacheTarget etag.
	self assert: (response headers fieldNamed: 'Last-Modified' ifNone: [nil])  isNil!

testIfNoneMatchHeaderNone
	"same etag"

	| response |
	request := HTTPGet request: 'foo/abc.html'.
	request headers addField: (HTTPIfNoneMatchField new valueFrom: 'blah').
	cacheControl := SwazooCacheControl new request: request
				cacheTarget: cacheTarget.
	self assert: cacheControl isNotModified not.
	self assert: cacheControl isIfNoneMatch.
	response := HTTPResponse ok.
	cacheControl addResponseHeaders: response.
	self 
		assert: (response headers fieldNamed: 'ETag') entityTag = cacheTarget etag.
	self assert: (response headers fieldNamed: 'Last-Modified') timestamp 
				= cacheTarget lastModified!

testNoHeaders
	| response |
	self assert: cacheControl isNotModified not.
	self assert: cacheControl isIfNoneMatch.
	self assert: cacheControl isIfModifiedSince.

	"add both"
	response := HTTPResponse ok.
	cacheControl addResponseHeaders: response.
	self 
		assert: (response headers fieldNamed: 'ETag') entityTag = cacheTarget etag.
	self assert: (response headers fieldNamed: 'Last-Modified') timestamp 
				= cacheTarget lastModified! !
!SwazooCacheControlTest categoriesFor: #setUp!public!running! !
!SwazooCacheControlTest categoriesFor: #tearDown!public!running! !
!SwazooCacheControlTest categoriesFor: #testIfModifiedSinceModified!public!testing! !
!SwazooCacheControlTest categoriesFor: #testIfModifiedSinceNot!public!testing! !
!SwazooCacheControlTest categoriesFor: #testIfNoneMatchHeaderMatch!public!testing! !
!SwazooCacheControlTest categoriesFor: #testIfNoneMatchHeaderNone!public!testing! !
!SwazooCacheControlTest categoriesFor: #testNoHeaders!public!testing! !

SwazooCompilerTest guid: (GUID fromString: '{9161CA74-0FE4-4046-9EC9-21316378A52B}')!
SwazooCompilerTest comment: ''!
!SwazooCompilerTest categoriesForClass!Unclassified! !
!SwazooCompilerTest methodsFor!

testEvaluate
	self assert: (SwazooCompiler evaluate: '1 + 2 * 3') = 9!

testEvaluateReceiver
	self assert: (SwazooCompiler evaluate: 'self + 2 * 3' receiver: 1) = 9! !
!SwazooCompilerTest categoriesFor: #testEvaluate!public!running! !
!SwazooCompilerTest categoriesFor: #testEvaluateReceiver!public!running! !

SwazooConfigurationTest guid: (GUID fromString: '{EA0D019F-1E10-4D63-9A11-67A43AFB5E0F}')!
SwazooConfigurationTest comment: ''!
!SwazooConfigurationTest categoriesForClass!Unclassified! !
!SwazooConfigurationTest methodsFor!

testCompositeResourceSite
	| rs site composite howdy duh hithere |
	rs := ReadStream 
				on: '<Site>
 <CompositeResource uriPattern: ''/''>
  <HelloWorldResource uriPattern: ''howdy''>
  <CompositeResource uriPattern: ''duh''>
   <HelloWorldResource uriPattern: ''hithere''>
  </CompositeResource>
 </CompositeResource>
</Site>'.
	site := SwazooSite new readFrom: rs.
	self assert: site children size = 1.
	composite := site children first.
	self assert: composite class == CompositeResource.
	self assert: composite uriPattern = '/'.
	self assert: composite children size = 2.
	self assert: composite parent == site.
	howdy := composite children first.
	self assert: (howdy class == HelloWorldResource).
	self assert: howdy uriPattern = 'howdy'.
	self assert: howdy parent == composite.
	duh := composite children last.
	self assert: duh children size = 1.
	self assert: duh class == CompositeResource.
	self assert: duh uriPattern = 'duh'.
	self assert: duh parent == composite.
	hithere := duh children first.
	self assert: hithere class == HelloWorldResource.
	self assert: hithere uriPattern = 'hithere'.
	self assert: hithere parent == duh.!

testEmptySite
	| rs site alias |
	rs := ReadStream 
				on: '<Site>
 <SiteIdentifier ip: ''192.168.1.66'' port: 80 host: ''swazoo.org''>
</Site>'.
	site := SwazooSite new readFrom: rs.
	self assert: site aliases size = 1.
	self assert: site currentUrl = 'http://swazoo.org/'.
	alias := site aliases first.
	self assert: alias host = 'swazoo.org'.
	self assert: alias ip = '192.168.1.66'.
	self assert: alias port = 80!

testFileResourceSite
	| rs site resource |
	rs := ReadStream 
				on: '<Site>
<SiteIdentifier ip: ''192.168.1.66'' port: 80 host: ''swazoo.org''>
 <FileResource uriPattern: ''/'' filePath: ''files''>
</Site>'.
	site := SwazooSite new readFrom: rs.
	self assert: site children size = 1.
	resource := site children first.
	self assert: resource class == FileResource.
	self assert: resource uriPattern = '/'.
	self assert: resource filePath = 'files'.
	self assert: resource parent == site.
	self assert: resource currentUrl = 'http://swazoo.org/'.!

testMultipleResourcesSite
	| rs site resource1 resource2 |
	rs := ReadStream 
				on: '<Site>
 <HelloWorldResource uriPattern: ''/''>
 <HelloWorldResource uriPattern: ''/''>
</Site>'.
	site := SwazooSite new readFrom: rs.
	self assert: site children size = 2.
	resource1 := site children first.
	self assert: (resource1 class == HelloWorldResource).
	self assert: resource1 uriPattern = '/'.
	resource2 := site children last.
	self assert: resource2 class == HelloWorldResource.
	self assert: resource2 uriPattern = '/'!

testMultipleSites
	| rs sites site alias1 alias2 |
	rs := ReadStream 
				on: '<Site>
 <SiteIdentifier ip: ''192.168.1.66'' port: 80 host: ''swazoo.org''>
 <SiteIdentifier ip: ''192.168.1.66'' port: 81 host: ''swazoo.org''>
</Site>
<Site>
</Site>'.
	sites := SwazooServer readSitesFrom: rs.
	self assert: sites size = 2.
	site := sites first.
	self assert: site aliases size = 2.
	alias1 := site aliases first.
	self assert: alias1 host = 'swazoo.org'.
	self assert: alias1 ip = '192.168.1.66'.
	self assert: alias1 port = 80.
	alias2 := site aliases last.
	self assert: alias2 host = 'swazoo.org'.
	self assert: alias2 ip = '192.168.1.66'.
	self assert: alias2 port = 81!

testSingleResourceSite
	| rs site resource |
	rs := ReadStream on: '<Site>
<SiteIdentifier ip: ''192.168.1.66'' port: 80 host: ''swazoo.org''>
 <HelloWorldResource uriPattern: ''/''>
</Site>'.
	site := SwazooSite new readFrom: rs.
	self assert: site children size = 1.
	resource := site children first.
	self assert: (resource class == HelloWorldResource).
	self assert: resource uriPattern = '/'.
	self assert: resource parent == site.
	self assert: resource currentUrl = 'http://swazoo.org/'.!

testSiteTag
	| rs config tag |
	rs := ReadStream on: '  <Site>  

</Site>   '.
	config := SwazooSite new.
	tag := config nextTagFrom: rs.
	self assert: tag = 'Site'.
	tag := config nextTagFrom: rs.
	self assert: tag = '/Site'.
	self assert: (config nextTagFrom: rs) isNil! !
!SwazooConfigurationTest categoriesFor: #testCompositeResourceSite!public!testing! !
!SwazooConfigurationTest categoriesFor: #testEmptySite!public!testing! !
!SwazooConfigurationTest categoriesFor: #testFileResourceSite!public!testing! !
!SwazooConfigurationTest categoriesFor: #testMultipleResourcesSite!public!testing! !
!SwazooConfigurationTest categoriesFor: #testMultipleSites!public!testing! !
!SwazooConfigurationTest categoriesFor: #testSingleResourceSite!public!testing! !
!SwazooConfigurationTest categoriesFor: #testSiteTag!public!testing! !

SwazooServerTest guid: (GUID fromString: '{BB866307-E712-4E3B-B36C-8AEF41A9C2CE}')!
SwazooServerTest comment: ''!
!SwazooServerTest categoriesForClass!Unclassified! !
!SwazooServerTest methodsFor!

removeAllTestSites

	SwazooServer singleton allSites do: [:each | SwazooServer singleton removeSite: each]!

removeTestSiteIfAny
	
	| site |
	site := SwazooServer siteNamed: self testSiteName.
	site notNil ifTrue: [SwazooServer singleton removeSite: site]!

testAccessingSite
	
	| site |
	self removeTestSiteIfAny.
	site := (SwazooSite new)
		name: self testSiteName;
		host: 'test.org' ip: 'localhost' port: 8543.
	[SwazooServer singleton addSite: site.
	self assert: (SwazooServer siteNamed: self testSiteName) notNil.
	site := SwazooServer siteNamed: self testSiteName.
	self assert: site name = self testSiteName.
	self assert: (SwazooServer siteHostnamed: 'test.org') notNil.
	site := SwazooServer siteHostnamed: 'test.org'.
	self assert: site host = 'test.org']
		ensure: [SwazooServer singleton removeSite: site]!

testAddingAllInterfacesSite
	"site to listen on all IP interfaces but on specified port"
	
	| site server |
	self removeAllTestSites.
	server := SwazooServer singleton.
	self assert: (server siteNamed: self testSiteName) isNil.
	site := (SwazooSite new)
		name: self testSiteName;
		host: '*' ip: '*' port: 7261.
	[server addSite: site.
	self assert: (server siteNamed: self testSiteName) notNil]
		ensure: [server removeSite: site]!

testAddingSite
	
	| site server nrSites |
	self removeTestSiteIfAny.
	server := SwazooServer singleton.
	nrSites := server sites size.
	self assert: (server siteNamed: self testSiteName) isNil.
	self assert: (server siteHostnamed: self testSiteName) isNil.
	site := (SwazooSite new)
		name: self testSiteName;
		host: 'test.org' ip: 'localhost' port: 5798.
	server addSite: site.
	self assert: (server siteNamed: self testSiteName) notNil.
	self assert: (server siteHostnamed: 'test.org') notNil.
	server removeSite: site.
	self assert: server sites size = nrSites!

testAllInterfacesTwoPortSites
	"two sites can run on all IP interfaces and different port"
	
	| server site1 site2 |
	server := SwazooServer singleton.
	site1 := (SwazooSite new)
		name: 'allInterfaces1';
		host: '*' ip: '*' port: 7261.
	site2 := (SwazooSite new)
		name: 'allInterfaces2';
		host: '*' ip: '*' port: 7262.
	[server addSite: site1.
	self
		shouldnt: [server addSite: site2]
		raise: Error]
		ensure:
			[server
				removeSite: site1;
				removeSite: site2]!

testAllStarsThenExactOnOtherPort
	
	| server site1 site2 |
	server := SwazooServer singleton.
	site1 := (SwazooSite new)
		name: 'allstar232';
		host: '*' ip: '*' port: 7261.
	site2 := (SwazooSite new)
		name: 'exactdfdf';
		host: 'localhost' ip: 'localhost' port: 7262.
	[server addSite: site1.
	self
		shouldnt:
			[server
				addSite: site2;
				removeSite: site2]
		raise: Error] ensure: [server removeSite: site1]!

testDuplicateAllInterfacesSite
	"two sites cannot run on all IP interfaces and same port"
	
	| server site1 site2 |
	server := SwazooServer singleton.
	site1 := (SwazooSite new)
		name: 'allInterfaces1';
		host: '*' ip: '*' port: 7261.
	site2 := (SwazooSite new)
		name: 'allInterfaces2';
		host: '*' ip: '*' port: 7261.
	[server addSite: site1.
	self
		should: [server addSite: site2]
		raise: Error] ensure: [server removeSite: site1]!

testDuplicateNames
	
	| site server |
	self removeTestSiteIfAny.
	server := SwazooServer singleton.
	site := (SwazooSite new)
		name: self testSiteName;
		host: 'test.org' ip: 'localhost' port: 6376.
	[server addSite: site.
	self
		should: [site name: self testSiteName]
		raise: Error.
	self
		shouldnt: [site host: 'test.org']
		raise: Error.
	self
		should:
			[(SwazooSite new)
				name: self testSiteName;
				host: 'test.org' ip: 'localhost' port: 6376]
		raise: Error] ensure: [server removeSite: site]!

testSiteName
	
	^'aaabbcc987'!

testStartingOnAPort
	"and all ip interfaces, any host"
	
	| site server nrServers |
	server := SwazooServer singleton.
	nrServers := server servers size.
	[site := server startOn: 4924.
	self assert: site isServing.
	self assert: server servers size = (nrServers + 1).
	server stopOn: 4924.
	self assert: site isServing not.
	self assert: server servers size = nrServers]
		ensure:
			[site stop.
			server removeSite: site]!

testStartingOnTwoPorts
	"and all ip interfaces, any host"
	
	| server nrServers site1 site2 |
	server := SwazooServer singleton.
	nrServers := server servers size.
	[site1 := server startOn: 4924.
	site2 := server startOn: 4925.
	self assert: site1 isServing.
	self assert: site2 isServing.
	self assert: server servers size = (nrServers + 2).
	server stopOn: 4924.
	server stopOn: 4925.
	self assert: site1 isServing not.
	self assert: site2 isServing not.
	self assert: server servers size = nrServers]
		ensure:
			[site1 stop.
			site2 stop.
			server
				removeSite: site1;
				removeSite: site2]!

testStartingSite
	
	| site server nrServers |
	self removeTestSiteIfAny.
	server := SwazooServer singleton.
	nrServers := server servers size.
	site := (SwazooSite new)
		name: self testSiteName;
		host: 'test.org' ip: 'localhost' port: 8765.
	[server addSite: site.
	self assert: site isServing not.
	SwazooServer startSite: self testSiteName.
	self assert: server servers size = (nrServers + 1).
	self assert: site isServing.
	SwazooServer stopSite: self testSiteName.
	self assert: site isServing not.
	self assert: server servers size = nrServers]
		ensure:
			[site stop.
			server removeSite: site]! !
!SwazooServerTest categoriesFor: #removeAllTestSites!public!testing-adding sites! !
!SwazooServerTest categoriesFor: #removeTestSiteIfAny!public!support! !
!SwazooServerTest categoriesFor: #testAccessingSite!public!testing! !
!SwazooServerTest categoriesFor: #testAddingAllInterfacesSite!public!testing-adding sites! !
!SwazooServerTest categoriesFor: #testAddingSite!public!testing-adding sites! !
!SwazooServerTest categoriesFor: #testAllInterfacesTwoPortSites!public!testing-adding sites! !
!SwazooServerTest categoriesFor: #testAllStarsThenExactOnOtherPort!public!testing-adding sites! !
!SwazooServerTest categoriesFor: #testDuplicateAllInterfacesSite!public!testing-adding sites! !
!SwazooServerTest categoriesFor: #testDuplicateNames!public!testing-adding sites! !
!SwazooServerTest categoriesFor: #testSiteName!public!support! !
!SwazooServerTest categoriesFor: #testStartingOnAPort!public!testing! !
!SwazooServerTest categoriesFor: #testStartingOnTwoPorts!public!testing! !
!SwazooServerTest categoriesFor: #testStartingSite!public!testing! !

SwazooSocketTest guid: (GUID fromString: '{DE016290-CEB6-4A56-8D36-DE88DE4B5DD3}')!
SwazooSocketTest comment: ''!
!SwazooSocketTest categoriesForClass!Unclassified! !
!SwazooSocketTest methodsFor!

setUp
	| pair |
	pair := SwazooSocket connectedPair.
	input := pair first.
	output := pair last!

tearDown
	input close.
	output close!

testConnectedPair
	(Array with: input with: output) 
		do: [:each | self assert: (each isKindOf: SwazooSocket)]!

testNetworkConnection
	| server sem |
	input close.
	output close.
	sem := Semaphore new.
	
	[server := SwazooSocket serverOnIP: '127.0.0.1' port: 65423.
	server listenFor: 50.
	
	[input := server accept.
	sem signal] fork.
	output := SwazooSocket connectTo: 'localhost' port: 65423.
	sem wait.
	self testReadWrite] 
			ensure: [server close]!

testPartialRead
	| bytes |
	bytes := ByteArray withAll: #(5 4 3).
	self assert: (input write: bytes) = 3.
	self assert: (output read: 5) = bytes!

testReadTimeout
	"on Squeak doesn't come back, and also we don't need it for now !!"
"	input write: (ByteArray withAll: #(1 2 3)).
	self assert: (output read: 3 timeout: 40) = (ByteArray withAll: #(1 2 3)).
	self assert: (output read: 3 timeout: 40) = ByteArray new
"!

testReadWrite
	| bytes |
	bytes := ByteArray withAll: #(1 2 3 4 5).
	self assert: (input write: bytes) = 5.
	self assert: (output read: 5) = bytes.
	bytes := ByteArray with: 4.
	self assert: (input write: bytes) = 1.
	self assert: (output read: 1) = bytes! !
!SwazooSocketTest categoriesFor: #setUp!public!running! !
!SwazooSocketTest categoriesFor: #tearDown!public!running! !
!SwazooSocketTest categoriesFor: #testConnectedPair!public!testing! !
!SwazooSocketTest categoriesFor: #testNetworkConnection!public!testing! !
!SwazooSocketTest categoriesFor: #testPartialRead!public!testing! !
!SwazooSocketTest categoriesFor: #testReadTimeout!public!testing! !
!SwazooSocketTest categoriesFor: #testReadWrite!public!testing! !

SwazooStreamTest guid: (GUID fromString: '{2FA7750A-7E1A-4AD9-BC57-7B462ACCBE0E}')!
SwazooStreamTest comment: ''!
!SwazooStreamTest categoriesForClass!Unclassified! !
!SwazooStreamTest methodsFor!

crlfOn: aSwazooStream
	aSwazooStream
		nextPut: Character cr;
		nextPut: Character lf!

setUp
	| pair |
	pair := SwazooStream connectedPair.
	input := pair first.
	output := pair last!

tearDown
	input close.
	output close!

testConnectedPair
	(Array with: input with: output) 
		do: [:each | self assert: (each isKindOf: SwazooStream)]!

testErrorOnInputClose
	self should: 
			[input close.
			output next]
		raise: Error!

testLinesWithDoubleCRLF
	| ws rs comparisonString |
	comparisonString := 'abcd'.
	ws := SwazooStream on: String new.
	ws nextPutAll: comparisonString.
	self crlfOn: ws.
	self crlfOn: ws.
	rs := SwazooStream on: ws writeBuffer contents.
	self assert: rs nextLine = comparisonString.
	self assert: rs nextLine = ''!

testNextPut
	#($A $M $Y $b $r $z) do: 
			[:each | 
			self assert: (input nextPut: each) = each. 
			input flush.
			self assert: output next = each]!

testNextPutAll
	#('123' 'abc' 'swazoo') do: 
			[:each | 
			self assert: (input nextPutAll: each) = each. 
			input flush.
			self assert: (output next: each size) = each]!

testNextPutByte
	| bytes |
	bytes := ByteArray 
				with: 6
				with: 5
				with: 0
				with: 2.
	bytes do: 
			[:each | 
			self assert: (input nextPutByte: each) = each. 
			input flush.
			self assert: output nextByte = each]!

testNextPutBytes
	| bytes1 bytes2 bytes3 |
	bytes1 := ByteArray withAll: #(1 2 3 4).
	bytes2 := ByteArray withAll: #(5 4 3 2 1).
	bytes3 := ByteArray withAll: #(1 1 2 3 5).
	(Array 
		with: bytes1
		with: bytes2
		with: bytes3) do: 
				[:each | 
				self assert: (input nextPutBytes: each) = each.
				input flush.
				self assert: (output nextBytes: each size) = each]!

testPeek
	#($K $J $D $j $m $z) do: 
			[:each | 
			input nextPut: each.
			input flush.
			self assert: output peek = each.
			output next]!

testPeekByte
	| bytes |
	bytes := ByteArray withAll: #(5 2 8 4 11 231).
	bytes do: 
			[:each | 
			input nextPutByte: each.
			input flush.
			self assert: output peekByte = each.
			output nextByte]!

testSingleLineWithCR
	| ws rs comparisonString errored |
	comparisonString := 'abcd' , (String with: Character cr) , 'efg'.
	ws := SwazooStream on: String new.
	ws nextPutAll: comparisonString.
	ws nextPut: Character cr.
	rs := SwazooStream on: ws writeBuffer contents.
	errored := false.
	SpExceptionContext 
		for: [rs nextLine]
		on: SpError
		do: [:ex | errored := true].
	self assert: errored!

testSingleLineWithCRLF
	| ws rs comparisonString |
	comparisonString := 'abcd'.
	ws := SwazooStream on: String new.
	ws nextPutAll: comparisonString.
	self crlfOn: ws.
	rs := SwazooStream on: ws writeBuffer contents.
	self assert: rs nextLine = comparisonString! !
!SwazooStreamTest categoriesFor: #crlfOn:!public!running! !
!SwazooStreamTest categoriesFor: #setUp!public!running! !
!SwazooStreamTest categoriesFor: #tearDown!public!running! !
!SwazooStreamTest categoriesFor: #testConnectedPair!public!testing! !
!SwazooStreamTest categoriesFor: #testErrorOnInputClose!public!testing! !
!SwazooStreamTest categoriesFor: #testLinesWithDoubleCRLF!public!testing-lines! !
!SwazooStreamTest categoriesFor: #testNextPut!public!testing! !
!SwazooStreamTest categoriesFor: #testNextPutAll!public!testing! !
!SwazooStreamTest categoriesFor: #testNextPutByte!public!testing! !
!SwazooStreamTest categoriesFor: #testNextPutBytes!public!testing! !
!SwazooStreamTest categoriesFor: #testPeek!public!testing! !
!SwazooStreamTest categoriesFor: #testPeekByte!public!testing! !
!SwazooStreamTest categoriesFor: #testSingleLineWithCR!public!testing-lines! !
!SwazooStreamTest categoriesFor: #testSingleLineWithCRLF!public!testing-lines! !

SwazooURITest guid: (GUID fromString: '{8966146C-72D2-4173-B8CE-95364DDBDEBB}')!
SwazooURITest comment: ''!
!SwazooURITest categoriesForClass!Unclassified! !
!SwazooURITest methodsFor!

setUp
	fooURI := SwazooURI fromString: 'www.foo.com/index.html'.
	queryURI := SwazooURI fromString: 'www.foo.com/index.html?foo=1&bar=hi'.
	barURI := SwazooURI fromString: 'www.bar.com:8080/files/'!

testHostname
	self assert: fooURI hostname = 'www.foo.com'.
	self assert: queryURI hostname = 'www.foo.com'.
	self assert: barURI hostname = 'www.bar.com'!

testIdentifier
	self assert: fooURI identifier = '/index.html'.
	self assert: queryURI identifier = '/index.html'.
	self assert: barURI identifier = '/files/'!

testIdentifierPath
	self assert: fooURI identifierPath 
				= (OrderedCollection with: '/' with: 'index.html').
	self assert: queryURI identifierPath 
				= (OrderedCollection with: '/' with: 'index.html').
	self 
		assert: barURI identifierPath = (OrderedCollection with: '/' with: 'files')!

testIsDirectory
	self deny: fooURI isDirectory.
	self deny: queryURI isDirectory.
	self assert: barURI isDirectory!

testPort
	self assert: fooURI port = 80.
	self assert: queryURI port = 80.
	self assert: barURI port = 8080!

testQueries
	self deny: (queryURI includesQuery: 'hi').
	self assert: (queryURI includesQuery: 'foo').
	self assert: (queryURI includesQuery: 'bar').
	self assert: (queryURI queryAt: 'foo') = '1'.
	self assert: (queryURI queryAt: 'bar') = 'hi'!

testValue
	self assert: fooURI value = 'http://www.foo.com/index.html'.
	self assert: queryURI value = 'http://www.foo.com/index.html?foo=1&bar=hi'.
	self assert: barURI value = 'http://www.bar.com:8080/files/'! !
!SwazooURITest categoriesFor: #setUp!public!running! !
!SwazooURITest categoriesFor: #testHostname!public!running! !
!SwazooURITest categoriesFor: #testIdentifier!public!running! !
!SwazooURITest categoriesFor: #testIdentifierPath!public!running! !
!SwazooURITest categoriesFor: #testIsDirectory!public!running! !
!SwazooURITest categoriesFor: #testPort!public!running! !
!SwazooURITest categoriesFor: #testQueries!public!running! !
!SwazooURITest categoriesFor: #testValue!public!running! !

URIParsingTest guid: (GUID fromString: '{B4341C79-76B7-4F4B-BE1F-385D7EA2DA32}')!
URIParsingTest comment: ''!
!URIParsingTest categoriesForClass!Unclassified! !
!URIParsingTest methodsFor!

test05SimpleFullURI

|uri|
uri := SwazooURI fromString: 'http://abc.com:8080/smith/home.html'.
self assert: (uri protocol = 'http').
self assert: (uri hostname = 'abc.com'). 
self assert: (uri port = 8080).
self assert: (uri identifier = '/smith/home.html').
self assert: (uri asString = 'http://abc.com:8080/smith/home.html').!

test10SimpleFullURIWithQuery

|uri|
uri := SwazooURI fromString: 'http://abc.com:8080/smith/home.html?a=1&b=2'.
self assert: (uri protocol = 'http').
self assert: (uri hostname = 'abc.com'). 
self assert: (uri port = 8080).
self assert: (uri identifier = '/smith/home.html').
self assert: (uri asString = 'http://abc.com:8080/smith/home.html?a=1&b=2').!

test15SimpleFullURIWithPort80

|uri|
uri := SwazooURI fromString: 'http://abc.com:80/smith/home.html?a=1&b=2'.
self assert: (uri protocol = 'http').
self assert: (uri hostname = 'abc.com'). 
self assert: (uri port = 80).
self assert: (uri identifier = '/smith/home.html').
self assert: (uri asString = 'http://abc.com/smith/home.html?a=1&b=2').!

test20SimpleFullURIWithNoPort

|uri|
uri := SwazooURI fromString: 'http://abc.com/smith/home.html?a=1&b=2'.
self assert: (uri protocol = 'http').
self assert: (uri hostname = 'abc.com'). 
self assert: (uri port = 80).
self assert: (uri identifier = '/smith/home.html').
self assert: (uri asString = 'http://abc.com/smith/home.html?a=1&b=2').! !
!URIParsingTest categoriesFor: #test05SimpleFullURI!public!testing! !
!URIParsingTest categoriesFor: #test10SimpleFullURIWithQuery!public!testing! !
!URIParsingTest categoriesFor: #test15SimpleFullURIWithPort80!public!testing! !
!URIParsingTest categoriesFor: #test20SimpleFullURIWithNoPort!public!testing! !

URIResolutionTest guid: (GUID fromString: '{627F976C-409D-44CD-80BE-2026B89E6EFB}')!
URIResolutionTest comment: ''!
!URIResolutionTest categoriesForClass!Unclassified! !
!URIResolutionTest methodsFor!

testCompositeAnswer
	| resource request response | 
	resource := CompositeResource uriPattern: 'base'.
	resource addResource: (HelloWorldResource uriPattern: 'hi').
	request := HTTPGet request: 'base/hi'.
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response code = 200.
	self assert: request resourcePath size = 2.
	self assert: request resourcePath first = 'base'.
	self assert: request resourcePath last = 'hi'!

testCompositeItselfCannotAnswer
	| resource request response |
	resource := CompositeResource uriPattern: 'base'.
	request := HTTPGet request: 'base'.
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response isNil!

testCompositeNoAnswer
	| resource request response |
	resource := CompositeResource uriPattern: 'base'.
	resource addResource: (HelloWorldResource uriPattern: 'hi').
	request := HTTPGet request: 'tail/hi'.
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response isNil!

testLeafAnswer
	| resource request response | 
	resource := HelloWorldResource uriPattern: 'hi'.
	request := HTTPGet request: 'hi'.
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response code = 200.
	self assert: request resourcePath size = 1.
	self assert: request resourcePath first = 'hi'!

testNoAnswerWhenDisabled
	| resource request response |
	resource := HelloWorldResource uriPattern: 'hi'.
	resource disable.
	request := HTTPGet request: 'hi'.
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response isNil!

testResourcePath
	| request resolution |
	request := HTTPGet 
				request: 'foo/bar/baz/quux'
				from: 'localhost:1234'
				at: '1.2.3.4'.
	resolution := URIResolution new initializeRequest: request.
	self assert: resolution resourcePath = #('foo') asOrderedCollection.
	resolution advance.
	self assert: resolution resourcePath = #('foo' 'bar') asOrderedCollection.
	resolution advance.
	self 
		assert: resolution resourcePath = #('foo' 'bar' 'baz') asOrderedCollection.
	resolution advance.
	self assert: resolution resourcePath = #('foo' 'bar' 'baz' 'quux') asOrderedCollection!

testSiteAnswer
	| resource request response |
	resource := SwazooSite new host: 'foo.com' ip: '1.2.3.4' port: 80.
	resource addResource: (HelloWorldResource uriPattern: '/').
	request := HTTPGet
				request: '/'
				from: 'foo.com'
				at: '1.2.3.4'.
	response := URIResolution resolveRequest: request startingAt: resource.
	self assert: response code = 200.
	self assert: request resourcePath size = 1.
	self assert: request resourcePath first = '/'!

testSiteMatch
	| request site visitor |
	request := HTTPGet 
				request: 'foo'
				from: 'myhosthost:1234'
				at: '1.2.3.4'.
	visitor := URIResolution new initializeRequest: request.
	site := SwazooSite new host: 'myhosthost' ip: '1.2.3.4' port: 1234.
	self assert: (visitor siteMatch: site)!

testSiteMismatch
	| request site visitor |
	request := HTTPGet 
				request: 'foo'
				from: 'localhost:1234'
				at: '1.2.3.4'.
	visitor := URIResolution new initializeRequest: request.
	site := SwazooSite new host: 'remotehost' ip: '1.2.3.4' port: 1234.
	self deny: (visitor siteMatch: site)!

testStringMatch
	| request visitor resource |
	request := HTTPGet request: 'foo'.
	visitor := URIResolution new initializeRequest: request.
	resource := HelloWorldResource uriPattern: 'foo'.
	self assert: (visitor stringMatch: resource)!

testStringMismatch
	| request visitor resource |
	request := HTTPGet request: 'foo'.
	visitor := URIResolution new initializeRequest: request.
	resource := HelloWorldResource uriPattern: 'Foo'.
	self deny: (visitor stringMatch: resource)!

testTailPath
	| request resolution |
	request := HTTPGet 
				request: 'foo/bar/baz/quux'
				from: 'localhost:1234'
				at: '1.2.3.4'.
	resolution := URIResolution new initializeRequest: request.
	self 
		assert: resolution tailPath = #('bar' 'baz' 'quux') asOrderedCollection.
	resolution advance.
	self assert: resolution tailPath = #('baz' 'quux') asOrderedCollection.
	resolution advance.
	self assert: resolution tailPath = #('quux') asOrderedCollection.
	resolution advance.
	self assert: resolution tailPath isEmpty! !
!URIResolutionTest categoriesFor: #testCompositeAnswer!public!testing! !
!URIResolutionTest categoriesFor: #testCompositeItselfCannotAnswer!public!testing! !
!URIResolutionTest categoriesFor: #testCompositeNoAnswer!public!testing! !
!URIResolutionTest categoriesFor: #testLeafAnswer!public!testing! !
!URIResolutionTest categoriesFor: #testNoAnswerWhenDisabled!public!testing! !
!URIResolutionTest categoriesFor: #testResourcePath!public!testing! !
!URIResolutionTest categoriesFor: #testSiteAnswer!public!testing! !
!URIResolutionTest categoriesFor: #testSiteMatch!public!testing! !
!URIResolutionTest categoriesFor: #testSiteMismatch!public!testing! !
!URIResolutionTest categoriesFor: #testStringMatch!public!testing! !
!URIResolutionTest categoriesFor: #testStringMismatch!public!testing! !
!URIResolutionTest categoriesFor: #testTailPath!public!testing! !

"Binary Globals"!

