| package |
package := Package name: 'Seaside-Core'.
package paxVersion: 1;
	basicComment: ''.

package basicPackageVersion: '659'.


package classNames
	add: #WAAccept;
	add: #WAAcceptCharset;
	add: #WAAcceptEncoding;
	add: #WAAcceptLanguage;
	add: #WAActionCallback;
	add: #WAAddRemoveExpression;
	add: #WAAttribute;
	add: #WAAttributeExpression;
	add: #WAAttributeNotFound;
	add: #WAAttributeSearchContext;
	add: #WAAttributeVisitor;
	add: #WAAuthConfiguration;
	add: #WAAuthConfigurationError;
	add: #WAAuthenticationFilter;
	add: #WABaseElement;
	add: #WABooleanAttribute;
	add: #WABufferedResponse;
	add: #WABuilder;
	add: #WACache;
	add: #WACacheCapacityConfiguration;
	add: #WACacheExpiryPolicy;
	add: #WACacheMissStrategy;
	add: #WACachePlugin;
	add: #WACacheReapingStrategy;
	add: #WACacheRemovalAction;
	add: #WACacheTimeoutConfiguration;
	add: #WACallback;
	add: #WACallbackRegistry;
	add: #WACancelActionCallback;
	add: #WAClosingConditionalComment;
	add: #WAClosingRevealedConditionalComment;
	add: #WACollectionAttribute;
	add: #WAConditionalComment;
	add: #WAConfiguration;
	add: #WAConfigurationDescription;
	add: #WAConfigurationElement;
	add: #WAConfigurationError;
	add: #WAConfiguredRequestFilter;
	add: #WAContentElement;
	add: #WACookie;
	add: #WACurrentRequestContext;
	add: #WADefaultActionCallback;
	add: #WADefaultScriptGenerator;
	add: #WADispatchCallback;
	add: #WADispatcher;
	add: #WADocument;
	add: #WADocumentHandler;
	add: #WADynamicVariable;
	add: #WAEmailAddress;
	add: #WAEncoder;
	add: #WAError;
	add: #WAErrorHandler;
	add: #WAExceptionFilter;
	add: #WAExceptionFilterConfiguration;
	add: #WAExceptionHandler;
	add: #WAFile;
	add: #WAFileHandler;
	add: #WAFileHandlerConfiguration;
	add: #WAFileHandlerListing;
	add: #WAFileLibrary;
	add: #WAForbiddenFileHandlerListing;
	add: #WAHeaderFields;
	add: #WAHtmlAttributes;
	add: #WAHtmlDocument;
	add: #WAHtmlElement;
	add: #WAHtmlRoot;
	add: #WAHttpVersion;
	add: #WAIllegalStateException;
	add: #WAImageCallback;
	add: #WAIntegerAttribute;
	add: #WAKeyGenerator;
	add: #WALastAccessExpiryPolicy;
	add: #WALeastRecentlyUsedExpiryPolicy;
	add: #WALinkElement;
	add: #WAListAttribute;
	add: #WALocale;
	add: #WAMapCallback;
	add: #WAMergedRequestFields;
	add: #WAMetaElement;
	add: #WAMimeDocument;
	add: #WAMimeType;
	add: #WAMultipleValuesCallback;
	add: #WAMutex;
	add: #WANotification;
	add: #WANotifyRemovalAction;
	add: #WANumberAttribute;
	add: #WAObject;
	add: #WAOpeningConditionalComment;
	add: #WAOpeningRevealedConditionalComment;
	add: #WAPainter;
	add: #WAPainterVisitor;
	add: #WAPasswordAttribute;
	add: #WAPathConsumer;
	add: #WAProtectionFilter;
	add: #WAQualifiedValue;
	add: #WARegistry;
	add: #WARegistryConfiguration;
	add: #WARenderContext;
	add: #WARenderer;
	add: #WARenderNotification;
	add: #WARenderVisitor;
	add: #WARequest;
	add: #WARequestContext;
	add: #WARequestContextNotFound;
	add: #WARequestCookie;
	add: #WARequestFields;
	add: #WARequestFilter;
	add: #WARequestHandler;
	add: #WARequestHandlingConfiguration;
	add: #WAResponse;
	add: #WAResponseGenerator;
	add: #WAResponseNotification;
	add: #WARetrievalIntervalReapingStrategy;
	add: #WARetrievalIntervalReapingStrategyConfiguration;
	add: #WARevealedConditionalComment;
	add: #WARoot;
	add: #WAScriptElement;
	add: #WAScriptGenerator;
	add: #WAServerAdaptor;
	add: #WAServerManager;
	add: #WASharedConfiguration;
	add: #WASnapshot;
	add: #WAStreamedResponse;
	add: #WAStringAttribute;
	add: #WASystemConfiguration;
	add: #WATextFileHandlerListing;
	add: #WATrailingSlashFilter;
	add: #WATransactionFilter;
	add: #WAUnescapedDocument;
	add: #WAUnhandledNotificationError;
	add: #WAUnregisteredHandlerError;
	add: #WAUpdateRootVisitor;
	add: #WAUpdateUrlVisitor;
	add: #WAUploadCallback;
	add: #WAUrl;
	add: #WAUrlAttribute;
	add: #WAUrlEncoder;
	add: #WAUserConfiguration;
	add: #WAValueCallback;
	add: #WAValueExpression;
	add: #WAValueHolder;
	add: #WAValuesCallback;
	add: #WAVisitor;
	add: #WAXmlDocument;
	add: #WAXmlEncoder;
	add: #WAXmlRoot;
	yourself.

package methodNames
	add: #ByteArray -> #renderOn:;
	add: #ByteArray -> #seasideMimeDocument;
	add: #ByteArray -> #seasideMimeDocumentType:;
	add: #Collection -> #renderOn:;
	add: #Dictionary -> #seasideRequestFields;
	add: #Dictionary -> #valuesCollect:;
	add: #Exception -> #seasidePossibleCauses;
	add: #GRInvalidUtf8Error -> #seasidePossibleCauses;
	add: #GRPlatform -> #seasideVersion;
	add: #GRSmallDictionary -> #seasideRequestFields;
	add: #GRUnsupportedEncodingError -> #seasidePossibleCauses;
	add: #MessageNotUnderstood -> #seasidePossibleCauses;
	add: #Object -> #encodeOn:;
	add: #Object -> #labelForSelector:;
	add: #Object -> #renderOn:;
	add: #String -> #asCapitalizedPhrase;
	add: #String -> #encodeOn:;
	add: #String -> #renderOn:;
	add: #String -> #seasideMimeDocument;
	add: #String -> #seasideMimeDocumentType:;
	add: #String -> #seasideMimeType;
	add: #String -> #seasideUrl;
	add: #UndefinedObject -> #encodeOn:;
	add: #UndefinedObject -> #renderOn:;
	add: #UndefinedObject -> #seasideUrl;
	add: 'GRPackage class' -> #seasideCore;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Grease\Grease-Core';
	add: '..\..\IDB\IDB DateAndTime';
	add: '..\..\IDB\IDB Duration';
	yourself).

package!

"Class Definitions"!

GRError subclass: #WAError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAError subclass: #WAAuthConfigurationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAError subclass: #WAConfigurationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAError subclass: #WAIllegalStateException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAError subclass: #WARequestContextNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAError subclass: #WAUnhandledNotificationError
	instanceVariableNames: 'notification'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAError subclass: #WAUnregisteredHandlerError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAConfigurationError subclass: #WAAttributeNotFound
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRNotification subclass: #WANotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WANotification subclass: #WADynamicVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WANotification subclass: #WARenderNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WANotification subclass: #WAResponseNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WADynamicVariable subclass: #WACurrentRequestContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRObject subclass: #WAObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GRSmallDictionary subclass: #WAHtmlAttributes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GROrderedMultiMap subclass: #WAHeaderFields
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GROrderedMultiMap subclass: #WARequestFields
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAAttributeSearchContext
	instanceVariableNames: 'key attribute cachedValues attributeHolders attributeInheritors'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WABuilder
	instanceVariableNames: 'fullDocument rootBlock rootClass documentClass rendererClass codec actionUrl resourceUrl'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WACache
	instanceVariableNames: 'mutex keysByObject objectsByKey expiryPolicy reapingStrategy missStrategy removalAction'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WACachePlugin
	instanceVariableNames: 'cache configuration'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WACallback
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WACallbackRegistry
	instanceVariableNames: 'callbacks nextKey'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAClosingConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAClosingRevealedConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAConditionalComment
	instanceVariableNames: 'condition root'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAConfigurationDescription
	instanceVariableNames: 'attributes expressions'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAConfigurationElement
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WADocument
	instanceVariableNames: 'stream root'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAEmailAddress
	instanceVariableNames: 'username address'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAEncoder
	instanceVariableNames: 'stream table'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'table'!
WAObject subclass: #WAExceptionHandler
	instanceVariableNames: 'requestContext'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAFile
	instanceVariableNames: 'contents contentType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAFileHandlerListing
	instanceVariableNames: 'handler context'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAFileLibrary
	instanceVariableNames: ''
	classVariableNames: 'MimeTypes'
	poolDictionaries: ''
	classInstanceVariableNames: 'default'!
WAObject subclass: #WAHtmlElement
	instanceVariableNames: 'root attributes children'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAHttpVersion
	instanceVariableNames: 'major minor'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAKeyGenerator
	instanceVariableNames: 'generator space'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'current'!
WAObject subclass: #WALocale
	instanceVariableNames: 'language country'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'iso2Languages iso3Languages iso2Countries iso3Countries'!
WAObject subclass: #WAMergedRequestFields
	instanceVariableNames: 'delegates'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAMimeDocument
	instanceVariableNames: 'contents mimeType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAMimeType
	instanceVariableNames: 'main sub parameters'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAMutex
	instanceVariableNames: 'semaphore owner'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAOpeningConditionalComment
	instanceVariableNames: 'condition'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAPainter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAPathConsumer
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAQualifiedValue
	instanceVariableNames: 'value quality'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WARenderContext
	instanceVariableNames: 'visitor actionUrl actionBaseUrl resourceUrl callbacks document properties'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WARenderer
	instanceVariableNames: 'context lastId'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'default'!
WAObject subclass: #WARequest
	instanceVariableNames: 'method uri version remoteAddress headers cookies body postFields'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WARequestContext
	instanceVariableNames: 'handlers request response codec consumer properties'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WARequestCookie
	instanceVariableNames: 'key path domain ports value version'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WARequestFilter
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WARequestHandler
	instanceVariableNames: 'filter parent configuration'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAResponse
	instanceVariableNames: 'headers cookies status message'
	classVariableNames: 'StatusMessages'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAResponseGenerator
	instanceVariableNames: 'requestContext'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WARoot
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAScriptGenerator
	instanceVariableNames: 'loadScripts'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAServerAdaptor
	instanceVariableNames: 'manager port requestHandler codec'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAServerManager
	instanceVariableNames: 'adaptors'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'default'!
WAObject subclass: #WASnapshot
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAUrl
	instanceVariableNames: 'scheme user password host port path slash queryFields fragment'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAValueHolder
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAObject subclass: #WAVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACachePlugin subclass: #WACacheExpiryPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACachePlugin subclass: #WACacheMissStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACachePlugin subclass: #WACacheReapingStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACachePlugin subclass: #WACacheRemovalAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACacheExpiryPolicy subclass: #WALastAccessExpiryPolicy
	instanceVariableNames: 'lastAccessTable'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACacheExpiryPolicy subclass: #WALeastRecentlyUsedExpiryPolicy
	instanceVariableNames: 'ageTable'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACacheReapingStrategy subclass: #WARetrievalIntervalReapingStrategy
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACacheRemovalAction subclass: #WANotifyRemovalAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACallback subclass: #WAActionCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACallback subclass: #WADispatchCallback
	instanceVariableNames: 'callbacks'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WACallback subclass: #WAValueCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAActionCallback subclass: #WACancelActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAActionCallback subclass: #WADefaultActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAActionCallback subclass: #WAImageCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAValueCallback subclass: #WAMapCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAValueCallback subclass: #WAUploadCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAValueCallback subclass: #WAValuesCallback
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAValuesCallback subclass: #WAMultipleValuesCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAConditionalComment subclass: #WARevealedConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAConfiguration subclass: #WASystemConfiguration
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'instance'!
WAConfiguration subclass: #WAUserConfiguration
	instanceVariableNames: 'expressions parents'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WASystemConfiguration subclass: #WAAuthConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WASystemConfiguration subclass: #WACacheCapacityConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WASystemConfiguration subclass: #WACacheTimeoutConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WASystemConfiguration subclass: #WAExceptionFilterConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WASystemConfiguration subclass: #WAFileHandlerConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WASystemConfiguration subclass: #WARegistryConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WASystemConfiguration subclass: #WARequestHandlingConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WASystemConfiguration subclass: #WARetrievalIntervalReapingStrategyConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAUserConfiguration subclass: #WASharedConfiguration
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'instances'!
WAConfigurationElement subclass: #WAAttribute
	instanceVariableNames: 'group comment label default advanced'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAConfigurationElement subclass: #WAAttributeExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAAttribute subclass: #WABooleanAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAAttribute subclass: #WAListAttribute
	instanceVariableNames: 'optionsBlock'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAAttribute subclass: #WANumberAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAAttribute subclass: #WAPasswordAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAAttribute subclass: #WAStringAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAAttribute subclass: #WAUrlAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAListAttribute subclass: #WACollectionAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WANumberAttribute subclass: #WAIntegerAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAAttributeExpression subclass: #WAAddRemoveExpression
	instanceVariableNames: 'additions removals'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAAttributeExpression subclass: #WAValueExpression
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WADocument subclass: #WAXmlDocument
	instanceVariableNames: 'urlEncoder xmlEncoder'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAXmlDocument subclass: #WAHtmlDocument
	instanceVariableNames: 'scriptGenerator'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAXmlDocument subclass: #WAUnescapedDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAEncoder subclass: #WAUrlEncoder
	instanceVariableNames: 'codec'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAEncoder subclass: #WAXmlEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAExceptionHandler subclass: #WAErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFileHandlerListing subclass: #WAForbiddenFileHandlerListing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAFileHandlerListing subclass: #WATextFileHandlerListing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAHtmlElement subclass: #WABaseElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAHtmlElement subclass: #WAContentElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAHtmlElement subclass: #WAMetaElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAContentElement subclass: #WALinkElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAContentElement subclass: #WAScriptElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAOpeningConditionalComment subclass: #WAOpeningRevealedConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAQualifiedValue subclass: #WAAccept
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAQualifiedValue subclass: #WAAcceptCharset
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAQualifiedValue subclass: #WAAcceptEncoding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAQualifiedValue subclass: #WAAcceptLanguage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WARequestCookie subclass: #WACookie
	instanceVariableNames: 'expiry secure discard comment commentUrl httpOnly maxAge'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WARequestFilter subclass: #WAAuthenticationFilter
	instanceVariableNames: 'authenticator realm'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WARequestFilter subclass: #WAConfiguredRequestFilter
	instanceVariableNames: 'configuration'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WARequestFilter subclass: #WAProtectionFilter
	instanceVariableNames: 'remoteAddress'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WARequestFilter subclass: #WATrailingSlashFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WARequestFilter subclass: #WATransactionFilter
	instanceVariableNames: 'closed'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAConfiguredRequestFilter subclass: #WAExceptionFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WARequestHandler subclass: #WADispatcher
	instanceVariableNames: 'defaultName handlers'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'default'!
WARequestHandler subclass: #WADocumentHandler
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WARequestHandler subclass: #WAFileHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'default'!
WARequestHandler subclass: #WARegistry
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAResponse subclass: #WABufferedResponse
	instanceVariableNames: 'contentsStream'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAResponse subclass: #WAStreamedResponse
	instanceVariableNames: 'committed externalStream'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WARoot subclass: #WAHtmlRoot
	instanceVariableNames: 'docType htmlAttrs headAttrs bodyAttrs headElements title styles scripts'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WARoot subclass: #WAXmlRoot
	instanceVariableNames: 'charSet'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAScriptGenerator subclass: #WADefaultScriptGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAVisitor subclass: #WAAttributeVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAVisitor subclass: #WAPainterVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPainterVisitor subclass: #WARenderVisitor
	instanceVariableNames: 'renderContext'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPainterVisitor subclass: #WAUpdateRootVisitor
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
WAPainterVisitor subclass: #WAUpdateUrlVisitor
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!ByteArray methodsFor!

renderOn: aRenderer
	aRenderer text: self!

seasideMimeDocument
	^ WAMimeDocument on: self mimeType: WAMimeType applicationOctetStream!

seasideMimeDocumentType: aMimeType
	^self seasideMimeDocument mimeType: aMimeType; yourself! !
!ByteArray categoriesFor: #renderOn:!*seaside-core!public! !
!ByteArray categoriesFor: #seasideMimeDocument!*seaside-core!public! !
!ByteArray categoriesFor: #seasideMimeDocumentType:!*seaside-core!public! !

!Collection methodsFor!

renderOn: html
	self do: [ :each | html render: each ]! !
!Collection categoriesFor: #renderOn:!*seaside-core!public! !

!Dictionary methodsFor!

seasideRequestFields
	^ WARequestFields withAll: self!

valuesCollect: aBlock
	| result |
	result := self species new: self size.
	self keysAndValuesDo: [ :key :value |
		result at: key put: (aBlock value: value) ].
	^ result! !
!Dictionary categoriesFor: #seasideRequestFields!*seaside-core!public! !
!Dictionary categoriesFor: #valuesCollect:!*seaside-core!public! !

!Exception methodsFor!

seasidePossibleCauses
	"Used by WAWalkback to render a list of what might have caused the receiver to be signaled.
	answers a collection of strings"
	^ #()! !
!Exception categoriesFor: #seasidePossibleCauses!*seaside-core!public! !

!GRInvalidUtf8Error methodsFor!

seasidePossibleCauses
	^#(
		'The input is not UTF-8 but some other encoding like ISO-8859-1.'
	)! !
!GRInvalidUtf8Error categoriesFor: #seasidePossibleCauses!*seaside-core!public! !

!GRPackage class methodsFor!

seasideCore
	^ self new
		name: 'Seaside-Core';
		description: 'The core of Seaside, required for all packages.';
		addDependency: 'Grease-Core';
		url: #seasideUrl;
		yourself! !
!GRPackage class categoriesFor: #seasideCore!*seaside-core!public! !

!GRPlatform methodsFor!

seasideVersion
	"Answer the Seaside version"

	^ (GRVersion major: 3 minor: 0)
		yourself! !
!GRPlatform categoriesFor: #seasideVersion!*seaside-core!public! !

!GRSmallDictionary methodsFor!

seasideRequestFields
	^ WARequestFields withAll: self! !
!GRSmallDictionary categoriesFor: #seasideRequestFields!*seaside-core!public! !

!GRUnsupportedEncodingError methodsFor!

seasidePossibleCauses
	^#(
		'The given encoding name is not supported on this Smalltalk dialect.'
		'The given encoding name is misspelled.'
	)! !
!GRUnsupportedEncodingError categoriesFor: #seasidePossibleCauses!*seaside-core!public! !

!MessageNotUnderstood methodsFor!

seasidePossibleCauses
	| causes |
	self receiver isNil ifFalse: [
		^ #('you sent a message this type of object doesn''t understand' )].
	causes := #(
		'the receiver of the message is nil'
		'a class extension hasn''t been loaded correctly'
		'you sent the wrong message' ) asOrderedCollection.
	self message selector = #contents ifTrue: [
		causes addFirst: 'you forgot to send "super initialize" in a initialize method of a component or task' ].
	^causes! !
!MessageNotUnderstood categoriesFor: #seasidePossibleCauses!*seaside-core!public! !

!Object methodsFor!

encodeOn: aDocument 
	aDocument print: self greaseString!

labelForSelector: aSymbol
	^ aSymbol asCapitalizedPhrase!

renderOn: aRenderer
	"This method is called on all objects passed as an argument to the #render: method of a WARenderer subclass. Override this method to customize how objects render themselves. The default is the return value of #displayString.
	Subclasses of WAPainter (including Components) should override #renderContentOn: and #rendererClass instead."

	aRenderer text: self! !
!Object categoriesFor: #encodeOn:!*seaside-core!public! !
!Object categoriesFor: #labelForSelector:!*seaside-core!public! !
!Object categoriesFor: #renderOn:!*seaside-core!public! !

!String methodsFor!

asCapitalizedPhrase
	|read words currentWord capitalizedWord|
	(self noneSatisfy: [:ea | ea isLowercase] ) ifTrue: [^ self].
	words := WriteStream on: String new.
	read := ReadStream on: self.
	[read atEnd] whileFalse:
		[currentWord := WriteStream on: String new.
		currentWord nextPut: read next.
		[|x| x := read peek. x isNil or: [x isUppercase]] whileFalse:
			[currentWord nextPut: read next].
		capitalizedWord := currentWord contents capitalized.
			(#(Of In At A Or To By) includes: capitalizedWord)
				ifTrue: [capitalizedWord := capitalizedWord asLowercase].
		words nextPutAll: capitalizedWord.
		words nextPutAll: ' '].
	words skip: -1.
	^ words contents!

encodeOn: aDocument
	aDocument xmlEncoder nextPutAll: self!

renderOn: aRenderer
	aRenderer text: self!

seasideMimeDocument
	^ WAMimeDocument on: self mimeType: WAMimeType textPlain!

seasideMimeDocumentType: aMimeType
	^self seasideMimeDocument mimeType: aMimeType; yourself!

seasideMimeType
	^ WAMimeType fromString: self!

seasideUrl
	^ WAUrl absolute: self! !
!String categoriesFor: #asCapitalizedPhrase!*seaside-core!public! !
!String categoriesFor: #encodeOn:!*seaside-core!public! !
!String categoriesFor: #renderOn:!*seaside-core!public! !
!String categoriesFor: #seasideMimeDocument!*seaside-core!public! !
!String categoriesFor: #seasideMimeDocumentType:!*seaside-core!public! !
!String categoriesFor: #seasideMimeType!*seaside-core!public! !
!String categoriesFor: #seasideUrl!*seaside-core!public! !

!UndefinedObject methodsFor!

encodeOn: aDocument!

renderOn: html!

seasideUrl

	^self! !
!UndefinedObject categoriesFor: #encodeOn:!*seaside-core!public! !
!UndefinedObject categoriesFor: #renderOn:!*seaside-core!public! !
!UndefinedObject categoriesFor: #seasideUrl!*seaside-core!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

WAError guid: (GUID fromString: '{F8B4D1A9-FAF2-41C3-9F4F-52BE1FD4EF06}')!
WAError comment: ''!
!WAError categoriesForClass!Unclassified! !
WAAuthConfigurationError guid: (GUID fromString: '{CDADA3AE-ADDC-40B3-9956-D94B508E1562}')!
WAAuthConfigurationError comment: 'A WAAuthConfigurationError is signaled when no WAAuthConfigration was to an application that is behind a WAAuthMain.'!
!WAAuthConfigurationError categoriesForClass!Unclassified! !
!WAAuthConfigurationError methodsFor!

seasidePossibleCauses
	^#(
		'No WAAuthConfiguration has been added to the application.'
	)! !
!WAAuthConfigurationError categoriesFor: #seasidePossibleCauses!accessing!public! !

WAConfigurationError guid: (GUID fromString: '{ADB7F884-D69F-42B7-B288-0BF09E5185AF}')!
WAConfigurationError comment: ''!
!WAConfigurationError categoriesForClass!Unclassified! !
WAIllegalStateException guid: (GUID fromString: '{C0190483-53F5-4BF3-ADBA-31310F788D33}')!
WAIllegalStateException comment: ''!
!WAIllegalStateException categoriesForClass!Unclassified! !
WARequestContextNotFound guid: (GUID fromString: '{D020FAC8-2970-4D05-809B-C46A4CAD0609}')!
WARequestContextNotFound comment: 'This exception is raised when trying to obtain the current request context when none is available.'!
!WARequestContextNotFound categoriesForClass!Unclassified! !
WAUnhandledNotificationError guid: (GUID fromString: '{065B6147-3001-4317-9F28-7B6DABABFA65}')!
WAUnhandledNotificationError comment: 'Seaside has several Notifications that signal the desire to end the current attempt to process a request. These Notification must be handled as they are not resumable or continuable. If those Notifications are not handled, their default actions are to signal this error.'!
!WAUnhandledNotificationError categoriesForClass!Unclassified! !
!WAUnhandledNotificationError methodsFor!

notification
	^ notification!

notification: aNotification
	notification := aNotification! !
!WAUnhandledNotificationError categoriesFor: #notification!accessing!public! !
!WAUnhandledNotificationError categoriesFor: #notification:!accessing!public! !

!WAUnhandledNotificationError class methodsFor!

signalWithNotification: aNotification
	^ self new
		notification: aNotification;
		signal! !
!WAUnhandledNotificationError class categoriesFor: #signalWithNotification:!public!signaling! !

WAUnregisteredHandlerError guid: (GUID fromString: '{3C823A38-DD38-4AA1-8D33-139FC056A37E}')!
WAUnregisteredHandlerError comment: 'This error is signaled by WARegistry whenever an attempt is made to find the key or URL for a handler that is not registered in its cache.'!
!WAUnregisteredHandlerError categoriesForClass!Unclassified! !
!WAUnregisteredHandlerError methodsFor!

seasidePossibleCauses
	^ #(
		'You are trying to use a session or other request handler that has expired'
	)! !
!WAUnregisteredHandlerError categoriesFor: #seasidePossibleCauses!accessing!public! !

WAAttributeNotFound guid: (GUID fromString: '{EA772867-4A19-4D94-A00B-E9CFA3101099}')!
WAAttributeNotFound comment: ''!
!WAAttributeNotFound categoriesForClass!Unclassified! !
!WAAttributeNotFound methodsFor!

initializeWithKey: aSymbol
	key := aSymbol!

key
	^ key!

seasidePossibleCauses
	^ #(
		'you need to clear your configuration caches to see new attributes (try "WAAdmin clearConfigurationCaches" in a workspace)'
		'you have not included a necessary ancestor in a configuration'
	)! !
!WAAttributeNotFound categoriesFor: #initializeWithKey:!initialization!public! !
!WAAttributeNotFound categoriesFor: #key!accessing!public! !
!WAAttributeNotFound categoriesFor: #seasidePossibleCauses!accessing!public! !

!WAAttributeNotFound class methodsFor!

signalWithKey: aSymbol
	^ self new
		initializeWithKey: aSymbol;
		signal! !
!WAAttributeNotFound class categoriesFor: #signalWithKey:!public!signaling! !

WANotification guid: (GUID fromString: '{C7A6E571-F850-48D4-953F-A235F67B23EF}')!
WANotification comment: ''!
!WANotification categoriesForClass!Unclassified! !
WADynamicVariable guid: (GUID fromString: '{708BE972-F509-4E9F-A886-3DD936FB954F}')!
WADynamicVariable comment: '
A WADynamicVariable is a variable that is visible only in the stackframes outgoing from this one.

Example:

WADynamicVariable
	use: ''Seaside''
	during: [ self compilcatedCalculation ]
	
Whenever
WADynamicVariable value
gets evaluated somewhere inside [ self compilcatedCalculation ] or a method invoked directly or indirectly by it, its value will be ''Seaside''. If no #use:during: handler is around the current stack frame, then the value will be the return value of #defaultValue.

Do not use WADynamicVariable directly, instead create a subclass for each variable you want to use.'!
!WADynamicVariable categoriesForClass!Unclassified! !
!WADynamicVariable methodsFor!

defaultAction
	^ self class defaultValue! !
!WADynamicVariable categoriesFor: #defaultAction!defaults!public! !

!WADynamicVariable class methodsFor!

defaultValue
	^ nil!

use: anObject during: aBlock
	"Set the dynamic value of the receiver to anObject during the evaluation of aBlock."
	
	^ aBlock on: self do: [ :notification | notification resume: anObject ]!

value
	"Answer the dynamic value of the receiver."
	
	^ self signal! !
!WADynamicVariable class categoriesFor: #defaultValue!defaults!public! !
!WADynamicVariable class categoriesFor: #use:during:!evaluating!public! !
!WADynamicVariable class categoriesFor: #value!evaluating!public! !

WARenderNotification guid: (GUID fromString: '{06122E36-DC20-4E91-9307-86A664A058B8}')!
WARenderNotification comment: ''!
!WARenderNotification categoriesForClass!Unclassified! !
!WARenderNotification methodsFor!

defaultAction
	^ WAUnhandledNotificationError signalWithNotification: self!

isResumable
	^ false! !
!WARenderNotification categoriesFor: #defaultAction!public! !
!WARenderNotification categoriesFor: #isResumable!public! !

WAResponseNotification guid: (GUID fromString: '{FF97B351-5A3B-4095-B564-F769EBB9867E}')!
WAResponseNotification comment: 'A WAReturnResponseRequest is singalled whenever the application server wants to return a response back to the client.'!
!WAResponseNotification categoriesForClass!Unclassified! !
!WAResponseNotification methodsFor!

defaultAction
	^ WAUnhandledNotificationError signalWithNotification: self!

isResumable
	^ false! !
!WAResponseNotification categoriesFor: #defaultAction!public! !
!WAResponseNotification categoriesFor: #isResumable!public!testing! !

WACurrentRequestContext guid: (GUID fromString: '{CDDE72ED-1D42-4C20-BD4C-B509E12E557F}')!
WACurrentRequestContext comment: '
A WACurrentRequestContext is a thread local variable that points to the current WARequestContext.
'!
!WACurrentRequestContext categoriesForClass!Unclassified! !
!WACurrentRequestContext class methodsFor!

defaultValue
	^ WARequestContextNotFound signal! !
!WACurrentRequestContext class categoriesFor: #defaultValue!defaults!public! !

WAObject guid: (GUID fromString: '{2B5F8C8E-8DBB-4990-A56B-B4C3220FF6BA}')!
WAObject comment: 'A WAObject is the base class for all portable Seaside classes. It guarantees that #initialize is send upon object creation. Additionally it provides convienience methods for accessing the current request context, session and application.'!
!WAObject categoriesForClass!Unclassified! !
!WAObject methodsFor!

requestContext
	"Answer the current WARequestContext instance."

	^ WACurrentRequestContext value! !
!WAObject categoriesFor: #requestContext!dynamic variables!public! !

!WAObject class methodsFor!

defaultErrorClass
	^ WAError! !
!WAObject class categoriesFor: #defaultErrorClass!error handling!public! !

WAHtmlAttributes guid: (GUID fromString: '{10A76F8A-08E7-4173-A523-5556DCFCEB12}')!
WAHtmlAttributes comment: 'I represent the attributes of a (X)(HT)ML tag. Compared to my superclass I ignore requests to add a nil-values. I also don''t throw an exception when accessing a key that doesn''t exist, but instead return nil.'!
!WAHtmlAttributes categoriesForClass!Unclassified! !
!WAHtmlAttributes methodsFor!

addClass: aString
	"Add an additional CSS class aString to the receiver."

	self at: 'class' append: aString separator: ' '!

addMedia: aString
	"Add an additional intended destination medium aString to the receiver."

	self at: 'media' append: aString separator: ', '!

addStyle: aString
	"Add an additional CSS style definition aString to the receiver."

	self at: 'style' append: aString separator: ';'!

at: aKey append: aValue
	"Append aValue to the attribute aKey. If already present, concatenate it with a space. Ignore the request if aValue is nil."

	^ self at: aKey append: aValue separator: ' '!

at: aKey append: aValue separator: aString 
	"Append aValue to the attribute aKey. If already present, concatenate it with aString. Ignore the request if aValue is nil."
	
	^ aValue isNil
		ifTrue: [ self at: aKey ]
		ifFalse: [
			self at: aKey put: (String streamContents: [ :stream | 
				self at: aKey ifPresent: [ :value | 
					stream nextPutAll: value greaseString.
					stream nextPutAll: aString ].
				stream nextPutAll: aValue greaseString ]) ]!

encodeOn: aDocument
	"Encode the receivers attribute onto aDocument. Note that this implementation reqires those two checks for true and false exactly the way they are here, to reliable encode boolean attributes in an XHTML compliant way."

	self keysAndValuesDo: [ :key :value |
		value == false ifFalse: [
			aDocument nextPut: $ ; nextPutAll: key; nextPutAll: '="'.
			value == true
				ifTrue: [ aDocument nextPutAll: key ]
				ifFalse: [ aDocument print: value ].
			aDocument nextPut: $" ] ]!

errorKeyNotFound
	^ nil!

privateAt: aKey put: aValue
	aValue ifNil: [ ^ nil ].
	^ super privateAt: aKey put: aValue! !
!WAHtmlAttributes categoriesFor: #addClass:!convenience!public! !
!WAHtmlAttributes categoriesFor: #addMedia:!convenience!public! !
!WAHtmlAttributes categoriesFor: #addStyle:!convenience!public! !
!WAHtmlAttributes categoriesFor: #at:append:!accessing!public! !
!WAHtmlAttributes categoriesFor: #at:append:separator:!accessing!public! !
!WAHtmlAttributes categoriesFor: #encodeOn:!encoding!public! !
!WAHtmlAttributes categoriesFor: #errorKeyNotFound!private! !
!WAHtmlAttributes categoriesFor: #privateAt:put:!private! !

WAHeaderFields guid: (GUID fromString: '{7BC6CD09-6A8D-4878-84BE-DA1EA584F36C}')!
WAHeaderFields comment: ''!
!WAHeaderFields categoriesForClass!Unclassified! !
!WAHeaderFields methodsFor!

at: aKey append: aValue
	self greaseDeprecatedApi: 'WAHeaderFields>>#at:append:'
		details:  'Use WAHeaderFields>>#at:add:.'.
	
	^ self at: aKey add: aValue!

errorKeyNotFound
	^ nil! !
!WAHeaderFields categoriesFor: #at:append:!public! !
!WAHeaderFields categoriesFor: #errorKeyNotFound!private! !

WARequestFields guid: (GUID fromString: '{8097BA18-6D8D-48A3-A4EA-57A92D544344}')!
WARequestFields comment: ''!
!WARequestFields categoriesForClass!Unclassified! !
!WARequestFields methodsFor!

at: aKey append: aValue
	self greaseDeprecatedApi: 'WARequestFields>>#at:append:'
		details:  'Use WARequestFields>>#at:add:.'.
	
	^ self at: aKey add: aValue! !
!WARequestFields categoriesFor: #at:append:!public! !

WAAttributeSearchContext guid: (GUID fromString: '{85EA051F-6B50-4C37-BE15-2AB8B36737C7}')!
WAAttributeSearchContext comment: 'This class makes attribute searching more efficient by traversing the ancestry once and caching which Configurations hold the attribute. It is then passed through search functions which cache values for the attribute.'!
!WAAttributeSearchContext categoriesForClass!Unclassified! !
!WAAttributeSearchContext methodsFor!

at: aConfiguration ifPresent: aBlock
	^ self cachedValues at: aConfiguration ifPresent: aBlock!

at: aConfiguration put: cachedObject
	^ self cachedValues at: aConfiguration put: cachedObject!

attribute
	^ attribute!

cachedValues
	^ cachedValues!

findAttributeAndSelectAncestorsOf: aConfiguration
	| found |
	(attributeHolders includes: aConfiguration) ifTrue: [ ^ true ].
			
	aConfiguration localAttributeAt: self key ifPresent:
		[ :attr |
		attribute := attr.
		attributeHolders add: aConfiguration.
		^ true ].
		
	found := false.
	aConfiguration parents do: [ :each | found := found | (self findAttributeAndSelectAncestorsOf: each) ].
	
	found ifTrue: [ attributeInheritors add: aConfiguration ].
	
	^ found!

initializeWithKey: keySymbol
	self initialize.
	key := keySymbol.
	attributeHolders := Set new.
	attributeInheritors := Set new.
	cachedValues := Dictionary new!

isAttributeFoundOn: aConfiguration 
	^ (self isAttributeLocalOn: aConfiguration) or: [ self isAttributeInheritedOn: aConfiguration ]!

isAttributeInheritedOn: aConfiguration 
	^ attributeInheritors includes: aConfiguration!

isAttributeLocalOn: aConfiguration 
	^ attributeHolders includes: aConfiguration!

key
	^ key! !
!WAAttributeSearchContext categoriesFor: #at:ifPresent:!accessing!public! !
!WAAttributeSearchContext categoriesFor: #at:put:!accessing!public! !
!WAAttributeSearchContext categoriesFor: #attribute!accessing!public! !
!WAAttributeSearchContext categoriesFor: #cachedValues!private! !
!WAAttributeSearchContext categoriesFor: #findAttributeAndSelectAncestorsOf:!private! !
!WAAttributeSearchContext categoriesFor: #initializeWithKey:!initialization!public! !
!WAAttributeSearchContext categoriesFor: #isAttributeFoundOn:!public!testing! !
!WAAttributeSearchContext categoriesFor: #isAttributeInheritedOn:!public!testing! !
!WAAttributeSearchContext categoriesFor: #isAttributeLocalOn:!public!testing! !
!WAAttributeSearchContext categoriesFor: #key!accessing!public! !

!WAAttributeSearchContext class methodsFor!

key: keySymbol target: targetConfiguration
	^ self basicNew
		initializeWithKey: keySymbol;
		findAttributeAndSelectAncestorsOf: targetConfiguration;
		yourself! !
!WAAttributeSearchContext class categoriesFor: #key:target:!instance creation!public! !

WABuilder guid: (GUID fromString: '{1B8A3F9E-7C96-4382-B968-AF258519566A}')!
WABuilder comment: '
This is a convenience class which provides a result of a rendering operation as a string. It is expected to be used like this:

WARenderCanvas builder render: [ :html |
	html anchor
		url: ''htttp://www.seaside.st'';
		with: ''Seaside Homepage'' ]

See WABuilderCanvasTest for more examples.'!
!WABuilder categoriesForClass!Unclassified! !
!WABuilder methodsFor!

actionUrl
	^ actionUrl ifNil: [ actionUrl := WAUrl new ]!

actionUrl: aUrl
	actionUrl := aUrl!

closeDocument: aDocument
	self fullDocument 
		ifTrue: [ aDocument close ]
		ifFalse: [ 
			"hack to make it work"
			(aDocument isKindOf: WAHtmlDocument)
				ifTrue: [ aDocument scriptGenerator closeOn: aDocument ] ]!

codec
	^ codec ifNil: [
		 codec := [ self requestContext codec ] 
			on: WARequestContextNotFound
			do: [ :e | GRNullCodec new ] ]!

codec: aCodec
	codec := aCodec!

documentClass
	^ documentClass ifNil: [ documentClass := WADocument ]!

documentClass: aDocumentClass
	documentClass := aDocumentClass!

fullDocument
	^fullDocument!

fullDocument: aBoolean
	fullDocument := aBoolean!

initialize
	super initialize.
	self fullDocument: false!

openDocument: aDocument context: aContext 
	| documentRoot |
	self fullDocument ifFalse: [ ^ self ].
	documentRoot := self rootClass context: aContext.
	self rootBlock value: documentRoot.
	aDocument open: documentRoot!

render: anObject
	"Render anObject and return the contents of the resulting Document as a String.
	anObject must understand #renderOn:. Commonly anObject will be a one-argument
	block, which will be evaluated with the appropriate renderer."
	
	^ String streamContents: [ :stream |
		| context document renderer |
		document := self documentClass on: stream codec: self codec.
		context := WARenderContext new.
		context document: document.
		context actionUrl: self actionUrl; resourceUrl: self resourceUrl.
		renderer := self rendererClass context: context.
		
		self openDocument: document context: context.
		renderer render: anObject; flush.
		self closeDocument: document ]!

rendererClass
	^ rendererClass!

rendererClass: aRendererClass 
	rendererClass := aRendererClass!

renderResponse: anObject 
	"This implementation will only work when used within a Session or something that has WACurrentRequestContext defined."
	self 
		greaseDeprecatedApi: 'WABuilder>>#renderResponse:'
		details: 'Returning a response is no longer allowed. Use WABuilder>>#render: to obtain the contents, configure the response returned by WARequestContext>>#response, then respond using WARequestContext>>#respond.'.
	self fullDocument: true.
	self requestContext respond: 
		[ :response | 
		response
			contentType: WAMimeType textHtml;
			nextPutAll: (self render: anObject) ]!

resourceUrl
	^ resourceUrl!

resourceUrl: aUrl
	resourceUrl := aUrl!

rootBlock
	^ rootBlock ifNil: [ rootBlock := [ :root | ] ]!

rootBlock: anObject
	rootBlock := anObject!

rootClass
	^ rootClass ifNil: [ rootClass := WARoot ]!

rootClass: aRootClass
	rootClass := aRootClass! !
!WABuilder categoriesFor: #actionUrl!accessing!public! !
!WABuilder categoriesFor: #actionUrl:!accessing!public! !
!WABuilder categoriesFor: #closeDocument:!private! !
!WABuilder categoriesFor: #codec!accessing!public! !
!WABuilder categoriesFor: #codec:!accessing!public! !
!WABuilder categoriesFor: #documentClass!accessing!public! !
!WABuilder categoriesFor: #documentClass:!accessing!public! !
!WABuilder categoriesFor: #fullDocument!accessing!public! !
!WABuilder categoriesFor: #fullDocument:!accessing!public! !
!WABuilder categoriesFor: #initialize!initialization!public! !
!WABuilder categoriesFor: #openDocument:context:!private! !
!WABuilder categoriesFor: #render:!public!rendering! !
!WABuilder categoriesFor: #rendererClass!accessing!public! !
!WABuilder categoriesFor: #rendererClass:!accessing!public! !
!WABuilder categoriesFor: #renderResponse:!public! !
!WABuilder categoriesFor: #resourceUrl!accessing!public! !
!WABuilder categoriesFor: #resourceUrl:!accessing!public! !
!WABuilder categoriesFor: #rootBlock!accessing!public! !
!WABuilder categoriesFor: #rootBlock:!accessing!public! !
!WABuilder categoriesFor: #rootClass!accessing!public! !
!WABuilder categoriesFor: #rootClass:!accessing!public! !

!WABuilder class methodsFor!

on: aRendererClass
	^self new
		rendererClass: aRendererClass;
		yourself! !
!WABuilder class categoriesFor: #on:!instance creation!public! !

WACache guid: (GUID fromString: '{50C99346-85B5-49A8-8CB2-8C9A880C7EF9}')!
WACache comment: '
A WACache represents a collection of arbitrary objects referenced by a key (an instance of WAExternalID).

Methods are provided to add and retrieve and remove objects from the cache. The behaviour of the cache is configurable through four different plugins:

+ expiry policy: determines when objects are considered expired
+ cache miss strategy: determines what do to if a requested object is not found in the cache
+ cache reap action: determines what to do when an expired object is eventually reaped from the cache
+ cache reaping strategy: determines when expired objects should be reaped from the cache

Access to the two dictionaries which store the objects and keys is protected by a mutex. Calls to the plugins are currently not protected by the mutex, but possibly should be to simplify implementation of the plugins.'!
!WACache categoriesForClass!Unclassified! !
!WACache methodsFor!

at: aString
	^ self at: aString ifAbsent: [ nil ]!

at: aString ifAbsent: absentBlock
	"Return the object stored at the key aString. If the key is not found in the
	cache, return the result of evaluating absentBlock.
	The block should not be evaluated within the mutex since it could take a long time."
	
	| object |
	mutex critical: [
		object := objectsByKey at: aString ifAbsent: [ self missStrategy missed: aString ].
		object isNil ifFalse: [
			(self expiryPolicy isExpired: object key: aString)
				ifTrue: [
					"Should we remove the object here?"
					object := nil ]
				ifFalse: [ self notifyRetrieved: object key: aString ] ] ].
	
	^ object ifNil: [ absentBlock value ]!

clear
	"Remove all objects from the cache. The removal action will be triggered for each
	object that is removed."
	
	| objects |
	mutex critical: [
		objects := objectsByKey.
		self initializeCollections.
		objects isNil ifFalse: [
			objects keysAndValuesDo: [ :key :object | self notifyRemoved: object key: key ] ] ]!

copy
	"Some of our operations replace the collections sotred in our instance variables. We don't
	want a copy to be made in the middle of this process (or it might have an unmatched pair)
	so we need to copy within our mutex."
	^ mutex critical: [ super copy ]!

copyEmpty
	"Create a copy with no values."
	
	^ self species new
		setExpiryPolicy: self expiryPolicy copy;
		setMissStrategy: self missStrategy copy;
		setRemovalAction: self removalAction copy;
		setReapingStrategy: self reapingStrategy copy;
		yourself!

expiryPolicy
	^ expiryPolicy!

initialize
	super initialize.
	self initializeCollections.
	self initializeMutex.
	self setExpiryPolicy: WALastAccessExpiryPolicy new.
	self setReapingStrategy: WARetrievalIntervalReapingStrategy new.
	self setMissStrategy: WACacheMissStrategy new.
	self setRemovalAction: WANotifyRemovalAction new!

initializeCollections
	objectsByKey := GRPlatform current reducedConflictDictionary new.
	keysByObject := GRPlatform current reducedConflictDictionary new!

initializeMutex
	mutex := WAMutex new!

isEmpty
	^ self size = 0!

keyAtValue: anObject
	^ self keyAtValue: anObject ifAbsent: [ nil ]!

keyAtValue: anObject ifAbsent: absentBlock
	"Return the key at which anObject is stored. If anObject is not found in the
	cache, return the result of evaluating absentBlock.
	The block should not be evaluated within the mutex since it could take a long time."
	
	| key |
	key := mutex critical: [ keysByObject at: anObject ifAbsent: [ nil ] ].
	
	^ key ifNil: [ absentBlock value ]!

keysAndValuesDo: aBlock

	objectsByKey keysAndValuesDo: aBlock!

keySize
	^ 16!

missStrategy
	^ missStrategy!

notifyRemoved: anObject key: aString
	self pluginsDo: [ :each | each removed: anObject key: aString ]!

notifyRetrieved: anObject key: aString
	self pluginsDo: [ :each | each retrieved: anObject key: aString ]!

notifyStored: anObject key: aString
	self pluginsDo: [ :each | each stored: anObject key: aString ]!

pluginsDo: aBlock
	aBlock value: self expiryPolicy.
	aBlock value: self reapingStrategy.
	aBlock value: self missStrategy.
	aBlock value: self removalAction.!

postCopy
	super postCopy.
	"At this point we are sharing the mutex with the original object. This means
	we can safely copy our dictionaries and our plugins."
	mutex critical: [
		keysByObject := keysByObject copy.
		objectsByKey := objectsByKey copy.
		
		self setExpiryPolicy: self expiryPolicy copy.
		self setMissStrategy: self missStrategy copy.
		self setRemovalAction: self removalAction copy.
		self setReapingStrategy: self reapingStrategy copy ].
	"Now we're done and have all our own data so we want our own mutex."
	self initializeMutex!

reap
	"Iterate through the cache and remove objects that have expired."
	| newObjectsByKey newKeysByObject |
	newObjectsByKey := GRPlatform current reducedConflictDictionary new.
	newKeysByObject := GRPlatform current reducedConflictDictionary new.
	mutex critical: 
		[ objectsByKey keysAndValuesDo: 
			[ :key :object | 
			(self expiryPolicy 
				isExpired: object
				key: key) 
				ifTrue: 
					[ self 
						notifyRemoved: object
						key: key ]
				ifFalse: 
					[ newObjectsByKey 
						at: key
						put: object.
					newKeysByObject 
						at: object
						put: key ] ].
		objectsByKey := newObjectsByKey.
		keysByObject := newKeysByObject ]!

reapingStrategy
	^ reapingStrategy!

removalAction
	^ removalAction!

remove: anObject
	^ self remove: anObject ifAbsent: [ nil ]!

remove: anObject ifAbsent: absentBlock
	"Remove anObject from the cache, returning the removed object. If the object is not
	found in the cache,	return the result of evaluating absentBlock.
	The block should not be evaluated within the mutex since it could take a long time."
	
	| key |
	mutex critical: [
		key := keysByObject at: anObject ifAbsent: [ nil ].
		key isNil ifFalse: [
			keysByObject removeKey: anObject ifAbsent: [ nil ].
			objectsByKey removeKey: key ifAbsent: [ nil ].
			self notifyRemoved: anObject key: key ] ].
		
	^ key isNil ifTrue: [ absentBlock value ] ifFalse: [ anObject ]!

removeKey: aString
	^ self removeKey: aString ifAbsent: [ nil ]!

removeKey: aString ifAbsent: absentBlock
	"Remove the object stored at the key aString and return the removed object. If the key
	is not found in the cache, return the result of evaluating absentBlock.
	The block should not be evaluated within the mutex since it could take a long time."
	
	| object |
	mutex critical: [
		object := objectsByKey removeKey: aString ifAbsent: [ nil ].
		keysByObject removeKey: object ifAbsent: [ nil ].
		object isNil ifFalse: [ self notifyRemoved: object key: aString ] ].
	
	^ object ifNil: [ absentBlock value ]!

setExpiryPolicy: anExpiryPolicy
	expiryPolicy := anExpiryPolicy setCache: self; yourself!

setMissStrategy: aMissStrategy
	missStrategy := aMissStrategy setCache: self; yourself!

setReapingStrategy: aReapingStrategy
	reapingStrategy := aReapingStrategy setCache: self; yourself!

setRemovalAction: aRemovalAction
	removalAction := aRemovalAction setCache: self; yourself!

size
	"Retun the number of objects currently in the cache. This number includes objects that
	are expired but have not yet been removed in a cache reap."

	^ mutex critical: [ objectsByKey size ].
!

store: anObject
	"Store anObject in the cache, generating a new random key. Return the key."
	
	| key |
	mutex critical: [
		[ objectsByKey includesKey:
			(key := WAKeyGenerator current keyOfLength: self keySize) ] whileTrue.
		objectsByKey at: key put: anObject.
		keysByObject at: anObject put: key.
		self notifyStored: anObject key: key ].
	
	^ key! !
!WACache categoriesFor: #at:!public! !
!WACache categoriesFor: #at:ifAbsent:!public! !
!WACache categoriesFor: #clear!public! !
!WACache categoriesFor: #copy!copying!public! !
!WACache categoriesFor: #copyEmpty!copying!public! !
!WACache categoriesFor: #expiryPolicy!private-accessing!public! !
!WACache categoriesFor: #initialize!initialization!public! !
!WACache categoriesFor: #initializeCollections!initialization!public! !
!WACache categoriesFor: #initializeMutex!initialization!public! !
!WACache categoriesFor: #isEmpty!public!testing! !
!WACache categoriesFor: #keyAtValue:!public! !
!WACache categoriesFor: #keyAtValue:ifAbsent:!public! !
!WACache categoriesFor: #keysAndValuesDo:!enumerating!public! !
!WACache categoriesFor: #keySize!configuration!public! !
!WACache categoriesFor: #missStrategy!private-accessing!public! !
!WACache categoriesFor: #notifyRemoved:key:!private! !
!WACache categoriesFor: #notifyRetrieved:key:!private! !
!WACache categoriesFor: #notifyStored:key:!private! !
!WACache categoriesFor: #pluginsDo:!private! !
!WACache categoriesFor: #postCopy!copying!public! !
!WACache categoriesFor: #reap!public! !
!WACache categoriesFor: #reapingStrategy!private-accessing!public! !
!WACache categoriesFor: #removalAction!private-accessing!public! !
!WACache categoriesFor: #remove:!public! !
!WACache categoriesFor: #remove:ifAbsent:!public! !
!WACache categoriesFor: #removeKey:!public! !
!WACache categoriesFor: #removeKey:ifAbsent:!public! !
!WACache categoriesFor: #setExpiryPolicy:!initialization!public! !
!WACache categoriesFor: #setMissStrategy:!initialization!public! !
!WACache categoriesFor: #setReapingStrategy:!initialization!public! !
!WACache categoriesFor: #setRemovalAction:!initialization!public! !
!WACache categoriesFor: #size!public! !
!WACache categoriesFor: #store:!public! !

WACachePlugin guid: (GUID fromString: '{9F17EE00-8DD3-47A2-989E-B38B86EEDEF3}')!
WACachePlugin comment: ''!
!WACachePlugin categoriesForClass!Unclassified! !
!WACachePlugin methodsFor!

configuration
	^ configuration!

defaultConfiguration
	^ WAUserConfiguration new!

initialize
	super initialize.
	configuration := self defaultConfiguration!

removed: anObject key: aString
	"Notification that an object has been removed from the cache."
!

retrieved: anObject key: aString
	"Notification that an object has been retrieved from the cache."!

setCache: aCache
	cache := aCache!

stored: anObject key: aString
	"Notificatin that a new object is being stored in the cache."! !
!WACachePlugin categoriesFor: #configuration!accessing!public! !
!WACachePlugin categoriesFor: #defaultConfiguration!configuration!public! !
!WACachePlugin categoriesFor: #initialize!initialization!public! !
!WACachePlugin categoriesFor: #removed:key:!notifications!public! !
!WACachePlugin categoriesFor: #retrieved:key:!notifications!public! !
!WACachePlugin categoriesFor: #setCache:!initialization!public! !
!WACachePlugin categoriesFor: #stored:key:!notifications!public! !

!WACachePlugin class methodsFor!

cache: aCache
	^ self new setCache: aCache; yourself! !
!WACachePlugin class categoriesFor: #cache:!instance creation!public! !

WACallback guid: (GUID fromString: '{BD35BB25-00DC-4617-88AD-9F9885FAE6E5}')!
WACallback comment: ''!
!WACallback categoriesForClass!Unclassified! !
!WACallback methodsFor!

<= other
	^ self priority < other priority or: [ self priority = other priority and: [ self key asNumber <= other key asNumber ] ]!

block: aBlock!

convertKey: aString
	^ aString!

evaluateWithArgument: anObject
	self subclassResponsibility!

evaluateWithFieldValues: anOrderedCollection
	self evaluateWithArgument: (self valueForField: (anOrderedCollection at: 1 ifAbsent: [ nil ]))!

isEnabledFor: aRequestContext
	^ true!

key
	"Answer the callback key of the receiver."
	
	^ self convertKey: key!

priority
	"Answer the priority in which the receiver is evaluated."
	
	^ 0!

setKey: aString callbacks: aDictionary
	key := aString!

valueForField: anObject
	"Answer the value that should be used when the field value in the Request
	is anObject. This allows subclasses to specify a default value other than
	nil, for example."

	^ anObject! !
!WACallback categoriesFor: #<=!comparing!public! !
!WACallback categoriesFor: #block:!accessing!public! !
!WACallback categoriesFor: #convertKey:!converting!public! !
!WACallback categoriesFor: #evaluateWithArgument:!evaluation!public! !
!WACallback categoriesFor: #evaluateWithFieldValues:!evaluation!public! !
!WACallback categoriesFor: #isEnabledFor:!public!testing! !
!WACallback categoriesFor: #key!accessing!public! !
!WACallback categoriesFor: #priority!accessing!public! !
!WACallback categoriesFor: #setKey:callbacks:!initialization!public! !
!WACallback categoriesFor: #valueForField:!converting!public! !

!WACallback class methodsFor!

on: aBlock
	^ self new block: aBlock! !
!WACallback class categoriesFor: #on:!instance creation!public! !

WACallbackRegistry guid: (GUID fromString: '{31D08C5B-5C97-4B48-8806-05F993623E51}')!
WACallbackRegistry comment: ''!
!WACallbackRegistry categoriesForClass!Unclassified! !
!WACallbackRegistry methodsFor!

advanceKey
	| key |
	key := self nextKey.
	self increaseKey.
	^ key!

handle: aRequestContext
	| set fields |
	set := Set new.
	fields := aRequestContext request fields.
	fields keysDo: [ :key |
		callbacks at: key ifPresent: [ :callback |
			(callback isEnabledFor: aRequestContext)
				ifTrue: [ set add: callback ] ] ].
	set sorted do: [ :callback |
		callback evaluateWithFieldValues:
			(fields allAt: callback key) ]!

increaseKey
	nextKey := nextKey + 1!

initialize
	super initialize.
	callbacks := Dictionary new.
	nextKey := 1!

nextKey
	^ nextKey greaseString!

registerActionCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerActionCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAActionCallback on: aBlock)!

registerCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAValueCallback on: aBlock)!

registerCancelActionCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerCancelActionCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WACancelActionCallback on: aBlock)!

registerDefaultActionCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerDefaultActionCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WADefaultActionCallback on: aBlock)!

registerDispatchCallback
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerDispatchCallback'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: WADispatchCallback new!

registerImageCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerImageCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAImageCallback on: aBlock)!

registerMapCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerMapCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAMapCallback on: aBlock)!

registerUploadCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerUploadCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAUploadCallback on: aBlock)!

registerValueCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerValueCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAValueCallback on: aBlock)!

store: aCallback 
	| key |
	key := self advanceKey.
	callbacks 
		at: (aCallback convertKey: key)
		put: aCallback.
	aCallback 
		setKey: key
		callbacks: callbacks.
	^ key! !
!WACallbackRegistry categoriesFor: #advanceKey!accessing!public! !
!WACallbackRegistry categoriesFor: #handle:!processing!public! !
!WACallbackRegistry categoriesFor: #increaseKey!accessing!public! !
!WACallbackRegistry categoriesFor: #initialize!initialization!public! !
!WACallbackRegistry categoriesFor: #nextKey!accessing!public! !
!WACallbackRegistry categoriesFor: #registerActionCallback:!public! !
!WACallbackRegistry categoriesFor: #registerCallback:!public! !
!WACallbackRegistry categoriesFor: #registerCancelActionCallback:!public! !
!WACallbackRegistry categoriesFor: #registerDefaultActionCallback:!public! !
!WACallbackRegistry categoriesFor: #registerDispatchCallback!public! !
!WACallbackRegistry categoriesFor: #registerImageCallback:!public! !
!WACallbackRegistry categoriesFor: #registerMapCallback:!public! !
!WACallbackRegistry categoriesFor: #registerUploadCallback:!public! !
!WACallbackRegistry categoriesFor: #registerValueCallback:!public! !
!WACallbackRegistry categoriesFor: #store:!public!registration! !

!WACallbackRegistry class methodsFor!

context: aContext 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry class>>#context:'
		details: 'Use #new. Callbacks are no longer instantiated with a context and an owning component.'.
	^ self new!

context: aContext owner: anObject 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry class>>#context:owner:'
		details: 'Use #new. Callbacks are no longer instantiated with a context and an owning component.'.
	^ self new! !
!WACallbackRegistry class categoriesFor: #context:!public! !
!WACallbackRegistry class categoriesFor: #context:owner:!public! !

WAClosingConditionalComment guid: (GUID fromString: '{89DBFC6D-DB35-4443-8DD8-91CE1EAEF599}')!
WAClosingConditionalComment comment: 'Closes a WAConditionalComment.'!
!WAClosingConditionalComment categoriesForClass!Unclassified! !
!WAClosingConditionalComment methodsFor!

encodeOn: aDocument
	aDocument nextPutAll: '<!![endif]-->'! !
!WAClosingConditionalComment categoriesFor: #encodeOn:!printing!public! !

WAClosingRevealedConditionalComment guid: (GUID fromString: '{2E69F64D-7E80-4E06-A665-059852C5882E}')!
WAClosingRevealedConditionalComment comment: 'Closes a WARevealedConditionalComment.'!
!WAClosingRevealedConditionalComment categoriesForClass!Unclassified! !
!WAClosingRevealedConditionalComment methodsFor!

encodeOn: aDocument
	aDocument nextPutAll: '<!!--<!![endif]-->'! !
!WAClosingRevealedConditionalComment categoriesFor: #encodeOn:!printing!public! !

WAConditionalComment guid: (GUID fromString: '{7B5CC3CC-D564-47E7-A14C-C34C8202248C}')!
WAConditionalComment comment: '
A WAConditionalComment is an implementation of Downlevel-hidden Conditional Comments:
http://msdn2.microsoft.com/en-us/library/ms537512.aspx
These are only visible for the IE family of browsers.

See also WAOpeningConditionalComment and WAClosingConditionalComment.'!
!WAConditionalComment categoriesForClass!Unclassified! !
!WAConditionalComment methodsFor!

addToCondition: aString
	condition := condition , aString!

closingConditionClass
	^WAClosingConditionalComment!

do: aBlock
	root add: (self openingConditionClass condition: condition).
	aBlock value.
	root add: (self closingConditionClass new)!

equal
	"implicit of nothing else"!

greaterThan
	self addToCondition: ' gt'!

ie
	self addToCondition: ' IE'!

ie: aString
	self addToCondition: ' IE ', aString!

ie5
	self addToCondition: '5'!

ie50
	self addToCondition: '5.0'!

ie55
	self ie: '5.5'!

ie6
	self ie: '6'!

ie7
	self ie: '7'!

ie8
	self ie: '8'!

initializeWithRoot: anHtmlRoot
	self initialize.
	root := anHtmlRoot.
	condition := 'if'!

lessThan
	self addToCondition: ' lt'!

not
	self addToCondition: ' !!'!

openingConditionClass
	^WAOpeningConditionalComment!

orEqual
	self addToCondition: 'e'! !
!WAConditionalComment categoriesFor: #addToCondition:!private! !
!WAConditionalComment categoriesFor: #closingConditionClass!private! !
!WAConditionalComment categoriesFor: #do:!public! !
!WAConditionalComment categoriesFor: #equal!operators!public! !
!WAConditionalComment categoriesFor: #greaterThan!operators!public! !
!WAConditionalComment categoriesFor: #ie!features!public! !
!WAConditionalComment categoriesFor: #ie:!features!public! !
!WAConditionalComment categoriesFor: #ie5!features!public! !
!WAConditionalComment categoriesFor: #ie50!features!public! !
!WAConditionalComment categoriesFor: #ie55!features!public! !
!WAConditionalComment categoriesFor: #ie6!features!public! !
!WAConditionalComment categoriesFor: #ie7!features!public! !
!WAConditionalComment categoriesFor: #ie8!features!public! !
!WAConditionalComment categoriesFor: #initializeWithRoot:!initialization!public! !
!WAConditionalComment categoriesFor: #lessThan!operators!public! !
!WAConditionalComment categoriesFor: #not!operators!public! !
!WAConditionalComment categoriesFor: #openingConditionClass!private! !
!WAConditionalComment categoriesFor: #orEqual!operators!public! !

!WAConditionalComment class methodsFor!

root: anHtmlRoot
	^self basicNew initializeWithRoot: anHtmlRoot! !
!WAConditionalComment class categoriesFor: #root:!instance creation!public! !

WAConfiguration guid: (GUID fromString: '{F6B06386-D56E-456C-B58A-6ADEE8CA3346}')!
WAConfiguration comment: '
A configuration for a Seaside application contains attributes which can be used by Seaside and the application. WAConfiguration hierarchy uses the composite pattern.

Subclasses of WASystemConfiguration define and configure related groups of attributes. See WASystemConfiguration class comment for information on defining your own attributes.

WAUserConfiguration is a composite of configurations. The set of configurations contained in WAUserConfiguration is called the ancestors. Attribute values in a configuration override the attribute values in the ancestors. WAUserConfiguration also holds the non-default values of attributes.

Seaside applications start with a WAUserConfiguration (see WAApplication>>configuration) a single parent: WARenderLoopConfiguration. The full ancestry also includes WASessionConfiguration WAGlobalConfiguration. Other configurations can be added to an application on the Seaside configuration page for the application or in your application. Values for the attributes can be given in either location. 

See Seaside documentation (http://www.seaside.st/documentation) on configuration and preferences (http://www.seaside.st/documentation/Configuration%20and%20Preferences) for more information.

Example of setting attributes and adding configurations in code
ASubclassOfWAComponent class>>initialize
	"self initialize"
	| application |
	application := self registerAsApplication: ''GlorpExample''.
	"set a standard attribute"
	application preferenceAt: #sessionClass put: Glorp.WAGlorpSession. 

	"add a configuration"
	application configuration addParent: GlorpConfiguration new.
	application preferenceAt: #databaseLogin put: ''foo''. "set attribute defined in GlorpConfiguration"

Subclasses must implement the following messages:
	name
		return the name of the configuration

	localValueAt:ifAbsent:
		return the value of the attribute given as first argument'!
!WAConfiguration categoriesForClass!Unclassified! !
!WAConfiguration methodsFor!

allAttributes
	| attributes |
	attributes := IdentityDictionary new.
	
	self ancestorsDo: 
		[ :each |
		each localAttributesDo: [ :attr | attributes at: attr key put: attr ] ].
	
	^ attributes!

ancestors
	"As it happens, the 'seen' set gives us the result we need"
	| set |
	set := IdentitySet new.
	self 
		ancestorsDo:  [ :each | "nothing" ]
		seen: set.
	^ set!

ancestorsDo: aBlock 
	| set |
	set := IdentitySet new.
	self 
		ancestorsDo: aBlock
		seen: set.
	^ set!

ancestorsDo: aBlock seen: seenSet 
	self parents reverseDo: [ :each | 
		(seenSet includes: each) ifFalse: [
			aBlock value: each.
			seenSet add: each.
			each 
				ancestorsDo: aBlock
				seen: seenSet ] ]!

at: aSymbol 
	| value context |
	context := self createSearchContextFor: aSymbol.

	value := self valueForContext: context.
	
	^ value isNil
		ifTrue: [ context attribute default ]
		ifFalse: [ value ]!

attributeAt: aSymbol
	^ self attributeAt: aSymbol ifAbsent: [ WAAttributeNotFound signalWithKey: aSymbol ]!

attributeAt: aSymbol ifAbsent: aBlock
	^ self allAttributes at: aSymbol ifAbsent: aBlock!

createSearchContextFor: aSymbol 
	| context |
	context := WAAttributeSearchContext key: aSymbol target: self.
	context attribute isNil ifTrue: [ WAAttributeNotFound signalWithKey: aSymbol ].
	^ context!

expressionAt: aSymbol ifAbsent: absentBlock
	self subclassResponsibility!

expressionAt: aSymbol ifPresent: aBlock
	| expression |
	expression := self expressionAt: aSymbol ifAbsent: [ ^ nil ].
	^ aBlock value: expression!

hasExpressionAt: aSymbol
	self expressionAt: aSymbol ifAbsent: [ ^ false ].
	^ true!

inheritedValueForContext: aContext
	| value |
	(self parents select: [ :each | aContext isAttributeInheritedOn: each ]) reverseDo:
		[ :each |
		value := each valueForContext: aContext.
		value notNil ifTrue: [ ^ value ] ].
	
	^ nil!

inheritsFrom: aConfiguration
	"Answer whether the given Configuration is a direct or indirect ancestor of this one"
	^ self ancestors includes: aConfiguration!

isShared
	^ false!

localAttributeAt: aSymbol ifAbsent: absentBlock
	self subclassResponsibility!

localAttributeAt: aSymbol ifPresent: aBlock
	| value |
	value := self localAttributeAt: aSymbol ifAbsent: [ ^ nil ].
	^ aBlock value: value!

localAttributesDo: aBlock
	self subclassResponsibility!

name
	^self class name!

parents
	^ #()!

valueAt: aSymbol 
	self 
		greaseDeprecatedApi: 'WAConfiguration>>#valueAt:'
		details: 'Use #at:.'.
	^ self at: aSymbol!

valueForContext: aContext
	aContext at: self ifPresent: [ :v | ^ v ].
	
	self expressionAt: aContext key ifPresent:
		[ :expression |
		^ aContext
			at: self
			put: (expression determineValueWithContext: aContext configuration: self) ].
	
	(aContext isAttributeLocalOn: self) ifTrue: [ ^ aContext at: self put: nil ].

	^ aContext at: self put: (self inheritedValueForContext: aContext)! !
!WAConfiguration categoriesFor: #allAttributes!attributes!public! !
!WAConfiguration categoriesFor: #ancestors!ancestry!public! !
!WAConfiguration categoriesFor: #ancestorsDo:!ancestry!public! !
!WAConfiguration categoriesFor: #ancestorsDo:seen:!ancestry-private!public! !
!WAConfiguration categoriesFor: #at:!public!values! !
!WAConfiguration categoriesFor: #attributeAt:!attributes!public! !
!WAConfiguration categoriesFor: #attributeAt:ifAbsent:!attributes!public! !
!WAConfiguration categoriesFor: #createSearchContextFor:!attributes-private!public! !
!WAConfiguration categoriesFor: #expressionAt:ifAbsent:!public!values! !
!WAConfiguration categoriesFor: #expressionAt:ifPresent:!public!values! !
!WAConfiguration categoriesFor: #hasExpressionAt:!public!values! !
!WAConfiguration categoriesFor: #inheritedValueForContext:!public!values-private! !
!WAConfiguration categoriesFor: #inheritsFrom:!ancestry!public! !
!WAConfiguration categoriesFor: #isShared!public!testing! !
!WAConfiguration categoriesFor: #localAttributeAt:ifAbsent:!attributes!public! !
!WAConfiguration categoriesFor: #localAttributeAt:ifPresent:!attributes!public! !
!WAConfiguration categoriesFor: #localAttributesDo:!attributes!public! !
!WAConfiguration categoriesFor: #name!accessing!public! !
!WAConfiguration categoriesFor: #parents!ancestry!public! !
!WAConfiguration categoriesFor: #valueAt:!public! !
!WAConfiguration categoriesFor: #valueForContext:!public!values-private! !

WAConfigurationDescription guid: (GUID fromString: '{AC6B70CB-582D-4F0C-BAFC-E91B0374C5F3}')!
WAConfigurationDescription comment: '
I hold a collection of attributes and present methods to construct new methods, providing an interface a bit like WACanvs and #renderContentOn: to WASystemConfiguration>>addAttributes:.

I can use any kind of collection class and handle setting the #configuration: parameter of the attribute appropriately on addition. If my collection is a Dictionary, I will store the attributes by their keys.
'!
!WAConfigurationDescription categoriesForClass!Unclassified! !
!WAConfigurationDescription methodsFor!

add: aDescriptor to: aDictionary
	^ aDictionary at: aDescriptor key put: aDescriptor!

addAttribute: anAttribute
	^ self add: anAttribute to: attributes!

addExpression: anExpression
	^ self add: anExpression to: expressions!

at: aSymbol addAll: aCollection
	self at: aSymbol addAll: aCollection removeAll: #()!

at: aSymbol addAll: additions removeAll: removals
	self addExpression: ((WAAddRemoveExpression key: aSymbol)
			additions: additions;
			removals: removals;
			yourself)!

at: aSymbol put: anObject 
	self addExpression: ((WAValueExpression key: aSymbol)
			value: anObject;
			yourself)!

attributes
	^ attributes!

boolean: aSymbol
	^ self addAttribute: (WABooleanAttribute key: aSymbol)!

collection: aSymbol
	^ self addAttribute: (WACollectionAttribute key: aSymbol)!

expressions
	^ expressions!

initialize
	super initialize.
	attributes := IdentityDictionary new.
	expressions := IdentityDictionary new.!

integer: aSymbol
	^ self addAttribute: (WAIntegerAttribute key: aSymbol)!

list: aSymbol
	^ self addAttribute: (WAListAttribute key: aSymbol)!

number: aSymbol
	^ self addAttribute: (WANumberAttribute key: aSymbol)!

password: aSymbol
	^ self addAttribute: (WAPasswordAttribute key: aSymbol)!

string: aSymbol
	^ self addAttribute: (WAStringAttribute key: aSymbol)!

url: aSymbol
	^ self addAttribute: (WAUrlAttribute key: aSymbol)! !
!WAConfigurationDescription categoriesFor: #add:to:!private! !
!WAConfigurationDescription categoriesFor: #addAttribute:!attribute creation!public! !
!WAConfigurationDescription categoriesFor: #addExpression:!public!values! !
!WAConfigurationDescription categoriesFor: #at:addAll:!public!values! !
!WAConfigurationDescription categoriesFor: #at:addAll:removeAll:!public!values! !
!WAConfigurationDescription categoriesFor: #at:put:!public!values! !
!WAConfigurationDescription categoriesFor: #attributes!accessing!public! !
!WAConfigurationDescription categoriesFor: #boolean:!attribute creation!public! !
!WAConfigurationDescription categoriesFor: #collection:!attribute creation!public! !
!WAConfigurationDescription categoriesFor: #expressions!accessing!public! !
!WAConfigurationDescription categoriesFor: #initialize!initialization!public! !
!WAConfigurationDescription categoriesFor: #integer:!attribute creation!public! !
!WAConfigurationDescription categoriesFor: #list:!attribute creation!public! !
!WAConfigurationDescription categoriesFor: #number:!attribute creation!public! !
!WAConfigurationDescription categoriesFor: #password:!attribute creation!public! !
!WAConfigurationDescription categoriesFor: #string:!attribute creation!public! !
!WAConfigurationDescription categoriesFor: #url:!attribute creation!public! !

WAConfigurationElement guid: (GUID fromString: '{003A5422-243C-4635-945C-C4CC532C7BB7}')!
WAConfigurationElement comment: ''!
!WAConfigurationElement categoriesForClass!Unclassified! !
!WAConfigurationElement methodsFor!

initializeWithKey: aSymbol
	self initialize.
	key := aSymbol!

key
	^ key! !
!WAConfigurationElement categoriesFor: #initializeWithKey:!initialization!public! !
!WAConfigurationElement categoriesFor: #key!accessing!public! !

!WAConfigurationElement class methodsFor!

key: aSymbol
	^ self basicNew initializeWithKey: aSymbol; yourself! !
!WAConfigurationElement class categoriesFor: #key:!instance creation!public! !

WADocument guid: (GUID fromString: '{F701663B-AEC4-430A-AA39-9B3032A21223}')!
WADocument comment: 'A WADocument combines an output stream and an instance of root. The root is reponsible to render header and footer if necessary.'!
!WADocument categoriesForClass!Unclassified! !
!WADocument methodsFor!

close
	"Close the receiving document."

	root isNil ifFalse: [ root closeOn: self ]!

destroy
	stream := root := nil!

initializeWithStream: aStream codec: aCodec
	self initialize.
	stream := aStream!

nextPut: aCharacter
	stream nextPut: aCharacter!

nextPutAll: aString
	stream nextPutAll: aString!

open: aRoot
	"Open the receiving document with aRoot."

	(root := aRoot) openOn: self!

scriptGenerator: aScriptGenerator
	"ignore"!

stream
	"Answer the underlying character stream of this document."

	^ stream! !
!WADocument categoriesFor: #close!actions!public! !
!WADocument categoriesFor: #destroy!initialization!public! !
!WADocument categoriesFor: #initializeWithStream:codec:!initialization!public! !
!WADocument categoriesFor: #nextPut:!public!writing! !
!WADocument categoriesFor: #nextPutAll:!public!writing! !
!WADocument categoriesFor: #open:!actions!public! !
!WADocument categoriesFor: #scriptGenerator:!accessing!public! !
!WADocument categoriesFor: #stream!accessing!public! !

!WADocument class methodsFor!

new
	^ self on: GRPlatform current readWriteCharacterStream!

on: aStream 
	^ self 
		on: aStream
		codec: GRNullCodec new!

on: aStream codec: aCodec
	^ self basicNew initializeWithStream: aStream codec: aCodec; yourself! !
!WADocument class categoriesFor: #new!instance creation!public! !
!WADocument class categoriesFor: #on:!instance creation!public! !
!WADocument class categoriesFor: #on:codec:!instance creation!public! !

WAEmailAddress guid: (GUID fromString: '{4EDDE7A2-DC07-4072-A3F6-93BC97A085F3}')!
WAEmailAddress comment: ''!
!WAEmailAddress categoriesForClass!Unclassified! !
!WAEmailAddress methodsFor!

address
	^address!

address: aString
	address := self sanitize: aString!

encodeOn: aDocument
	self encodeOn: aDocument xmlEncoder usingQuotes: false!

encodeOn: aStream usingQuotes: aBoolean
	username isNil ifFalse:  [
		aBoolean ifTrue: [ aStream nextPut: $" ].
		aStream nextPutAll: username.
		aBoolean ifTrue: [ aStream nextPut: $" ].
		aStream nextPutAll: ' <' ].
	aStream nextPutAll: address.
	username isNil ifFalse: [ aStream nextPut: $> ]!

greaseString
	^ String streamContents: 
		[ :stream | 
		self 
			encodeOn: stream
			usingQuotes: true ]!

printOn: aStream 
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self greaseString.
	aStream nextPut: $)!

sanitize: aString
	"prevents SMTP header injection"
	| newlineIndex |
	newlineIndex := (aString indexOf: Character cr) min: (aString indexOf: Character lf).
	^newlineIndex = 0
		ifTrue: [ aString ]
		ifFalse: [ aString copyFrom: 1 to: newlineIndex - 1  ]!

username
	^username!

username: aString
	username := self sanitize: aString! !
!WAEmailAddress categoriesFor: #address!accessing!public! !
!WAEmailAddress categoriesFor: #address:!accessing!public! !
!WAEmailAddress categoriesFor: #encodeOn:!displaying!public! !
!WAEmailAddress categoriesFor: #encodeOn:usingQuotes:!private! !
!WAEmailAddress categoriesFor: #greaseString!displaying!public! !
!WAEmailAddress categoriesFor: #printOn:!printing!public! !
!WAEmailAddress categoriesFor: #sanitize:!private! !
!WAEmailAddress categoriesFor: #username!accessing!public! !
!WAEmailAddress categoriesFor: #username:!accessing!public! !

!WAEmailAddress class methodsFor!

address: aString
	^self new
		address: aString;
		yourself!

address: anAddressString username: aUsernameString
	^self new
		address: anAddressString;
		username: aUsernameString;
		yourself! !
!WAEmailAddress class categoriesFor: #address:!instance creation!public! !
!WAEmailAddress class categoriesFor: #address:username:!instance creation!public! !

WAEncoder guid: (GUID fromString: '{40DE90D6-F034-4A59-8D01-BAB789DE72A6}')!
WAEncoder comment: '
I encode everything that is written to myself using #nextPut: and #nextPutAll: onto the wrapped stream. The specific encoding that is done is determined by my subclasses (the conversion of a single character is defined in the class-side method #encode:on:).

To be efficient, each subclass uses a cached encoding table to transform the most used characters from the UTF Basic Multilingual Plane.'!
!WAEncoder categoriesForClass!Unclassified! !
!WAEncoder methodsFor!

initializeOn: aStream table: anArray
	self initialize.
	stream := aStream.
	table := anArray!

nextPut: aCharacter 
	| value encoded |
	value := aCharacter greaseInteger.
	value < table size 
		ifFalse: [
			self class 
				encode: aCharacter
				on: stream ]
		ifTrue: [
			encoded := table at: value + 1.
			encoded isString 
				ifTrue: [ stream nextPutAll: encoded ]
				ifFalse: [ stream nextPut: encoded ] ]!

nextPutAll: aString 
	"uses #to:do: for speed reasons (on Pharo)
	this is not premature optimization, this is a hotspot method method
	and #to:do: shows measurable speed improvements for rendering seaside pages"
	| character value encoded |
	1 
		to: aString size
		do: [ :index | 
			character := aString at: index.
			value := character greaseInteger.
			value < table size 
				ifFalse: [
					self class 
						encode: character
						on: stream ]
				ifTrue: [
					encoded := table at: value + 1.
					encoded isString 
						ifTrue: [ stream nextPutAll: encoded ]
						ifFalse: [ stream nextPut: encoded ] ] ]! !
!WAEncoder categoriesFor: #initializeOn:table:!initialization!public! !
!WAEncoder categoriesFor: #nextPut:!accessing!public! !
!WAEncoder categoriesFor: #nextPutAll:!accessing!public! !

!WAEncoder class methodsFor!

encode: aCharacter on: aStream
	self subclassResponsibility!

initializeBMP
	"Initializes the BMP, the Basic Multilingual Plane of UTF characters, using the encoding strategy of the receiver. This chaching strategy ensures that most commonly used characters can be encoded as efficient as possible."

	| stream characterLimit |
	characterLimit := self maximumCharacterValue.
	"counting starts at zero so we need to add 1"
	table := Array new: characterLimit + 1.
	stream := WriteStream on: (String new: 6).
	0 to: characterLimit do: [ :index |
		| encoded |
		self encode: (Character codePoint: index) on: stream reset.
		encoded := stream contents.
		"Smalltalk indices are one based but character values start at 0"
		table at: index + 1 put: (encoded size = 1
			ifTrue: [ encoded first ]
			ifFalse: [ encoded ]) ]!

maximumCharacterValue
	"find the maximum value of a character that we can instantiate, for Squeak 3.7 this is 255"
	^[ Character codePoint: 16rFFFF.
		16rFFFF ]
			on: Error
			do: [ :error  | 16rFF ]!

new
	^ self on: GRPlatform current readWriteCharacterStream!

on: aStream
	^ self on: aStream table: table!

on: aStream codec: aCodec
	"For compatibility with WAUrlEncoder"
	^ self on: aStream!

on: aStream table: anArray
	^ self basicNew initializeOn: aStream table: anArray; yourself! !
!WAEncoder class categoriesFor: #encode:on:!private! !
!WAEncoder class categoriesFor: #initializeBMP!initialization!public! !
!WAEncoder class categoriesFor: #maximumCharacterValue!private! !
!WAEncoder class categoriesFor: #new!instance creation!public! !
!WAEncoder class categoriesFor: #on:!instance creation!public! !
!WAEncoder class categoriesFor: #on:codec:!instance creation!public! !
!WAEncoder class categoriesFor: #on:table:!instance creation!public! !

WAExceptionHandler guid: (GUID fromString: '{DE1A5DA0-BEBA-4735-9D8C-E836E434AD17}')!
WAExceptionHandler comment: '
Exception handlers are invoked when an error in a Seaside application occurs. Request handlers can use the class-side method #handleExceptionsDuring: to set up exception handlers around a block of code.

== Catching ==

Exception handlers can configure which exceptions they want to catch by overriding the class-side method #exceptionsToCatch. They may also choose to override #handleExceptionsDuring: on the class-side directly, if they need more complex behaviour.

== Handling ==

Handling behaviour is implemented on the instance side by implementing #handleException:. This method should return a suitable seaside response (usually an instance of WAResponse) if it returns.

== Internal Errors ==

Internal errors are typically errors that occur while trying to execute one of the other error handlers and should be as basic as possible to ensure they don''t have any trouble executing. Request handlers can ask for an internal error response by calling #internalError: on the class-side of an exception handler.

== HTML Responses ==

See WAWalkbackErrorHandler in the development packages for examples of how to do rendering with the canvas API.
'!
!WAExceptionHandler categoriesForClass!Unclassified! !
!WAExceptionHandler methodsFor!

, anException
	^ self class, anException!

handleException: anException
	"If for some reason we are asked to handle an exception for which we have no
	handling behaviour defined, just pass."	
	^ anException pass!

handleExceptionsDuring: aBlock
	^ aBlock
		on: self
		do: [ :exception | 
			[ self handleException: exception ]
				"If there's an error while handling the exception, fall
				back on an internal error response."
				on: Error
				do: [ :error | self internalError: error ] ] !

handles: anException
	^ self class handles: anException!

initializeWithContext: aRequestContext
	self initialize.
	requestContext := aRequestContext!

internalError: anError 
	"This method should not call #handleException: because subclasses want to modify the behaviour for for other exceptions without changing the simple fallback internal error behaviour."
	
	self requestContext responseGenerator
		internalError: anError;
		respond!

requestContext
	"Exception handlers are created with a request context because they may
	often be running where WACurrentRequestContext is either undefined or
	unused."
	^ requestContext! !
!WAExceptionHandler categoriesFor: #,!ansi-exception-selector!public! !
!WAExceptionHandler categoriesFor: #handleException:!actions!public! !
!WAExceptionHandler categoriesFor: #handleExceptionsDuring:!actions!public! !
!WAExceptionHandler categoriesFor: #handles:!ansi-exception-selector!public! !
!WAExceptionHandler categoriesFor: #initializeWithContext:!initialization!public! !
!WAExceptionHandler categoriesFor: #internalError:!actions!public! !
!WAExceptionHandler categoriesFor: #requestContext!accessing!public! !

!WAExceptionHandler class methodsFor!

, anException 
	"Create an exception set that includes all the exceptions we handle and the
	one passed as a parameter."
	^ self exceptionSelector, anException!

context: aRequestContext
	^ self basicNew initializeWithContext: aRequestContext; yourself !

exceptionSelector
	^ ExceptionSet new!

handleExceptionsDuring: aBlock context: aRequestContext
	^ (self context: aRequestContext) handleExceptionsDuring: aBlock!

handles: anException 
	"You should probably override #exceptionsToCatch instead of this method.
	If you do need to override this method, make sure to override #, as well"
	^ self exceptionSelector handles: anException!

internalError: anError context: aRequestContext
	^ (self context: aRequestContext) internalError: anError!

new
	^ self context: nil! !
!WAExceptionHandler class categoriesFor: #,!ansi-exception-selector!public! !
!WAExceptionHandler class categoriesFor: #context:!instance creation!public! !
!WAExceptionHandler class categoriesFor: #exceptionSelector!exception handling!public! !
!WAExceptionHandler class categoriesFor: #handleExceptionsDuring:context:!exception handling!public! !
!WAExceptionHandler class categoriesFor: #handles:!ansi-exception-selector!public! !
!WAExceptionHandler class categoriesFor: #internalError:context:!public!responding! !
!WAExceptionHandler class categoriesFor: #new!instance creation!public! !

WAFile guid: (GUID fromString: '{420D0B0E-D1E7-409B-A74D-27E824DE5B37}')!
WAFile comment: '
I represent a file that was uploaded by the user via #fileInput.

Instance Variables
	contents:		<ByteArray>
	contentType:	<WAMimeType>
	fileName:		<String>

contents
	- the contents of the file, binary

contentType
	- the content type of the file
	
fileName
	- The name of the file the user agent uploaded. This is locale name on the machine of the client. The instance variable might include the full path on the file system, the accessor will never return the path.'!
!WAFile categoriesForClass!Unclassified! !
!WAFile methodsFor!

contents
	"Answer a String"
	self
		greaseDeprecatedApi: 'WAFile>>#contents'
		details: 'Use #rawContents, #contentsDecoded or #contentsDecodedUsing: instead.'.
	^  self contentsDecodedUsing: 'ISO-8859-1'!

contents: aByteArray
	contents := aByteArray!

contentsDecoded
	"Answer the contents decoded using the character set in the part header. Signal an error if not character set is present in the part header."
	| type charSet |
	type := self contentType.
	charSet := type isNil ifFalse: [ type charSet ].
	^charSet isNil
		ifTrue: [ WAIllegalStateException signal: 'no character set of file upload can not be determined' ]
		ifFalse: [ self contentsDecodedUsing: charSet ]!

contentsDecodedUsing: aCharSetName
	"Answer the contents decoded using the given character set name."
	^ (GRCodec forEncoding: aCharSetName) decode: self rawContents!

contentType
	^ contentType!

contentType: aMimeTypeOrString
	contentType := aMimeTypeOrString seasideMimeType!

fileName
	"compensate for windows explorer behavior"
	^ self isWindowsPath
		ifTrue: [ fileName copyAfterLast: $\ ]
		ifFalse: [ fileName ]!

fileName: aString
	fileName := aString!

isWindowsPath
	"'#:\*' match: fileName is broken on Squeak for WideString arguments"
	^fileName notEmpty
		and: [ fileName first isLetter
		and: [ fileName size >= 3
		and: [ (fileName copyFrom: 2 to: 3) = ':\' ] ] ]!

rawContents
	"Answer the raw, undecoded contents as sent by the user agent as a ByteArray.
	
	Use #contentsDecoded or #contentsDecodeUsing: to access the decoded contents."
	
	^ contents!

size
	"the file size in bytes"
	^self rawContents size! !
!WAFile categoriesFor: #contents!accessing!public! !
!WAFile categoriesFor: #contents:!accessing!public! !
!WAFile categoriesFor: #contentsDecoded!accessing!public! !
!WAFile categoriesFor: #contentsDecodedUsing:!accessing!public! !
!WAFile categoriesFor: #contentType!accessing!public! !
!WAFile categoriesFor: #contentType:!accessing!public! !
!WAFile categoriesFor: #fileName!accessing!public! !
!WAFile categoriesFor: #fileName:!accessing!public! !
!WAFile categoriesFor: #isWindowsPath!private! !
!WAFile categoriesFor: #rawContents!accessing!public! !
!WAFile categoriesFor: #size!accessing!public! !

WAFileHandlerListing guid: (GUID fromString: '{F06521BB-39F3-45FB-AEB4-FF790D440660}')!
WAFileHandlerListing comment: ''!
!WAFileHandlerListing categoriesForClass!Unclassified! !
!WAFileHandlerListing methodsFor!

initializeWithFileHandler: aFileHandler context: aRequestContext
	self initialize.
	handler := aFileHandler.
	context := aRequestContext!

responseForLibraries
	self subclassResponsibility!

responseForLibrary: aLibrary
	self subclassResponsibility! !
!WAFileHandlerListing categoriesFor: #initializeWithFileHandler:context:!initialization!public! !
!WAFileHandlerListing categoriesFor: #responseForLibraries!public!responding! !
!WAFileHandlerListing categoriesFor: #responseForLibrary:!public!responding! !

!WAFileHandlerListing class methodsFor!

on: aFileHandler context: aRequestContext
	^ self basicNew initializeWithFileHandler: aFileHandler context: aRequestContext; yourself! !
!WAFileHandlerListing class categoriesFor: #on:context:!instance creation!public! !

WAFileLibrary guid: (GUID fromString: '{C59D2393-3591-4E2A-9630-8CF6DF2E401D}')!
WAFileLibrary comment: '
What does FileLibrary do
=============================
It allows to serve static files directly from seaside without the need for a standalone server like Apache or to configure Kom. These files can reference each other (say a CSS references an image) and can be distrubuted the same way as normal Smalltalk code (Monticello, SqueakMap, ...).

Each file in a file library is represented by a method. The method name is created from the file name, the dot is removed and the first letter of the suffix in capitalized. This puts certain limitations to the allowed filenames. Eg. ''main.css'' becomes #mainCss.

Like Script- and StyleLibraries FileLibraries can be added to an application so that they automatically include themselves in the document root. Implement #selectorsToInclude and return the selectors you whish to be added to the document root.

How to create a FileLibrary
================================
- First create the static files and put them in some directory. From there they can reference the other files in the same directory normally with their filenames.
- Make sure you have a "Files" entry that serves your files. This is a normal entry point type that you can find in your /seaside/config application. If you don''t already have one, you can create it if you select "Files" in the type field of the "add entry point" dialog. For the rest of this text we assume you chose "files" as the path.
- Create a subclass of WAFileLibrary, for the rest of this text I assume its name is MyFileLibrary.
- To add the files to your file library there are two ways.
1. Programmatically with MyFileLibrary class >> #addAllFilesIn: / #addFileNamed:. For example MyFileLibrary addAllFilesIn: ''/path/to/directory/with/files'' or MyFileLibrary addFileNamed: ''/path/to/background.png''.
2. Via the web interface. Go to your /seaside/config application and there click configure for your "Files". Click "configure" behind MyFileLibrary. There you can add a file by uploading it (select the file, then click "Add")

Note that a "Files" can consist of several file libraries and can even have tradional script or style libraries.

How to integrate a FileLibrary into your application
=============================================================
Files from a FileLibrary are ingetrated the same way other static files are integrated. They have a constant path that is ''/seaside/<Static File Library>/<FileLibrary class name>/<filename>'' so for example ''/seaside/files/MyFileLibrary/background.png''. These can be conveniently generated by ''MyFileLibrary / #aSelector'' where #aSelector is the name of the method representing that file. For example ''MyFileLibrary / #backgroundPng''.

How to get back the files in a FileLibrary
=================================================
The contents of a file library can be written out to disk. Writing out a file library first makes a folder with the name of the file library in the folder of your Smallatlk image. Then a file for each file in the file library is created in this folder. Writing out to disk can happen in three ways
1. MyFileLibrary default deployFiles
2. Via the configuration interface of the file library. On the same page where you can add files to your file library there is also a button ''write to disk'' which will write out all the files in this library.
3. Via the configuration interface of your application. In the section where you can add libraries to your application there is a a button ''write to disk'' which will write out all the libraries of this application.

Examples:
==========

The following code uses WAFileLibrary to add a CSS file to a page.

updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet 
		url: WAFileLibraryDemo / #mainCss
		
The folllowing code uses WAFileLibrary to display an image.

renderContentOn: html
	html image
		url: WAFileLibraryDemo / #mainJpg'!
!WAFileLibrary categoriesForClass!Unclassified! !
!WAFileLibrary methodsFor!

addFile: aFile 
	"adds a file to the receiver

	aFile an instance of of WAFile"
	| contents |
	aFile isNil ifTrue: [ ^ self	"in case no file was selected for uploading" ].
	contents := (self class isBinary: aFile fileName) 
		ifTrue: [ aFile contents ]
		ifFalse: [ GRPlatform current convertToSmalltalkNewlines: aFile contents ].
	self class 
		addFileNamed: aFile fileName
		contents: contents!

asFilename: aSelector 
	| dotIndex extension |
	dotIndex := self lastUpperCaseIndexIn: aSelector.
	dotIndex = 0 ifTrue: 
		[ "convert Symbol to String"
		^ aSelector greaseString ].
	extension := (aSelector last: aSelector size - dotIndex + 1) asLowercase.
	^ (aSelector first: dotIndex - 1) , '.' , extension!

asSelector: aFilename
	^ self class asSelector: aFilename!

cacheDuration
	"ansers the duration the response should be cached by the user agent"
	^Duration days: 0 hours: 0 minutes: 30 seconds: 0!

compileBinary: aString selector: aSymbol
	^self class compileBinary: aString selector: aSymbol!

compileText: aString selector: aSymbol
	self class compileText: aString selector: aSymbol!

deployFiles
	"Write to disk the files that the receiver use to serve as methods.
	The files are stored in a subfolder named like the classname of the receiver in a subfolder of Smalltalk image folder."
	GRPlatform current ensureExistenceOfFolder: self name.
	self fileSelectors do: [ :each | 
		GRPlatform current 
			write: (self perform: each)
			toFile: (self asFilename: each)
			inFolder: self name ]!

documentForFile: aFilename
	^self perform: (self asSelector: aFilename)!

filenames
	^ self fileSelectors collect: [ :each | self asFilename: each ]!

fileSelectors
	| selectors current |
	selectors := Set new.
	current := self class.
	[ WAFileLibrary = current ] whileFalse: [
		selectors addAll: (current selectors
			select: [ :each | self isFileSelector: each ]).
		current := current superclass ].
	^ selectors!

fileSizeOf: aSymbol
	^ (self perform: aSymbol) size!

handle: aRequestContext
	| fileName selector |
	fileName := aRequestContext consumer next.
	selector := self asSelector: fileName.
	(self fileSelectors includes: selector) 
		ifFalse: [ ^ self ].
	aRequestContext respond: [ :response |
		response
			cacheFor: self cacheDuration;
			document: (self documentForFile: fileName)
			mimeType: (self mimetypeForFile: fileName) ]!

isFileSelector: aSymbol
	"added condition to prevent overrides of methods defined in this class being picked up"
	^ aSymbol isUnary
		and: [ (self lastUpperCaseIndexIn: aSymbol) > 1
		and: [ (self nonFileSelectors includes: aSymbol) not ] ]!

lastUpperCaseIndexIn: aString
	^ aString findLast: [ :each | each isUppercase ]!

mimetypeForFile: aFilename
	^self class mimetypeFor: (aFilename copyAfterLast: $.)!

name
	^ self class name!

nonFileSelectors
	"Answers all the unary selectors with an upper clase latter that are not file selector.s
	This method is intended to be overriden by superclasses that add functionality. Don't forget to add the result of the super send."
	^ #(cacheDuration fileSelectors deployFiles configurationComponent selectorsToInclude nonFileSelectors)!

removeFile: aFilename 
	GRPlatform current 
		removeSelector: (self asSelector: aFilename)
		from: self class!

renameFile: oldName to: newName
	| contents file |
	(self asSelector: oldName) = (self asSelector: newName)
		ifTrue: [ ^ nil ].
	contents := self perform: (self asSelector: oldName).
	file := WAFile new contents: contents.
	file fileName: newName.
	self addFile: file.
	self removeFile: oldName!

selectorsToInclude
	"The files represented by the selectors this method returns will be automatically added to the html <head> if the receiver is added to the respective Seaside application.

	This makes only sense for CSS and JS files"
	^ #()!

updateRoot: anHtmlRoot
	"Only override if you want to automatically include new types of resources. The default implementation knows how to reference CSS, JS and FavIcons into anHtmlRoot."

	self selectorsToInclude do: [ :each |
		(each endsWithSubCollection: #Js)
			ifTrue: [ anHtmlRoot javascript url: (self urlOf: each) ].
		(each endsWithSubCollection: #Ico)
			ifTrue: [ anHtmlRoot link beShortcutIcon; url: (self urlOf: each) ].
		(each endsWithSubCollection: #Css)
			ifTrue: [ anHtmlRoot stylesheet url: (self urlOf: each) ] ]!

urlForFile: aFilename
	^ self urlOf: (self asSelector: aFilename)!

urlOf: aSymbol
	^ self urlOf: aSymbol using: WAFileHandler default!

urlOf: aSymbol using: aHandler
	^ aHandler url
		addToPath: self className;
		addToPath: (self asFilename: aSymbol);
		yourself! !
!WAFileLibrary categoriesFor: #addFile:!actions!public! !
!WAFileLibrary categoriesFor: #asFilename:!private! !
!WAFileLibrary categoriesFor: #asSelector:!private! !
!WAFileLibrary categoriesFor: #cacheDuration!accessing!public! !
!WAFileLibrary categoriesFor: #compileBinary:selector:!private! !
!WAFileLibrary categoriesFor: #compileText:selector:!private! !
!WAFileLibrary categoriesFor: #deployFiles!actions!public! !
!WAFileLibrary categoriesFor: #documentForFile:!accessing!public! !
!WAFileLibrary categoriesFor: #filenames!accessing!public! !
!WAFileLibrary categoriesFor: #fileSelectors!private! !
!WAFileLibrary categoriesFor: #fileSizeOf:!accessing!public! !
!WAFileLibrary categoriesFor: #handle:!handling!public! !
!WAFileLibrary categoriesFor: #isFileSelector:!private! !
!WAFileLibrary categoriesFor: #lastUpperCaseIndexIn:!private! !
!WAFileLibrary categoriesFor: #mimetypeForFile:!accessing!public! !
!WAFileLibrary categoriesFor: #name!accessing!public! !
!WAFileLibrary categoriesFor: #nonFileSelectors!private! !
!WAFileLibrary categoriesFor: #removeFile:!actions!public! !
!WAFileLibrary categoriesFor: #renameFile:to:!actions!public! !
!WAFileLibrary categoriesFor: #selectorsToInclude!accessing!public! !
!WAFileLibrary categoriesFor: #updateRoot:!processing!public! !
!WAFileLibrary categoriesFor: #urlForFile:!accessing!public! !
!WAFileLibrary categoriesFor: #urlOf:!accessing!public! !
!WAFileLibrary categoriesFor: #urlOf:using:!accessing!public! !

!WAFileLibrary class methodsFor!

/ aSymbol
	^self urlOf: aSymbol!

addAllFilesIn: aPathString 
	"adds all files in the directory specified by aPathString to the current file library"
	(GRPlatform current filesIn: aPathString) do: [ :each | self addFileAt: each ]!

addFileAt: aPath 
	"adds the file specified by aFilename to the current file library"
	self 
		addFileAt: aPath
		contents: (GRPlatform current 
				contentsOfFile: aPath
				binary: (self isBinaryAt: aPath))!

addFileAt: aPath contents: aByteArrayOrString 
	self 
		addFileNamed: (GRPlatform current localNameOf: aPath)
		contents: aByteArrayOrString!

addFileNamed: aFilename contents: aByteArrayOrString
	| selector |
	selector := self asSelector: aFilename.
	(self isBinary: aFilename)
		ifTrue: [ self compileBinary: aByteArrayOrString selector: selector ]
		ifFalse: [ self compileText: aByteArrayOrString selector: selector ]!

adjustForVisualWorks
	| newSource oldSource badCode goodCode |
	badCode := 'xxxCache := #(nil).'.
	goodCode := 'xxxCache := #(nil) beMutable.'.
	self selectors do: [:selector |
		oldSource := self sourceCodeAt: selector.
		(oldSource indexOfSubCollection: badCode startingAt: 1) > 0 ifTrue:
			[newSource := oldSource copyReplaceAll: badCode with: goodCode.
			self compile: newSource classified: self methodCategory]]!

asSelector: aFilename
	| mainPart extension |
	mainPart := (aFilename copyUpToLast: $.)
		select: [ :each | each isAlphaNumeric ].
	[ mainPart first isDigit ]
		whileTrue: [ mainPart := mainPart allButFirst ].
	extension := (aFilename copyAfterLast: $.) asLowercase capitalized.
	^ (mainPart , extension) asSymbol!

compileBinary: aByteArrayOrString selector: aSymbol 
	"compiles aByteArrayOrString into a method named aSymbol that returns aByteArrayOrString as a byte array"
	| code |
	code := GRPlatform current 
		asMethodReturningByteArray: aByteArrayOrString
		named: aSymbol.
	GRPlatform current 
		compile: code
		into: self
		classified: self methodCategory!

compileText: aByteArrayOrString selector: aSymbol 
	"Compiles aByteArrayOrString into a method named aSymbol that returns aByteArrayOrString as a string literal.
	aSymbol
		^ aByteArrayOrString"
	| code |
	code := String streamContents: 
		[ :stream | 
		stream
			nextPutAll: aSymbol;
			nextPut: Character cr.
		stream
			tab;
			nextPutAll: '^ '''.
		aByteArrayOrString greaseString do: 
			[ :each | 
			each = $' ifTrue: [ stream nextPut: $' ].
			stream nextPut: each ].
		stream nextPutAll: '''' ].
	GRPlatform current 
		compile: code
		into: self
		classified: self methodCategory!

default
	^ default ifNil: [ default := self new ]!

defaultMimeType
	^ 'application/octet-stream'!

defaultMimeTypes
	^ #(
		'%' 'application/x-trash'
		'323' 'text/h323'
		'abw' 'application/x-abiword'
		'ai' 'application/postscript'
		'aif' 'audio/x-aiff'
		'aifc' 'audio/x-aiff'
		'aiff' 'audio/x-aiff'
		'alc' 'chemical/x-alchemy'
		'art' 'image/x-jg'
		'asc' 'text/plain'
		'asf' 'video/x-ms-asf'
		'asn' 'chemical/x-ncbi-asn1-spec'
		'aso' 'chemical/x-ncbi-asn1-binary'
		'asx' 'video/x-ms-asf'
		'au' 'audio/basic'
		'avi' 'video/x-msvideo'
		'b' 'chemical/x-molconn-Z'
		'bak' 'application/x-trash'
		'bat' 'application/x-msdos-program'
		'bcpio' 'application/x-bcpio'
		'bib' 'text/x-bibtex'
		'bin' 'application/octet-stream'
		'bmp' 'image/x-ms-bmp'
		'book' 'application/x-maker'
		'bsd' 'chemical/x-crossfire'
		'c' 'text/x-csrc'
		'c++' 'text/x-c++src'
		'c3d' 'chemical/x-chem3d'
		'cac' 'chemical/x-cache'
		'cache' 'chemical/x-cache'
		'cascii' 'chemical/x-cactvs-binary'
		'cat' 'application/vnd.ms-pki.seccat'
		'cbin' 'chemical/x-cactvs-binary'
		'cc' 'text/x-c++src'
		'cdf' 'application/x-cdf'
		'cdr' 'image/x-coreldraw'
		'cdt' 'image/x-coreldrawtemplate'
		'cdx' 'chemical/x-cdx'
		'cdy' 'application/vnd.cinderella'
		'cef' 'chemical/x-cxf'
		'cer' 'chemical/x-cerius'
		'chm' 'chemical/x-chemdraw'
		'chrt' 'application/x-kchart'
		'cif' 'chemical/x-cif'
		'class' 'application/java-vm'
		'cls' 'text/x-tex'
		'cmdf' 'chemical/x-cmdf'
		'cml' 'chemical/x-cml'
		'cod' 'application/vnd.rim.cod'
		'com' 'application/x-msdos-program'
		'cpa' 'chemical/x-compass'
		'cpio' 'application/x-cpio'
		'cpp' 'text/x-c++src'
		'cpt' 'image/x-corelphotopaint'
		'crl' 'application/x-pkcs7-crl'
		'crt' 'application/x-x509-ca-cert'
		'csf' 'chemical/x-cache-csf'
		'csh' 'text/x-csh'
		'csm' 'chemical/x-csml'
		'csml' 'chemical/x-csml'
		'css' 'text/css'
		'csv' 'text/comma-separated-values'
		'ctab' 'chemical/x-cactvs-binary'
		'ctx' 'chemical/x-ctx'
		'cu' 'application/cu-seeme'
		'cub' 'chemical/x-gaussian-cube'
		'cxf' 'chemical/x-cxf'
		'cxx' 'text/x-c++src'
		'dat' 'chemical/x-mopac-input'
		'dcr' 'application/x-director'
		'deb' 'application/x-debian-package'
		'dif' 'video/dv'
		'diff' 'text/plain'
		'dir' 'application/x-director'
		'djv' 'image/vnd.djvu'
		'djvu' 'image/vnd.djvu'
		'dl' 'video/dl'
		'dll' 'application/x-msdos-program'
		'dmg' 'application/x-apple-diskimage'
		'dms' 'application/x-dms'
		'doc' 'application/msword'
		'dot' 'application/msword'
		'dv' 'video/dv'
		'dvi' 'application/x-dvi'
		'dx' 'chemical/x-jcamp-dx'
		'dxr' 'application/x-director'
		'emb' 'chemical/x-embl-dl-nucleotide'
		'embl' 'chemical/x-embl-dl-nucleotide'
		'ent' 'chemical/x-pdb'
		'eps' 'application/postscript'
		'etx' 'text/x-setext'
		'exe' 'application/x-msdos-program'
		'ez' 'application/andrew-inset'
		'fb' 'application/x-maker'
		'fbdoc' 'application/x-maker'
		'fch' 'chemical/x-gaussian-checkpoint'
		'fchk' 'chemical/x-gaussian-checkpoint'
		'fig' 'application/x-xfig'
		'flac' 'application/x-flac'
		'fli' 'video/fli'
		'fm' 'application/x-maker'
		'frame' 'application/x-maker'
		'frm' 'application/x-maker'
		'gal' 'chemical/x-gaussian-log'
		'gam' 'chemical/x-gamess-input'
		'gamin' 'chemical/x-gamess-input'
		'gau' 'chemical/x-gaussian-input'
		'gcd' 'text/x-pcs-gcd'
		'gcf' 'application/x-graphing-calculator'
		'gcg' 'chemical/x-gcg8-sequence'
		'gen' 'chemical/x-genbank'
		'gf' 'application/x-tex-gf'
		'gif' 'image/gif'
		'gjc' 'chemical/x-gaussian-input'
		'gjf' 'chemical/x-gaussian-input'
		'gl' 'video/gl'
		'gnumeric' 'application/x-gnumeric'
		'gpt' 'chemical/x-mopac-graph'
		'gsf' 'application/x-font'
		'gsm' 'audio/x-gsm'
		'gtar' 'application/x-gtar'
		'h' 'text/x-chdr'
		'h++' 'text/x-c++hdr'
		'hdf' 'application/x-hdf'
		'hh' 'text/x-c++hdr'
		'hin' 'chemical/x-hin'
		'hpp' 'text/x-c++hdr'
		'hqx' 'application/mac-binhex40'
		'hs' 'text/x-haskell'
		'hta' 'application/hta'
		'htc' 'text/x-component'
		'htm' 'text/html'
		'html' 'text/html'
		'hxx' 'text/x-c++hdr'
		'ica' 'application/x-ica'
		'ice' 'x-conference/x-cooltalk'
		'ico' 'image/x-icon'
		'ics' 'text/calendar'
		'icz' 'text/calendar'
		'ief' 'image/ief'
		'iges' 'model/iges'
		'igs' 'model/iges'
		'iii' 'application/x-iphone'
		'inp' 'chemical/x-gamess-input'
		'ins' 'application/x-internet-signup'
		'iso' 'application/x-iso9660-image'
		'isp' 'application/x-internet-signup'
		'ist' 'chemical/x-isostar'
		'istr' 'chemical/x-isostar'
		'jad' 'text/vnd.sun.j2me.app-descriptor'
		'jar' 'application/java-archive'
		'java' 'text/x-java'
		'jdx' 'chemical/x-jcamp-dx'
		'jmz' 'application/x-jmol'
		'jng' 'image/x-jng'
		'jnlp' 'application/x-java-jnlp-file'
		'jpe' 'image/jpeg'
		'jpeg' 'image/jpeg'
		'jpg' 'image/jpeg'
		'js' 'application/x-javascript'
		'kar' 'audio/midi'
		'key' 'application/pgp-keys'
		'kil' 'application/x-killustrator'
		'kin' 'chemical/x-kinemage'
		'kpr' 'application/x-kpresenter'
		'kpt' 'application/x-kpresenter'
		'ksp' 'application/x-kspread'
		'kwd' 'application/x-kword'
		'kwt' 'application/x-kword'
		'latex' 'application/x-latex'
		'lha' 'application/x-lha'
		'lhs' 'text/x-literate-haskell'
		'lsf' 'video/x-la-asf'
		'lsx' 'video/x-la-asf'
		'ltx' 'text/x-tex'
		'lzh' 'application/x-lzh'
		'lzx' 'application/x-lzx'
		'm3u' 'audio/x-mpegurl'
		'm4a' 'audio/mpeg'
		'maker' 'application/x-maker'
		'man' 'application/x-troff-man'
		'mcif' 'chemical/x-mmcif'
		'mcm' 'chemical/x-macmolecule'
		'mdb' 'application/msaccess'
		'me' 'application/x-troff-me'
		'mesh' 'model/mesh'
		'mid' 'audio/midi'
		'midi' 'audio/midi'
		'mif' 'application/x-mif'
		'mm' 'application/x-freemind'
		'mmd' 'chemical/x-macromodel-input'
		'mmf' 'application/vnd.smaf'
		'mml' 'text/mathml'
		'mmod' 'chemical/x-macromodel-input'
		'mng' 'video/x-mng'
		'moc' 'text/x-moc'
		'mol' 'chemical/x-mdl-molfile'
		'mol2' 'chemical/x-mol2'
		'moo' 'chemical/x-mopac-out'
		'mop' 'chemical/x-mopac-input'
		'mopcrt' 'chemical/x-mopac-input'
		'mov' 'video/quicktime'
		'movie' 'video/x-sgi-movie'
		'mp2' 'audio/mpeg'
		'mp3' 'audio/mpeg'
		'mp4' 'video/mp4'
		'mpc' 'chemical/x-mopac-input'
		'mpe' 'video/mpeg'
		'mpeg' 'video/mpeg'
		'mpega' 'audio/mpeg'
		'mpg' 'video/mpeg'
		'mpga' 'audio/mpeg'
		'ms' 'application/x-troff-ms'
		'msh' 'model/mesh'
		'msi' 'application/x-msi'
		'mvb' 'chemical/x-mopac-vib'
		'mxu' 'video/vnd.mpegurl'
		'nb' 'application/mathematica'
		'nc' 'application/x-netcdf'
		'nwc' 'application/x-nwc'
		'o' 'application/x-object'
		'oda' 'application/oda'
		'odb' 'application/vnd.oasis.opendocument.database'
		'odc' 'application/vnd.oasis.opendocument.chart'
		'odf' 'application/vnd.oasis.opendocument.formula'
		'odg' 'application/vnd.oasis.opendocument.graphics'
		'odi' 'application/vnd.oasis.opendocument.image'
		'odm' 'application/vnd.oasis.opendocument.text-master'
		'odp' 'application/vnd.oasis.opendocument.presentation'
		'ods' 'application/vnd.oasis.opendocument.spreadsheet'
		'odt' 'application/vnd.oasis.opendocument.text'
		'ogg' 'application/ogg'
		'old' 'application/x-trash'
		'oth' 'application/vnd.oasis.opendocument.text-web'
		'oza' 'application/x-oz-application'
		'p' 'text/x-pascal'
		'p7r' 'application/x-pkcs7-certreqresp'
		'pac' 'application/x-ns-proxy-autoconfig'
		'pas' 'text/x-pascal'
		'pat' 'image/x-coreldrawpattern'
		'pbm' 'image/x-portable-bitmap'
		'pcf' 'application/x-font'
		'pcf.Z' 'application/x-font'
		'pcx' 'image/pcx'
		'pdb' 'chemical/x-pdb'
		'pdf' 'application/pdf'
		'pfa' 'application/x-font'
		'pfb' 'application/x-font'
		'pgm' 'image/x-portable-graymap'
		'pgn' 'application/x-chess-pgn'
		'pgp' 'application/pgp-signature'
		'pk' 'application/x-tex-pk'
		'pl' 'text/x-perl'
		'pls' 'audio/x-scpls'
		'pm' 'text/x-perl'
		'png' 'image/png'
		'pnm' 'image/x-portable-anymap'
		'pot' 'text/plain'
		'ppm' 'image/x-portable-pixmap'
		'pps' 'application/vnd.ms-powerpoint'
		'ppt' 'application/vnd.ms-powerpoint'
		'prf' 'application/pics-rules'
		'prt' 'chemical/x-ncbi-asn1-ascii'
		'ps' 'application/postscript'
		'psd' 'image/x-photoshop'
		'psp' 'text/x-psp'
		'py' 'text/x-python'
		'pyc' 'application/x-python-code'
		'pyo' 'application/x-python-code'
		'qt' 'video/quicktime'
		'qtl' 'application/x-quicktimeplayer'
		'ra' 'audio/x-realaudio'
		'ram' 'audio/x-pn-realaudio'
		'rar' 'application/rar'
		'ras' 'image/x-cmu-raster'
		'rd' 'chemical/x-mdl-rdfile'
		'rdf' 'application/rdf+xml'
		'rgb' 'image/x-rgb'
		'rm' 'audio/x-pn-realaudio'
		'roff' 'application/x-troff'
		'ros' 'chemical/x-rosdal'
		'rpm' 'application/x-redhat-package-manager'
		'rss' 'application/rss+xml'
		'rtf' 'text/rtf'
		'rtx' 'text/richtext'
		'rxn' 'chemical/x-mdl-rxnfile'
		'sct' 'text/scriptlet'
		'sd' 'chemical/x-mdl-sdfile'
		'sd2' 'audio/x-sd2'
		'sda' 'application/vnd.stardivision.draw'
		'sdc' 'application/vnd.stardivision.calc'
		'sdd' 'application/vnd.stardivision.impress'
		'sdf' 'chemical/x-mdl-sdfile'
		'sdp' 'application/vnd.stardivision.impress'
		'sdw' 'application/vnd.stardivision.writer'
		'ser' 'application/java-serialized-object'
		'sgf' 'application/x-go-sgf'
		'sgl' 'application/vnd.stardivision.writer-global'
		'sh' 'text/x-sh'
		'shar' 'application/x-shar'
		'shtml' 'text/html'
		'sid' 'audio/prs.sid'
		'sik' 'application/x-trash'
		'silo' 'model/mesh'
		'sis' 'application/vnd.symbian.install'
		'sit' 'application/x-stuffit'
		'skd' 'application/x-koan'
		'skm' 'application/x-koan'
		'skp' 'application/x-koan'
		'skt' 'application/x-koan'
		'smf' 'application/vnd.stardivision.math'
		'smi' 'application/smil'
		'smil' 'application/smil'
		'snd' 'audio/basic'
		'spc' 'chemical/x-galactic-spc'
		'spl' 'application/x-futuresplash'
		'src' 'application/x-wais-source'
		'stc' 'application/vnd.sun.xml.calc.template'
		'std' 'application/vnd.sun.xml.draw.template'
		'sti' 'application/vnd.sun.xml.impress.template'
		'stl' 'application/vnd.ms-pki.stl'
		'stw' 'application/vnd.sun.xml.writer.template'
		'sty' 'text/x-tex'
		'sv4cpio' 'application/x-sv4cpio'
		'sv4crc' 'application/x-sv4crc'
		'svg' 'image/svg+xml'
		'svgz' 'image/svg+xml'
		'sw' 'chemical/x-swissprot'
		'swf' 'application/x-shockwave-flash'
		'swfl' 'application/x-shockwave-flash'
		'sxc' 'application/vnd.sun.xml.calc'
		'sxd' 'application/vnd.sun.xml.draw'
		'sxg' 'application/vnd.sun.xml.writer.global'
		'sxi' 'application/vnd.sun.xml.impress'
		'sxm' 'application/vnd.sun.xml.math'
		'sxw' 'application/vnd.sun.xml.writer'
		't' 'application/x-troff'
		'tar' 'application/x-tar'
		'taz' 'application/x-gtar'
		'tcl' 'text/x-tcl'
		'tex' 'text/x-tex'
		'texi' 'application/x-texinfo'
		'texinfo' 'application/x-texinfo'
		'text' 'text/plain'
		'tgf' 'chemical/x-mdl-tgf'
		'tgz' 'application/x-gtar'
		'tif' 'image/tiff'
		'tiff' 'image/tiff'
		'tk' 'text/x-tcl'
		'tm' 'text/texmacs'
		'torrent' 'application/x-bittorrent'
		'tr' 'application/x-troff'
		'ts' 'text/texmacs'
		'tsp' 'application/dsptype'
		'tsv' 'text/tab-separated-values'
		'txt' 'text/plain'
		'udeb' 'application/x-debian-package'
		'uls' 'text/iuls'
		'ustar' 'application/x-ustar'
		'val' 'chemical/x-ncbi-asn1-binary'
		'vcd' 'application/x-cdlink'
		'vcf' 'text/x-vcard'
		'vcs' 'text/x-vcalendar'
		'vmd' 'chemical/x-vmd'
		'vms' 'chemical/x-vamas-iso14976'
		'vor' 'application/vnd.stardivision.writer'
		'vrm' 'x-world/x-vrml'
		'vrml' 'x-world/x-vrml'
		'vsd' 'application/vnd.visio'
		'wad' 'application/x-doom'
		'wav' 'audio/x-wav'
		'wax' 'audio/x-ms-wax'
		'wbmp' 'image/vnd.wap.wbmp'
		'wbxml' 'application/vnd.wap.wbxml'
		'wk' 'application/x-123'
		'wm' 'video/x-ms-wm'
		'wma' 'audio/x-ms-wma'
		'wmd' 'application/x-ms-wmd'
		'wml' 'text/vnd.wap.wml'
		'wmlc' 'application/vnd.wap.wmlc'
		'wmls' 'text/vnd.wap.wmlscript'
		'wmlsc' 'application/vnd.wap.wmlscriptc'
		'wmv' 'video/x-ms-wmv'
		'wmx' 'video/x-ms-wmx'
		'wmz' 'application/x-ms-wmz'
		'wp5' 'application/wordperfect5.1'
		'wpd' 'application/wordperfect'
		'wrl' 'x-world/x-vrml'
		'wsc' 'text/scriptlet'
		'wvx' 'video/x-ms-wvx'
		'wz' 'application/x-wingz'
		'xbm' 'image/x-xbitmap'
		'xcf' 'application/x-xcf'
		'xht' 'application/xhtml+xml'
		'xhtml' 'application/xhtml+xml'
		'xlb' 'application/vnd.ms-excel'
		'xls' 'application/vnd.ms-excel'
		'xlt' 'application/vnd.ms-excel'
		'xml' 'application/xml'
		'xpi' 'application/x-xpinstall'
		'xpm' 'image/x-xpixmap'
		'xsl' 'application/xml'
		'xtel' 'chemical/x-xtel'
		'xul' 'application/vnd.mozilla.xul+xml'
		'xwd' 'image/x-xwindowdump'
		'xyz' 'chemical/x-xyz'
		'zip' 'application/zip'
		'zmt' 'chemical/x-mopac-input'
		'~' 'application/x-trash'

	)!

deployFiles
	^self default deployFiles!

handle: aRequestContext
	^ self default handle: aRequestContext!

handlesFolder: aSymbol
	^self name = aSymbol!

initialize
	MimeTypes := Dictionary new.
	1 to: self defaultMimeTypes size by: 2 do: [ :index |
		MimeTypes
			at: (self defaultMimeTypes at: index)
			put: (self defaultMimeTypes at: index + 1) ]!

isBinary: aFilename
	^(self mimetypeFor: (aFilename copyAfterLast: $.)) isBinary!

isBinaryAt: aPath 
	^ self isBinary: (GRPlatform current localNameOf: aPath)!

methodCategory
	"the method category for uploaded files"
	^#uploaded!

migrateSubclassesSeaside29
	"migrates all subclasses of the receiver to Seaside 2.9
	you should not send this message to WAFileLibrary because that will also migrate the classes in Seaside"
	self allSubclassesDo: [ :each |
		each migrateToSeaside29 ]!

migrateToSeaside29
	"migrates only the receiver to Seaside 2.9"
	(self default fileSelectors intersection: self selectors) do: [ :each |
		| contents |
		contents := (self default perform: each).
		(contents isKindOf: ByteArray) ifTrue: [
			| file |
			file := WAFile new
				contents: contents;
				fileName: (self default asFilename: each);
				yourself.
			self default addFile: file ] ]!

mimetypeFor: aString
	^ (self mimetypes at: aString ifAbsent: [ self defaultMimeType ]) seasideMimeType!

mimetypes
	^ MimeTypes!

register
	"no longer needed left in so that code can still be loaded since it is sent in class side initialize methods"!

unregister
	"no longer used"!

urlOf: aSymbol
	^self default urlOf: aSymbol! !
!WAFileLibrary class categoriesFor: #/!convenience!public! !
!WAFileLibrary class categoriesFor: #addAllFilesIn:!file addition!public! !
!WAFileLibrary class categoriesFor: #addFileAt:!file addition!public! !
!WAFileLibrary class categoriesFor: #addFileAt:contents:!private! !
!WAFileLibrary class categoriesFor: #addFileNamed:contents:!private! !
!WAFileLibrary class categoriesFor: #adjustForVisualWorks!public!vw port-squeak! !
!WAFileLibrary class categoriesFor: #asSelector:!private! !
!WAFileLibrary class categoriesFor: #compileBinary:selector:!private! !
!WAFileLibrary class categoriesFor: #compileText:selector:!private! !
!WAFileLibrary class categoriesFor: #default!instance creation!public! !
!WAFileLibrary class categoriesFor: #defaultMimeType!accessing-defaults!public! !
!WAFileLibrary class categoriesFor: #defaultMimeTypes!accessing-defaults!public! !
!WAFileLibrary class categoriesFor: #deployFiles!actions!public! !
!WAFileLibrary class categoriesFor: #handle:!handling!public! !
!WAFileLibrary class categoriesFor: #handlesFolder:!public!testing! !
!WAFileLibrary class categoriesFor: #initialize!class initialization!public! !
!WAFileLibrary class categoriesFor: #isBinary:!private! !
!WAFileLibrary class categoriesFor: #isBinaryAt:!private! !
!WAFileLibrary class categoriesFor: #methodCategory!private! !
!WAFileLibrary class categoriesFor: #migrateSubclassesSeaside29!migrating!public! !
!WAFileLibrary class categoriesFor: #migrateToSeaside29!migrating!public! !
!WAFileLibrary class categoriesFor: #mimetypeFor:!accessing!public! !
!WAFileLibrary class categoriesFor: #mimetypes!accessing!public! !
!WAFileLibrary class categoriesFor: #register!convenience!public! !
!WAFileLibrary class categoriesFor: #unregister!convenience!public! !
!WAFileLibrary class categoriesFor: #urlOf:!convenience!public! !

WAHtmlElement guid: (GUID fromString: '{B81E02E8-D45A-4C38-99C2-E53C7E6E1876}')!
WAHtmlElement comment: 'Root class of all elements inside a <head> section.'!
!WAHtmlElement categoriesForClass!Unclassified! !
!WAHtmlElement methodsFor!

add: anElement
	children ifNil: [ children := OrderedCollection new ].
	children add: anElement!

attributeAt: aString
	^ self attributes at: aString!

attributeAt: aString ifAbsent: aBlock
	^ self attributes at: aString ifAbsent: aBlock!

attributeAt: aString put: anObject
	^ self attributes at: aString put: anObject!

attributes
	^ attributes ifNil: [ attributes := WAHtmlAttributes new ]!

childrenDo: aBlock
	children isNil
		ifFalse: [ children do: aBlock ]!

encodeAfterOn: aDocument
	aDocument closeTag: self tag!

encodeBeforeOn: aDocument
	aDocument openTag: self tag attributes: attributes closed: self isClosed!

encodeChildrenOn: aDocument
	self childrenDo: [ :each | each encodeOn: aDocument ]!

encodeOn: aDocument
	self encodeBeforeOn: aDocument.
	self isClosed ifTrue: [ ^ self ].
	self encodeChildrenOn: aDocument.
	self encodeAfterOn: aDocument!

initializeWithRoot: aRoot
	self initialize.
	root := aRoot!

isClosed
	^ true!

tag
	self subclassResponsibility!

with: anObject
	self add: anObject! !
!WAHtmlElement categoriesFor: #add:!accessing-children!public! !
!WAHtmlElement categoriesFor: #attributeAt:!accessing-attributes!public! !
!WAHtmlElement categoriesFor: #attributeAt:ifAbsent:!accessing-attributes!public! !
!WAHtmlElement categoriesFor: #attributeAt:put:!accessing-attributes!public! !
!WAHtmlElement categoriesFor: #attributes!accessing!public! !
!WAHtmlElement categoriesFor: #childrenDo:!accessing-children!public! !
!WAHtmlElement categoriesFor: #encodeAfterOn:!printing!public! !
!WAHtmlElement categoriesFor: #encodeBeforeOn:!printing!public! !
!WAHtmlElement categoriesFor: #encodeChildrenOn:!printing!public! !
!WAHtmlElement categoriesFor: #encodeOn:!printing!public! !
!WAHtmlElement categoriesFor: #initializeWithRoot:!initialization!public! !
!WAHtmlElement categoriesFor: #isClosed!public!testing! !
!WAHtmlElement categoriesFor: #tag!accessing!public! !
!WAHtmlElement categoriesFor: #with:!public! !

!WAHtmlElement class methodsFor!

root: aRoot
	^ self basicNew initializeWithRoot: aRoot; yourself! !
!WAHtmlElement class categoriesFor: #root:!instance creation!public! !

WAHttpVersion guid: (GUID fromString: '{ED4CB4E1-2039-47BF-A64D-466864BDBB34}')!
WAHttpVersion comment: ''!
!WAHttpVersion categoriesForClass!Unclassified! !
!WAHttpVersion methodsFor!

< otherVersion
	^ (major < otherVersion major) or: [
		(major = otherVersion major) and: [ minor < otherVersion minor ] ]!

<= otherVersion
	^ (self = otherVersion) or: [ self < otherVersion ]!

= otherVersion
	^ (major = otherVersion major) and: [ minor = otherVersion minor ]!

> otherVersion
	^ (major > otherVersion major) or: [
		(major = otherVersion major) and: [ minor > otherVersion minor ] ]!

>= otherVersion
	^ (self = otherVersion) or: [ self > otherVersion ]!

hash
	^ major hash bitXor: minor hash!

initializeWithMajor: majorInteger minor: minorInteger
	self initialize.
	major := majorInteger.
	minor := minorInteger!

isHttp10
	^ major = 1 and: [ minor = 0 ]!

isHttp11
	^ major = 1 and: [ minor = 1 ]!

major
	^ major!

minor
	^ minor!

printOn: aStream
	aStream nextPutAll: 'HTTP/'.
	major printOn: aStream.
	aStream nextPut: $..
	minor printOn: aStream! !
!WAHttpVersion categoriesFor: #<!comparing!public! !
!WAHttpVersion categoriesFor: #<=!comparing!public! !
!WAHttpVersion categoriesFor: #=!comparing!public! !
!WAHttpVersion categoriesFor: #>!comparing!public! !
!WAHttpVersion categoriesFor: #>=!comparing!public! !
!WAHttpVersion categoriesFor: #hash!comparing!public! !
!WAHttpVersion categoriesFor: #initializeWithMajor:minor:!initialization!public! !
!WAHttpVersion categoriesFor: #isHttp10!public!testing! !
!WAHttpVersion categoriesFor: #isHttp11!public!testing! !
!WAHttpVersion categoriesFor: #major!accessing!public! !
!WAHttpVersion categoriesFor: #minor!accessing!public! !
!WAHttpVersion categoriesFor: #printOn:!printing!public! !

!WAHttpVersion class methodsFor!

fromString: aString
	^ self readFrom: aString readStream!

http10
	^ self major: 1 minor: 0!

http11
	^ self major: 1 minor: 1!

major: majorInteger minor: minorInteger
	^ self basicNew
		initializeWithMajor: majorInteger minor: minorInteger;
		yourself!

new
	^ self http11!

readFrom: aStream 
	| major minor |
	[ aStream peek = Character space ] whileTrue: [ aStream next ].
	aStream peek = $H ifTrue: [ aStream skipTo: $/ ].	"Skip over 'HTTP/' "
	major := aStream upTo: $..
	minor := aStream upTo: Character space.
	^ self 
		major: major greaseInteger
		minor: minor greaseInteger! !
!WAHttpVersion class categoriesFor: #fromString:!instance creation!public! !
!WAHttpVersion class categoriesFor: #http10!instance creation!public! !
!WAHttpVersion class categoriesFor: #http11!instance creation!public! !
!WAHttpVersion class categoriesFor: #major:minor:!instance creation!public! !
!WAHttpVersion class categoriesFor: #new!instance creation!public! !
!WAHttpVersion class categoriesFor: #readFrom:!instance creation!public! !

WAKeyGenerator guid: (GUID fromString: '{996CD3BF-DF42-4526-927B-18E844169128}')!
WAKeyGenerator comment: ''!
!WAKeyGenerator categoriesForClass!Unclassified! !
!WAKeyGenerator methodsFor!

generator: aStream
	"A stream of random numbers, basically a random generator."

	generator := aStream!

initialize
	super initialize.
	self generator: GRPlatform current newRandom.
	self space: 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_-'!

keyOfLength: anInteger
	"Answer a random key as a string with the length anInteger. This does not use any of the fancy collection methods for speed reasons."

	| key |
	key := String new: anInteger.
	1 to: anInteger do: [ :index | key at: index put: (space at: (generator nextInt: space size)) ].
	^ key!

space: aCollectionOfCharacters
	"Defines the key generator space."

	space := aCollectionOfCharacters! !
!WAKeyGenerator categoriesFor: #generator:!accessing!public! !
!WAKeyGenerator categoriesFor: #initialize!initialization!public! !
!WAKeyGenerator categoriesFor: #keyOfLength:!public! !
!WAKeyGenerator categoriesFor: #space:!accessing!public! !

!WAKeyGenerator class methodsFor!

current
	^ current!

initialize
	current := self new! !
!WAKeyGenerator class categoriesFor: #current!accessing!public! !
!WAKeyGenerator class categoriesFor: #initialize!initialization!public! !

WALocale guid: (GUID fromString: '{7D633DCB-45E5-406C-9910-82998F6D40EB}')!
WALocale comment: '
A WALocale definces a users langauge and country.

Instance Variables
	country:		<String>
	language:		<String>

country
	- either an ISO 2 or ISO 3 country code

language
	- either an ISO 2 or ISO 3 language code
'!
!WALocale categoriesForClass!Unclassified! !
!WALocale methodsFor!

country
	^ country!

country: aString
	country := aString!

countryName
	"answers the country name in english and all capitals"
	^self country size = 2
		ifTrue: [ self class iso2Countries at: self country ]
		ifFalse: [ self class iso3Countries at: self country ]!

greaseString
	^ String streamContents: 
		[ :stream | 
		stream nextPutAll: self language.
		self country isNil ifFalse: 
			[ stream
				nextPut: $-;
				nextPutAll: self country ] ]!

language
	^ language!

language: aString
	language := aString!

languageName
	"answers the language name in english and all capitals"
	^self language size = 2
		ifTrue: [ self class iso2Languages at: self language ]
		ifFalse: [ self class iso3Languages at: self language ]!

printOn: aStream 
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self greaseString;
		nextPut: $)!

withoutCountry
	"Answer a copy with the language but no country."
	^ WALocale language: self language country: nil! !
!WALocale categoriesFor: #country!accessing!public! !
!WALocale categoriesFor: #country:!accessing!public! !
!WALocale categoriesFor: #countryName!accessing!public! !
!WALocale categoriesFor: #greaseString!converting!public! !
!WALocale categoriesFor: #language!accessing!public! !
!WALocale categoriesFor: #language:!accessing!public! !
!WALocale categoriesFor: #languageName!accessing!public! !
!WALocale categoriesFor: #printOn:!printing!public! !
!WALocale categoriesFor: #withoutCountry!copying!public! !

!WALocale class methodsFor!

countryList
	^#(('AF' 'AFG' 'AFGHANISTAN') ('AL' 'ALB' 'ALBANIA') ('DZ' 'DZA' 'ALGERIA') ('AS' 'ASM' 'AMERICAN SAMOA') ('AD' 'AND' 'ANDORRA') ('AO' 'AGO' 'ANGOLA') ('AI' 'AIA' 'ANGUILLA') ('AQ' 'ATA' 'ANTARCTICA') ('AG' 'ATG' 'ANTIGUA AND BARBUDA') ('AR' 'ARG' 'ARGENTINA') ('AM' 'ARM' 'ARMENIA') ('AW' 'ABW' 'ARUBA') ('AU' 'AUS' 'AUSTRALIA') ('AT' 'AUT' 'AUSTRIA') ('AZ' 'AZE' 'AZERBAIJAN') ('BS' 'BHS' 'BAHAMAS') ('BH' 'BHR' 'BAHRAIN') ('BD' 'BGD' 'BANGLADESH') ('BB' 'BRB' 'BARBADOS') ('BY' 'BLR' 'BELARUS') ('BE' 'BEL' 'BELGIUM') ('BZ' 'BLZ' 'BELIZE') ('BJ' 'BEN' 'BENIN') ('BM' 'BMU' 'BERMUDA') ('BT' 'BTN' 'BHUTAN') ('BO' 'BOL' 'BOLIVIA') ('BA' 'BIH' 'BOSNIA AND HERZEGOWINA') ('BW' 'BWA' 'BOTSWANA') ('BV' 'BVT' 'BOUVET ISLAND') ('BR' 'BRA' 'BRAZIL') ('IO' 'IOT' 'BRITISH INDIAN OCEAN TERRITORY') ('BN' 'BRN' 'BRUNEI DARUSSALAM') ('BG' 'BGR' 'BULGARIA') ('BF' 'BFA' 'BURKINA FASO') ('BI' 'BDI' 'BURUNDI') ('KH' 'KHM' 'CAMBODIA') ('CM' 'CMR' 'CAMEROON') ('CA' 'CAN' 'CANADA') ('CV' 'CPV' 'CAPE VERDE') ('KY' 'CYM' 'CAYMAN ISLANDS') ('CF' 'CAF' 'CENTRAL AFRICAN REPUBLIC') ('TD' 'TCD' 'CHAD') ('CL' 'CHL' 'CHILE') ('CN' 'CHN' 'CHINA') ('CX' 'CXR' 'CHRISTMAS ISLAND') ('CC' 'CCK' 'COCOS (KEELING) ISLANDS') ('CO' 'COL' 'COLOMBIA') ('KM' 'COM' 'COMOROS') ('CG' 'COG' 'CONGO') ('CK' 'COK' 'COOK ISLANDS') ('CR' 'CRI' 'COSTA RICA') ('CI' 'CIV' 'COTE D''IVOIRE') ('HR' 'HRV' 'CROATIA (local name: Hrvatska)') ('CU' 'CUB' 'CUBA') ('CY' 'CYP' 'CYPRUS') ('CZ' 'CZE' 'CZECH REPUBLIC') ('DK' 'DNK' 'DENMARK') ('DJ' 'DJI' 'DJIBOUTI') ('DM' 'DMA' 'DOMINICA') ('DO' 'DOM' 'DOMINICAN REPUBLIC') ('TP' 'TMP' 'EAST TIMOR') ('EC' 'ECU' 'ECUADOR') ('EG' 'EGY' 'EGYPT') ('SV' 'SLV' 'EL SALVADOR') ('GQ' 'GNQ' 'EQUATORIAL GUINEA') ('ER' '   ' 'ERITREA') ('EE' 'EST' 'ESTONIA') ('ET' 'ETH' 'ETHIOPIA') ('FK' 'FLK' 'FALKLAND ISLANDS (MALVINAS)') ('FO' 'FRO' 'FAROE ISLANDS') ('FJ' 'FJI' 'FIJI') ('FI' 'FIN' 'FINLAND') ('FR' 'FRA' 'FRANCE') ('FX' 'FXX' 'FRANCE, METROPOLITAN') ('GF' 'GUF' 'FRENCH GUIANA') ('PF' 'PYF' 'FRENCH POLYNESIA') ('TF' 'ATF' 'FRENCH SOUTHERN TERRITORIES') ('GA' 'GAB' 'GABON') ('GM' 'GMB' 'GAMBIA') ('GE' 'GEO' 'GEORGIA') ('DE' 'DEU' 'GERMANY') ('GH' 'GHA' 'GHANA') ('GI' 'GIB' 'GIBRALTAR') ('GR' 'GRC' 'GREECE') ('GL' 'GRL' 'GREENLAND') ('GD' 'GRD' 'GRENADA') ('GP' 'GLP' 'GUADELOUPE') ('GU' 'GUM' 'GUAM') ('GT' 'GTM' 'GUATEMALA') ('GN' 'GIN' 'GUINEA') ('GW' 'GNB' 'GUINEA-BISSAU') ('GY' 'GUY' 'GUYANA') ('HT' 'HTI' 'HAITI') ('HM' 'HMD' 'HEARD AND MC DONALD ISLANDS') ('VA' 'VAT' 'HOLY SEE (VATICAN CITY STATE)') ('HN' 'HND' 'HONDURAS') ('HK' 'HKG' 'HONG KONG') ('HU' 'HUN' 'HUNGARY') ('IS' 'ISL' 'ICELAND') ('IN' 'IND' 'INDIA') ('ID' 'IDN' 'INDONESIA') ('IR' 'IRN' 'IRAN (ISLAMIC REPUBLIC OF)') ('IQ' 'IRQ' 'IRAQ') ('IE' 'IRL' 'IRELAND') ('IL' 'ISR' 'ISRAEL') ('IT' 'ITA' 'ITALY') ('JM' 'JAM' 'JAMAICA') ('JP' 'JPN' 'JAPAN') ('JO' 'JOR' 'JORDAN') ('KZ' 'KAZ' 'KAZAKHSTAN') ('KE' 'KEN' 'KENYA') ('KI' 'KIR' 'KIRIBATI') ('KP' 'PRK' 'KOREA, DEMOCRATIC PEOPLE''S REPUBLIC OF') ('KR' 'KOR' 'KOREA, REPUBLIC OF') ('KW' 'KWT' 'KUWAIT') ('KG' 'KGZ' 'KYRGYZSTAN') ('LA' 'LAO' 'LAO PEOPLE''S DEMOCRATIC REPUBLIC') ('LV' 'LVA' 'LATVIA') ('LB' 'LBN' 'LEBANON') ('LS' 'LSO' 'LESOTHO') ('LR' 'LBR' 'LIBERIA') ('LY' 'LBY' 'LIBYAN ARAB JAMAHIRIYA') ('LI' 'LIE' 'LIECHTENSTEIN') ('LT' 'LTU' 'LITHUANIA') ('LU' 'LUX' 'LUXEMBOURG') ('MO' 'MAC' 'MACAU') ('MK' 'MKD' 'MACEDONIA, THE FORMER YUGOSLAV REPUBLIC OF') ('MG' 'MDG' 'MADAGASCAR') ('MW' 'MWI' 'MALAWI') ('MY' 'MYS' 'MALAYSIA') ('MV' 'MDV' 'MALDIVES') ('ML' 'MLI' 'MALI') ('MT' 'MLT' 'MALTA') ('MH' 'MHL' 'MARSHALL ISLANDS') ('MQ' 'MTQ' 'MARTINIQUE') ('MR' 'MRT' 'MAURITANIA') ('MU' 'MUS' 'MAURITIUS') ('YT' 'MYT' 'MAYOTTE') ('MX' 'MEX' 'MEXICO') ('FM' 'FSM' 'MICRONESIA, FEDERATED STATES OF') ('MD' 'MDA' 'MOLDOVA, REPUBLIC OF') ('MC' 'MCO' 'MONACO') ('MN' 'MNG' 'MONGOLIA') ('MS' 'MSR' 'MONTSERRAT') ('MA' 'MAR' 'MOROCCO') ('MZ' 'MOZ' 'MOZAMBIQUE') ('MM' 'MMR' 'MYANMAR') ('NA' 'NAM' 'NAMIBIA') ('NR' 'NRU' 'NAURU') ('NP' 'NPL' 'NEPAL') ('NL' 'NLD' 'NETHERLANDS') ('AN' 'ANT' 'NETHERLANDS ANTILLES') ('NC' 'NCL' 'NEW CALEDONIA') ('NZ' 'NZL' 'NEW ZEALAND') ('NI' 'NIC' 'NICARAGUA') ('NE' 'NER' 'NIGER') ('NG' 'NGA' 'NIGERIA') ('NU' 'NIU' 'NIUE') ('NF' 'NFK' 'NORFOLK ISLAND') ('MP' 'MNP' 'NORTHERN MARIANA ISLANDS') ('NO' 'NOR' 'NORWAY') ('OM' 'OMN' 'OMAN') ('PK' 'PAK' 'PAKISTAN') ('PW' 'PLW' 'PALAU') ('PA' 'PAN' 'PANAMA') ('PG' 'PNG' 'PAPUA NEW GUINEA') ('PY' 'PRY' 'PARAGUAY') ('PE' 'PER' 'PERU') ('PH' 'PHL' 'PHILIPPINES') ('PN' 'PCN' 'PITCAIRN') ('PL' 'POL' 'POLAND') ('PT' 'PRT' 'PORTUGAL') ('PR' 'PRI' 'PUERTO RICO') ('QA' 'QAT' 'QATAR') ('RE' 'REU' 'REUNION') ('RO' 'ROM' 'ROMANIA') ('RU' 'RUS' 'RUSSIAN FEDERATION') ('RW' 'RWA' 'RWANDA') ('KN' 'KNA' 'SAINT KITTS AND NEVIS') ('LC' 'LCA' 'SAINT LUCIA') ('VC' 'VCT' 'SAINT VINCENT AND THE GRENADINES') ('WS' 'WSM' 'SAMOA') ('SM' 'SMR' 'SAN MARINO') ('ST' 'STP' 'SAO TOME AND PRINCIPE') ('SA' 'SAU' 'SAUDI ARABIA') ('SN' 'SEN' 'SENEGAL') ('SC' 'SYC' 'SEYCHELLES') ('SL' 'SLE' 'SIERRA LEONE') ('SG' 'SGP' 'SINGAPORE') ('SK' 'SVK' 'SLOVAKIA (Slovak Republic)') ('SI' 'SVN' 'SLOVENIA') ('SB' 'SLB' 'SOLOMON ISLANDS') ('SO' 'SOM' 'SOMALIA') ('ZA' 'ZAF' 'SOUTH AFRICA') ('GS' 'SGS' 'SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS') ('ES' 'ESP' 'SPAIN') ('LK' 'LKA' 'SRI LANKA') ('SH' 'SHN' 'ST. HELENA') ('PM' 'SPM' 'ST. PIERRE AND MIQUELON') ('SD' 'SDN' 'SUDAN') ('SR' 'SUR' 'SURINAME') ('SJ' 'SJM' 'SVALBARD AND JAN MAYEN ISLANDS') ('SZ' 'SWZ' 'SWAZILAND') ('SE' 'SWE' 'SWEDEN') ('CH' 'CHE' 'SWITZERLAND') ('SY' 'SYR' 'SYRIAN ARAB REPUBLIC') ('TW' 'TWN' 'TAIWAN, PROVINCE OF CHINA') ('TJ' 'TJK' 'TAJIKISTAN') ('TZ' 'TZA' 'TANZANIA, UNITED REPUBLIC OF') ('TH' 'THA' 'THAILAND') ('TG' 'TGO' 'TOGO') ('TK' 'TKL' 'TOKELAU') ('TO' 'TON' 'TONGA') ('TT' 'TTO' 'TRINIDAD AND TOBAGO') ('TN' 'TUN' 'TUNISIA') ('TR' 'TUR' 'TURKEY') ('TM' 'TKM' 'TURKMENISTAN') ('TC' 'TCA' 'TURKS AND CAICOS ISLANDS') ('TV' 'TUV' 'TUVALU') ('UG' 'UGA' 'UGANDA') ('UA' 'UKR' 'UKRAINE') ('AE' 'ARE' 'UNITED ARAB EMIRATES') ('GB' 'GBR' 'UNITED KINGDOM') ('US' 'USA' 'UNITED STATES') ('UM' 'UMI' 'UNITED STATES MINOR OUTLYING ISLANDS') ('UY' 'URY' 'URUGUAY') ('UZ' 'UZB' 'UZBEKISTAN') ('VU' 'VUT' 'VANUATU') ('VE' 'VEN' 'VENEZUELA') ('VN' 'VNM' 'VIET NAM') ('VG' 'VGB' 'VIRGIN ISLANDS (BRITISH)') ('VI' 'VIR' 'VIRGIN ISLANDS (U.S.)') ('WF' 'WLF' 'WALLIS AND FUTUNA ISLANDS') ('EH' 'ESH' 'WESTERN SAHARA') ('YE' 'YEM' 'YEMEN') ('YU' 'YUG' 'YUGOSLAVIA') ('ZR' 'ZAR' 'ZAIRE') ('ZM' 'ZMB' 'ZAMBIA') ('ZW' 'ZWE' 'ZIMBABWE'))!

fromString: aString
	| language country delimiter |
	delimiter := (aString includes: $_)
		ifTrue: [ $_ ]
		ifFalse: [ $- ].
	language := aString copyUpTo: delimiter.
	country := aString copyAfter: delimiter.
	country isEmpty ifTrue: [ country := nil ].
	^self
		language: language
		country: country!

initialize
	self initializeLangaugeList.
	self initializeCountryList!

initializeCountryList
	iso2Countries := Dictionary new.
	iso3Countries := Dictionary new.
	self countryList do: [ :each |
		iso2Countries
			at: each first
			put: each third.
		iso3Countries
			at: each second
			put: each third ]!

initializeLangaugeList
	iso2Languages := Dictionary new.
	iso3Languages := Dictionary new.
	
	self languageList do: [ :each |
		each size > 2
			ifTrue: [
				iso2Languages at: each first put: each third.
				iso3Languages at: each second put: each third ]
			ifFalse: [
				iso3Languages at: each first put: each second ] ]!

iso2Countries
	^iso2Countries!

iso2Languages
	^iso2Languages!

iso3Countries
	^iso3Countries!

iso3Languages
	^iso3Languages!

language: aLanguageString
	^self new
		language: aLanguageString;
		yourself!

language: aLanguageString country: aCounryString
	^self new
		language: aLanguageString;
		country: aCounryString;
		yourself!

languageList
	^#(('aa' 'aar' 'Afar') ('ab' 'abk' 'Abkhazian') ('ace' 'Achinese') ('ach' 'Acoli') ('ada' 'Adangme') ('ady' 'Adyghe; Adygei') ('afa' 'Afro-Asiatic (Other)') ('afh' 'Afrihili') ('af' 'afr' 'Afrikaans') ('ain' 'Ainu') ('ak' 'aka' 'Akan') ('akk' 'Akkadian') ('sq' 'alb' 'Albanian') ('ale' 'Aleut') ('alg' 'Algonquian languages') ('alt' 'Southern Altai') ('am' 'amh' 'Amharic') ('ang' 'English, Old (ca.450-1100)') ('anp' 'Angika') ('apa' 'Apache languages') ('ar' 'ara' 'Arabic') ('arc' 'Official Aramaic (700-300 BCE); Imperial Aramaic (700-300 BCE)') ('an' 'arg' 'Aragonese') ('hy' 'arm' 'Armenian') ('arn' 'Mapudungun; Mapuche') ('arp' 'Arapaho') ('art' 'Artificial (Other)') ('arw' 'Arawak') ('as' 'asm' 'Assamese') ('ast' 'Asturian; Bable; Leonese; Asturleonese') ('ath' 'Athapascan languages') ('aus' 'Australian languages') ('av' 'ava' 'Avaric') ('ae' 'ave' 'Avestan') ('awa' 'Awadhi') ('ay' 'aym' 'Aymara') ('az' 'aze' 'Azerbaijani') ('bad' 'Banda languages') ('bai' 'Bamileke languages') ('ba' 'bak' 'Bashkir') ('bal' 'Baluchi') ('bm' 'bam' 'Bambara') ('ban' 'Balinese') ('eu' 'baq' 'Basque') ('bas' 'Basa') ('bat' 'Baltic (Other)') ('bej' 'Beja; Bedawiyet') ('be' 'bel' 'Belarusian') ('bem' 'Bemba') ('bn' 'ben' 'Bengali') ('ber' 'Berber (Other)') ('bho' 'Bhojpuri') ('bh' 'bih' 'Bihari') ('bik' 'Bikol') ('bin' 'Bini; Edo') ('bi' 'bis' 'Bislama') ('bla' 'Siksika') ('bnt' 'Bantu (Other)') ('bs' 'bos' 'Bosnian') ('bra' 'Braj') ('br' 'bre' 'Breton') ('btk' 'Batak languages') ('bua' 'Buriat') ('bug' 'Buginese') ('bg' 'bul' 'Bulgarian') ('my' 'bur' 'Burmese') ('byn' 'Blin; Bilin') ('cad' 'Caddo') ('cai' 'Central American Indian (Other)') ('car' 'Galibi Carib') ('ca' 'cat' 'Catalan; Valencian') ('cau' 'Caucasian (Other)') ('ceb' 'Cebuano') ('cel' 'Celtic (Other)') ('ch' 'cha' 'Chamorro') ('chb' 'Chibcha') ('ce' 'che' 'Chechen') ('chg' 'Chagatai') ('zh' 'chi' 'Chinese') ('chk' 'Chuukese') ('chm' 'Mari') ('chn' 'Chinook jargon') ('cho' 'Choctaw') ('chp' 'Chipewyan; Dene Suline') ('chr' 'Cherokee') ('cu' 'chu' 'Church Slavic; Old Slavonic; Church Slavonic; Old Bulgarian; Old Church Slavonic') ('cv' 'chv' 'Chuvash') ('chy' 'Cheyenne') ('cmc' 'Chamic languages') ('cop' 'Coptic') ('kw' 'cor' 'Cornish') ('co' 'cos' 'Corsican') ('cpe' 'Creoles and pidgins, English based (Other)') ('cpf' 'Creoles and pidgins, French-based (Other)') ('cpp' 'Creoles and pidgins, Portuguese-based (Other)') ('cr' 'cre' 'Cree') ('crh' 'Crimean Tatar; Crimean Turkish') ('crp' 'Creoles and pidgins (Other)') ('csb' 'Kashubian') ('cus' 'Cushitic (Other)') ('cs' 'cze' 'Czech') ('dak' 'Dakota') ('da' 'dan' 'Danish') ('dar' 'Dargwa') ('day' 'Land Dayak languages') ('del' 'Delaware') ('den' 'Slave (Athapascan)') ('dgr' 'Dogrib') ('din' 'Dinka') ('dv' 'div' 'Divehi; Dhivehi; Maldivian') ('doi' 'Dogri') ('dra' 'Dravidian (Other)') ('dsb' 'Lower Sorbian') ('dua' 'Duala') ('dum' 'Dutch, Middle (ca.1050-1350)') ('nl' 'dut' 'Dutch; Flemish') ('dyu' 'Dyula') ('dz' 'dzo' 'Dzongkha') ('efi' 'Efik') ('egy' 'Egyptian (Ancient)') ('eka' 'Ekajuk') ('elx' 'Elamite') ('en' 'eng' 'English') ('enm' 'English, Middle (1100-1500)') ('eo' 'epo' 'Esperanto') ('et' 'est' 'Estonian') ('ee' 'ewe' 'Ewe') ('ewo' 'Ewondo') ('fan' 'Fang') ('fo' 'fao' 'Faroese') ('fat' 'Fanti') ('fj' 'fij' 'Fijian') ('fil' 'Filipino; Pilipino') ('fi' 'fin' 'Finnish') ('fiu' 'Finno-Ugrian (Other)') ('fon' 'Fon') ('fr' 'fre' 'French') ('frm' 'French, Middle (ca.1400-1600)') ('fro' 'French, Old (842-ca.1400)') ('frr' 'Northern Frisian') ('frs' 'Eastern Frisian') ('fy' 'fry' 'Western Frisian') ('ff' 'ful' 'Fulah') ('fur' 'Friulian') ('gaa' 'Ga') ('gay' 'Gayo') ('gba' 'Gbaya') ('gem' 'Germanic (Other)') ('ka' 'geo' 'Georgian') ('de' 'ger' 'German') ('gez' 'Geez') ('gil' 'Gilbertese') ('gd' 'gla' 'Gaelic; Scottish Gaelic') ('ga' 'gle' 'Irish') ('gl' 'glg' 'Galician') ('gv' 'glv' 'Manx') ('gmh' 'German, Middle High (ca.1050-1500)') ('goh' 'German, Old High (ca.750-1050)') ('gon' 'Gondi') ('gor' 'Gorontalo') ('got' 'Gothic') ('grb' 'Grebo') ('grc' 'Greek, Ancient (to 1453)') ('el' 'gre' 'Greek, Modern (1453-)') ('gn' 'grn' 'Guarani') ('gsw' 'Swiss German; Alemannic; Alsatian') ('gu' 'guj' 'Gujarati') ('gwi' 'Gwich''in') ('hai' 'Haida') ('ht' 'hat' 'Haitian; Haitian Creole') ('ha' 'hau' 'Hausa') ('haw' 'Hawaiian') ('he' 'heb' 'Hebrew') ('hz' 'her' 'Herero') ('hil' 'Hiligaynon') ('him' 'Himachali') ('hi' 'hin' 'Hindi') ('hit' 'Hittite') ('hmn' 'Hmong') ('ho' 'hmo' 'Hiri Motu') ('hsb' 'Upper Sorbian') ('hu' 'hun' 'Hungarian') ('hup' 'Hupa') ('iba' 'Iban') ('ig' 'ibo' 'Igbo') ('is' 'ice' 'Icelandic') ('io' 'ido' 'Ido') ('ii' 'iii' 'Sichuan Yi; Nuosu') ('ijo' 'Ijo languages') ('iu' 'iku' 'Inuktitut') ('ie' 'ile' 'Interlingue; Occidental') ('ilo' 'Iloko') ('ia' 'ina' 'Interlingua (International Auxiliary Language Association)') ('inc' 'Indic (Other)') ('id' 'ind' 'Indonesian') ('ine' 'Indo-European (Other)') ('inh' 'Ingush') ('ik' 'ipk' 'Inupiaq') ('ira' 'Iranian (Other)') ('iro' 'Iroquoian languages') ('it' 'ita' 'Italian') ('jv' 'jav' 'Javanese') ('jbo' 'Lojban') ('ja' 'jpn' 'Japanese') ('jpr' 'Judeo-Persian') ('jrb' 'Judeo-Arabic') ('kaa' 'Kara-Kalpak') ('kab' 'Kabyle') ('kac' 'Kachin; Jingpho') ('kl' 'kal' 'Kalaallisut; Greenlandic') ('kam' 'Kamba') ('kn' 'kan' 'Kannada') ('kar' 'Karen languages') ('ks' 'kas' 'Kashmiri') ('kr' 'kau' 'Kanuri') ('kaw' 'Kawi') ('kk' 'kaz' 'Kazakh') ('kbd' 'Kabardian') ('kha' 'Khasi') ('khi' 'Khoisan (Other)') ('km' 'khm' 'Central Khmer') ('kho' 'Khotanese') ('ki' 'kik' 'Kikuyu; Gikuyu') ('rw' 'kin' 'Kinyarwanda') ('ky' 'kir' 'Kirghiz; Kyrgyz') ('kmb' 'Kimbundu') ('kok' 'Konkani') ('kv' 'kom' 'Komi') ('kg' 'kon' 'Kongo') ('ko' 'kor' 'Korean') ('kos' 'Kosraean') ('kpe' 'Kpelle') ('krc' 'Karachay-Balkar') ('krl' 'Karelian') ('kro' 'Kru languages') ('kru' 'Kurukh') ('kj' 'kua' 'Kuanyama; Kwanyama') ('kum' 'Kumyk') ('ku' 'kur' 'Kurdish') ('kut' 'Kutenai') ('lad' 'Ladino') ('lah' 'Lahnda') ('lam' 'Lamba') ('lo' 'lao' 'Lao') ('la' 'lat' 'Latin') ('lv' 'lav' 'Latvian') ('lez' 'Lezghian') ('li' 'lim' 'Limburgan; Limburger; Limburgish') ('ln' 'lin' 'Lingala') ('lt' 'lit' 'Lithuanian') ('lol' 'Mongo') ('loz' 'Lozi') ('lb' 'ltz' 'Luxembourgish; Letzeburgesch') ('lua' 'Luba-Lulua') ('lu' 'lub' 'Luba-Katanga') ('lg' 'lug' 'Ganda') ('lui' 'Luiseno') ('lun' 'Lunda') ('luo' 'Luo (Kenya and Tanzania)') ('lus' 'Lushai') ('mk' 'mac' 'Macedonian') ('mad' 'Madurese') ('mag' 'Magahi') ('mh' 'mah' 'Marshallese') ('mai' 'Maithili') ('mak' 'Makasar') ('ml' 'mal' 'Malayalam') ('man' 'Mandingo') ('mi' 'mao' 'Maori') ('map' 'Austronesian (Other)') ('mr' 'mar' 'Marathi') ('mas' 'Masai') ('ms' 'may' 'Malay') ('mdf' 'Moksha') ('mdr' 'Mandar') ('men' 'Mende') ('mga' 'Irish, Middle (900-1200)') ('mic' 'Mi''kmaq; Micmac') ('min' 'Minangkabau') ('mis' 'Uncoded languages') ('mkh' 'Mon-Khmer (Other)') ('mg' 'mlg' 'Malagasy') ('mt' 'mlt' 'Maltese') ('mnc' 'Manchu') ('mni' 'Manipuri') ('mno' 'Manobo languages') ('moh' 'Mohawk') ('mo' 'mol' 'Moldavian') ('mn' 'mon' 'Mongolian') ('mos' 'Mossi') ('mul' 'Multiple languages') ('mun' 'Munda languages') ('mus' 'Creek') ('mwl' 'Mirandese') ('mwr' 'Marwari') ('myn' 'Mayan languages') ('myv' 'Erzya') ('nah' 'Nahuatl languages') ('nai' 'North American Indian') ('nap' 'Neapolitan') ('na' 'nau' 'Nauru') ('nv' 'nav' 'Navajo; Navaho') ('nr' 'nbl' 'Ndebele, South; South Ndebele') ('nd' 'nde' 'Ndebele, North; North Ndebele') ('ng' 'ndo' 'Ndonga') ('nds' 'Low German; Low Saxon; German, Low; Saxon, Low') ('ne' 'nep' 'Nepali') ('new' 'Nepal Bhasa; Newari') ('nia' 'Nias') ('nic' 'Niger-Kordofanian (Other)') ('niu' 'Niuean') ('nn' 'nno' 'Norwegian Nynorsk; Nynorsk, Norwegian') ('nb' 'nob' 'Bokml, Norwegian; Norwegian Bokml') ('nog' 'Nogai') ('non' 'Norse, Old') ('no' 'nor' 'Norwegian') ('nqo' 'N''Ko') ('nso' 'Pedi; Sepedi; Northern Sotho') ('nub' 'Nubian languages') ('nwc' 'Classical Newari; Old Newari; Classical Nepal Bhasa') ('ny' 'nya' 'Chichewa; Chewa; Nyanja') ('nym' 'Nyamwezi') ('nyn' 'Nyankole') ('nyo' 'Nyoro') ('nzi' 'Nzima') ('oc' 'oci' 'Occitan (post 1500); Provenal') ('oj' 'oji' 'Ojibwa') ('or' 'ori' 'Oriya') ('om' 'orm' 'Oromo') ('osa' 'Osage') ('os' 'oss' 'Ossetian; Ossetic') ('ota' 'Turkish, Ottoman (1500-1928)') ('oto' 'Otomian languages') ('paa' 'Papuan (Other)') ('pag' 'Pangasinan') ('pal' 'Pahlavi') ('pam' 'Pampanga; Kapampangan') ('pa' 'pan' 'Panjabi; Punjabi') ('pap' 'Papiamento') ('pau' 'Palauan') ('peo' 'Persian, Old (ca.600-400 B.C.)') ('fa' 'per' 'Persian') ('phi' 'Philippine (Other)') ('phn' 'Phoenician') ('pi' 'pli' 'Pali') ('pl' 'pol' 'Polish') ('pon' 'Pohnpeian') ('pt' 'por' 'Portuguese') ('pra' 'Prakrit languages') ('pro' 'Provenal, Old (to 1500)') ('ps' 'pus' 'Pushto; Pashto') ('qaa-qtz' 'Reserved for local use') ('qu' 'que' 'Quechua') ('raj' 'Rajasthani') ('rap' 'Rapanui') ('rar' 'Rarotongan; Cook Islands Maori') ('roa' 'Romance (Other)') ('rm' 'roh' 'Romansh') ('rom' 'Romany') ('ro' 'rum' 'Romanian') ('rn' 'run' 'Rundi') ('rup' 'Aromanian; Arumanian; Macedo-Romanian') ('ru' 'rus' 'Russian') ('sad' 'Sandawe') ('sg' 'sag' 'Sango') ('sah' 'Yakut') ('sai' 'South American Indian (Other)') ('sal' 'Salishan languages') ('sam' 'Samaritan Aramaic') ('sa' 'san' 'Sanskrit') ('sas' 'Sasak') ('sat' 'Santali') ('sr' 'scc' 'Serbian') ('scn' 'Sicilian') ('sco' 'Scots') ('hr' 'scr' 'Croatian') ('sel' 'Selkup') ('sem' 'Semitic (Other)') ('sga' 'Irish, Old (to 900)') ('sgn' 'Sign Languages') ('shn' 'Shan') ('sid' 'Sidamo') ('si' 'sin' 'Sinhala; Sinhalese') ('sio' 'Siouan languages') ('sit' 'Sino-Tibetan (Other)') ('sla' 'Slavic (Other)') ('sk' 'slo' 'Slovak') ('sl' 'slv' 'Slovenian') ('sma' 'Southern Sami') ('se' 'sme' 'Northern Sami') ('smi' 'Sami languages (Other)') ('smj' 'Lule Sami') ('smn' 'Inari Sami') ('sm' 'smo' 'Samoan') ('sms' 'Skolt Sami') ('sn' 'sna' 'Shona') ('sd' 'snd' 'Sindhi') ('snk' 'Soninke') ('sog' 'Sogdian') ('so' 'som' 'Somali') ('son' 'Songhai languages') ('st' 'sot' 'Sotho, Southern') ('es' 'spa' 'Spanish; Castilian') ('sc' 'srd' 'Sardinian') ('srn' 'Sranan Tongo') ('srr' 'Serer') ('ssa' 'Nilo-Saharan (Other)') ('ss' 'ssw' 'Swati') ('suk' 'Sukuma') ('su' 'sun' 'Sundanese') ('sus' 'Susu') ('sux' 'Sumerian') ('sw' 'swa' 'Swahili') ('sv' 'swe' 'Swedish') ('syc' 'Classical Syriac') ('syr' 'Syriac') ('ty' 'tah' 'Tahitian') ('tai' 'Tai (Other)') ('ta' 'tam' 'Tamil') ('tt' 'tat' 'Tatar') ('te' 'tel' 'Telugu') ('tem' 'Timne') ('ter' 'Tereno') ('tet' 'Tetum') ('tg' 'tgk' 'Tajik') ('tl' 'tgl' 'Tagalog') ('th' 'tha' 'Thai') ('bo' 'tib' 'Tibetan') ('tig' 'Tigre') ('ti' 'tir' 'Tigrinya') ('tiv' 'Tiv') ('tkl' 'Tokelau') ('tlh' 'Klingon; tlhIngan-Hol') ('tli' 'Tlingit') ('tmh' 'Tamashek') ('tog' 'Tonga (Nyasa)') ('to' 'ton' 'Tonga (Tonga Islands)') ('tpi' 'Tok Pisin') ('tsi' 'Tsimshian') ('tn' 'tsn' 'Tswana') ('ts' 'tso' 'Tsonga') ('tk' 'tuk' 'Turkmen') ('tum' 'Tumbuka') ('tup' 'Tupi languages') ('tr' 'tur' 'Turkish') ('tut' 'Altaic (Other)') ('tvl' 'Tuvalu') ('tw' 'twi' 'Twi') ('tyv' 'Tuvinian') ('udm' 'Udmurt') ('uga' 'Ugaritic') ('ug' 'uig' 'Uighur; Uyghur') ('uk' 'ukr' 'Ukrainian') ('umb' 'Umbundu') ('und' 'Undetermined') ('ur' 'urd' 'Urdu') ('uz' 'uzb' 'Uzbek') ('vai' 'Vai') ('ve' 'ven' 'Venda') ('vi' 'vie' 'Vietnamese') ('vo' 'vol' 'Volapk') ('vot' 'Votic') ('wak' 'Wakashan languages') ('wal' 'Walamo') ('war' 'Waray') ('was' 'Washo') ('cy' 'wel' 'Welsh') ('wen' 'Sorbian languages') ('wa' 'wln' 'Walloon') ('wo' 'wol' 'Wolof') ('xal' 'Kalmyk; Oirat') ('xh' 'xho' 'Xhosa') ('yao' 'Yao') ('yap' 'Yapese') ('yi' 'yid' 'Yiddish') ('yo' 'yor' 'Yoruba') ('ypk' 'Yupik languages') ('zap' 'Zapotec') ('zbl' 'Blissymbols; Blissymbolics; Bliss') ('zen' 'Zenaga') ('za' 'zha' 'Zhuang; Chuang') ('znd' 'Zande languages') ('zu' 'zul' 'Zulu') ('zun' 'Zuni') ('zxx' 'No linguistic content') ('zza' 'Zaza; Dimili; Dimli; Kirdki; Kirmanjki; Zazaki'))! !
!WALocale class categoriesFor: #countryList!accessing!public! !
!WALocale class categoriesFor: #fromString:!instance creation!public! !
!WALocale class categoriesFor: #initialize!class initialization!public! !
!WALocale class categoriesFor: #initializeCountryList!class initialization!public! !
!WALocale class categoriesFor: #initializeLangaugeList!class initialization!public! !
!WALocale class categoriesFor: #iso2Countries!accessing!public! !
!WALocale class categoriesFor: #iso2Languages!accessing!public! !
!WALocale class categoriesFor: #iso3Countries!accessing!public! !
!WALocale class categoriesFor: #iso3Languages!accessing!public! !
!WALocale class categoriesFor: #language:!instance creation!public! !
!WALocale class categoriesFor: #language:country:!instance creation!public! !
!WALocale class categoriesFor: #languageList!accessing!public! !

WAMergedRequestFields guid: (GUID fromString: '{C4F1E5A1-DF32-411A-95FD-C90153F0AC2D}')!
WAMergedRequestFields comment: 'Provides a read-only view onto multiple dictionaries. Note that this can lead to to duplicated keys that can only retrieved by iterating over all the associations.'!
!WAMergedRequestFields categoriesForClass!Unclassified! !
!WAMergedRequestFields methodsFor!

allAt: aKey
	^ Array streamContents: [ :stream |
		delegates do: [ :each | stream nextPutAll: (each allAt: aKey) ] ]!

allAt: aKey ifAbsent: absentBlock
	| result |
	result := self allAt: aKey.
	^ result isEmpty
		ifTrue: [ absentBlock value ]
		ifFalse: [ result ]!

associationsDo: aBlock
	delegates do: [ :each | each associationsDo: aBlock ]!

at: aKey
	^ self at: aKey ifAbsent: [ self errorKeyNotFound ]!

at: aKey ifAbsent: aBlock
	delegates do: [ :each |
		each
			at: aKey
			ifPresent: [ :value | ^ value ] ].
	^ aBlock value!

at: aKey ifPresent: aBlock
	delegates do: [ :each |
		each
			at: aKey
			ifPresent: [ :value | ^ aBlock value: value ] ].
	^ nil!

do: aBlock
	delegates do: [ :each | each do: aBlock ]!

errorKeyNotFound
	^ nil!

includesKey: aKey
	^ delegates anySatisfy: [ :each | each includesKey: aKey ]!

initializeOn: anArray
	self initialize.
	delegates := anArray!

isEmpty
	^ delegates allSatisfy: [ :each | each isEmpty ]!

keys
	^ Array streamContents: [ :stream |
		delegates do: [ :each | stream nextPutAll: each keys ] ]!

keysAndValuesDo: aBlock
	delegates do: [ :each | each keysAndValuesDo: aBlock ]!

keysDo: aBlock
	delegates do: [ :each | each keysDo: aBlock ]!

size
	^ delegates inject: 0 into: [ :result :each | result + each size ]!

values
	^ Array streamContents: [ :stream |
		delegates do: [ :each | stream nextPutAll: each values ] ]! !
!WAMergedRequestFields categoriesFor: #allAt:!enumerating!public! !
!WAMergedRequestFields categoriesFor: #allAt:ifAbsent:!enumerating!public! !
!WAMergedRequestFields categoriesFor: #associationsDo:!enumerating!public! !
!WAMergedRequestFields categoriesFor: #at:!accessing!public! !
!WAMergedRequestFields categoriesFor: #at:ifAbsent:!accessing!public! !
!WAMergedRequestFields categoriesFor: #at:ifPresent:!accessing!public! !
!WAMergedRequestFields categoriesFor: #do:!enumerating!public! !
!WAMergedRequestFields categoriesFor: #errorKeyNotFound!private! !
!WAMergedRequestFields categoriesFor: #includesKey:!public!testing! !
!WAMergedRequestFields categoriesFor: #initializeOn:!initialization!public! !
!WAMergedRequestFields categoriesFor: #isEmpty!public!testing! !
!WAMergedRequestFields categoriesFor: #keys!enumerating!public! !
!WAMergedRequestFields categoriesFor: #keysAndValuesDo:!enumerating!public! !
!WAMergedRequestFields categoriesFor: #keysDo:!enumerating!public! !
!WAMergedRequestFields categoriesFor: #size!accessing!public! !
!WAMergedRequestFields categoriesFor: #values!enumerating!public! !

!WAMergedRequestFields class methodsFor!

new
	self error: self name , ' is created with #on:'!

on: anArray
	^ self basicNew initializeOn: anArray! !
!WAMergedRequestFields class categoriesFor: #new!instance creation!public! !
!WAMergedRequestFields class categoriesFor: #on:!instance creation!public! !

WAMimeDocument guid: (GUID fromString: '{5C5E0A93-8A81-4715-A209-7E32D4AA7C83}')!
WAMimeDocument comment: '
WAMimeDocument is the abstract base class for mime documents. It is intened as a very basic, mime documents. Implementations are free to use more advance, native implentations as long as they conform to the protocol.

Instance Variables
	contentType:		<WAMimeType>

mimeType
	- the mime type of this document
'!
!WAMimeDocument categoriesForClass!Unclassified! !
!WAMimeDocument methodsFor!

= anObject
	^ (anObject isKindOf: WAMimeDocument)
		and: [ self mimeType = anObject mimeType
		and: [ self fileName = anObject fileName
		and: [ self contents = anObject contents ] ] ]!

content
	^ self contents!

contents
	"Answer the content of the receiver as a Collection of Characters or bytes."
	
	^ contents!

contents: aCollection
	contents := aCollection!

contentStream
	^ self contents readStream!

contentType
	^ self mimeType!

fileName
	"Answer the file name of this document, or nil."
	
	^ fileName!

fileName: aString
	fileName := aString!

hash
	^ (self mimeType hash
		bitXor: self fileName hash)
		bitXor: self contents hash!

initializeOn: aCollection mimeType: aMimeType fileName: aString
	self initialize.
	self contents: aCollection.
	self mimeType: aMimeType.
	self fileName: aString!

mimeType
	"Answer the file name of this document, or nil."
	
	^ mimeType!

mimeType: aMimeType
	mimeType := aMimeType isNil
		ifFalse: [ aMimeType seasideMimeType ]
		ifTrue: [ WAMimeType applicationOctetStream ]!

seasideMimeDocument
	^ self! !
!WAMimeDocument categoriesFor: #=!comparing!public! !
!WAMimeDocument categoriesFor: #content!compatibility!public! !
!WAMimeDocument categoriesFor: #contents!accessing!public! !
!WAMimeDocument categoriesFor: #contents:!accessing!public! !
!WAMimeDocument categoriesFor: #contentStream!compatibility!public! !
!WAMimeDocument categoriesFor: #contentType!compatibility!public! !
!WAMimeDocument categoriesFor: #fileName!accessing!public! !
!WAMimeDocument categoriesFor: #fileName:!accessing!public! !
!WAMimeDocument categoriesFor: #hash!comparing!public! !
!WAMimeDocument categoriesFor: #initializeOn:mimeType:fileName:!initialization!public! !
!WAMimeDocument categoriesFor: #mimeType!accessing!public! !
!WAMimeDocument categoriesFor: #mimeType:!accessing!public! !
!WAMimeDocument categoriesFor: #seasideMimeDocument!converting!public! !

!WAMimeDocument class methodsFor!

on: aCollection
	^ self on: aCollection mimeType: nil!

on: aCollection mimeType: aMimeType
	^ self on: aCollection mimeType: aMimeType fileName: nil!

on: aCollection mimeType: aMimeType fileName: aString
	^ self basicNew initializeOn: aCollection mimeType: aMimeType fileName: aString; yourself! !
!WAMimeDocument class categoriesFor: #on:!instance creation!public! !
!WAMimeDocument class categoriesFor: #on:mimeType:!instance creation!public! !
!WAMimeDocument class categoriesFor: #on:mimeType:fileName:!instance creation!public! !

WAMimeType guid: (GUID fromString: '{A8930CDF-4972-49AD-8A1A-AC0CC7ECD2B2}')!
WAMimeType comment: '
A WAMimeType abstracts a Internet media type, it is a two-part identifier for file formats on the Internet.

Instance Variables
	main:		<String>
	parameters:		<WASmallDictionary>
	sub:		<String>

main
	- the main type

parameters
	- a lazily initialized dictionary of optional parameters

sub
	- the subtype
'!
!WAMimeType categoriesForClass!Unclassified! !
!WAMimeType methodsFor!

= other
	^(other isKindOf: WAMimeType)
		and: [ self main = other main
		and: [ self sub = other sub ] ]!

charSet
	^self parameters at: 'charset' ifAbsent: [ nil ]!

charset: aString
	self parameters at: 'charset' put: aString!

greaseString
	^ String streamContents: 
		[ :stream | 
		stream
			nextPutAll: self main;
			nextPut: $/;
			nextPutAll: self sub.
		parameters isNil ifFalse: 
			[ parameters keysAndValuesDo: 
				[ :key :value | 
				stream
					nextPut: $;;
					nextPutAll: key;
					nextPut: $=;
					nextPutAll: value ] ] ]!

hash
	^self main hash bitXor: self sub hash!

isBinary
	"answers whether the contents of a document of the receiving mime type are binary"
	| subTypes |
	self main = 'text' ifTrue: [ ^false ].
	self main = 'application' ifFalse: [ ^true ].
	subTypes := self sub greaseSubStrings: '+'.
	^ subTypes noneSatisfy: [ :each | 
		#('x-javascript' 'xml') includes: each ]!

isNonStandard
	"tests if the receiver is a non-standard mime type that is not registered with IANA"
	^(self main beginsWithSubCollection: 'x-')
		or: [ (self main beginsWithSubCollection: 'X-')
		or: [ (self sub beginsWithSubCollection: 'x-')
		or: [ self sub beginsWithSubCollection: 'X-' ] ] ]!

isVendorSpecific
	"tests if the receiver is a vendor specific mimetype"
	^self sub beginsWithSubCollection: 'vnd.'!

main
	^ main!

main: aString
	main := aString!

matches: aMimeType
	"aMimeType is the pattern to match, it is a normal WAMimeType instance where main or sub can be wildcards"
	^(aMimeType main = '*'
		or: [ aMimeType main = self main ])
		and: [
			aMimeType sub = '*'
				or: [ aMimeType sub = self sub ] ]!

parameterAt: aKey put: aValue
	self parameters at: aKey put: aValue!

parameters
	parameters isNil ifTrue: [ parameters := GRSmallDictionary new ].
	^ parameters!

parameters: aDictionary
	parameters := aDictionary!

printOn: aStream 
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self greaseString;
		nextPut: $)!

seasideMimeType
	^ self!

sub
	^ sub!

sub: aString
	sub := aString! !
!WAMimeType categoriesFor: #=!comparing!public! !
!WAMimeType categoriesFor: #charSet!parameters!public! !
!WAMimeType categoriesFor: #charset:!parameters!public! !
!WAMimeType categoriesFor: #greaseString!converting!public! !
!WAMimeType categoriesFor: #hash!comparing!public! !
!WAMimeType categoriesFor: #isBinary!public!testing! !
!WAMimeType categoriesFor: #isNonStandard!public!testing! !
!WAMimeType categoriesFor: #isVendorSpecific!public!testing! !
!WAMimeType categoriesFor: #main!accessing!public! !
!WAMimeType categoriesFor: #main:!accessing!public! !
!WAMimeType categoriesFor: #matches:!public!testing! !
!WAMimeType categoriesFor: #parameterAt:put:!parameters!public! !
!WAMimeType categoriesFor: #parameters!accessing!public! !
!WAMimeType categoriesFor: #parameters:!accessing!public! !
!WAMimeType categoriesFor: #printOn:!printing!public! !
!WAMimeType categoriesFor: #seasideMimeType!converting!public! !
!WAMimeType categoriesFor: #sub!accessing!public! !
!WAMimeType categoriesFor: #sub:!accessing!public! !

!WAMimeType class methodsFor!

applicationAtomXml
	^ self main: 'application' sub: 'atom+xml'!

applicationJson
	^ self main: 'application' sub: 'json'!

applicationOctetStream
	^ self main: 'application' sub: 'octet-stream'!

applicationRssXml
	^ self main: 'application' sub: 'rss+xml'!

formUrlencoded
	^ self main: 'application' sub: 'x-www-form-urlencoded'!

fromString: aString 
	| main endOfSub sub parts parameters |
	main := aString copyUpTo: $/.
	endOfSub := aString indexOf: $;.
	endOfSub := endOfSub = 0 
		ifTrue: [ aString size ]
		ifFalse: [ endOfSub - 1 ].
	sub := aString 
		copyFrom: main size + 2
		to: endOfSub.
	endOfSub = aString size ifTrue: 
		[ ^ self 
			main: main
			sub: sub ].
	parts := (aString 
		copyFrom: endOfSub + 1
		to: aString size) greaseSubStrings: ';'.
	parameters := GRSmallDictionary new.
	parts do: 
		[ :each | 
		parameters 
			at: (each copyUpTo: $=) trimBoth
			put: (each copyAfter: $=) trimBoth ].
	^ self 
		main: main
		sub: sub
		parameters: parameters!

imageGif
	^ self main: 'image' sub: 'gif'!

imageJpeg
	^ self main: 'image' sub: 'jpeg'!

imagePng
	^ self main: 'image' sub: 'png'!

main: aMainString sub: aSubString
	^self new
		main: aMainString;
		sub: aSubString;
		yourself!

main: aMainString sub: aSubString parameters: aDictionary
	^(self main: aMainString sub: aSubString)
		parameters: aDictionary;
		yourself!

textCss
	^ self main: 'text' sub: 'css'!

textHtml
	^ self main: 'text' sub: 'html'!

textJavascript
	^ self main: 'text' sub: 'javascript'!

textPlain
	^ self main: 'text' sub: 'plain'! !
!WAMimeType class categoriesFor: #applicationAtomXml!convenience!public! !
!WAMimeType class categoriesFor: #applicationJson!convenience!public! !
!WAMimeType class categoriesFor: #applicationOctetStream!convenience!public! !
!WAMimeType class categoriesFor: #applicationRssXml!convenience!public! !
!WAMimeType class categoriesFor: #formUrlencoded!convenience!public! !
!WAMimeType class categoriesFor: #fromString:!instance creation!public! !
!WAMimeType class categoriesFor: #imageGif!convenience!public! !
!WAMimeType class categoriesFor: #imageJpeg!convenience!public! !
!WAMimeType class categoriesFor: #imagePng!convenience!public! !
!WAMimeType class categoriesFor: #main:sub:!instance creation!public! !
!WAMimeType class categoriesFor: #main:sub:parameters:!instance creation!public! !
!WAMimeType class categoriesFor: #textCss!convenience!public! !
!WAMimeType class categoriesFor: #textHtml!convenience!public! !
!WAMimeType class categoriesFor: #textJavascript!convenience!public! !
!WAMimeType class categoriesFor: #textPlain!convenience!public! !

WAMutex guid: (GUID fromString: '{F319ED5E-623E-44E5-9888-940D8EC4C709}')!
WAMutex comment: '
WAMutex provides mutual exclusion properties.

Only one process at a time can execute code within its #critical: method. Other processes attempting to call #critical: will block until the first process leaves the critical section. The process that owns the mutex (the one currently in the critical section), however, may call #critical: repeatedly without fear of blocking.

The process currently inside the critical section can be terminated by calling #terminateOwner. This will result in the process being unwound and the critical section being freed.'!
!WAMutex categoriesForClass!Unclassified! !
!WAMutex methodsFor!

copy
	^ self species new!

critical: aBlock
	| process |
	process := Processor activeProcess.
	^ (owner == process)
		ifTrue: [ aBlock value ]
		ifFalse: [
			semaphore critical: [
				owner := process.
				aBlock ensure: [ owner := nil ] ] ]!

initialize
	super initialize.
	semaphore := GRPlatform current semaphoreClass forMutualExclusion!

owner
	^ owner!

terminateOwner
	owner isNil ifFalse: [ GRPlatform current terminateProcess: owner ]! !
!WAMutex categoriesFor: #copy!copying!public! !
!WAMutex categoriesFor: #critical:!mutual exclusion!public! !
!WAMutex categoriesFor: #initialize!initialization!public! !
!WAMutex categoriesFor: #owner!accessing!public! !
!WAMutex categoriesFor: #terminateOwner!mutual exclusion!public! !

WAOpeningConditionalComment guid: (GUID fromString: '{637306BA-8491-4194-AAC3-304FCF7EE984}')!
WAOpeningConditionalComment comment: 'Opens a WAConditionalComment and encodes the condition.'!
!WAOpeningConditionalComment categoriesForClass!Unclassified! !
!WAOpeningConditionalComment methodsFor!

condition
	^ condition!

condition: aString
	condition := aString!

encodeOn: aDocument
	aDocument
		nextPutAll: '<!!--[';
		nextPutAll: self condition;
		nextPutAll: ']>'! !
!WAOpeningConditionalComment categoriesFor: #condition!accessing!public! !
!WAOpeningConditionalComment categoriesFor: #condition:!accessing!public! !
!WAOpeningConditionalComment categoriesFor: #encodeOn:!printing!public! !

!WAOpeningConditionalComment class methodsFor!

condition: aString
	^self new
		condition: aString;
		yourself! !
!WAOpeningConditionalComment class categoriesFor: #condition:!instance creation!public! !

WAPainter guid: (GUID fromString: '{E4E37CE4-0A1F-420B-8658-8D0F8E94E05A}')!
WAPainter comment: '
A Painter is an object that renders onto a Document using a Renderer (typically a subclass of WACanvas). The class of the Renderer is specified by #rendererClass.

Subclasses should implement #renderContentOn: to do the actual rendering.

Painters do not store or backtrack state and do not provide call/answer semantics or decorations. They are often created for each request, used, and then discarded. If you want any of the above features, you should use a subclass of WAPresenter or WAComponent.

To cause a Painter to render itself, you should pass it to the #render: message of a Renderer. For example, from within a Component you could do the following:

	renderContentOn: html
		html render: MyPainterSubclass new'!
!WAPainter categoriesForClass!Unclassified! !
!WAPainter methodsFor!

accept: aVisitor
	aVisitor visitPainter: self!

renderContentOn: aRenderer
	"This is the main rendering method of WAPainter. It will be called with an instance of
	the Renderer class returned by #rendererClass whenever this Painter is asked to render
	itself. By convention, implementations of this method that expect a Canvas renderer
	use 'html' as the parameter name."
	
	self subclassResponsibility!

rendererClass
	"Returns a subclass of WARenderer to use when rendering this Painter."
	
	^ WARenderer default!

renderOn: aRenderer
	"This method allows Painters to be passed into the #render: method of a Renderer.
	It should not normally be overridden. Subclasses should override #renderContentOn:.
	
	DO NOT call this method directly. Instead, pass this Painter as a parameter to the
	#render: method of aRenderer."
	
	self renderWithContext: aRenderer context!

renderWithContext: aRenderContext
	"This is the main entry point when attempting to render a Painter.
	It should not normally be overridden. Subclasses should override #renderContentOn:.
	
	You DO NOT normally need to call this method directly. Usually you have an instance
	of a Renderer (e.g. a WARenderCanvas) and can call the #render: method."
	
	aRenderContext visitor visit: self!

updateRoot: anHtmlRoot
	"Override this method to modify the Root object of a Document while rendering. This
	method is usually called by a WAUpdateRootVisitor.
	
	If you are using Painters within a tree of Presenters/Components, this method will not
	be called unless the Painter is included in the list of children of the Presenter."!

updateUrl: aUrl
	"Override this method to modify the WAUrl object which will be used as a base URL
	while rendering. This method is usually called by a WAUpdateUrlVisitor.
	
	If you are using Painters within a tree of Presenters/Components, this method will not
	be called unless the Painter is included in the list of children of the Presenter."! !
!WAPainter categoriesFor: #accept:!public!visiting! !
!WAPainter categoriesFor: #renderContentOn:!public!rendering! !
!WAPainter categoriesFor: #rendererClass!public!rendering! !
!WAPainter categoriesFor: #renderOn:!public!rendering! !
!WAPainter categoriesFor: #renderWithContext:!public!rendering! !
!WAPainter categoriesFor: #updateRoot:!public!updating! !
!WAPainter categoriesFor: #updateUrl:!public!updating! !

WAPathConsumer guid: (GUID fromString: '{859DFEBF-1969-4873-9F4B-F1F5F9056293}')!
WAPathConsumer comment: '
A WAPathConsumer keeps track of the unconsumed path elements in request handling.

Instance Variables
	path:		<Collection<String>>

path
	- the collection of unconsumed path elements
'!
!WAPathConsumer categoriesForClass!Unclassified! !
!WAPathConsumer methodsFor!

atEnd
	"Answer whether there are any unconsumed path elements left."
	^path isEmpty!

initializeWith: aCollectionOfStrings
	self initialize.
	path := aCollectionOfStrings!

next
	"Remove the first unconsumed path element and answer it."
	^path removeFirst!

nextIfPresentDo: aOneArgumentBlock
	"Evaluate the given block with #next if not #atEnd."
	self atEnd
		ifFalse: [ aOneArgumentBlock value: self next ]!

peek
	"Answer the first unconsumed path element without removing it."
	^path first!

try: aString
	"See if the next element in the stream matches aString.
	If it does, consume the element and return true.
	If it does not or we are at the end of the stream, simply return false."
	
	(self atEnd or: [ (self peek = aString) not ]) ifTrue: [ ^ false ].
	
	self next.
	^ true!

upToEnd
	"answer the remaining elements in my path"
	| elements |
	elements := OrderedCollection new.
	[ self atEnd ] whileFalse: [ elements add: self next ].
	^ elements! !
!WAPathConsumer categoriesFor: #atEnd!accessing!public! !
!WAPathConsumer categoriesFor: #initializeWith:!initialization!public! !
!WAPathConsumer categoriesFor: #next!accessing!public! !
!WAPathConsumer categoriesFor: #nextIfPresentDo:!accessing!public! !
!WAPathConsumer categoriesFor: #peek!accessing!public! !
!WAPathConsumer categoriesFor: #try:!accessing!public! !
!WAPathConsumer categoriesFor: #upToEnd!accessing!public! !

!WAPathConsumer class methodsFor!

path: aCollectionOfStrings
	^self basicNew initializeWith: aCollectionOfStrings! !
!WAPathConsumer class categoriesFor: #path:!instance creation!public! !

WAQualifiedValue guid: (GUID fromString: '{E2A374A6-29D9-436B-A973-D3EABBAA7898}')!
WAQualifiedValue comment: '
A WAQualifiedValue is an Object with an assigned quality value.

Instance Variables
	quality:		<Float>
	value:		<Object>

quality
	- between 0.0 and 1.0 or Float infinity if no value is given

value
	- the qualified object'!
!WAQualifiedValue categoriesForClass!Unclassified! !
!WAQualifiedValue methodsFor!

<= other
	^self quality <= other quality!

quality
	^ quality!

quality: aFloat
	quality := aFloat!

value
	^ value!

value: anObject
	value := anObject! !
!WAQualifiedValue categoriesFor: #<=!comparing!public! !
!WAQualifiedValue categoriesFor: #quality!accessing!public! !
!WAQualifiedValue categoriesFor: #quality:!accessing!public! !
!WAQualifiedValue categoriesFor: #value!accessing!public! !
!WAQualifiedValue categoriesFor: #value:!accessing!public! !

!WAQualifiedValue class methodsFor!

fromString: aString
	^Array streamContents: [ :stream |
		| values |
		values := aString greaseSubStrings: ','.
		values do: [ :each |
			| value quality |
			value := self valueClass fromString: (each copyUpTo: $;) trimBoth.
			quality := (each includes: $;)
				ifTrue: [ Float readFrom: ((each copyAfter: $;) copyAfter: $=) readStream ]
				ifFalse: [ 1.0 ].
			stream nextPut: (self value: value quality: quality) ] ]!

value: anObject quality: aFloat
	^self new
		value: anObject;
		quality: aFloat;
		yourself!

valueClass
	self subclassResponsibility! !
!WAQualifiedValue class categoriesFor: #fromString:!instance creation!public! !
!WAQualifiedValue class categoriesFor: #value:quality:!instance creation!public! !
!WAQualifiedValue class categoriesFor: #valueClass!private! !

WARenderContext guid: (GUID fromString: '{45BD60ED-93A3-47D9-A3D8-52DD03E8EB32}')!
WARenderContext comment: '
A RenderContext provides all the state needed by a Renderer to do its work.

It is a decoupling device between whatever is initiating rendering and the Renderer itself.'!
!WARenderContext categoriesForClass!Unclassified! !
!WARenderContext methodsFor!

absoluteUrlForResource: aString 
	| url |
	aString isNil ifTrue: [ ^ nil ].
	url := self resourceUrl.
	(url isNil or: [ aString includesSubString: '://' ]) ifTrue: [ ^ WAUrl absolute: aString ].
	^ url copy addToPath: aString; yourself!

actionBaseUrl
	"Answer the action URL, that was not modified by #updateUrl:."
	
	^ actionBaseUrl!

actionBaseUrl: anObject
	actionBaseUrl := anObject seasideUrl!

actionUrl
	"Answer the action URL that was modified by #updateUrl:."

	^ actionUrl!

actionUrl: anObject
	actionUrl := anObject seasideUrl!

advanceKey
	self 
		greaseDeprecatedApi: 'WARenderContext>>#advanceKey'
		details: 'Use WACallbackRegistry>>#advanceKey. The callback registry is available from WARenderContext or WARenderCanvas by sending #callbacks.'.
	^ self callbacks advanceKey!

callbackAt: aString
	^ callbacks at: aString ifAbsent: [ ]!

callbacks
	^ callbacks!

callbacksFor: anObject 
	self 
		greaseDeprecatedApi: 'WARenderContext>>#callbacksFor:'
		details: 'Use #callbacks. Callbacks are no longer evaluated in the context of an owning object.'.
	^ self callbacks!

defaultVisitor
	^ WARenderVisitor context: self!

destroy
	self document destroy.
	document := nil!

document
	"Answer the value of document"

	^ document!

document: anObject
	"Set the value of document"

	document := anObject!

document: aDocument during: aBlock
	"Set the value of document for the duration of aBlock"
	| previous |
	previous := document.
	[ document := aDocument.
	aBlock value ]
		ensure: [ document := previous ]!

increaseKey
	self 
		greaseDeprecatedApi: 'WARenderContext>>#increaseKey'
		details: 'Use WACallbackRegistry>>increaseKey. The callback registry is available from WARenderContext or WARenderCanvas by sending #callbacks.'.
	^ self callbacks increaseKey!

initialize
	super initialize.
	callbacks := WACallbackRegistry new!

nextKey
	self 
		greaseDeprecatedApi: 'WARenderContext>>#nextKey'
		details: 'Use WACallbackRegistry>>nextKey. The callback registry is available from WARenderContext or WARenderCanvas by sending #callbacks.'.
	^ self callbacks nextKey!

postCopy
	super postCopy.
	visitor := visitor copyForRenderContext: self.
	actionUrl := actionUrl copy.
	resourceUrl := resourceUrl copy.
	properties := properties copy!

properties
	"Answer a property dictionary."
	^ properties ifNil: [ properties := GRSmallDictionary new ]!

resourceUrl
	^ resourceUrl!

resourceUrl: anObject
	resourceUrl := anObject seasideUrl!

session
	self 
		greaseDeprecatedApi: 'WARenderContext>>#session'
		details: 'The session is no longer stored in the render context. You can get at the session in the current request context by calling "self session" from any subclass of WAObject.'.
	^ super session!

session: aSession 
	self 
		greaseDeprecatedApi: 'WARenderContext>>#session:'
		details: 'The session is no longer stored in the render context.'!

urlForDocument: anObject
	^ self urlForDocument: anObject mimeType: nil!

urlForDocument: anObject mimeType: mimeString
	^ self urlForDocument: anObject mimeType: mimeString fileName: nil!

urlForDocument: anObject mimeType: mimeType fileName: fileName
	| handler |
	handler := (WADocumentHandler
		document: anObject
		mimeType: mimeType
		fileName: fileName).
	^self requestContext registry
		register: handler;
		urlFor: handler!

visitor
	^ visitor ifNil: [ visitor := self defaultVisitor ]!

visitor: anObject
	visitor := anObject! !
!WARenderContext categoriesFor: #absoluteUrlForResource:!accessing!public! !
!WARenderContext categoriesFor: #actionBaseUrl!accessing!public! !
!WARenderContext categoriesFor: #actionBaseUrl:!accessing!public! !
!WARenderContext categoriesFor: #actionUrl!accessing!public! !
!WARenderContext categoriesFor: #actionUrl:!accessing!public! !
!WARenderContext categoriesFor: #advanceKey!public! !
!WARenderContext categoriesFor: #callbackAt:!callbacks!public! !
!WARenderContext categoriesFor: #callbacks!accessing!public! !
!WARenderContext categoriesFor: #callbacksFor:!public! !
!WARenderContext categoriesFor: #defaultVisitor!private! !
!WARenderContext categoriesFor: #destroy!initialization!public! !
!WARenderContext categoriesFor: #document!accessing!public! !
!WARenderContext categoriesFor: #document:!accessing!public! !
!WARenderContext categoriesFor: #document:during:!accessing!public! !
!WARenderContext categoriesFor: #increaseKey!public! !
!WARenderContext categoriesFor: #initialize!initialization!public! !
!WARenderContext categoriesFor: #nextKey!public! !
!WARenderContext categoriesFor: #postCopy!copying!public! !
!WARenderContext categoriesFor: #properties!accessing!public! !
!WARenderContext categoriesFor: #resourceUrl!accessing!public! !
!WARenderContext categoriesFor: #resourceUrl:!accessing!public! !
!WARenderContext categoriesFor: #session!public! !
!WARenderContext categoriesFor: #session:!public! !
!WARenderContext categoriesFor: #urlForDocument:!documents!public! !
!WARenderContext categoriesFor: #urlForDocument:mimeType:!documents!public! !
!WARenderContext categoriesFor: #urlForDocument:mimeType:fileName:!documents!public! !
!WARenderContext categoriesFor: #visitor!accessing!public! !
!WARenderContext categoriesFor: #visitor:!accessing!public! !

WARenderer guid: (GUID fromString: '{70F52393-B30A-4A65-A254-2B9A07EEF32C}')!
WARenderer comment: '
A Renderer provides methods for rendering data (typically HTML) onto a Document. It gets all the information needed to do its work from a RenderContext, which is passed in on initialization.

Renderer are typically controlled by a Painter.'!
!WARenderer categoriesForClass!Unclassified! !
!WARenderer methodsFor!

absoluteUrlForResource: aString
	"Answer a resource URL for aString. The URL will always be absolute (ie. it will begin
	with a / or a URL scheme like http://. If aString already looks like a URL, an instance
	of WAUrl will be returned for it. If it looks like a path, it will be appended to the
	resource base URL configured in the RenderContext if there is one."

	^ self context absoluteUrlForResource: aString!

actionBaseUrl
	^ self context actionBaseUrl!

actionUrl
	^ self context actionUrl!

callbacks
	"Answer the callback registry."

	^ self context callbacks!

context
	"Answer the rendering context."

	^ context!

document
	^ self context document!

flush
	"Close any open elements and write any remaining data."!

initializeWithContext: aRenderContext
	self initialize.
	context := aRenderContext!

lastId
	"Answer the last identifier that was generated with #nextId."
	
	^ lastId!

nextId
	"Answer an identifier string that is unique within this RenderContext."
	
	^ lastId := 'id' , self callbacks advanceKey!

render: anObject
	"Render anObject using this Renderer."
	
	anObject renderOn: self!

text: anObject
	"Emit anObject onto the target document."

	self document print: anObject!

urlForAction: aBlock
	"Answer an action URL that will evaluate aBlock when it is requested."

	^ self actionUrl withField: (self callbacks store: (WAActionCallback on: aBlock))! !
!WARenderer categoriesFor: #absoluteUrlForResource:!public! !
!WARenderer categoriesFor: #actionBaseUrl!public! !
!WARenderer categoriesFor: #actionUrl!public! !
!WARenderer categoriesFor: #callbacks!accessing!public! !
!WARenderer categoriesFor: #context!accessing!public! !
!WARenderer categoriesFor: #document!accessing!public! !
!WARenderer categoriesFor: #flush!private! !
!WARenderer categoriesFor: #initializeWithContext:!initialization!public! !
!WARenderer categoriesFor: #lastId!public! !
!WARenderer categoriesFor: #nextId!public! !
!WARenderer categoriesFor: #render:!public! !
!WARenderer categoriesFor: #text:!public! !
!WARenderer categoriesFor: #urlForAction:!public! !

!WARenderer class methodsFor!

builder
	^ WABuilder on: self!

context: aRenderContext
	^ self basicNew initializeWithContext: aRenderContext; yourself!

default
	^ default ifNil: [ default := WARenderer ]!

default: anObject
	default := anObject!

resetDefault
	WARenderer default: nil!

selectAsDefault
	WARenderer default: self!

unselectAsDefault
	(WARenderer default = self) ifTrue: [ WARenderer resetDefault ]! !
!WARenderer class categoriesFor: #builder!instance creation!public! !
!WARenderer class categoriesFor: #context:!instance creation!public! !
!WARenderer class categoriesFor: #default!defaults!public! !
!WARenderer class categoriesFor: #default:!defaults!public! !
!WARenderer class categoriesFor: #resetDefault!defaults!public! !
!WARenderer class categoriesFor: #selectAsDefault!defaults!public! !
!WARenderer class categoriesFor: #unselectAsDefault!defaults!public! !

WARequest guid: (GUID fromString: '{7CF02AD7-2AD0-491E-A955-541132598AEC}')!
WARequest comment: '
I am a server independent http request object. Instance of me can be aquired through WAObject >> #currentRequest.

Instance Variables
	url:				<WAUrl>
	fields:			<Dictionary<String, Object>>
	headers:		<Dictionary<String, String>>
	nativeRequest:	<Object>
	cookies:			<Collection<WARequestCookie>>
	method:			<String>
	remoteAddress:	<String>
	body:				<String>

url
	- The request url without parameters. For example if the client requested ''http://www.google.com/search?q=seaside'' then the contents of url would be ''/search''. To get the parameters use #fields. This url is fully decoded. Use the #host method to get the host name. Dependening on the server adapter the #scheme may be ''http'' or ''https'' if the original request was HTTPS.

headers
	- The header of the HTTP request. This is a Dictionary mapping lowercase strings to other strings.
	
fields
	- The HTTP request parameters. These are the GET and POST parameters in combined into a single dictionary. In general this is a dictionary mapping Strings to Strings. In the case of multivalued paramters or parameters specified in both GET and POST it maps Strings to a Collection of Strings.
	
cookies
	- The collection of cookies (instance of WARequestCookie) the client sent. Note not all clients support all fields. E.g. you might send a path but the client might not return it. Note there can be several cookies with the same key but a different domain or path. See the #cookiesAt: method.
	
nativeRequest
	- The underlying request object of the web server (Kom, Swazoo, OpenTalk, FastCGI, ...). Accessing this makes your code unportable.
	
method
	- the HTTP method, should be upper case. In general only ''GET'' and ''POST'' are encountered in Seaside. SqueakSource also supports ''PUT''.
	
remoteAddress
	- The IP address of the client. If the server is behind a reverse proxy then this is ''127.0.0.1''. This could in theory also be an IPv6 address.
	
body
	- The undecoded, raw request body as a String, may be nil. See the "accessing-body" protocol for accessing it.'!
!WARequest categoriesForClass!Unclassified! !
!WARequest methodsFor!

accept
	"The Accept request-header field can be used to specify certain media types which are acceptable for the response. Accept headers can be used to indicate that the request is specifically limited to a small set of desired types, as in the case of a request for an in-line image.
	
	Answers an OrderedCollection of WAAccept with the values in the order the client sent them."
	^ WAAccept fromString: (self headerAt: 'accept' ifAbsent: [ ^nil ])!

acceptCharset
	"The Accept-Charset request-header field can be used to indicate what character sets are acceptable for the response. This field allows clients capable of understanding more comprehensive or special- purpose character sets to signal that capability to a server which is capable of representing documents in those character sets.
	
	Answers an OrderedCollection of WAAcceptCharset with the values in the order the client sent them."
	^ WAAcceptCharset fromString: (self headerAt: 'accept-charset' ifAbsent: [ ^nil ])!

acceptEncoding
	"The Accept-Encoding request-header field is similar to Accept, but restricts the content-codings (section 3.5) that are acceptable in the response.
	
	Answers an OrderedCollection of WAAcceptEncoding with the values in the order the client sent them."
	^ WAAcceptEncoding fromString: (self headerAt: 'accept-encoding' ifAbsent: [ ^nil ])!

acceptLanguage
	"The Accept-Language request-header field is similar to Accept, but restricts the set of natural languages that are preferred as a response to the request.
	
	Answers an OrderedCollection of WAAcceptLanguage with the values in the order the client sent them."
	^ WAAcceptLanguage fromString: (self headerAt: 'accept-language' ifAbsent: [ ^nil ])!

at: key
	^ self fields at: key!

at: key ifAbsent: aBlock
	^ self fields at: key ifAbsent: aBlock!

at: key ifPresent: aBlock
	^ self fields at: key ifPresent: aBlock!

authorization
	"Answer the basic authorization string from the request. This is the username and the password separated by a colon."
	
	| authorization |
	authorization := self headerAt: 'authorization'.
	^ authorization isNil ifFalse: [ self decodeAuthorization: authorization ]!

bodyDecoded
	"Answer the body decoded using the character set in the request header. Answer nil if no body is present. Signal an error if not character set is present in the request header."
	| contentType charSet |
	contentType := self contentType.
	charSet := contentType isNil ifFalse: [ contentType charSet ].
	^charSet isNil
		ifTrue: [ WAIllegalStateException signal: 'no character set of request body can not be determined' ]
		ifFalse: [ self bodyDecodeUsing: charSet ]!

bodyDecodeUsing: aCharSetName 
	"Answer the body decoded using the given character set name. Answer nil if there's no body."
	^ body isNil ifFalse: [ (GRCodec forEncoding: aCharSetName) decode: body ]!

contentType
	"The Content-Type entity-header field indicates the media type of the entity-body sent to the recipient or, in the case of the HEAD method, the media type that would have been sent had the request been a GET.
	
	Answer an instance of WAMimeType or nil."
	
	| contentType |
	contentType := self headerAt: 'content-type'.
	^ contentType isNil ifFalse: [ WAMimeType fromString: contentType ]!

cookieAt: aKey
	"Answer the first found cookie with the given key, there might be several cookies with the name key but different paths, in this case use #cookiesAt:."

	^ self cookies
		detect: [ :each | each key = aKey ]
		ifNone: [ nil ]!

cookies
	^ cookies ifNil: [ #() ]!

cookiesAt: aKey
	"Answer all the cookies with the given key."
	
	^ self cookies
		select: [ :each | each key = aKey ]!

decodeAuthorization: aString 
	^ GRPlatform current base64Decode: (aString greaseSubStrings: ' ') last!

destroy
	method := uri := version := postFields := remoteAddress := headers := cookies := nil!

fields
	^ WAMergedRequestFields on: (Array with: self queryFields with: self postFields)!

headerAt: aKey
	^ self headerAt: aKey ifAbsent: [ nil ]!

headerAt: aKey ifAbsent: aBlock
	^ headers at: aKey ifAbsent: aBlock!

headers
	^ headers!

host
	^ self headerAt: 'host'!

includesKey: key
	^ self fields includesKey: key!

initializeWithMethod: methodString uri: aUrlOrString version: aVersion
	self initialize.
	method := methodString asUppercase.
	uri := aUrlOrString seasideUrl.
	version := aVersion.
	headers := WAHeaderFields new.
	postFields := Dictionary new.
	cookies := OrderedCollection new.
	remoteAddress := nil!

isGet
	^ self method = 'GET'!

isHttp10
	^ version isHttp10!

isHttp11
	^ version isHttp11!

isPost
	^ self method = 'POST'!

isSsl
	^ self uri isSsl!

isXmlHttpRequest
	^ (self headerAt: 'x-requested-with') = 'XMLHttpRequest'!

method
	^ method!

password
	"Answer the password from basic authentication."
	
	| authorization |
	^ (authorization := self authorization) isNil
		ifFalse: [ authorization copyAfter: $: ]!

postFields
	^ postFields!

printOn: aStream 
	super printOn: aStream.
	aStream
		nextPutAll: ' method: ';
		nextPutAll: self method.
	aStream
		nextPutAll: ' uri: ';
		nextPutAll: self uri greaseString.
	aStream nextPutAll: ' version: '.
	self version printOn: aStream!

queryFields
	^ self uri queryFields!

rawBody
	"Answer the raw, undecoded body. May be nil.
	
	Use #bodyDecoded or #bodyDecodeUsing: to access the decoded contents."
	
	^body!

referer
	^ self headerAt: 'referer'!

remoteAddress
	"answer the IP address of the client (String)"
	^ remoteAddress!

setBody: aString
	body := aString!

setCookies: cookieCollection
	cookies := cookieCollection!

setHeaders: headerDictionary
	headers := headerDictionary!

setPostFields: aRequestFields
	postFields := aRequestFields seasideRequestFields!

setRemoteAddress: addressString
	remoteAddress := addressString!

uri
	^ uri!

url
	^ self uri!

user
	"Answer the username from basic authentication."
	
	| authorization |
	^ (authorization := self authorization) isNil
		ifFalse: [ authorization copyUpTo: $: ]!

userAgent
	^ self headerAt: 'user-agent'!

version
	^ version!

version: aVersion
	version := aVersion! !
!WARequest categoriesFor: #accept!accessing-headers!public! !
!WARequest categoriesFor: #acceptCharset!accessing-headers!public! !
!WARequest categoriesFor: #acceptEncoding!accessing-headers!public! !
!WARequest categoriesFor: #acceptLanguage!accessing-headers!public! !
!WARequest categoriesFor: #at:!accessing!public! !
!WARequest categoriesFor: #at:ifAbsent:!accessing!public! !
!WARequest categoriesFor: #at:ifPresent:!accessing!public! !
!WARequest categoriesFor: #authorization!accessing-headers!public! !
!WARequest categoriesFor: #bodyDecoded!accessing-body!public! !
!WARequest categoriesFor: #bodyDecodeUsing:!accessing-body!public! !
!WARequest categoriesFor: #contentType!accessing-headers!public! !
!WARequest categoriesFor: #cookieAt:!accessing-cookies!public! !
!WARequest categoriesFor: #cookies!accessing-cookies!public! !
!WARequest categoriesFor: #cookiesAt:!accessing-cookies!public! !
!WARequest categoriesFor: #decodeAuthorization:!private! !
!WARequest categoriesFor: #destroy!initialization!public! !
!WARequest categoriesFor: #fields!accessing!public! !
!WARequest categoriesFor: #headerAt:!accessing!public! !
!WARequest categoriesFor: #headerAt:ifAbsent:!accessing!public! !
!WARequest categoriesFor: #headers!accessing!public! !
!WARequest categoriesFor: #host!accessing-headers!public! !
!WARequest categoriesFor: #includesKey:!public!testing! !
!WARequest categoriesFor: #initializeWithMethod:uri:version:!initialization!public! !
!WARequest categoriesFor: #isGet!public!testing! !
!WARequest categoriesFor: #isHttp10!public!testing! !
!WARequest categoriesFor: #isHttp11!public!testing! !
!WARequest categoriesFor: #isPost!public!testing! !
!WARequest categoriesFor: #isSsl!public!testing! !
!WARequest categoriesFor: #isXmlHttpRequest!public!testing! !
!WARequest categoriesFor: #method!accessing!public! !
!WARequest categoriesFor: #password!accessing!public! !
!WARequest categoriesFor: #postFields!accessing-body!public! !
!WARequest categoriesFor: #printOn:!printing!public! !
!WARequest categoriesFor: #queryFields!accessing!public! !
!WARequest categoriesFor: #rawBody!accessing-body!public! !
!WARequest categoriesFor: #referer!accessing-headers!public! !
!WARequest categoriesFor: #remoteAddress!accessing!public! !
!WARequest categoriesFor: #setBody:!initialization!public! !
!WARequest categoriesFor: #setCookies:!initialization!public! !
!WARequest categoriesFor: #setHeaders:!initialization!public! !
!WARequest categoriesFor: #setPostFields:!initialization!public! !
!WARequest categoriesFor: #setRemoteAddress:!initialization!public! !
!WARequest categoriesFor: #uri!accessing!public! !
!WARequest categoriesFor: #url!accessing!public! !
!WARequest categoriesFor: #user!accessing!public! !
!WARequest categoriesFor: #userAgent!accessing-headers!public! !
!WARequest categoriesFor: #version!accessing!public! !
!WARequest categoriesFor: #version:!accessing!public! !

!WARequest class methodsFor!

defaultMethod
	^ 'GET'!

defaultUri
	^ '/' seasideUrl!

defaultVersion
	^ WAHttpVersion http11!

method: methodString uri: aUrlOrString
	^ self method: methodString uri: aUrlOrString version: self defaultVersion!

method: methodString uri: aUrlOrString version: aVersion
	^ self basicNew
		initializeWithMethod: methodString
			uri: aUrlOrString
			version: aVersion;
		yourself!

method: methodString url: urlOrString headers: headDict fields: fieldDict cookies: cookieDict 
	self 
		greaseDeprecatedApi: 'WARequest class>>#method:url:headers:fields:cookies:'
		details: 'Create Requests with #method:uri:version: or #method:uri: and use accessors to set other values.'.
	^ (self 
		method: methodString
		uri: urlOrString)
		setHeaders: headDict;
		setPostFields: fieldDict;
		setCookies: cookieDict;
		yourself!

new
	^ self
		method: self defaultMethod
		uri: self defaultUri
		version: self defaultVersion! !
!WARequest class categoriesFor: #defaultMethod!configuration!public! !
!WARequest class categoriesFor: #defaultUri!configuration!public! !
!WARequest class categoriesFor: #defaultVersion!configuration!public! !
!WARequest class categoriesFor: #method:uri:!instance creation!public! !
!WARequest class categoriesFor: #method:uri:version:!instance creation!public! !
!WARequest class categoriesFor: #method:url:headers:fields:cookies:!public! !
!WARequest class categoriesFor: #new!instance creation!public! !

WARequestContext guid: (GUID fromString: '{E54E3371-48C2-4590-BD3A-EC7D074BED6C}')!
WARequestContext comment: '
WARequestContext encapsulates all the knowledge that shuld be available while processing a single request. It does not matter if this is a request to a static file, an AJAX request, a long Comet request or a normal Seaside requestion.

The request context is valid only during the request that caused it. It should not be stored. Neither within instance variables, nor within the execution stack so that it might be captured by a continuation. In both cases this might lead to memory leaks.'!
!WARequestContext categoriesForClass!Unclassified! !
!WARequestContext methodsFor!

charSet
	"Answer the character set to be used for the response.
	First try to take the one from the codec.
	If it is a NullCodec take the one from the handler.
	If there's no handler answer nil."
	| codecName handler |
	codecName := self codec name.
	codecName = GRNullCodec codecName
		ifFalse: [ ^ codecName ].
	handler := self handler.
	self handler isNil
		ifFalse: [ ^ handler charSet ].
	^ nil!

codec
	"Answer the Codec that should be used when preparing strings to be returned in the Response."

	^ codec!

consumer
	"Answer the path consumer."
	
	^ consumer!

destroy
	"Clear references to objects when the receiver is no longer required. This helps avoid circular references and reduces memory consumption. This method is called by the ServerAdaptor after request processing is finished."
	
	self request destroy.
	self response destroy.
	handlers := request := response := codec := properties := nil!

handler
	"Answer the current RequestHandler or nil."

	^ self handlers isEmpty ifFalse: [ self handlers first ]!

handlers
	"Answer an OrderedCollection of RequestHandlers that are processing this request. The list is ordered such that the most recent handler is first in the list."

	^ handlers!

initializeWithRequest: aRequest response: aResponse codec: aCodec
	self initialize.
	handlers := OrderedCollection new.
	request := aRequest.
	response := aResponse.
	codec := aCodec.
	aRequest isNil ifFalse: [
		consumer := WAPathConsumer path: aRequest url path copy ]!

newCookie
	"Create a new cookie. Try to restrict it as much as possible to make stealing it as hard as possible. Some of these restrictions may be too severe for some applications, in which case the sender can relax them."
	
	| cookie baseUrl |
	baseUrl := self handler url.
	cookie := WACookie new
		path: baseUrl pathString;
		httpOnly: true;
		yourself.
	baseUrl host isNil ifFalse: [ cookie domain: baseUrl host ].
	baseUrl scheme = 'https' ifTrue: [ cookie secure: true ].
	(baseUrl port notNil and: [ baseUrl host notNil ]) ifTrue: [ cookie port: baseUrl port ].
	^ cookie!

newDocument
	"Answer a new Document configured to write onto our Response's stream using the
	current Codec. Try to use the Document class specified by the closest Handler
	but fall back on WAHtmlDocument if there is none."
	
	^ ((self handler isNil
		ifTrue: [ WAHtmlDocument ]
		ifFalse: [ self handler documentClass ])
			on: self response stream codec: self codec)
			scriptGenerator: (self handler configuration at: #scriptGeneratorClass) new;
			yourself!

printOn: aStream 
	super printOn: aStream.
	self request isNil 
		ifTrue: [ aStream nextPutAll: ' url: <nil>' ]
		ifFalse: 
			[ aStream
				nextPutAll: ' url: ';
				print: self request url greaseString ]!

properties
	"Answer a dictionary of request-related properties."
	^ properties ifNil: [ properties := GRSmallDictionary new ]!

push: aRequestHandler while: aBlock
	"Push aRequestHandler onto the handler stack while evaluating aBlock."
	
	handlers addFirst: aRequestHandler.
	^ [ WACurrentRequestContext use: self during: aBlock ]
		ensure: [ handlers removeFirst ]!

registry
	"Answer the closest Registry or nil."

	^ handlers 
		detect: [ :each | each isRegistry ]
		ifNone: [ nil ]!

request
	"Answer the current Request object."
	
	^ request!

respond
	"Signal a desire to end request processing and return the current Response to the user agent."
	
	WAResponseNotification signal!

respond: aBlock
	"Evaluate aBlock with the current Response as a parameter and then signal a desire to end request processing and return the Response to the user agent."

	aBlock value: self response.
	self respond!

response
	"Answer the current Response object."
	
	^ response!

responseGenerator
	"Answer a ResponseGenerator as configured in the closest RequestHandler."

	^ (self handler isNil 
		ifTrue: [ WAResponseGenerator ]
		ifFalse: [ self handler responseGenerator ])
			on: self! !
!WARequestContext categoriesFor: #charSet!accessing!public! !
!WARequestContext categoriesFor: #codec!accessing!public! !
!WARequestContext categoriesFor: #consumer!accessing!public! !
!WARequestContext categoriesFor: #destroy!initialization!public! !
!WARequestContext categoriesFor: #handler!accessing-dynamic!public! !
!WARequestContext categoriesFor: #handlers!accessing!public! !
!WARequestContext categoriesFor: #initializeWithRequest:response:codec:!initialization!public! !
!WARequestContext categoriesFor: #newCookie!accessing-dynamic!public! !
!WARequestContext categoriesFor: #newDocument!accessing-dynamic!public! !
!WARequestContext categoriesFor: #printOn:!printing!public! !
!WARequestContext categoriesFor: #properties!accessing!public! !
!WARequestContext categoriesFor: #push:while:!actions!public! !
!WARequestContext categoriesFor: #registry!accessing-dynamic!public! !
!WARequestContext categoriesFor: #request!accessing!public! !
!WARequestContext categoriesFor: #respond!actions!public! !
!WARequestContext categoriesFor: #respond:!actions!public! !
!WARequestContext categoriesFor: #response!accessing!public! !
!WARequestContext categoriesFor: #responseGenerator!accessing-dynamic!public! !

!WARequestContext class methodsFor!

new
	self error: self name , ' has to be instantiated with a request and response object.'!

request: aRequest response: aResponse 
	^ self 
		request: aRequest
		response: aResponse
		codec: GRNullCodec new!

request: aRequest response: aResponse codec: aCodec
	^ self basicNew initializeWithRequest: aRequest response: aResponse codec: aCodec! !
!WARequestContext class categoriesFor: #new!instance creation!public! !
!WARequestContext class categoriesFor: #request:response:!instance creation!public! !
!WARequestContext class categoriesFor: #request:response:codec:!instance creation!public! !

WARequestCookie guid: (GUID fromString: '{65705E0F-3650-414C-A57B-F17C93A2736E}')!
WARequestCookie comment: '
A WARequestCookie is the cookie the user agent sent to the server.

Instance Variables
	domain:		<String>
	key:		<String>
	path:		<String>
	ports:		<Collection<Integer>>
	value:		<String>
	version:		<Integer>

domain
	- xxxxx

key
	- xxxxx

path
	- xxxxx

ports
	- xxxxx

value
	- xxxxx

version
	- the version of the cookie specification supported, currently only 1 is known
'!
!WARequestCookie categoriesForClass!Unclassified! !
!WARequestCookie methodsFor!

= other
	"cookies are identified by the triple name/domain/path"
	^ self species = other species
		and: [ self key = other key
		and: [ self domain = other domain
		and: [ self path = other path ] ] ]!

domain
	^ domain!

domain: aString
	domain := aString!

hash
	"see #="
	^(self key hash
		bitXor: self domain hash)
		bitXor: self path hash!

initializePorts: aString 
	self ports: ((aString greaseSubStrings: ',') collect: [ :each | each greaseInteger ])!

key
	^ key!

key: aString
	key := aString!

path
	^ path ifNil: ['/']!

path: aString
	path := aString!

port: anInteger
	self ports: (Array with: anInteger)!

ports
	^ ports!

ports: aCollection
	ports := aCollection!

postCopy
	super postCopy.
	ports := ports copy!

value
	^ value!

value: aString
	value := aString!

version
	^ version!

version: anInteger
	version := anInteger! !
!WARequestCookie categoriesFor: #=!comparing!public! !
!WARequestCookie categoriesFor: #domain!accessing!public! !
!WARequestCookie categoriesFor: #domain:!accessing!public! !
!WARequestCookie categoriesFor: #hash!comparing!public! !
!WARequestCookie categoriesFor: #initializePorts:!initialization!public! !
!WARequestCookie categoriesFor: #key!accessing!public! !
!WARequestCookie categoriesFor: #key:!accessing!public! !
!WARequestCookie categoriesFor: #path!accessing!public! !
!WARequestCookie categoriesFor: #path:!accessing!public! !
!WARequestCookie categoriesFor: #port:!accessing!public! !
!WARequestCookie categoriesFor: #ports!accessing!public! !
!WARequestCookie categoriesFor: #ports:!accessing!public! !
!WARequestCookie categoriesFor: #postCopy!copying!public! !
!WARequestCookie categoriesFor: #value!accessing!public! !
!WARequestCookie categoriesFor: #value:!accessing!public! !
!WARequestCookie categoriesFor: #version!accessing!public! !
!WARequestCookie categoriesFor: #version:!accessing!public! !

!WARequestCookie class methodsFor!

actions
	^Dictionary new
		at: '$Domain' put: [ :cookie :value | cookie domain: value ];
		at: '$Path' put: [ :cookie :value | cookie path: value ];
		at: '$Port' put: [ :cookie :value | cookie initializePorts: value ];
		yourself!

fromString: aString 
	"Creates an array of cookies from a HTTP Cookie: header value."
	| version tokens cookieLine current |
	cookieLine := aString.
	aString isEmptyOrNil ifTrue: 
		[ ^ #() ].
	tokens := cookieLine greaseSubStrings: ';'.
	current := nil.
	^ Array streamContents: 
		[ :cookies | 
		tokens do: 
			[ :each | 
			| key value action |
			key := self keyFrom: each.
			value := self valueFrom: each.
			key = '$Version' 
				ifTrue: [ version := value greaseInteger ]
				ifFalse: 
					[ action := self actions 
						at: key
						ifAbsent: [ nil ].
					action isNil 
						ifTrue: 
							[ current := self 
								key: key
								value: value.
							current version: version.
							cookies nextPut: current ]
						ifFalse: 
							[ action 
								value: current
								value: value ] ] ] ]!

key: keyString value: valueString
	^ self new
		key: keyString;
		value: valueString;
		yourself!

keyFrom: aString
	^(aString copyUpTo: $=) trimBoth!

trimBlanksAndQuotes: aString
	| trimmed |
	trimmed := aString trimBoth.
	^(trimmed size > 2
		and: [ trimmed first = $"
		and: [ trimmed last = $" ] ])
			ifTrue: [ trimmed copyFrom: 2 to: trimmed size - 1 ]
			ifFalse: [ trimmed ]!

valueFrom: aString
	^(aString includes: $=)
		ifTrue: [ self trimBlanksAndQuotes: (aString copyAfter: $=) ]! !
!WARequestCookie class categoriesFor: #actions!accessing!public! !
!WARequestCookie class categoriesFor: #fromString:!instance creation!public! !
!WARequestCookie class categoriesFor: #key:value:!instance creation!public! !
!WARequestCookie class categoriesFor: #keyFrom:!private! !
!WARequestCookie class categoriesFor: #trimBlanksAndQuotes:!private! !
!WARequestCookie class categoriesFor: #valueFrom:!private! !

WARequestFilter guid: (GUID fromString: '{C9F14374-0B0D-42BA-A779-FFB236E99929}')!
WARequestFilter comment: ''!
!WARequestFilter categoriesForClass!Unclassified! !
!WARequestFilter methodsFor!

copyTo: aRequestHandler
	^ self copy setNext: (self next copyTo: aRequestHandler)!

handleFiltered: aRequestContext 
	"Pass on the aRequestContext to the next filter or handler. Subclasses might override this method to customize the request and response handling."
	
	self next handleFiltered: aRequestContext!

handler
	"Answer the owning request handler."

	^ self next handler!

initialize
	super initialize.
	next := WAValueHolder new!

isExceptionFilter
	^ false!

next
	"Answer the next filter or request handler."
	
	^ next contents!

postCopy
	super postCopy.
	next := next copy!

setNext: aFilter
	next contents: aFilter! !
!WARequestFilter categoriesFor: #copyTo:!copying!public! !
!WARequestFilter categoriesFor: #handleFiltered:!processing!public! !
!WARequestFilter categoriesFor: #handler!accessing!public! !
!WARequestFilter categoriesFor: #initialize!initialization!public! !
!WARequestFilter categoriesFor: #isExceptionFilter!public!testing! !
!WARequestFilter categoriesFor: #next!accessing!public! !
!WARequestFilter categoriesFor: #postCopy!copying!public! !
!WARequestFilter categoriesFor: #setNext:!initialization!public! !

WARequestHandler guid: (GUID fromString: '{02C7E470-AD2B-44E3-9FB2-BAB11B2BE980}')!
WARequestHandler comment: '
WARequestHandler is an abstract class whose subclasses handle http requests. Most of the methods are either empty or return a default value. 

Subclasses must implement the following messages:
	handleFiltered:	process the request

'!
!WARequestHandler categoriesForClass!Unclassified! !
!WARequestHandler methodsFor!

addFilter: aFilter
	"Add aFilter to the receiver. Answer the filter added."

	^ self addFilterLast: aFilter!

addFilterFirst: aFilter
	"Add aFilter as the first one in the filter chain. Answer the filter added."

	aFilter setNext: self filter.
	self setFilter: aFilter.
	^ aFilter!

addFilterLast: aFilter
	"Add aFilter as the last one in the filter chain. Answer the filter added."

	| previous current |
	previous := nil.
	current := self filter.
	[ current = self ] whileFalse: [
		previous := current.
		current := current next ].
	aFilter setNext: current.
	previous isNil
		ifTrue: [ self setFilter: aFilter ]
		ifFalse: [ previous setNext: aFilter ].
	^ aFilter!

authConfigurationError: aString
	WAAuthConfigurationError signal: aString!

basePath
	self greaseDeprecatedApi: 'WARequestHandler>>#basePath'
		details: 'Use WARequestHandler>>#url to get a WAUrl object and then #pathString if you want th path.'.
	^ self url pathString!

baseUrl
	self greaseDeprecatedApi: 'WARequestHandler>>#baseUrl'
		details: 'Use WARequestHandler>>#url.'.
	
	^ self url!

basicUrl
	^ self isRoot
		ifTrue: [ WAUrl new ]
		ifFalse: [ self parent urlFor: self ]!

charSet
	^ self preferenceAt: #charSet!

childrenDo: aBlock
	"Request handlers that act as containers should implement this method to
	iterate over all child handlers and pass each into aBlock."!

configuration
	^ configuration!

configuration: aConfiguration
	configuration := aConfiguration!

copyTo: aRequestHandler
	^ aRequestHandler!

defaultConfiguration
	^ WAUserConfiguration new
		addParent: WARequestHandlingConfiguration instance;
		yourself!

description
	self 
		greaseDeprecatedApi: 'WARequestHandler>>#description'
		details: 'Use WARequestHandler class>>#description.'.
	^ self class description!

documentClass
	^ self preferenceAt: #documentClass!

exceptionHandler: anExceptionHandlerClass
	| theFilter |
	theFilter := self filters
		detect: [ :ea | ea isExceptionFilter ]
		ifNone: [ self addFilter: WAExceptionFilter new ].
	
	theFilter configuration at: #exceptionHandler put: anExceptionHandlerClass!

filter
	^ filter contents!

filters
	"Answer an ordered colleciton of all filters active in the receiver."
	
	| current result |
	current := self filter.
	result := OrderedCollection new.
	[ current = self ] whileFalse: [
		result add: current.
		current := current next ].
	^ result!

handle: aRequestContext
	"Handle a request described by aRequestContext. Do not override this method; instead subclass #handleFiltered: to allow filters to process the request first."

	aRequestContext push: self while: [ self filter handleFiltered: aRequestContext ]!

handleFiltered: aRequestContext 
	"Handle aRequestContext by either dispatching to a different request handler of by producing a response and singalling the result."

	self subclassResponsibility!

handler
	^ self!

initialize
	super initialize.
	configuration := self defaultConfiguration.
	filter := WAValueHolder with: self!

isDispatcher
	^ false!

isRegistry
	^ false!

isRoot
	^ self parent isNil!

name
	^ self isRoot
		ifTrue: [ '' ]
		ifFalse: [ self parent nameOfHandler: self ]!

parent
	^ parent!

parentChildPairsDo: aTwoArgumentBlock
	"Evaluate the given two argument block for all the direct parent-child handler pairs in the handler chain up the receiver."
	self parent isNil ifFalse: [
		self parent parentChildPairsDo: aTwoArgumentBlock.
		aTwoArgumentBlock value: self parent value: self ].!

postCopy
	super postCopy.
	filter := filter copy.
	self setFilter: (self filter copyTo: self).
	configuration := configuration copy.
	parent := nil!

preferenceAt: aSymbol
	^ self configuration at: aSymbol!

preferenceAt: aSymbol put: anObject
	anObject isNil
		ifTrue: [ self configuration removeExpressionAt: aSymbol ]
		ifFalse: [ self configuration at: aSymbol put: anObject ].
	
	^ anObject!

removeFilter: aFilter
	"Remove aFilter from the receiver. Answer the removed filter or nil."

	| previous current |
	previous := nil.
	current := self filter.
	[ current = self ] whileFalse: [
		current = aFilter ifTrue: [
			previous isNil
				ifTrue: [ self setFilter: current next ]
				ifFalse: [ previous setNext: current next ].
			^ aFilter setNext: nil ].
		previous := current.
		current := current next ].
	^ nil!

responseGenerator
	^ self preferenceAt: #responseGenerator!

serverHostname
	^ self preferenceAt: #serverHostname!

serverHostname: aString
	self preferenceAt: #serverHostname put: aString!

serverPath
	^ self preferenceAt: #serverPath!

serverPath: aString
	self preferenceAt: #serverPath put: aString!

serverPort
	^ self preferenceAt: #serverPort!

serverPort: anInteger
	self preferenceAt: #serverPort put: anInteger!

serverProtocol
	^ self preferenceAt: #serverProtocol!

serverProtocol: aSymbol
	self preferenceAt: #serverProtocol put: aSymbol!

setFilter: aFilter
	filter contents: aFilter!

setParent: aRequestHandler
	parent notNil ifTrue: [ parent unregister: self ].
	parent := aRequestHandler!

unregister
	"Unregister this request handler from its parent handler."
	
	parent notNil ifTrue: [ parent unregister: self ]!

unregister: aRequestHandler
	"Request handlers that act as containers should implement this method to
	remove aRequestHandler from their collections and send #unregistered to
	aRequestHandler. This method is also called by #setParent:."!

unregistered
	"This method is called to notify a RequestHandler that it has been removed
	from its container. Subclasses should override to perfrom cleanup actions."
	parent := nil!

url
	| url |
	
	url := self basicUrl.
	self serverPath isNil ifFalse: [ url parsePath: self serverPath ].
	self serverProtocol isNil ifFalse: [ url scheme: self serverProtocol ].
	self serverHostname isNil ifFalse: [ url host: self serverHostname ].
	self serverPort isNil ifFalse: [ url port: self serverPort ].

	^ url!

urlFor: aRequestHandler
	"Return the URL for the given request handler, which should be a
	child of the receiver. The default implementation simply returns the
	receiver's URL, but subclasses should override to add a relevant
	paramter or path segment that identifies the particular chid."

	^ self url!

verifyPassword: password forUser: username 
	"This method is called by WAAuthMain to verify the username provided
	in the HTTP request. The default implementation compares them against
	the configuration values provided by WAAuthConfiguration. WAAuthMain
	can also be used by itself if you implement this method in your
	own Application subclass to do something different."
	| loginPref hashPref |
	loginPref := self preferenceAt: #login.
	hashPref := self preferenceAt: #passwordHash.
	loginPref ifNil: 
		[ self authConfigurationError: 'Login not defined. The default authentication method requires a WAAuthConfiguration' ].
	hashPref ifNil: 
		[ self authConfigurationError: 'Password not defined. The default authentication method requires a WAAuthConfiguration' ].
	(username isEmptyOrNil or: [ password isEmptyOrNil ]) ifTrue: [ ^ false ].
	^ loginPref = username and: [ hashPref = (GRPlatform current secureHashFor: password) ]!

withDescendantsDo: aBlock
	"Evaluate aBlock for this request handler and recursively for each of
	its child handlers."
	
	aBlock value: self.
	self childrenDo: [ :each | each withDescendantsDo: aBlock ]! !
!WARequestHandler categoriesFor: #addFilter:!filters!public! !
!WARequestHandler categoriesFor: #addFilterFirst:!filters!public! !
!WARequestHandler categoriesFor: #addFilterLast:!filters!public! !
!WARequestHandler categoriesFor: #authConfigurationError:!private! !
!WARequestHandler categoriesFor: #basePath!public! !
!WARequestHandler categoriesFor: #baseUrl!public! !
!WARequestHandler categoriesFor: #basicUrl!private! !
!WARequestHandler categoriesFor: #charSet!configuration!public! !
!WARequestHandler categoriesFor: #childrenDo:!parent/child!public! !
!WARequestHandler categoriesFor: #configuration!configuration!public! !
!WARequestHandler categoriesFor: #configuration:!configuration!public! !
!WARequestHandler categoriesFor: #copyTo:!copying!public! !
!WARequestHandler categoriesFor: #defaultConfiguration!configuration!public! !
!WARequestHandler categoriesFor: #description!public! !
!WARequestHandler categoriesFor: #documentClass!configuration!public! !
!WARequestHandler categoriesFor: #exceptionHandler:!filters-convenience!public! !
!WARequestHandler categoriesFor: #filter!private-accessing!public! !
!WARequestHandler categoriesFor: #filters!filters!public! !
!WARequestHandler categoriesFor: #handle:!handling!public! !
!WARequestHandler categoriesFor: #handleFiltered:!handling!public! !
!WARequestHandler categoriesFor: #handler!filters!public! !
!WARequestHandler categoriesFor: #initialize!initialization!public! !
!WARequestHandler categoriesFor: #isDispatcher!public!testing! !
!WARequestHandler categoriesFor: #isRegistry!public!testing! !
!WARequestHandler categoriesFor: #isRoot!public!testing! !
!WARequestHandler categoriesFor: #name!accessing!public! !
!WARequestHandler categoriesFor: #parent!accessing!public! !
!WARequestHandler categoriesFor: #parentChildPairsDo:!enumerating!public! !
!WARequestHandler categoriesFor: #postCopy!copying!public! !
!WARequestHandler categoriesFor: #preferenceAt:!configuration!public! !
!WARequestHandler categoriesFor: #preferenceAt:put:!configuration!public! !
!WARequestHandler categoriesFor: #removeFilter:!filters!public! !
!WARequestHandler categoriesFor: #responseGenerator!configuration!public! !
!WARequestHandler categoriesFor: #serverHostname!configuration!public! !
!WARequestHandler categoriesFor: #serverHostname:!configuration!public! !
!WARequestHandler categoriesFor: #serverPath!configuration!public! !
!WARequestHandler categoriesFor: #serverPath:!configuration!public! !
!WARequestHandler categoriesFor: #serverPort!configuration!public! !
!WARequestHandler categoriesFor: #serverPort:!configuration!public! !
!WARequestHandler categoriesFor: #serverProtocol!configuration!public! !
!WARequestHandler categoriesFor: #serverProtocol:!configuration!public! !
!WARequestHandler categoriesFor: #setFilter:!private-accessing!public! !
!WARequestHandler categoriesFor: #setParent:!parent/child!public! !
!WARequestHandler categoriesFor: #unregister!parent/child!public! !
!WARequestHandler categoriesFor: #unregister:!parent/child!public! !
!WARequestHandler categoriesFor: #unregistered!parent/child!public! !
!WARequestHandler categoriesFor: #url!accessing!public! !
!WARequestHandler categoriesFor: #urlFor:!accessing!public! !
!WARequestHandler categoriesFor: #verifyPassword:forUser:!authentication!public! !
!WARequestHandler categoriesFor: #withDescendantsDo:!parent/child!public! !

!WARequestHandler class methodsFor!

concreteSubclasses
	^ self allSubclasses reject: [ :each | each isAbstract ]!

description
	^ self name greaseString!

isAbstract
	^ self name = #WARequestHandler! !
!WARequestHandler class categoriesFor: #concreteSubclasses!accessing!public! !
!WARequestHandler class categoriesFor: #description!accessing!public! !
!WARequestHandler class categoriesFor: #isAbstract!public!testing! !

WAResponse guid: (GUID fromString: '{805D87F2-3201-440E-9B24-667BBDD7216C}')!
WAResponse comment: '
A WAResponse is an abstract HTTP response objects. It is independent of the used server adapter.

Instance Variables
	status:		<Integer> The HTTP status code.
	message:	<String> The HTTP status message.
	headers:	<WAHeaderFileds> A dictionary with the header fields.
	cookies:		<OrderedCollection> A collection of cookies.
'!
!WAResponse categoriesForClass!Unclassified! !
!WAResponse methodsFor!

addCookie: aCookie
	"Add the cookie aCookies to the receiver."

	^ self cookies add: aCookie!

attachmentWithFileName: aString 
	aString notNil ifTrue: 
		[ self 
			headerAt: 'Content-Disposition'
			put: 'attachment; filename="' , aString greaseString , '"' ]!

authenticationFailed
	"Indicate that the request requires HTTP authentication."
	
	self status: 401!

badRequest
	"The request could not be understood by the server due to malformed syntax. The client SHOULD NOT repeat the request without modifications."
	
	self status: 400!

basicAuthenticationRealm: aString 
	self 
		headerAt: 'WWW-Authenticate'
		put: 'Basic realm="' , aString greaseString , '"'.
	self authenticationFailed!

binary
	"put the response stream into binary mode"
	
	self subclassResponsibility!

cacheFor: aDuration
	"Configure the receiver to be cached for aDuration."

	self removeHeaderAt: 'Pragma'. "Proxies"
	self headerAt: 'Expires' putDate: DateAndTime now + aDuration. "HTTP 1.0"
	self headerAt: 'Cache-Control' put: 'max-age=' , aDuration asSeconds printString. "HTTP 1.1"!

cacheForever
	"Configure the response to be cached by user agents."
	
	self removeHeaderAt: 'Pragma'. "Proxies"
	self headerAt: 'Expires' putDate: self cacheForeverExpiryDate. "HTTP 1.0"
	self removeHeaderAt: 'Cache-Control'. "HTTP 1.1"!

cacheForeverExpiryDate
	"Answer the expiry date that should be used if the response should be cached forever.
	
	Note that according to HTTP 1.1 says: To mark a response as 'never expires,' an origin server sends an Expires date approximately one year from the time the response is sent. HTTP/1.1 servers SHOULD NOT send Expires dates more than one year in the future."
	
	^ (DateAndTime now) + (Duration days: 300 hours: 0 minutes: 0 seconds: 0)!

contentType
	^ self headerAt: 'Content-Type' ifAbsent: [ WAMimeType textPlain ]!

contentType: aMimeType
	self headerAt: 'Content-Type' put: aMimeType!

cookies
	"Answer the cookies of this response."

	^ cookies!

created
	"The request has been fulfilled and resulted in a new resource being created."
	
	self status: 201!

deleteCookie: aCookie 
	"Try to get the path from the closest entry point in the context. This path
	is used in case the browser did not provide the path information in the cookie.
	Trouble is, this method may be called in a context where WACurrentRequestContext
	is not defined or where there is no RequestHandler. In this case, we just use nil and
	pray the cookie has path information or was created without any."
	
	| baseUrl |
	baseUrl := [ self requestContext handler url ] 
		on: WARequestContextNotFound
		do: [ :err | nil ].
	self 
		deleteCookie: aCookie
		path: (baseUrl isNil ifFalse: [ baseUrl pathString ])
		domain: (baseUrl isNil ifFalse: [ baseUrl host ])!

deleteCookie: aCookie path: aPathString domain: aDomainString
	"Delete the cookie in the browser.
	
	The spec sez:
	If a CGI script wishes to delete a cookie, it can do so by returning a cookie with the same name, and an expires time which is in the past. The path and name must match exactly in order for the expiring cookie to replace the valid cookie. This requirement makes it difficult for anyone but the originator of a cookie to delete a cookie.
	
	What is not specified but also has to match is the domain.
	
	The trouble is:
	Browsers that follow the Netscape spec don't send path or domain information"
	| copy |
	copy := (WACookie 
		key: aCookie key
		value: '')
		path: aCookie path;
		version: aCookie version;
		domain: aCookie domain;
		yourself.
	aCookie version isNil ifTrue:  [
		"old Netscape cookie with no path or domain information"
		aPathString isNil ifFalse: [ 
			copy path: aPathString ].
		aDomainString isNil ifFalse: [
			copy domain: aDomainString ] ].
	copy expireInPast.
	self addCookie: copy!

deleteCookieAt: aKeyString
	"Delete the cookie in the browser. This method is quite unrelyable. Consider using #deleteCookie:"
	self deleteCookie: (WARequestCookie key: aKeyString value: '')!

destroy
	headers := cookies := nil!

document: aDocument
	| document mimeType |
	document := aDocument seasideMimeDocument.
	self attachmentWithFileName: document fileName.
	mimeType := document mimeType.
	self contentType: mimeType.
	mimeType isBinary
		ifTrue: [ self binary ].
	self nextPutAll: document content!

document: anObject mimeType: aMimeType
	self document: (anObject seasideMimeDocument 
		mimeType: aMimeType;
		yourself)!

document: anObject mimeType: aMimeType fileName: aString
	self document: (anObject seasideMimeDocument 
		mimeType: aMimeType;
		fileName: aString;
		yourself)!

doNotCache
	"Configure the receiver to not be cached at all."
	
	self headerAt: 'Pragma' put: 'no-cache'. "Proxies"
	self headerAt: 'Expires' putDate: self doNotCacheExpiryDate. "HTTP 1.0"
	self headerAt: 'Cache-Control' put: 'no-cache, must-revalidate'. "HTTP 1.1"
	!

doNotCacheExpiryDate
	"Answer the expiry date that should be used if the response should not be cached at all."
	
	^ DateAndTime year: 2000 month: 1 day: 1 hour: 0 minute: 0 second: 0!

forbidden
	"Indicate that the server understood the request but refused to fulfill it."
	
	self status: 403!

found
	"Indicate that the resource reside temporarily under a different URI."
	
	self status: 302!

gone
	"Indicate that the resource is no longer available at the server and no forwarding address is known."
	
	self status: 410!

headerAt: aString
	"Answer the header with aString."
	
	^ self headers at: aString!

headerAt: aString append: aValue 
	"Appends a response header with aString and aValue. This method allows response headers to have multiple values."
	^ self headers 
		at: aString
		add: aValue greaseString!

headerAt: aString ifAbsent: aBlock
	"Answer the header with aString, if none answer the result of evaluating aBlock."
	
	^ self headers at: aString ifAbsent: aBlock!

headerAt: aString put: aValue
	"Set a response header with aString and aValue. If the header had already been set, the new value overwrites the previous one."
	
	^ self headers at: aString put: aValue!

headerAt: aKeyString putDate: aDateAndTime 
	"Convenience method that sets a response header with aString and aDateAndTime. If the header had already been set, the new value overwrites the previous one."
	^ self 
		headerAt: aKeyString
		put: (GRPrinter httpDate print: aDateAndTime)!

headers
	"Answer the headers of this response."
	
	^ headers!

httpVersion
	"Answer the HTTP version to be used."

	^ 'HTTP/1.1'!

initialize
	super initialize.
	status := 200.
	message := 'OK'.
	headers := WAHeaderFields new.
	cookies := OrderedCollection new!

initializeOn: aStream 
	self initialize!

inlineWithFileName: aString 
	aString notNil ifTrue: 
		[ self 
			headerAt: 'Content-Disposition'
			put: 'inline; filename="' , aString greaseString , '"' ]!

internalError
	"Indicate an error inside the server which prevented it from fulfilling the request."

	self status: 500!

isCommitted
	"Answer a boolean indicating if the response header has been committed."
	
	^ false!

location: aUrlOrString 
	self 
		headerAt: 'Location'
		put: aUrlOrString greaseString!

message
	"Answer the message associated with this response."

	^ message!

movedPermanently
	"The requested resource has been assigned a new permanent URI and any future references to this resource SHOULD use one of the returned URIs."
	
	self status: 301!

nextPutAll: aStringOrByteArray
	"Append the elements of aCollection to the body part of the response."
	
	self stream nextPutAll: aStringOrByteArray!

notFound
	"Indicate that the requested resource is not available."
	
	self status: 404!

notImplemented
	"Indicate the HTTP server does not support the functionality needed to fulfill the request."
	
	self status: 501!

preconditionFailed
	"The precondition given in one or more of the request-header fields evaluated to false when it was tested on the server. This response code allows the client to place preconditions on the current resource metainformation (header field data) and thus prevent the requested method from being applied to a resource other than the one intended."
	
	self status: 412!

printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: ' status: '; print: self status.
	aStream nextPutAll: ' message: '; print: self message!

redirectTo: aUrlOrString
	self location: aUrlOrString.
	self found!

refreshAfter: aDuration location: aUrl 
	self 
		headerAt: 'Refresh'
		put: aDuration asSeconds greaseString , '; ' , aUrl greaseString!

removeHeaderAt: aString
	"Removes all occurences of the header value aString."

	^ self headers removeKey: aString!

respond
	WAResponseNotification signal!

status
	"Answer the status code associated with this response."

	^ status!

status: aNumber
	"Set the status to aNumber and associate the default message."

	self status: aNumber message: (self class messageForStatus: aNumber)!

status: aNumber message: aString
	"Set the status to aNumber and the message to aString."
	
	status := aNumber.
	message := aString!

stream
	"Answer a write stream, this is where contents should be written to."
	
	self subclassResponsibility!

writeContentOn: aStream
	self subclassResponsibility!

writeCookiesOn: aStream
	cookies do: [ :each | 
		aStream nextPutAll: 'Set-Cookie: '.
		each writeOn: aStream.
		aStream crlf ]!

writeHeadersOn: aStream 
	headers keysAndValuesDo: 
		[ :key :value | 
		aStream
			nextPutAll: key;
			nextPutAll: ': ';
			nextPutAll: value greaseString;
			crlf ]!

writeOn: aStream
	self writeStatusOn: aStream.
	self writeHeadersOn: aStream.
	self writeCookiesOn: aStream.
	aStream crlf.
	self writeContentOn: aStream!

writeStatusOn: aStream 
	aStream nextPutAll: self httpVersion.
	aStream
		nextPut: $ ;
		nextPutAll: self status greaseString.
	self message isNil ifFalse: 
		[ aStream
			nextPut: $ ;
			nextPutAll: self message ].
	aStream crlf! !
!WAResponse categoriesFor: #addCookie:!accessing-cookies!public! !
!WAResponse categoriesFor: #attachmentWithFileName:!convenience-headers!public! !
!WAResponse categoriesFor: #authenticationFailed!public!status! !
!WAResponse categoriesFor: #badRequest!public!status! !
!WAResponse categoriesFor: #basicAuthenticationRealm:!convenience-status!public! !
!WAResponse categoriesFor: #binary!public!streaming! !
!WAResponse categoriesFor: #cacheFor:!convenience-caching!public! !
!WAResponse categoriesFor: #cacheForever!convenience-caching!public! !
!WAResponse categoriesFor: #cacheForeverExpiryDate!configuration!public! !
!WAResponse categoriesFor: #contentType!convenience-accessing!public! !
!WAResponse categoriesFor: #contentType:!convenience-accessing!public! !
!WAResponse categoriesFor: #cookies!accessing!public! !
!WAResponse categoriesFor: #created!public!status! !
!WAResponse categoriesFor: #deleteCookie:!accessing-cookies!public! !
!WAResponse categoriesFor: #deleteCookie:path:domain:!accessing-cookies!public! !
!WAResponse categoriesFor: #deleteCookieAt:!accessing-cookies!public! !
!WAResponse categoriesFor: #destroy!initialization!public! !
!WAResponse categoriesFor: #document:!documents!public! !
!WAResponse categoriesFor: #document:mimeType:!documents!public! !
!WAResponse categoriesFor: #document:mimeType:fileName:!documents!public! !
!WAResponse categoriesFor: #doNotCache!convenience-caching!public! !
!WAResponse categoriesFor: #doNotCacheExpiryDate!configuration!public! !
!WAResponse categoriesFor: #forbidden!public!status! !
!WAResponse categoriesFor: #found!public!status! !
!WAResponse categoriesFor: #gone!public!status! !
!WAResponse categoriesFor: #headerAt:!accessing-headers!public! !
!WAResponse categoriesFor: #headerAt:append:!accessing-headers!public! !
!WAResponse categoriesFor: #headerAt:ifAbsent:!accessing-headers!public! !
!WAResponse categoriesFor: #headerAt:put:!accessing-headers!public! !
!WAResponse categoriesFor: #headerAt:putDate:!accessing-headers!public! !
!WAResponse categoriesFor: #headers!accessing!public! !
!WAResponse categoriesFor: #httpVersion!configuration!public! !
!WAResponse categoriesFor: #initialize!initialization!public! !
!WAResponse categoriesFor: #initializeOn:!initialization!public! !
!WAResponse categoriesFor: #inlineWithFileName:!convenience-headers!public! !
!WAResponse categoriesFor: #internalError!public!status! !
!WAResponse categoriesFor: #isCommitted!public!testing! !
!WAResponse categoriesFor: #location:!convenience-headers!public! !
!WAResponse categoriesFor: #message!accessing!public! !
!WAResponse categoriesFor: #movedPermanently!public!status! !
!WAResponse categoriesFor: #nextPutAll:!public!streaming! !
!WAResponse categoriesFor: #notFound!public!status! !
!WAResponse categoriesFor: #notImplemented!public!status! !
!WAResponse categoriesFor: #preconditionFailed!public!status! !
!WAResponse categoriesFor: #printOn:!printing!public! !
!WAResponse categoriesFor: #redirectTo:!convenience-status!public! !
!WAResponse categoriesFor: #refreshAfter:location:!convenience-status!public! !
!WAResponse categoriesFor: #removeHeaderAt:!accessing-headers!public! !
!WAResponse categoriesFor: #respond!convenience!public! !
!WAResponse categoriesFor: #status!accessing!public! !
!WAResponse categoriesFor: #status:!accessing-status!public! !
!WAResponse categoriesFor: #status:message:!accessing-status!public! !
!WAResponse categoriesFor: #stream!accessing!public! !
!WAResponse categoriesFor: #writeContentOn:!public!writing! !
!WAResponse categoriesFor: #writeCookiesOn:!public!writing! !
!WAResponse categoriesFor: #writeHeadersOn:!public!writing! !
!WAResponse categoriesFor: #writeOn:!public!writing! !
!WAResponse categoriesFor: #writeStatusOn:!public!writing! !

!WAResponse class methodsFor!

initialize
	self initializeStatusMessages!

initializeStatusMessages
	StatusMessages := Dictionary new.
	StatusMessages
		at: 100 put: 'Continue';
		at: 101 put: 'Switching Protocols';
		at: 102 put: 'Processing';
		at: 200 put: 'OK';
		at: 201 put: 'Created';
		at: 202 put: 'Accepted';
		at: 203 put: 'Non-Authoritative Information';
		at: 204 put: 'No Content';
		at: 205 put: 'Reset Content';
		at: 206 put: 'Partial Content';
		at: 207 put: 'Multi-Status';
		at: 300 put: 'Multiple Choices';
		at: 301 put: 'Moved Permanently';
		at: 302 put: 'Found';
		at: 303 put: 'See Other';
		at: 304 put: 'Not Modified';
		at: 305 put: 'Use Proxy';
		at: 307 put: 'Temporary Redirect';
		at: 400 put: 'Bad Request';
		at: 401 put: 'Unauthorized';
		at: 402 put: 'Payment Required';
		at: 403 put: 'Forbidden';
		at: 404 put: 'Not Found';
		at: 405 put: 'Method Not Allowed';
		at: 406 put: 'Not Acceptable';
		at: 407 put: 'Proxy Authentication Required';
		at: 408 put: 'Request Timeout';
		at: 409 put: 'Conflict';
		at: 410 put: 'Gone';
		at: 411 put: 'Length Required';
		at: 412 put: 'Precondition Failed';
		at: 413 put: 'Request Entity Too Large';
		at: 414 put: 'Request-URI Too Long';
		at: 415 put: 'Unsupported Media Type';
		at: 416 put: 'Requested Range Not Satisfiable';
		at: 417 put: 'Expectation Failed';
		at: 418 put: 'I''m a teapot';
		at: 422 put: 'Unprocessable Entity';
		at: 423 put: 'Locked';
		at: 424 put: 'Failed Dependency';
		at: 500 put: 'Internal Server Error';
		at: 501 put: 'Not Implemented';
		at: 502 put: 'Bad Gateway';
		at: 503 put: 'Service Unavailable';
		at: 504 put: 'Gateway Timeout';
		at: 505 put: 'HTTP Version Not Supported';
		at: 507 put: 'Insufficient Storage'!

messageForStatus: anInteger
	^ StatusMessages at: anInteger ifAbsent: [ nil ]! !
!WAResponse class categoriesFor: #initialize!initialization!public! !
!WAResponse class categoriesFor: #initializeStatusMessages!initialization!public! !
!WAResponse class categoriesFor: #messageForStatus:!accessing!public! !

WAResponseGenerator guid: (GUID fromString: '{B534A669-4A46-4958-9E46-2A34B3427103}')!
WAResponseGenerator comment: 'The response generator configures the response of the provided request context according to the called generation method. This class can be subclassed to provide custom response templates.'!
!WAResponseGenerator categoriesForClass!Unclassified! !
!WAResponseGenerator methodsFor!

authenticate: aString
	"Asks for authentication to the domain aString."

	self response basicAuthenticationRealm: aString!

expiredRegistryKey
	"The session key has expired, redirect the request to the home directory preserving the path as good as possible."

	| url |
	self request isXmlHttpRequest
		ifTrue: [ ^ self forbidden ].
	url := self requestContext registry url.
	url addAllToPath: self requestContext consumer upToEnd.
	self request fields keysAndValuesDo: [ :key :value |
		(url isSeasideField: key) 
			ifFalse: [ url addField: key value: value ] ].
	self response redirectTo: url!

forbidden
	"The resource is forbidden to access and the request was not processed."
	self response
		forbidden;
		contentType: WAMimeType textPlain;
		nextPutAll: 'Error: you are forbidden to access "';
		nextPutAll: self request url pathString;
		nextPutAll: '"'!

initializeOn: aRequestContext
	self initialize.
	requestContext := aRequestContext!

internalError: anException
	"An internal error occured while processing the request."

	self response 
		internalError;
		contentType: WAMimeType textPlain;
		nextPutAll: 'Internal Error: ';
		nextPutAll: (anException messageText ifNil: [ String new ])!

notFound
	"The resource could not be found and the request processing was aborted."
	self response
		notFound;
		contentType: WAMimeType textPlain;
		nextPutAll: self request url pathString;
		nextPutAll: ' not found'!

notImplemented
	"The functionality requested is not implemented and the request processing was aborted."

	self response 
		notImplemented;
		contentType: WAMimeType textPlain;
		nextPutAll: 'Not Implemented'!

pageExpired
	"The page is no longer in the cache and the request could not be processed."

	self response
		doNotCache;
		contentType: WAMimeType textPlain;
		nextPutAll: 'This page has expired, please use the back-button to navigate to the last valid page.'!

redirectTo: aUrlOrString
	"Redirect to a new location."
	
	self response redirectTo: aUrlOrString!

refreshAfter: aDuration location: aUrl message: aString 
	"Show aString for aDuration, then redirect to aUrl."
	self response
		contentType: WAMimeType textPlain;
		refreshAfter: aDuration
			location: aUrl
			message: aString , (String with: Character cr) , 'You are being redirected to ' , aUrl greaseString!

request
	"Answer the current request."

	^ self requestContext request!

requestContext
	"Answer the current request context."

	^ requestContext!

respond
	"Tell the current request context to return the response."

	self requestContext respond!

response
	"Answer the current response."

	^ self requestContext response! !
!WAResponseGenerator categoriesFor: #authenticate:!generation!public! !
!WAResponseGenerator categoriesFor: #expiredRegistryKey!generation!public! !
!WAResponseGenerator categoriesFor: #forbidden!generation!public! !
!WAResponseGenerator categoriesFor: #initializeOn:!initialization!public! !
!WAResponseGenerator categoriesFor: #internalError:!generation!public! !
!WAResponseGenerator categoriesFor: #notFound!generation!public! !
!WAResponseGenerator categoriesFor: #notImplemented!generation!public! !
!WAResponseGenerator categoriesFor: #pageExpired!generation!public! !
!WAResponseGenerator categoriesFor: #redirectTo:!generation!public! !
!WAResponseGenerator categoriesFor: #refreshAfter:location:message:!generation!public! !
!WAResponseGenerator categoriesFor: #request!accessing!public! !
!WAResponseGenerator categoriesFor: #requestContext!accessing!public! !
!WAResponseGenerator categoriesFor: #respond!actions!public! !
!WAResponseGenerator categoriesFor: #response!accessing!public! !

!WAResponseGenerator class methodsFor!

on: aRequestContext
	^ self basicNew initializeOn: aRequestContext! !
!WAResponseGenerator class categoriesFor: #on:!instance creation!public! !

WARoot guid: (GUID fromString: '{D73AEB19-692B-4E28-9529-98B018342896}')!
WARoot comment: 'A WARoot is the root of a document. It is responsible to generate header and footer of a document.'!
!WARoot categoriesForClass!Unclassified! !
!WARoot methodsFor!

absoluteUrlForResource: aString
	^ self context absoluteUrlForResource: aString!

closeOn: aDocument
	"Close aDocument and optionally write its footer."!

context
	^ context!

openOn: aDocument
	"Open aDocument and optionally write its header."!

setContext: aRenderContext
	context := aRenderContext! !
!WARoot categoriesFor: #absoluteUrlForResource:!accessing!public! !
!WARoot categoriesFor: #closeOn:!public!writing! !
!WARoot categoriesFor: #context!accessing!public! !
!WARoot categoriesFor: #openOn:!public!writing! !
!WARoot categoriesFor: #setContext:!initialization!public! !

!WARoot class methodsFor!

context: aRenderContext
	^ self new setContext: aRenderContext! !
!WARoot class categoriesFor: #context:!instance creation!public! !

WAScriptGenerator guid: (GUID fromString: '{B14F0B1A-7FA8-4996-A475-2C5CD9C64922}')!
WAScriptGenerator comment: ''!
!WAScriptGenerator categoriesForClass!Unclassified! !
!WAScriptGenerator methodsFor!

addLoadScript: anObject
	"Add a script anObject to the receiver. This method ensures all scripts to run in the added order when the DOM is ready. Note that the default implementation calls the scripts when the page has finished loading."
	
	^ loadScripts addLast: anObject!

addLoadScriptFirst: anObject
	"Add a script anObject at the beginning of the load scripts."
	
	^ loadScripts addFirst: anObject!

close: aHtmlRoot on: aDocument
	"This method is called before the document is closed."!

closeOn: aDocument
	"This method is called to close the document that has no root."
	
	self loadScripts isEmpty 
		ifTrue: [ ^ self ].
	self 
		writeScriptTag: [ self writeLoadScriptsOn: aDocument ]
		on: aDocument!

event: aString do: anObject on: aBrush
	"Attaches the Javscript anObject to the event aString of aBrush. This default implementation simply inlines the Javascript code into the brush; subclasses might override this to do something more meaningful."
	
	aBrush attributes at: 'on' , aString append: anObject separator: ';'!

initialize
	super initialize.
	loadScripts := OrderedCollection new!

loadScripts
	"Answer the load scripts of the receiver. These scripts will be evaluated in order when the page has loaded."

	^ loadScripts!

open: aHtmlRoot on: aDocument
	"This method is called before the document is opened."!

writeLoadScriptsOn: aDocument
	"Utitlity method to write the receivers load scripts onto aDocument."

	self loadScripts do: [ :each | aDocument nextPutAll: each greaseString; nextPut: $; ]!

writeScriptTag: aBlock on: aDocument
	"Utitlity method to properly wrap the script generation code in aBlock onto aDocument."

	| attributes |
	attributes := WAHtmlAttributes new.
	attributes at: 'type' put: 'text/javascript'.
	aDocument openTag: 'script' attributes: attributes; nextPutAll: '/*<!![CDATA[*/'.
	aBlock value.
	aDocument nextPutAll: '/*]]>*/'; closeTag: 'script'! !
!WAScriptGenerator categoriesFor: #addLoadScript:!accessing!public! !
!WAScriptGenerator categoriesFor: #addLoadScriptFirst:!accessing!public! !
!WAScriptGenerator categoriesFor: #close:on:!actions!public! !
!WAScriptGenerator categoriesFor: #closeOn:!actions!public! !
!WAScriptGenerator categoriesFor: #event:do:on:!public! !
!WAScriptGenerator categoriesFor: #initialize!initialization!public! !
!WAScriptGenerator categoriesFor: #loadScripts!accessing!public! !
!WAScriptGenerator categoriesFor: #open:on:!actions!public! !
!WAScriptGenerator categoriesFor: #writeLoadScriptsOn:!private! !
!WAScriptGenerator categoriesFor: #writeScriptTag:on:!private! !

WAServerAdaptor guid: (GUID fromString: '{9CF2096E-AF44-49C5-BDC8-6B911F674FB9}')!
WAServerAdaptor comment: '
A WAServer is the abstract base class for all servers. Actual servers do not have to subclass it but have to support the protocol:
 - #codec
 - #usesSmalltalkEncoding

Instance Variables
	codec:		<WACodec>

codec
	- the codec used for response conversion from characters to bytes'!
!WAServerAdaptor categoriesForClass!Unclassified! !
!WAServerAdaptor methodsFor!

basicStart
	self subclassResponsibility!

basicStop
	self subclassResponsibility!

canStart
	^ self manager canStart: self!

canStop
	^ self manager canStop: self!

codec
	^ codec!

codec: aCodec
	codec := aCodec!

contextFor: aNativeRequest
	"Answer a request context for aNativeRequest."

	^ WARequestContext
		request: (self requestFor: aNativeRequest)
		response: (self responseFor: aNativeRequest)
		codec: self codec!

defaultCodec
	^ GRNullCodec new!

defaultPort
	^ 8080!

defaultRequestHandler
	^ WADispatcher default!

handle: aRequestContext
	"Handle the basic request-response loop."

	self handleRequest: aRequestContext.
	self handlePadding: aRequestContext!

handlePadding: aRequestContext
	"If you create an error page that's too small, Microsoft Internet Explorer will display its own error page that includes a link to the MSN network search engine rather than your own error page. See <http://www.404-error-page.com/404-error-page-too-short-problem-microsoft-ie.shtml> for details."

	| size |
	size := aRequestContext response stream size.
	^ (size < 512 and: [ #(400 403 404 405 406 408 409 410 500 501 505) includes: aRequestContext response status ])
		ifTrue: [ aRequestContext response nextPutAll: ((String new: 512 - size) atAllPut: $ ) ]!

handleRequest: aRequestContext
	"Pass the request context to the appropriate request handler."
	
	[ self requestHandler handle: aRequestContext ]
		on: WAResponseNotification
		do: [ :n | "got a response" ]!

initialize
	super initialize.
	codec := self defaultCodec.
	port := self defaultPort.!

initializeWithManager: aServerManager
	self initialize.
	manager := aServerManager!

isRunning
	self subclassResponsibility!

isStarting
	self subclassResponsibility!

isStopped
	self subclassResponsibility!

isStopping
	self subclassResponsibility!

kill
	self basicStop!

manager
	^ manager!

port
	^ port!

port: anObject
	port := anObject!

process: aNativeRequest
	"Process aNativeRequest by converting to a request context, handling the request, and converting the request context back to a native response. Make sure to release the context after processing, to help the garbage collector and avoid having large streams and sockets hanging around if people still refer to the obsolete request context."

	| context |
	context := self contextFor: aNativeRequest.
	^ [ self handle: context; responseFrom: context ]
		ensure: [ context destroy ]!

requestAddressFor: aNativeRequest
	self subclassResponsibility!

requestBodyFor: aNativeRequest
	"Answer the undecoded request body as a String."
	
	self subclassResponsibility!

requestCookiesFor: aNativeRequest
	self subclassResponsibility!

requestFieldsFor: aNativeRequest
	self subclassResponsibility!

requestFor: aNativeRequest
	"Answer a request object for aNativeRequest."

	^ (WARequest
		method: (self requestMethodFor: aNativeRequest)
		uri: (self requestUrlFor: aNativeRequest)
		version: (self requestVersionFor: aNativeRequest))
			setHeaders: (self requestHeadersFor: aNativeRequest);
			setBody: (self requestBodyFor: aNativeRequest);
			setPostFields: (self requestFieldsFor: aNativeRequest);
			setCookies: (self requestCookiesFor: aNativeRequest);
			setRemoteAddress: (self requestAddressFor: aNativeRequest);
			yourself!

requestHandler
	"We don't set the instvar here, if nil, because the default request handler
	may change over time and we want to keep using the current default if
	the user hasn't specified one."
	^ requestHandler ifNil: [ self defaultRequestHandler ]!

requestHandler: aRequestHandler
	requestHandler := aRequestHandler!

requestHeadersFor: aNativeRequest
	self subclassResponsibility!

requestMethodFor: aNativeRequest
	self subclassResponsibility!

requestUrlFor: aNativeRequest
	self subclassResponsibility!

requestVersionFor: aNativeRequest
	self subclassResponsibility!

responseFor: aNativeRequest
	"Answer a response object for aNativeRequest."

	^ WABufferedResponse on: (self codec encoderFor: (WriteStream on: String new))!

responseFrom: aRequestContext
	"Answer a native response from aRequestContext."

	self subclassResponsibility!

restart
	self manager restart: self!

shutDown!

start
	self manager start: self!

startUp!

statusString
	^ self isRunning
		ifTrue: [ 'running' ]
		ifFalse: [ 'stopped' ]!

stop
	self manager stop: self!

unregister
	self manager unregister: self!

unregistered
	manager := nil! !
!WAServerAdaptor categoriesFor: #basicStart!private! !
!WAServerAdaptor categoriesFor: #basicStop!private! !
!WAServerAdaptor categoriesFor: #canStart!public!testing! !
!WAServerAdaptor categoriesFor: #canStop!public!testing! !
!WAServerAdaptor categoriesFor: #codec!accessing!public! !
!WAServerAdaptor categoriesFor: #codec:!accessing!public! !
!WAServerAdaptor categoriesFor: #contextFor:!converting!public! !
!WAServerAdaptor categoriesFor: #defaultCodec!defaults!public! !
!WAServerAdaptor categoriesFor: #defaultPort!defaults!public! !
!WAServerAdaptor categoriesFor: #defaultRequestHandler!defaults!public! !
!WAServerAdaptor categoriesFor: #handle:!processing!public! !
!WAServerAdaptor categoriesFor: #handlePadding:!processing!public! !
!WAServerAdaptor categoriesFor: #handleRequest:!processing!public! !
!WAServerAdaptor categoriesFor: #initialize!initialization!public! !
!WAServerAdaptor categoriesFor: #initializeWithManager:!initialization!public! !
!WAServerAdaptor categoriesFor: #isRunning!public!testing! !
!WAServerAdaptor categoriesFor: #isStarting!public!testing! !
!WAServerAdaptor categoriesFor: #isStopped!public!testing! !
!WAServerAdaptor categoriesFor: #isStopping!public!testing! !
!WAServerAdaptor categoriesFor: #kill!public!starting/stopping! !
!WAServerAdaptor categoriesFor: #manager!accessing-readonly!public! !
!WAServerAdaptor categoriesFor: #port!accessing!public! !
!WAServerAdaptor categoriesFor: #port:!accessing!public! !
!WAServerAdaptor categoriesFor: #process:!processing!public! !
!WAServerAdaptor categoriesFor: #requestAddressFor:!converting-request!public! !
!WAServerAdaptor categoriesFor: #requestBodyFor:!converting-request!public! !
!WAServerAdaptor categoriesFor: #requestCookiesFor:!converting-request!public! !
!WAServerAdaptor categoriesFor: #requestFieldsFor:!converting-request!public! !
!WAServerAdaptor categoriesFor: #requestFor:!converting!public! !
!WAServerAdaptor categoriesFor: #requestHandler!accessing!public! !
!WAServerAdaptor categoriesFor: #requestHandler:!accessing!public! !
!WAServerAdaptor categoriesFor: #requestHeadersFor:!converting-request!public! !
!WAServerAdaptor categoriesFor: #requestMethodFor:!converting-request!public! !
!WAServerAdaptor categoriesFor: #requestUrlFor:!converting-request!public! !
!WAServerAdaptor categoriesFor: #requestVersionFor:!converting-request!public! !
!WAServerAdaptor categoriesFor: #responseFor:!converting!public! !
!WAServerAdaptor categoriesFor: #responseFrom:!converting!public! !
!WAServerAdaptor categoriesFor: #restart!public!starting/stopping! !
!WAServerAdaptor categoriesFor: #shutDown!private! !
!WAServerAdaptor categoriesFor: #start!public!starting/stopping! !
!WAServerAdaptor categoriesFor: #startUp!private! !
!WAServerAdaptor categoriesFor: #statusString!accessing-readonly!public! !
!WAServerAdaptor categoriesFor: #stop!public!starting/stopping! !
!WAServerAdaptor categoriesFor: #unregister!public!registration! !
!WAServerAdaptor categoriesFor: #unregistered!public!registration! !

!WAServerAdaptor class methodsFor!

isAbstract
	^ self name = #WAServerAdaptor!

manager: aServerManager
	^ aServerManager register: 
		(self basicNew
			initializeWithManager: aServerManager;
			yourself)!

new
	^ self manager: WAServerManager default!

port: anInteger
	^ self new
		port: anInteger;
		yourself! !
!WAServerAdaptor class categoriesFor: #isAbstract!public!testing! !
!WAServerAdaptor class categoriesFor: #manager:!instance creation!public! !
!WAServerAdaptor class categoriesFor: #new!instance creation!public! !
!WAServerAdaptor class categoriesFor: #port:!instance creation!public! !

WAServerManager guid: (GUID fromString: '{4002CBF6-BF60-4F55-A72A-111960CB8D83}')!
WAServerManager comment: ''!
!WAServerManager categoriesForClass!Unclassified! !
!WAServerManager methodsFor!

adaptors
	^ adaptors copy!

canStart: aServerAdaptor
	"Because we can't rely on the socket refusing to listen on a port already in use, we simply check here if we know of another adaptor using this adaptor's port"
	^ aServerAdaptor isStopped 
			and: [ self adaptors noneSatisfy: [ :adaptor | 
							( adaptor = aServerAdaptor ) not 
								and: [ adaptor port = aServerAdaptor port ] ] ]!

canStop: aServerAdaptor
	^ aServerAdaptor isStopped not!

initialize
	super initialize.
	adaptors := OrderedCollection new!

register: aServerAdaptor
	^ adaptors add: aServerAdaptor!

restart: aServerAdaptor
	self stop: aServerAdaptor.
	self start: aServerAdaptor!

restartAll
	adaptors do: [ :each | each restart ]!

start: aServerAdaptor
	(self canStart: aServerAdaptor) ifTrue: [
		[ aServerAdaptor basicStart ]
			ifCurtailed: [ self stop: aServerAdaptor ] ]!

startAll
	adaptors do: [ :each | each start ]!

stop: aServerAdaptor
	(self canStop: aServerAdaptor) ifTrue: [ aServerAdaptor basicStop ]!

stopAll
	adaptors do: [ :each | each stop ]!

unregister: aServerAdaptor
	self stop: aServerAdaptor.
	adaptors remove: aServerAdaptor.
	aServerAdaptor unregistered.
	^ aServerAdaptor! !
!WAServerManager categoriesFor: #adaptors!accessing!public! !
!WAServerManager categoriesFor: #canStart:!private! !
!WAServerManager categoriesFor: #canStop:!private! !
!WAServerManager categoriesFor: #initialize!initialization!public! !
!WAServerManager categoriesFor: #register:!accessing!public! !
!WAServerManager categoriesFor: #restart:!public!starting/stopping! !
!WAServerManager categoriesFor: #restartAll!public!starting/stopping! !
!WAServerManager categoriesFor: #start:!public!starting/stopping! !
!WAServerManager categoriesFor: #startAll!public!starting/stopping! !
!WAServerManager categoriesFor: #stop:!public!starting/stopping! !
!WAServerManager categoriesFor: #stopAll!public!starting/stopping! !
!WAServerManager categoriesFor: #unregister:!accessing!public! !

!WAServerManager class methodsFor!

default
	^ default ifNil: [ default := self new ]!

initialize
	GRPlatform current
		addToStartUpList: self;
		addToShutDownList: self!

shutDown
	self default adaptors do: [ :each | each shutDown ]!

startUp
	self default adaptors do: [ :each | each startUp ]!

unload
	GRPlatform current
		removeFromStartUpList: self;
		removeFromShutDownList: self! !
!WAServerManager class categoriesFor: #default!accessing!public! !
!WAServerManager class categoriesFor: #initialize!class initialization!public! !
!WAServerManager class categoriesFor: #shutDown!public!system startup! !
!WAServerManager class categoriesFor: #startUp!public!system startup! !
!WAServerManager class categoriesFor: #unload!class initialization!public! !

WASnapshot guid: (GUID fromString: '{73AAFEA8-0B9C-4C98-A463-0C6A8DE51510}')!
WASnapshot comment: 'I represent a memory snapshot of objects. Objects can be registered by sending the message #register:. All object snapshots are updated by sending #snapshot and restored by sending #restore. To have specific snpshot and restore actions for particular classes override #snapshotCopy and #restoreFromSnapshot: in your classes.'!
!WASnapshot categoriesForClass!Unclassified! !
!WASnapshot methodsFor!

initialize
	super initialize.
	self reset!

register: anObject
	"Register anObject for backtracking."

	anObject isNil
		ifFalse: [ objects at: anObject put: anObject snapshotCopy ]!

reset
	"Clears the snapshot dictionary."

	objects := IdentityDictionary new!

restore
	"Restore all the backtracked states."

	objects keysAndValuesDo: [ :key :value | key restoreFromSnapshot: value ]!

snapshot
	"Snapshot all the states that have been registered for backtracking overriding existing snapshots."

	objects associationsDo: [ :assoc | assoc value: assoc key snapshotCopy ]! !
!WASnapshot categoriesFor: #initialize!initialization!public! !
!WASnapshot categoriesFor: #register:!public!registry! !
!WASnapshot categoriesFor: #reset!actions!public! !
!WASnapshot categoriesFor: #restore!actions!public! !
!WASnapshot categoriesFor: #snapshot!actions!public! !

WAUrl guid: (GUID fromString: '{830D71D3-7A2C-4B4D-9D1A-5AC6D462247A}')!
WAUrl comment: '
I represent all portions of an URL as described by the RFC 1738 and updated by RFC 3986. I include scheme, userinfo, host, port, path, query, and fragment.

Instance Variables
	scheme:			<String> or nil
	user:		<String> or nil
	password:		<String> or nil
	host:		<String> or nil
	port:			<Integer> or nil
	path:			<OrderedCollection> or nil
	slash:			<Boolean>
	queryFields:		<WARequestFields> or nil
	fragment:		<String> or nil'!
!WAUrl categoriesForClass!Unclassified! !
!WAUrl methodsFor!

= aUrl
	^ self class = aUrl class and: [ self printString = aUrl printString ]!

addAllToPath: aCollectionOfStrings
	"Add a collection of strings to the path."
	
	aCollectionOfStrings do: [ :each | self addToPath: each ]!

addField: aKey
	"Add the query field aKey to the receiving url."

	self addField: aKey value: nil!

addField: aKey value: aValue
	"Add the query field aKey with aValue to the receiving url."
	
	aKey isEmpty 
		ifFalse: [ self queryFields at: aKey add: aValue ]!

addParameter: aKey
	self greaseDeprecatedApi: 'WAUrl>>#addParameter:'
		details: 'Use WAUrl>>#addField:.'.
	
	^ self addField: aKey!

addParameter: aKey value: aValue
	self greaseDeprecatedApi: 'WAUrl>>#addParameter:value:'
		details: 'Use WAUrl>>#addField:value:.'.
	
	^ self addField: aKey value: aValue!

addToPath: aString
	"Adds the argument as a path element. If the argument contains $/ it is split into multiple elements."

	self path addAll: (aString greaseSubStrings: '/').
	self slash: (aString notEmpty and: [ aString last = $/ ])!

decode: aString
	"percent decodes the given String"
	^self class decodePercent: aString!

decodedWith: aCodec
	"answers a copy of the receiver decoded with the given codec
	http://www.ietf.org/rfc/rfc3987.txt"
	| url |
	url := self copy.
	
	"scheme, host, port cannot include escaped characters (%FF) and so should not
	be able to include characters that need decoding"
	
	"userinfo (username + password) can be percent encoded"
	self user isNil ifFalse: [
		url user: (aCodec url decode: self user) ].
	self password isNil ifFalse: [
		url password: (aCodec url decode: self password) ].
	
	self path isEmpty ifFalse: [
		url path: (self path collect: [ :each | aCodec url decode: each ]) ].
	url queryFields: nil.
	self queryFields keysAndValuesDo: [ :key :value |
		url
			addField: (aCodec url decode: key)
			value: (value isNil ifFalse: [ aCodec url decode: value ]) ].
	self fragment isNil ifFalse: [
		url fragment: (aCodec url decode: self fragment) ].
	
	^ url!

encodeFragmentOn: aDocument
	aDocument urlEncoder nextPutAll: fragment!

encodeOn: aDocument
	self encodeSchemeAndAuthorityOn: aDocument.
	self encodePathOn: aDocument.
	(queryFields isNil or: [ queryFields isEmpty ]) ifFalse: [
		aDocument xmlEncoder nextPut: $?.
		self encodeQueryOn: aDocument ].
	fragment isNil ifFalse: [
		aDocument xmlEncoder nextPut: $#.
		self encodeFragmentOn: aDocument ]!

encodePathOn: aDocument
	path isNil ifFalse: [
		path do: [ :each |
			aDocument nextPut: $/.
			aDocument urlEncoder nextPutAll: each ] ].
	(path isNil or: [ path isEmpty or: [ slash ] ])
		ifTrue: [ aDocument nextPut: $/ ]!

encodeQueryOn: aDocument 
	| first |
	first := true.
	self queryFields keysAndValuesDo: 
		[ :key :value |
		first ifFalse: [ aDocument xmlEncoder nextPut: $& ].
		first := false.
		aDocument urlEncoder nextPutAll: key.
		value isNil ifFalse: 
			[ aDocument nextPut: $=.
			aDocument urlEncoder nextPutAll: value greaseString ] ]!

encodeSchemeAndAuthorityOn: aDocument
	host ifNil: [ ^ self ].
	aDocument nextPutAll: self scheme; nextPutAll: '://'.
	user notNil ifTrue: [
		aDocument urlEncoder nextPutAll: user.
		password notNil ifTrue: [
			aDocument nextPut: $:.
			aDocument urlEncoder nextPutAll: password ].
		aDocument nextPut: $@ ].
	aDocument urlEncoder nextPutAll: host.
	port notNil ifTrue: [
		((self scheme = 'http' and: [ port = 80 ])
			or: [ self scheme = 'https' and: [ port = 443 ] ])
			ifFalse: [ aDocument nextPut: $:; print: port ] ]!

fragment
	"Answer the fragment part of the URL."

	^ fragment!

fragment: aString
	fragment := aString!

hash
	^ self host hash bitXor: self path hash!

host
	"Answer the host part of the URL."

	^ host!

host: aString
	host := aString isNil
		ifFalse: [ aString greaseString asLowercase ]!

hostname
	self greaseDeprecatedApi: 'WAUrl>>#hostname'
		details: 'Use WAUrl>>#host.'.

	^ self host!

hostname: aString
	self greaseDeprecatedApi: 'WAUrl>>#hostname:'
		details: 'Use WAUrl>>#host:.'.
	
	^ self host: aString!

initialize
	super initialize.
	slash := false!

initializeFromString: aString
	| string index |
	self initialize.
	string := aString.
	index := string indexOf: $#.
	index > 0 ifTrue: [
		self parseFragment: (string copyFrom: index + 1 to: string size).
		string := string copyFrom: 1 to: index - 1 ].
	index := string indexOf: $?.
	index > 0 ifTrue: [
		self parseQuery: (string copyFrom: index + 1 to: string size).
		string := string copyFrom: 1 to: index - 1 ].
	index := string indexOfSubCollection: '://'.
	index > 0 ifTrue: [ 
		self scheme: (string copyFrom: 1 to: index - 1).
		string := string copyFrom: index + 3 to: string size.
		index := string indexOf: $/.
		string := index > 0
			ifFalse: [ 
				self parseAuthority: string.
				'' ]
			ifTrue: [
				self parseAuthority: (string copyFrom: 1 to: index - 1).
				string copyFrom: index + 1 to: string size ] ].
	self parsePath: string!

isSeasideField: aString
	^ aString notEmpty
		and: [ aString first = $_
		or: [ aString allSatisfy: [ :each | each isDigit ] ] ]!

isSsl
	^ self scheme isEmptyOrNil not
		and: [ self scheme last = $s ]!

parameters
	self greaseDeprecatedApi: 'WAUrl>>#parameters'
		details: 'Use WAUrl>>#queryFields.'.

	^ self queryFields!

parameters: aDictionary
	self greaseDeprecatedApi: 'WAUrl>>#parameters:'
		details: 'Use WAUrl>>#queryFields:.'.

	^ self queryFields: aDictionary!

parseAuthority: aString 
	| string temp index |
	aString isEmpty ifTrue: [ ^ self ].
	string := aString.
	index := string indexOf: $@.
	index > 1 ifTrue: 
		[ temp := string 
			copyFrom: 1
			to: index - 1.
		string := string 
			copyFrom: index + 1
			to: string size.
		index := temp indexOf: $:.
		index > 0 
			ifFalse: [ self user: (self decode: temp) ]
			ifTrue: 
				[ self user: (self decode: (temp 
							copyFrom: 1
							to: index - 1)).
				self password: (self decode: (temp 
							copyFrom: index + 1
							to: temp size)) ] ].
	index := string lastIndexOf: $:.
	index > 0 ifTrue: 
		[ temp := string 
			copyFrom: index + 1
			to: string size.
		string := string 
			copyFrom: 1
			to: index - 1.
		self port: ((temp allSatisfy: [ :each | each isDigit ]) ifTrue: [ temp greaseInteger ]) ].
	self host: (self decode: string)!

parseFragment: aString
	aString isEmpty ifTrue: [ ^ self ].
	self fragment: (self decode: aString)!

parseHost: aString
	"This was probably only used internally anyway, but what the heck."
	
	self greaseDeprecatedApi: 'WAUrl>>#parseHost:'
		details: 'Use WAUrl>>#parseAuthority:.'.
		
	^ self parseAuthority: aString!

parseParameters: aString
	"This was probably only used internally anyway, but what the heck."
	
	self greaseDeprecatedApi: 'WAUrl>>#parseParameters:'
		details: 'Use WAUrl>>#parseQuery:.'.
		
	^ self parseQuery: aString!

parsePath: aString
	| input part |
	input := aString readStream.
	input peek = $/ 
		ifTrue: [ path := nil ].
	[ input atEnd ] whileFalse: [
		part := input upTo: $/.
		part isEmpty ifFalse: [
			part = '..'
				ifTrue: [ self path isEmpty ifFalse: [ self path removeLast ] ]
				ifFalse: [ part = '.' ifFalse: [ self path addLast: (self decode: part) ] ] ] ].
	slash := aString notEmpty and: [ aString last = $/ ]!

parseQuery: aString
	| input string index |
	input := aString readStream.
	[ input atEnd ] whileFalse: [
		string := input upTo: $&.
		index := string indexOf: $=.
		index > 0
			ifFalse: [ self addField: (self decode: string) ]
			ifTrue: [
				self
					addField: (self decode: (string copyFrom: 1 to: index - 1))
					value: (self decode: (string copyFrom: index + 1 to: string size)) ] ]!

password
	"Answer the password part of the URL userinfo. Note that the use of the format
	'user:password' for userinfo has been deprecated in RFC 3986 (3.2.1)."

	^ password!

password: aString
	password := aString!

path
	"Answer the path part of the URL."

	^ path ifNil: [ path := OrderedCollection new ]!

path: aCollection
	"Set the path part of the URL to aCollection."

	path := aCollection!

pathString
	"Answer the path converted to a string."

	| document |
	^ String streamContents: [ :stream | 
		document := WAHtmlDocument on: stream.
		self encodePathOn: document ]!

port
	"Answer the port number part of the URL."

	^ port!

port: aNumber
	port := aNumber!

postCopy
	super postCopy.
	path := path copy.
	queryFields := queryFields copy!

printOn: aStream 
	| document codec |
	codec := [ self requestContext codec ] 
		on: WARequestContextNotFound
		do: [ :e | GRNullCodec new ].
	document := WAUnescapedDocument 
		on: aStream
		codec: codec.
	self encodeOn: document!

queryFields
	"Answer a dictionary with the query fields."
	^ queryFields ifNil: [ queryFields := WARequestFields new ]!

queryFields: aDictionary
	queryFields := aDictionary!

queryString
	"Answer the full query part of the URL. It would probably be better to
	store this as a string somewhere so we can support queries that are not
	key/value field lists."
	
	^ String streamContents: [ :stream |
		|urlEncoder|
		urlEncoder := WAUrlEncoder on: stream.
		self queryFields associations
			do: [ :each |
				urlEncoder nextPutAll: each key.
				each value notNil ifTrue: [
					stream nextPut: $=.
					urlEncoder nextPutAll: each value greaseString ] ]
			separatedBy: [ stream nextPut: $& ] ]!

relativeTo: aUrl
	"Answer a path element collection relative from the receiver to aUrl."
	
	| currentPath argumentPath resultingPath |
	currentPath := self path copy.
	argumentPath := aUrl path copy.
	[ currentPath notEmpty and: [ argumentPath notEmpty and: [ currentPath first = argumentPath first ] ] ] whileTrue: [
		currentPath removeFirst.
		argumentPath removeFirst ].
	resultingPath := OrderedCollection new.
	currentPath size 
		timesRepeat: [ resultingPath add: '..' ].
	resultingPath addAll: argumentPath.
	^ resultingPath!

scheme
	"Answer the URL's scheme."

	^ scheme ifNil: [ 'http' ]!

scheme: aString
	scheme := aString isNil ifFalse: [ aString asLowercase ]!

seasideUrl
	^ self!

slash
	"Answer if the path has a trailing slash."

	^ slash!

slash: aBoolean
	slash := aBoolean!

takeServerParametersFromRequest: aRequest
	"Retrieves scheme, hostname and basepath from the request unless already set."

	scheme isNil
		ifTrue: [ self scheme: aRequest url scheme ].
	host isNil 
		ifTrue: [ aRequest headers at: 'host' ifPresent: [ :value | self parseAuthority: value ] ].
	path isNil
		ifTrue: [ aRequest headers at: 'base' ifPresent: [ :value | self parsePath: value ] ]!

user
	"Answer the user part of the URL userinfo. Note that the use of the format
	'user:password' for userinfo has been deprecated in RFC 3986 (3.2.1)."

	^ user!

user: aString
	user := aString!

userinfo
	"Answer the userinfo part of the URL. We store user and password seperately,
	even though the format 'user:password' is deprecated for userinfo in RFC 3986,
	because otherwise it is impossible to figure out correct encoding when userinfo
	data has a colon in it."

	^ password isNil
		ifTrue: [ user ]
		ifFalse: [ String streamContents: [ :stream |
			stream
				nextPutAll: user;
				nextPut: $:;
				nextPutAll: password ] ]!

userinfo: aString
	"Colons in userinfo must be encoded. The only exception (now deprecated by RFC 3986)
	is a single colon separating a password from the rest of the user information. Since
	we can't tell the difference here, we assume that any colons should be encoded. If
	you want to specify a (deprecated) password, use #user: and #password:."
	
	user := aString.
	password := nil!

username
	self greaseDeprecatedApi: 'WAUrl>>#username'
		details: 'Use WAUrl>>#user.'.

	^ self user!

username: aString
	self greaseDeprecatedApi: 'WAUrl>>#username:'
		details: 'Use WAUrl>>#user:.'.
	
	^ self user: aString!

with: pathString
	^ self copy
		addToPath: pathString;
		yourself!

withField: aString
	^ self copy
		addField: aString;
		yourself!

withField: aString value: valueString
	^ self copy
		addField: aString value: valueString;
		yourself!

withoutParameters
	self greaseDeprecatedApi: 'WAUrl>>#withoutParameters'
		details: 'Use WAUrl>>#withoutQuery.'.
	
	^ self withoutQuery!

withoutQuery
	^ self copy
		queryFields: nil;
		yourself!

withParameter: aKey
	self greaseDeprecatedApi: 'WAUrl>>#withParameter:'
		details: 'Use WAUrl>>#withField:.'.
	
	^ self withField: aKey!

withParameter: aKey value: aValue
	self greaseDeprecatedApi: 'WAUrl>>#withParameter:value:'
		details: 'Use WAUrl>>#withField:value:.'.
	
	^ self withField: aKey value: aValue! !
!WAUrl categoriesFor: #=!comparing!public! !
!WAUrl categoriesFor: #addAllToPath:!adding!public! !
!WAUrl categoriesFor: #addField:!adding!public! !
!WAUrl categoriesFor: #addField:value:!adding!public! !
!WAUrl categoriesFor: #addParameter:!public! !
!WAUrl categoriesFor: #addParameter:value:!public! !
!WAUrl categoriesFor: #addToPath:!adding!public! !
!WAUrl categoriesFor: #decode:!private! !
!WAUrl categoriesFor: #decodedWith:!converting!public! !
!WAUrl categoriesFor: #encodeFragmentOn:!encoding!public! !
!WAUrl categoriesFor: #encodeOn:!encoding!public! !
!WAUrl categoriesFor: #encodePathOn:!encoding!public! !
!WAUrl categoriesFor: #encodeQueryOn:!encoding!public! !
!WAUrl categoriesFor: #encodeSchemeAndAuthorityOn:!encoding!public! !
!WAUrl categoriesFor: #fragment!accessing!public! !
!WAUrl categoriesFor: #fragment:!accessing!public! !
!WAUrl categoriesFor: #hash!comparing!public! !
!WAUrl categoriesFor: #host!accessing!public! !
!WAUrl categoriesFor: #host:!accessing!public! !
!WAUrl categoriesFor: #hostname!public! !
!WAUrl categoriesFor: #hostname:!public! !
!WAUrl categoriesFor: #initialize!initialization!public! !
!WAUrl categoriesFor: #initializeFromString:!initialization!public! !
!WAUrl categoriesFor: #isSeasideField:!private! !
!WAUrl categoriesFor: #isSsl!public!testing! !
!WAUrl categoriesFor: #parameters!public! !
!WAUrl categoriesFor: #parameters:!public! !
!WAUrl categoriesFor: #parseAuthority:!parsing!public! !
!WAUrl categoriesFor: #parseFragment:!parsing!public! !
!WAUrl categoriesFor: #parseHost:!public! !
!WAUrl categoriesFor: #parseParameters:!public! !
!WAUrl categoriesFor: #parsePath:!parsing!public! !
!WAUrl categoriesFor: #parseQuery:!parsing!public! !
!WAUrl categoriesFor: #password!accessing!public! !
!WAUrl categoriesFor: #password:!accessing!public! !
!WAUrl categoriesFor: #path!accessing!public! !
!WAUrl categoriesFor: #path:!accessing!public! !
!WAUrl categoriesFor: #pathString!converting!public! !
!WAUrl categoriesFor: #port!accessing!public! !
!WAUrl categoriesFor: #port:!accessing!public! !
!WAUrl categoriesFor: #postCopy!copying!public! !
!WAUrl categoriesFor: #printOn:!printing!public! !
!WAUrl categoriesFor: #queryFields!accessing!public! !
!WAUrl categoriesFor: #queryFields:!accessing!public! !
!WAUrl categoriesFor: #queryString!converting!public! !
!WAUrl categoriesFor: #relativeTo:!converting!public! !
!WAUrl categoriesFor: #scheme!accessing!public! !
!WAUrl categoriesFor: #scheme:!accessing!public! !
!WAUrl categoriesFor: #seasideUrl!converting!public! !
!WAUrl categoriesFor: #slash!accessing!public! !
!WAUrl categoriesFor: #slash:!accessing!public! !
!WAUrl categoriesFor: #takeServerParametersFromRequest:!private! !
!WAUrl categoriesFor: #user!accessing!public! !
!WAUrl categoriesFor: #user:!accessing!public! !
!WAUrl categoriesFor: #userinfo!accessing!public! !
!WAUrl categoriesFor: #userinfo:!accessing!public! !
!WAUrl categoriesFor: #username!public! !
!WAUrl categoriesFor: #username:!public! !
!WAUrl categoriesFor: #with:!copying!public! !
!WAUrl categoriesFor: #withField:!copying!public! !
!WAUrl categoriesFor: #withField:value:!copying!public! !
!WAUrl categoriesFor: #withoutParameters!public! !
!WAUrl categoriesFor: #withoutQuery!copying!public! !
!WAUrl categoriesFor: #withParameter:!public! !
!WAUrl categoriesFor: #withParameter:value:!public! !

!WAUrl class methodsFor!

absolute: aString
	"Parse aString as an absolute URL."

	^ self basicNew initializeFromString: aString!

absolute: aString relative: aRelativeString
	"Take absolute URL aString and combine it with a relative path aRelativeString."

	^ (self absolute: aString)
		parsePath: aRelativeString;
		yourself!

decodePercent: aString
	"percent decodes the given String"
	| input output char |
	input := aString readStream.
	output := WriteStream on: (String new: aString size).
	[ input atEnd ] whileFalse: [
		char := input next.
		output nextPut: (char = $+
			ifTrue: [ Character space ]
			ifFalse: [
				char = $%
					ifTrue: [
						Character codePoint: input next asUppercase digitValue * 16
							+ input next asUppercase digitValue ]
					ifFalse: [ char ] ]) ].
	^ output contents! !
!WAUrl class categoriesFor: #absolute:!parsing!public! !
!WAUrl class categoriesFor: #absolute:relative:!parsing!public! !
!WAUrl class categoriesFor: #decodePercent:!decoding!public! !

WAValueHolder guid: (GUID fromString: '{50B240CE-9F05-47F0-92C3-7131A516A59E}')!
WAValueHolder comment: 'I wrap a single object. I am like value holder except that I am portable and don''t include the Model cruft in Squeak.'!
!WAValueHolder categoriesForClass!Unclassified! !
!WAValueHolder methodsFor!

contents
	^ contents!

contents: anObject
	contents := anObject!

printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' contents: '; print: self contents! !
!WAValueHolder categoriesFor: #contents!accessing!public! !
!WAValueHolder categoriesFor: #contents:!accessing!public! !
!WAValueHolder categoriesFor: #printOn:!printing!public! !

!WAValueHolder class methodsFor!

with: anObject
	^ self new contents: anObject! !
!WAValueHolder class categoriesFor: #with:!instance creation!public! !

WAVisitor guid: (GUID fromString: '{EE9DD94C-E943-4146-AFEC-696328662634}')!
WAVisitor comment: ''!
!WAVisitor categoriesForClass!Unclassified! !
!WAVisitor methodsFor!

start: anObject
	self visit: anObject!

visit: anObject
	anObject accept: self!

visitAll: aCollection
	aCollection do: [ :each | self visit: each ]! !
!WAVisitor categoriesFor: #start:!public!visiting! !
!WAVisitor categoriesFor: #visit:!public!visiting! !
!WAVisitor categoriesFor: #visitAll:!public!visiting! !

WACacheExpiryPolicy guid: (GUID fromString: '{B92D3DAE-E11D-473C-8AA5-E37B371EDEA5}')!
WACacheExpiryPolicy comment: '
A cache expiry policy determines when an item in the cache is considered expired. Expired items are periodically reaped an a schedule determined by the reaping strategy in place.

Subclasses should implement any of the notification methods that are interesting to them and should implement #isExpired:key: and return true or false as appropriate for any given object.'!
!WACacheExpiryPolicy categoriesForClass!Unclassified! !
!WACacheExpiryPolicy methodsFor!

isExpired: anObject key: aString
	^ false! !
!WACacheExpiryPolicy categoriesFor: #isExpired:key:!protocol!public! !

WACacheMissStrategy guid: (GUID fromString: '{87B67937-D6E0-4956-9131-34656CCB1621}')!
WACacheMissStrategy comment: '
A cache miss strategy determines what should be done when an attempt is made to retrieve an object with a key that is not found in the cache.

Subclasses should implement #missed: and should either return nil or if the object can be found outside the cache somewhere, the object.'!
!WACacheMissStrategy categoriesForClass!Unclassified! !
!WACacheMissStrategy methodsFor!

missed: aString
	^ nil! !
!WACacheMissStrategy categoriesFor: #missed:!protocol!public! !

WACacheReapingStrategy guid: (GUID fromString: '{6439C721-EBAD-4829-927A-9BDE5D152571}')!
WACacheReapingStrategy comment: '
A cache reaping strategy determines when expired items should be removed from a cache.

Subclasses should implement any of the event notification methods they require and should call "self reap" whenever they determine that expired items should be removed from the cache.'!
!WACacheReapingStrategy categoriesForClass!Unclassified! !
!WACacheReapingStrategy methodsFor!

reap
	cache reap! !
!WACacheReapingStrategy categoriesFor: #reap!private! !

WACacheRemovalAction guid: (GUID fromString: '{0368952A-1B2A-4895-895F-AB7EE73AB781}')!
WACacheRemovalAction comment: '
A cache reap action determines what, if anything, should happen when an object is reaped from the cache.

Subclasses should implement #reaped:key:. When this method is called, the object will already have been removed from the cache itself but the subclass should perform any any additional actions that need to be taken.'!
!WACacheRemovalAction categoriesForClass!Unclassified! !
WALastAccessExpiryPolicy guid: (GUID fromString: '{34B83CAE-3A61-4A11-80C4-156398BDE037}')!
WALastAccessExpiryPolicy comment: ''!
!WALastAccessExpiryPolicy categoriesForClass!Unclassified! !
!WALastAccessExpiryPolicy methodsFor!

defaultConfiguration
	^ super defaultConfiguration
		addParent: WACacheTimeoutConfiguration instance;
		yourself!

initialize
	super initialize.
	lastAccessTable := GRPlatform current reducedConflictDictionary new!

isExpired: anObject key: aString
	| lastAccess |
	lastAccess := lastAccessTable at: aString ifAbsent: [ Time totalSeconds ].
	^ (Time totalSeconds - lastAccess) > self timeout!

postCopy
	super postCopy.
	lastAccessTable := lastAccessTable copy!

removed: anObject key: aString
	lastAccessTable removeKey: aString ifAbsent: []!

retrieved: anObject key: aString
	lastAccessTable at: aString put: Time totalSeconds!

stored: anObject key: aString
	lastAccessTable at: aString put: Time totalSeconds!

timeout
	^ self configuration at: #cacheTimeout! !
!WALastAccessExpiryPolicy categoriesFor: #defaultConfiguration!configuration!public! !
!WALastAccessExpiryPolicy categoriesFor: #initialize!initialization!public! !
!WALastAccessExpiryPolicy categoriesFor: #isExpired:key:!protocol!public! !
!WALastAccessExpiryPolicy categoriesFor: #postCopy!copying!public! !
!WALastAccessExpiryPolicy categoriesFor: #removed:key:!notifications!public! !
!WALastAccessExpiryPolicy categoriesFor: #retrieved:key:!notifications!public! !
!WALastAccessExpiryPolicy categoriesFor: #stored:key:!notifications!public! !
!WALastAccessExpiryPolicy categoriesFor: #timeout!configuration!public! !

WALeastRecentlyUsedExpiryPolicy guid: (GUID fromString: '{5FE6A8C2-B076-48BC-BB86-1451F93175B3}')!
WALeastRecentlyUsedExpiryPolicy comment: ''!
!WALeastRecentlyUsedExpiryPolicy categoriesForClass!Unclassified! !
!WALeastRecentlyUsedExpiryPolicy methodsFor!

defaultConfiguration
	^ super defaultConfiguration
		addParent: WACacheCapacityConfiguration instance;
		yourself!

initialize
	super initialize.
	ageTable := GRPlatform current reducedConflictDictionary new!

isExpired: anObject key: aString
	^ (ageTable at: aString) first > self maximumAge!

maximumAge
	^ self configuration at: #cacheCapacity!

postCopy
	super postCopy.
	ageTable := ageTable copy.
	ageTable keysAndValuesDo: [:eachKey :eachValue | 
		ageTable at: eachKey put: (Array with: eachValue first).
	]. !

removed: anObject key: aString
	ageTable removeKey: aString ifAbsent: []!

retrieved: anObject key: aString
	(ageTable at: aString) at: 1 put: 0!

stored: anObject key: aString
	"Avoid #associationsDo: to maintain cross-platform portability (see Issue #312 for details)."
	
	ageTable do: [:each | each at: 1 put: (each at: 1) + 1].
	ageTable at: aString put: (Array with: 0).! !
!WALeastRecentlyUsedExpiryPolicy categoriesFor: #defaultConfiguration!configuration!public! !
!WALeastRecentlyUsedExpiryPolicy categoriesFor: #initialize!initialization!public! !
!WALeastRecentlyUsedExpiryPolicy categoriesFor: #isExpired:key:!protocol!public! !
!WALeastRecentlyUsedExpiryPolicy categoriesFor: #maximumAge!configuration!public! !
!WALeastRecentlyUsedExpiryPolicy categoriesFor: #postCopy!copying!public! !
!WALeastRecentlyUsedExpiryPolicy categoriesFor: #removed:key:!notifications!public! !
!WALeastRecentlyUsedExpiryPolicy categoriesFor: #retrieved:key:!notifications!public! !
!WALeastRecentlyUsedExpiryPolicy categoriesFor: #stored:key:!notifications!public! !

WARetrievalIntervalReapingStrategy guid: (GUID fromString: '{7A76E69D-1FDF-4E52-A565-5AF9F1A88D5D}')!
WARetrievalIntervalReapingStrategy comment: ''!
!WARetrievalIntervalReapingStrategy categoriesForClass!Unclassified! !
!WARetrievalIntervalReapingStrategy methodsFor!

defaultConfiguration
	^ super defaultConfiguration
		addParent: WARetrievalIntervalReapingStrategyConfiguration instance;
		yourself!

initialize
	super initialize.
	count := 0!

interval
	^ self configuration at: #cacheReapInterval!

reap
	count := 0.
	super reap!

retrieved: anObject key: anExternalId
	count := count + 1.
	(count >= self interval) ifTrue: [ self reap ]! !
!WARetrievalIntervalReapingStrategy categoriesFor: #defaultConfiguration!configuration!public! !
!WARetrievalIntervalReapingStrategy categoriesFor: #initialize!initialization!public! !
!WARetrievalIntervalReapingStrategy categoriesFor: #interval!configuration!public! !
!WARetrievalIntervalReapingStrategy categoriesFor: #reap!private! !
!WARetrievalIntervalReapingStrategy categoriesFor: #retrieved:key:!notifications!public! !

WANotifyRemovalAction guid: (GUID fromString: '{B8345D52-8C91-44D7-8606-5B50A54BE1D1}')!
WANotifyRemovalAction comment: ''!
!WANotifyRemovalAction categoriesForClass!Unclassified! !
!WANotifyRemovalAction methodsFor!

removed: anObject key: aString
	(anObject respondsTo: #unregistered) ifTrue: [ anObject unregistered ]
	! !
!WANotifyRemovalAction categoriesFor: #removed:key:!protocol!public! !

WAActionCallback guid: (GUID fromString: '{C5F4ED7B-9C73-425C-BB1D-75EE9090006A}')!
WAActionCallback comment: ''!
!WAActionCallback categoriesForClass!Unclassified! !
!WAActionCallback methodsFor!

block: aZeroOrOneArgBlock
	block := aZeroOrOneArgBlock fixCallbackTemps!

evaluateWithArgument: anObject
	block valueWithPossibleArguments: (Array with: anObject).
	self signalRenderNotification!

isEnabledFor: aRequestContext
	^ aRequestContext request isXmlHttpRequest not!

priority
	^ 5!

signalRenderNotification
	WARenderNotification signal! !
!WAActionCallback categoriesFor: #block:!accessing!public! !
!WAActionCallback categoriesFor: #evaluateWithArgument:!evaluation!public! !
!WAActionCallback categoriesFor: #isEnabledFor:!public!testing! !
!WAActionCallback categoriesFor: #priority!accessing!public! !
!WAActionCallback categoriesFor: #signalRenderNotification!evaluation!public! !

WADispatchCallback guid: (GUID fromString: '{1474E138-1262-43AC-9B06-28050CA10610}')!
WADispatchCallback comment: ''!
!WADispatchCallback categoriesForClass!Unclassified! !
!WADispatchCallback methodsFor!

evaluateWithArgument: anObject
	callbacks at: anObject ifPresent: [ :callback | callback evaluateWithFieldValues: #(nil) ]!

setKey: aString callbacks: aDictionary
	super setKey: aString callbacks: aDictionary.
	callbacks := aDictionary! !
!WADispatchCallback categoriesFor: #evaluateWithArgument:!evaluation!public! !
!WADispatchCallback categoriesFor: #setKey:callbacks:!initialization!public! !

WAValueCallback guid: (GUID fromString: '{AF4DE6E0-7E1B-45AB-B833-D7CB6046893B}')!
WAValueCallback comment: ''!
!WAValueCallback categoriesForClass!Unclassified! !
!WAValueCallback methodsFor!

block: aOneArgBlock
	block := aOneArgBlock fixCallbackTemps!

evaluateWithArgument: anObject
	anObject isNil
		ifFalse: [ block valueWithPossibleArguments: (Array with:  anObject) ]!

valueForField: anObject
	"For most ValueCallbacks, it is more convenient to work with an empty String
	than with nil when the HTML input is empty."
	
	^ anObject ifNil: [ String new ]! !
!WAValueCallback categoriesFor: #block:!accessing!public! !
!WAValueCallback categoriesFor: #evaluateWithArgument:!evaluation!public! !
!WAValueCallback categoriesFor: #valueForField:!converting!public! !

WACancelActionCallback guid: (GUID fromString: '{92946FD8-9EA6-4472-9F5E-D211E5C2B5DA}')!
WACancelActionCallback comment: ''!
!WACancelActionCallback categoriesForClass!Unclassified! !
!WACancelActionCallback methodsFor!

priority
	^ -5! !
!WACancelActionCallback categoriesFor: #priority!accessing!public! !

WADefaultActionCallback guid: (GUID fromString: '{B6C117A8-3283-4780-8C13-2F6869314A65}')!
WADefaultActionCallback comment: ''!
!WADefaultActionCallback categoriesForClass!Unclassified! !
!WADefaultActionCallback methodsFor!

priority
	^ 10! !
!WADefaultActionCallback categoriesFor: #priority!accessing!public! !

WAImageCallback guid: (GUID fromString: '{8E28B1FA-C8A8-4056-AB6B-9AD56C47FFC5}')!
WAImageCallback comment: ''!
!WAImageCallback categoriesForClass!Unclassified! !
!WAImageCallback methodsFor!

convertKey: aString
	^ aString , '.x'! !
!WAImageCallback categoriesFor: #convertKey:!converting!public! !

WAMapCallback guid: (GUID fromString: '{ECD58FC3-F95F-4296-8EFF-B4762C41B6DF}')!
WAMapCallback comment: ''!
!WAMapCallback categoriesForClass!Unclassified! !
!WAMapCallback methodsFor!

valueForField: anObject 
	| stream x y |
	stream := (super valueForField: anObject) readStream.
	(stream atEnd not and: [ stream next = $? ]) ifFalse: [ ^ nil ].
	x := (stream upTo: $,) greaseInteger.
	(x isNil or: [ stream atEnd ]) ifTrue: [ ^ nil ].
	y := stream upToEnd greaseInteger.
	y isNil ifTrue: [ ^ nil ].
	^ x @ y! !
!WAMapCallback categoriesFor: #valueForField:!converting!public! !

WAUploadCallback guid: (GUID fromString: '{8A1CCAA3-EF02-46F3-A240-3DC129817835}')!
WAUploadCallback comment: ''!
!WAUploadCallback categoriesForClass!Unclassified! !
!WAUploadCallback methodsFor!

valueForField: anObject
	^ (anObject isKindOf: WAFile) ifTrue: [ anObject ]! !
!WAUploadCallback categoriesFor: #valueForField:!converting!public! !

WAValuesCallback guid: (GUID fromString: '{2865585D-93FA-400B-B3D7-AC10F11F3306}')!
WAValuesCallback comment: ''!
!WAValuesCallback categoriesForClass!Unclassified! !
!WAValuesCallback methodsFor!

evaluateWithArgument: anObject
	values at: anObject greaseInteger ifPresent: [ :value | block valueWithPossibleArguments: (Array with: value) ]!

values
	^values!

values: aDictionary 
	values := aDictionary! !
!WAValuesCallback categoriesFor: #evaluateWithArgument:!evaluation!public! !
!WAValuesCallback categoriesFor: #values!accessing!public! !
!WAValuesCallback categoriesFor: #values:!accessing!public! !

!WAValuesCallback class methodsFor!

on: aBlock values: aDictionary
	^ self new block: aBlock; values: aDictionary; yourself! !
!WAValuesCallback class categoriesFor: #on:values:!instance creation!public! !

WAMultipleValuesCallback guid: (GUID fromString: '{B41B4F24-9083-4CDA-98C4-8E217D4735F4}')!
WAMultipleValuesCallback comment: ''!
!WAMultipleValuesCallback categoriesForClass!Unclassified! !
!WAMultipleValuesCallback methodsFor!

evaluateWithFieldValues: anOrderedCollection
	| selectedValues keys |
	selectedValues := OrderedCollection new.
	keys := anOrderedCollection collect: [ :each | each isNil ifFalse: [ each greaseInteger ] ].
	keys do: [:each | values at: each ifPresent: [ :value | selectedValues add: value ] ].
	block valueWithPossibleArguments: (Array with: selectedValues) ! !
!WAMultipleValuesCallback categoriesFor: #evaluateWithFieldValues:!evaluation!public! !

WARevealedConditionalComment guid: (GUID fromString: '{37CEEF88-87D9-431B-BB19-62B87AC70430}')!
WARevealedConditionalComment comment: '
A WAConditionalComment is an implementation of Downlevel-revealed Conditional Comments:
http://msdn2.microsoft.com/en-us/library/ms537512.aspx
Non-IE family browsers see them always.

See also WAOpeningRevealedConditionalComment and WARevealedConditionalComment.'!
!WARevealedConditionalComment categoriesForClass!Unclassified! !
!WARevealedConditionalComment methodsFor!

closingConditionClass
	^WAClosingRevealedConditionalComment!

openingConditionClass
	^WAOpeningRevealedConditionalComment! !
!WARevealedConditionalComment categoriesFor: #closingConditionClass!private! !
!WARevealedConditionalComment categoriesFor: #openingConditionClass!private! !

WASystemConfiguration guid: (GUID fromString: '{3CF3DE74-8431-46DB-9E8F-C9404EE80A34}')!
WASystemConfiguration comment: '
You should subclass WASystemConfiguration to define new attributes. The method #describeOn: is passed an instance of WAConfigurationDescription which can be used to create new attributes. The attributes can be configured to specify their default value, label, and so on. See the methods on WAAttribute and its subclasses to see what options are available.

If a configuration needs to override the value of another WASystemConfiguration or depends on its attributes, implement the method "parents", returning a collection of configuration objects.

WASystemConfiguration subclasses are "read-only" in that their attributes, parents, and default values are all specified in code. Users and applications that want to configure values for attributes should create a WAUserConfiguration and specify the WASystemConfiguration in its ancestry.

WASystemConfiguration classes are singleton. You should use #instance on the class side to get the current instance. You cannot call #copy on a WASystemConfiguration.

Subclasses should implement the following messages:
	describeOn:
		
They may also want to implement:
	parents'!
!WASystemConfiguration categoriesForClass!Unclassified! !
!WASystemConfiguration methodsFor!

attributes
	^ self description attributes!

buildDescription
	| d |
	d := WAConfigurationDescription new.
	self describeOn: d.
	^ description := d!

clearDescription
	description := nil!

copy
	^ self error: 'SystemConfigurations are singletons and should not be copied.'!

describeOn: conf
	"Should be implemented by subclasses to add attributes and value overrides to the configuration"!

description
	^ description isNil 
		ifFalse: [ description ]
		ifTrue: [ self buildDescription ]!

expressionAt: aSymbol ifAbsent: absentBlock
	^ self description expressions at: aSymbol ifAbsent: absentBlock.!

localAttributeAt: aSymbol ifAbsent: absentBlock
	^ self attributes at: aSymbol ifAbsent: absentBlock!

localAttributesDo: aBlock
	self attributes do: aBlock! !
!WASystemConfiguration categoriesFor: #attributes!private! !
!WASystemConfiguration categoriesFor: #buildDescription!description!public! !
!WASystemConfiguration categoriesFor: #clearDescription!description!public! !
!WASystemConfiguration categoriesFor: #copy!copying!public! !
!WASystemConfiguration categoriesFor: #describeOn:!description!public! !
!WASystemConfiguration categoriesFor: #description!private! !
!WASystemConfiguration categoriesFor: #expressionAt:ifAbsent:!public!values! !
!WASystemConfiguration categoriesFor: #localAttributeAt:ifAbsent:!attributes!public! !
!WASystemConfiguration categoriesFor: #localAttributesDo:!attributes!public! !

!WASystemConfiguration class methodsFor!

clearAllDescriptions
	self allSubclasses do: [ :each | each instance clearDescription ]!

instance
	^ instance ifNil: [ instance := self basicNew initialize ]!

new
	^ self error: 'SystemConfigurations are singletons. Use #instance.'! !
!WASystemConfiguration class categoriesFor: #clearAllDescriptions!actions!public! !
!WASystemConfiguration class categoriesFor: #instance!accessing!public! !
!WASystemConfiguration class categoriesFor: #new!instance creation!public! !

WAUserConfiguration guid: (GUID fromString: '{DF9CB4C4-84A3-4CB0-B205-7071DD07D8A3}')!
WAUserConfiguration comment: '
WAUserConfiguration is a composite of configurations.  This composite of configurations is stored in the field "parents". WAUserConfiguration provides methods to dynamically provide non-default values for attributes. WAUserConfiguration inherits attributes and values defined in its ancestors. If WAUserConfiguration does not have a value for an attribute it will search its ancestors for a value, stopping when it finds a value.

An instance of WAUserConfiguration is the first configuration added to a Seaside application (WAApplication). All other configurations added to the application are added as ancestors of this instance. When a value for an attribute is set either by the standard Seaside component configuration page or in code the value is added to the "values" dictionary in WAUserConfiguration.

Instance Variables:
	parents	<Collection of: WAConfiguration>	 hierarchy of configurations defining all attributes for this instance of WAUserConfiguration
	values	<Dictionary>	the dictionary key is an attribute key, dictionary value is value of that attribute 
'!
!WAUserConfiguration categoriesForClass!Unclassified! !
!WAUserConfiguration methodsFor!

addParent: aConfiguration
	(self parents includes: aConfiguration)
		ifTrue: [ ^ aConfiguration ].
	(self canAddParent: aConfiguration) 
		ifTrue: [ parents add: aConfiguration ]
		ifFalse: [ WAConfigurationError signal: 'Cannot add this configuration as a parent. Would this cause a circular ancestry graph?' ].
	^ aConfiguration!

at: aSymbol addAll: aCollection
	^ self at: aSymbol addAll: aCollection removeAll: #()!

at: aSymbol addAll: additions removeAll: removals
	^ self
		storeExpression:
			((WAAddRemoveExpression key: aSymbol)
				additions: additions;
				removals: removals;
				yourself)
		forAttribute: (self attributeAt: aSymbol)!

at: aSymbol put: anObject
	"It would be faster to simply add the value to the dictionary and
	implement #takeValue:forAttribute: in terms of this method, but
	config options are set only rarely and this ensures you are setting
	a value for an attribute that actually exists."

	^ self takeValue: anObject forAttribute: (self attributeAt: aSymbol)!

canAddParent: aConfiguration 
	^ (aConfiguration = self or: [ aConfiguration inheritsFrom: self ]) not!

expressionAt: aSymbol ifAbsent: errorBlock
	^ expressions at: aSymbol ifAbsent: errorBlock!

initialize
	super initialize.
	expressions := Dictionary new.
	parents := OrderedCollection new!

localAttributeAt: aSymbol ifAbsent: absentBlock
	^ absentBlock value!

localAttributesDo: aBlock
	"we have no local attributes -- do nothing"!

moveParentDown: aConfiguration 
	| index |
	index := parents indexOf: aConfiguration ifAbsent: [ ^ self ].
	index < parents size ifTrue: [ parents swap: index with: index + 1 ]!

moveParentUp: aConfiguration 
	| index |
	index := parents indexOf: aConfiguration ifAbsent: [ ^ self ].
	index > 1 ifTrue: [ parents swap: index with: index - 1 ]!

parents
	^ parents!

postCopy
	super postCopy.
	expressions := expressions copy.
	parents := parents copy.!

removeExpressionAt: aSymbol
	^ self removeExpressionAt: aSymbol ifAbsent: [ nil ]!

removeExpressionAt: aSymbol ifAbsent: aBlock
	^ expressions removeKey: aSymbol ifAbsent: aBlock!

removeParent: aConfiguration 
	parents 
		remove: aConfiguration
		ifAbsent: [ ]!

storeExpression: anAttributeExpression forAttribute: anAttribute
	^ expressions at: anAttribute key put: anAttributeExpression!

takeValue: anObject forAttribute: anAttribute
	^ anObject isNil ifFalse: [
		self
			storeExpression:
				((WAValueExpression key: anAttribute key)
					value: anObject;
					yourself)
			forAttribute: anAttribute ]!

takeValueFromString: aString forAttribute: anAttribute
	^ self takeValue: (anAttribute valueFromString: aString) forAttribute: anAttribute!

valueAt: aSymbol put: anObject 
	self 
		greaseDeprecatedApi: 'WAUserConfiguration>>#valueAt:put:'
		details: 'Use #at:put:.'.
	^ self 
		at: aSymbol
		put: anObject! !
!WAUserConfiguration categoriesFor: #addParent:!ancestry!public! !
!WAUserConfiguration categoriesFor: #at:addAll:!public!values! !
!WAUserConfiguration categoriesFor: #at:addAll:removeAll:!public!values! !
!WAUserConfiguration categoriesFor: #at:put:!public!values! !
!WAUserConfiguration categoriesFor: #canAddParent:!ancestry!public! !
!WAUserConfiguration categoriesFor: #expressionAt:ifAbsent:!public!values! !
!WAUserConfiguration categoriesFor: #initialize!initialization!public! !
!WAUserConfiguration categoriesFor: #localAttributeAt:ifAbsent:!attributes!public! !
!WAUserConfiguration categoriesFor: #localAttributesDo:!attributes!public! !
!WAUserConfiguration categoriesFor: #moveParentDown:!ancestry!public! !
!WAUserConfiguration categoriesFor: #moveParentUp:!ancestry!public! !
!WAUserConfiguration categoriesFor: #parents!ancestry!public! !
!WAUserConfiguration categoriesFor: #postCopy!copying!public! !
!WAUserConfiguration categoriesFor: #removeExpressionAt:!public!values! !
!WAUserConfiguration categoriesFor: #removeExpressionAt:ifAbsent:!public!values! !
!WAUserConfiguration categoriesFor: #removeParent:!ancestry!public! !
!WAUserConfiguration categoriesFor: #storeExpression:forAttribute:!public!values! !
!WAUserConfiguration categoriesFor: #takeValue:forAttribute:!public!values! !
!WAUserConfiguration categoriesFor: #takeValueFromString:forAttribute:!public!values! !
!WAUserConfiguration categoriesFor: #valueAt:put:!public! !

WAAuthConfiguration guid: (GUID fromString: '{EA7A0457-101B-4C7B-BB11-FFED0D790573}')!
WAAuthConfiguration comment: '
WAAuthConfiguration defines attributes to store a username and password for an application. It is used by WAApplication to provide a basic single-account authentication mechanism for applications like the Seaside Configuration application. It changes to mainClass for the session to WAAuthMain, which adds a Decoration to check for authentication before displaying the root component.

You can implement your own authentication mechanism without using this configuration by subclassing WAApplication and implementing #verifyPassword:forUser: to lookup account details from a database or similar. You can then manually set WAAuthMain as your main class.
'!
!WAAuthConfiguration categoriesForClass!Unclassified! !
!WAAuthConfiguration methodsFor!

describeOn: config
	(config string: #login)
		group: #authentication;
		comment: 'The username for this application.'.
	(config password: #passwordHash)
		group: #authentication;
		comment: 'The password for this application.';
		label: 'Password'.! !
!WAAuthConfiguration categoriesFor: #describeOn:!description!public! !

WACacheCapacityConfiguration guid: (GUID fromString: '{4FE393AC-039A-420F-8AD4-0C0E11AAF2E8}')!
WACacheCapacityConfiguration comment: ''!
!WACacheCapacityConfiguration categoriesForClass!Unclassified! !
!WACacheCapacityConfiguration methodsFor!

describeOn: config
	(config integer: #cacheCapacity)
		comment: 'The maximum number of objects to keep in the cache.';
		default: 20! !
!WACacheCapacityConfiguration categoriesFor: #describeOn:!description!public! !

WACacheTimeoutConfiguration guid: (GUID fromString: '{E3C3446E-5378-498D-B191-3F6D6831EF06}')!
WACacheTimeoutConfiguration comment: ''!
!WACacheTimeoutConfiguration categoriesForClass!Unclassified! !
!WACacheTimeoutConfiguration methodsFor!

describeOn: config
	(config integer: #cacheTimeout)
		comment: 'The maximum lifetime of a cached object in seconds';
		default: 600! !
!WACacheTimeoutConfiguration categoriesFor: #describeOn:!description!public! !

WAExceptionFilterConfiguration guid: (GUID fromString: '{4D800EBD-F681-4DBB-AA7C-C21A65D46504}')!
WAExceptionFilterConfiguration comment: ''!
!WAExceptionFilterConfiguration categoriesForClass!Unclassified! !
!WAExceptionFilterConfiguration methodsFor!

describeOn: config
	(config list: #exceptionHandler)
		options: [ self exceptionHandlerClasses ];
		default: WAErrorHandler.!

exceptionHandlerClasses
	^ WAExceptionHandler withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !
!WAExceptionFilterConfiguration categoriesFor: #describeOn:!description!public! !
!WAExceptionFilterConfiguration categoriesFor: #exceptionHandlerClasses!description!public! !

WAFileHandlerConfiguration guid: (GUID fromString: '{6924609F-E0EA-4635-9343-B44D651CD5F2}')!
WAFileHandlerConfiguration comment: ''!
!WAFileHandlerConfiguration categoriesForClass!Unclassified! !
!WAFileHandlerConfiguration methodsFor!

describeOn: config
	(config list: #fileHandlerListingClass)
		beAdvanced;
		options: [ self listingClasses ];
		default: WAForbiddenFileHandlerListing!

listingClasses
	^ WAFileHandlerListing allSubclasses asSortedCollection: [ :a :b | a name <= b name ]!

parents
	^ Array with: WARequestHandlingConfiguration instance! !
!WAFileHandlerConfiguration categoriesFor: #describeOn:!description!public! !
!WAFileHandlerConfiguration categoriesFor: #listingClasses!description!public! !
!WAFileHandlerConfiguration categoriesFor: #parents!ancestry!public! !

WARegistryConfiguration guid: (GUID fromString: '{2989A13C-CA2D-4CCC-826B-2AE005778AB3}')!
WARegistryConfiguration comment: ''!
!WARegistryConfiguration categoriesForClass!Unclassified! !
!WARegistryConfiguration methodsFor!

describeOn: config
	(config boolean: #useCookies)
		comment: 'Whether cookies should be generated and honoured for registry keys. Will fall back to URL if the client does not support cookies.';
		default: false.!

parents
	^ Array with: WARequestHandlingConfiguration instance! !
!WARegistryConfiguration categoriesFor: #describeOn:!description!public! !
!WARegistryConfiguration categoriesFor: #parents!ancestry!public! !

WARequestHandlingConfiguration guid: (GUID fromString: '{3FD3B3EC-7E5C-4C79-8361-CD5427DFF273}')!
WARequestHandlingConfiguration comment: 'This configuration class holds attributes needed by classes in the Request Handling layer.'!
!WARequestHandlingConfiguration categoriesForClass!Unclassified! !
!WARequestHandlingConfiguration methodsFor!

describeOn: config 
	(config string: #charSet)
		beAdvanced;
		label: 'Character Set';
		comment: 'The character set reported to the browser. This is only used if you set the encoding in the server to ''(none)''.';
		default: 'utf-8'.
	(config list: #documentClass)
		beAdvanced;
		options: [ self documentClasses ];
		default: WAHtmlDocument.
	(config list: #scriptGeneratorClass)
		beAdvanced;
		options: [ self scriptGeneratorClasses ];
		default: WADefaultScriptGenerator.
	(config list: #responseGenerator)
		beAdvanced;
		options: [ self responseGenerators ];
		default: WAResponseGenerator.
	(config list: #serverProtocol)
		beAdvanced;
		group: #server;
		comment: 'The protocol in URLs generated by Seaside.';
		options: [ self serverProtocols ].
	(config string: #serverHostname)
		beAdvanced;
		group: #server;
		comment: 'The hostname in URLs generated by Seaside.'.
	(config integer: #serverPort)
		beAdvanced;
		group: #server;
		comment: 'The port in URLs generated by Seaside.'.
	(config string: #serverPath)
		group: #server;
		comment: 'The path in URLs generated by Seaside.'!

documentClasses
	^ WADocument withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]!

responseGenerators
	^ WAResponseGenerator withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]!

scriptGeneratorClasses
	^ WAScriptGenerator allSubclasses asSortedCollection: [ :a :b | a name <= b name ]!

serverProtocols
	^ #('http' 'https')! !
!WARequestHandlingConfiguration categoriesFor: #describeOn:!description!public! !
!WARequestHandlingConfiguration categoriesFor: #documentClasses!private! !
!WARequestHandlingConfiguration categoriesFor: #responseGenerators!private! !
!WARequestHandlingConfiguration categoriesFor: #scriptGeneratorClasses!private! !
!WARequestHandlingConfiguration categoriesFor: #serverProtocols!private! !

WARetrievalIntervalReapingStrategyConfiguration guid: (GUID fromString: '{26D637BB-AA0C-4795-8364-6B0E3F4E9912}')!
WARetrievalIntervalReapingStrategyConfiguration comment: ''!
!WARetrievalIntervalReapingStrategyConfiguration categoriesForClass!Unclassified! !
!WARetrievalIntervalReapingStrategyConfiguration methodsFor!

describeOn: config
	(config integer: #cacheReapInterval)
		comment: 'The number of cache retrievals that are allowed before expired objects are reaped from the cache.';
		default: 10! !
!WARetrievalIntervalReapingStrategyConfiguration categoriesFor: #describeOn:!description!public! !

WASharedConfiguration guid: (GUID fromString: '{2267F9FD-3813-4529-AE3B-6E73B93DF5E6}')!
WASharedConfiguration comment: ''!
!WASharedConfiguration categoriesForClass!Unclassified! !
!WASharedConfiguration methodsFor!

initializeWithName: aString
	self initialize.
	name := aString!

isShared
	^ true!

name
	^ name!

unregister
	self class unregister: self! !
!WASharedConfiguration categoriesFor: #initializeWithName:!initialization!public! !
!WASharedConfiguration categoriesFor: #isShared!public!testing! !
!WASharedConfiguration categoriesFor: #name!accessing!public! !
!WASharedConfiguration categoriesFor: #unregister!actions!public! !

!WASharedConfiguration class methodsFor!

configurations
	^ instances copy!

initialize
	instances := Set new!

named: aString
	"Answer a shared configuration with the given name aString or answer a newly created one."
	
	^ instances
		detect: [ :each | each name = aString ]
		ifNone: [
			instances add: (self basicNew
				initializeWithName: aString;
				yourself) ]!

new
	self error: 'Create or retrieve shared configurations by sending the message #named:'!

unregister: aConfiguration
	"Removes aConfiguration from the list of known configurations."
	
	^ instances remove: aConfiguration ifAbsent: [ nil ]! !
!WASharedConfiguration class categoriesFor: #configurations!accessing!public! !
!WASharedConfiguration class categoriesFor: #initialize!initialization!public! !
!WASharedConfiguration class categoriesFor: #named:!instance creation!public! !
!WASharedConfiguration class categoriesFor: #new!instance creation!public! !
!WASharedConfiguration class categoriesFor: #unregister:!instance creation!public! !

WAAttribute guid: (GUID fromString: '{83C66A32-B713-4351-8F2B-AF219F29526D}')!
WAAttribute comment: '
WAConfigurationAttribute represents a value of a specified type in a Seaside configuration. Some attributes are needed by Seaside for application parameters like deployment Mode and session timeout. Optional attributes like a database login may be used internally by the application.

Each subclass of WAConfigurationAttribute handles one type (Number, Boolean, etc) of attribute. The "group" of the attribute is used to place all attributes in the same group together on the Seaside configuration page. The "key" of the attribute identifies the attribute. Attribute keys must be globally unique so use namespacing where required to ensure uniqueness. See WAConfiguration for example of accessing a configuration attribute. 

Subclasses may implement their own configuration options depending on their needs.

Subclasses must implement the following messages:
	valueFromString: aString
		convert "aString" into type represented by the class, return result of the conversion
	
	accept: aVisitor with: anObject
		Typical implementation is:
			aVisitor visitXXXAttribute: self with: anObject

		where XXX is the type of this attribute. The method visitXXXAttribute:with: must be implemented in all visitors, in particular WAConfigurationEditor which creates the configuration page for Seaside applications.

Instance Variables:
	configuration	<WAConfiguration>	The configuration object that defined the attribute
	group	<Symbol>	name of the group the attribute belongs to
	key	<Symbol>	key or name of the attribute, used to look up the attribute
	comment	<String> a full length description of the attribute for displaying in the configuration interface
	label	<String>	a short field label used in the user interface. If not specified, a label is constructed from the key.
	default	<Object>	The default value for the attribute.'!
!WAAttribute categoriesForClass!Unclassified! !
!WAAttribute methodsFor!

accept: aVisitor
	aVisitor visitAttribute: self!

beAdvanced
	advanced := true!

comment
	"Answer a comment or help text of the receiving attribute."

	^ comment!

comment: aString
	comment := aString!

default
	"Answer a default value for the receiving attribute."

	^ default!

default: anObject
	default := anObject!

group
	"Answer the group of the receiving attribute."
	
	^ group ifNil: [ #general ]!

group: aSymbol
	group := aSymbol!

initializeWithKey: aSymbol
	super initializeWithKey: aSymbol.
	advanced := false!

isAdvanced
	"Answer whether this is an advanced option and should be hidden by default in the configuration editor so as not to overwhelm new users."

	^ advanced!

label
	"Answer the label of the receiving attribute."

	^ label ifNil: [ self labelForSelector: self key ]!

label: aString
	label := aString!

printOn: aStream 
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self key greaseString;
		nextPut: $)!

stringForValue: anObject 
	^ anObject isNil ifFalse: [ anObject greaseString ]!

valueFromString: aString
	self subclassResponsibility! !
!WAAttribute categoriesFor: #accept:!public!visiting! !
!WAAttribute categoriesFor: #beAdvanced!actions!public! !
!WAAttribute categoriesFor: #comment!accessing!public! !
!WAAttribute categoriesFor: #comment:!accessing!public! !
!WAAttribute categoriesFor: #default!accessing!public! !
!WAAttribute categoriesFor: #default:!accessing!public! !
!WAAttribute categoriesFor: #group!accessing!public! !
!WAAttribute categoriesFor: #group:!accessing!public! !
!WAAttribute categoriesFor: #initializeWithKey:!initialization!public! !
!WAAttribute categoriesFor: #isAdvanced!public!testing! !
!WAAttribute categoriesFor: #label!accessing!public! !
!WAAttribute categoriesFor: #label:!accessing!public! !
!WAAttribute categoriesFor: #printOn:!printing!public! !
!WAAttribute categoriesFor: #stringForValue:!converting!public! !
!WAAttribute categoriesFor: #valueFromString:!converting!public! !

WAAttributeExpression guid: (GUID fromString: '{11D6097E-2C0F-4345-9131-7E21CD473446}')!
WAAttributeExpression comment: ''!
!WAAttributeExpression categoriesForClass!Unclassified! !
!WAAttributeExpression methodsFor!

determineValueWithContext: aContext configuration: aConfiguration
	self subclassResponsibility! !
!WAAttributeExpression categoriesFor: #determineValueWithContext:configuration:!public!values! !

WABooleanAttribute guid: (GUID fromString: '{501666B5-6B91-4ACF-9275-5075B49E3135}')!
WABooleanAttribute comment: 'WABooleanAttribute  represents a boolean attribute. It converts between text entered on the configuration page and boolean values.'!
!WABooleanAttribute categoriesForClass!Unclassified! !
!WABooleanAttribute methodsFor!

accept: aVisitor
	aVisitor visitBooleanAttribute: self!

valueFromString: aString
	^ aString = 'true'
		ifTrue: [ true ]
		ifFalse: [
			aString = 'false'
				 ifTrue: [ false ]
				 ifFalse: [ WAConfigurationError signal: 'Invalid value for boolean attribute' ] ]! !
!WABooleanAttribute categoriesFor: #accept:!public!visiting! !
!WABooleanAttribute categoriesFor: #valueFromString:!converting!public! !

WAListAttribute guid: (GUID fromString: '{AC88BB0E-DFEA-4882-AC08-A72B63A19606}')!
WAListAttribute comment: '
WAListAttribute is an attribute that is restricted to a list of values. 

Instance Variables:
	options	<Block>	A block returning a list of possible values for the attribute'!
!WAListAttribute categoriesForClass!Unclassified! !
!WAListAttribute methodsFor!

accept: aVisitor
	aVisitor visitListAttribute: self!

options
	^ optionsBlock isNil
		ifTrue: [ #() ]
		ifFalse: [ optionsBlock value ]!

options: aBlock
	optionsBlock := aBlock!

valueFromString: aString 
	self error: 'List attributes cannot be converted from Strings'! !
!WAListAttribute categoriesFor: #accept:!public!visiting! !
!WAListAttribute categoriesFor: #options!accessing!public! !
!WAListAttribute categoriesFor: #options:!accessing!public! !
!WAListAttribute categoriesFor: #valueFromString:!converting!public! !

WANumberAttribute guid: (GUID fromString: '{B237D5C9-2497-46E6-83C9-1090613C39AE}')!
WANumberAttribute comment: '
WANumberAttribute represents a number attribute. It converts between text entered on the configuration page and numbers.
'!
!WANumberAttribute categoriesForClass!Unclassified! !
!WANumberAttribute methodsFor!

accept: aVisitor
	aVisitor visitNumberAttribute: self!

valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [ Number readFrom: aString readStream ]! !
!WANumberAttribute categoriesFor: #accept:!public!visiting! !
!WANumberAttribute categoriesFor: #valueFromString:!converting!public! !

WAPasswordAttribute guid: (GUID fromString: '{C75F1D2A-0254-407C-892D-CC825E3B1FB9}')!
WAPasswordAttribute comment: '
WAPasswordAttribute represents a password attribute. When set from a string, it records a hashed value. On the Seaside configuration page it does not display its current value.
'!
!WAPasswordAttribute categoriesForClass!Unclassified! !
!WAPasswordAttribute methodsFor!

accept: aVisitor
	aVisitor visitPasswordAttribute: self!

valueFromString: aString 
	^ aString isEmptyOrNil ifFalse: [ GRPlatform current secureHashFor: aString ]! !
!WAPasswordAttribute categoriesFor: #accept:!public!visiting! !
!WAPasswordAttribute categoriesFor: #valueFromString:!converting!public! !

WAStringAttribute guid: (GUID fromString: '{BB8550A6-E05F-492C-8F74-7A20014267CA}')!
WAStringAttribute comment: 'WAStringAttribute represents a string attribute. It does the trivial conversion between text entered on the Seaside configuration page and a string.'!
!WAStringAttribute categoriesForClass!Unclassified! !
!WAStringAttribute methodsFor!

accept: aVisitor
	aVisitor visitStringAttribute: self!

valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [ aString ]! !
!WAStringAttribute categoriesFor: #accept:!public!visiting! !
!WAStringAttribute categoriesFor: #valueFromString:!converting!public! !

WAUrlAttribute guid: (GUID fromString: '{6C27728A-90CF-4829-B862-C2EF3B3E205F}')!
WAUrlAttribute comment: 'WAUrlAttribute represents a URL attribute. It converts between text entered on the configuration page and WAUrl instances.'!
!WAUrlAttribute categoriesForClass!Unclassified! !
!WAUrlAttribute methodsFor!

accept: aVisitor
	aVisitor visitUrlAttribute: self!

valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [ WAUrl absolute: aString ]! !
!WAUrlAttribute categoriesFor: #accept:!public!visitor accepting! !
!WAUrlAttribute categoriesFor: #valueFromString:!converting!public! !

WACollectionAttribute guid: (GUID fromString: '{E3AA291B-7372-49FF-8C8F-B90C9E8E7A9E}')!
WACollectionAttribute comment: ''!
!WACollectionAttribute categoriesForClass!Unclassified! !
!WACollectionAttribute methodsFor!

accept: aVisitor
	aVisitor visitCollectionAttribute: self!

default: aCollection
	super default: (Array withAll: aCollection)!

initializeWithKey: aSymbol
	super initializeWithKey: aSymbol.
	self default: #()! !
!WACollectionAttribute categoriesFor: #accept:!public!visiting! !
!WACollectionAttribute categoriesFor: #default:!accessing!public! !
!WACollectionAttribute categoriesFor: #initializeWithKey:!initialization!public! !

WAIntegerAttribute guid: (GUID fromString: '{A16DC0E0-E8C6-4F02-9EEC-48F34C329238}')!
WAIntegerAttribute comment: ''!
!WAIntegerAttribute categoriesForClass!Unclassified! !
!WAIntegerAttribute methodsFor!

accept: aVisitor
	aVisitor visitIntegerAttribute: self!

valueFromString: aString 
	^ aString isEmptyOrNil ifFalse: [ aString greaseInteger ]! !
!WAIntegerAttribute categoriesFor: #accept:!public!visiting! !
!WAIntegerAttribute categoriesFor: #valueFromString:!converting!public! !

WAAddRemoveExpression guid: (GUID fromString: '{366FE53E-469A-45D8-89F3-47E1E083FF31}')!
WAAddRemoveExpression comment: ''!
!WAAddRemoveExpression categoriesForClass!Unclassified! !
!WAAddRemoveExpression methodsFor!

additions
	^ additions!

additions: aCollection
	additions := aCollection!

determineValueWithContext: aContext configuration: aConfiguration
	| collection result |
	collection := aConfiguration inheritedValueForContext: aContext.
	
	collection isNil ifTrue: [ collection := aContext attribute default ].
	collection isNil ifTrue: [ collection := Array new ].
	
	result := OrderedCollection withAll: collection.
	result := result reject: [ :each |
		(self additions includes: each)
			or: [ self removals includes: each ] ].
	result addAll: self additions.
	
	^ result asArray!

removals
	^ removals!

removals: anObject
	removals := anObject! !
!WAAddRemoveExpression categoriesFor: #additions!accessing!public! !
!WAAddRemoveExpression categoriesFor: #additions:!accessing!public! !
!WAAddRemoveExpression categoriesFor: #determineValueWithContext:configuration:!public!values! !
!WAAddRemoveExpression categoriesFor: #removals!accessing!public! !
!WAAddRemoveExpression categoriesFor: #removals:!accessing!public! !

WAValueExpression guid: (GUID fromString: '{23731057-0F8C-4B6C-88B6-6A5A71291D7C}')!
WAValueExpression comment: ''!
!WAValueExpression categoriesForClass!Unclassified! !
!WAValueExpression methodsFor!

determineValueWithContext: aContext configuration: aConfiguration
	^ self value!

value
	^ value!

value: anObject
	value := anObject! !
!WAValueExpression categoriesFor: #determineValueWithContext:configuration:!public!values! !
!WAValueExpression categoriesFor: #value!accessing!public! !
!WAValueExpression categoriesFor: #value:!accessing!public! !

WAXmlDocument guid: (GUID fromString: '{33B74E8E-D17D-46E1-8214-86436DA384BD}')!
WAXmlDocument comment: 'A WAXmlDocument is adds the possiblity to generate XML tags and knows encoders for XML text and URLs.'!
!WAXmlDocument categoriesForClass!Unclassified! !
!WAXmlDocument methodsFor!

closeTag: aString
	"Close the XML tag named aString."

	stream nextPutAll: '</'; nextPutAll: aString; nextPut: $>!

destroy
	super destroy.
	urlEncoder := xmlEncoder := nil!

initializeWithStream: aStream codec: aCodec
	super initializeWithStream: aStream codec: aCodec.
	xmlEncoder := WAXmlEncoder on: aStream.
	urlEncoder := WAUrlEncoder on: aStream codec: aCodec!

openTag: aString
	"Open the XML tag named aString."

	self openTag: aString attributes: nil closed: false!

openTag: aString attributes: anAttributes
	"Open the XML tag named aString with the attribute dictionary anAttributes."

	self openTag: aString attributes: anAttributes closed: false!

openTag: aString attributes: anAttributes closed: aBoolean
	"Open the XML tag named aString with the attribute dictionary anAttributes. Immediately close the tag if aBoolean is true."
	
	stream nextPut: $<; nextPutAll: aString.
	anAttributes encodeOn: self.
	aBoolean ifTrue: [ stream nextPut: $/ ].
	stream nextPut: $>!

print: anObject
	anObject encodeOn: self!

urlEncoder
	"Answer an encoder for URL data."

	^ urlEncoder!

xmlEncoder
	"Answer an encoder for XML data."

	^ xmlEncoder! !
!WAXmlDocument categoriesFor: #closeTag:!public!writing! !
!WAXmlDocument categoriesFor: #destroy!initialization!public! !
!WAXmlDocument categoriesFor: #initializeWithStream:codec:!initialization!public! !
!WAXmlDocument categoriesFor: #openTag:!public!writing! !
!WAXmlDocument categoriesFor: #openTag:attributes:!public!writing! !
!WAXmlDocument categoriesFor: #openTag:attributes:closed:!public!writing! !
!WAXmlDocument categoriesFor: #print:!public!writing! !
!WAXmlDocument categoriesFor: #urlEncoder!accessing!public! !
!WAXmlDocument categoriesFor: #xmlEncoder!accessing!public! !

WAHtmlDocument guid: (GUID fromString: '{A89050DB-93A4-41D8-B049-5F58E98D4069}')!
WAHtmlDocument comment: 'A WAHtmlDocument controls how a string is created from a series of brushes.'!
!WAHtmlDocument categoriesForClass!Unclassified! !
!WAHtmlDocument methodsFor!

addLoadScript: anObject
	^ self scriptGenerator addLoadScript: anObject!

addLoadScriptFirst: anObject
	^ self scriptGenerator addLoadScriptFirst: anObject!

loadScripts
	^ self scriptGenerator loadScripts!

scriptGenerator
	^ scriptGenerator ifNil: [ scriptGenerator := WADefaultScriptGenerator new ]!

scriptGenerator: aScriptGenerator
	scriptGenerator := aScriptGenerator! !
!WAHtmlDocument categoriesFor: #addLoadScript:!public!scripting! !
!WAHtmlDocument categoriesFor: #addLoadScriptFirst:!public!scripting! !
!WAHtmlDocument categoriesFor: #loadScripts!public!scripting! !
!WAHtmlDocument categoriesFor: #scriptGenerator!accessing!public! !
!WAHtmlDocument categoriesFor: #scriptGenerator:!accessing!public! !

WAUnescapedDocument guid: (GUID fromString: '{13311AB6-0132-4BBA-AAA6-A54EC6630318}')!
WAUnescapedDocument comment: 'A WAUnescapedDocument is does not do any escaping.'!
!WAUnescapedDocument categoriesForClass!Unclassified! !
!WAUnescapedDocument methodsFor!

initializeWithStream: aStream codec: aCodec
	super initializeWithStream: aStream codec: aCodec.
	xmlEncoder := aStream! !
!WAUnescapedDocument categoriesFor: #initializeWithStream:codec:!initialization!public! !

WAUrlEncoder guid: (GUID fromString: '{9C4606E2-3614-41E6-9B3A-E3B5CFA2A1FD}')!
WAUrlEncoder comment: '
I do percent-encoding of parts (e.g. path segments and arguments) of a URI.

Additionally, a Codec is given the chance to encode the characters into bytes before being percent-encoded (see http://tools.ietf.org/html/rfc3986#section-2.5). This allows extended characters to be represented in URIs in, for example, UTF-8.'!
!WAUrlEncoder categoriesForClass!Unclassified! !
!WAUrlEncoder methodsFor!

initializeOn: aStream table: anArray codec: aCodec
	self initializeOn: aStream table: anArray.
	codec := aCodec!

nextPut: aCharacter
	self nextPutAll: (String with: aCharacter)!

nextPutAll: aString
	| encoded |
	encoded := codec url encode: aString.
	(GRPlatform current includesUnsafeUrlCharacter: encoded)
		ifTrue: [ super nextPutAll: encoded ]
		ifFalse: [ stream nextPutAll: encoded ]! !
!WAUrlEncoder categoriesFor: #initializeOn:table:codec:!initialization!public! !
!WAUrlEncoder categoriesFor: #nextPut:!accessing!public! !
!WAUrlEncoder categoriesFor: #nextPutAll:!accessing!public! !

!WAUrlEncoder class methodsFor!

encode: aCharacter on: aStream 
	| printer |
	('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.~' includes: aCharacter) ifTrue: [ ^ aStream nextPut: aCharacter ].
	aStream nextPut: $%.
	printer := GRNumberPrinter new.
	printer
		base: 16;
		padding: $0;
		digits: 2;
		uppercase.
	printer 
		print: aCharacter greaseInteger
		on: aStream!

initialize
	self initializeBMP !

maximumCharacterValue
	"String to byte encoding has aleady happened in the server."
	
	^ 16rFF!

on: aStream codec: aCodec
	^ self on: aStream codec: aCodec table: table!

on: aStream codec: aCodec table: anArray
	^ self basicNew initializeOn: aStream table: anArray codec: aCodec; yourself!

on: aStream table: anArray 
	^ self 
		on: aStream
		codec: GRNullCodec new
		table: anArray! !
!WAUrlEncoder class categoriesFor: #encode:on:!private! !
!WAUrlEncoder class categoriesFor: #initialize!initialization!public! !
!WAUrlEncoder class categoriesFor: #maximumCharacterValue!private! !
!WAUrlEncoder class categoriesFor: #on:codec:!instance creation!public! !
!WAUrlEncoder class categoriesFor: #on:codec:table:!instance creation!public! !
!WAUrlEncoder class categoriesFor: #on:table:!instance creation!public! !

WAXmlEncoder guid: (GUID fromString: '{F311422F-FE0B-42F0-BE07-F65CDA23F035}')!
WAXmlEncoder comment: 'I encode XHTML text.'!
!WAXmlEncoder categoriesForClass!Unclassified! !
!WAXmlEncoder methodsFor!

nextPutAll: aString
	(GRPlatform current includesUnsafeXmlCharacter: aString)
		ifTrue: [ super nextPutAll: aString ]
		ifFalse: [ stream nextPutAll: aString ]! !
!WAXmlEncoder categoriesFor: #nextPutAll:!accessing!public! !

!WAXmlEncoder class methodsFor!

encode: aCharacter on: aStream
	aCharacter = $" ifTrue: [ ^ aStream nextPutAll: '&quot;' ].
	aCharacter = $< ifTrue: [ ^ aStream nextPutAll: '&lt;' ].
	aCharacter = $& ifTrue: [ ^ aStream nextPutAll: '&amp;'].
	aCharacter = $> ifTrue: [ ^ aStream nextPutAll: '&gt;' ].
	aStream nextPut: aCharacter!

initialize
	self initializeBMP! !
!WAXmlEncoder class categoriesFor: #encode:on:!private! !
!WAXmlEncoder class categoriesFor: #initialize!initialization!public! !

WAErrorHandler guid: (GUID fromString: '{F1DC3A57-8273-4847-BDEE-0AD11CA722B4}')!
WAErrorHandler comment: '
WAErrorHandler catches Errors and Warnings and provides two methods for handling each type of exception:

handleError:
handleWarning:

If either method is not implemented, the default implementation will call #handleDefault:, which can be used to provide common behaviour for both exception types.'!
!WAErrorHandler categoriesForClass!Unclassified! !
!WAErrorHandler methodsFor!

handleDefault: anException
	"This method provides the default behaviour if subclasses do
	not implement one of the specific handler methods."
	^ self internalError: anException!

handleError: anError
	^ self handleDefault: anError!

handleException: anException
	(Error handles: anException)
		ifTrue: [ ^ self handleError: anException ].
	(Warning handles: anException)
		ifTrue: [ ^ self handleWarning: anException ].

	^ super handleException: anException!

handleWarning: aWarning
	^ self handleDefault: aWarning! !
!WAErrorHandler categoriesFor: #handleDefault:!actions!public! !
!WAErrorHandler categoriesFor: #handleError:!actions!public! !
!WAErrorHandler categoriesFor: #handleException:!actions!public! !
!WAErrorHandler categoriesFor: #handleWarning:!actions!public! !

!WAErrorHandler class methodsFor!

exceptionSelector
	^ super exceptionSelector, Error, Warning!

handleError: anError 
	self 
		greaseDeprecatedApi: 'WAErrorHandler class>>#handleError:'
		details: 'ExceptionHandlers should be allowed to set up their own exception handling code. See WAExceptionHandler class>>handleExceptionsDuring:.'.
	^ self new handleError: anError!

handleWarning: aWarning 
	self 
		greaseDeprecatedApi: 'WAErrorHandler class>>#handleWarning:'
		details: 'ExceptionHandlers should be allowed to set up their own exception handling code. See WAExceptionHandler class>>handleExceptionsDuring:.'.
	^ self new handleWarning: aWarning! !
!WAErrorHandler class categoriesFor: #exceptionSelector!exception handling!public! !
!WAErrorHandler class categoriesFor: #handleError:!public! !
!WAErrorHandler class categoriesFor: #handleWarning:!public! !

WAForbiddenFileHandlerListing guid: (GUID fromString: '{72ADA3FA-D892-4B59-B45C-2DEC2C54E73D}')!
WAForbiddenFileHandlerListing comment: ''!
!WAForbiddenFileHandlerListing categoriesForClass!Unclassified! !
!WAForbiddenFileHandlerListing methodsFor!

responseForLibraries
	context responseGenerator
		forbidden;
		respond!

responseForLibrary: aLibrary 
	context responseGenerator
		forbidden;
		respond! !
!WAForbiddenFileHandlerListing categoriesFor: #responseForLibraries!public!responding! !
!WAForbiddenFileHandlerListing categoriesFor: #responseForLibrary:!public!responding! !

WATextFileHandlerListing guid: (GUID fromString: '{C735313F-92A3-4119-83A8-2F0268156A87}')!
WATextFileHandlerListing comment: ''!
!WATextFileHandlerListing categoriesForClass!Unclassified! !
!WATextFileHandlerListing methodsFor!

responseForLibraries
	context respond: [ :response |
		response contentType: WAMimeType textPlain.
		handler libraries do: [ :each |
			response stream
				nextPutAll: each name;
				crlf ] ]!

responseForLibrary: aLibrary
	context respond: [ :response |
		response contentType: WAMimeType textPlain.
		aLibrary fileSelectors do: [ :each |
			response stream
				nextPutAll: (aLibrary asFilename: each);
				crlf ] ]! !
!WATextFileHandlerListing categoriesFor: #responseForLibraries!public!responding! !
!WATextFileHandlerListing categoriesFor: #responseForLibrary:!public!responding! !

WABaseElement guid: (GUID fromString: '{29EB41F3-35AD-4A2D-89B8-C218C47CCA00}')!
WABaseElement comment: '
In HTML, links and references to external images, applets, form-processing programs, style sheets, etc. are always specified by a URI. Relative URIs are resolved according to a base URI, which may come from a variety of sources. The BASE element allows authors to specify a document''s base URI explicitly.

When present, the BASE element must appear in the HEAD section of an HTML document, before any element that refers to an external source. The path information specified by the BASE element only affects URIs in the document where the element appears.

For example, given the following BASE declaration and A declaration:
updateRoot: html
	super updateRoot: html.
	html base url: ''http://www.aviary.com/products/intro.html''

renderContentOn: html
	html anchor
		url: ''../cages/birds.gif'';
		with: ''Bird Cages''

the relative URI "../cages/birds.gif" would resolve to:
http://www.aviary.com/cages/birds.gif'!
!WABaseElement categoriesForClass!Unclassified! !
!WABaseElement methodsFor!

tag
	^ 'base'!

target: aString
	self attributeAt: 'target' put: aString!

url: aString
	self attributeAt: 'href' put: aString! !
!WABaseElement categoriesFor: #tag!accessing!public! !
!WABaseElement categoriesFor: #target:!attributes!public! !
!WABaseElement categoriesFor: #url:!attributes!public! !

WAContentElement guid: (GUID fromString: '{E7AC670F-EC2C-4248-B9B0-57824FDBD9F5}')!
WAContentElement comment: 'Common superclass of all elements inside a <head> that can have content. Either between the start and end tag or a (mime) document pointed to by an URL.'!
!WAContentElement categoriesForClass!Unclassified! !
!WAContentElement methodsFor!

charset: aString
	self attributeAt: 'charset' put: aString!

contents: aString
	self document: aString!

document: aString
	self document: aString mimeType: self typeOrNil!

document: aString fileName: fileName
	self document: aString mimeType: self typeOrNil fileName: fileName!

document: aString mimeType: mimeType
	self document: aString mimeType: mimeType fileName: nil!

document: aString mimeType: mimeType fileName: fileName
	self url: (root context urlForDocument: aString mimeType: mimeType fileName: fileName)!

encodeChildrenOn: aDocument 
	children isEmptyOrNil ifTrue: [ ^ self ].
	aDocument nextPutAll: '/*<!![CDATA[*/'.
	children do: [ :each | aDocument nextPutAll: each greaseString ].
	aDocument nextPutAll: '/*]]>*/'!

isClosed
	^ false!

resourceUrl: aString
	self url: (root absoluteUrlForResource: aString)!

type: aMimeTypeOrString
	self attributeAt: 'type' put: aMimeTypeOrString!

typeOrNil
	^ self attributeAt: 'type' ifAbsent:  [ nil ]!

url: aString
	self subclassResponsibility! !
!WAContentElement categoriesFor: #charset:!attributes!public! !
!WAContentElement categoriesFor: #contents:!attributes!public! !
!WAContentElement categoriesFor: #document:!document!public! !
!WAContentElement categoriesFor: #document:fileName:!document!public! !
!WAContentElement categoriesFor: #document:mimeType:!document!public! !
!WAContentElement categoriesFor: #document:mimeType:fileName:!document!public! !
!WAContentElement categoriesFor: #encodeChildrenOn:!printing!public! !
!WAContentElement categoriesFor: #isClosed!public!testing! !
!WAContentElement categoriesFor: #resourceUrl:!attributes!public! !
!WAContentElement categoriesFor: #type:!attributes!public! !
!WAContentElement categoriesFor: #typeOrNil!private! !
!WAContentElement categoriesFor: #url:!attributes!public! !

WAMetaElement guid: (GUID fromString: '{DC35A187-71B8-4FF3-B356-B1E90DF693CE}')!
WAMetaElement comment: '
The META element can be used to identify properties of a document (e.g., author, expiration date, a list of key words, etc.) and assign values to those properties. This specification does not define a normative set of properties.

Each META element specifies a property/value pair. The name attribute identifies the property and the content attribute specifies the property''s value.

For example, the following declaration sets a value for the Author property:
<META name="Author" content="Dave Raggett">

The lang attribute can be used with META to specify the language for the value of the content attribute. This enables speech synthesizers to apply language dependent pronunciation rules.

In this example, the author''s name is declared to be French:

htm meta
	name: ''Author''; language: ''fr''; content: ''Arnaud Le Hors''
	
Note. The META element is a generic mechanism for specifying meta data. However, some HTML elements and attributes already handle certain pieces of meta data and may be used by authors instead of META to specify those pieces: the TITLE element, the ADDRESS element, the INS and DEL elements, the title attribute, and the cite attribute.

Note. When a property specified by a META element takes a value that is a URI, some authors prefer to specify the meta data via the LINK element. Thus, the following meta data declaration:
html meta
      name: ''DC.identifier'';
      content: ''http://www.ietf.org/rfc/rfc1866.txt''

might also be written:
html link
         relationship: ''DC.identifier'';
         type: ''text/plain'';
         url: ''http://www.ietf.org/rfc/rfc1866.txt''

The http-equiv attribute can be used in place of the name attribute and has a special significance when documents are retrieved via the Hypertext Transfer Protocol (HTTP). HTTP servers may use the property name specified by the http-equiv attribute to create an [RFC822]-style header in the HTTP response. Please see the HTTP specification ([RFC2616]) for details on valid HTTP headers.

The following sample META declaration:
htttp meta
         responseHeaderName: ''Expires'';
         content: ''Tue, 20 Aug 1996 14:25:27 GMT''

will result in the HTTP header:
Expires: Tue, 20 Aug 1996 14:25:27 GMT

This can be used by caches to determine when to fetch a fresh copy of the associated document.

Note. Some user agents support the use of META to refresh the current page after a specified number of seconds, with the option of replacing it by a different URI. Authors should not use this technique to forward users to different pages, as this makes the page inaccessible to some users. Instead, automatic page forwarding should be done using server-side redirects.

html meta
         redirectAfter: 5 to: ''http://www.google.com/'''!
!WAMetaElement categoriesForClass!Unclassified! !
!WAMetaElement methodsFor!

beLeftToRight
	self textDirection: 'LTR'!

beRightToLeft
	self textDirection: 'RTL'!

content: aString
	self attributeAt: 'content' put: aString!

contentScriptType: aMimeTypeOrString
	self responseHeaderName: 'Content-Script-Type'.
	self content: aMimeTypeOrString!

contentType: aMimeTypeOrString
	self responseHeaderName: 'Content-Type'.
	self content: aMimeTypeOrString!

encodeBeforeOn: aDocument
	self attributes at: 'content' ifAbsentPut: ''.
	super encodeBeforeOn: aDocument!

language: aString
	self attributeAt: 'lang' put: aString!

name: aString
	self attributeAt: 'name' put: aString!

redirectAfter: seconds to: aString 
	self responseHeaderName: 'refresh'.
	self content: seconds greaseString , ';URL=' , aString!

responseHeaderName: aString
	self attributeAt: 'http-equiv' put: aString!

scheme: aString
	self attributeAt: 'scheme' put: aString!

tag
	^ 'meta'!

textDirection: aString
	self attributeAt: 'dir' put: aString! !
!WAMetaElement categoriesFor: #beLeftToRight!convenience!public! !
!WAMetaElement categoriesFor: #beRightToLeft!convenience!public! !
!WAMetaElement categoriesFor: #content:!attributes!public! !
!WAMetaElement categoriesFor: #contentScriptType:!convenience!public! !
!WAMetaElement categoriesFor: #contentType:!convenience!public! !
!WAMetaElement categoriesFor: #encodeBeforeOn:!printing!public! !
!WAMetaElement categoriesFor: #language:!attributes!public! !
!WAMetaElement categoriesFor: #name:!attributes!public! !
!WAMetaElement categoriesFor: #redirectAfter:to:!convenience!public! !
!WAMetaElement categoriesFor: #responseHeaderName:!attributes!public! !
!WAMetaElement categoriesFor: #scheme:!attributes!public! !
!WAMetaElement categoriesFor: #tag!accessing!public! !
!WAMetaElement categoriesFor: #textDirection:!attributes!public! !

WALinkElement guid: (GUID fromString: '{0B1CD7C4-4530-4DDD-AD87-973FA7C6BE73}')!
WALinkElement comment: '
Defines either a link or style sheet rules. If it has children then it defines style sheet rules, else it defines a link.

= if link =
This element defines a link. Unlike A, it may only appear in the HEAD section of a document, although it may appear any number of times. Although LINK has no content, it conveys relationship information that may be rendered by user agents in a variety of ways (e.g., a tool-bar with a drop-down menu of links).

= style sheet rules =
The STYLE element allows authors to put style sheet rules in the head of the document. HTML permits any number of STYLE elements in the HEAD section of a document.

User agents that don''t support style sheets, or don''t support the specific style sheet language used by a STYLE element, must hide the contents of the STYLE element. It is an error to render the content as part of the document''s text. Some style sheet languages support syntax for hiding the content from non-conforming user agents.'!
!WALinkElement categoriesForClass!Unclassified! !
!WALinkElement methodsFor!

add: anElement
	super add: anElement.
	attributes isNil ifFalse: [
		attributes removeKey: 'rel' ifAbsent: [ "ignore" ] ]!

addAll
	self addMedia: 'all'!

addAural
	self addMedia: 'aural'!

addBraille
	self addMedia: 'braille'!

addHandheld
	self addMedia: 'handheld'!

addMedia: aString
	self attributes addMedia: aString!

addPrint
	self addMedia: 'print'!

addProjection
	self addMedia: 'projection'!

addScreen
	self addMedia: 'screen'!

addTeletype
	self addMedia: 'tty'!

addTelevision
	self addMedia: 'tv'!

beAlternate
	"Gives alternate representations of the current document."
	self relationship: 'alternate'!

beAlternateStylesheet
	self relationship: 'alternate stylesheet'!

beAppendix
	self relationship: 'appendix'!

beArchives
	"Provides a link to a collection of records, documents, or other materials of historical interest."
	self relationship: 'archives'!

beAtom
	self type: 'application/atom+xml' seasideMimeType!

beBookmark
	self relationship: 'bookmark'!

beCanonical
	"Used to specify a canonical URL."

	self relationship: 'canonical'!

beChapter
	self relationship: 'chapter'!

beClossary
	self relationship: 'lossary'!

beCopyright
	self relationship: 'copyright'!

beCss
	self type: WAMimeType textCss!

beFirst
	"Indicates that the current document is a part of a series, and that the first document in the series is the referenced document."
	self relationship: 'first'!

beFontDefinition
	self relationship: 'fontdef'!

beGlossary
	self relationship: 'glossary'!

beHelp
	self relationship: 'help'!

beIndex
	self relationship: 'index'!

beLast
	self relationship: 'last'!

beMicrosummary
	"http://wiki.mozilla.org/Microsummaries"
	self relationship: 'microsummary'!

beNext
	"Indicates that the current document is a part of a series, and that the next document in the series is the referenced document."
	self relationship: 'next'!

bePrevious
	"Indicates that the current document is a part of a series, and that the previous document in the series is the referenced document."
	self relationship: 'previous'!

beRss
	self type: 'application/rss+xml' seasideMimeType!

beSearch
	"Gives a link to a resource that can be used to search through the current document and its related pages. "
	self relationship: 'search'!

beSection
	self relationship: 'section'!

beShortcutIcon
	self relationship: 'shortcut icon'!

beStart
	"Refers to the first document in a collection of documents. This link type tells search engines which document is considered by the author to be the starting point of the collection."
	self relationship: 'start'!

beStylesheet
	"Imports a stylesheet."
	self relationship: 'stylesheet'!

beSubsection
	self relationship: 'subsection'!

beTableOfContents
	self relationship: 'contents'!

beTop
	self relationship: 'top'!

beUp
	"Provides a link to a document giving the context for the current document."
	self relationship: 'up'!

isClosed
	^ children isEmptyOrNil!

media: aString
	"This attribute specifies the intended destination medium for style information. It may be a single media descriptor or a comma-separated list. The default value for this attribute is 'screen'."
	self attributeAt: 'media' put: aString!

relationship: aString
	"This attribute describes the relationship from the current document to the anchor specified by the href attribute. The value of this attribute is a space-separated list of link types."
	
	self attributes at: 'rel' append: aString!

reverse: aString
	"This attribute is used to describe a reverse link from the anchor specified by the href attribute to the current document. The value of this attribute is a space-separated list of link types."
	self attributeAt: 'rev' put: aString!

tag
	^ children isEmptyOrNil
		ifTrue: [ 'link' ]
		ifFalse: [ 'style' ]!

title: aString
	self attributeAt: 'title' put: aString!

url: aString
	self attributeAt: 'href' put: aString! !
!WALinkElement categoriesFor: #add:!accessing-children!public! !
!WALinkElement categoriesFor: #addAll!media!public! !
!WALinkElement categoriesFor: #addAural!media!public! !
!WALinkElement categoriesFor: #addBraille!media!public! !
!WALinkElement categoriesFor: #addHandheld!media!public! !
!WALinkElement categoriesFor: #addMedia:!media!public! !
!WALinkElement categoriesFor: #addPrint!media!public! !
!WALinkElement categoriesFor: #addProjection!media!public! !
!WALinkElement categoriesFor: #addScreen!media!public! !
!WALinkElement categoriesFor: #addTeletype!media!public! !
!WALinkElement categoriesFor: #addTelevision!media!public! !
!WALinkElement categoriesFor: #beAlternate!public!relationship! !
!WALinkElement categoriesFor: #beAlternateStylesheet!public!relationship! !
!WALinkElement categoriesFor: #beAppendix!public!relationship! !
!WALinkElement categoriesFor: #beArchives!public!relationship! !
!WALinkElement categoriesFor: #beAtom!public!type! !
!WALinkElement categoriesFor: #beBookmark!public!relationship! !
!WALinkElement categoriesFor: #beCanonical!public!relationship! !
!WALinkElement categoriesFor: #beChapter!public!relationship! !
!WALinkElement categoriesFor: #beClossary!public!relationship! !
!WALinkElement categoriesFor: #beCopyright!public!relationship! !
!WALinkElement categoriesFor: #beCss!public!type! !
!WALinkElement categoriesFor: #beFirst!public!relationship! !
!WALinkElement categoriesFor: #beFontDefinition!public!relationship! !
!WALinkElement categoriesFor: #beGlossary!public!relationship! !
!WALinkElement categoriesFor: #beHelp!public!relationship! !
!WALinkElement categoriesFor: #beIndex!public!relationship! !
!WALinkElement categoriesFor: #beLast!public!relationship! !
!WALinkElement categoriesFor: #beMicrosummary!public!relationship! !
!WALinkElement categoriesFor: #beNext!public!relationship! !
!WALinkElement categoriesFor: #bePrevious!public!relationship! !
!WALinkElement categoriesFor: #beRss!public!type! !
!WALinkElement categoriesFor: #beSearch!public!relationship! !
!WALinkElement categoriesFor: #beSection!public!relationship! !
!WALinkElement categoriesFor: #beShortcutIcon!public!relationship! !
!WALinkElement categoriesFor: #beStart!public!relationship! !
!WALinkElement categoriesFor: #beStylesheet!public!relationship! !
!WALinkElement categoriesFor: #beSubsection!public!relationship! !
!WALinkElement categoriesFor: #beTableOfContents!public!relationship! !
!WALinkElement categoriesFor: #beTop!public!relationship! !
!WALinkElement categoriesFor: #beUp!public!relationship! !
!WALinkElement categoriesFor: #isClosed!public!testing! !
!WALinkElement categoriesFor: #media:!attributes!public! !
!WALinkElement categoriesFor: #relationship:!attributes!public! !
!WALinkElement categoriesFor: #reverse:!attributes!public! !
!WALinkElement categoriesFor: #tag!accessing!public! !
!WALinkElement categoriesFor: #title:!attributes!public! !
!WALinkElement categoriesFor: #url:!attributes!public! !

WAScriptElement guid: (GUID fromString: '{07F8C9ED-7159-4113-A719-8D42AB8F756E}')!
WAScriptElement comment: '
The SCRIPT element places a script within a document. This element may appear any number of times in the HEAD of an HTML document.

The script may be defined within the contents of the SCRIPT element or in an external file. If the src attribute is not set, user agents must interpret the contents of the element as the script. If the src has a URI value, user agents must ignore the element''s contents and retrieve the script via the URI. Note that the charset attribute refers to the character encoding of the script designated by the src attribute; it does not concern the content of the SCRIPT element.'!
!WAScriptElement categoriesForClass!Unclassified! !
!WAScriptElement methodsFor!

beJavascript
	self type: WAMimeType textJavascript!

defer
	"When set, this boolean attribute provides a hint to the user agent that the script is not going to generate any document content (e.g., no 'document.write' in javascript) and thus, the user agent can continue parsing and rendering."
		self attributeAt: 'defer' put: true!

tag
	^ 'script'!

url: aString
	self attributeAt: 'src' put: aString! !
!WAScriptElement categoriesFor: #beJavascript!public!types! !
!WAScriptElement categoriesFor: #defer!attributes!public! !
!WAScriptElement categoriesFor: #tag!accessing!public! !
!WAScriptElement categoriesFor: #url:!attributes!public! !

WAOpeningRevealedConditionalComment guid: (GUID fromString: '{D3FAE759-7CC3-40BD-9FDF-81AFCD82D4C0}')!
WAOpeningRevealedConditionalComment comment: 'Opens a WARevealedConditionalComment and encodes the condition.'!
!WAOpeningRevealedConditionalComment categoriesForClass!Unclassified! !
!WAOpeningRevealedConditionalComment methodsFor!

encodeOn: aDocument
	aDocument
		nextPutAll: '<!!--[';
		nextPutAll: self condition;
		nextPutAll: ']><!!-->'! !
!WAOpeningRevealedConditionalComment categoriesFor: #encodeOn:!printing!public! !

WAAccept guid: (GUID fromString: '{C1452BF6-F132-40CC-81E8-739CD0A04C8B}')!
WAAccept comment: 'A WAAccept is a WAQualifiedValue with a value that is an instance of WAMimeType. It represents how much a user agent preferes a certain mime type.'!
!WAAccept categoriesForClass!Unclassified! !
!WAAccept class methodsFor!

valueClass
	^WAMimeType! !
!WAAccept class categoriesFor: #valueClass!private! !

WAAcceptCharset guid: (GUID fromString: '{9AA547D9-9AE6-4266-869A-95861300CC13}')!
WAAcceptCharset comment: 'A WAAcceptCharset is a WAQualifiedValue with a value that is an instance of String. It represents how much a user agent preferes a certain character set for the response.'!
!WAAcceptCharset categoriesForClass!Unclassified! !
!WAAcceptCharset class methodsFor!

valueClass
	^String! !
!WAAcceptCharset class categoriesFor: #valueClass!private! !

WAAcceptEncoding guid: (GUID fromString: '{76236274-2AA4-4456-BB3E-2183BCE8171D}')!
WAAcceptEncoding comment: 'A WAAcceptCharset is a WAQualifiedValue with a value that is an instance of String. It represents how much a user agent preferes a certain encoding for the response.'!
!WAAcceptEncoding categoriesForClass!Unclassified! !
!WAAcceptEncoding class methodsFor!

valueClass
	^String! !
!WAAcceptEncoding class categoriesFor: #valueClass!private! !

WAAcceptLanguage guid: (GUID fromString: '{C4F1667D-5EB7-4CEA-A955-5428F30C6C56}')!
WAAcceptLanguage comment: 'A WAAcceptLanguage is a WAQualifiedValue with a value that is an instance of WALocale. It represents how much a user agent preferes a certain locale.'!
!WAAcceptLanguage categoriesForClass!Unclassified! !
!WAAcceptLanguage class methodsFor!

valueClass
	^WALocale! !
!WAAcceptLanguage class categoriesFor: #valueClass!private! !

WACookie guid: (GUID fromString: '{AACF6363-51ED-4795-8C11-71E7CEE0DE3D}')!
WACookie comment: '
I represent a cookie, a piece of information that is stored on the client and read and writable by the server. I am basically a key/value pair of strings.
You can never trust information in a cookie, the client is free to edit it.
I model only a part of the full cookie specification.

Browser support:
http://www.mnot.net/blog/2006/10/27/cookie_fun

Netscape spec
http://cgi.netscape.com/newsref/std/cookie_spec.html

Cookie spec
http://tools.ietf.org/html/rfc2109

Cookie 2 spec
http://tools.ietf.org/html/rfc2965

HttpOnly
http://msdn2.microsoft.com/en-us/library/ms533046.aspx
https://bugzilla.mozilla.org/show_bug.cgi?id=178993

Compared to WARequestCookie I represent the information that is sent to the user agent.'!
!WACookie categoriesForClass!Unclassified! !
!WACookie methodsFor!

comment
	^ comment!

comment: aString
	comment := aString!

commentUrl
	^ commentUrl!

commentUrl: aUrl
	commentUrl := aUrl!

discard
	^ discard!

discard: aBoolean
	discard := aBoolean!

expireIn: aDuration
	"sets the lifetime of the receiver mesaured in a duration"
	self expiry: DateAndTime now + aDuration.
	self maxAge: aDuration asSeconds!

expireInPast
	self maxAge: 0.
	self expiry: (DateAndTime now - (Duration days: 10 hours: 0 minutes: 0 seconds: 0)).!

expireInSeconds: anInteger
	"sets the lifetime of the receiver mesaured in seconds"
	self expiry: (Duration days: 0 hours: 0 minutes: 0 seconds: anInteger).
	self maxAge: anInteger!

expiry
	^ expiry!

expiry: aDateTime
	expiry := aDateTime asUTC!

expiryString
	^ GRPrinter cookieTimestamp print: expiry!

httpOnly
	^ httpOnly!

httpOnly: anObject
	httpOnly := anObject!

initialize
	super initialize.
	self secure: false.
	self discard: false.
	self httpOnly: false.
	self version: 1!

maxAge
	^ maxAge!

maxAge: anInteger
	"Optional.  The Max-Age attribute defines the lifetime of the
	cookie, in seconds.  The delta-seconds value is a decimal non-
	negative integer.  After delta-seconds seconds elapse, the client
	should discard the cookie.  A value of zero means the cookie
	should be discarded immediately."
	maxAge := anInteger!

oldNetscapeString
	"Serializes the receiver accroding to the orginal Netscape spec.
	This has the broadest browser support but limited features.
	It can not be used with HTTP header combining.
	See class comment for a link to the spec."
	^String streamContents: [ :stream |
		self writeKeyValueQuoted: false on: stream.
		self writeExpiresOn: stream.
		self writePathQuoted: false on: stream.
		self writeDomainQuoted: false on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream ]!

oldNetscapeStringWithoutKey
	"same as oldNetscapeString except that the key is not included, used for Kom hacks"
	^String streamContents: [ :stream |
		self value isNil ifFalse: [
			stream nextPutAll: self value ].
		self writeExpiresOn: stream.
		self writePathQuoted: false on: stream.
		self writeDomainQuoted: false on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream ]!

rfc2109String
	"Serializes the receiver accroding to RFC 2109.
	Almost no browser support.
	It can be used with HTTP header combining.
	See class comment for a link to the spec."
	^String streamContents: [ :stream |
		self writeKeyValueQuoted: true on: stream.
		self writeCommentOn: stream.
		self writeMaxAgeOn: stream.
		self writePathQuoted: true on: stream.
		self writeDomainQuoted: true on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream.
		self writeVersionOn: stream ]!

rfc2965String
	"Serializes the receiver accroding to RFC 2965.
	This has the most features but is only supported in Opera.
	It can be used together with other serialization forms.
	It can be used with HTTP header combining.
	See class comment for a link to the spec."
	^String streamContents: [ :stream |
		self writeKeyValueQuoted: true on: stream.
		self writeCommentOn: stream.
		self writeCommentUrlOn: stream.
		self writeMaxAgeOn: stream.
		self writePathQuoted: true on: stream.
		self writePortsOn: stream.
		self writeDomainQuoted: true on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream.
		self writeDiscardOn: stream.
		self writeVersionOn: stream ]!

secure
	^ secure!

secure: aBoolean
	secure := aBoolean!

write: aString asQuotedStringOn: aStream

	aStream nextPut: $".
	aString do: [ :each |
		each = $" 
			ifTrue: [ aStream nextPutAll: '\"']
			ifFalse: [ aStream nextPut: each ] ].
	aStream nextPut: $"!

write: aString quoted: aBoolean on: aStream
	aBoolean
		ifTrue: [
			self
				write: aString
				asQuotedStringOn: aStream ]
		ifFalse: [ aStream nextPutAll: aString ]!

writeCommentOn: aStream
	self comment isNil ifTrue: [ ^self ].
	
	aStream nextPutAll: '; Comment='.
	self
		write: self comment
		asQuotedStringOn: aStream!

writeCommentUrlOn: aStream 
	self commentUrl isNil ifTrue: [ ^ self ].
	aStream nextPutAll: '; CommentURL='.
	self 
		write: self commentUrl greaseString
		asQuotedStringOn: aStream!

writeDiscardOn: aStream
	(self discard notNil and: [ self discard ])
		ifTrue: [ aStream nextPutAll: '; Discard' ]!

writeDomainQuoted: aBoolean on: aStream
	domain isNil ifTrue: [ ^self ].

	aStream nextPutAll: '; domain='.
	self
		write: self domain
		quoted: aBoolean
		on: aStream!

writeExpiresOn: aStream
	expiry isNil ifTrue: [ ^self ].

	aStream
		nextPutAll: '; expires=';
		nextPutAll: self expiryString!

writeHttpOnlyOn: aStream
	self httpOnly
		ifTrue: [ aStream nextPutAll: '; HttpOnly' ]!

writeKeyValueQuoted: aBoolean on: aStream
	aStream nextPutAll: self key.
	aStream nextPut: $=.
	self
		write: (self value ifNil: [ '' ])
		quoted: aBoolean
		on: aStream!

writeMaxAgeOn: aStream
	maxAge isNil ifTrue: [ ^self ].
	
	aStream nextPutAll: '; Max-Age="'.
	aStream print: maxAge.
	aStream nextPut: $".!

writeOn: aStream
	aStream nextPutAll: self oldNetscapeString!

writePathQuoted: aBoolean on: aStream
	path isNil ifTrue: [ ^self ].

	aStream nextPutAll: '; path='.
	self
		write: self path
		quoted: aBoolean
		on: aStream!

writePortsOn: aStream
	ports isEmptyOrNil ifTrue: [ ^self ].
	
	aStream nextPutAll: '; Port="'.
	self ports
		do: [ :each | aStream print: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $".!

writeSecureOn: aStream
	self secure
		ifTrue: [ aStream nextPutAll: '; Secure' ]!

writeVersionOn: aStream
	aStream nextPutAll: '; Version='.
	aStream print: self version! !
!WACookie categoriesFor: #comment!accessing!public! !
!WACookie categoriesFor: #comment:!accessing!public! !
!WACookie categoriesFor: #commentUrl!accessing!public! !
!WACookie categoriesFor: #commentUrl:!accessing!public! !
!WACookie categoriesFor: #discard!accessing!public! !
!WACookie categoriesFor: #discard:!accessing!public! !
!WACookie categoriesFor: #expireIn:!api!public! !
!WACookie categoriesFor: #expireInPast!api!public! !
!WACookie categoriesFor: #expireInSeconds:!api!public! !
!WACookie categoriesFor: #expiry!accessing!public! !
!WACookie categoriesFor: #expiry:!accessing!public! !
!WACookie categoriesFor: #expiryString!private! !
!WACookie categoriesFor: #httpOnly!accessing!public! !
!WACookie categoriesFor: #httpOnly:!accessing!public! !
!WACookie categoriesFor: #initialize!initialization!public! !
!WACookie categoriesFor: #maxAge!accessing!public! !
!WACookie categoriesFor: #maxAge:!accessing!public! !
!WACookie categoriesFor: #oldNetscapeString!public!writing! !
!WACookie categoriesFor: #oldNetscapeStringWithoutKey!public!writing! !
!WACookie categoriesFor: #rfc2109String!public!writing! !
!WACookie categoriesFor: #rfc2965String!public!writing! !
!WACookie categoriesFor: #secure!accessing!public! !
!WACookie categoriesFor: #secure:!accessing!public! !
!WACookie categoriesFor: #write:asQuotedStringOn:!public!writing-private! !
!WACookie categoriesFor: #write:quoted:on:!public!writing-private! !
!WACookie categoriesFor: #writeCommentOn:!public!writing-private! !
!WACookie categoriesFor: #writeCommentUrlOn:!public!writing-private! !
!WACookie categoriesFor: #writeDiscardOn:!public!writing-private! !
!WACookie categoriesFor: #writeDomainQuoted:on:!public!writing-private! !
!WACookie categoriesFor: #writeExpiresOn:!public!writing-private! !
!WACookie categoriesFor: #writeHttpOnlyOn:!public!writing-private! !
!WACookie categoriesFor: #writeKeyValueQuoted:on:!public!writing-private! !
!WACookie categoriesFor: #writeMaxAgeOn:!public!writing-private! !
!WACookie categoriesFor: #writeOn:!public!writing! !
!WACookie categoriesFor: #writePathQuoted:on:!public!writing-private! !
!WACookie categoriesFor: #writePortsOn:!public!writing-private! !
!WACookie categoriesFor: #writeSecureOn:!public!writing-private! !
!WACookie categoriesFor: #writeVersionOn:!public!writing-private! !

!WACookie class methodsFor!

combine: aCollectionOfCookies using: aOneArgumentBlock
	"combines several cookies into one HTTP header line
	aOneArgumentBlock takes a cookie as an argument and returns a string,
	it is supposed to send one of #oldNetscapeString #rfc2109String #rfc2965String to the argument"
	^String streamContents: [ :stream |
		aCollectionOfCookies
			do: [ :each |
				stream nextPutAll: (aOneArgumentBlock value: each) ]
			separatedBy: [ stream nextPutAll: ', ' ] ]! !
!WACookie class categoriesFor: #combine:using:!convenience!public! !

WAAuthenticationFilter guid: (GUID fromString: '{534CDB16-E361-45DB-B7E3-E6A30975BF60}')!
WAAuthenticationFilter comment: 'WAAuthenticationFilter protects a request handler with username and password using the standard HTTP basic authentication. This passes username and password in clear-text, unless used over an encripted HTTPS connection. You should set the authenticator, and object that is able to validate usernames and passwords by implementing #verifyPassword:forUser:.'!
!WAAuthenticationFilter categoriesForClass!Unclassified! !
!WAAuthenticationFilter methodsFor!

authenticator
	"Answer the object used for authentication. Defaults to the owning handler."

	^ authenticator ifNil: [ self handler ]!

authenticator: anObject
	authenticator := anObject!

handleFiltered: aRequestContext 
	(self verifyRequest: aRequestContext request) 
		ifTrue: [ super handleFiltered: aRequestContext ]
		ifFalse: [
			aRequestContext responseGenerator
				authenticate: self realm;
				respond ]!

realm
	"Answer the realm to be displayed in the authentication dialog."
	
	^ realm ifNil: [ realm := 'Seaside' ]!

realm: anObject
	realm := anObject!

verifyRequest: aRequest
	^ self authenticator verifyPassword: aRequest password forUser: aRequest user! !
!WAAuthenticationFilter categoriesFor: #authenticator!accessing!public! !
!WAAuthenticationFilter categoriesFor: #authenticator:!accessing!public! !
!WAAuthenticationFilter categoriesFor: #handleFiltered:!processing!public! !
!WAAuthenticationFilter categoriesFor: #realm!accessing!public! !
!WAAuthenticationFilter categoriesFor: #realm:!accessing!public! !
!WAAuthenticationFilter categoriesFor: #verifyRequest:!public!testing! !

WAConfiguredRequestFilter guid: (GUID fromString: '{2F4EA704-7D6A-4F57-B676-31F0E41CA16E}')!
WAConfiguredRequestFilter comment: ''!
!WAConfiguredRequestFilter categoriesForClass!Unclassified! !
!WAConfiguredRequestFilter methodsFor!

configuration
	^ configuration!

defaultConfiguration
	"Return the configuration (normally a new instance of WAUserConfiguration) to be
	used with the Filter upon initialization."
	
	self subclassResponsibility!

initialize
	super initialize.
	configuration := self defaultConfiguration! !
!WAConfiguredRequestFilter categoriesFor: #configuration!configuration!public! !
!WAConfiguredRequestFilter categoriesFor: #defaultConfiguration!configuration!public! !
!WAConfiguredRequestFilter categoriesFor: #initialize!initialization!public! !

WAProtectionFilter guid: (GUID fromString: '{BE66AD71-8286-45E2-9D5A-F8F231830511}')!
WAProtectionFilter comment: '
The protection filter ensures that the wrapped request handler only accepts requests from the same IP. Do add this filter to a WASession for example to avoid session hijacking, do not add it to static request handlers such as WAApplication or WADispatcher as this might restrict access to the handler if your IP changes.

Note that checking for IP addresses is not bullet proof and should never be used as the sole security measure for a web application as IP addresses can be easily spoofed.'!
!WAProtectionFilter categoriesForClass!Unclassified! !
!WAProtectionFilter methodsFor!

handleFiltered: aRequestContext 
	(self verifyRequest: aRequestContext request) 
		ifTrue: [ super handleFiltered: aRequestContext ]
		ifFalse: [ 
			aRequestContext responseGenerator
				forbidden;
				respond ]!

remoteAddress
	^ remoteAddress!

remoteAddressFromRequest: aRequest
	remoteAddress ifNil: [
		remoteAddress := aRequest
			headerAt: 'x-forwarded-for'
			ifAbsent: [ aRequest remoteAddress ]	].
	^ aRequest remoteAddress!

verifyRequest: aRequest
	^ (self remoteAddressFromRequest: aRequest) = self remoteAddress! !
!WAProtectionFilter categoriesFor: #handleFiltered:!processing!public! !
!WAProtectionFilter categoriesFor: #remoteAddress!private! !
!WAProtectionFilter categoriesFor: #remoteAddressFromRequest:!private! !
!WAProtectionFilter categoriesFor: #verifyRequest:!public!testing! !

WATrailingSlashFilter guid: (GUID fromString: '{65D3CA79-A92F-43FC-9001-BC3C6933E4EE}')!
WATrailingSlashFilter comment: 'Enforces a trailing slash on the wrapped request handler.'!
!WATrailingSlashFilter categoriesForClass!Unclassified! !
!WATrailingSlashFilter methodsFor!

handleFiltered: aRequestContext
	(self shouldRedirect: aRequestContext)
		ifFalse: [ super handleFiltered: aRequestContext ]
		ifTrue: [ self redirectWithTrailingSlash: aRequestContext ]!

redirectWithTrailingSlash: aRequestContext 
	aRequestContext responseGenerator
		redirectTo: (aRequestContext request url copy
			takeServerParametersFromRequest: aRequestContext request;
			slash: true;
			yourself);
		respond!

shouldRedirect: aRequestContext
	^ aRequestContext request isGet and: [ aRequestContext request url slash not ]! !
!WATrailingSlashFilter categoriesFor: #handleFiltered:!processing!public! !
!WATrailingSlashFilter categoriesFor: #redirectWithTrailingSlash:!processing!public! !
!WATrailingSlashFilter categoriesFor: #shouldRedirect:!public!testing! !

WATransactionFilter guid: (GUID fromString: '{867D8CCC-2AF3-45F8-A4E1-4ABFF51AAE91}')!
WATransactionFilter comment: 'This filter provides the implementation of WAComponent>>#isolate:. It rejects all requests as soon as the filter has been closed.'!
!WATransactionFilter categoriesForClass!Unclassified! !
!WATransactionFilter methodsFor!

close
	closed := true!

handleFiltered: aRequestContext 
	self isClosed 
		ifFalse: [ super handleFiltered: aRequestContext ]
		ifTrue: [ 
			aRequestContext responseGenerator
				pageExpired;
				respond ]!

initialize
	super initialize.
	closed := false!

isClosed
	^ closed! !
!WATransactionFilter categoriesFor: #close!actions!public! !
!WATransactionFilter categoriesFor: #handleFiltered:!processing!public! !
!WATransactionFilter categoriesFor: #initialize!initialization!public! !
!WATransactionFilter categoriesFor: #isClosed!public!testing! !

WAExceptionFilter guid: (GUID fromString: '{6EE2B496-FCF4-4E3A-ACAC-1C211E7B42A2}')!
WAExceptionFilter comment: ''!
!WAExceptionFilter categoriesForClass!Unclassified! !
!WAExceptionFilter methodsFor!

defaultConfiguration
	^ WAUserConfiguration new
		addParent: WAExceptionFilterConfiguration instance;
		yourself!

exceptionHandler
	^ self configuration at: #exceptionHandler!

handleFiltered: aRequestContext
	(self exceptionHandler)
		handleExceptionsDuring: [ super handleFiltered: aRequestContext ]
		context: aRequestContext!

isExceptionFilter
	^ true! !
!WAExceptionFilter categoriesFor: #defaultConfiguration!configuration!public! !
!WAExceptionFilter categoriesFor: #exceptionHandler!configuration!public! !
!WAExceptionFilter categoriesFor: #handleFiltered:!processing!public! !
!WAExceptionFilter categoriesFor: #isExceptionFilter!public!testing! !

WADispatcher guid: (GUID fromString: '{E2BD6A4C-B2FE-4D1D-9FD9-7DCEC977427C}')!
WADispatcher comment: '
WADispatcher takes http requests and dispatches them to the correct handler (WAApplication, WAFileHandler, WANotFoundHandler, etc). 

WADispatcher class>>default is the top level dispatcher. When a Seaside application is registered as "foo" the application is added to the top level dispatcher. The application is added to the entryPoints of the dispatcher at the key "foo". If a Seaside application is registered as "bar/foo" then the application isadded to a  dispatcher''s entryPoints at the key "foo". That dispatcher is in the top level dispatcher''s  entryPoints at the key "bar". 
  
When a http request is received it is sent to WADispatcher class>>default to find the correct handler for the request. If a handler exists for the request is sent to that handler. Otherwise the request is sent to WANotFoundHandler.

The VW port maintains multiple copies of the tree of dispatchers rooted at WADispatcher class>>default. One copy is for each different URL that can reach Seaside (http://..../seaside/go/counter - normal, http://..../counter - SeasideShortPath, http://..../seaside/stream/counter - streaming). 

Instance Variables:
	defaultName	<String>
	entryPoints	<(Dictionary of: WAEntryPoint)>	 the keys are strings, which are the names and URL path segments for the handler at that key
'!
!WADispatcher categoriesForClass!Unclassified! !
!WADispatcher methodsFor!

childrenDo: aBlock
	handlers do: aBlock!

defaultHandler
	self defaultName isNil ifTrue: [ ^ nil ].
	^ self handlerAt: self defaultName ifAbsent: [ nil ]!

defaultName
	^ defaultName!

defaultName: aString
	defaultName := aString!

entryPointAt: aString 
	self 
		greaseDeprecatedApi: 'WADispatcher>>#entryPointAt:'
		details: 'Use WADispatcher>>#handlerAt:.'.
	^ self handlerAt: aString!

handleDefault: aRequestContext
	self defaultName isNil
		ifTrue: [ aRequestContext responseGenerator forbidden; respond ]
		ifFalse: [ self handleFiltered: aRequestContext named: self defaultName ]!

handleFiltered: aRequestContext
	| consumer |
	consumer := aRequestContext consumer.
	consumer atEnd
		ifTrue: [ self handleDefault: aRequestContext ]
		ifFalse: [ self handleFiltered: aRequestContext named: consumer next ]!

handleFiltered: aRequestContext named: aString
	(self 
		handlerAt: aString 
		ifAbsent: [ aRequestContext responseGenerator notFound; respond ])
			handle: aRequestContext!

handlerAt: aString
	^ self
			handlerAt: aString
			with: [ :dispatcher :token |
				dispatcher handlers at: token ] !

handlerAt: aString ifAbsent: aBlock
	^ self
		handlerAt: (aString
			ifNil: [ ^ aBlock value ])
		with: [ :dispatcher :token |
			dispatcher handlers
				at: token
				ifAbsent: [ ^ aBlock value ] ]!

handlerAt: aString with: aBlock
	^ (aString greaseSubStrings: '/') inject: self into: aBlock!

handlers
	^ handlers!

initialize
	super initialize.
	handlers := Dictionary new!

isDispatcher
	^ true!

nameOfHandler: aRequestHandler 
	"Answer the name of the given request handler. Signal an error the given handler is not registered in the receiver."
	^ handlers
		keyAtValue: aRequestHandler
		ifAbsent: [ WAUnregisteredHandlerError signal ]!

postCopy
	super postCopy.
	handlers := handlers valuesCollect: [ :each | each copy setParent: self; yourself ]!

register: aRequestHandler at: aString 
	aString ifNil: [ WAError signal: 'Registration key cannot be nil.' ].
	handlers 
		at: aString
		put: (aRequestHandler setParent: self; yourself).
	^ aRequestHandler!

unregister: aRequestHandler
	handlers 
		removeKey: aRequestHandler name
		ifAbsent: [ ^ nil ].
	^ aRequestHandler unregistered!

urlFor: aRequestHandler
	^ self url
		addToPath: (self nameOfHandler: aRequestHandler);
		yourself! !
!WADispatcher categoriesFor: #childrenDo:!parent/child!public! !
!WADispatcher categoriesFor: #defaultHandler!accessing!public! !
!WADispatcher categoriesFor: #defaultName!accessing!public! !
!WADispatcher categoriesFor: #defaultName:!accessing!public! !
!WADispatcher categoriesFor: #entryPointAt:!public! !
!WADispatcher categoriesFor: #handleDefault:!handling!public! !
!WADispatcher categoriesFor: #handleFiltered:!handling!public! !
!WADispatcher categoriesFor: #handleFiltered:named:!handling!public! !
!WADispatcher categoriesFor: #handlerAt:!accessing!public! !
!WADispatcher categoriesFor: #handlerAt:ifAbsent:!accessing!public! !
!WADispatcher categoriesFor: #handlerAt:with:!accessing!public! !
!WADispatcher categoriesFor: #handlers!accessing!public! !
!WADispatcher categoriesFor: #initialize!initialization!public! !
!WADispatcher categoriesFor: #isDispatcher!public!testing! !
!WADispatcher categoriesFor: #nameOfHandler:!accessing!public! !
!WADispatcher categoriesFor: #postCopy!copying!public! !
!WADispatcher categoriesFor: #register:at:!parent/child!public! !
!WADispatcher categoriesFor: #unregister:!parent/child!public! !
!WADispatcher categoriesFor: #urlFor:!accessing!public! !

!WADispatcher class methodsFor!

default
	^ default ifNil: [ default := self new ]!

description
	^ 'Dispatcher'!

resetDefault
	default := nil.! !
!WADispatcher class categoriesFor: #default!accessing!public! !
!WADispatcher class categoriesFor: #description!accessing!public! !
!WADispatcher class categoriesFor: #resetDefault!initialization!public! !

WADocumentHandler guid: (GUID fromString: '{B70C647B-A0C5-4ADD-BC40-D6315304D197}')!
WADocumentHandler comment: '
WADocumentHandler handles requests for images, text documents and binary files (byte arrays). This class is not normally used directly. A number of WA*Tag classes implement document:mimeType:fileName: which use WADocumentHandler. Given a document, #document:mimeType:fileName: creates a WADocumentHandler for the document, registers the handler with a Registry, and adds the correct url in the tag for the document.

Instance Variables:
	document	<WAMIMEDocument>	MIMEDocument object representing this document and mimeType, generates stream used to write document for the response.'!
!WADocumentHandler categoriesForClass!Unclassified! !
!WADocumentHandler methodsFor!

= anObject
	^ self species = anObject species and: [ self document = anObject document]!

document
	^ document!

handleFiltered: aRequestContext
	aRequestContext respond: [ :response |
		response
			cacheForever;
			document: self document ]!

hash
	^ self document hash!

initializeOn: aDocument
	self initialize.
	document := aDocument!

postCopy
	super postCopy.
	document := document copy! !
!WADocumentHandler categoriesFor: #=!comparing!public! !
!WADocumentHandler categoriesFor: #document!accessing!public! !
!WADocumentHandler categoriesFor: #handleFiltered:!handling!public! !
!WADocumentHandler categoriesFor: #hash!comparing!public! !
!WADocumentHandler categoriesFor: #initializeOn:!initialization!public! !
!WADocumentHandler categoriesFor: #postCopy!copying!public! !

!WADocumentHandler class methodsFor!

document: anObject
	^ self basicNew initializeOn: anObject seasideMimeDocument; yourself!

document: anObject mimeType: aMimeType
	^ self document: anObject mimeType: aMimeType fileName: nil!

document: anObject mimeType: aMimeType fileName: aString
	| document |
	document := aMimeType isNil
		ifTrue: [ anObject seasideMimeDocument]
		ifFalse: [ anObject seasideMimeDocumentType: aMimeType ].
	aString isNil
		ifFalse: [ document fileName: aString ].
	^ self document: document! !
!WADocumentHandler class categoriesFor: #document:!instance creation!public! !
!WADocumentHandler class categoriesFor: #document:mimeType:!instance creation!public! !
!WADocumentHandler class categoriesFor: #document:mimeType:fileName:!instance creation!public! !

WAFileHandler guid: (GUID fromString: '{B093B85F-B8F7-4338-9890-5C0E0E5FD6D6}')!
WAFileHandler comment: 'Seaside serves static files using WALibrary subclasses. WAFileHandler handles all requests for WALibrary files (or methods) for all applications on the Seaside server. WAFileHandler is registered with the default WADispatcher automatically.'!
!WAFileHandler categoriesForClass!Unclassified! !
!WAFileHandler methodsFor!

defaultConfiguration
	^ super defaultConfiguration
		removeParent: WARequestHandlingConfiguration instance;
		addParent: WAFileHandlerConfiguration instance;
		yourself!

fileHandlerListingClass
	^ self preferenceAt: #fileHandlerListingClass!

handleFiltered: aRequestContext
	self responseForContext: aRequestContext!

libraries
	^ WAFileLibrary allSubclasses!

libraryAt: aSymbol ifAbsent: aBlock
	^ self libraries 
		detect: [ :each | each handlesFolder: aSymbol ]
		ifNone: aBlock!

responseForContext: aRequestContext
	| libraryClass consumer |
	consumer := aRequestContext consumer.
	consumer atEnd
		ifTrue: [ ^ (self fileHandlerListingClass on: self context: aRequestContext) responseForLibraries ].
	libraryClass := self 
		libraryAt: consumer next asSymbol
		ifAbsent: [ ^ aRequestContext responseGenerator notFound; respond ].
	consumer atEnd
		ifTrue: [
			| listingClass |
			listingClass := (self fileHandlerListingClass on: self context: aRequestContext).
			listingClass responseForLibrary: libraryClass default ]
		ifFalse: [
			libraryClass handle: aRequestContext.
			" won't be executed if a document is found "
			aRequestContext responseGenerator
				notFound;
				respond ]! !
!WAFileHandler categoriesFor: #defaultConfiguration!configuration!public! !
!WAFileHandler categoriesFor: #fileHandlerListingClass!configuration!public! !
!WAFileHandler categoriesFor: #handleFiltered:!handling!public! !
!WAFileHandler categoriesFor: #libraries!accessing!public! !
!WAFileHandler categoriesFor: #libraryAt:ifAbsent:!accessing!public! !
!WAFileHandler categoriesFor: #responseForContext:!private! !

!WAFileHandler class methodsFor!

default

	default isNil ifTrue: [ default := self new ].
	^ default!

default: aFileHandler
	default := aFileHandler!

description
	^ 'File Library'! !
!WAFileHandler class categoriesFor: #default!accessing!public! !
!WAFileHandler class categoriesFor: #default:!accessing!public! !
!WAFileHandler class categoriesFor: #description!accessing!public! !

WARegistry guid: (GUID fromString: '{37F4DA91-AFD2-4A4A-9756-AD0389DF5B2C}')!
WARegistry comment: '
WARegistry maintains a set of handlers indexed by a key which it assigns when the handler is registerd. WARegistry checks incoming request URLs for a key and looks for a matching active request handler. If one exists, the request is sent to the proper handler. If not, the request is either a new request (in which case #handleDefaultRequest: is called) or a request to a now-inactive handler (in which case #handleExpiredRequest: is called). These two methods allow subclasses to properly handle these requests.

Subclasses must implement the following messages:
	handleDefaultRequest:
		Handle a request without a session key, ie a new request.
	handlerField
		The URL parameter in which to store the request handler key.

Instance Variables:
	cache - an instance of WACache to hold the stored request handlers
'!
!WARegistry categoriesForClass!Unclassified! !
!WARegistry methodsFor!

addCookieForHandler: aRequestHandler to: aRequestContext
	"Create a new handler key cookie and att it to the response."
	
	aRequestContext response addCookie: 
		(aRequestContext newCookie
			key: self keyCookieName;
			value: (self keyFor: aRequestHandler);
			discard: true;
			comment: 'the Seaside Session Cookie';
			commentUrl: 'http://www.seaside.st/documentation/sessionCookie';
			yourself)!

addDeletionOfCookie: aCookie to: aRequestContext
	"Request the deletion of aCookie in the response."

	| baseUrl |
	baseUrl := self url.
	aRequestContext response
		deleteCookie: aCookie
		path: baseUrl pathString
		domain: baseUrl host!

cache
	^ cache!

cache: aCache
	cache := aCache!

childrenDo: aBlock
	self cache keysAndValuesDo: [ :key :value | aBlock value: value ]!

clear
	"Remove all registered handlers."

	self cache clear!

clearHandlers
	self 
		greaseDeprecatedApi: 'WARegistry>>#clearHandlers'
		details: 'Use #clear.'.
	^ self clear!

cookieFromContext: aRequestContext ifAbsent: absentBlock
	"Answer the handler key cookie. If none is found, return the result of evaluating absentBlock.
	There can be several cookies with the correct key so we try to find the one with the most specific path."

	| candidates requestUrl |
	candidates := aRequestContext request cookiesAt: self keyCookieName.
	
	candidates isEmptyOrNil
		ifTrue: [ ^ absentBlock value ].
	candidates size = 1 
		ifTrue: [ ^ candidates first ].
		
	requestUrl := aRequestContext request url.
	candidates := candidates collect: [ :each |
		each -> (each path seasideUrl relativeTo: requestUrl) ].
	
	candidates := candidates reject: [ :each |
		| path |
		path := each value.
		path notEmpty and: [ path first = '..' ] ].

	candidates isEmpty
		ifTrue: [ ^ absentBlock value ].
		
	candidates size > 1
		ifTrue: [
			candidates sort: [ :a :b |
				 a value size <= b value size ] ].
	
	^ candidates first key!

defaultConfiguration
	^ super defaultConfiguration
		removeParent: WARequestHandlingConfiguration instance;
		addParent: WARegistryConfiguration instance;
		yourself!

dispatch: aRequestContext to: aRequestHandler
	"This method is used by the handling methods to trigger the dispatch of a request
	to the specified handler."
	
	aRequestHandler handle: aRequestContext
!

doesHandlerSupportCookies: aRequestHandler
	^ true!

ensureKeyFor: aRequestHandler
	"Ensure the request handler is registered and returns its key."
	
	^ self keyFor: aRequestHandler ifAbsent: [ self register: aRequestHandler ]!

ensureKeyForHandler: aRequestHandler 
	self 
		greaseDeprecatedApi: 'WARegistry>>#ensureKeyForHandler:'
		details: 'Use #ensureKeyFor:.'.
	^ self ensureKeyFor: aRequestHandler!

handle: aRequestContext registering: aRequestHandler
	"Register a new handler and then dispatch the request to it. A cookie may need
	to be added to the response with the handler's key."
	
	self register: aRequestHandler.
	self useCookies ifTrue: [ self addCookieForHandler: aRequestHandler to: aRequestContext ].
	self dispatch: aRequestContext to: aRequestHandler.!

handleDefault: aRequestContext 
	"This method is called whenever a request is received with no key specified. This method can be overridden by subclasses to register a new handler to handle the request."
	
	aRequestContext responseGenerator
		notFound;
		respond!

handleExpired: aRequestContext 
	"This method is called whenever a request is received with a key that does not match a registered handler."
	
	aRequestContext responseGenerator
		expiredRegistryKey;
		respond!

handleFiltered: aRequestContext
	| cookie key handler urlKey |
	urlKey := self urlKeyFromContext: aRequestContext ifAbsent: [ nil ].
	cookie := self useCookies
		ifFalse: [ nil ]
		ifTrue: [ self cookieFromContext: aRequestContext ifAbsent: [ nil ] ].
	key := self keyFromFieldValue: urlKey cookie: cookie.
	key isNil
		ifTrue: [ self handleDefault: aRequestContext ]
		ifFalse: [
			handler := self cache at: key ifAbsent: [ nil ].
			handler isNil
				ifTrue: [
					cookie notNil ifTrue: [ self addDeletionOfCookie: cookie to: aRequestContext ].
					self handleExpired: aRequestContext ]
				ifFalse: [
					((self doesHandlerSupportCookies: handler) and: [ (cookie isNil or: [ (cookie value = key) not ]) and: [ self useCookies ] ])
						ifTrue: [ self addCookieForHandler: handler to: aRequestContext ] ].
					self handleKeyed: aRequestContext with: handler ]!

handleKeyed: aRequestContext with: aRequestHandler
	"This method is called whenever a request is received with a key that matches
	a registered handler."
	
	self dispatch: aRequestContext to: aRequestHandler!

handlersDo: aBlock

	self keysAndHandlersDo: [:key :value | aBlock value: value ]!

hasCookieInContext: aRequestContext
	self cookieFromContext: aRequestContext ifAbsent: [ ^ false ].
	^ true!

hasCookieInContext: aRequestContext withValue: aString 
	| cookie |
	cookie := self cookieFromContext: aRequestContext ifAbsent: [ ^ false ].
	^ cookie value = aString!

initialize
	super initialize.
	cache := WACache new!

isRegistry
	^ true!

keyCookieName
	"Returns the key (name) of the key cookie."
	
	^ self keyField!

keyField
	"Returns the name of the URL query field used to store the key."
	
	^ '_key'!

keyFor: aRequestHandler
	^ self
		keyFor: aRequestHandler
		ifAbsent: [ WAUnregisteredHandlerError signal ]!

keyFor: aRequestHandler ifAbsent: absentBlock
	^ (self cache keyAtValue: aRequestHandler) ifNil: [ absentBlock value ]!

keyFromFieldValue: aStringOrNil cookie: aCookieOrNil
	"Combine the keys from the URL and cookie.
	If we have a URL key we always use that. If not, we use the cookie if it is present."
	
	aStringOrNil isNil ifFalse: [ ^ aStringOrNil ].
	aCookieOrNil isNil ifFalse: [ ^ aCookieOrNil value ].
	^ nil
	!

keyOrNilForHandler: aRequestHandler 
	self 
		greaseDeprecatedApi: 'WARegistry>>#keyOrNilForHandler:'
		details: 'Use #keyFor:ifAbsent:.'.
	^ self 
		keyFor: aRequestHandler
		ifAbsent: [ nil ]!

keysAndHandlersDo: aBlock

	self cache keysAndValuesDo: aBlock!

postCopy
	super postCopy.
	"Since our handlers are dynamically registered and temporary, it makes
	sense not to copy them."
	cache := cache species new!

register: aRequestHandler
	^ self cache store: (aRequestHandler setParent: self; yourself)!

registerRequestHandler: aRequestHandler 
	self 
		greaseDeprecatedApi: 'WARegistry>>#registerRequestHandler:'
		details: 'Use register:.'.
	^ self register: aRequestHandler!

unregister: aRequestHandler
	^ self cache remove: aRequestHandler!

unregistered
	super unregistered.
	self clear!

unregisterRequestHandler: aRequestHandler 
	self 
		greaseDeprecatedApi: 'WARegistry>>#unregisterRequestHandler:'
		details: 'Use #unregister:.'.
	^ self unregister: aRequestHandler!

urlFor: aRequestHandler
	^ self
		urlFor: aRequestHandler
		ifAbsent: [ WAUnregisteredHandlerError signal ]!

urlFor: aRequestHandler ifAbsent: absentBlock
	"Return the URL for the given request handler. If the handler is not registered, return
	the result of absentBlock.
	This URL will include the handler's key; if you don't want this, use #url instead."

	| key url |
	key := self keyFor: aRequestHandler ifAbsent: [ ^ absentBlock value ].
	url := self url.
	"Another option would be to have the Registry cache the cookie in the request context."
	(self hasCookieInContext: self requestContext withValue: key)
		"add the url field if the cookie is pointing to a different one"
		ifFalse: [ url addField: self keyField value: key ].
		
	^ url!

urlForRequestHandler: aRequestHandler addHandlerField: aBoolean 
	| key url |
	self 
		greaseDeprecatedApi: 'WARegistry>>#urlForRequestHandler:addHandlerField:'
		details: 'Use #urlFor: or #urlFor:ifAbsent:. In any case where you do not want the handler field, simply use #url.'.
	key := self ensureKeyForHandler: aRequestHandler.
	url := self url.
	aBoolean ifTrue: 
		[ url 
			addField: self keyField
			value: key ].
	^ url!

urlKeyFromContext: aRequestContext ifAbsent: absentBlock
	"Answer the key found in the request URL. If none is found, return the
	result of evaluating absentBlock."
	
	^ aRequestContext request at: self keyField ifAbsent: absentBlock!

useCookies
	^ self configuration at: #useCookies! !
!WARegistry categoriesFor: #addCookieForHandler:to:!handling-helpers!public! !
!WARegistry categoriesFor: #addDeletionOfCookie:to:!handling-helpers!public! !
!WARegistry categoriesFor: #cache!accessing!public! !
!WARegistry categoriesFor: #cache:!accessing!public! !
!WARegistry categoriesFor: #childrenDo:!parent/child!public! !
!WARegistry categoriesFor: #clear!parent/child!public! !
!WARegistry categoriesFor: #clearHandlers!public! !
!WARegistry categoriesFor: #cookieFromContext:ifAbsent:!handling-helpers!public! !
!WARegistry categoriesFor: #defaultConfiguration!configuration!public! !
!WARegistry categoriesFor: #dispatch:to:!handling-helpers!public! !
!WARegistry categoriesFor: #doesHandlerSupportCookies:!private! !
!WARegistry categoriesFor: #ensureKeyFor:!parent/child!public! !
!WARegistry categoriesFor: #ensureKeyForHandler:!public! !
!WARegistry categoriesFor: #handle:registering:!handling-helpers!public! !
!WARegistry categoriesFor: #handleDefault:!handling!public! !
!WARegistry categoriesFor: #handleExpired:!handling!public! !
!WARegistry categoriesFor: #handleFiltered:!handling!public! !
!WARegistry categoriesFor: #handleKeyed:with:!handling!public! !
!WARegistry categoriesFor: #handlersDo:!enumerating!public! !
!WARegistry categoriesFor: #hasCookieInContext:!public!testing! !
!WARegistry categoriesFor: #hasCookieInContext:withValue:!public!testing! !
!WARegistry categoriesFor: #initialize!initialization!public! !
!WARegistry categoriesFor: #isRegistry!public!testing! !
!WARegistry categoriesFor: #keyCookieName!handling-helpers!public! !
!WARegistry categoriesFor: #keyField!handling-helpers!public! !
!WARegistry categoriesFor: #keyFor:!parent/child!public! !
!WARegistry categoriesFor: #keyFor:ifAbsent:!parent/child!public! !
!WARegistry categoriesFor: #keyFromFieldValue:cookie:!handling-helpers!public! !
!WARegistry categoriesFor: #keyOrNilForHandler:!public! !
!WARegistry categoriesFor: #keysAndHandlersDo:!enumerating!public! !
!WARegistry categoriesFor: #postCopy!copying!public! !
!WARegistry categoriesFor: #register:!parent/child!public! !
!WARegistry categoriesFor: #registerRequestHandler:!public! !
!WARegistry categoriesFor: #unregister:!parent/child!public! !
!WARegistry categoriesFor: #unregistered!notifications!public! !
!WARegistry categoriesFor: #unregisterRequestHandler:!public! !
!WARegistry categoriesFor: #urlFor:!accessing!public! !
!WARegistry categoriesFor: #urlFor:ifAbsent:!accessing!public! !
!WARegistry categoriesFor: #urlForRequestHandler:addHandlerField:!public! !
!WARegistry categoriesFor: #urlKeyFromContext:ifAbsent:!handling-helpers!public! !
!WARegistry categoriesFor: #useCookies!configuration!public! !

!WARegistry class methodsFor!

isAbstract
	^ self name = #WARegistry! !
!WARegistry class categoriesFor: #isAbstract!public!testing! !

WABufferedResponse guid: (GUID fromString: '{436C526A-F850-49ED-9C4B-33A758C8A51D}')!
WABufferedResponse comment: '
A WABufferedResponse is a concrete implementation of a HTTP response. Its contentsStream is used to represent the body of the message.

Instance Variables
	contentsStream:		<WriteStream> The contents of this message.'!
!WABufferedResponse categoriesForClass!Unclassified! !
!WABufferedResponse methodsFor!

binary
	"put the response stream into binary mode. For buffered response, 
	 replace the contentStream with a ByteArray based stream."
	contentsStream := GRPlatform current readWriteByteStream!

contents
	^ contentsStream contents!

destroy
	super destroy.
	contentsStream := nil!

initializeOn: aStream
	super initializeOn: aStream.
	contentsStream := aStream!

stream
	^ contentsStream!

writeContentOn: aStream 
	aStream nextPutAll: self contents!

writeHeadersOn: aStream 
	self 
		headerAt: 'Content-Length'
		put: contentsStream size.
	super writeHeadersOn: aStream! !
!WABufferedResponse categoriesFor: #binary!public!streaming! !
!WABufferedResponse categoriesFor: #contents!accessing!public! !
!WABufferedResponse categoriesFor: #destroy!initialization!public! !
!WABufferedResponse categoriesFor: #initializeOn:!initialization!public! !
!WABufferedResponse categoriesFor: #stream!accessing!public! !
!WABufferedResponse categoriesFor: #writeContentOn:!public!writing! !
!WABufferedResponse categoriesFor: #writeHeadersOn:!public!writing! !

!WABufferedResponse class methodsFor!

new
	^ self on: GRPlatform current readWriteCharacterStream!

on: aStream
	^ self basicNew initializeOn: aStream! !
!WABufferedResponse class categoriesFor: #new!instance creation!public! !
!WABufferedResponse class categoriesFor: #on:!instance creation!public! !

WAStreamedResponse guid: (GUID fromString: '{C139FC78-7CAB-4570-BAF8-83079F82A861}')!
WAStreamedResponse comment: '
A WAStreamedResponse is a HTTP response that directly writes to an external write stream. This response class is used to implement efficient HTTP response streaming, as it can directly write do the socket while content is still generated.

Instance Variables
	committed:		<Boolean>	Whether the status and header was written to the stream.
	externalStream:		<WriteStream>	The external stream to write to.'!
!WAStreamedResponse categoriesForClass!Unclassified! !
!WAStreamedResponse methodsFor!

addCookie: aCookie
	self committedCheck.
	^ super addCookie: aCookie!

binary
	"put the response stream into binary mode"

	externalStream binary!

committedCheck
	"Raises a singal if this response is already committed."

	self isCommitted 
		ifTrue: [ WAIllegalStateException signal ]!

destroy
	super destroy.
	externalStream := nil!

flush
	"Flush the status code and header fields, if they haven't been written yet."

	self isCommitted
		ifFalse: [ self writeOn: externalStream ].
	externalStream flush!

headerAt: aString append: aValue
	self committedCheck.
	^ super headerAt: aString append: aValue!

headerAt: aString put: aValue
	self committedCheck.
	^ super headerAt: aString put: aValue!

initializeOn: aStream 
	super initializeOn: aStream.
	committed := false.
	externalStream := aStream!

isCommitted
	^ committed!

removeHeaderAt: aString
	self committedCheck.
	^ super removeHeaderAt: aString!

status: aNumber message: aString
	self committedCheck.
	super status: aNumber message: aString!

stream
	self flush.
	^ externalStream!

writeContentOn: aStream 
	committed := true! !
!WAStreamedResponse categoriesFor: #addCookie:!accessing-cookies!public! !
!WAStreamedResponse categoriesFor: #binary!public!streaming! !
!WAStreamedResponse categoriesFor: #committedCheck!private! !
!WAStreamedResponse categoriesFor: #destroy!initialization!public! !
!WAStreamedResponse categoriesFor: #flush!public! !
!WAStreamedResponse categoriesFor: #headerAt:append:!accessing-headers!public! !
!WAStreamedResponse categoriesFor: #headerAt:put:!accessing-headers!public! !
!WAStreamedResponse categoriesFor: #initializeOn:!initialization!public! !
!WAStreamedResponse categoriesFor: #isCommitted!public!testing! !
!WAStreamedResponse categoriesFor: #removeHeaderAt:!accessing-headers!public! !
!WAStreamedResponse categoriesFor: #status:message:!accessing-status!public! !
!WAStreamedResponse categoriesFor: #stream!accessing!public! !
!WAStreamedResponse categoriesFor: #writeContentOn:!public!writing! !

!WAStreamedResponse class methodsFor!

on: aStream
	^ self basicNew initializeOn: aStream! !
!WAStreamedResponse class categoriesFor: #on:!instance creation!public! !

WAHtmlRoot guid: (GUID fromString: '{F4F99557-DCB4-4EAA-B26E-B0DCE8DCAD26}')!
WAHtmlRoot comment: '
A WAHtmlRoot is the root element of an HTML Document (<html>).

Instance Variables
	bodyAttrs:		<WAHtmlAttributes>
	context:			<WARenderContext>
	docType:		<String>
	headAttrs:		<WAHtmlAttributes>
	headElements:	<OrderedCollection<WAHtmlElement>>
	htmlAttrs:		<WAHtmlAttributes>
	scripts:			<Set<String>>
	styles:			<Set<String>>
	title:			<String>

bodyAttrs
	- the attributes of the <body> element

context
	- the context used to render the contents of the <body> element

docType
	- the document type

headAttrs
	- the attributes of the <head> element

headElements
	- the elements inside the <head> section

htmlAttrs
	- the attriebutes of the <html> element

scripts
	- contains the strings returned by WAPresenter >> #script

styles
	- contains the strings returned by WAPresenter >> #style

title
	- the title of the HTML document, the contents of the <title> element
'!
!WAHtmlRoot categoriesForClass!Unclassified! !
!WAHtmlRoot methodsFor!

add: aHtmlElement
	"Add a HTML head element to the receiver."

	^ headElements add: aHtmlElement!

addScript: aString
	"Include the script aString into the receiver."

	scripts ifNil: [ scripts := Set new ].
	scripts add: aString!

addStyle: aString
	"Include the style-sheet aString into the receiver."

	styles ifNil: [ styles := Set new ].
	styles add: aString!

base
	^ self add: (WABaseElement root: self)!

beXhtml10Strict
	self docType: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'!

beXhtml10Transitional
	self docType: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'!

beXhtml11
	self docType: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">'!

bodyAttributes
	^ bodyAttrs ifNil: [ bodyAttrs := WAHtmlAttributes new ]!

closeOn: aDocument
	aDocument scriptGenerator
		close: self on: aDocument.
	self writeFootOn: aDocument!

contentBase: urlString
	self base url: urlString!

docType
	^ docType!

docType: aString
	"Set the document-type of the receiver. The table at http://www.w3.org/TR/2002/NOTE-xhtml-media-types-20020430/ summarizes the recommendation to content authors for labeling their XHTML documents:

Media type				XHTML 1.0 (HTML compatible)	XHTML 1.0 (other)	XHTML Basic / 1.1	XHTML+MathML
text/html				MAY							SHOULD NOT			SHOULD NOT			SHOULD NOT
application/xhtml+xml	SHOULD							SHOULD				SHOULD				SHOULD
application/xml			MAY							MAY				MAY				MAY
text/xml					MAY							MAY				MAY				MAY"

	docType := aString!

headAttributes
	^ headAttrs ifNil: [ headAttrs := WAHtmlAttributes new ]!

headElements
	^ headElements!

headElements: anOrderedCollection
	headElements := anOrderedCollection!

htmlAttributes
	^ htmlAttrs ifNil: [ htmlAttrs := WAHtmlAttributes new ]!

if
	^ WAConditionalComment root: self!

initialize
	super initialize.
	headElements := OrderedCollection new.
	title := docType := String new!

javascript
	^ self script beJavascript; yourself!

link
	^ self add: (WALinkElement root: self)!

meta
	^ self add: (WAMetaElement root: self)!

openOn: aDocument
	aDocument scriptGenerator 
		open: self on: aDocument.
	self writeHeadOn: aDocument!

redirectTo: aLocationString delay: aNumber
	self meta redirectAfter: aNumber to: aLocationString!

revealedIf
	^ WARevealedConditionalComment root: self!

script
	^ self add: (WAScriptElement root: self)!

stylesheet
	^ self link beStylesheet; beCss; yourself!

title
	^ title!

title: aString
	title := aString!

writeElementsOn: aDocument
	aDocument openTag: 'title'; nextPutAll: title; closeTag: 'title'.
	headElements do: [ :each | aDocument print: each ]!

writeFootOn: aDocument
	aDocument closeTag: 'body'.
	aDocument closeTag: 'html'!

writeHeadOn: aDocument
	aDocument nextPutAll: docType.
	aDocument openTag: 'html' attributes: htmlAttrs.
	aDocument openTag: 'head' attributes: headAttrs.
	self writeElementsOn: aDocument.
	self writeStylesOn: aDocument.
	self writeScriptsOn: aDocument.
	aDocument closeTag: 'head'.
	aDocument openTag: 'body' attributes: bodyAttrs!

writeScriptsOn: aDocument
	scripts ifNil: [ ^ self ].
	scripts do: [ :each |
		aDocument print: ((WAScriptElement root: self)
			beJavascript;
			document: each;
			yourself) ]!

writeStylesOn: aDocument
	styles ifNil: [ ^ self ].
	styles do: [ :each |
		aDocument print: ((WALinkElement root: self)
			beStylesheet; beCss;
			document: each;
			yourself) ]! !
!WAHtmlRoot categoriesFor: #add:!adding!public! !
!WAHtmlRoot categoriesFor: #addScript:!adding!public! !
!WAHtmlRoot categoriesFor: #addStyle:!adding!public! !
!WAHtmlRoot categoriesFor: #base!elements!public! !
!WAHtmlRoot categoriesFor: #beXhtml10Strict!doctype!public! !
!WAHtmlRoot categoriesFor: #beXhtml10Transitional!doctype!public! !
!WAHtmlRoot categoriesFor: #beXhtml11!doctype!public! !
!WAHtmlRoot categoriesFor: #bodyAttributes!accessing-attributes!public! !
!WAHtmlRoot categoriesFor: #closeOn:!public!writing! !
!WAHtmlRoot categoriesFor: #contentBase:!convenience!public! !
!WAHtmlRoot categoriesFor: #docType!doctype!public! !
!WAHtmlRoot categoriesFor: #docType:!doctype!public! !
!WAHtmlRoot categoriesFor: #headAttributes!accessing-attributes!public! !
!WAHtmlRoot categoriesFor: #headElements!accessing!public! !
!WAHtmlRoot categoriesFor: #headElements:!accessing!public! !
!WAHtmlRoot categoriesFor: #htmlAttributes!accessing-attributes!public! !
!WAHtmlRoot categoriesFor: #if!elements!public! !
!WAHtmlRoot categoriesFor: #initialize!initialization!public! !
!WAHtmlRoot categoriesFor: #javascript!elements!public! !
!WAHtmlRoot categoriesFor: #link!elements!public! !
!WAHtmlRoot categoriesFor: #meta!elements!public! !
!WAHtmlRoot categoriesFor: #openOn:!public!writing! !
!WAHtmlRoot categoriesFor: #redirectTo:delay:!convenience!public! !
!WAHtmlRoot categoriesFor: #revealedIf!elements!public! !
!WAHtmlRoot categoriesFor: #script!elements!public! !
!WAHtmlRoot categoriesFor: #stylesheet!elements!public! !
!WAHtmlRoot categoriesFor: #title!accessing-properties!public! !
!WAHtmlRoot categoriesFor: #title:!accessing-properties!public! !
!WAHtmlRoot categoriesFor: #writeElementsOn:!public!writing! !
!WAHtmlRoot categoriesFor: #writeFootOn:!public!writing! !
!WAHtmlRoot categoriesFor: #writeHeadOn:!public!writing! !
!WAHtmlRoot categoriesFor: #writeScriptsOn:!public!writing! !
!WAHtmlRoot categoriesFor: #writeStylesOn:!public!writing! !

WAXmlRoot guid: (GUID fromString: '{E0AEBA9C-919E-40EE-9F2C-1A76ACE20975}')!
WAXmlRoot comment: ''!
!WAXmlRoot categoriesForClass!Unclassified! !
!WAXmlRoot methodsFor!

charSet
	^ charSet ifNil: [ charSet := self class defaultCharSet ]!

charSet: aString
	charSet := aString!

openOn: aDocument
	super openOn: aDocument.
	self writePreambleOn: aDocument!

writePreambleOn: aDocument
	aDocument nextPutAll: '<?xml version="1.0" encoding="'; nextPutAll: self charSet; nextPutAll: '"?>'! !
!WAXmlRoot categoriesFor: #charSet!accessing!public! !
!WAXmlRoot categoriesFor: #charSet:!accessing!public! !
!WAXmlRoot categoriesFor: #openOn:!public!writing! !
!WAXmlRoot categoriesFor: #writePreambleOn:!public!writing! !

!WAXmlRoot class methodsFor!

defaultCharSet
	^ 'UTF-8'! !
!WAXmlRoot class categoriesFor: #defaultCharSet!accessing!public! !

WADefaultScriptGenerator guid: (GUID fromString: '{05C43E82-0915-4F15-90F0-D5B452F1A78C}')!
WADefaultScriptGenerator comment: 'A WADefaultScriptGenerator uses the onLoad event on the body to trigger the load scripts. Events handlers are directly inlined with the respecitve elements. Both techniques are considered outdated and should be avoided if possible.'!
!WADefaultScriptGenerator categoriesForClass!Unclassified! !
!WADefaultScriptGenerator methodsFor!

close: aHtmlRoot on: aDocument
	self 
		writeScriptTag: [
			aDocument nextPutAll: 'function onLoad(){'.
			self writeLoadScriptsOn: aDocument.
			aDocument nextPutAll: '};' ]
		on: aDocument!

open: aHtmlRoot on: aDocument
	aHtmlRoot bodyAttributes at: 'onload' put: 'onLoad()'! !
!WADefaultScriptGenerator categoriesFor: #close:on:!actions!public! !
!WADefaultScriptGenerator categoriesFor: #open:on:!actions!public! !

WAAttributeVisitor guid: (GUID fromString: '{18506E63-C4D0-4AFD-A939-9D698251EE8E}')!
WAAttributeVisitor comment: ''!
!WAAttributeVisitor categoriesForClass!Unclassified! !
!WAAttributeVisitor methodsFor!

visitAttribute: anAttribute!

visitBooleanAttribute: anAttribute
	self visitAttribute: anAttribute!

visitCollectionAttribute: anAttribute
	self visitListAttribute: anAttribute!

visitIntegerAttribute: anAttribute
	self visitNumberAttribute: anAttribute!

visitListAttribute: anAttribute
	self visitAttribute: anAttribute!

visitNumberAttribute: anAttribute
	self visitAttribute: anAttribute!

visitPasswordAttribute: anAttribute
	self visitAttribute: anAttribute!

visitStringAttribute: anAttribute
	self visitAttribute: anAttribute!

visitUrlAttribute: anAttribute
	self visitAttribute: anAttribute! !
!WAAttributeVisitor categoriesFor: #visitAttribute:!public!visiting! !
!WAAttributeVisitor categoriesFor: #visitBooleanAttribute:!public!visiting! !
!WAAttributeVisitor categoriesFor: #visitCollectionAttribute:!public!visiting! !
!WAAttributeVisitor categoriesFor: #visitIntegerAttribute:!public!visiting! !
!WAAttributeVisitor categoriesFor: #visitListAttribute:!public!visiting! !
!WAAttributeVisitor categoriesFor: #visitNumberAttribute:!public!visiting! !
!WAAttributeVisitor categoriesFor: #visitPasswordAttribute:!public!visiting! !
!WAAttributeVisitor categoriesFor: #visitStringAttribute:!public!visiting! !
!WAAttributeVisitor categoriesFor: #visitUrlAttribute:!public!visiting! !

WAPainterVisitor guid: (GUID fromString: '{B187C5FA-8E04-40C6-BCA6-2D399A01D446}')!
WAPainterVisitor comment: 'An implementation of the Visitor pattern for Painter subclasses.'!
!WAPainterVisitor categoriesForClass!Unclassified! !
!WAPainterVisitor methodsFor!

copyForRenderContext: aRenderContext 
	"Return a copy, making sure that references to a RenderContext are replaced
	with aRenderContext."
	
	^ self copy
		postCopyForRenderContext: aRenderContext;
		yourself!

postCopyForRenderContext: aRenderContext
	"self is a shallow copy. Subclasses should copy fields as necessary to complete
	the full copy and ensure that all references to the old RenderContext are replaced
	with aRenderContext. Note that #postCopy is also called prior to this method being called."!

visitPainter: aPainter! !
!WAPainterVisitor categoriesFor: #copyForRenderContext:!copying!public! !
!WAPainterVisitor categoriesFor: #postCopyForRenderContext:!copying!public! !
!WAPainterVisitor categoriesFor: #visitPainter:!public!visiting! !

WARenderVisitor guid: (GUID fromString: '{8E5E85FD-5FCC-4AE5-8548-773AF332F892}')!
WARenderVisitor comment: 'A visitor that renders Painters. It creates an instance of the #rendererClass specified by each Painter it visits and passes it to the Painter with #renderContentOn:.'!
!WARenderVisitor categoriesForClass!Unclassified! !
!WARenderVisitor methodsFor!

initializeWithContext: aRenderContext
	self initialize.
	renderContext := aRenderContext!

postCopyForRenderContext: aRenderContext
	super postCopyForRenderContext: aRenderContext.
	renderContext := aRenderContext!

renderContext
	^ renderContext!

visitPainter: aPainter 
	| renderer |
	renderer := aPainter rendererClass context: self renderContext.
	aPainter renderContentOn: renderer.
	renderer flush! !
!WARenderVisitor categoriesFor: #initializeWithContext:!initialization!public! !
!WARenderVisitor categoriesFor: #postCopyForRenderContext:!copying!public! !
!WARenderVisitor categoriesFor: #renderContext!accessing!public! !
!WARenderVisitor categoriesFor: #visitPainter:!public!visiting! !

!WARenderVisitor class methodsFor!

context: aRenderContext
	^ self basicNew
		initializeWithContext: aRenderContext;
		yourself! !
!WARenderVisitor class categoriesFor: #context:!instance creation!public! !

WAUpdateRootVisitor guid: (GUID fromString: '{14E7B176-DED9-4E09-A74F-3669DA5091EA}')!
WAUpdateRootVisitor comment: '
A visitor which asks Painters to update a WARoot subclass using #updateRoot:.

This is used to update the root of the Document stored on a RenderContext.'!
!WAUpdateRootVisitor categoriesForClass!Unclassified! !
!WAUpdateRootVisitor methodsFor!

initializeWithRoot: aRoot
	self initialize.
	root := aRoot!

root
	^ root!

visitPainter: aPainter
	aPainter updateRoot: self root! !
!WAUpdateRootVisitor categoriesFor: #initializeWithRoot:!initialization!public! !
!WAUpdateRootVisitor categoriesFor: #root!accessing!public! !
!WAUpdateRootVisitor categoriesFor: #visitPainter:!public!visiting! !

!WAUpdateRootVisitor class methodsFor!

new
	^ self root: WARoot new!

root: aRoot
	^ self basicNew initializeWithRoot: aRoot; yourself! !
!WAUpdateRootVisitor class categoriesFor: #new!instance creation!public! !
!WAUpdateRootVisitor class categoriesFor: #root:!instance creation!public! !

WAUpdateUrlVisitor guid: (GUID fromString: '{E11EE3DE-8868-4F6A-8CE0-44FDC6444800}')!
WAUpdateUrlVisitor comment: '
A visitor which asks Painters to update a WAUrl subclass using #updateRoot:.

This is used to update the base URL stored on a RenderContext.'!
!WAUpdateUrlVisitor categoriesForClass!Unclassified! !
!WAUpdateUrlVisitor methodsFor!

initializeWithUrl: aUrl
	self initialize.
	url := aUrl!

url
	^ url!

visitPainter: aPainter
	aPainter updateUrl: self url! !
!WAUpdateUrlVisitor categoriesFor: #initializeWithUrl:!initialization!public! !
!WAUpdateUrlVisitor categoriesFor: #url!accessing!public! !
!WAUpdateUrlVisitor categoriesFor: #visitPainter:!public!visiting! !

!WAUpdateUrlVisitor class methodsFor!

new
	^ self url: WAUrl new!

url: aUrl
	^ self basicNew initializeWithUrl: aUrl; yourself! !
!WAUpdateUrlVisitor class categoriesFor: #new!instance creation!public! !
!WAUpdateUrlVisitor class categoriesFor: #url:!instance creation!public! !

"Binary Globals"!

